#ifndef BBTree_c_INCLUDED
#define BBTree_c_INCLUDED

#line 1 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
/*XCC.h
 * !!!!	BBTree.xcc
 *
 * Marco Garatti (Marco.Garatti@st.com)
 *
 * Copyright 2007 STMicroelectronics.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 *
 * A BBTree is a very simple data structure that represent binary trees.
 * Different nodes may contain different types.
 * Each node of the tree contains two information:
 *
 * - node metadata
 * - user data
 *
 * Clients only "see" the user data, while the package manipulates the
 * metadata.
 */

#line 25 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
#include "BSL/BSL_.h"

#line 30 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 41 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
BBTreeNode
BBTreeNode_Ctor(BBTreeNode this)
{
  *BBTreeNode__LTKID(this) = NULL;
  *BBTreeNode__RTKID(this) = NULL;
  return this;
}

#line 49 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
static void
BBTreeNode_Dtor_(BBTreeNode this, Memory memory)
{
  BBTreeNode this_node = this - 1;
  if (BBTreeNode_LTKID(this_node) != NULL) {
    BBTreeNode_Dtor_(BBTreeNode_LTKID(this_node), memory);
  }
  if (BBTreeNode_RTKID(this_node) != NULL) {
    BBTreeNode_Dtor_(BBTreeNode_RTKID(this_node), memory);
  }
  Memory_free_(memory, this_node);
}

#line 73 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
BBTree
BBTree_Ctor(BBTree this, Memory memory)
{
  *BBTree__MEMORY(this) = memory;
  *BBTree__ROOT(this) = NULL;
  *BBTree__COUNT(this) = 0;
  return this;
}

#line 82 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
void
BBTree_Dtor(BBTree this)
{
  if (BBTree_ROOT(this) != NULL) {
    BBTreeNode node = BBTree_ROOT(this);
    Memory memory = BBTree_MEMORY(this);
    BBTreeNode_Dtor_(node, memory);
  }
  *BBTree__ROOT(this) = NULL;
  *BBTree__COUNT(this) = 0;
}

#line 154 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
void *
BBTree_createNode(BBTree this, int32_t size)
{
  Memory memory = BBTree_MEMORY(this);
  // The allocated object contains both the user data and the BBTree control information.
  size_t adjustedSize = size + sizeof(BBTreeNode_);
  size_t align_size = CDT_ALIGN_NEXT(adjustedSize);
  BBTreeNode new_node = Memory_alloc_(memory, align_size);
  *BBTreeNode__LTKID(new_node) = NULL;
  *BBTreeNode__RTKID(new_node) = NULL;
  ++*BBTree__COUNT(this);
  return (void*)(new_node + 1);
}

#line 177 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
void
BBTreeNode_attachKids(void* node,void* left,void* right)
{
  /* These pointers point into the user data, go back to get to the underlying node info */
  BBTreeNode father = (BBTreeNode)node - 1;
  assert(left && right);
  *BBTreeNode__LTKID(father) = left;
  *BBTreeNode__RTKID(father) = right;
}

#line 195 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
void
BBTreeNode_attachLeftKid(void* node,void* left)
{
  /* These pointers point into the user data, go back to get to the underlying node info */
  BBTreeNode father = (BBTreeNode)node - 1;
  assert(left);
  *BBTreeNode__LTKID(father) = left;
}

#line 212 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
void
BBTreeNode_attachRightKid(void* node,void* right)
{
  /* These pointers point into the user data, go back to get to the
      underlying node info */
  BBTreeNode father = (BBTreeNode)node - 1;
  assert(right);
  *BBTreeNode__RTKID(father) = right;
}

#line 235 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
void
BBTree_attachTrees(BBTree this, void* node,BBTree left,BBTree right)
{
  /* These pointers point into the user data, go back to get to the
     underlying node info */
  BBTreeNode father = (BBTreeNode)node - 1;
  assert(left && right);
  *BBTreeNode__LTKID(father) = BBTree_ROOT(left);
  *BBTreeNode__RTKID(father) = BBTree_ROOT(right);
  *BBTree__COUNT(this) += BBTree_COUNT(left) + BBTree_COUNT(right);
}

#line 259 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
void
BBTree_attachLeftTree(BBTree this, void* node,BBTree left)
{
  /* These pointers point into the user data, go back to get to the underlying
     node info */
  BBTreeNode father = (BBTreeNode)node - 1;
  assert(left);
  *BBTreeNode__LTKID(father) = BBTree_ROOT(left);
  *BBTree__COUNT(this) += BBTree_COUNT(left);
}

#line 282 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
void
BBTree_attachRightTree(BBTree this, void* node,BBTree right)
{
  /* These pointers point into the user data, go back to get to the underlying
     node info */
  BBTreeNode father = (BBTreeNode)node - 1;
  assert(right);
  *BBTreeNode__RTKID(father) = BBTree_ROOT(right);
  *BBTree__COUNT(this) += BBTree_COUNT(right);
}

#line 299 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
void
BBTree_dfs(BBTree this, void (*map)(void *, va_list), ...)
{
  va_list va;
  va_start(va, map);
  if (BBTree_ROOT(this) != NULL) {
    BBTreeNode_dfs(BBTree_ROOT(this), map, va);
  }
  va_end(va);
}

#line 314 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
void
BBTreeNode_dfs(BBTreeNode this, void (*map)(void *, va_list), va_list va)
{
  BBTreeNode this_node = this - 1;
  if (BBTreeNode_LTKID(this_node) != NULL) {
    BBTreeNode_dfs(BBTreeNode_LTKID(this_node), map, va);
  }
  if (BBTreeNode_RTKID(this_node) != NULL) {
    BBTreeNode_dfs(BBTreeNode_RTKID(this_node), map, va);
  }
  (*map)(this, va);
}

#line 327 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
#if XCC__C
typedef struct MyStruct {
    int x;
    int y;
} MyStruct;

#line 333 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
static void dump(void *value, va_list va)
{
  MyStruct* my_struct = (MyStruct*)value;
  printf("x=%d -- y=%d\n",my_struct->x,my_struct->y);
}
#endif

#line 406 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 418 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
#if XCC__C
static void
BBTree_TEST(void)
{
#include "BSL/BBTree_.c"
}

#line 425 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
int
main(int argc, char **argv)
{
  BSL_Test(BBTree_TEST);
  return 0;
}
#endif


#endif//BBTree_c_INCLUDED
