#ifndef Buffer_c_INCLUDED
#define Buffer_c_INCLUDED

#line 16 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Buffer.xcc"
#include "BSL/BSL_.h"

#line 21 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Buffer.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 33 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Buffer.xcc"
BufferBlock
BufferBlock_Ctor(BufferBlock this, size_t blockSize)
{
  *BufferBlock__AVAIL(this) = blockSize;
  *BufferBlock__NEXT(this) = NULL;
  return this;
}

#line 41 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Buffer.xcc"
void
BufferBlock_Dtor(BufferBlock this)
{
  *BufferBlock__NEXT(this) = NULL;
}

#line 70 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Buffer.xcc"
Buffer
Buffer_Ctor(Buffer this, Memory memory, size_t blockSize)
{
  *Buffer__MEMORY(this) = memory;
  *Buffer__BLOCKSIZE(this) = blockSize;
  *Buffer__LENGTH(this) = 0;
  *Buffer__FIRST(this) = NULL;
  *Buffer__LAST(this) = NULL;
  *Buffer__START(this) = NULL;
  *Buffer__PAST(this) = NULL;
  *Buffer__INDENT(this) = "\t";
  *Buffer__ILEVEL(this) = 0;
  *Buffer__ISIZE(this) = strlen(Buffer_INDENT(this));
  return this;
}

#line 86 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Buffer.xcc"
void
Buffer_Dtor(Buffer this)
{
  Buffer_empty(this);
}

#line 103 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Buffer.xcc"
void
Buffer_empty(Buffer this)
{
  Memory memory = Buffer_MEMORY(this);
  BufferBlock block = Buffer_FIRST(this);
  while (block != NULL) {
    BufferBlock next = BufferBlock_NEXT(block);
    BufferBlock_Dtor(block);
    Memory_free_(memory, block);
    block = next;
  }
  *Buffer__LENGTH(this) = 0;
  *Buffer__FIRST(this) = NULL;
  *Buffer__LAST(this) = NULL;
  *Buffer__START(this) = NULL;
  *Buffer__PAST(this) = NULL;
  *Buffer__ILEVEL(this) = 0;
}

#line 122 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Buffer.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 184 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Buffer.xcc"
int32_t
Buffer_append(Buffer this, size_t length, const char *data)
{
  int remains = length;
  BufferBlock last = Buffer_LAST(this);
  if (last == NULL) {
    Memory memory = Buffer_MEMORY(this);
    size_t blockSize = Buffer_BLOCKSIZE(this);
    void *alloc = Memory_alloc(memory, sizeof(BufferBlock_) + blockSize);
    BufferBlock block = BufferBlock_Ctor(alloc, blockSize);
    char *base = BufferBlock_BASE(block);
    *Buffer__FIRST(this) = block;
    *Buffer__START(this) = base;
    *Buffer__LAST(this) = block;
    *Buffer__PAST(this) = base;
    last = block;
  }
  for (;;) {
    char *past = Buffer_PAST(this);
    size_t avail = BufferBlock_AVAIL(last);
    size_t size = MIN(avail, remains);
    if (size > 0) {
      if (data != NULL) memcpy(past, data, size);
      else memset(past, 0, size);
      *Buffer__PAST(this) += size;
      *BufferBlock__AVAIL(last) -= size;
      *Buffer__LENGTH(this) += size;
      remains -= size;
      data += size;
    }
    if (remains > 0) {
      Memory memory = Buffer_MEMORY(this);
      size_t blockSize = Buffer_BLOCKSIZE(this);
      void *alloc = Memory_alloc(memory, sizeof(BufferBlock_) + blockSize);
      BufferBlock block = BufferBlock_Ctor(alloc, blockSize);
      char *base = BufferBlock_BASE(block);
      *BufferBlock__NEXT(last) = block;
      *Buffer__LAST(this) = block;
      *Buffer__PAST(this) = base;
      last = block;
    } else break;
  }
  return length;
}

#line 235 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Buffer.xcc"
int32_t
Buffer_appendIndent(Buffer this)
{
  const char *indent = Buffer_INDENT(this);
  int iLevel = Buffer_ILEVEL(this);
  int iSize = Buffer_ISIZE(this);
  int length = iLevel*iSize, i;
  char buffer[128], *p = buffer;
  if (length <= sizeof(buffer)) {
    for (i = 0; i < iLevel; i++) {
      strncpy(p, indent, iSize);
      p += iSize;
    }
    Buffer_append(this, length, buffer);
  } else {
    for (i = 0; i < iLevel; i++) {
      Buffer_append(this, iSize, indent);
    }
  }
  return length;
}

#line 263 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Buffer.xcc"
int32_t
Buffer_appendC(Buffer this, int c)
{
  char character = c;
  Buffer_append(this, 1, &character);
  return 1;
}

#line 277 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Buffer.xcc"
int32_t
Buffer_appendD(Buffer this, int64_t lld)
{
  char data[64];
  int lenght = sprintf(data, "%lld", lld);
  return Buffer_append(this, lenght, data);
}

#line 291 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Buffer.xcc"
int32_t
Buffer_appendU(Buffer this, int64_t llu)
{
  char data[64];
  int lenght = sprintf(data, "%llu", llu);
  return Buffer_append(this, lenght, data);
}

#line 305 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Buffer.xcc"
int32_t
Buffer_appendX(Buffer this, int64_t llx)
{
  char data[64];
  int lenght = sprintf(data, "%llx", llx);
  return Buffer_append(this, lenght, data);
}

#line 335 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Buffer.xcc"
void
Buffer_fwrite(const_Buffer this, FILE *file)
{
  size_t blockSize = Buffer_BLOCKSIZE(this);
  BufferBlock first = Buffer_FIRST(this);
  BufferBlock last = Buffer_LAST(this);
  if (first != NULL) {
    if (first == last) {
      char *start = Buffer_START(this);
      char *past = Buffer_PAST(this);
      fwrite(start, 1, past - start, file);
    } else {
      BufferBlock block = BufferBlock_NEXT(first);
      char *start = Buffer_START(this);
      char *base = BufferBlock_BASE(first);
      char *past = base + blockSize;
      fwrite(start, 1, past - start, file);
      while (block != last) {
        char *base = BufferBlock_BASE(block);
        BufferBlock next = BufferBlock_NEXT(block);
        fwrite(base, 1, blockSize, file);
        block = next;
      }
      base = BufferBlock_BASE(last);
      past = Buffer_PAST(this);
      fwrite(base, 1, past - base, file);
    }
  }
}

#line 385 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Buffer.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 397 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Buffer.xcc"
#if XCC__C
static void
Buffer_TEST(void)
{
#include "BSL/Buffer_.c"
}

#line 404 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Buffer.xcc"
int
main(int argc, char **argv)
{
  BSL_Test(Buffer_TEST);
  return 0;
}
#endif


#endif//Buffer_c_INCLUDED
