#ifndef Buffer__h_INCLUDED
#define Buffer__h_INCLUDED

//
#include "BSL/Buffer.h"

/*
 * BufferBlock --	Block storage for the Buffer.
 */
struct BufferBlock_ {
  //@args	size_t blockSize
  size_t AVAIL;			// Available space in this BufferBlock.
  //@access BASE	((char *)((BufferBlock)(this) + 1))
  struct BufferBlock_ *NEXT;	// Next BufferBlock in the Buffer.
};
typedef struct BufferBlock_ BufferBlock_, *BufferBlock;
typedef const struct BufferBlock_ *const_BufferBlock;
typedef struct BufferBlock_ * restrict_BufferBlock;

extern BufferBlock
BufferBlock_Ctor(BufferBlock this, size_t blockSize);

extern BufferBlock
BufferBlock_Copy(BufferBlock this, const_BufferBlock that);

extern void
BufferBlock_Dtor(BufferBlock this);

extern size_t
BufferBlock_Size(size_t blockSize);

#define BufferBlock_AVAIL(this) ((this)->AVAIL)
#define BufferBlock__AVAIL(this) (&(this)->AVAIL)
#define BufferBlock_NEXT(this) ((this)->NEXT)
#define BufferBlock__NEXT(this) (&(this)->NEXT)
#define BufferBlock_BASE(this) (((char *)((BufferBlock)(this) + 1)))


/*
 * Buffer_INIT --	Initialize the Buffer module.
 */
#define Buffer_INIT()

/*
 * Buffer_FINI --	Finalize the Buffer module.
 */
#define Buffer_FINI()


#endif//Buffer__h_INCLUDED
