#ifndef ETable_c_INCLUDED
#define ETable_c_INCLUDED

#line 16 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/ETable.xcc"
//
#include "BSL/BSL_.h"

#line 22 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/ETable.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 39 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/ETable.xcc"
/*
 * ETableEntry_compare --	Used by qsort to sort the HTable ENTRIES.
 */
static int
ETableEntry_compare(const void *this, const void *that)
{
  const ETableEntry_ *this_entry = (const ETableEntry_ *)this;
  const ETableEntry_ *that_entry = (const ETableEntry_ *)that;
  return ETableEntry_VALUE(this_entry) - ETableEntry_VALUE(that_entry);
}

#line 77 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/ETable.xcc"
ETable
ETable_Ctor(ETable this, Memory memory, ETableEntry_ *entries)
{
  uint32_t mask = 0;
  bool sorted = true;
  int32_t count = 0, i;
  ETableEntry *buckets = NULL;
  // Count the ENTRIES and sort them if needed.
  if (entries[count].NAME != NULL) ++count;
  while (entries[count].NAME != NULL) {
    ETableEntry curr_entry = entries + count;
    ETableEntry prev_entry = curr_entry - 1;
    if (ETableEntry_VALUE(prev_entry) > ETableEntry_VALUE(curr_entry)) sorted = false;
    ++count;
  }
  if (!sorted) qsort(entries, count, sizeof(ETableEntry_), ETableEntry_compare);
  //
  mask = HackerU32_clp2(count) - 1;
  buckets = Memory_alloc(memory, (mask + 1)*sizeof(ETableEntry));
  for (i = 0; i < mask + 1; i++) buckets[i] = NULL;
  // Hash all the ENTRIES and fill the BUCKETS.
  for (i = 0; i < count; i++) {
    ETableEntry entry = entries + i;
    const char *name = ETableEntry_NAME(entry);
    uint32_t hash = Hacker_hashFNV32(name);
    int32_t index = hash & mask;
    *ETableEntry__HASH(entry) = hash;
    *ETableEntry__LINK(entry) = buckets[index];
    buckets[index] = entry;
  }
  //
  *ETable__MEMORY(this) = memory;
  *ETable__ENTRIES(this) = entries;
  *ETable__BUCKETS(this) = buckets;
  *ETable__COUNT(this) = count;
  *ETable__MASK(this) = mask;
  return this;
}

#line 116 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/ETable.xcc"
void
ETable_Dtor(ETable this)
{
  Memory memory = ETable_MEMORY(this);
  Memory_free(memory, ETable_BUCKETS(this));
}

#line 128 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/ETable.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 178 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/ETable.xcc"
const char *
ETable_name(const_ETable this, int32_t value)
{
  ETableEntry_ *entries = ETable_ENTRIES(this);
  int32_t count = ETable_COUNT(this);
  int32_t l = 0, r = count - 1;
  while (r >= l) {
    int32_t i = (l + r) >> 1;
    int32_t i_value = ETableEntry_VALUE(entries + i);
    if (value < i_value) r = i - 1;
    else if (value > i_value) l = i + 1;
    else return ETableEntry_NAME(entries + i);
  }
  return NULL;
}

#line 200 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/ETable.xcc"
int32_t
ETable_value(const_ETable this, const char *name)
{
  ETableEntry *buckets = ETable_BUCKETS(this);
  uint32_t hash = Hacker_hashFNV32(name);
  uint32_t mask = ETable_MASK(this);
  int32_t index = hash & mask;
  ETableEntry entry = buckets[index];
  for (; entry != NULL; entry = ETableEntry_LINK(entry)) {
    if (ETableEntry_HASH(entry) == hash &&
        !strcmp(ETableEntry_NAME(entry), name)) {
      return ETableEntry_VALUE(entry);
    }
  }
  return 0;
}

#line 223 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/ETable.xcc"
bool
ETable_pretty(ETable this, const char *prefix, FILE *file)
{
  fprintf(file, "%s[\n", prefix);
  ETable_FOREACH_ETableEntry(this, entry) {
    uint32_t value = ETableEntry_VALUE(entry);
    const char *name = ETableEntry_NAME(entry);
    fprintf(file, "%s%s = %d\n", prefix, name, value);
  } ETable_ENDEACH_ETableEntry;
  fprintf(file, "%s]\n", prefix);
  return true;
}

#line 242 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/ETable.xcc"
bool
ETable_prettyFlags(ETable this, uint32_t flags, const char *sep, FILE *file)
{
  const char *string = "";
  ETable_FOREACH_ETableEntry(this, entry) {
    uint32_t value = ETableEntry_VALUE(entry);
    if ((value & flags) == value) {
      const char *name = ETableEntry_NAME(entry);
      fprintf(file, "%s%s", string, name);
      flags ^= value;
      string = sep;
    }
    if (flags == 0) break;
  } ETable_ENDEACH_ETableEntry;
  return true;
}

#line 266 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/ETable.xcc"
bool
ETable_parseFlags(ETable this, const char *string, char sep, uint32_t *flags)
{
  bool result = true;
  int tokens = 0;
  *flags = 0;
  while(string != NULL && *string != '\0') {
    size_t length;
    const char *ptr;
    ptr = strchr(string, sep);
    if (ptr == NULL) length = strlen(string);
    else length = ptr - string;
    if (length > 0) {
      char *endptr;
      uint32_t parsed_flag;
      parsed_flag = strtoll(string, &endptr, 0);
      if (endptr - string == length) {
	// Parsed a valid number, verify if it is a valid flag value
	uint32_t valid_flag = parsed_flag;
	ETable_FOREACH_ETableEntry(this, entry) {
	  uint32_t value = ETableEntry_VALUE(entry);
	  if (value & valid_flag) {
	    valid_flag &= ~value;
	  }
	} ETable_ENDEACH_ETableEntry;
	if (valid_flag != 0) result = false;
	*flags |= parsed_flag;
	tokens++;
      } else if (endptr == string) {
	parsed_flag = 0;
	ETable_FOREACH_ETableEntry(this, entry) {
	  uint32_t value = ETableEntry_VALUE(entry);
	  const char *name = ETableEntry_NAME(entry);
	  if (strncmp(name, string, length) == 0 &&
	      strlen(name) == length) {
	    parsed_flag = value;
	  }
	} ETable_ENDEACH_ETableEntry;
	if (parsed_flag == 0) result = false;
	*flags |= parsed_flag;
	tokens++;
      } else {
	result = false;
      }
    }
    if (ptr != NULL) ptr++;
    string = ptr;
  }
  return result && tokens > 0;
}

#line 365 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/ETable.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 377 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/ETable.xcc"
#if XCC__C
static void
ETable_TEST(void)
{
#include "BSL/ETable_.c"
}

#line 384 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/ETable.xcc"
int
main(int argc, char **argv)
{
  BSL_Test(ETable_TEST);
  return 0;
}
#endif


#endif//ETable_c_INCLUDED
