#ifndef Memory_c_INCLUDED
#define Memory_c_INCLUDED

#line 32 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
#include "BSL/BSL_.h"

#line 37 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 63 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
MemoryUsage
MemoryUsage_Ctor(MemoryUsage this)
{
  memset(this, 0, sizeof(MemoryUsage_));
  return this;
}

#line 81 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
#if !defined(CDT_NTRACE) || defined(XCC__C)
bool
MemoryUsage_pretty(const_MemoryUsage this, FILE *file)
{
  double sofar = 0.0;
  double total = MemoryUsage_ALLOCS(this);
  if (file == NULL) file = stderr;
  fprintf(file, "*** MemoryUsage\tINUSE=%u\tMAXUSE=%u\tALLOCS=%u\n",
          MemoryUsage_INUSE(this), MemoryUsage_MAXUSE(this), MemoryUsage_ALLOCS(this));
  {
    uint32_t size;
    for (size = 1; size <= 1024; size += CDT_ALIGN_MAX) {
      int index = (size + CDT_ALIGN_MAX - 1)/CDT_ALIGN_MAX - 1;
      const_MemoryUsageRecord record = MemoryUsage_SMALLRECORDS(this) + index;
      int opened = MemoryUsageRecord_OPENED(record);
      int allocs = MemoryUsageRecord_ALLOCS(record);
      if (allocs != 0) {
        double percent = (sofar += allocs)/total;
        fprintf(file, "    %u < size <= %u\tallocs=%u\tcumul=%2.0f%%",
                size - 1, size + CDT_ALIGN_MAX - 1, allocs, percent*100);
        fprintf(file, opened != 0? "\topened=%u\n": "\n", opened);
      }
    }
  }
  {
    int index;
    for (index = 0; index < 32-10; index++) {
      uint32_t size = 1024<<index;
      const_MemoryUsageRecord record = MemoryUsage_LARGERECORDS(this) + index;
      int opened = MemoryUsageRecord_OPENED(record);
      int allocs = MemoryUsageRecord_ALLOCS(record);
      if (allocs != 0) {
        double percent = (sofar += allocs)/total;
        fprintf(file, "    %u <= size < %u\tallocs=%u\tcumul=%2.0f%%",
                size, size<<1, allocs, percent*100);
        fprintf(file, opened != 0? "\topened=%u\n": "\n", opened);
      }
    }
  }
  return true;
}
#endif//!defined(CDT_NTRACE) || defined(XCC__C)

#line 124 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
static MemoryUsageRecord
MemoryUsage_getRecord(MemoryUsage this, uint32_t size)
{
  if (size <= 1024) {
    int index = (size + CDT_ALIGN_MAX - 1)/CDT_ALIGN_MAX - 1;
    Except_CHECK(index >= 0 && index < MemoryUsage_SMALLCOUNT);
    return MemoryUsage_SMALLRECORDS(this) + index;
  } else {
    int index = -1;
    for (size >>= 10; size != 0; index++, size >>= 1);
    Except_CHECK(index >= 0 && index < MemoryUsage_LARGECOUNT);
    return MemoryUsage_LARGERECORDS(this) + index;
  }
}

#line 145 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
void
MemoryUsage_alloc(MemoryUsage this, uint32_t size, bool isPool)
{
  uint32_t inUse = MemoryUsage_INUSE(this);
  uint32_t maxUse = MemoryUsage_MAXUSE(this);
  MemoryUsageRecord record = MemoryUsage_getRecord(this, size);
  *MemoryUsage__INUSE(this) = (inUse += size);
  if (inUse > maxUse) *MemoryUsage__MAXUSE(this) = inUse;
  ++*MemoryUsageRecord__OPENED(record);
  ++*MemoryUsageRecord__ALLOCS(record);
  ++*MemoryUsage__OPENED(this);
  ++*MemoryUsage__ALLOCS(this);
}

#line 165 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
void
MemoryUsage_free(MemoryUsage this, uint32_t size, bool isPool)
{
  uint32_t inUse = MemoryUsage_INUSE(this);
  MemoryUsageRecord record = MemoryUsage_getRecord(this, size);
  *MemoryUsage__INUSE(this) = (inUse -= size);
  --*MemoryUsageRecord__OPENED(record);
  --*MemoryUsage__OPENED(this);
}

#line 200 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
MemoryUsage_ Memory_Usage_, *Memory_Usage = NULL;

#line 202 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 213 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
MemoryListItem
MemoryListItem_Ctor(MemoryListItem this)
{
  *MemoryListItem__NEXT(this) = NULL;
  *MemoryListItem__PREV(this) = NULL;
  return this;
}

#line 236 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
MemoryList
MemoryList_Ctor(MemoryList this)
{
  *MemoryList__FIRST(this) = NULL;
  *MemoryList__LAST(this) = NULL;
  return this;
}

#line 263 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
bool
MemoryList_check(MemoryList this, MemoryListItem item)
{
  MemoryListItem first = MemoryList_FIRST(this);
  MemoryListItem last = MemoryList_LAST(this);
  if (BSL_TRACE)
    fprintf(BSL_TRACE, "MemoryList %p<%p,%p>:", this, first, last);
  if (first ==  NULL) {
    Except_ALWAYS(last == NULL);
    Except_ALWAYS(item == NULL);
  } else {
    int found = 0;
    MemoryListItem curr = first, prev = NULL;
    while (curr != NULL) {
      if (curr == item) found++;
      if (BSL_TRACE)
        fprintf(BSL_TRACE, "\t%p<%p,%p>",
                curr, MemoryListItem_PREV(curr), MemoryListItem_NEXT(curr));
      Except_ALWAYS(MemoryListItem_PREV(curr) == prev);
      prev = curr;
      curr = MemoryListItem_NEXT(curr);
    }
    if (item != NULL) Except_ALWAYS(found == 1);
    Except_ALWAYS(prev == last);
  }
  if (BSL_TRACE)
    fprintf(BSL_TRACE, "\n");
  return true;
}

#line 311 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
void
MemoryList_append(MemoryList this, MemoryListItem item)
{
  MemoryListItem first = MemoryList_FIRST(this);
  MemoryListItem last = MemoryList_LAST(this);
  Except_DEBUG(MemoryList_check(this, NULL));
  //BSL_TRACE && fprintf(BSL_TRACE, "MemoryList_append(%p, %p)\n", this, item);
  if (last != NULL) *MemoryListItem__NEXT(last) = item;
  if (first == NULL) *MemoryList__FIRST(this) = item;
  *MemoryListItem__PREV(item) = last;
  *MemoryListItem__NEXT(item) = NULL;
  *MemoryList__LAST(this) = item;
}

#line 331 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
void
MemoryList_remove(MemoryList this, MemoryListItem item)
{
  MemoryListItem first = MemoryList_FIRST(this);
  MemoryListItem last = MemoryList_LAST(this);
  MemoryListItem prev = MemoryListItem_PREV(item);
  MemoryListItem next = MemoryListItem_NEXT(item);
  Except_DEBUG(MemoryList_check(this, item));
  //BSL_TRACE && fprintf(BSL_TRACE, "MemoryList_remove(%p, %p)\n", this, item);
  if (item == first) {
    *MemoryList__FIRST(this) = next;
    if (next == NULL) {
      *MemoryList__LAST(this) = NULL;
    } else {
      *MemoryListItem__PREV(next) = NULL;
    }
  } else if (item == last) {
    *MemoryList__LAST(this) = prev;
    if (prev == NULL) {
      *MemoryList__FIRST(this) = NULL;
    } else {
      *MemoryListItem__NEXT(prev) = NULL;
    }
  } else {
    *MemoryListItem__PREV(next) = prev;
    *MemoryListItem__NEXT(prev) = next;
    *MemoryListItem__PREV(item) = NULL;
    *MemoryListItem__NEXT(item) = NULL;
  }
}

#line 362 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 381 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
MemoryTableEntry
MemoryTableEntry_Ctor(MemoryTableEntry this, void *start, size_t useSize, int level,
                      struct MemoryTableEntry_ *leaf)
{
  *MemoryTableEntry__USESIZE(this) = useSize;
  *MemoryTableEntry__LEVEL(this) = level;
  *MemoryTableEntry__REFC(this) = 0;
  *MemoryTableEntry__LEFT(this) = leaf;
  *MemoryTableEntry__RIGHT(this) = leaf;
  *MemoryTableEntry__START(this) = start;
  *MemoryTableEntry__NEXTBLOCK(this) = NULL;
  return this;
}

#line 401 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
static inline MemoryTableEntry
MemoryTableEntry_skew(MemoryTableEntry this)
{
  MemoryTableEntry t = this;
  MemoryTableEntry left = MemoryTableEntry_LEFT(t);
  if (MemoryTableEntry_LEVEL(left) == MemoryTableEntry_LEVEL(t)) {
    // Rotate right.
    MemoryTableEntry temp = t;
    t = left;
    *MemoryTableEntry__LEFT(temp) = MemoryTableEntry_RIGHT(t);
    *MemoryTableEntry__RIGHT(t) = temp;
#ifdef XCC__C
    printf("skew\tuseSize=%u\n", MemoryTableEntry_USESIZE(this));
#endif//XCC__C
  }
  return t;
}

#line 419 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
static inline MemoryTableEntry
MemoryTableEntry_split(MemoryTableEntry this)
{
  MemoryTableEntry t = this;
  MemoryTableEntry right = MemoryTableEntry_RIGHT(t);
  MemoryTableEntry right_right = MemoryTableEntry_RIGHT(right);
  if (MemoryTableEntry_LEVEL(right_right) == MemoryTableEntry_LEVEL(t)) {
    // Rotate left.
    MemoryTableEntry temp = t;
    t = right;
    *MemoryTableEntry__RIGHT(temp) = MemoryTableEntry_LEFT(t);
    *MemoryTableEntry__LEFT(t) = temp;
    ++*MemoryTableEntry__LEVEL(t);
#ifdef XCC__C
    printf("split\tuseSize=%u\n", MemoryTableEntry_USESIZE(this));
#endif//XCC__C
  }
  return t;
}

#line 439 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
static MemoryTableEntry
MemoryTableEntry_insert(MemoryTableEntry this, MemoryTableEntry entry,
                        MemoryTableEntry leaf)
{
  MemoryTableEntry t = this;
  const char *entry_start = MemoryTableEntry_START(entry);
  const char *start = MemoryTableEntry_START(t);
  const char *past = MemoryTableEntry_PAST(t);
  //printf("entry %p useSize=%u\n", this, MemoryTableEntry_USESIZE(this));
  if (entry_start < start) {
    MemoryTableEntry left = MemoryTableEntry_LEFT(t);
    if (left != leaf) {
      left = MemoryTableEntry_insert(left, entry, leaf);
    } else {
      left = entry;
    }
    *MemoryTableEntry__LEFT(t) = left;
  } else if (entry_start >= past) {
    MemoryTableEntry right = MemoryTableEntry_RIGHT(t);
    if (right != leaf) {
      right = MemoryTableEntry_insert(right, entry, leaf);
    } else {
      right = entry;
    }
    *MemoryTableEntry__RIGHT(t) = right;
  } else Except_NEVER(true);
  t = MemoryTableEntry_skew(t);
  t = MemoryTableEntry_split(t);
  return t;
}

#line 470 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
#if !defined(CDT_NTRACE) || defined(XCC__C)
static bool
MemoryTableEntry_pretty(MemoryTableEntry this, FILE *file)
{
  int level = MemoryTableEntry_LEVEL(this), i;
  MemoryTableEntry left = MemoryTableEntry_LEFT(this);
  MemoryTableEntry right = MemoryTableEntry_RIGHT(this);
  if (MemoryTableEntry_LEVEL(left) != 0) MemoryTableEntry_pretty(left, file);
  fprintf(file, "\tuseSize=%u", MemoryTableEntry_USESIZE(this));
  for (i = 0; i < level; i++) fprintf(file, "  ");
  fprintf(file, "level=%u\n", level);
  if (MemoryTableEntry_LEVEL(right) != 0) MemoryTableEntry_pretty(right, file);
  return true;
}
#endif//!defined(CDT_NTRACE) || defined(XCC__C)

#line 521 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 538 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
MemoryTable
MemoryTable_Ctor(MemoryTable this, void *memory)
{
  MemoryTableEntry leaf = MemoryTable_LEAF(this);
  MemoryTableEntry_Ctor(MemoryTable_LEAF(this), NULL, 0, 0, leaf);
  *MemoryTable__ROOT(this) = leaf;
  return this;
}

#line 558 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
struct MemoryBlock_ *
MemoryTable_search(const_MemoryTable this, const void *address)
{
  const char *pointer = address;
  const_MemoryTableEntry t = MemoryTable_ROOT(this);
  const_MemoryTableEntry leaf = MemoryTable_LEAF(this);
  while (t != leaf) {
    const char *start = MemoryTableEntry_START(t);
    const char *past = MemoryTableEntry_PAST(t);
    if (pointer < start) t = MemoryTableEntry_LEFT(t);
    else if (pointer >= past) t = MemoryTableEntry_RIGHT(t);
    else return MemoryTableEntry_BLOCK(t);
  }
  return NULL;
}

#line 580 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
void
MemoryTable_insert(MemoryTable this, MemoryTableEntry entry)
{
  MemoryTableEntry root = MemoryTable_ROOT(this);
  MemoryTableEntry leaf = MemoryTable_LEAF(this);
  Except_REQUIRE(MemoryTableEntry_LEFT(entry) == leaf);
  Except_REQUIRE(MemoryTableEntry_RIGHT(entry) == leaf);
  Except_REQUIRE(MemoryTableEntry_LEVEL(entry) == 1);
  if (root == leaf) {
    *MemoryTable__ROOT(this) = entry;
  } else {
    *MemoryTable__ROOT(this) = MemoryTableEntry_insert(root, entry, leaf);
  }
}

#line 618 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 643 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
MemoryBlock
MemoryBlock_Ctor(MemoryBlock this, size_t useSize, MemoryTableEntry leaf)
{
  char *start = (char *)(this + 1);
  MemoryListItem_Ctor(MemoryBlock_ITEM(this));
  MemoryTableEntry_Ctor(MemoryBlock_ENTRY(this), start, useSize, 1, leaf);
  return this;
}

#line 660 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 687 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
Memory
Memory_Ctor(Memory this, Memory parent, size_t pooled)
{
  MemoryListItem_Ctor(Memory_ITEM(this));
  *Memory__PARENT(this) = parent;
  *Memory__POOLED(this) = pooled;
  *Memory__TOTALSIZE(this) = 0;
  *Memory__TOTALCOUNT(this) = 0;
  *Memory__POOLBLOCK(this) = NULL;
  *Memory__POOLFIRST(this) = NULL;
  *Memory__POOLPAST(this) = NULL;
  *Memory__RECYCLE(this) = NULL;
  MemoryList_Ctor(Memory_CHILDREN(this));
  if (parent != NULL) {
    MemoryList_append(Memory_CHILDREN(parent), Memory_ITEM(this));
  }
  MemoryList_Ctor(Memory_BLOCKS(this));
  if (pooled > 0) {
    MemoryTableEntry leaf = MemoryTable_LEAF(Memory_TABLE(this));
    *Memory__POOLBLOCK(this) = MemoryTableEntry_BLOCK(leaf);
    MemoryTable_Ctor(Memory_TABLE(this), this);
  }
  return this;
}

#line 712 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
void
Memory_Dtor(Memory this)
{
  size_t pooled = Memory_POOLED(this);
  memset(this, -1, sizeof(Memory_) + (pooled > 0? sizeof(MemoryTable_): 0));
}

#line 719 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
size_t
Memory_Size(Memory parent, size_t pooled)
{
  return sizeof(Memory_) + (pooled > 0? sizeof(MemoryTable_): 0);
}

#line 747 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
Memory
Memory_new(Memory parent, size_t pooled)
{
  size_t force_pooled = FORCE_POOLED >= 0?
                        FORCE_POOLED: pooled;
  size_t alignedSize = CDT_ALIGN_NEXT(Memory_Size(parent, force_pooled));
  Memory this = Memory_alloc_(parent, alignedSize);
  return Memory_Ctor(this, parent, force_pooled);
}

#line 763 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
Memory
Memory_delete(Memory this)
{
  if (this != NULL) {
    Memory parent = Memory_PARENT(this);
    if (parent != this) {
      MemoryList_remove(Memory_CHILDREN(parent), Memory_ITEM(this));
    }
    Memory_freeAll(this);
    Memory_Dtor(this);
    if (parent != this) {
      Memory_free_(parent, this);
    }
  }
  return NULL;
}

#line 820 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
static inline MemoryBlock
Memory_allocBlock_(Memory this, size_t useSize, bool isPool)
{
  size_t realSize = sizeof(MemoryBlock_) + useSize;
  MemoryBlock block = malloc(realSize);
  *Memory__TOTALSIZE(this) += useSize;
  *Memory__TOTALCOUNT(this) += 1;
#if XCC__C
  //printf("allocBlock_(%d)\t%s\n", realSize, isPool? "pooled": "");
#endif
  Except_CHECK(useSize > 0 && CDT_ALIGNED(useSize));
  Except_ALWAYS(block != NULL);
  if (isPool) {
    MemoryTable table = Memory_TABLE(this);
    MemoryBlock_Ctor(block, useSize, MemoryTable_LEAF(table));
    MemoryTable_insert(table, MemoryBlock_ENTRY(block));
  } else {
    MemoryBlock_Ctor(block, useSize, NULL);
  }
  MemoryList_append(Memory_BLOCKS(this), MemoryBlock_ITEM(block));
#if CDT_MEMORY_STATS
  if (BSL_MEMORY_STATS) MemoryUsage_alloc(Memory_Usage, realSize, isPool);
#endif//CDT_MEMORY_STATS
  Except_CHECK(CDT_ALIGNED(block));
  return block;
}

#line 854 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
static inline MemoryBlock
Memory_allocPoolBlock_(Memory this, size_t poolSize)
{
  MemoryBlock block = Memory_RECYCLE(this);
  if (block != NULL) {
    *Memory__RECYCLE(this) = MemoryBlock_NEXTBLOCK(block);
    *MemoryBlock__NEXTBLOCK(block) = NULL;
    Except_CHECK(MemoryBlock_USESIZE(block) == poolSize);
  } else {
    block = Memory_allocBlock_(this, poolSize, true);
  }
  Except_CHECK(MemoryBlock_REFC(block) == 0);
  return block;
}

#line 875 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
void *
Memory_alloc_(Memory this, size_t alignedSize)
{
#ifndef Memory_DEBUG
  size_t pooled = Memory_POOLED(this);
  char *poolFirst = Memory_POOLFIRST(this);
  char *poolPast = Memory_POOLPAST(this);
  Except_CHECK(alignedSize > 0 && CDT_ALIGNED(alignedSize));
  if (alignedSize <= pooled) {
    MemoryBlock poolBlock = Memory_POOLBLOCK(this);
    unsigned poolRefC = MemoryBlock_REFC(poolBlock);
    if (poolFirst + alignedSize >= poolPast) {
      size_t poolSize = Memory_POOLFACTOR*pooled;
      poolBlock = Memory_allocPoolBlock_(this, poolSize);
      poolFirst = MemoryBlock_START(poolBlock);
      poolPast = MemoryBlock_PAST(poolBlock);
      *Memory__POOLBLOCK(this) = poolBlock;
      *Memory__POOLPAST(this) = poolPast;
      poolRefC = 0;
    }
    *Memory__POOLFIRST(this) = poolFirst + alignedSize;
    *MemoryBlock__REFC(poolBlock) = poolRefC + 1;
    Except_CHECK(CDT_ALIGNED(poolFirst));
    return poolFirst;
  } else {
    MemoryBlock block = Memory_allocBlock_(this, alignedSize, false);
    void *alloc = block + 1;
    Except_CHECK(CDT_ALIGNED(alloc));
    return alloc;
  }
#else//Memory_DEBUG
  void *alloc = malloc(alignedSize);
  Except_CHECK(CDT_ALIGNED(alloc));
  return alloc;
#endif//Memory_DEBUG
}

#line 931 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
static inline void
Memory_freeBlock_(Memory this, MemoryBlock block, bool isPool)
{
  size_t realSize = MemoryBlock_REALSIZE(block);
#if CDT_MEMORY_STATS
  if (BSL_MEMORY_STATS) MemoryUsage_free(Memory_Usage, realSize, isPool);
#endif//CDT_MEMORY_STATS
  MemoryList_remove(Memory_BLOCKS(this), MemoryBlock_ITEM(block));
#if CDT_DEBUG
  memset(block, -1, realSize);
#endif//CDT_DEBUG
  free(block);
#if XCC__C
  //printf("freeBlock_(%d)\t%s\n", realSize, isPool? "pooled": "");
#endif
}

#line 948 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
static inline void
Memory_freePoolBlock_(Memory this, MemoryBlock block)
{
#if CDT_DEBUG
  size_t useSize = MemoryBlock_USESIZE(block);
  char *start = MemoryBlock_START(block);
  memset(start, -1, useSize);
#endif//CDT_DEBUG
  Except_CHECK(MemoryBlock_REFC(block) == 0);
  if (block == Memory_POOLBLOCK(this)) {
    *Memory__POOLFIRST(this) = MemoryBlock_START(block);
  } else {
    *MemoryBlock__NEXTBLOCK(block) = Memory_RECYCLE(this);
    *Memory__RECYCLE(this) = block;
  }
}

#line 971 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
void
Memory_free_(Memory this, void *address)
{
#ifndef Memory_DEBUG
  MemoryBlock block = NULL;
  size_t pooled = Memory_POOLED(this);
  MemoryTable table = Memory_TABLE(this);
  Except_CHECK(address != NULL && CDT_ALIGNED(address));
  if (pooled > 0 && (block = MemoryTable_search(table, address)) != NULL) {
    unsigned poolRefC = MemoryBlock_REFC(block);
    *MemoryBlock__REFC(block) = poolRefC - 1;
    if (poolRefC == 1) Memory_freePoolBlock_(this, block);
  } else {
    MemoryBlock block = (MemoryBlock)address - 1;
    Memory_freeBlock_(this, block, false);
  }
#else//Memory_DEBUG
  Except_CHECK(CDT_ALIGNED(address));
  free(address);
#endif//Memory_DEBUG
}

#line 1036 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
void
Memory_freeAll(Memory this) {
  Except_CHECK(this != NULL);
  Memory_CHILDREN_FOREACH_Memory(this, memory) {
    if (memory != this) {
      Memory_freeAll(memory);
      Memory_Dtor(memory);
      Memory_free_(this, memory);
    }
  } Memory_CHILDREN_ENDEACH_Memory;
  MemoryList_Ctor(Memory_CHILDREN(this));
  Memory_FOREACH_MemoryBlock(this, block) {
    Memory_freeBlock_(this, block, false);
  } Memory_ENDEACH_MemoryBlock;
  MemoryList_Ctor(Memory_BLOCKS(this));
}

#line 1057 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
void *
Memory_realloc_(Memory this, void* address, size_t alignedSize)
{
#ifndef Memory_DEBUG
  MemoryBlock block = NULL;
  size_t pooled = Memory_POOLED(this);
  MemoryTable table = Memory_TABLE(this);
  Except_CHECK(CDT_ALIGNED(alignedSize));
  if (pooled > 0 && (block = MemoryTable_search(table, address)) != NULL) {
    char *alloc = Memory_alloc_(this, alignedSize);
    unsigned poolRefC = MemoryBlock_REFC(block);
    const char *past = MemoryBlock_PAST(block);
    size_t copy_size = past - (char *)address;
    if (alloc >= (char *)address && alloc < past) {
      // alloc is in the same pooling block as address.
      copy_size = alloc - (char *)address;
    }
    if (copy_size > alignedSize) copy_size = alignedSize;
    memcpy(alloc, address, copy_size);
    *MemoryBlock__REFC(block) = poolRefC - 1;
    if (poolRefC == 1) Memory_freePoolBlock_(this, block);
    return alloc;
  } else {
    size_t realSize = sizeof(MemoryBlock_) + alignedSize;
    MemoryBlock old_block = (MemoryBlock)address - 1;
#if CDT_MEMORY_STATS
    size_t old_realSize = MemoryBlock_REALSIZE(old_block);
#endif//CDT_MEMORY_STATS
    MemoryList_remove(Memory_BLOCKS(this), MemoryBlock_ITEM(old_block));
    block = realloc(old_block, realSize);
    Except_ALWAYS(block != NULL);
    *MemoryBlock__USESIZE(block) = alignedSize;
    MemoryList_append(Memory_BLOCKS(this), MemoryBlock_ITEM(block));
#if CDT_MEMORY_STATS
    if (BSL_MEMORY_STATS) {
      MemoryUsage_free(Memory_Usage, old_realSize, false);
      MemoryUsage_alloc(Memory_Usage, realSize, false);
    }
#endif//CDT_MEMORY_STATS
    return block + 1;
  }
#else//Memory_DEBUG
  return realloc(address, alignedSize);
#endif//Memory_DEBUG
}

#line 1109 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
void *
Memory_realloc(Memory this, void* address, size_t size)
{
  Except_CHECK(this != NULL);
  Except_CHECK(CDT_ALIGNED(address));
  if (size == 0) {
    if (address != NULL) Memory_free_(this, address);
    return NULL;
  } else {
    size_t alignedSize = CDT_ALIGN_NEXT(size);
    if (address != NULL) return Memory_realloc_(this, address, alignedSize);
    return Memory_alloc_(this, alignedSize);
  }
}

#line 1184 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
Memory Memory_Root;

#line 1186 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1192 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
uint32_t
Memory_usageMax(void)
{
  return Memory_Usage != NULL? MemoryUsage_MAXUSE(Memory_Usage): 0;
}

#line 1202 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
uint32_t
Memory_usageCurrent(void)
{
  return Memory_Usage != NULL? MemoryUsage_INUSE(Memory_Usage): 0;
}

#line 1214 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
void
Memory_INIT(void)
{
  static Memory_ Memory_Root_;
  Memory_Root = Memory_Ctor(&Memory_Root_, &Memory_Root_, 0);
  Memory_Usage = MemoryUsage_Ctor(&Memory_Usage_);
}

#line 1228 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
void
Memory_FINI(void)
{
  if (BSL_TRACE) {
#ifndef CDT_NTRACE
    MemoryUsage_pretty(Memory_Usage, BSL_TRACE);
#endif//CDT_NTRACE
  }
  Memory_freeAll(Memory_Root);
  Memory_Dtor(Memory_Root);
  Memory_Usage = NULL;
  Memory_Root = NULL;
}

#line 1242 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
#if XCC__C
static void
Memory_TEST(void)
{
#include "BSL/Memory_.c"
}

#line 1249 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Memory.xcc"
int
main(int argc, char **argv)
{
  BSL_Test(Memory_TEST);
  return 0;
}
#endif


#endif//Memory_c_INCLUDED
