#ifndef String_c_INCLUDED
#define String_c_INCLUDED

#line 22 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
#include "BSL/BSL_.h"

#line 27 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 50 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 66 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
StringTableEntry
StringTableEntry_Ctor(StringTableEntry this,
                      const void *data, int32_t length, StringTableEntry leaf)
{
  uint32_t hashed = Hacker_hashJenkins(data, length, 0) & 0x7fffffff;
  *StringTableEntry__LEFT(this) = leaf;
  *StringTableEntry__RIGHT(this) = leaf;
  *StringTableEntry__HASHED(this) = hashed;
  *StringTableEntry__LENGTH(this) = length;
  *StringTableEntry__DATA(this) = data;
  return this;
}

#line 79 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
size_t
StringTableEntry_Size(const void *data, int32_t length, StringTableEntry leaf)
{
  return sizeof(StringTableEntry_) + String_Size(data, length, leaf);
}

#line 85 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 124 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
void
String_Ctor(String this, const void *data, int32_t length, const_StringTableEntry leaf)
{
  intptr_t *first = (intptr_t *)this;
  size_t size = String_Size(data, length, leaf);
  intptr_t *past = (intptr_t *)((char *)this + size);
  StringTableEntry entry = String_ENTRY(this);
  if (first < past) {
    *StringTableEntry__DATA(entry) = this;
    past[-1] = 0;	// Clear the padding bytes implied by String_Size.
    memcpy(first, data, length);
  } else {
    // No copies of data: nothing to do.
  }
}

#line 140 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
static void
StringTableEntry_Dtor_(StringTableEntry this, const_StringTableEntry leaf, Memory memory)
{
  StringTableEntry left = StringTableEntry_LEFT(this);
  StringTableEntry right = StringTableEntry_RIGHT(this);
  if (left != leaf) StringTableEntry_Dtor_(left, leaf, memory);
  if (right != leaf) StringTableEntry_Dtor_(right, leaf, memory);
  Memory_free(memory, this);
}

#line 155 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
#ifdef XCC__C
int32_t StringTableEntry_cmpCount;
#endif

#line 186 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
/*
 * StringTableEntry_Splay --	Simple top down splay, not requiring n to be in the tree t.
 *
 * Adapted from ftp://ftp.cs.cmu.edu/user/sleator/splaying/top-down-splay.c
 * "An implementation of top-down splaying", D. Sleator <sleator@cs.cmu.edu>
 */
static StringTableEntry
StringTableEntry_Splay(StringTableEntry t, StringTableEntry n, StringTableEntry leaf)
{
  StringTableEntry_ N, *l, *r, *y;
  if (t == leaf) return t;
  N.LEFT = N.RIGHT = leaf;
  l = r = &N;
  for (;;) {
    int32_t cmp = StringTableEntry_cmp(n, t);
    if (cmp < 0) {
      if (StringTableEntry_LEFT(t) == leaf) break;
      cmp = StringTableEntry_cmp(n, StringTableEntry_LEFT(t));
      if (cmp < 0) {
        y = StringTableEntry_LEFT(t);			/* rotate right */
        *StringTableEntry__LEFT(t) = StringTableEntry_RIGHT(y);
        *StringTableEntry__RIGHT(y) = t;
        t = y;
        if (StringTableEntry_LEFT(t) == leaf) break;
      }
      *StringTableEntry__LEFT(r) = t;			/* link right */
      r = t;
      t = StringTableEntry_LEFT(t);
    } else if (cmp > 0) {
      if (StringTableEntry_RIGHT(t) == leaf) break;
      cmp = StringTableEntry_cmp(n, StringTableEntry_RIGHT(t));
      if (cmp > 0) {
        y = StringTableEntry_RIGHT(t);			/* rotate left */
        *StringTableEntry__RIGHT(t) = StringTableEntry_LEFT(y);
        *StringTableEntry__LEFT(y) = t;
        t = y;
        if (StringTableEntry_RIGHT(t) == leaf) break;
      }
      *StringTableEntry__RIGHT(l) = t;			/* link left */
      l = t;
      t = StringTableEntry_RIGHT(t);
    } else {
      break;
    }
  }
  *StringTableEntry__RIGHT(l) = StringTableEntry_LEFT(t);		/* assemble */
  *StringTableEntry__LEFT(r) = StringTableEntry_RIGHT(t);
  *StringTableEntry__LEFT(t) = N.RIGHT;
  *StringTableEntry__RIGHT(t) = N.LEFT;
  return t;
}

#line 238 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
/*
 * This function can be called only if K2 has a left child.
 * Perform a rotate between a node (K2) and its left child.
 * Update heights, then return new root.
 */
static inline StringTableEntry
StringTableEntry_SingleRotateWithLeft(StringTableEntry K2)
{
  StringTableEntry K1;
  K1 = StringTableEntry_LEFT(K2);
  *StringTableEntry__LEFT(K2) = StringTableEntry_RIGHT(K1);
  *StringTableEntry__RIGHT(K1) = K2;
  return K1;			/* New root */
}

#line 253 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
/*
 * This function can be called only if K1 has a right child.
 * Perform a rotate between a node (K1) and its right child.
 * Update heights, then return new root.
 */
static inline StringTableEntry
StringTableEntry_SingleRotateWithRight(StringTableEntry K1)
{
  StringTableEntry K2;
  K2 = StringTableEntry_RIGHT(K1);
  *StringTableEntry__RIGHT(K1) = StringTableEntry_LEFT(K2);
  *StringTableEntry__LEFT(K2) = K1;
  return K2;			/* New root */
}

#line 268 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
static StringTableEntry
StringTableEntry_insertTreap(StringTableEntry t, StringTableEntry n, StringTableEntry leaf)
{
  if (t == leaf) {
    // Flag that n is inserted.
    *StringTableEntry__LENGTH(leaf) = -1;
    t = n;
  } else {
    int32_t cmp = StringTableEntry_cmp(n, t);
    if (cmp < 0) {
      *StringTableEntry__LEFT(t) = StringTableEntry_insertTreap(StringTableEntry_LEFT(t), n, leaf);
      if (StringTableEntry_PRIORITY(StringTableEntry_LEFT(t)) < StringTableEntry_PRIORITY(t)) {
        t = StringTableEntry_SingleRotateWithLeft(t);
      }
    } else if (cmp > 0) {
      *StringTableEntry__RIGHT(t) = StringTableEntry_insertTreap(StringTableEntry_RIGHT(t), n, leaf);
      if (StringTableEntry_PRIORITY(StringTableEntry_RIGHT(t)) < StringTableEntry_PRIORITY(t)) {
        t = StringTableEntry_SingleRotateWithRight(t);
      }
    }
  }
  // Otherwise it's a duplicate; do nothing.
  return t;
}

#line 293 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
static StringTableEntry
StringTableEntry_removeTreap(StringTableEntry t, StringTableEntry n, StringTableEntry leaf)
{
  int32_t cmp = StringTableEntry_cmp(n, t);
  if (cmp < 0) {
    *StringTableEntry__LEFT(t) = StringTableEntry_removeTreap(StringTableEntry_LEFT(t), n, leaf);
  } else if (cmp > 0) {
    *StringTableEntry__RIGHT(t) = StringTableEntry_removeTreap(StringTableEntry_RIGHT(t), n, leaf);
  } else {
    // Match found.
    if (StringTableEntry_PRIORITY(StringTableEntry_LEFT(t)) <
        StringTableEntry_PRIORITY(StringTableEntry_RIGHT(t))) {
      t = StringTableEntry_SingleRotateWithLeft(t);
    } else {
      t = StringTableEntry_SingleRotateWithRight(t);
    }
    if (t != leaf) {
      // Continue on down.
      t = StringTableEntry_removeTreap(t, n, leaf);
    } else {
      // At a leaf.
      *StringTableEntry__LEFT(t) = leaf;
    }
  }
  return t;
}

#line 320 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 337 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
StringTable
StringTable_Ctor(StringTable this, Memory memory, bool copies)
{
  StringTableEntry leaf = StringTable_LEAF(this);
  *StringTable__MEMORY(this) = memory;
  *StringTable__ROOT(this) = StringTable_LEAF(this);
  StringTableEntry_Ctor(leaf, NULL, 0, leaf);
  *StringTableEntry__HASHED(leaf) = (uint32_t)(int32_t)-1; // For Treap.
  if (copies) *StringTableEntry__DATA(leaf) = (const void *)1;
  *StringTable__COUNT(this) = 0;
  return this;
}

#line 351 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
void
StringTable_Dtor(StringTable this)
{
  const_StringTableEntry leaf = StringTable_LEAF(this);
  Memory memory = StringTable_MEMORY(this);
  if (StringTable_ROOT(this) != leaf) {
    StringTableEntry_Dtor_(StringTable_ROOT(this), leaf, memory);
  }
  *StringTable__ROOT(this) = StringTable_LEAF(this);
  *StringTable__COUNT(this) = 0;
}

#line 368 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 396 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
/*
 * Standard binary tree search.
 */
String
StringTable_search(const_StringTable this, const void *data, int32_t length)
{
  const_StringTableEntry t = StringTable_ROOT(this);
  const_StringTableEntry leaf = StringTable_LEAF(this);
  while (t != leaf) {
    int32_t cmp = StringTableEntry_cmp_(t, data, length);
    if (cmp > 0) t = StringTableEntry_LEFT(t);
    else if (cmp < 0) t = StringTableEntry_RIGHT(t);
    else return StringTableEntry_STRING(t);
  }
  return NULL;
}

#line 447 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
String
StringTable_insertSplay(StringTable this, const void *data, int32_t length)
{
  StringTableEntry t = StringTable_ROOT(this);
  StringTableEntry leaf = StringTable_LEAF(this);
  Memory memory = StringTable_MEMORY(this);
  size_t size = StringTableEntry_Size(data, length, leaf);
  StringTableEntry n = Memory_alloc(memory, size);
  StringTableEntry_Ctor(n, data, length, leaf);
  String_Ctor(StringTableEntry_STRING(n), data, length, leaf);
  if (t == leaf) {
    *StringTableEntry__LEFT(n) = *StringTableEntry__RIGHT(n) = leaf;
    *StringTable__COUNT(this) = 1;
    *StringTable__ROOT(this) = n;
    return StringTableEntry_STRING(n);
  }
  t = StringTableEntry_Splay(t, n, leaf);
  {
    int32_t cmp = StringTableEntry_cmp(n, t);
    if (cmp < 0) {
      *StringTableEntry__LEFT(n) = StringTableEntry_LEFT(t);
      *StringTableEntry__RIGHT(n) = t;
      *StringTableEntry__LEFT(t) = leaf;
      ++*StringTable__COUNT(this);
      *StringTable__ROOT(this) = n;
      return StringTableEntry_STRING(n);
    } else if (cmp > 0) {
      *StringTableEntry__RIGHT(n) = StringTableEntry_RIGHT(t);
      *StringTableEntry__LEFT(n) = t;
      *StringTableEntry__RIGHT(t) = leaf;
      ++*StringTable__COUNT(this);
      *StringTable__ROOT(this) = n;
      return StringTableEntry_STRING(n);
    } else {
      // We get here if it's already in the tree. Don't add it again.
      Memory_free(memory, n);
      *StringTable__ROOT(this) = t;
      return NULL;
    }
  }
}

#line 489 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
/*
 * StringTable_removeSplay --	Remove data from the tree if it's there.
 *
 * Adapted from ftp://ftp.cs.cmu.edu/user/sleator/splaying/top-down-splay.c
 * "An implementation of top-down splaying", D. Sleator <sleator@cs.cmu.edu>
 */
static bool
StringTable_removeSplay(StringTable this, const void *data, int32_t length)
{
  Memory memory = StringTable_MEMORY(this);
  StringTableEntry t = StringTable_ROOT(this);
  StringTableEntry leaf = StringTable_LEAF(this);
  String a = StringTable_search(this, data, length);
  if (a) {
    StringTableEntry n = String_ENTRY(a), x = 0;
    t = StringTableEntry_Splay(t, n, leaf);
    if (!StringTableEntry_cmp(n, t)) {		/* found it */
      if (StringTableEntry_LEFT(t) == leaf) {
        x = StringTableEntry_RIGHT(t);
      } else {
        x = StringTableEntry_Splay(StringTableEntry_LEFT(t), n, leaf);
        *StringTableEntry__RIGHT(x) = StringTableEntry_RIGHT(t);
      }
      --*StringTable__COUNT(this);
      Memory_free(memory, t);
      *StringTable__ROOT(this) = x;
      return true;
    }
    *StringTable__ROOT(this) = t;		/* wasn't there */
  }
  return false;
}

#line 531 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
String
StringTable_insertTreap(StringTable this, const void *data, int32_t length)
{
  StringTableEntry t = StringTable_ROOT(this);
  StringTableEntry leaf = StringTable_LEAF(this);
  size_t size = StringTableEntry_Size(data, length, leaf);
  Memory memory = StringTable_MEMORY(this);
  StringTableEntry n = Memory_alloc(memory, size);
  StringTableEntry_Ctor(n, data, length, leaf);
  String_Ctor(StringTableEntry_STRING(n), data, length, leaf);
  t = StringTableEntry_insertTreap(t, n, leaf);
  if (StringTableEntry_LENGTH(leaf) != 0) {
    *StringTableEntry__LENGTH(leaf) = 0;
    ++*StringTable__COUNT(this);
    *StringTable__ROOT(this) = t;
    return StringTableEntry_STRING(n);
  } else {
    Memory_free(memory, n);
    return NULL;
  }
}

#line 553 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
/*
 * StringTable_removeTreap --	Insert data into the tree t, unless it's already there.
 *
 * Adapted from http://www.cs.fiu.edu/~weiss/dsaa_c2e/files.html
 * "Data Structures and Algorithm Analysis in C", Mark Allen Weiss <weiss@fiu.edu>
 */
bool
StringTable_removeTreap(StringTable this, const void *data, int32_t length)
{
  Memory memory = StringTable_MEMORY(this);
  StringTableEntry t = StringTable_ROOT(this);
  StringTableEntry leaf = StringTable_LEAF(this);
  String a = StringTable_search(this, data, length);
  if (a != NULL) {
    StringTableEntry n = String_ENTRY(a);
    t = StringTableEntry_removeTreap(t, n, leaf);
    --*StringTable__COUNT(this);
    Memory_free(memory, n);
    *StringTable__ROOT(this) = t;
    return true;
  }
  return false;
}

#line 588 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
#ifdef XCC__C
static int32_t StringTable_indent;
#endif//XCC__C

#line 592 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
void
StringTable_map(StringTable this, void (*map)(String, va_list), ...)
{
  va_list va;
  const_StringTableEntry leaf = StringTable_LEAF(this);
  va_start(va, map);
#ifdef XCC__C
  StringTable_indent = -1;
#endif//XCC__C
  if (StringTable_ROOT(this) != leaf) {
    StringTableEntry_map(StringTable_ROOT(this), leaf, map, va);
  }
  va_end(va);
}

#line 612 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
void
StringTableEntry_map(StringTableEntry this, const_StringTableEntry leaf,
                void (*map)(String, va_list), va_list va)
{
#ifdef XCC__C
  StringTable_indent++;
#endif//XCC__C
  (*map)(StringTableEntry_STRING(this), va);
  if (StringTableEntry_LEFT(this) != leaf) {
    StringTableEntry_map(StringTableEntry_LEFT(this), leaf, map, va);
  }
  if (StringTableEntry_RIGHT(this) != leaf) {
    StringTableEntry_map(StringTableEntry_RIGHT(this), leaf, map, va);
  }
#ifdef XCC__C
  StringTable_indent--;
#endif//XCC__C
}

#line 672 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
#if XCC__C
static void
dump(String string, va_list va)
{
  FILE *file = (FILE *)va_arg(va, FILE *);
  fprintf(file, "    %s (%d)\n", (const char *)String_data(string), StringTable_indent);
}

#line 680 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
const char *
strings[] = {
  "aim", "your", "message", "at", "the", "audience", "you", "want", "to", "influence",
  "create", "specific", "messages", "for", "each", "segment", "of", "your", "audience",
  0
};

#line 687 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
static void
StringTable_test(bool copies)
{
  int32_t i;
  String string = 0;
  StringTable_ stringTable[1];
  StringTable_Ctor(stringTable, Memory_Root, copies);
  for (i = 0; strings[i]; i++) {
    const char *data = strings[i];
    int32_t length = strlen(data) + 1;
    printf("access(%s)\t", data);
    string = StringTable_search(stringTable, data, length);
    if (string != NULL) {
      printf("-> '%s'\n", (const char *)String_data(string));
    } else {
      printf("\n");
    }
    printf("insert(%s)\t", data);
    string = StringTable_insert(stringTable, data, length);
    if (string != NULL) {
      printf("-> '%s'\n", (const char *)String_data(string));
    } else {
      printf("*\n");
    }
  }
  StringTable_map(stringTable, dump, stdout, 0);
  StringTable_Dtor(stringTable);
}
#endif

#line 731 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
String
StringTable_S(StringTable this, const char *name)
{
  int32_t length = strlen(name) + 1;
  String string = StringTable_insert(this, name, length);
  Except_REQUIRE(StringTable_copies(this));
  if (string == NULL) {
    return StringTable_search(this, name, length);
  }
  return string;
}

#line 749 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
String
StringTable_D(StringTable this, int64_t lld)
{
  char data[64];
  int32_t length = sprintf(data, "%lld", lld) + 1;
  String string = StringTable_insert(this, data, length);
  Except_REQUIRE(StringTable_copies(this));
  if (string == NULL) {
    return StringTable_search(this, data, length);
  }
  return string;
}

#line 776 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 787 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
StringStoreItem
StringStoreItem_Ctor(StringStoreItem this,
                     int32_t length, struct StringStoreItem_ *next)
{
  *StringStoreItem__LENGTH(this) = length;
  *StringStoreItem__NEXT(this) = next;
  return this;
}

#line 805 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
StringStore
StringStore_Ctor(StringStore this, Memory memory)
{
  *StringStore__MEMORY(this) = memory;
  *StringStore__FIRST(this) = NULL;
  return this;
}

#line 813 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
void
StringStore_Dtor(StringStore this)
{
  Memory memory = StringStore_MEMORY(this);
  StringStoreItem item = StringStore_FIRST(this);
  while (item != NULL) {
    StringStoreItem next = StringStoreItem_NEXT(item);
    Memory_free(memory, item);
    item = next;
  }
  *StringStore__FIRST(this) = NULL;
}

#line 863 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
String
StringStore_push(StringStore this, const void *data, int32_t length)
{
  Memory memory = StringStore_MEMORY(this);
  size_t size = sizeof(StringStoreItem_) + length;
  StringStoreItem first = StringStore_FIRST(this);
  StringStoreItem item = Memory_alloc(memory, size);
  StringStoreItem_Ctor(item, length, first);
  memcpy(item + 1, data, length);
  *StringStore__FIRST(this) = item;
  return (String)(item + 1);
}

#line 898 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 910 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
#if XCC__C
static void
String_TEST(void)
{
#include "BSL/String_.c"
}

#line 917 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
int
main(int argc, char **argv)
{
  BSL_Test(String_TEST);
  return 0;
}
#endif


#endif//String_c_INCLUDED
