#ifndef DGraph_c_INCLUDED
#define DGraph_c_INCLUDED

#line 16 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
#include "CAL/CAL_.h"

#line 21 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 88 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
void
DGraphArc_attachTailNode(DGraphArc this, DGraphNode tailNode)
{
  DGraphArcCell this_cell = DGraphArc_CELL(this);
  DGraphNodeCell tail_nodeCell = DGraphNode_CELL(tailNode);
  Except_REQUIRE(DGraphArcCell_TAILNODE(this_cell) == NULL);
  *DGraphArcCell__TAILNODE(this_cell) = tailNode;
  *DGraphArcCell__LEAVEARC(this_cell) = DGraphNodeCell_LEAVEARC(tail_nodeCell);
  *DGraphNodeCell__LEAVEARC(tail_nodeCell) = this;
}

#line 105 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
void
DGraphArc_attachHeadNode(DGraphArc this, DGraphNode headNode)
{
  DGraphArcCell this_cell = DGraphArc_CELL(this);
  DGraphNodeCell head_nodeCell = DGraphNode_CELL(headNode);
  Except_REQUIRE(DGraphArcCell_HEADNODE(this_cell) == NULL);
  *DGraphArcCell__HEADNODE(this_cell) = headNode;
  *DGraphArcCell__ENTERARC(this_cell) = DGraphNodeCell_ENTERARC(head_nodeCell);
  *DGraphNodeCell__ENTERARC(head_nodeCell) = this;
}

#line 122 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
void
DGraphArc_detachTailNode(DGraphArc this)
{
  DGraphArcCell this_cell = DGraphArc_CELL(this);
  DGraphNode tailNode = DGraphArcCell_TAILNODE(this_cell);
  DGraphNodeCell tail_nodeCell = DGraphNode_CELL(tailNode);
  DGraphArc arc = DGraphNodeCell_LEAVEARC(tail_nodeCell), prev_arc = NULL;
  while (arc != this) {
    Except_CHECK(arc != NULL);
    prev_arc = arc;
    arc = DGraphArc_LEAVEARC(arc);
  }
  if (prev_arc != NULL) {
    DGraphArcCell prev_arcCell = DGraphArc_CELL(prev_arc);
    *DGraphArcCell__LEAVEARC(prev_arcCell) = DGraphArc_LEAVEARC(arc);
  } else {
    *DGraphNodeCell__LEAVEARC(tail_nodeCell) = DGraphArc_LEAVEARC(arc);
  }
  *DGraphArcCell__LEAVEARC(this_cell) = NULL;
  *DGraphArcCell__TAILNODE(this_cell) = NULL;
}

#line 150 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
void
DGraphArc_detachHeadNode(DGraphArc this)
{
  DGraphArcCell this_cell = DGraphArc_CELL(this);
  DGraphNode headNode = DGraphArcCell_HEADNODE(this_cell);
  DGraphNodeCell head_nodeCell = DGraphNode_CELL(headNode);
  DGraphArc arc = DGraphNodeCell_ENTERARC(head_nodeCell), prev_arc = NULL;
  while (arc != this) {
    Except_CHECK(arc != NULL);
    prev_arc = arc;
    arc = DGraphArc_ENTERARC(arc);
  }
  if (prev_arc != NULL) {
    DGraphArcCell prev_arcCell = DGraphArc_CELL(prev_arc);
    *DGraphArcCell__ENTERARC(prev_arcCell) = DGraphArc_ENTERARC(arc);
  } else {
    *DGraphNodeCell__ENTERARC(head_nodeCell) = DGraphArc_ENTERARC(arc);
  }
  *DGraphArcCell__ENTERARC(this_cell) = NULL;
  *DGraphArcCell__HEADNODE(this_cell) = NULL;
}

#line 172 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 244 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
void
DGraphNode_detachEnterArcs(DGraphNode this)
{
  DGraphArc enter_arc = DGraphNode_ENTERARC(this);
  while (enter_arc != NULL) {
    DGraphArcCell arcCell = DGraphArc_CELL(enter_arc);
    enter_arc = DGraphArc_ENTERARC(enter_arc);
    *DGraphArcCell__ENTERARC(arcCell) = NULL;
    *DGraphArcCell__HEADNODE(arcCell) = NULL;
  }
  *DGraphNode__ENTERARC(this) = NULL;
}

#line 263 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
void
DGraphNode_detachLeaveArcs(DGraphNode this)
{
  DGraphArc leave_arc = DGraphNode_LEAVEARC(this);
  while (leave_arc != NULL) {
    DGraphArcCell arcCell = DGraphArc_CELL(leave_arc);
    leave_arc = DGraphArc_LEAVEARC(leave_arc);
    *DGraphArcCell__LEAVEARC(arcCell) = NULL;
    *DGraphArcCell__TAILNODE(arcCell) = NULL;
  }
  *DGraphNode__LEAVEARC(this) = NULL;
}

#line 282 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
void
DGraphNode_sortLeaveArcs(DGraphNode this, int (*cmp)(const_DGraphArc, const_DGraphArc))
{
  void *leave = DGraphNode_LEAVEARC(this);
  if (leave != NULL && DGraphArc_LEAVEARC(leave) != NULL) {
    bool sorted = true;
    int32_t arcCount = 0, i = 0;
    DGraphArc prev_arc = leave;
    DGraphNode_FORLEAVE(this, DGraphArc_, arc) {
      if ((*cmp)(prev_arc, arc) > 0) sorted = false;
      prev_arc = arc;
      arcCount++;
    } DGraphNode_ENDLEAVE;
    if (!sorted) {
      DGraphArc arcArray[128];
      DGraphArc *arcs = arcCount > 128?
                        Memory_alloc(Memory_Root, sizeof(DGraphArc)*arcCount):
                        arcArray;
      DGraphNode_FORLEAVE(this, DGraphArc_, arc) {
        arcs[i++] = arc;
      } DGraphNode_ENDLEAVE;
      HackerPtr_Sort(arcs, 0, arcCount - 1, cmp);
      *DGraphNode__LEAVEARC(this) = arcs[0];
      for (i = 0; i < arcCount - 1; i++) {
        *DGraphArc__LEAVEARC(arcs[i]) = arcs[i + 1];
      }
      *DGraphArc__LEAVEARC(arcs[i]) = NULL;
      if (arcCount > 128) Memory_free_(Memory_Root, arcs);
    }
  }
}

#line 314 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 326 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
DGraphArcCell
DGraphArcCell_Ctor(DGraphArcCell this)
{
  *DGraphArcCell__TAILNODE(this) = NULL;
  *DGraphArcCell__HEADNODE(this) = NULL;
  *DGraphArcCell__LEAVEARC(this) = NULL;
  *DGraphArcCell__ENTERARC(this) = NULL;
  return this;
}

#line 336 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
void
DGraphArcCell_Dtor(DGraphArcCell this)
{
  *DGraphArcCell__TAILNODE(this) = NULL;
  *DGraphArcCell__HEADNODE(this) = NULL;
  *DGraphArcCell__LEAVEARC(this) = NULL;
  *DGraphArcCell__ENTERARC(this) = NULL;
}

#line 351 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 363 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
DGraphNodeCell
DGraphNodeCell_Ctor(DGraphNodeCell this, int32_t index)
{
  *DGraphNodeCell__INDEX(this) = index;
  *DGraphNodeCell__SCANNODE(this) = NULL;
  *DGraphNodeCell__LEAVEARC(this) = NULL;
  *DGraphNodeCell__ENTERARC(this) = NULL;
  return this;
}

#line 373 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
void
DGraphNodeCell_Dtor(DGraphNodeCell this)
{
  *DGraphNodeCell__SCANNODE(this) = NULL;
  *DGraphNodeCell__LEAVEARC(this) = NULL;
  *DGraphNodeCell__ENTERARC(this) = NULL;
}

#line 387 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 404 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
DGraph
DGraph_Ctor(DGraph this, Memory memory, int32_t maxNodes)
{
  *DGraph__ROOTNODE(this) = NULL;
  *DGraph__SCANNODE(this) = NULL;
  *DGraph__NODECOUNT(this) = 0;
  *DGraph__ARCCOUNT(this) = 0;
  PtrSeq_Ctor(DGraph_NODESTACK(this), memory, maxNodes);
  return this;
}

#line 415 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
void
DGraph_Dtor(DGraph this)
{
  PtrSeq_Dtor(DGraph_NODESTACK(this));
}

#line 434 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
void
DGraph_empty(DGraph this,
             void (*release_node)(DGraphNode),
             void (*release_arc)(DGraphArc))
{
  Memory memory = DGraph_MEMORY(this);
  DGraph_FOREACH(this, DGraphNode_, node) {
    DGraphArcCell prev_arcCell = NULL;
    DGraphNodeCell nodeCell = DGraphNode_CELL(node);
    DGraphNode_FORLEAVE(node, DGraphArc_, arc) {
      DGraphArcCell arcCell = DGraphArc_CELL(arc);
      if (prev_arcCell != NULL) {
        DGraphArcCell_Dtor(prev_arcCell);
        if (release_arc != NULL) (*release_arc)(arc);
        Memory_free_(memory, prev_arcCell);
      }
      prev_arcCell = arcCell;
    } DGraphNode_ENDLEAVE;
    if (prev_arcCell != NULL) {
      DGraphArcCell_Dtor(prev_arcCell);
      Memory_free_(memory, prev_arcCell);
    }
    DGraphNodeCell_Dtor(nodeCell);
    if (release_node != NULL) (*release_node)(node);
    Memory_free(memory, nodeCell);
  } DGraph_ENDEACH;
  *DGraph__ROOTNODE(this) = NULL;
  *DGraph__SCANNODE(this) = NULL;
  *DGraph__NODECOUNT(this) = 0;
  *DGraph__ARCCOUNT(this) = 0;
  PtrSeq_empty(DGraph_NODESTACK(this));
}

#line 467 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 582 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 590 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
DGraphNode
DGraph_makeNode(DGraph this, size_t nodeSize)
{
  Memory memory = DGraph_MEMORY(this);
  size_t adjustedSize = sizeof(DGraphNodeCell_) + nodeSize;
  size_t align_size = CDT_ALIGN_NEXT(adjustedSize);
  DGraphNodeCell nodeCell = Memory_alloc_(memory, align_size);
  DGraphNode node = DGraphNodeCell_NODE(nodeCell);
  int32_t count = DGraph_count(this);
  PtrSeq_push2(DGraph_NODESTACK(this), node);
  DGraphNodeCell_Ctor(DGraphNode_CELL(node), count);
  if (count == 0) {
    *DGraph__ROOTNODE(this) = node;
  }
  ++*DGraph__NODECOUNT(this);
  return node;
}

#line 636 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
DGraphArc
DGraph_makeArc(DGraph this, DGraphNode tail_node, DGraphNode head_node, size_t arcSize)
{
  Memory memory = DGraph_MEMORY(this);
  size_t adjustedSize = sizeof(DGraphArcCell_) + arcSize;
  size_t align_size = CDT_ALIGN_NEXT(adjustedSize);
  DGraphArcCell arcCell = DGraphArcCell_Ctor(Memory_alloc_(memory, align_size));
  return DGraph_attachArc(this, DGraphArcCell_ARC(arcCell), tail_node, head_node);
}

#line 652 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
DGraphArc
DGraph_getArc(DGraph this, DGraphNode tail_node, DGraphNode head_node, int position)
{
  DGraphNode_FORLEAVE(tail_node, DGraphArc_, arc) {
    if (DGraphArc_HEADNODE(arc) == head_node && position-- == 0) return arc;
  } DGraphNode_ENDLEAVE;
  return NULL;
}

#line 681 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
void
DGraph_removeArc(DGraph this, DGraphArc arc)
{
  Memory memory = DGraph_MEMORY(this);
  DGraphArcCell arcCell = DGraphArc_CELL(arc);
  DGraph_detachArc(this, arc);
  DGraphArcCell_Dtor(arcCell);
  Memory_free_(memory, arcCell);
  --*DGraph__ARCCOUNT(this);
}

#line 692 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 741 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
#if XCC__C
int id;
int V;
int *val;
PtrSeq stack;
DGraph dgraph;

#line 748 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
static void
DGraph_print(DGraph this)
{
  printf("forward stars:\n");
  DGraph_FOREACH(this, DGraphNode_, node) {
    printf("  node %c:\n", *(char *)node);
    DGraphNode_FORLEAVE(node, DGraphArc_, leave) {
      DGraphNode tailNode = DGraphArc_TAILNODE(leave);
      DGraphNode headNode = DGraphArc_HEADNODE(leave);
      printf("    %c -> %c\n", *(char *)tailNode, *(char *)headNode);
    } DGraphNode_ENDLEAVE;
  } DGraph_ENDEACH;
  printf("backward stars:\n");
  DGraph_FOREACH(this, DGraphNode_, node) {
    printf("  node %c:\n", *(char *)node);
    DGraphNode_FORENTER(node, DGraphArc_, enter) {
      DGraphNode tailNode = DGraphArc_TAILNODE(enter);
      DGraphNode headNode = DGraphArc_HEADNODE(enter);
      printf("    %c <- %c\n", *(char *)headNode, *(char *)tailNode);
    } DGraphNode_ENDENTER;
  } DGraph_ENDEACH;
}

#line 771 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
static int
DGraphNode_visit(DGraphNode this)
{
  int m, min;
  int k = DGraphNode_INDEX(this);
  val[k] = min = ++id;
  PtrSeq_push(stack, (void *)k);
  DGraphNode_FORLEAVE(this, DGraphArc_, arc) {
    DGraphNode head = DGraphArc_HEADNODE(arc);
    int index = DGraphNode_INDEX(head);
    if (val[index] == 0) {
      m = DGraphNode_visit(head);
    } else {
      m = val[index];
    }
    if (m < min) min = m;
  } DGraphNode_ENDLEAVE;
  if (min == val[k]) {
    do {
      m = (int *)PtrSeq_lastItem(stack);
      PtrSeq_pop(stack);
      printf("%c ", *((char *)DGraph_access(dgraph, m)));
      val[m] = V + 1;
    } while (m != k);
    printf("\n");
  }
  return min;
}

#line 800 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
static void
DGraph_visit(DGraph this)
{
  PtrSeq_ stack_;
  id = 0;
  V = DGraph_count(this);
  val = malloc(sizeof(int)*V);
  dgraph = this;
  memset(val, 0, V*sizeof(int));
  stack = &stack_;
  PtrSeq_Ctor(stack, Memory_Root, V);
  DGraphNode_visit(DGraph_rootNode(dgraph));
  PtrSeq_Dtor(stack);
  stack = NULL;
  free(val);
}
#endif

#line 818 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 830 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
#if XCC__C
static void
DGraph_TEST(void)
{
#include "CAL/DGraph_.c"
}

#line 837 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
int
main(int argc, char **argv)
{
  CAL_Test(DGraph_TEST);
  return 0;
}
#endif


#endif//DGraph_c_INCLUDED
