#ifndef Hierarchy_c_INCLUDED
#define Hierarchy_c_INCLUDED

#line 16 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
#include "CAL/CAL_.h"

#line 21 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 47 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
HierarchyComponent
HierarchyComponent_Ctor(HierarchyComponent this,
                        HierarchyComponentType type, DGraphNode node)
{
  *HierarchyComponent__TYPE(this) = type;
  *HierarchyComponent__DEPTH(this) = -1;
  *HierarchyComponent__NODE(this) = node;
  *HierarchyComponent__CHILD(this) = NULL;
  *HierarchyComponent__NEXT(this) = NULL;
  return this;
}

#line 107 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
static inline void
HierarchyComponent_putContents(HierarchyComponent this, HierarchyComponent child)
{
  *HierarchyComponent__DEPTH(child) = HierarchyComponent_DEPTH(this) + 1;
  *HierarchyComponent__NEXT(child) = HierarchyComponent_CHILD(this);
  *HierarchyComponent__CHILD(this) = child;
}

#line 120 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
#if !defined(CDT_NTRACE) || defined(XCC__C)
bool
HierarchyComponent_pretty(const_HierarchyComponent this, FILE *file,
                          bool (*node_pretty)(DGraphNode, FILE*))
{
  HierarchyComponentType type = HierarchyComponent_TYPE(this);
  if (file == NULL) file = stderr;
  if (type == HierarchyComponentType_Node) {
    DGraphNode node = HierarchyComponent_NODE(this);
    if (node_pretty != NULL) (*node_pretty)(node, file);
    else fprintf(file, "%d", DGraphNode_NUMBER(node));
  } else {
    const char *sep = "";
    if (type == HierarchyComponentType_SCC) fprintf(file, "(");
    if (type == HierarchyComponentType_Loop) fprintf(file, "[");
    HierarchyComponent_CHILDREN_FOREACH_HierarchyComponent(this, component) {
      fputs(sep, file);
      HierarchyComponent_pretty(component, file, node_pretty);
      sep = " ";
    } HierarchyComponent_CHILDREN_ENDEACH_HierarchyComponent;
    if (type == HierarchyComponentType_Loop) fprintf(file, "]");
    if (type == HierarchyComponentType_SCC) fprintf(file, ")");
  }
  return true;
}
#endif//CDT_NTRACE

#line 151 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
void
HierarchyComponent_free(HierarchyComponent this, Memory memory)
{
  HierarchyComponent next = HierarchyComponent_NEXT(this);
  HierarchyComponent child = HierarchyComponent_CHILD(this);
  if (child != NULL) HierarchyComponent_free(child, memory);
  if (next != NULL) HierarchyComponent_free(next, memory);
  Memory_free_(memory, this);
}

#line 161 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 178 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
Hierarchy
Hierarchy_Ctor(Hierarchy this, Memory memory, DGraph dgraph, DGraphNode entry)
{
  int32_t count = DGraph_count(dgraph);
  HierarchyComponent root = Hierarchy_ROOTNODE(this);
  *Hierarchy__MEMORY(this) = memory;
  *Hierarchy__COUNT(this) = count;
  *Hierarchy__NODEOF(this) = DGraph_nodeOf(dgraph);
  *Hierarchy__ENTRY(this) = entry;
  *Hierarchy__DFN(this) = Memory_alloc(memory, sizeof(int32_t)*(count+1));
  *Hierarchy__PAST(this) = Memory_alloc(memory, sizeof(int32_t)*count);
  HierarchyComponent_Ctor(root, HierarchyComponentType_Root, NULL);
  return this;
}

#line 193 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
void
Hierarchy_Dtor(Hierarchy this)
{
  Memory memory = Hierarchy_MEMORY(this);
  HierarchyComponent root = Hierarchy_ROOTNODE(this);
  HierarchyComponent child = HierarchyComponent_CHILD(root);
  Memory_free_(memory, Hierarchy_DFN(this));
  Memory_free_(memory, Hierarchy_PAST(this));
  *HierarchyComponent__CHILD(root) = NULL;
  if (child != NULL) HierarchyComponent_free(child, memory);
}

#line 205 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
size_t
Hierarchy_Size(Memory memory, DGraph dgraph, DGraphNode entry)
{
  return sizeof(Hierarchy_);
}

#line 220 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
#ifndef Hierarchy_POOLED
#define Hierarchy_POOLED 128
#endif//Hierarchy_POOLED

#line 224 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
Hierarchy
Hierarchy_new(Memory parent, DGraph dgraph, DGraphNode entry)
{
  Memory memory = Memory_new(parent, Hierarchy_POOLED);
  size_t size = Hierarchy_Size(memory, dgraph, entry);
  Hierarchy this = Memory_alloc(memory, size);
  return Hierarchy_Ctor(this, memory, dgraph, entry);
}

#line 237 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
Hierarchy
Hierarchy_delete(Hierarchy this)
{
  if (this != NULL) {
    Memory memory = Hierarchy_MEMORY(this);
#ifndef CDT_NDTOR
    Hierarchy_Dtor(this);
    Memory_free_(memory, this);
#endif//CDT_NDTOR
    Memory_delete(memory);
  }
  return NULL;
}

#line 258 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
static inline HierarchyComponent
Hierarchy_makeComponent(Hierarchy this, HierarchyComponentType type, DGraphNode node)
{
  Memory memory = Hierarchy_MEMORY(this);
  HierarchyComponent component = Memory_alloc(memory, sizeof(HierarchyComponent_));
  HierarchyComponent_Ctor(component, type, node);
  return component;
}

#line 272 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
#if !defined(CDT_NTRACE) || defined(XCC__C)
bool
Hierarchy_pretty(const_Hierarchy this, FILE *file,
                 bool (*node_pretty)(DGraphNode, FILE*))
{
  const_HierarchyComponent root = Hierarchy_ROOTNODE(this);
  if (file == NULL) file = stderr;
  HierarchyComponent_pretty(root, file, node_pretty);
  fprintf(file, "\n");
  return true;
}
#endif//CDT_NTRACE

#line 285 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
/*
 * This is the classic SCC algorithm from Tarjan adapted from F. Bourdoncle's
 * PhD thesis ``Semantique des langages imperatifs d'ordre superieur et interpretation
 * abstraite'', 1992, Figure 3.8 p. 41.
 */
static int32_t
Hierarchy_visitTarjan(Hierarchy this, int32_t vertex, HierarchyComponent parent)
{
  DGraphNode *nodeOf = Hierarchy_NODEOF(this);
  int32_t *dfn = Hierarchy_DFN(this);
  int32_t head = dfn[vertex] = ++dfn[0];
  bool loop = false;
  *Hierarchy_PAST(this) = vertex;
  ++*Hierarchy__PAST(this);
  DGraphNode_FORLEAVE(nodeOf[vertex], DGraphArc_, arc) {
    int32_t succ = DGraphNode_NUMBER(DGraphArc_HEADNODE(arc)), min = 0;
    if (dfn[succ] <= 0) {
      min = Hierarchy_visitTarjan(this, succ, parent);
    } else {
      min = dfn[succ];
    }
    if (min <= head) {
      head = min;
      loop = true;
    }
  } DGraphNode_ENDLEAVE;
  if (head == dfn[vertex]) {
    int32_t element = 0;
    HierarchyComponent component = NULL;
    if (loop) {
      component = Hierarchy_makeComponent(this, HierarchyComponentType_SCC,
                                          nodeOf[vertex]);
      HierarchyComponent_putContents(parent, component);
      parent = component;
    }
    do {
      --*Hierarchy__PAST(this);
      element = *Hierarchy_PAST(this);
      dfn[element] = INT32_MAX;
      component = Hierarchy_makeComponent(this, HierarchyComponentType_Node,
                                          nodeOf[element]);
      HierarchyComponent_putContents(parent, component);
    } while (element != vertex);
  }
  return head;
}

#line 332 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
/*
 * This implementation is adapted from F. Bourdoncle's paper, ``Efficient Chaotic
 * Iteration Strategies with Widenings'', Proc. of the International Conference
 * on Formal Methods in Programming and their Applications, Lecture Notes in
 * Computer Science 735, Springer-Verlag 1993. The Tarjan-Bourdoncle algorithm
 * runs in O(de), where d is the maximum loop nesting depth.
 *
 * The algorithm is extended to detect the extra loop entry nodes as proposed by
 * Steensgaard in ``Sequentializing Program Dependence Graphs for Irreducible
 * Programs''. The resulting loop forest is not Steengaard's though, because
 * the SCC root nodes are removed one at a time. In Steensgaard's forest, all
 * the heads of looping arcs are removed before reprocessing the current SCC.
 */
static int32_t
Hierarchy_visitBourdoncle(Hierarchy this, int32_t vertex, HierarchyComponent parent)
{
  DGraphNode *nodeOf = Hierarchy_NODEOF(this);
  int32_t *dfn = Hierarchy_DFN(this);
  int32_t head = dfn[vertex] = ++dfn[0];
  bool loop = false;
  *Hierarchy_PAST(this) = vertex;
  ++*Hierarchy__PAST(this);
  DGraphNode_FORLEAVE(nodeOf[vertex], DGraphArc_, arc) {
    int32_t succ = DGraphNode_NUMBER(DGraphArc_HEADNODE(arc)), min = 0;
    if (dfn[succ] <= 0) {
      min = Hierarchy_visitBourdoncle(this, succ, parent);
    } else {
      min = dfn[succ];
    }
    if (min <= head) {
      head = min;
      loop = true;
    }
  } DGraphNode_ENDLEAVE;
  if (head == dfn[vertex]) {
    int32_t element = 0, *start = NULL;
    int32_t *last = Hierarchy_PAST(this) - 1;
    HierarchyComponent component = NULL;
    dfn[vertex] = INT32_MAX;
    --*Hierarchy__PAST(this);
    element = *Hierarchy_PAST(this);
    if (loop) {
      int32_t stamp = -1;
      int32_t extraCount = 0;
      HierarchyComponentType type = HierarchyComponentType_Loop;
      while (element != vertex) {
        dfn[element] = stamp;
        --*Hierarchy__PAST(this);
        element = *Hierarchy_PAST(this);
      }
      // Traverse the SCC excluding its root to identify other loop entry nodes.
      for (start = Hierarchy_PAST(this) + 1; start <= last; start++) {
        DGraphNode_FORENTER(nodeOf[*start], DGraphArc_, arc) {
          int32_t pred = DGraphNode_NUMBER(DGraphArc_TAILNODE(arc));
          if (pred != vertex && dfn[pred] != stamp) {
            ++extraCount;
            break;
          }
        } DGraphNode_ENDENTER;
      }
      if (extraCount > 0) type = HierarchyComponentType_SCC;
      component = Hierarchy_makeComponent(this, type, nodeOf[vertex]);
      HierarchyComponent_putContents(parent, component);
      parent = component;
      DGraphNode_FORLEAVE(nodeOf[vertex], DGraphArc_, arc) {
        int32_t succ = DGraphNode_NUMBER(DGraphArc_HEADNODE(arc));
        if (dfn[succ] <= 0) {
          Hierarchy_visitBourdoncle(this, succ, parent);
        }
      } DGraphNode_ENDLEAVE;
    }
    component = Hierarchy_makeComponent(this, HierarchyComponentType_Node,
                                        nodeOf[element]);
    HierarchyComponent_putContents(parent, component);
  }
  return head;
}

#line 416 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
void
Hierarchy_makeSCC(Hierarchy this)
{
  int32_t count = Hierarchy_COUNT(this);
  DGraphNode entry = Hierarchy_ENTRY(this);
  HierarchyComponent root = Hierarchy_ROOTNODE(this);
  Memory memory = Hierarchy_MEMORY(this);
  HierarchyComponent child = HierarchyComponent_CHILD(root);
  if (child != NULL) HierarchyComponent_free(child, memory);
  HierarchyComponent_Ctor(root, HierarchyComponentType_Root, NULL);
  memset(Hierarchy_DFN(this), 0, sizeof(int32_t)*(count+1));
  Hierarchy_visitTarjan(this, DGraphNode_NUMBER(entry), Hierarchy_ROOTNODE(this));
}

#line 442 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
void
Hierarchy_makeNSCC(Hierarchy this)
{
  int32_t count = Hierarchy_COUNT(this);
  DGraphNode entry = Hierarchy_ENTRY(this);
  HierarchyComponent root = Hierarchy_ROOTNODE(this);
  Memory memory = Hierarchy_MEMORY(this);
  HierarchyComponent child = HierarchyComponent_CHILD(root);
  if (child != NULL) HierarchyComponent_free(child, memory);
  HierarchyComponent_Ctor(root, HierarchyComponentType_Root, NULL);
  memset(Hierarchy_DFN(this), 0, sizeof(int32_t)*(count+1));
  Hierarchy_visitBourdoncle(this, DGraphNode_NUMBER(entry), Hierarchy_ROOTNODE(this));
}

#line 702 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 714 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
#if XCC__C
static void
Hierarchy_TEST(void)
{
#include "CAL/Hierarchy_.c"
}

#line 721 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
int
main(int argc, char **argv)
{
  CAL_Test(Hierarchy_TEST);
  return 0;
}
#endif


#endif//Hierarchy_c_INCLUDED
