#ifndef BitSet_c_INCLUDED
#define BitSet_c_INCLUDED

#line 16 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/BitSet.xcc"
#include "CCL/CCL_.h"

#line 21 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/BitSet.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 43 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/BitSet.xcc"
BitSet
BitSet_Ctor(BitSet this, Memory memory, int32_t universe)
{
  int32_t wordCount = BitSet_MAJOR(universe + BitSet_WORDBITS - 1);
  IArray_Ctor(BitSet_ARRAY(this), memory, sizeof(BitSetWord), wordCount);
  return this;
}

#line 51 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/BitSet.xcc"
void
BitSet_Dtor(BitSet this)
{
  IArray_Dtor(BitSet_ARRAY(this));
}

#line 68 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/BitSet.xcc"
void
BitSet_empty(BitSet this)
{
  IArray_empty(BitSet_ARRAY(this), NULL);
  Except_CHECK(BitSet_isEmpty(this));
}

#line 75 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/BitSet.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 113 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/BitSet.xcc"
bool
BitSet_isEmpty(const_BitSet this)
{
  const BitSetWord *words = BitSet_words(this);
  int32_t wordCount = BitSet_wordCount(this), i;
  for (i = 0; i < wordCount; i++) {
    if (words[i] != 0) return false;
  }
  return true;
}

#line 136 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/BitSet.xcc"
int32_t
BitSet_count(const_BitSet this)
{
  const BitSetWord *words = BitSet_words(this);
  int32_t wordCount = BitSet_wordCount(this), count = 0, i;
  for (i = 0; i < wordCount; i++) count += HackerU64_popc(words[i]);
  return count;
}

#line 201 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/BitSet.xcc"
BitSetMember
BitSet_choose(BitSet this)
{
  BitSetWord *words = BitSet_WORDS(this);
  int32_t wordCount = BitSet_wordCount(this), i, j;
  for (i = 0; i < wordCount; i++) {
    BitSetWord word = words[i];
    for (j = 0; word != 0; j++, word >>= 1) {
      if (word & 1) {
        words[i] &= ~((BitSetWord)1 << j);
        return i*BitSet_WORDBITS + j;
      }
    }
  }
  return (BitSetMember)-1;
}

#line 224 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/BitSet.xcc"
BitSetMember
BitSet_nextMember(const_BitSet this, BitSetMember member)
{
  BitSetWord *words = BitSet_WORDS(this);
  int32_t wordCount = BitSet_wordCount(this);
  uint32_t i = BitSet_MAJOR(member + 1);
  uint32_t j = BitSet_MINOR(member + 1);
  if (i < wordCount) {
    BitSetWord word = words[i] >> j;
    for (; word != 0; j++, word >>= 1) {
      if (word & 1) {
        return i*BitSet_WORDBITS + j;
      }
    }
  }
  for (i++; i < wordCount; i++) {
    BitSetWord word = words[i];
    for (j = 0; word != 0; j++, word >>= 1) {
      if (word & 1) {
        return i*BitSet_WORDBITS + j;
      }
    }
  }
  return (BitSetMember)-1;
}

#line 256 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/BitSet.xcc"
bool
BitSet_equals(const_BitSet this, const_BitSet that)
{
  Except_REQUIRE(BitSet_wordCount(this) == BitSet_wordCount(that));
  return memcmp(BitSet_WORDS(this), BitSet_WORDS(that),
                BitSet_wordCount(this)*sizeof(BitSetWord));
}

#line 270 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/BitSet.xcc"
bool
BitSet_union(BitSet this, BitSet that)
{
  bool change = false;
  int32_t wordCount = BitSet_wordCount(this), i;
  Except_REQUIRE(BitSet_wordCount(this) == BitSet_wordCount(that));
  // Assume non used bits in the last word are all zero.
  for (i = 0; i < wordCount; i++) {
    change |= (BitSet_WORDS(this)[i] != BitSet_WORDS(that)[i]);
    BitSet_WORDS(this)[i] |= BitSet_WORDS(that)[i];
  }
  return change;
}

#line 290 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/BitSet.xcc"
bool
BitSet_inter(BitSet this, BitSet that)
{
  bool change = false;
  int32_t wordCount = BitSet_wordCount(this), i;
  Except_REQUIRE(BitSet_wordCount(this) == BitSet_wordCount(that));
  // Assume non used bits in the last word are all zero.
  for (i = 0; i < wordCount; i++) {
    change |= (BitSet_WORDS(this)[i] != BitSet_WORDS(that)[i]);
    BitSet_WORDS(this)[i] &= BitSet_WORDS(that)[i];
  }
  return change;
}

#line 310 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/BitSet.xcc"
bool
BitSet_diff(BitSet this, BitSet that)
{
  bool change = false;
  int32_t wordCount = BitSet_wordCount(this), i;
  Except_REQUIRE(BitSet_wordCount(this) == BitSet_wordCount(that));
  // Assume non used bits in the last word are all zero.
  for (i = 0; i < wordCount; i++) {
    change |= (BitSet_WORDS(this)[i] != BitSet_WORDS(that)[i]);
    BitSet_WORDS(this)[i] &= ~BitSet_WORDS(that)[i];
  }
  return change;
}

#line 377 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/BitSet.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 389 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/BitSet.xcc"
#if XCC__C
static void
BitSet_TEST(void)
{
#include "CCL/BitSet_.c"
}

#line 396 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/BitSet.xcc"
int
main(int argc, char **argv)
{
  CCL_Test(BitSet_TEST);
  return 0;
}
#endif


#endif//BitSet_c_INCLUDED
