#ifndef HTable_c_INCLUDED
#define HTable_c_INCLUDED

#line 16 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
#include "CCL/CCL_.h"

#line 21 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 52 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 70 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
HTableEntry
HTableEntry_Ctor(HTableEntry this,
                 HTableKey key, size_t valueSize, struct HTableEntry_ *link)
{
  *HTableEntry__KEY(this) = key;
  *HTableEntry__LINK(this) = link;
  return this;
}

#line 79 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
size_t
HTableEntry_Size(HTableKey key, size_t valueSize, struct HTableEntry_ *link)
{
  return (sizeof(HTableEntry_) + valueSize);
}

#line 112 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 128 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
HTable
HTable_Ctor(HTable this, Memory memory, uint32_t estimate)
{
  *HTable__MEMORY(this) = memory;
  *HTable__MASK(this) = 0;
  *HTable__COUNT(this) = 0;
  *HTable__BUCKETS(this) = NULL;
  if (estimate > 0) HTable_resize(this, estimate);
  return this;
}

#line 139 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
void
HTable_Dtor(HTable this)
{
  Memory memory = HTable_MEMORY(this);
  HTable_empty(this, NULL);
  Memory_free(memory, HTable_BUCKETS(this));
}

#line 158 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
void
HTable_resize(HTable this, uint32_t estimate)
{
  Memory memory = HTable_MEMORY(this);
  HTableEntry *buckets = HTable_BUCKETS(this);
  uint32_t clp2 = HackerU32_clp2(estimate), mask = clp2 - 1;
  size_t size = clp2*sizeof(HTableEntry);
  HTableEntry *new_buckets = Memory_alloc_(memory, size);
  memset(new_buckets, 0, size);
  if (buckets != NULL) {
    HTable_FOREACH(this, key, void, _) {
      uint32_t hash = HTable_Hash((uint32_t)key);
      int32_t index = hash & mask;
      *HTableEntry__LINK(HTable_ENTRY) = new_buckets[index];
      new_buckets[index] = HTable_ENTRY;
    } HTable_ENDEACH;
    Memory_free(memory, buckets);
  }
  *HTable__MASK(this) = mask;
  *HTable__BUCKETS(this) = new_buckets;
}

#line 186 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
void
HTable_empty(HTable this, HTableValueRelease release)
{
  HTableEntry *buckets = HTable_BUCKETS(this);
  if (buckets != NULL) {
    Memory memory = HTable_MEMORY(this);
    uint32_t mask = HTable_MASK(this), i;
    for (i = 0; i <= mask; i++) {
      HTableEntry entry = buckets[i];
      while (entry != NULL) {
        HTableEntry link = HTableEntry_LINK(entry);
        HTableValue value = HTableEntry_VALUE(entry);
        if (release != NULL) (*release)(value);
        Memory_free_(memory, entry);
        entry = link;
      }
      buckets[i] = NULL;
    }
  }
  *HTable__COUNT(this) = 0;
  Except_CHECK(HTable_isEmpty(this));
}

#line 209 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 284 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 293 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
HTableValue
HTable_search(const_HTable this, HTableKey key)
{
  HTableEntry *buckets = HTable_BUCKETS(this);
  uint32_t hash = HTable_Hash((uint32_t)key);
  uint32_t mask = HTable_MASK(this);
  int32_t index = hash & mask;
  HTableEntry entry = buckets[index];
  while (entry != NULL) {
    HTableEntry link = HTableEntry_LINK(entry);
    if (HTableEntry_KEY(entry) == key) {
      return HTableEntry_VALUE(entry);
    }
    entry = link;
  }
  return NULL;
}

#line 320 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
HTableValue
HTable_lookup_(HTable this, HTableKey key, size_t valueSize)
{
  Memory memory = HTable_MEMORY(this);
  HTableEntry *buckets = HTable_BUCKETS(this);
  uint32_t hash = HTable_Hash((uint32_t)key);
  uint32_t mask = HTable_MASK(this);
  int32_t count = HTable_COUNT(this);
  int32_t index = hash & mask;
  HTableEntry entry = buckets[index];
  while (entry != NULL) {
    HTableEntry link = HTableEntry_LINK(entry);
    if (HTableEntry_KEY(entry) == key) {
      return HTableEntry_VALUE(entry);
    }
    entry = link;
  }
  entry = Memory_alloc(memory, HTableEntry_Size(key, valueSize, buckets[index]));
  HTableEntry_Ctor(entry, key, valueSize, buckets[index]);
  buckets[index] = entry;
  *HTable__COUNT(this) = count + 1;
  if (count > mask) HTable_resize(this, count + 1);
  return HTableEntry_VALUE(entry);
}

#line 368 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
HTableValue
HTable_insert(HTable this, HTableKey key, size_t valueSize)
{
  Memory memory = HTable_MEMORY(this);
  HTableEntry *buckets = HTable_BUCKETS(this);
  uint32_t hash = HTable_Hash((uint32_t)key);
  uint32_t mask = HTable_MASK(this);
  int32_t count = HTable_COUNT(this);
  int32_t index = hash & mask;
  HTableEntry entry = buckets[index];
  while (entry != NULL) {
    HTableEntry link = HTableEntry_LINK(entry);
    if (HTableEntry_KEY(entry) == key) {
      return NULL;
    }
    entry = link;
  }
  entry = Memory_alloc(memory, HTableEntry_Size(key, valueSize, buckets[index]));
  HTableEntry_Ctor(entry, key, valueSize, buckets[index]);
  buckets[index] = entry;
  *HTable__COUNT(this) = count + 1;
  if (count > mask) HTable_resize(this, count + 1);
  return HTableEntry_VALUE(entry);
}

#line 399 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
HTableEntry
HTable_remove_(HTable this, HTableKey key)
{
  HTableEntry *buckets = HTable_BUCKETS(this);
  uint32_t hash = HTable_Hash((uint32_t)key);
  uint32_t mask = HTable_MASK(this);
  int32_t index = hash & mask;
  HTableEntry entry = buckets[index], prev_entry = NULL;
  while (entry != NULL) {
    HTableEntry link = HTableEntry_LINK(entry);
    HTableValue value = HTableEntry_VALUE(entry);
    if (HTableEntry_KEY(entry) == key) {
      if (prev_entry != NULL) {
        *HTableEntry__LINK(prev_entry) = link;
      } else {
        buckets[index] = link;
      }
      --*HTable__COUNT(this);
      return entry;
    }
    prev_entry = entry;
    entry = link;
  }
  return NULL;
}

#line 455 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
void
HTable_map(HTable this, void (*map)(HTableKey, HTableValue, va_list), ...)
{
  va_list va;
  va_start(va, map);
  HTable_FOREACH(this, key, void, value) {
    (*map)(key, value, va);
  } HTable_ENDEACH;
  va_end(va);
}

#line 532 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
#if XCC__C
static int
HTable_compare(HTableKey a, HTableKey b)
{
  return (*(const int *)a > *(const int *)b) -
      (*(const int *)a < *(const int *)b);
}

#line 540 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
static void
HTable_VAL(HTableKey key, HTableValue value, va_list va)
{
  int *array = va_arg(va, int *);
  int *index = va_arg(va, int *);
  array[*index] = *(int *)value;
  ++*index;
}
#endif

#line 550 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 562 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
#if XCC__C
static void
HTable_TEST(void)
{
#include "CCL/HTable_.c"
}

#line 569 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
int
main(int argc, char **argv)
{
  CCL_Test(HTable_TEST);
  return 0;
}
#endif


#endif//HTable_c_INCLUDED
