#ifndef HTable__c_INCLUDED
#define HTable__c_INCLUDED

#line 39 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
//
{
  int i, j;
  for (i = 0; i < 8; i++) {
    for (j = 0; j < 8; j++) {
      uint32_t number = (1<<i)*j;
      uint32_t hash = HTable_Hash(number);
      printf("%4x=>%4x\t", number, hash & 0xffff);
    }
    printf("\n");
  }
}

#line 85 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
//
{
  printf("sizeof(HTableEntry_) = %d\n", sizeof(HTableEntry_));
  Except_ALWAYS(CDT_ALIGNED(sizeof(HTableEntry_)));
}

#line 147 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
//
{
  printf("sizeof(HTable_) = %d\n", sizeof(HTable_));
}

#line 466 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
//
{
  int i, j, k;
  HTable_ htable[1];
  HTable_Ctor(htable, Memory_Root, 10);
#define NumItems 500
  printf("Insert:\n");
  for (i = 0, j = 0; i < NumItems; i++, j = (j + 7)%NumItems) {
    *(int *)HTable_insert(htable, (HTableKey)(j), sizeof(int *)) = j;
    k = *(int *)HTable_search(htable, (HTableKey)(j));
    if (k != j) printf("Error0 at %d\n", j);
  }
  printf("Entry count = %d\n", HTable_COUNT(htable));
  for (j = 0; j < 2; j++) {
    for (i = 0; i < NumItems; i++) {
      k = *(int *)HTable_search(htable, (HTableKey)(i));
      if (k != i) printf("Error1 at %d\n", i);
    }
  }
  printf("Remove\n");
  for (i = 0; i < NumItems; i += 2) {
    if (HTable_remove(htable, (HTableKey)(i), NULL));
    else printf("Error3 at %d\n", i);
  }
  for (i = 1; i < NumItems; i += 2) {
    k = *(int *)HTable_search(htable, (HTableKey)(i));
    if (k != i) printf("Error4 at %d\n", i);
  }
  for (i = 0; i < NumItems; i += 2) {
    if (HTable_search(htable, (HTableKey)(i)) != NULL) {
      printf("Error5 at %d\n", i);
    }
  }
  {
    int array[NumItems], index = 0;
    HTable_map(htable, HTable_VAL, array, &index);
    qsort((char *) array, index, sizeof(int), HTable_compare);
    printf("[ ");
    for (i = 0; i < index; i++) {
      printf("%d ", array[i]);
    }
    printf("]\n");
  }
  printf("Entry count = %d\n", HTable_COUNT(htable));
  for (i = NumItems - 1; i > 0; i -= 2) {
    if (HTable_remove(htable, (HTableKey)(i), NULL));
    else printf("Error6 at %d\n", i);
  }
  printf("Node count = %d\n", HTable_COUNT(htable));
  HTable_Dtor(htable);
}

#line 518 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/HTable.xcc"
//
{
  int i, j;
  HTable_ htable[1];
  HTable_Ctor(htable, Memory_Root, 10);
  for (i = 0, j = 0; i < NumItems; i++, j = (j + 7)%NumItems) {
    HTable_insert(htable, (HTableKey)(j), 0);
  }
  for (i = 0; i < NumItems; i += 2) {
    HTable_remove(htable, (HTableKey)(i), NULL);
  }
  HTable_Dtor(htable);
}


#endif//HTable__c_INCLUDED
