#ifndef IArray_c_INCLUDED
#define IArray_c_INCLUDED

#line 20 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IArray.xcc"
#include "CCL/CCL_.h"

#line 25 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IArray.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 47 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IArray.xcc"
IArray
IArray_Ctor(IArray this, Memory memory, size_t itemSize, int32_t maxCount)
{
  *IArray__MEMORY(this) = memory;
  *IArray__ITEMSIZE(this) = itemSize;
  Except_REQUIRE(itemSize > 0);
  *IArray__MAXCOUNT(this) = 0;
  *IArray__BASE(this) = NULL;
  if (maxCount > 0) IArray_resize(this, maxCount);
  return this;
}

#line 59 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IArray.xcc"
void
IArray_Dtor(IArray this)
{
  Memory memory = IArray_MEMORY(this);
  Memory_free(memory, IArray_BASE(this));
}

#line 82 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IArray.xcc"
void
IArray_resize(IArray this, int32_t maxCount)
{
  Memory memory = IArray_MEMORY(this);
  size_t itemSize = IArray_ITEMSIZE(this);
  int32_t old_maxCount = IArray_MAXCOUNT(this);
  if (maxCount > old_maxCount) {
    size_t maxSize = maxCount*itemSize;
    size_t alignedSize = CDT_ALIGN_NEXT(maxSize);
    char *new_base = Memory_alloc_(memory, alignedSize);
    char *old_base = IArray_BASE(this);
    size_t old_maxSize = IArray_MAXSIZE(this);
    if (old_maxSize != 0) {
      memcpy(new_base, old_base, old_maxSize);
      Memory_free_(memory, old_base);
    } else {
      Memory_free(memory, old_base);
    }
    memset(new_base + old_maxSize, 0, alignedSize - old_maxSize);
    while ((alignedSize -= itemSize) >= maxSize) ++maxCount;
    *IArray__BASE(this) = new_base;
    *IArray__MAXCOUNT(this) = maxCount;
  }
}

#line 113 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IArray.xcc"
void
IArray_empty(IArray this, IArrayItemRelease release)
{
  char *base = IArray_BASE(this);
  size_t itemSize = IArray_ITEMSIZE(this);
  int32_t maxCount = IArray_MAXCOUNT(this), i;
  if (base != NULL) {
    if (release != NULL) {
      for (i = 0; i < maxCount; i++) {
        (*release)(base + i*itemSize);
      }
    }
    memset(base, 0, IArray_MAXSIZE(this));
  }
}

#line 129 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IArray.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 306 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IArray.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 318 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IArray.xcc"
#if XCC__C
static void
IArray_TEST(void)
{
#include "CCL/IArray_.c"
}

#line 325 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IArray.xcc"
int
main(int argc, char **argv)
{
  CCL_Test(IArray_TEST);
  return 0;
}
#endif


#endif//IArray_c_INCLUDED
