#ifndef IETree_c_INCLUDED
#define IETree_c_INCLUDED

#line 20 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
#include "CCL/CCL_.h"

#line 25 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 74 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
IETreeNode
IETreeNode_Ctor(IETreeNode this, IETreeMember low, IETreeMember high)
{
  Except_REQUIRE(IETreeMember_LE(low, high));
  *IETreeNode__LOW(this) = low;
  *IETreeNode__HIGH(this) = high;
  *IETreeNode__LEFT(this) = NULL;
  *IETreeNode__RIGHT(this) = NULL;
  return this;
}

#line 85 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
void
IETreeNode_Dtor(IETreeNode this)
{
  *IETreeNode__LEFT(this) = NULL;
  *IETreeNode__RIGHT(this) = NULL;
}

#line 92 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 108 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
IETree
IETree_Ctor(IETree this, Memory memory)
{
  *IETree__MEMORY(this) = memory;
  *IETree__ROOT(this) = NULL;
  *IETree__LOW(this) = (IETreeMember)0;
  *IETree__HIGH(this) = (IETreeMember)0;
  *IETree__COUNT(this) = 0;
  *IETree__ORDER(this) = 0;
  return this;
}

#line 120 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
static void
IETree_killNode(IETree this, IETreeNode node)
{
  Memory memory = IETree_MEMORY(this);
  IETreeNode left = IETreeNode_LEFT(node);
  IETreeNode right = IETreeNode_RIGHT(node);
  if (left != NULL) IETree_killNode(this, left);
  if (right != NULL) IETree_killNode(this, right);
  IETreeNode_Dtor(node);
  Memory_free_(memory, node);
}

#line 132 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
void
IETree_Dtor(IETree this)
{
  IETreeNode root = IETree_ROOT(this);
  if (root != NULL) IETree_killNode(this, root);
  *IETree__ROOT(this) = NULL;
  *IETree__LOW(this) = (IETreeMember)0;
  *IETree__HIGH(this) = (IETreeMember)0;
  *IETree__COUNT(this) = 0;
  *IETree__ORDER(this) = 0;
}

#line 149 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 198 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
static inline IETreeNode
IETree_makeNode(IETree this, IETreeMember low, IETreeMember high)
{
  IETreeNode new_node = Memory_alloc_(IETree_MEMORY(this), sizeof(IETreeNode_));
  IETreeNode_Ctor(new_node, low, high);
  ++*IETree__ORDER(this);
  return new_node;
}

#line 213 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
static inline void
IETree_delNode(IETree this, IETreeNode node)
{
  --*IETree__ORDER(this);
  IETreeNode_Dtor(node);
  Memory_free(IETree_MEMORY(this), node);
}

#line 227 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
IETreeNode
IETree_splitMin(IETree this, IETreeNode node)
{
  IETreeNode prev_node = NULL;
  IETreeNode min_node = node;
  IETreeNode split_node = node;
  while (IETreeNode_LEFT(min_node) != NULL) {
    prev_node = min_node;
    min_node = IETreeNode_LEFT(min_node);
  }
  if (prev_node != NULL) {
    *IETreeNode__LEFT(prev_node) = IETreeNode_RIGHT(min_node);
  } else {
    split_node = IETreeNode_RIGHT(min_node);
  }
  *IETree__LOW(this) = IETreeNode_LOW(min_node);
  *IETree__HIGH(this) = IETreeNode_HIGH(min_node);
  IETree_delNode(this, min_node);
  return split_node;
}

#line 254 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
IETreeNode
IETree_splitMax(IETree this, IETreeNode node)
{
  IETreeNode prev_node = NULL;
  IETreeNode max_node = node;
  IETreeNode split_node = node;
  while (IETreeNode_RIGHT(max_node) != NULL) {
    prev_node = max_node;
    max_node = IETreeNode_RIGHT(max_node);
  }
  if (prev_node != NULL) {
    *IETreeNode__RIGHT(prev_node) = IETreeNode_LEFT(max_node);
  } else {
    split_node = IETreeNode_LEFT(max_node);
  }
  *IETree__LOW(this) = IETreeNode_LOW(max_node);
  *IETree__HIGH(this) = IETreeNode_HIGH(max_node);
  IETree_delNode(this, max_node);
  return split_node;
}

#line 281 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
IETreeNode
IETree_mergeNode(IETree this, IETreeNode node)
{
  IETreeNode left_node = IETreeNode_LEFT(node);
  IETreeNode right_node = IETreeNode_RIGHT(node);
  if (left_node == NULL) {
    IETree_delNode(this, node);
    return right_node;
  } else if (right_node == NULL) {
    IETree_delNode(this, node);
    return left_node;
  } else {
    IETreeNode split_node = IETree_splitMax(this, left_node);
    *IETreeNode__LOW(node) = IETree_LOW(this);
    *IETreeNode__HIGH(node) = IETree_HIGH(this);
    *IETreeNode__LEFT(node) = split_node;
    return node;
  }
}

#line 307 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
IETreeMember
IETree_choose(IETree this)
{
  IETreeMember low, high;
  IETreeNode prev_node = NULL;
  IETreeNode node = IETree_ROOT(this);
  Except_REQUIRE(node != NULL);
  while (IETreeNode_LEFT(node) != NULL) {
    prev_node = node;
    node = IETreeNode_LEFT(node);
  }
  low = IETreeNode_LOW(node);
  high = IETreeNode_HIGH(node);
  if (IETreeMember_EQ(low, high)) {
    if (prev_node == NULL) {
      *IETree__ROOT(this) = IETree_mergeNode(this, node);
    } else {
      *IETreeNode__LEFT(prev_node) = IETree_mergeNode(this, node);
    }
  } else {
    *IETreeNode__LOW(node) = IETreeMember_SUCC(low);
  }
  return low;
}

#line 339 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
bool
IETree_contains(const_IETree this, IETreeMember member)
{
  IETreeNode node = IETree_ROOT(this);
  while (node != NULL) {
    IETreeMember low = IETreeNode_LOW(node);
    IETreeMember high = IETreeNode_HIGH(node);
    if (IETreeMember_LT(member, low)) node = IETreeNode_LEFT(node);
    else if (IETreeMember_GT(member, high)) node = IETreeNode_RIGHT(node);
    return true;
  }
  return false;
}

#line 353 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
static void
IETree_joinLeft(IETree this, IETreeNode node)
{
  IETreeNode left_node = IETreeNode_LEFT(node);
  if (left_node != NULL) {
    IETreeNode max_node = left_node;
    while (IETreeNode_RIGHT(max_node) != NULL) {
      max_node = IETreeNode_RIGHT(max_node);
    }
    if (IETreeMember_EQ(IETreeNode_HIGH(max_node),
        IETreeMember_PRED(IETreeNode_LOW(node)))) {
      *IETreeNode__LOW(node) = IETreeNode_LOW(max_node);
      *IETreeNode__LEFT(node) = IETree_splitMax(this, left_node);
    }
  }
}

#line 370 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
static void
IETree_joinRight(IETree this, IETreeNode node)
{
  IETreeNode right_node = IETreeNode_RIGHT(node);
  if (right_node != NULL) {
    IETreeNode min_node = right_node;
    while (IETreeNode_LEFT(min_node) != NULL) {
      min_node = IETreeNode_LEFT(min_node);
    }
    if (IETreeMember_EQ(IETreeNode_LOW(min_node),
        IETreeMember_SUCC(IETreeNode_HIGH(node)))) {
      *IETreeNode__HIGH(node) = IETreeNode_HIGH(min_node);
      *IETreeNode__RIGHT(node) = IETree_splitMin(this, right_node);
    }
  }
}

#line 394 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
bool
IETree_insert(IETree this, IETreeMember member)
{
  IETreeNode node = IETree_ROOT(this);
  if (node == NULL) {
    *IETree__ROOT(this) = IETree_makeNode(this, member, member);
  } else do {
    IETreeMember low = IETreeNode_LOW(node);
    IETreeMember high = IETreeNode_HIGH(node);
    if (IETreeMember_LT(member, low)) {
      IETreeMember succ = IETreeMember_SUCC(member);
      if (IETreeMember_EQ(succ, low)) {
        *IETreeNode__LOW(node) = member;
        IETree_joinLeft(this, node);
        break;
      } else {
        if (IETreeNode_LEFT(node) == NULL) {
          *IETreeNode__LEFT(node) = IETree_makeNode(this, member, member);
          break;
        }
        node = IETreeNode_LEFT(node);
      }
    } else if (IETreeMember_GT(member, high)) {
      IETreeMember pred = IETreeMember_PRED(member);
      if (IETreeMember_EQ(pred, high)) {
        *IETreeNode__HIGH(node) = member;
        IETree_joinRight(this, node);
        break;
      } else {
        if (IETreeNode_RIGHT(node) == NULL) {
          *IETreeNode__RIGHT(node) = IETree_makeNode(this, member, member);
          break;
        }
        node = IETreeNode_RIGHT(node);
      }
    } else return false;
  } while (1);
  return true;
}

#line 441 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
bool
IETree_remove(IETree this, IETreeMember member)
{
  IETreeNode prev_node = NULL;
  IETreeNode node = IETree_ROOT(this);
  while (node != NULL) {
    IETreeMember low = IETreeNode_LOW(node);
    IETreeMember high = IETreeNode_HIGH(node);
    if (IETreeMember_LT(member, low)) {
      prev_node = node;
      node = IETreeNode_LEFT(node);
    } else if (IETreeMember_GT(member, high)) {
      prev_node = node;
      node = IETreeNode_RIGHT(node);
    } else if (IETreeMember_EQ(low, high)) {
      if (prev_node == NULL) {
        *IETree__ROOT(this) = IETree_mergeNode(this, node);
      } else if (node == IETreeNode_LEFT(prev_node)) {
        *IETreeNode__LEFT(prev_node) = IETree_mergeNode(this, node);
      } else if (node == IETreeNode_RIGHT(prev_node)) {
        *IETreeNode__RIGHT(prev_node) = IETree_mergeNode(this, node);
      } else Except_NEVER(true);
      break;
    } else if (IETreeMember_EQ(member, low)) {
      *IETreeNode__LOW(node) = IETreeMember_SUCC(low);
      break;
    } else if (IETreeMember_EQ(member, high)) {
      *IETreeNode__HIGH(node) = IETreeMember_PRED(high);
      break;
    } else {
      IETreeNode new_node = IETree_makeNode(this, IETreeMember_SUCC(member), high);
      *IETreeNode__RIGHT(new_node) = IETreeNode_RIGHT(node);
      *IETreeNode__HIGH(node) = IETreeMember_PRED(member);
      *IETreeNode__RIGHT(node) = new_node;
      break;
    }
  }
  return node != NULL;
}

#line 481 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
#if XCC__C
static void
IETreeNode_pretty(IETreeNode this, FILE *file)
{
  IETreeNode left = IETreeNode_LEFT(this);
  IETreeNode right = IETreeNode_RIGHT(this);
  IETreeMember low = IETreeNode_LOW(this);
  IETreeMember high = IETreeNode_HIGH(this);
  if (left != NULL) IETreeNode_pretty(left, file);
  fprintf(file, "[%lld,%lld] ", (long long)low, (long long)high);
  if (right != NULL) IETreeNode_pretty(right, file);
}

#line 494 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
static bool
IETree_pretty(IETree this, FILE *file)
{
  IETreeNode root = IETree_ROOT(this);
  if (file == NULL) file = stderr;
  if (root != NULL) IETreeNode_pretty(root, file);
  fprintf(file, "\n");
  return true;
}
#endif//XCC__C

#line 615 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 627 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
#if XCC__C
static void
IETree_TEST(void)
{
#include "CCL/IETree_.c"
}

#line 634 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
int
main(int argc, char **argv)
{
  CCL_Test(IETree_TEST);
  return 0;
}
#endif


#endif//IETree_c_INCLUDED
