#ifndef IQueue_c_INCLUDED
#define IQueue_c_INCLUDED

#line 19 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IQueue.xcc"
#include "CCL/CCL_.h"

#line 24 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IQueue.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 48 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IQueue.xcc"
IQueue
IQueue_Ctor(IQueue this, Memory memory, size_t itemSize, int32_t maxCount)
{
  *IQueue__MEMORY(this) = memory;
  *IQueue__ITEMSIZE(this) = itemSize;
  Except_REQUIRE(itemSize > 0);
  *IQueue__MAXCOUNT(this) = 0;
  *IQueue__BASE(this) = NULL;
  *IQueue__PAST(this) = NULL;
  *IQueue__FIRSTITEM(this) = NULL;
  if (maxCount > 0) IQueue_resize(this, maxCount);
  return this;
}

#line 62 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IQueue.xcc"
void
IQueue_Dtor(IQueue this)
{
  Memory memory = IQueue_MEMORY(this);
  IQueue_empty(this, NULL);
  Memory_free(memory, IQueue_BASE(this));
}

#line 83 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IQueue.xcc"
void
IQueue_resize(IQueue this, int32_t maxCount)
{
  Memory memory = IQueue_MEMORY(this);
  size_t itemSize = IQueue_ITEMSIZE(this);
  int32_t old_maxCount = IQueue_MAXCOUNT(this);
  if (maxCount > old_maxCount) {
    size_t maxSize = (maxCount + 1)*itemSize;
    size_t alignedSize = CDT_ALIGN_NEXT(maxSize);
    char *new_base = Memory_alloc_(memory, alignedSize);
    char *old_base = (char *)IQueue_BASE(this);
    size_t old_usedSize = IQueue_usedSize(this);
    if (old_usedSize != 0) {
      Except_NEVER(true);	// FIXME!
      Memory_free_(memory, old_base);
    } else {
      Memory_free(memory, old_base);
    }
    *IQueue__FIRSTITEM(this) = new_base;
    *IQueue__PAST(this) = new_base;
    while ((alignedSize -= itemSize) >= maxSize) ++maxCount;
    *IQueue__BASE(this) = new_base;
    *IQueue__MAXCOUNT(this) = maxCount;
  }
  Except_ENSURE((char *)IQueue_PAST(this) >= (char *)IQueue_BASE(this));
  Except_ENSURE((char *)IQueue_PAST(this) < (char *)IQueue_WRAPITEM(this));
  Except_ENSURE((char *)IQueue_FIRSTITEM(this) >= (char *)IQueue_BASE(this));
  Except_ENSURE((char *)IQueue_FIRSTITEM(this) < (char *)IQueue_WRAPITEM(this));
}

#line 119 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IQueue.xcc"
void
IQueue_empty(IQueue this, IQueueItemRelease release)
{
  Memory memory = IQueue_MEMORY(this);
  IQueueItem_ *base = IQueue_BASE(this);
  if (base != NULL && release != NULL) {
    size_t itemSize = IQueue_ITEMSIZE(this);
    char *wrapItem = IQueue_WRAPITEM(this);
    char *firstItem = IQueue_FIRSTITEM(this);
    char *past = IQueue_PAST(this);
    if (firstItem < past) {
      char *item = firstItem;
      for (; item < past; item += itemSize) {
        (*release)(item);
      }
    } else if (firstItem > past) {
      char *item = firstItem;
      for (; item < wrapItem; item += itemSize) {
        (*release)(item);
      }
      item = base;
      for (; item < past; item += itemSize) {
        (*release)(item);
      }
    }
  }
  *IQueue__PAST(this) = base;
  *IQueue__FIRSTITEM(this) = base;
  Except_CHECK(IQueue_isEmpty(this));
}

#line 150 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IQueue.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 482 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IQueue.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 484 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IQueue.xcc"
#if XCC__C
typedef struct Pair_ { int a, b; int dummy; } Pair_, *Pair;
static void Pair_Dtor(Pair this)
{
  printf("Pair_Dtor(%d,%d)\n", this->a, this->b);
}
#endif//XCC__C

#line 542 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IQueue.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 554 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IQueue.xcc"
#if XCC__C
static void
IQueue_TEST(void)
{
#include "CCL/IQueue_.c"
}

#line 561 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IQueue.xcc"
int
main(int argc, char **argv)
{
  CCL_Test(IQueue_TEST);
  return 0;
}
#endif


#endif//IQueue_c_INCLUDED
