#ifndef IStack_c_INCLUDED
#define IStack_c_INCLUDED

#line 19 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IStack.xcc"
#include "CCL/CCL_.h"

#line 24 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IStack.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 48 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IStack.xcc"
IStack
IStack_Ctor(IStack this, Memory memory, size_t itemSize, int32_t maxCount)
{
  *IStack__MEMORY(this) = memory;
  *IStack__ITEMSIZE(this) = itemSize;
  Except_REQUIRE(itemSize > 0);
  *IStack__MAXCOUNT(this) = 0;
  *IStack__BASE(this) = NULL;
  *IStack__PAST(this) = NULL;
  *IStack__POINTER(this) = NULL;
  if (maxCount > 0) IStack_resize(this, maxCount);
  return this;
}

#line 62 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IStack.xcc"
void
IStack_Dtor(IStack this)
{
  Memory memory = IStack_MEMORY(this);
  IStack_empty(this, NULL);
  Memory_free(memory, IStack_BASE(this));
}

#line 84 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IStack.xcc"
void
IStack_resize(IStack this, int32_t maxCount)
{
  Memory memory = IStack_MEMORY(this);
  size_t itemSize = IStack_ITEMSIZE(this);
  int32_t old_maxCount = IStack_MAXCOUNT(this);
  if (maxCount > old_maxCount) {
    size_t size = maxCount*itemSize;
    size_t alignedSize = CDT_ALIGN_NEXT(maxCount*itemSize);
    char *new_base = Memory_alloc_(memory, alignedSize);
    size_t old_usedSize = IStack_USEDSIZE(this);
    if (old_usedSize > 0) {
      char *old_base = IStack_BASE(this);
      memcpy(new_base, old_base, old_usedSize);
      Memory_free_(memory, old_base);
    }
    *IStack__PAST(this) = new_base + old_usedSize;
    *IStack__BASE(this) = new_base;
    while ((alignedSize -= itemSize) >= size) ++maxCount;
    *IStack__MAXCOUNT(this) = maxCount;
  }
  Except_ENSURE((char *)IStack_PAST(this) >= (char *)IStack_BASE(this));
  Except_ENSURE(IStack_USEDSIZE(this) <= IStack_MAXSIZE(this));
}

#line 115 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IStack.xcc"
void
IStack_empty(IStack this, IStackItemRelease release)
{
  IStackItem_ *base = IStack_BASE(this);
  if (base != NULL && release != NULL) {
    size_t itemSize = IStack_ITEMSIZE(this);
    char *past = IStack_PAST(this);
    char *item = base;
    for (; item < past; item += itemSize) {
      (*release)(item);
    }
  }
  *IStack__PAST(this) = base;
  Except_CHECK(IStack_isEmpty(this));
}

#line 131 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IStack.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 196 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IStack.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 312 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IStack.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 357 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IStack.xcc"
#ifndef IStack_MAGICCOUNT
#define IStack_MAGICCOUNT 16
#endif//IStack_MAGICCOUNT

#line 361 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IStack.xcc"
IStackItem
IStack_push2(IStack this)
{
  size_t itemSize = IStack_ITEMSIZE(this);
  char *past = IStack_PAST(this);
  if (IStack_isFull(this)) {
    int32_t newCount = IStack_count(this)*2;
    if (newCount < IStack_MAGICCOUNT) {
      newCount = IStack_MAGICCOUNT;
    }
    IStack_resize(this, newCount);
    past = IStack_PAST(this);
    Except_CHECK(!IStack_isFull(this));
  }
  *IStack__PAST(this) = past + itemSize;
  return past;
}

#line 455 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IStack.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 467 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IStack.xcc"
#if XCC__C
static void
IStack_TEST(void)
{
#include "CCL/IStack_.c"
}

#line 474 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IStack.xcc"
int
main(int argc, char **argv)
{
  CCL_Test(IStack_TEST);
  return 0;
}
#endif


#endif//IStack_c_INCLUDED
