#ifndef PQueue_c_INCLUDED
#define PQueue_c_INCLUDED

#line 15 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
#include "CCL/CCL_.h"

#line 20 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 57 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
PQueue
PQueue_Ctor(PQueue this, Memory memory, int32_t maxCount)
{
  *PQueue__MEMORY(this) = memory;
  *PQueue__STATUS(this) = (maxCount<<1)|0x1;
  *PQueue__COUNT(this) = 0;
  *PQueue__ENTRIES(this) = Memory_alloc(memory, maxCount*sizeof(PQueueEntry_));
  return this;
}

#line 67 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
void
PQueue_Dtor(PQueue this)
{
  Memory memory = PQueue_MEMORY(this);
  Memory_free_(memory, PQueue_ENTRIES(this));
}

#line 83 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
bool
PQueue_check(const_PQueue this)
{
  PQueueEntry entries = PQueue_ENTRIES(this);
  int32_t count = PQueue_COUNT(this), x;
  for (x = 0; x < count; x++) {
    int32_t child_1 = (4*x + 1);
    int32_t child_2 = (4*x + 2);
    int32_t child_3 = (4*x + 3);
    int32_t child_4 = (4*x + 4);
    if (child_1 < count) {
      Except_ALWAYS(PQueueEntry_PRIORITY(entries + x) <= PQueueEntry_PRIORITY(entries + child_1));
    }
    if (child_2 < count) {
      Except_ALWAYS(PQueueEntry_PRIORITY(entries + x) <= PQueueEntry_PRIORITY(entries + child_2));
    }
    if (child_3 < count) {
      Except_ALWAYS(PQueueEntry_PRIORITY(entries + x) <= PQueueEntry_PRIORITY(entries + child_3));
    }
    if (child_4 < count) {
      Except_ALWAYS(PQueueEntry_PRIORITY(entries + x) <= PQueueEntry_PRIORITY(entries + child_4));
    }
  }
  return true;
}

#line 115 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
void
PQueue_empty(PQueue this)
{
  *PQueue__STATUS(this) |= 0x1;
  *PQueue__COUNT(this) = 0;
}

#line 167 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
void
PQueue_addEntry(PQueue this, PQueueMember member, PQueuePriority priority)
{
  int32_t count = PQueue_COUNT(this);
  PQueueEntry entry = PQueue_ENTRIES(this) + count;
  Except_REQUIRE(count < PQueue_MAXCOUNT(this));
  *PQueueEntry__PRIORITY(entry) = priority;
  *PQueueEntry__MEMBER(entry) = member;
  *PQueue__COUNT(this) = count + 1;
  if (count) PQueue_clearOrdered(this);
}

#line 179 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
// PQueue_minChild --	The index of the minimal priority child of entry at index x.
static int32_t
PQueue_minChild(PQueue this, int32_t x)
{
  PQueuePriority min_priority = PQueuePriority_MAX;
  int32_t min_index = -1, max_index = PQueue_COUNT(this) - 1;
  int32_t first_child = 4*x + 1, last_child = 4*x + 4, index;
  PQueueEntry_ *entries = PQueue_ENTRIES(this);
  Except_CHECK(x >= 0 && x < PQueue_COUNT(this));
  if (last_child > max_index) last_child = max_index;
  for (index = first_child; index <= last_child; index++) {
    PQueuePriority priority = PQueueEntry_PRIORITY(entries + index);
    // Use >= instead of > for case priority == PQueuePriority_MAX.
    if (min_priority >= priority) {
      min_priority = priority;
      min_index = index;
    }
  }
  return min_index;
}

#line 200 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
static void
PQueue_siftUp(PQueue this, int32_t x, PQueueEntry entry)
{
  int32_t p = (x - 1)>>2;
  PQueueEntry_ *entries = PQueue_ENTRIES(this);
  Except_CHECK(x >= 0 && x < PQueue_COUNT(this));
  while (   p >= 0
         && PQueueEntry_PRIORITY(entries + p) > PQueueEntry_PRIORITY(entry)) {
    entries[x] = entries[p];
    x = p;
    p = (x - 1)>>2;
  }
  entries[x] = *entry;
}

#line 215 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
static void
PQueue_siftDown(PQueue this, int32_t x, PQueueEntry entry)
{
  int32_t c = PQueue_minChild(this, x);
  PQueueEntry_ *entries = PQueue_ENTRIES(this);
  Except_CHECK(x >= 0 && x < PQueue_COUNT(this));
  while (   c >= 0
         && PQueueEntry_PRIORITY(entries + c) < PQueueEntry_PRIORITY(entry)) {
    entries[x] = entries[c];
    x = c;
    c = PQueue_minChild(this, c);
  }
  entries[x] = *entry;
}

#line 236 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
int32_t
PQueue_makeHeap(PQueue this)
{
  int32_t count = PQueue_COUNT(this), i;
  PQueueEntry_ *entries = PQueue_ENTRIES(this);
  *PQueue__COUNT(this) = count;
  for (i = count - 1; i >= 0; i--) {
    PQueueEntry_ entry_ = entries[i];
    PQueue_siftDown(this, i, &entry_);
  }
  Except_DEBUG(PQueue_check(this));
  *PQueue__STATUS(this) |= 0x1;
  return count;
}

#line 257 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
void
PQueue_insert(PQueue this, PQueueMember member, PQueuePriority priority)
{
  int32_t count = PQueue_COUNT(this);
  struct PQueueEntry_ entry[1];
  *PQueueEntry__MEMBER(entry) = member;
  *PQueueEntry__PRIORITY(entry) = priority;
  Except_REQUIRE(PQueue_isOrdered(this));
  Except_REQUIRE(count >= 0 && count < PQueue_MAXCOUNT(this));
  *PQueue__COUNT(this) = count + 1;
  PQueue_siftUp(this, count, entry);
  Except_DEBUG(PQueue_check(this));
}

#line 277 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
void
PQueue_remove(PQueue this, int32_t index)
{
  int32_t count = PQueue_COUNT(this);
  PQueueEntry_ *entries = PQueue_ENTRIES(this);
  PQueueEntry last = entries + count - 1;
  Except_REQUIRE(PQueue_isOrdered(this));
  Except_REQUIRE(count > 0);
  *PQueue__COUNT(this) = count - 1;
  if (index < count - 1) {
    if (PQueueEntry_PRIORITY(last) <= PQueueEntry_PRIORITY(entries + index)) {
      PQueue_siftUp(this, index, last);
    } else {
      PQueue_siftDown(this, index, last);
    }
  }
  Except_DEBUG(PQueue_check(this));
}

#line 302 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
void
PQueue_update(PQueue this, const_PQueueEntry entry, PQueuePriority priority)
{
  PQueueEntry_ entry_ = *entry;
  int32_t index = entry - PQueue_ENTRIES(this);
  *PQueueEntry__PRIORITY(&entry_) = priority;
  Except_REQUIRE(index >= 0 && index < PQueue_COUNT(this));
  Except_REQUIRE(PQueue_isOrdered(this));
  if (priority <= PQueueEntry_PRIORITY(entry)) {
    PQueue_siftUp(this, index, &entry_);
  } else {
    PQueue_siftDown(this, index, &entry_);
  }
  Except_DEBUG(PQueue_check(this));
}

#line 324 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
#if 1
PQueueMember
PQueue_extractMin(PQueue this)
{
  int32_t count = PQueue_COUNT(this);
  PQueueEntry_ *entries = PQueue_ENTRIES(this);
  PQueueEntry last = entries + count - 1;
  PQueueMember member = entries[0].MEMBER;
  Except_REQUIRE(PQueue_isOrdered(this));
  *PQueue__COUNT(this) = count - 1;
  if (count > 1) {
    PQueue_siftDown(this, 0, last);
  }
  Except_DEBUG(PQueue_check(this));
  return member;
}
#else
PQueueMember
PQueue_extractMin(PQueue this)
{
  int32_t count = PQueue_COUNT(this);
  PQueueEntry_ *entries = PQueue_ENTRIES(this);
  PQueueMember member = entries[0].MEMBER;
  Except_REQUIRE(PQueue_isOrdered(this));
  PQueue_remove(this, 0);
  Except_DEBUG(PQueue_check(this));
  return member;
}
#endif

#line 397 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
#if !defined(CDT_NTRACE) || defined(XCC__C)
bool
PQueue_pretty(PQueue this, FILE *file)
{
  if (file == NULL) file = stderr;
  PQueue_FOREACH(this, void*, member) {
    int priority = PQueueEntry_PRIORITY(PQueue_ENTRY);
    fprintf (file, "%d ", priority);
  } PQueue_ENDEACH;
  return true;
}
#endif//CDT_NTRACE

#line 496 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 508 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
#if XCC__C
static void
PQueue_TEST(void)
{
#include "CCL/PQueue_.c"
}

#line 515 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
int
main(int argc, char **argv)
{
  CCL_Test(PQueue_TEST);
  return 0;
}
#endif


#endif//PQueue_c_INCLUDED
