#ifndef PtrMap_h_INCLUDED
#define PtrMap_h_INCLUDED

/*
 * !!!!	PtrMap.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com)
 *
 * Copyright 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 *
 * The PtrMap implements a map of pointers using balanced binary tree.
 */

/*
 * PtrMap --	Sequence of pointers implemented as stack.
 *
 * If =maxCount= is zero, no memory is allocated at construction time.
 */
struct PtrMap_ {
  //@args	Memory memory
  Memory MEMORY;
};
typedef struct PtrMap_ PtrMap_, *PtrMap;
typedef const struct PtrMap_ *const_PtrMap;
typedef struct PtrMap_ * restrict_PtrMap;

extern PtrMap
PtrMap_Ctor(PtrMap this, Memory memory);

extern PtrMap
PtrMap_Copy(PtrMap this, const_PtrMap that);

extern void
PtrMap_Dtor(PtrMap this);

extern size_t
PtrMap_Size(Memory memory);

#define PtrMap_MEMORY(this) ((this)->MEMORY)
#define PtrMap__MEMORY(this) (&(this)->MEMORY)



#endif//PtrMap_h_INCLUDED
