#ifndef PtrSet_c_INCLUDED
#define PtrSet_c_INCLUDED

#line 16 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
#include "CCL/CCL_.h"

#line 21 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 60 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
PtrSet
PtrSet_Ctor(PtrSet this, Memory memory, int32_t maxCount)
{
  *PtrSet__MEMORY(this) = memory;
  *PtrSet__STATUS(this) = 0x1;
  *PtrSet__BASE(this) = NULL;
  *PtrSet__PAST(this) = NULL;
  if (maxCount > 0) PtrSet_resize(this, maxCount);
  return this;
}

#line 71 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
void
PtrSet_Dtor(PtrSet this)
{
  Memory memory = PtrSet_MEMORY(this);
  PtrSet_empty(this);
  Memory_free(memory, PtrSet_BASE(this));
}

#line 92 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
void
PtrSet_resize(PtrSet this, int32_t maxCount)
{
  Memory memory = PtrSet_MEMORY(this);
  size_t memberSize = sizeof(PtrSetMember);
  bool old_isOrdered = PtrSet_ISORDERED(this);
  int32_t old_maxCount = PtrSet_MAXCOUNT(this);
  if (maxCount > old_maxCount) {
    size_t maxSize = maxCount*memberSize;
    size_t alignedSize = CDT_ALIGN_NEXT(maxSize);
    char *new_base = Memory_alloc_(memory, alignedSize);
    size_t old_usedSize = PtrSet_USEDSIZE(this);
    if (old_usedSize != 0) {
      char *old_base = (char *)PtrSet_BASE(this);
      memcpy(new_base, old_base, old_usedSize);
      Memory_free_(memory, old_base);
    }
    *PtrSet__PAST(this) = (PtrSetMember *)(new_base + old_usedSize);
    *PtrSet__BASE(this) = (PtrSetMember *)(new_base);
    while ((alignedSize -= memberSize) >= maxSize) ++maxCount;
    *PtrSet__STATUS(this) = ((maxCount<<1)|old_isOrdered);
  }
  Except_ENSURE(PtrSet_PAST(this) >= PtrSet_BASE(this));
  Except_ENSURE(PtrSet_USEDSIZE(this) <= PtrSet_MAXSIZE(this));
}

#line 124 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
void
PtrSet_empty(PtrSet this)
{
  *PtrSet__PAST(this) = PtrSet_BASE(this);
  Except_CHECK(PtrSet_isEmpty(this));
}

#line 137 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
bool
PtrSet_checkOrder(const_PtrSet this)
{
  int32_t count = PtrSet_count(this), i = 0;
  PtrSetMember *base = PtrSet_BASE(this);
  if (base != NULL) {
    for (i = 1; i < count; i++) {
      if (!PtrSetMember_GT(base[i - 1], base[i])) return false;
    }
  }
  return PtrSet_ISORDERED(this);
}

#line 202 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 223 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
#ifndef PtrSet_MAGICCOUNT
#define PtrSet_MAGICCOUNT 16
#endif//PtrSet_MAGICCOUNT

#line 227 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
void
PtrSet_addMember(PtrSet this, PtrSetMember member)
{
  int32_t maxCount = PtrSet_MAXCOUNT(this);
  PtrSetMember *base = PtrSet_BASE(this);
  PtrSetMember *past = PtrSet_PAST(this);
  int32_t count = past - base;
  if (count == maxCount) {
    int32_t newMaxCount = PtrSet_MAGICCOUNT > count*2?
                          PtrSet_MAGICCOUNT: count*2;
    if (count != 0) {
      if (PtrSet_makeOrder(this) < maxCount);
      else PtrSet_resize(this, newMaxCount);
    } else PtrSet_resize(this, newMaxCount);
    past = PtrSet_PAST(this);
    maxCount = PtrSet_MAXCOUNT(this);
  }
  Except_CHECK(!PtrSet_isFull(this));
  *past = member;
  *PtrSet__PAST(this) = past + 1;
  *PtrSet__STATUS(this) = ((maxCount<<1)|!count);
}

#line 258 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
#if 0
int32_t
PtrSet_sort(PtrSet this)
{
  PtrSetMember *members = PtrSet_BASE(this);
  PtrSetMember *past = PtrSet_PAST(this);
  int32_t count = past - members;
  int32_t n = count, i = count/2;
  while (true) {
    int32_t parent, child;
    PtrSetMember temp_member;
    if (i > 0) {
      temp_member = members[--i];
    } else if (n > 1) {
      temp_member = members[--n];
      members[n] = members[0];
    } else break;
    parent = i, child = i*2 + 1;
    while (child < n) {
      if (   child + 1 < n
          && PtrSetMember_LT(members[child + 1], members[child])) {
        child = child + 1;
      }
      if (PtrSetMember_LT(members[child], temp_member)) {
        members[parent] = members[child];
        parent = child;
        child = child*2 + 1;
      } else break;
    }
    members[parent] = temp_member;
  }
  *PtrSet__STATUS(this) |= 0x1;
  return PtrSet_uniq(this);
}
#else
int32_t
PtrSet_makeOrder(PtrSet this)
{
  PtrSetMember *base = PtrSet_BASE(this);
  PtrSetMember *past = PtrSet_PAST(this);
  PtrSetMember *members = past - 1;
  int32_t count = past - base;
  int32_t n = -count, i = -(count/2), d = 0;
  while (i++ < 0) {
    int32_t parent = i, child = i*2 - 1;
    PtrSetMember temp_member = members[i];
    while (child > n) {
      if (   child - 1 > n
          && PtrSetMember_GT(members[child - 1], members[child])) {
        child = child - 1;
      }
      if (PtrSetMember_GT(members[child], temp_member)) {
        members[parent] = members[child];
        parent = child;
        child = child*2 - 1;
      } else break;
    }
    members[parent] = temp_member;
  }
  while (n++ < -1) {
    int32_t parent = 0, child = -1;
    PtrSetMember temp_member = members[n];
    members[n] = members[0];
    while (child > n) {
      if (   child - 1 > n
          && PtrSetMember_GT(members[child - 1], members[child])) {
        child = child - 1;
      }
      if (PtrSetMember_GT(members[child], temp_member)) {
        members[parent] = members[child];
        parent = child;
        child = child*2 - 1;
      } else break;
    }
    members[parent] = temp_member;
  }
  // This PtrSet is ordered now.
  *PtrSet__STATUS(this) |= 0x1;
  return PtrSet_uniq(this);
}
#endif

#line 344 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
int32_t
PtrSet_uniq(PtrSet this)
{
  PtrSetMember *base = PtrSet_BASE(this);
  PtrSetMember *past = PtrSet_PAST(this);
  int32_t count = past - base, d = 0, i;
  if (base != NULL) {
    for (i = 0; i + d + 1 < count;) {
      base[i] = base[i + d];
      if (PtrSetMember_EQ(base[i + d], base[i + d + 1])) d++;
      else i++;
    }
    base[i] = base[i + d];
    *PtrSet__PAST(this) = base + count - d;
  }
  Except_DEBUG(PtrSet_checkOrder(this));
  Except_CHECK(PtrSet_count(this) == count - d);
  return count - d;
}

#line 391 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 473 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
bool
PtrSet_contains(const_PtrSet this, PtrSetMember member)
{
  int32_t count = PtrSet_count(this);
  int32_t l = 0, r = count - 1, i = 0;
  PtrSetMember *base = PtrSet_BASE(this);
  Except_REQUIRE(PtrSet_isOrdered(this));
  while (r >= l) {
    i = (l + r) >> 1;
    if (PtrSetMember_LT(base[i], member)) r = i - 1;
    else if (PtrSetMember_GT(base[i],  member)) l = i + 1;
    else return true;
  }
  return false;
}

#line 497 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
bool
PtrSet_insert(PtrSet this, PtrSetMember member)
{
#if 0
  int32_t count = PtrSet_count(this);
  PtrSet_addMember(this, member);
  PtrSet_makeOrder(this);
  return count == PtrSet_count(this);
#else
  if (PtrSet_isEmpty(this)) {
    PtrSet_addMember(this, member);
  } else {
    PtrSetMember *base = PtrSet_BASE(this);
    PtrSetMember *past = PtrSet_PAST(this);
    int32_t count = past - base;
    int32_t l = 0, r = count - 1, i = 0, j;
    Except_REQUIRE(PtrSet_isOrdered(this));
    while (r >= l) {
      i = (l + r) >> 1;
      if (PtrSetMember_LT(base[i], member)) r = i - 1;
      else if (PtrSetMember_GT(base[i], member)) l = i + 1;
      else return false;
    }
    if (PtrSetMember_GT(base[i], member)) i++;
    if (count == PtrSet_MAXCOUNT(this)) {
      int32_t newMaxCount = PtrSet_MAGICCOUNT > count*2?
                            PtrSet_MAGICCOUNT: count*2;
      PtrSet_resize(this, newMaxCount);
      // Reload base because of the PtrSet_resize side-effects.
      base = PtrSet_BASE(this);
    }
    *PtrSet__PAST(this) = base + count + 1;
    for (j = count; j > i; j--) base[j] = base[j - 1];
    base[i] = member;
    Except_DEBUG(PtrSet_checkOrder(this));
  }
  return true;
#endif
}

#line 545 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
bool
PtrSet_remove(PtrSet this, PtrSetMember member)
{
  PtrSetMember *base = PtrSet_BASE(this);
  PtrSetMember *past = PtrSet_PAST(this);
  int32_t count = past - base;
  int32_t l = 0, r = count - 1, i = 0;
  Except_REQUIRE(PtrSet_isOrdered(this));
  while (r >= l) {
    i = (l + r) >> 1;
    if (PtrSetMember_LT(base[i], member)) r = i - 1;
    else if (PtrSetMember_GT(base[i], member)) l = i + 1;
    else {
      for (; i < count - 1; i++) base[i] = base[i + 1];
      *PtrSet__PAST(this) = past - 1;
      Except_DEBUG(PtrSet_checkOrder(this));
      return true;
    }
  }
  Except_DEBUG(PtrSet_checkOrder(this));
  return false;
}

#line 587 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
bool
PtrSet_equals(const_PtrSet this, const_PtrSet that)
{
  int32_t this_count = PtrSet_count(this), i = 0;
  int32_t that_count = PtrSet_count(that), j = 0;
  PtrSetMember *this_base = PtrSet_BASE(this);
  PtrSetMember *that_base = PtrSet_BASE(that);
  Except_REQUIRE(PtrSet_isOrdered(this));
  Except_REQUIRE(PtrSet_isOrdered(that));
  if (this_count != that_count) return false;
  while (i < this_count && j < that_count) {
    PtrSetMember this_member = this_base[i];
    PtrSetMember that_member = that_base[j];
    if (PtrSetMember_NE(this_member, that_member)) return false;
    i++, j++;
  }
  return true;
}

#line 612 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
void
PtrSet_assign(PtrSet this, const_PtrSet that)
{
  Memory memory = PtrSet_MEMORY(this);
  int32_t maxCount = PtrSet_MAXCOUNT(this);
  PtrSetMember *this_base = PtrSet_BASE(this);
  PtrSetMember *that_base = PtrSet_BASE(that);
  int32_t that_count = PtrSet_count(that), i = 0;
  bool that_isOrdered = PtrSet_ISORDERED(that);
  if (maxCount < that_count) {
    size_t that_size = that_count*sizeof(PtrSetMember);
    size_t alignedSize = CDT_ALIGN_NEXT(that_size);
    Memory_free(memory, this_base);
    this_base = Memory_alloc_(memory, alignedSize);
    *PtrSet__STATUS(this) = ((that_count<<1)|that_isOrdered);
    *PtrSet__BASE(this) = this_base;
  }
  for (i = 0; i < that_count; i++) {
    this_base[i] = that_base[i];
  }
  *PtrSet__PAST(this) = this_base + that_count;
}

#line 664 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
bool
PtrSet_comprises(const_PtrSet this, const_PtrSet that)
{
  int32_t this_count = PtrSet_count(this);
  int32_t that_count = PtrSet_count(that);
  Except_REQUIRE(PtrSet_isOrdered(this));
  Except_REQUIRE(PtrSet_isOrdered(that));
  if (this_count >= that_count) {
    int32_t i = 0, j = 0, k = 0;
    const PtrSetMember *this_base = PtrSet_BASE(this);
    const PtrSetMember *that_base = PtrSet_BASE(that);
    while (i < this_count && j < that_count) {
      PtrSetMember this_member = this_base[i];
      PtrSetMember that_member = that_base[j];
      if (PtrSetMember_GT(this_member, that_member)) i++, k++;
      else if (PtrSetMember_LT(this_member, that_member)) j++, k++;
      else i++, j++, k++;
    }
    if (this_count - i > 0) k += this_count - i;
    if (that_count - j > 0) k += that_count - j;
    return k == this_count;
  }
  return false;
}

#line 695 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
bool
PtrSet_union(PtrSet this, const_PtrSet that)
{
  Memory memory = PtrSet_MEMORY(this);
  int32_t this_count = PtrSet_count(this), i = 0;
  int32_t that_count = PtrSet_count(that), j = 0;
  int32_t temp_count = this_count + that_count, k = 0;
  size_t tempSize = temp_count*sizeof(PtrSetMember);
  size_t alignedSize = CDT_ALIGN_NEXT(tempSize);
  PtrSetMember *this_base = PtrSet_BASE(this);
  PtrSetMember *that_base = PtrSet_BASE(that);
#define PtrSet_TEMPARRAYCOUNT 64
  PtrSetMember tempArray[PtrSet_TEMPARRAYCOUNT];
  PtrSetMember *temp_base = temp_count > PtrSet_TEMPARRAYCOUNT?
                                  Memory_alloc_(memory, alignedSize):
                                  tempArray;
  Except_REQUIRE(PtrSet_isOrdered(this));
  Except_REQUIRE(PtrSet_isOrdered(that));
  while (i < this_count && j < that_count) {
    PtrSetMember this_member = this_base[i];
    PtrSetMember that_member = that_base[j];
    if (PtrSetMember_GT(this_member, that_member)) {
      temp_base[k++] = this_member, i++;
    } else if (PtrSetMember_LT(this_member, that_member)) {
      temp_base[k++] = that_member, j++;
    } else temp_base[k++] = this_member, i++, j++;
  }
  while (i < this_count) temp_base[k++] = this_base[i++];
  while (j < that_count) temp_base[k++] = that_base[j++];
  if (k == this_count) {
    // This set is unchanged.
    if (temp_count > PtrSet_TEMPARRAYCOUNT) Memory_free_(memory, temp_base);
    return false;
  }
  if (k > PtrSet_MAXCOUNT(this)) {
    // Must reallocate this_base.
    Memory_free(memory, this_base);
    if (temp_count > PtrSet_TEMPARRAYCOUNT) {
      // Recycle the temp_base into this_base.
      this_base = temp_base;
    } else {
      // Allocate this_base and copy temp_base into it.
      this_base = Memory_alloc_(memory, alignedSize);
      for (i = 0; i < k; i++) this_base[i] = temp_base[i];
    }
    *PtrSet__STATUS(this) = ((temp_count<<1)|true);
    *PtrSet__BASE(this) = this_base;
    *PtrSet__PAST(this) = this_base + k;
  } else {
    // Here k <= maxCount, so just copy temp_base into this_base.
    for (i = 0; i < k; i++) this_base[i] = temp_base[i];
    if (temp_count > PtrSet_TEMPARRAYCOUNT) Memory_free_(memory, temp_base);
    *PtrSet__PAST(this) = this_base + k;
  }
  Except_DEBUG(PtrSet_checkOrder(this));
  return true;
}

#line 805 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
bool
PtrSet_inter(PtrSet this, const_PtrSet that)
{
  int32_t this_count = PtrSet_count(this), i = 0;
  int32_t that_count = PtrSet_count(that), j = 0, k = 0;
  PtrSetMember *this_base = PtrSet_BASE(this);
  PtrSetMember *that_base = PtrSet_BASE(that);
  PtrSetMember *temp_base = this_base;
  Except_REQUIRE(PtrSet_isOrdered(this));
  Except_REQUIRE(PtrSet_isOrdered(that));
  while (i < this_count && j < that_count) {
    PtrSetMember this_member = this_base[i];
    PtrSetMember that_member = that_base[j];
    if (PtrSetMember_GT(this_member, that_member)) i++;
    else if (PtrSetMember_LT(this_member, that_member)) j++;
    else temp_base[k++] = this_member, i++, j++;
  }
  if (k == this_count) {
    return false;
  } else if (k != 0) {
    *PtrSet__PAST(this) = this_base + k;
  } else {
    PtrSet_empty(this);
  }
  Except_DEBUG(PtrSet_checkOrder(this));
  return true;
}

#line 885 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
bool
PtrSet_overlap(const_PtrSet this, const_PtrSet that)
{
  int32_t this_count = PtrSet_count(this), i = 0;
  int32_t that_count = PtrSet_count(that), j = 0;
  PtrSetMember *this_base = PtrSet_BASE(this);
  PtrSetMember *that_base = PtrSet_BASE(that);
  Except_REQUIRE(PtrSet_isOrdered(this));
  Except_REQUIRE(PtrSet_isOrdered(that));
  while (i < this_count && j < that_count) {
    PtrSetMember this_member = this_base[i];
    PtrSetMember that_member = that_base[j];
    if (PtrSetMember_GT(this_member, that_member)) i++;
    else if (PtrSetMember_LT(this_member, that_member)) j++;
    else return true;
  }
  return false;
}

#line 935 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
bool
PtrSet_diff(PtrSet this, const_PtrSet that)
{
  int32_t this_count = PtrSet_count(this), i = 0;
  int32_t that_count = PtrSet_count(that), j = 0, k = 0;
  PtrSetMember *this_base = PtrSet_BASE(this);
  PtrSetMember *that_base = PtrSet_BASE(that);
  PtrSetMember *temp_base = this_base;
  Except_REQUIRE(PtrSet_isOrdered(this));
  Except_REQUIRE(PtrSet_isOrdered(that));
  while (i < this_count && j < that_count) {
    if (PtrSetMember_GT(this_base[i], that_base[j]))
      temp_base[k++] = this_base[i++];
    else if (PtrSetMember_LT(this_base[i], that_base[j])) j++;
    else i++, j++;
  }
  while (i < this_count) temp_base[k++] = this_base[i++];
  if (k == this_count) {
    return false;
  } else if (k != 0) {
    *PtrSet__PAST(this) = this_base + k;
  } else {
    PtrSet_empty(this);
  }
  Except_DEBUG(PtrSet_checkOrder(this));
  return true;
}

#line 1038 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1050 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
#if XCC__C
static void
PtrSet_TEST(void)
{
#include "CCL/PtrSet_.c"
}

#line 1057 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
int
main(int argc, char **argv)
{
  CCL_Test(PtrSet_TEST);
  return 0;
}
#endif


#endif//PtrSet_c_INCLUDED
