#ifndef Sparse_c_INCLUDED
#define Sparse_c_INCLUDED

#line 16 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
#include "CCL/CCL_.h"

#line 21 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 49 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
Sparse
Sparse_Ctor(Sparse this, Memory memory, int32_t universe)
{
  size_t allocSize = universe*sizeof(SparseEntry_);
  void *entries = Memory_alloc(memory, allocSize);
  *Sparse__MEMORY(this) = memory;
  *Sparse__UNIVERSE(this) = universe;
  *Sparse__COUNT(this) = 0;
  *Sparse__ENTRIES(this) = entries;
  Except_CHECK(!entries || memset(entries, -1, allocSize));
  return this;
}

#line 62 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
void
Sparse_Dtor(Sparse this)
{
  Memory memory = Sparse_MEMORY(this);
  Memory_free(memory, Sparse_ENTRIES(this));
}

#line 80 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
void
Sparse_empty(Sparse this)
{
  *Sparse__COUNT(this) = 0;
  Except_CHECK(Sparse_isEmpty(this));
}

#line 87 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 122 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
bool
Sparse_contains(const_Sparse this, SparseMember member)
{
  int32_t count = Sparse_COUNT(this);
  SparseEntry entries = Sparse_ENTRIES(this);
  uint32_t position = SparseEntry_POSITION(entries + member);
  Except_CHECK(member < Sparse_UNIVERSE(this));
  return position < count
      && SparseEntry_MEMBER(entries + position) == member;
}

#line 141 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
bool
Sparse_insert(Sparse this, SparseMember member)
{
  int32_t count = Sparse_COUNT(this);
  SparseEntry entries = Sparse_ENTRIES(this);
  uint32_t position = SparseEntry_POSITION(entries + member);
  Except_CHECK(member < Sparse_UNIVERSE(this));
  if (   position < count
      && SparseEntry_MEMBER(entries + position) == member) return false;
  *SparseEntry__POSITION(entries + member) = count;
  *SparseEntry__MEMBER(entries + count) = member;
  ++*Sparse__COUNT(this);
  return true;
}

#line 164 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
bool
Sparse_remove(Sparse this, SparseMember member)
{
  int32_t count = Sparse_COUNT(this);
  SparseEntry entries = Sparse_ENTRIES(this);
  uint32_t position = SparseEntry_POSITION(entries + member);
  Except_CHECK(member < Sparse_UNIVERSE(this));
  if (   position < count
      && SparseEntry_MEMBER(entries + position) == member) {
    member = SparseEntry_MEMBER(entries + count - 1);
    *SparseEntry__POSITION(entries + member) = position;
    *SparseEntry__MEMBER(entries + position) = member;
    --*Sparse__COUNT(this);
    return true;
  }
  return false;
}

#line 188 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
SparseMember
Sparse_choose(Sparse this)
{
  int32_t count = Sparse_COUNT(this);
  if (count > 0) {
    SparseEntry entries = Sparse_ENTRIES(this);
    SparseMember member = SparseEntry_MEMBER(entries + count - 1);
    --*Sparse__COUNT(this);
    return member;
  }
  return (SparseMember)-1;
}

#line 207 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
bool
Sparse_equals(const_Sparse this, const_Sparse that)
{
  if (Sparse_COUNT(this) != Sparse_COUNT(that)) return false;
  Sparse_FOREACH(this, member) {
    if (!Sparse_contains(that, member)) return false;
  } Sparse_ENDEACH;
  return true;
}

#line 223 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
bool
Sparse_union(Sparse this, const_Sparse that)
{
  bool change = false;
  Except_CHECK(Sparse_COUNT(this) == Sparse_COUNT(that));
  Sparse_FOREACH(that, element) {
    if (Sparse_insert(this, element)) change = true;
  } Sparse_ENDEACH;
  return change;
}

#line 240 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
bool
Sparse_inter(Sparse this, const_Sparse that)
{
  bool change = false;
  Sparse_ new[1];
  Except_CHECK(Sparse_COUNT(this) == Sparse_COUNT(that));
  Sparse_Ctor(new, Sparse_MEMORY(this), Sparse_COUNT(this));
  Sparse_FOREACH(this, member) {
    if (!Sparse_contains(that, member)) Sparse_insert(new, member);
  } Sparse_ENDEACH;
  change = Sparse_COUNT(new) != 0;
  Sparse_FOREACH(new, remove) {
    Sparse_remove(this, remove);
  } Sparse_ENDEACH;
  Sparse_Dtor(new);
  return change;
}

#line 264 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
bool
Sparse_diff(Sparse this, const_Sparse that)
{
  bool change = false;
  Sparse_FOREACH(that, element) {
    if (Sparse_remove(this, element)) change = true;
  } Sparse_ENDEACH;
  return change;
}

#line 375 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
#ifndef CDT_NTRACE
bool
Sparse_pretty(Sparse this, FILE *file)
{
  if (file == NULL) file = stderr;
  Sparse_FOREACH(this, member) {
    fprintf (file, "%d ", member);
  } Sparse_ENDEACH;
  return true;
}
#endif//CDT_NTRACE

#line 387 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 399 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
#if XCC__C
static void
Sparse_TEST(void)
{
#include "CCL/Sparse_.c"
}

#line 406 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
int
main(int argc, char **argv)
{
  CCL_Test(Sparse_TEST);
  return 0;
}
#endif


#endif//Sparse_c_INCLUDED
