#ifndef Sparse__c_INCLUDED
#define Sparse__c_INCLUDED

#line 32 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
//
{
  // Check it is safe to use Memory_alloc_ on sizeof(SparseEntry_).
  Except_ALWAYS(CDT_ALIGNED(sizeof(SparseEntry_)));
}

#line 69 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
//
{
  printf("sizeof(Sparse_) = %d\n", sizeof(Sparse_));
}

#line 308 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
//
{
  int max = 100, i;
  Sparse_ sieve[1];
  Sparse_ primes[1];
  Sparse_Ctor(sieve, Memory_Root, max);
  Sparse_Ctor(primes, Memory_Root, max);
  for (i = max - 1; i >= 2; i--) Sparse_insert(sieve, (SparseMember)i);
//  for (i = 2; i < max/2; i++) Sparse_insert(sieve, (SparseMember)i);
//  for (i = max - 1; i >= max/2; i--) Sparse_insert(sieve, (SparseMember)i);
  while (!Sparse_isEmpty(sieve)) {
    int j = Sparse_choose(sieve);
    printf("prime %d\n", j);
    Sparse_insert(primes, (SparseMember)j);
    for (i = j + j; i < max; i += j) Sparse_remove(sieve, (SparseMember)i);
    printf("sieve: ");
    Sparse_FOREACH(sieve, iter) {
      printf("%d ", iter);
    } Sparse_ENDEACH;
    printf("\n");
  }
  printf("primes: ");
  Sparse_FOREACH(primes, iter) {
    printf("%d ", iter);
  } Sparse_ENDEACH;
  printf("\n");
  Sparse_Dtor(primes);
  Sparse_Dtor(sieve);
}

#line 338 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/Sparse.xcc"
//
{
#if 0
  int max = 100, i;
  Sparse_ set[1];
  Sparse_Ctor(set, Memory_Root, max);
  for (i = 0; i < 10; i++)
    if (Sparse_contains(set, i))
      printf("ERROR : Empty set contains number %d\n", i);
  for (i = 0; i < 10; i++) {
    if (!Sparse_insert(set, i))
      printf("ERROR : Can't insert number %d in to the set\n", i);
    else {
      printf ("Inserting number %d ; Set [size=%d] : ", i, Sparse_COUNT(set));
      Sparse_pretty(set, stdout);
      printf ("\n");
    }
  }
  for (i = 9; i >= 0; i--) {
    if (!Sparse_remove(set, i))
      printf("ERROR : Can't remove number %d from the set\n", i);
    else {
      printf ("Removing number %d ; Set [size=%d] : ", i, Sparse_COUNT(set));
      Sparse_pretty(set, stdout);
      printf ("\n");
    }
  }
  Sparse_Dtor(set);
#endif
}


#endif//Sparse__c_INCLUDED
