#ifndef TSTree_c_INCLUDED
#define TSTree_c_INCLUDED

#line 1 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/TSTree.xcc"
/*XCC.h
 * !!!!	TSTree.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com)
 *
 * Copyright 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 *
 * A Ternary Search Tree is a structure discoved by Bentley and Sedgewick
 * used to build a dictionary of sequences. In the initial presentation,
 * sequences were C strings (null-terminated char[]).
 *
 * In the present implementation, the sequence elements are of type intptr_t,
 * and the terminating value is given at TSTree construction time. The TSTree
 * structure can thus hold sequence of integers or pointers.
 */

#line 24 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/TSTree.xcc"
#include "CCL/CCL_.h"

#line 29 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/TSTree.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 42 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/TSTree.xcc"
TSTreeNode
TSTreeNode_Ctor(TSTreeNode this, intptr_t split)
{
  *TSTreeNode__SPLIT(this) = split;
  *TSTreeNode__LTKID(this) = NULL;
  *TSTreeNode__EQKID(this) = NULL;
  *TSTreeNode__GTKID(this) = NULL;
  return this;
}

#line 52 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/TSTree.xcc"
static void
TSTreeNode_Dtor_(TSTreeNode this, intptr_t stop, Memory memory)
{
  if (TSTreeNode_LTKID(this) != NULL)
      TSTreeNode_Dtor_(TSTreeNode_LTKID(this), stop, memory);
  if (TSTreeNode_EQKID(this) != NULL && TSTreeNode_SPLIT(this) != stop)
      TSTreeNode_Dtor_(TSTreeNode_EQKID(this), stop, memory);
  if (TSTreeNode_GTKID(this) != NULL)
      TSTreeNode_Dtor_(TSTreeNode_GTKID(this), stop, memory);
  Memory_free_(memory, this);
}

#line 86 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/TSTree.xcc"
TSTree
TSTree_Ctor(TSTree this, Memory memory, intptr_t stop)
{
  *TSTree__MEMORY(this) = memory;
  *TSTree__STOP(this) = stop;
  *TSTree__ROOT(this) = NULL;
  *TSTree__LAST(this) = NULL;
  *TSTree__COUNT(this) = 0;
  *TSTree__LENGTH(this) = 0;
  return this;
}

#line 98 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/TSTree.xcc"
void
TSTree_Dtor(TSTree this)
{
  if (TSTree_ROOT(this) != NULL) {
    TSTreeNode node = TSTree_ROOT(this);
    intptr_t stop = TSTree_STOP(this);
    Memory memory = TSTree_MEMORY(this);
    TSTreeNode_Dtor_(node, stop, memory);
  }
  *TSTree__ROOT(this) = NULL;
  *TSTree__LAST(this) = NULL;
  *TSTree__COUNT(this) = 0;
  *TSTree__LENGTH(this) = 0;
}

#line 119 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/TSTree.xcc"
int32_t
TSTree_count(const_TSTree this)
{
  return TSTree_COUNT(this);
}

#line 133 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/TSTree.xcc"
void *
TSTree_search(const_TSTree this, const intptr_t key[])
{
  intptr_t stop = TSTree_STOP(this);
  TSTreeNode node = TSTree_ROOT(this);
  while (node) {
    intptr_t split = key[0];
    if (split < TSTreeNode_SPLIT(node)) node = TSTreeNode_LTKID(node);
    else if (split > TSTreeNode_SPLIT(node)) node = TSTreeNode_GTKID(node);
    else {
      if (split == stop) {
        return TSTreeNode_EQKID(node);
      }
      node = TSTreeNode_EQKID(node);
      ++key;
    }
  }
  return NULL;
}

#line 162 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/TSTree.xcc"
void *
TSTree_insert(TSTree this, intptr_t key[], void *value)
{
  TSTreeNode root = TSTree_ROOT(this);
  *TSTree__LAST(this) = NULL;
  *TSTree__ROOT(this) = TSTreeNode_insert(root, key, this);
  if (TSTree_LAST(this) != NULL) {
    int32_t length = 0;
    intptr_t stop = TSTree_STOP(this);
    TSTreeNode last = TSTree_LAST(this);
    while (key[length++] != stop);
    if (length > TSTree_LENGTH(this)) {
      *TSTree__LENGTH(this) = length;
    }
    ++*TSTree__COUNT(this);
    *TSTreeNode__EQKID(last) = value;
    return value;
  }
  return NULL;
}

#line 187 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/TSTree.xcc"
TSTreeNode
TSTreeNode_insert(TSTreeNode this, intptr_t key[], TSTree tstree)
{
  intptr_t split = key[0];
  intptr_t stop = TSTree_STOP(tstree);
  if (this == NULL) {
    Memory memory = TSTree_MEMORY(tstree);
    this = Memory_alloc_(memory, sizeof(TSTreeNode_));
    TSTreeNode_Ctor(this, split);
    *TSTree__LAST(tstree) = this;
  }
  if (split < TSTreeNode_SPLIT(this)) {
    *TSTreeNode__LTKID(this) = TSTreeNode_insert(TSTreeNode_LTKID(this), key, tstree);
  } else if (split > TSTreeNode_SPLIT(this)) {
    *TSTreeNode__GTKID(this) = TSTreeNode_insert(TSTreeNode_GTKID(this), key, tstree);
  } else {
    if (split != stop) {
      *TSTreeNode__EQKID(this) = TSTreeNode_insert(TSTreeNode_EQKID(this), ++key, tstree);
    }
  }
  return this;
}

#line 222 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/TSTree.xcc"
void
TSTree_map(TSTree this, void (*map)(intptr_t [], void *, va_list), ...)
{
  va_list va;
  Memory memory = TSTree_MEMORY(this);
  intptr_t *key = Memory_alloc(memory, sizeof(intptr_t)*TSTree_LENGTH(this));
  va_start(va, map);
  if (TSTree_ROOT(this) != NULL) {
    TSTreeNode_map(TSTree_ROOT(this), TSTree_STOP(this), key, 0, map, va);
  }
  Memory_free_(memory, key);
  va_end(va);
}

#line 241 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/TSTree.xcc"
void
TSTreeNode_map(TSTreeNode this, intptr_t stop, intptr_t key[], int i,
               void (*map)(intptr_t [], void *, va_list), va_list va) {
  intptr_t split = TSTreeNode_SPLIT(this);
  if (split == stop) {
    if (key != NULL) key[i] = split;
    (*map)(key, TSTreeNode_EQKID(this), va);
  }
  if (TSTreeNode_LTKID(this) != NULL) {
    TSTreeNode_map(TSTreeNode_LTKID(this), stop, key, i, map, va);
  }
  if (TSTreeNode_EQKID(this) != NULL) {
    if (key != NULL) key[i] = split;
    if (split != stop) {
      TSTreeNode_map(TSTreeNode_EQKID(this), stop, key, i + 1, map, va);
    }
  }
  if (TSTreeNode_GTKID(this) != NULL) {
    TSTreeNode_map(TSTreeNode_GTKID(this), stop, key, i, map, va);
  }
}

#line 263 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/TSTree.xcc"
#if XCC__C
static void dump(intptr_t key[], void *value, va_list va)
{
  int i;
  FILE *file = (FILE *)va_arg(va, FILE *);
  fprintf(file, "    ");
  for (i = 0; key[i] != 0; i++) {
    fprintf(file, "%c", (int)key[i]);
  }
  fprintf(file, "\t-> %s\n", (char *)value);
}

#line 275 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/TSTree.xcc"
const char *
strings[] = {
  "aim", "your", "message", "at", "the", "audience", "you", "want", "to", "influence",
  "create", "specific", "messages", "for", "each", "segment", "of", "your", "audience",
  NULL
};
#endif

#line 318 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/TSTree.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 330 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/TSTree.xcc"
#if XCC__C
static void
TSTree_TEST(void)
{
#include "CCL/TSTree_.c"
}

#line 337 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/TSTree.xcc"
int
main(int argc, char **argv)
{
  CCL_Test(TSTree_TEST);
  return 0;
}
#endif


#endif//TSTree_c_INCLUDED
