#ifndef _CDT_STDINT_H
#define _CDT_STDINT_H 1
#ifndef _GENERATED_STDINT_H
#define _GENERATED_STDINT_H "CDT 1.0"
/* generated using a gnu compiler version gcc (SUSE Linux) 4.5.1 20101208 [gcc-4_5-branch revision 167585] Copyright (C) 2010 Free Software Foundation, Inc. This is free software; see the source for copying conditions. There is NO warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. */

#include <stdint.h>


/* system headers have good uint64_t */
#ifndef _HAVE_UINT64_T
#define _HAVE_UINT64_T
#endif
/* The ISO C99 standard specifies that in C++ implementations these
   macros should only be defined if explicitly requested.  */
#if !defined __cplusplus || defined __STDC_LIMIT_MACROS

#ifdef _HAVE_UINT64_T
#ifndef __INT64_C
#define __INT64_C(c)		c ## LL
#endif/*__INT64_C*/
#ifndef __UINT64_C
#define __UINT64_C(c)	c ## ULL
#endif/*__UINT64_C*/
#endif
/* Limits of integral types.  */

/* Minimum of signed integral types.  */
#ifndef INT8_MIN
#define INT8_MIN		(-128)
#endif/*INT8_MIN*/
#ifndef INT16_MIN
#define INT16_MIN		(-32767-1)
#endif/*INT16_MIN*/
#ifndef INT32_MIN
#define INT32_MIN		(-2147483647-1)
#endif/*INT32_MIN*/
#ifdef _HAVE_UINT64_T
#ifndef INT64_MIN
#define INT64_MIN		(-__INT64_C(9223372036854775807)-1)
#endif/*INT64_MIN*/
#endif

/* Maximum of signed integral types.  */
#ifndef INT8_MAX
#define INT8_MAX		(127)
#endif/*INT8_MAX*/
#ifndef INT16_MAX
#define INT16_MAX		(32767)
#endif/*INT16_MAX*/
#ifndef INT32_MAX
#define INT32_MAX		(2147483647)
#endif/*INT32_MAX*/
#ifdef _HAVE_UINT64_T
#ifndef INT64_MAX
#define INT64_MAX		(__INT64_C(9223372036854775807))
#endif/*INT64_MAX*/
#endif

/* Maximum of unsigned integral types.  */
#ifndef UINT8_MAX
#define UINT8_MAX		(255)
#endif/*UINT8_MAX*/
#ifndef UINT16_MAX
#define UINT16_MAX		(65535)
#endif/*UINT16_MAX*/
#ifndef UINT32_MAX
#define UINT32_MAX		(4294967295U)
#endif/*UINT32_MAX*/
#ifdef _HAVE_UINT64_T
#ifndef UINT64_MAX
#define UINT64_MAX		(__UINT64_C(18446744073709551615))
#endif/*UINT64_MAX*/
#endif

/* Minimum of signed integral types having a minimum size.  */
#ifndef INT_LEAST8_MIN
#define INT_LEAST8_MIN		(-128)
#endif/*INT_LEAST8_MIN*/
#ifndef INT_LEAST16_MIN
#define INT_LEAST16_MIN	(-32767-1)
#endif/*INT_LEAST16_MIN*/
#ifndef INT_LEAST32_MIN
#define INT_LEAST32_MIN	(-2147483647-1)
#endif/*INT_LEAST32_MIN*/
#ifdef _HAVE_UINT64_T
#ifndef INT_LEAST64_MIN
#define INT_LEAST64_MIN	(-__INT64_C(9223372036854775807)-1)
#endif/*INT_LEAST64_MIN*/
#endif

/* Maximum of signed integral types having a minimum size.  */
#ifndef INT_LEAST8_MAX
#define INT_LEAST8_MAX		(127)
#endif/*INT_LEAST8_MAX*/
#ifndef INT_LEAST16_MAX
#define INT_LEAST16_MAX	(32767)
#endif/*INT_LEAST16_MAX*/
#ifndef INT_LEAST32_MAX
#define INT_LEAST32_MAX	(2147483647)
#endif/*INT_LEAST32_MAX*/
#ifdef _HAVE_UINT64_T
#ifndef INT_LEAST64_MAX
#define INT_LEAST64_MAX	(__INT64_C(9223372036854775807))
#endif/*INT_LEAST64_MAX*/
#endif

/* Maximum of unsigned integral types having a minimum size.  */
#ifndef UINT_LEAST8_MAX
#define UINT_LEAST8_MAX	(255)
#endif/*UINT_LEAST8_MAX*/
#ifndef UINT_LEAST16_MAX
#define UINT_LEAST16_MAX	(65535)
#endif/*UINT_LEAST16_MAX*/
#ifndef UINT_LEAST32_MAX
#define UINT_LEAST32_MAX	(4294967295U)
#endif/*UINT_LEAST32_MAX*/
#ifdef _HAVE_UINT64_T
#ifndef UINT_LEAST64_MAX
#define UINT_LEAST64_MAX	(__UINT64_C(18446744073709551615))
#endif/*UINT_LEAST64_MAX*/
#endif

/* Minimum of fast signed integral types having a minimum size.  */
#ifndef INT_FAST8_MIN
#define INT_FAST8_MIN		(-128)
#endif/*INT_FAST8_MIN*/
#ifndef INT_FAST16_MIN
#define INT_FAST16_MIN	(-2147483647-1)
#endif/*INT_FAST16_MIN*/
#ifndef INT_FAST32_MIN
#define INT_FAST32_MIN	(-2147483647-1)
#endif/*INT_FAST32_MIN*/
#ifdef _HAVE_UINT64_T
#ifndef INT_FAST64_MIN
#define INT_FAST64_MIN		(-__INT64_C(9223372036854775807)-1)
#endif/*INT_FAST64_MIN*/
#endif

/* Maximum of fast signed integral types having a minimum size.  */
#ifndef INT_FAST8_MAX
#define INT_FAST8_MAX		(127)
#endif/*INT_FAST8_MAX*/
#ifndef INT_FAST16_MAX
#define INT_FAST16_MAX	(2147483647)
#endif/*INT_FAST16_MAX*/
#ifndef INT_FAST32_MAX
#define INT_FAST32_MAX	(2147483647)
#endif/*INT_FAST32_MAX*/
#ifdef _HAVE_UINT64_T
#ifndef INT_FAST64_MAX
#define INT_FAST64_MAX		(__INT64_C(9223372036854775807))
#endif/*INT_FAST64_MAX*/
#endif

/* Maximum of fast unsigned integral types having a minimum size.  */
#ifndef UINT_FAST8_MAX
#define UINT_FAST8_MAX		(255)
#endif/*UINT_FAST8_MAX*/
#ifndef UINT_FAST16_MAX
#define UINT_FAST16_MAX	(4294967295U)
#endif/*UINT_FAST16_MAX*/
#ifndef UINT_FAST32_MAX
#define UINT_FAST32_MAX	(4294967295U)
#endif/*UINT_FAST32_MAX*/
#ifdef _HAVE_UINT64_T
#ifndef UINT_FAST64_MAX
#define UINT_FAST64_MAX	(__UINT64_C(18446744073709551615))
#endif/*UINT_FAST64_MAX*/
#endif

/* Values to test for integral types holding void * pointer.  */
#ifndef INTPTR_MIN
#define INTPTR_MIN		(-2147483647-1)
#endif/*INTPTR_MIN*/
#ifndef INTPTR_MAX
#define INTPTR_MAX		(2147483647)
#endif/*INTPTR_MAX*/
#ifndef UINTPTR_MAX
#define UINTPTR_MAX		(4294967295U)
#endif/*UINTPTR_MAX*/

/* Minimum for largest signed integral type.  */
#ifdef _HAVE_UINT64_T
#ifndef INTMAX_MIN
#define INTMAX_MIN		(-__INT64_C(9223372036854775807)-1)
#endif/*INTMAX_MIN*/
#else
#ifndef INTMAX_MIN
#define INTMAX_MIN		(-2147483647-1)
#endif/*INTMAX_MIN*/
#endif

/* Maximum for largest signed integral type.  */
#ifdef _HAVE_UINT64_T
#ifndef INTMAX_MAX
#define INTMAX_MAX		(__INT64_C(9223372036854775807))
#endif/*INTMAX_MAX*/
#else
#ifndef INTMAX_MAX
#define INTMAX_MAX		(2147483647)
#endif/*INTMAX_MAX*/
#endif

/* Maximum for largest unsigned integral type.  */
#ifdef _HAVE_UINT64_T
#ifndef UINTMAX_MAX
#define UINTMAX_MAX		(__UINT64_C(18446744073709551615))
#endif/*UINTMAX_MAX*/
#else
#ifndef UINTMAX_MAX
#define UINTMAX_MAX		(4294967295U)
#endif/*UINTMAX_MAX*/
#endif

/* Limits of other integer types.  */

/* Limits of ptrdiff_t type.  */
#ifndef PTRDIFF_MIN
#define PTRDIFF_MIN		(-2147483647-1)
#endif/*PTRDIFF_MIN*/
#ifndef PTRDIFF_MAX
#define PTRDIFF_MAX		(2147483647)
#endif/*PTRDIFF_MAX*/

/* Limits of sig_atomic_t.  */
#ifndef SIG_ATOMIC_MIN
#define SIG_ATOMIC_MIN		(-2147483647-1)
#endif/*SIG_ATOMIC_MIN*/
#ifndef SIG_ATOMIC_MAX
#define SIG_ATOMIC_MAX		(2147483647)
#endif/*SIG_ATOMIC_MAX*/

/* Limit of size_t type.  */
#ifndef SIZE_MAX
#define SIZE_MAX		(4294967295U)
#endif/*SIZE_MAX*/

#endif	/* C++ && limit macros */

/* The ISO C99 standard specifies that in C++ implementations these
   should only be defined if explicitly requested.  */
#if !defined __cplusplus || defined __STDC_CONSTANT_MACROS

/* Signed.  */
#ifndef INT8_C
#define INT8_C(c)	c
#endif/*INT8_C*/
#ifndef INT16_C
#define INT16_C(c)	c
#endif/*INT16_C*/
#ifndef INT32_C
#define INT32_C(c)	c
#endif/*INT32_C*/
#ifdef _HAVE_UINT64_T
#ifndef INT64_C
#define INT64_C(c)	c ## LL
#endif/*INT64_C*/
#endif

/* Unsigned.  */
#ifndef UINT8_C
#define UINT8_C(c)	c ## U
#endif/*UINT8_C*/
#ifndef UINT16_C
#define UINT16_C(c)	c ## U
#endif/*UINT16_C*/
#ifndef UINT32_C
#define UINT32_C(c)	c ## U
#endif/*UINT32_C*/
#ifdef _HAVE_UINT64_T
#ifndef UINT64_C
#define UINT64_C(c)	c ## ULL
#endif/*UINT64_C*/
#endif

/* Maximal type.  */
#ifndef INTMAX_C
#define INTMAX_C(c)	c ## LL
#endif/*INTMAX_C*/
#ifndef UINTMAX_C
#define UINTMAX_C(c)	c ## ULL
#endif/*UINTMAX_C*/

#endif	/* C++ && constant macros */


  /* once */
#endif
#endif
