#ifndef AIR_c_INCLUDED
#define AIR_c_INCLUDED

#line 15 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/AIR.xcc"
#include "AIR/AIR_.h"

#line 25 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/AIR.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 80 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/AIR.xcc"
#undef AIR_TRACE
FILE *AIR_TRACE = NULL;

#line 87 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/AIR.xcc"
int FORCE_PIPELINE;
int FORCE_ONLYCOUNT;

#line 90 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/AIR.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 98 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/AIR.xcc"
static int AIR_Initialized = 0;

#line 100 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/AIR.xcc"
void
AIR_INIT(void)
{
  if (AIR_Initialized++ == 0) {
    FORCE_ONLYCOUNT = 0;
    if (GETENV("FORCE_ONLYCOUNT")) {
      sscanf(GETENV("FORCE_ONLYCOUNT"), "%d", &FORCE_ONLYCOUNT);
      fprintf(stderr, "*** FORCE_ONLYCOUNT=%d\n", FORCE_ONLYCOUNT);
    }
    FORCE_PIPELINE = 0;
    if (GETENV("FORCE_PIPELINE")) {
      sscanf(GETENV("FORCE_PIPELINE"), "%d", &FORCE_PIPELINE);
      fprintf(stderr, "*** FORCE_PIPELINE=%d\n", FORCE_PIPELINE);
    }
    if (GETENV("AIR_TRACE")) {
      int file = 0;
      sscanf(GETENV("AIR_TRACE"), "%d", &file);
      if (file == 1) AIR_TRACE = stdout;
      else if (file == 2) AIR_TRACE = stderr;
    }
    AIR_TRACE && fprintf(AIR_TRACE, "*** AIR INIT\n");
    CCL_INIT();
    MDS_INIT();
    Label_INIT();
    Symbol_INIT();
    Constant_INIT();
    Literal_INIT();
    Instruction_INIT();
    Pipeline_INIT();
    Scoreboard_INIT();
    NativeBlock_INIT();
    NativeStream_INIT();
    InterBlock_INIT();
    Trampoline_INIT();
  }
}

#line 143 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/AIR.xcc"
void
AIR_FINI(void)
{
  if (--AIR_Initialized == 0) {
    AIR_TRACE && fprintf(AIR_TRACE, "*** AIR FINI\n");
    Trampoline_FINI();
    InterBlock_FINI();
    NativeStream_FINI();
    NativeBlock_FINI();
    Pipeline_FINI();
    Scoreboard_FINI();
    Instruction_FINI();
    Literal_FINI();
    Constant_FINI();
    Symbol_FINI();
    Label_FINI();
    MDS_FINI();
    CCL_FINI();
  }
}

#line 170 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/AIR.xcc"
void
AIR_Test(void (*test)(void))
{
  AIR_INIT();
  (*test)();
  AIR_FINI();
}

#line 178 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/AIR.xcc"
#if XCC__C
static void
AIR_TEST(void)
{
#include "AIR/AIR_.c"
}

#line 185 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/AIR.xcc"
int
main(int argc, char **argv)
{
  AIR_Test(AIR_TEST);
  return 0;
}
#endif


#endif//AIR_c_INCLUDED
