#ifndef Instruction_c_INCLUDED
#define Instruction_c_INCLUDED

#line 15 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
#include "AIR/AIR_.h"

#line 20 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 59 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 95 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 135 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
InstructionTask
InstructionTask_Ctor(InstructionTask this,
                     Instance instance)
{
  Scheduling scheduling = Instance_scheduling(instance);
  Reservation reservation = Scheduling_reservation(scheduling);
  const_ReservationTable table = Reservation_table(reservation);
  int columnCount = ReservationTable_columnCount(table);
  *InstructionTask__INSTANCE(this) = instance;
  *InstructionTask__FLAGS(this) = InstructionFlags_make(instance);
  *InstructionTask__INDEXED(this) = NULL;
  *InstructionTask__SCHEDULING(this) = scheduling;
  *InstructionTask__RESERVATION(this) = reservation;
  *InstructionTask__PROCESSING(this) = columnCount;
  *InstructionTask__ITERATION(this) = 0;
  *InstructionTask__ORDERING(this) = 0;
  *InstructionTask__STARTDATE(this) = -1;
  *InstructionTask__RELEASE(this) = 0;
  *InstructionTask__CRITICAL(this) = columnCount;
  *InstructionTask__PREDCOUNT(this) = 0;
  *InstructionTask__WRITECOUNT(this) = 0;
  *InstructionTask__READCOUNT(this) = 0;
  *InstructionTask__EFFECTS(this) = NULL;
  return this;
}

#line 172 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
int
InstructionTask_compare(const void *this_pointer, const void *that_pointer)
{
  const_InstructionTask this = this_pointer;
  const_InstructionTask that = that_pointer;
  int result = InstructionTask_STARTDATE(this) - InstructionTask_STARTDATE(that);
  if (result == 0) {
    int this_position = InstructionTask_isInductive(this);
    int that_position = InstructionTask_isInductive(that);
    if (InstructionTask_isControl(this)) this_position += 255;
    if (InstructionTask_isControl(that)) that_position += 255;
    result = this_position - that_position;
    if (result == 0) {
      result = InstructionTask_ITERATION(this) - InstructionTask_ITERATION(that);
      if (result == 0) {
        result = InstructionTask_INDEX(this) - InstructionTask_INDEX(that);
      }
    }
  }
  return result;
}

#line 194 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 207 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
InstructionRelocatable
InstructionRelocatable_Ctor(InstructionRelocatable this,
                            const_OperandsBuffer buffer, Relocation relocation,
                            Operands operands)
{
  int relocatableRank = Operands_relocatableRank(operands);
  Constant constant = NULL;
  if (relocatableRank > 0) {
    const OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
    Constant decoded_constant = (Constant)decoded[relocatableRank - 1];
    if (Constant_isRelocatable(decoded_constant)) {
      constant = decoded_constant;
    }
  }
  *InstructionRelocatable__CONSTANT(this) = constant;
  *InstructionRelocatable__RELOCATION(this) = relocation;
  *InstructionRelocatable__OPERANDS(this) = operands;
  *InstructionRelocatable__RANK(this) = relocatableRank;
  return this;
}

#line 233 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 293 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
Instruction
Instruction_Ctor(Instruction this,
                 Instance instance, const_OperandsBuffer buffer, Relocation relocation)
{
  Scheduling scheduling = Instance_scheduling(instance);
  Reservation reservation = Scheduling_reservation(scheduling);
  InstructionTask_Ctor(Instruction_TASK(this), instance);
  *InstructionRelocatable__CONSTANT(Instruction_RELOCATABLE(this)) = NULL;
  *Instruction_OPCODES(this) = *Instance_opcodes(instance);
  if (buffer != NULL) {
    Operands operands = Instance_operands(instance);
    InstructionRelocatable_Ctor(Instruction_RELOCATABLE(this),
                                buffer, relocation, operands);
    (*Operands_encode(operands))(buffer, Instruction_OPCODES(this));
  }
  *Instruction__ADDRESS(this) = (PlatformInt)-1;
  *Instruction__ACTIONS(this) = Instruction_ARRAY(this);
  return this;
}

#line 318 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 480 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
const InstructionAction_ *
Instruction_makeActions(Instruction this, const_OperandsBuffer buffer)
{
  int writeCount = 0, readCount = 0;
  Instance instance = Instruction_INSTANCE(this);
  const_RegisterActionArray actionArray = Instance_actionArray(instance);
  const OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  InstructionAction_ *this_actions = Instruction_ACTIONS(this);
  InstructionFlags flags = Instruction_FLAGS(this);
  bool war = (flags & InstructionFlag_Control)? 1: 0;
  InstructionAction_ register_action_, volatile_action_;
  InstructionAction_ control_action_, memory_action_;
  register_action_.__.RAW = 0; register_action_.__.WAR = war; register_action_.__.WAW = 1;
  volatile_action_.__.RAW = 1; volatile_action_.__.WAR = 1; volatile_action_.__.WAW = 1;
  control_action_.__.RAW = 1; control_action_.__.WAR = 0; control_action_.__.WAW = 1;
  memory_action_.__.RAW = 1; memory_action_.__.WAR = 1; memory_action_.__.WAW = 1;
  volatile_action_.__.CELL = StorageCell__Volatile; volatile_action_.__.STAGE = 0;
  control_action_.__.CELL = StorageCell__Control; control_action_.__.STAGE = 0;
  memory_action_.__.CELL = StorageCell__Memory; memory_action_.__.STAGE = 0;
  // Write RegisterActions.
  RegisterActionArray_FORWRITE_RegisterAction(actionArray, action) {
    int rank = RegisterAction_rank(action);
    Register registre = rank > 0?
                        (Register)decoded[rank - 1]:
                        RegisterAction_register(action);
    const_RegisterStorageCells storageCells = Register_storageCells(registre);
    if (Register_isWired(registre)) continue;
    register_action_.__.STAGE = RegisterAction_stage(action);
    RegisterStorageCells_FOREACH_StorageCell(storageCells, cell) {
      register_action_.__.CELL = cell;
      if (cell != StorageCell__Control) {
        this_actions[writeCount++] = register_action_;
      }
    } RegisterStorageCells_ENDEACH_StorageCell;
  } RegisterActionArray_ENDWRITE_RegisterAction;
  if (flags & InstructionFlag_Volatile) {
    this_actions[writeCount++] = volatile_action_;
  }
  if (flags & InstructionFlag_Control) {
    this_actions[writeCount++] = control_action_;
  }
  if (flags & InstructionFlag_MemoryWrite) {
    this_actions[writeCount++] = memory_action_;
  }
  *Instruction__WRITECOUNT(this) = writeCount;
  this_actions += writeCount;
  // Read RegisterActions.
  RegisterActionArray_FORREAD_RegisterAction(actionArray, action) {
    int rank = RegisterAction_rank(action);
    Register registre = rank > 0?
                        (Register)decoded[rank - 1]:
                        RegisterAction_register(action);
    const_RegisterStorageCells storageCells = Register_storageCells(registre);
    if (Register_isWired(registre)) continue;
    register_action_.__.STAGE = RegisterAction_stage(action);
    RegisterStorageCells_FOREACH_StorageCell(storageCells, cell) {
      register_action_.__.CELL = cell;
      this_actions[readCount++] = register_action_;
    } RegisterStorageCells_ENDEACH_StorageCell;
  } RegisterActionArray_ENDREAD_RegisterAction;
  if (!(flags & InstructionFlag_Control)) {
    this_actions[readCount++] = control_action_;
  }
  if (flags & InstructionFlag_MemoryRead) {
    this_actions[readCount++] = memory_action_;
  }
  *Instruction__READCOUNT(this) = readCount;
  Except_CHECK(writeCount + readCount <= InstructionTask_ACTIONS_COUNT_MAX);
  return this_actions - writeCount;
}

#line 551 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 570 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
void
Instruction_relocate(Instruction this, PlatformUInt nativePC,
                     InstructionRelocationFixup fixup,
                     void* userData, NativeStream stream)
{
  Instance instance = Instruction_INSTANCE(this);
  Operands operands = Instance_operands(instance);
  InstructionRelocatable relocatable = Instruction_RELOCATABLE(this);
  Constant constant = InstructionRelocatable_CONSTANT(relocatable);
  Relocation relocation = InstructionRelocatable_RELOCATION(relocatable);
  Operand operand = Operands_relocatableOperand(operands);
  Immediate immediate = Operands_relocatableImmediate(operands);
  ImmediateValue value = Constant_VALUE(constant);
  //
  Except_REQUIRE(Instruction_hasRelocatable(this));
  // If the user provided a fixup function, we invoke it.
  if (fixup) {
    (*fixup)(this, nativePC, relocation, userData, stream);
    value = Constant_VALUE(constant);
  }
  if (Relocation_isRelativePC(relocation)) value -= nativePC;
  Except_CHECK(Immediate_canEncode(immediate, value));
  Operand_encodeImmediateValue(operand, value, Instruction_OPCODES(this));
}

#line 610 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 618 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
void
Instruction_recode(Instruction this, const_OperandsBuffer buffer, Relocation relocation)
{
  Instance instance = Instruction_INSTANCE(this);
  Operands operands = Instance_operands(instance);
  (*Operands_encode(operands))(buffer, Instruction_OPCODES(this));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(this),
                              buffer, relocation, operands);
}

#line 634 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
#ifndef NDECODE
Instruction
Instruction_decode(Instruction this, Encoding encoding, const_InstanceOpcodes opcodes)
{
  OperandsBuffer_ buffer[1];
  Instance instance = (*Encoding_decode(encoding))(opcodes);
  Operands operands = Instance_operands(instance);
  OperandsBuffer_Ctor(buffer);
  (*Operands_decode(operands))(opcodes, buffer);
  Instruction_Ctor(this, instance, NULL, Relocation__UNDEF);
  *Instruction_OPCODES(this) = *opcodes;
  return this;
}
#endif//NDECODE

#line 655 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
#ifndef NDECODE
void
Instruction_decodeOperands(const_Instruction this, OperandsBuffer buffer)
{
  Instance instance = Instruction_INSTANCE(this);
  Operands operands = Instance_operands(instance);
  Constant constant = InstructionRelocatable_CONSTANT(Instruction_RELOCATABLE(this));
  (*Operands_decode(operands))(Instruction_OPCODES(this), buffer);
  if (constant != NULL) {
    OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
    int relocatableRank = Operands_relocatableRank(operands);
    decoded[relocatableRank - 1] = (OperandDecoded)constant;
  }
}
#endif//NDECODE

#line 701 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 709 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
#ifndef ECL_NTRACE
bool
Instruction_pretty(const_Instruction this, FILE *file, void *stream)
{
  NativeStream nativeStream = (NativeStream)stream;
  Instance instance = Instruction_INSTANCE(this);
  Operands operands = Instance_operands(instance);
  OperandsBuffer_ buffer_, *buffer = OperandsBuffer_Ctor(&buffer_);
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  const char *syntax = Instance_syntax(instance), *q;
  if (file == NULL) file = stderr;
  Instruction_decodeOperands(this, buffer);
  for (q = syntax; *q != 0; q++) {
    if (q[0] == '%') {
      if (q[1] >= '0' && q[1] <= '9') {
        int rank = q[1] - '0';
        if (rank == 0) {
          fputs(Instance_mnemonic(instance), file);
          // TODO: Display other InstructionFlags
          if (Instruction_isVolatile(this))
            fputs(".vol", file);
        } else {
          int operandsIndex = rank - 1;
          Operand operand = Operands_access(operands, operandsIndex);
          Immediate immediate = Operand_immediate(operand);
          OperandType type = Operand_type(operand);
          if (type == OperandType_RegClass) {
            Register registre = (Register)decoded[operandsIndex];
            fputs(Register_names(registre)[0], file);
          } else if (type == OperandType_Immediate) {
            ImmediateConstant immediateConstant =
                (ImmediateConstant)decoded[operandsIndex];
            Constant relocatableConstant = Instruction_relocatableConstant(this);
            if (nativeStream != NULL &&
                relocatableConstant != NULL &&
                rank == Operands_relocatableRank(operands)) {
              char print[16];
              void *handle = Constant_HANDLE(relocatableConstant);
              long long offset = (long long)Constant_OFFSET(relocatableConstant);
              const char *format = offset != 0? "%s%+lld": "%s";
              if (Constant_isLabel(relocatableConstant)) {
                const char *(*makeLabelName)(const void *Label) =
                    NativeStream_MAKELABELNAME(nativeStream);
                const char *name = makeLabelName != NULL?
                                   (*makeLabelName)(handle): print;
                if (name == print) sprintf(print, "L?%p", handle);
                fprintf(file, format, name, offset);
              } else {
                const char *(*makeSymbolName)(const void *Symbol) =
                    NativeStream_MAKESYMBOLNAME(nativeStream);
                const char *name = makeSymbolName != NULL?
                                   (*makeSymbolName)(handle): print;
                if (name == print) sprintf(print, "S?%p", handle);
                fprintf(file, format, name, offset);
              }
            } else {
              long long value = (long long)ImmediateConstant_VALUE(immediateConstant);
              const_ImmediateRelocations relocations = Immediate_relocations(immediate);
              Relocation relocation = ImmediateRelocations_count(relocations)?
                                      ImmediateRelocations_access(relocations, 0):
                                      Relocation__UNDEF;
              const char *format = Relocation_isRelativePC(relocation)? ".%+lld": "%lld";
              fprintf(file, format, value);
            }
          } else if (type == OperandType_Modifier) {
            Modifier modifier = Operand_modifier(operand);
            ModifierMember member = (ModifierMember)decoded[operandsIndex];
            fputs(ModifierMember_name_(member), file);
          } else if (type == OperandType_RegMask) {
            RegisterSet registerSet = (RegisterSet)decoded[operandsIndex];
            bool inRange = false;
            Register prevReg = Register__UNDEF;
            RegisterSet_FOREACH_Register(registerSet, registre) {
              if (prevReg == Register__UNDEF) {
                fputs(Register_names(registre)[0], file);
              } else if (registre == prevReg + 1) {
                Except_CHECK(   Register_regFile(registre)
                             == Register_regFile(prevReg));
                // Inside Register range.
                inRange = true;
              } else if (inRange) {
                // Stop Register range.
                fprintf(file, "-%s", Register_names(prevReg)[0]);
                fprintf(file, ",%s", Register_names(registre)[0]);
                inRange = false;
              } else {
                fprintf(file, ",%s", Register_names(registre)[0]);
              }
              prevReg = registre;
            } RegisterSet_ENDEACH_Register;
            if (inRange && prevReg != Register__UNDEF) {
              fprintf(file, "-%s", Register_names(prevReg)[0]);
            }
          } else Except_NEVER(true);
        }
        q++;
      } else if (q[1] == '%') {
        fputc(q[1], file);
        q++;
      }
    } else {
      fputc(q[0], file);
    }
  }
  if (Instruction_STARTDATE(this) >= 0) {
    fprintf(file, "\t## date %d", Instruction_STARTDATE(this));
  }
  return true;
}
#endif//ECL_NTRACE

#line 820 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 841 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
InstructionGroup
InstructionGroup_Ctor(InstructionGroup this)
{
#if Bundle_ISSUE_MAX
  *InstructionGroup__BUNDLE(this) = Bundle__UNDEF;
  *InstructionGroup__TEMPLATE(this) = Template__UNDEF;
  *InstructionGroup__COUNT(this) = 0;
#else//!Bundle_ISSUE_MAX
  *InstructionGroup__INSTRUCTION(this) = NULL;
#endif//Bundle_ISSUE_MAX
  return this;
}

#line 859 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 886 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
#if Bundle_ISSUE_MAX
Template
InstructionGroup_findTemplate(InstructionGroup this, PlatformUInt nativePC)
{
  int count = InstructionGroup_COUNT(this);
  BundlingBuffer buffer = InstructionGroup_BUFFER(this);
  uint32_t hash = BundlingBuffer_sort(buffer, count);
  Bundle bundle = BundleMatch_FindBundle(hash, nativePC);
  Template template = Bundle_template(bundle);
  Except_ENSURE(bundle != Bundle__UNDEF);
  *InstructionGroup__BUNDLE(this) = bundle;
  *InstructionGroup__TEMPLATE(this) = template;
  return template;
}
#endif//Bundle_ISSUE_MAX

#line 910 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
void
InstructionGroup_encode(InstructionGroup this, PlatformUInt nativePC, void *buffer,
                        InstructionRelocationFixup fixup,
                        void* userData, NativeStream stream)
{
#if Bundle_ISSUE_MAX
  int count = InstructionGroup_COUNT(this), i;
  Template template = InstructionGroup_TEMPLATE(this);
  const uint8_t *restrict distances = Template_distances(template);
  Instruction *restrict instructions = InstructionGroup_INSTRUCTIONS(this);
  const_InstanceOpcodes templateOpcodes[Bundle_ISSUE_MAX];
  if (count == 1) {
    int distance = distances[0];
    Instruction instruction = instructions[0];
    if (Instruction_hasRelocatable(instruction)) {
      Instruction_relocate(instruction, nativePC + distance,
                           fixup, userData, stream);
    }
    *Instruction__ADDRESS(instruction) = nativePC + distance;
    templateOpcodes[0] = Instruction_opcodes(instruction);
  } else {
    Bundle bundle = InstructionGroup_BUNDLE(this);
    const uint8_t *restrict inverse = Bundle_inverse(bundle);
    BundlingBuffer bundlingBuffer = InstructionGroup_BUFFER(this);
    uint8_t *restrict permute = BundlingBuffer_PERMUTE(bundlingBuffer);
    for (i = 0; i < count; i++) {
      int distance = distances[i];
      int index = permute[inverse[i]];
      Instruction instruction = instructions[index];
      if (Instruction_hasRelocatable(instruction)) {
        Instruction_relocate(instruction, nativePC + distance,
                             fixup, userData, stream);
      }
      *Instruction__ADDRESS(instruction) = nativePC + distance;
      templateOpcodes[i] = Instruction_opcodes(instruction);
    }
  }
  (*Template_encode(template))(templateOpcodes, buffer);
#else//!Bundle_ISSUE_MAX
  Instruction instruction = InstructionGroup_INSTRUCTION(this);
  if (instruction != NULL) {
    if (Instruction_hasRelocatable(instruction)) {
      Instruction_relocate(instruction, nativePC, fixup, userData, stream);
    }
    Instruction_encode(instruction, buffer);
    *Instruction__ADDRESS(instruction) = nativePC;
  }
#endif//Bundle_ISSUE_MAX
}

#line 960 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 969 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
#ifndef ECL_NTRACE
bool
InstructionGroup_pretty(const_InstructionGroup this, FILE *file,
                        void *stream, int offset)
{
  NativeStream nativeStream = stream;
  const uint8_t *codeBuffer = NativeStream_CODEBUFFER(nativeStream);
  const uint8_t *encoded = codeBuffer + offset;
#if Bundle_ISSUE_MAX
  int count = InstructionGroup_COUNT(this), i, j;
  Template template = InstructionGroup_TEMPLATE(this);
  const uint8_t *distances = Template_distances(template);
  const Instruction *instructions = InstructionGroup_INSTRUCTIONS(this);
  const_BundlingBuffer bundlingBuffer = InstructionGroup_BUFFER(this);
  const uint8_t *permute = BundlingBuffer_PERMUTE(bundlingBuffer);
  Bundle bundle = InstructionGroup_BUNDLE(this);
  const uint8_t *inverse = Bundle_inverse(bundle);
  int codeSizes[Bundle_ISSUE_MAX];
  if (file == NULL) file = stderr;
  codeSizes[0] = distances[1];
  for (i = 1; i < count - 1; i++) {
    codeSizes[i] = distances[i + 1] - distances[i];
  }
  codeSizes[count - 1] = Template_increment(template);
  if (count > 1) codeSizes[count - 1] -= distances[count - 1];
  for (i = 0; i < count; i++) {
    int index = permute[inverse[i]];
    Instruction instruction = instructions[index];
    fprintf(file, "%08x\t", encoded - codeBuffer);
    for (j = Encoding_SIZE_MAX - 1; j >= codeSizes[i]; j--) {
      fprintf(file, "   ");
    }
    for (j = codeSizes[i] - 1; j >= 0; j--) {
      fprintf(file, "%02x ", encoded[j]);
    }
    fputc('\t', file);
    Instruction_pretty(instruction, file, nativeStream);
    fputc('\n', file);
    encoded += codeSizes[i];
  }
#else//!Bundle_ISSUE_MAX
  Instruction instruction = InstructionGroup_INSTRUCTION(this);
  if (instruction != NULL) {
    Instance instance = Instruction_INSTANCE(instruction);
    int codeSize = Instance_increment(instance), j;
    fprintf(file, "%08x\t", encoded - codeBuffer);
    for (j = Encoding_SIZE_MAX - 1; j >= codeSize; j--) {
      fprintf(file, "   ");
    }
    for (j = codeSize - 1; j >= 0; j--) {
      fprintf(file, "%02x ", encoded[j]);
    }
    fputc('\t', file);
    Instruction_pretty(instruction, file, nativeStream);
    fputc('\n', file);
  }
#endif//Bundle_ISSUE_MAX
  return true;
}
#endif//ECL_NTRACE

#line 1030 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1148 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1168 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
InstructionStack
InstructionStack_Ctor(InstructionStack this,
                      Memory memory, int maxCount)
{
  PtrSeq_Ctor(InstructionStack____(this), memory, maxCount);
  return this;
}

#line 1176 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
void
InstructionStack_Dtor(InstructionStack this)
{
  PtrSeq_Dtor(InstructionStack____(this));
}

#line 1241 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1253 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
#if XCC__C
#include "MDS/MDS_.h"
static void
Instruction_TEST(void)
{
#include "AIR/Instruction_.c"
}

#line 1261 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
int
main(int argc, char **argv)
{
  AIR_Test(Instruction_TEST);
  return 0;
}
#endif


#endif//Instruction_c_INCLUDED
