#ifndef Instruction__c_INCLUDED
#define Instruction__c_INCLUDED

#line 40 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//
{
  Except_ALWAYS(InstructionFlag_Control == 1<<InstanceAttribute_Control);
  Except_ALWAYS(InstructionFlag_MemoryRead == 1<<InstanceAttribute_MemoryRead);
  Except_ALWAYS(InstructionFlag_MemoryWrite == 1<<InstanceAttribute_MemoryWrite);
}

#line 90 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//
{
  printf("sizeof(InstructionAction_)\t%d\n", sizeof(InstructionAction_));
}

#line 161 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//
{
  printf("sizeof(InstructionTask_)\t%d\n", sizeof(InstructionTask_));
}

#line 228 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//
{
  printf("sizeof(InstructionRelocatable_)\t%d\n", sizeof(InstructionRelocatable_));
}

#line 313 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//
{
  printf("sizeof(Instruction_)\t%d\n", sizeof(Instruction_));
}

#line 671 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//
{
#ifdef MDS_CORE_st231
  InstanceOpcodes_ opcodes[] = {
    { { 0x2502444c } },	//  stw 36[$r12] = $r17
    { { 0x2502040c } },	//  stw 32[$r12] = $r16
    { { 0x2001824c } },	//  ldw $r9 = 24[$r12]
    { { 0x00010240 } },	//  mov $r16 = $r9
    { { 0x30000000 } },	//  call $r63 = <Module>:fclose
    { { 0x2001424c } },	//  ldw $r9 = 20[$r12]
    { { 0x00010240 } },	//  mov $r16 = $r9
    { { 0x30000000 } },	//  call $r63 = <Module>:fclose
    { { 0x08001400 } },	//  mov $r16 = 1
    { { 0x30000000 } },	//  call $r63 = <Module>:__io_ftable_get_stdentry
  };
  printf("Instruction_decode:\n");
  {
    int count = sizeof(opcodes)/sizeof(*opcodes), i;
    for (i = 0; i < count; i++) {
      Instruction_ instruction[1];
      InstanceOpcodes instanceOpcodes = opcodes + i;
      Encoding encoding = InstanceOpcodes_WORDS(instanceOpcodes)[1]?
                          Encoding_st231_ANYX: Encoding_st231_ANY;
      Instruction_decode(instruction, encoding, instanceOpcodes);
      printf("\t"), Instruction_pretty(instruction, stdout, NULL), printf("\n");
    }
  }
#endif//MDS_CORE_st231
}

#line 854 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//
{
  printf("sizeof(InstructionGroup_)\t%d\n", sizeof(InstructionGroup_));
}

#line 1032 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//
{
  Processor processor = Processor__DEFAULT;
  NativeStream stream = NativeStream_new(Memory_Root, 10);
  NativeBlock block_1 = NativeStream_pushNativeBlock(stream, processor, 0, NULL);
  NativeBlock block_2 = NativeStream_pushNativeBlock(stream, processor, 0, NULL);
  static uint32_t codeBuffer[64] = { 0xdeadbeef, 0xdeadbeef };
#ifdef MDS_FAMILY_arm
  Constant_ immed8[1], rotimm[1];
  RegisterSet_ regmask[1];
  RegisterSet_insert(regmask, Register_arm_GR0);
  RegisterSet_insert(regmask, Register_arm_GR1);
  RegisterSet_insert(regmask, Register_arm_GR2);
  RegisterSet_insert(regmask, Register_arm_LR);
  NativeBlock_makeInstruction_arm_cond_amode4L_rnNoPC_reglistNoPC(
      block_1, Operator_instance(Operator_arm_stm_w_3noPC_1cond_2amode4S_3noPC_4reglist, processor),
      ModifierMember_arm_cond_none, ModifierMember_arm_amode4L_fd, Register_arm_SP, regmask);
  NativeBlock_makeInstruction_arm_cond_rdNoPC_rnNoPC(
      block_1, Operator_instance(
          Operator_arm_ldr_2noPC_1cond_3general,
          processor),
      ModifierMember_arm_cond_none, Register_arm_IP, Register_arm_SP);
  NativeBlock_makeInstruction_arm_cond_rn_immed8(
      block_1, Operator_instance(Operator_arm_cmp_imm_1cond_2general_3immed8, processor),
      ModifierMember_arm_cond_none, Register_arm_IP,
      Constant_Ctor(immed8, ConstantType_Absolute, NULL, 32, 0));
#endif//MDS_FAMILY_arm
#ifdef MDS_CORE_st231
  Constant_ constant[1];
  NativeBlock_makeInstruction_st200_idest_src1_isrc2(
      block_1, Instance_st231_add_idest_src1_isrc2,
      Register_st200_GR12, Register_st200_GR12,
      Constant_Ctor(constant, ConstantType_Absolute, NULL, -32, 0),
      Relocation__UNDEF);
  NativeBlock_makeInstruction_st200_isrc2_src1_src2(
      block_1, Instance_st231_stw_isrc2_src1_src2,
      Constant_Ctor(constant, ConstantType_Absolute, NULL, 24, 0),
      Register_st200_GR12, Register_st200_GR63,
      Relocation__UNDEF);
  NativeBlock_makeInstruction_st200_isrc2_src1_src2(
      block_1, Instance_st231_stw_isrc2_src1_src2,
      Constant_Ctor(constant, ConstantType_Absolute, NULL, 32, 0),
      Register_st200_GR12, Register_st200_GR16,
      Relocation__UNDEF);
  NativeBlock_makeInstruction_st200_isrc2_src1_src2(
      block_1, Instance_st231_stw_isrc2_src1_src2,
      Constant_Ctor(constant, ConstantType_Absolute, NULL, 36, 0),
      Register_st200_GR12, Register_st200_GR17,
      Relocation__UNDEF);
  NativeBlock_makeInstruction_st200_isrc2_src1_src2(
      block_1, Instance_st231_stw_isrc2_src1_src2,
      Constant_Ctor(constant, ConstantType_Absolute, NULL, 40, 0),
      Register_st200_GR12, Register_st200_GR18,
      Relocation__UNDEF);
  NativeBlock_makeInstruction_st200_idest_xsrc2_src1(
      block_2, Instance_st231_ldw_idest_xsrc2_src1,
      Register_st200_GR9,
      Constant_Ctor(constant, ConstantType_Absolute, NULL, 32, 0),
      Register_st200_GR12,
      Relocation__UNDEF);
  NativeBlock_makeInstruction_st200_ibdest_src1_isrc2(
      block_2, Instance_st231_cmpgt_ibdest_src1_isrc2,
      Register_st200_BR0, Register_st200_GR9,
      Constant_Ctor(constant, ConstantType_Absolute, NULL, 32, 0),
      Relocation__UNDEF);
  NativeBlock_makeInstruction_st200_btarg(
      block_2, Instance_st231_call_btarg,
      Constant_Ctor(constant, ConstantType_Absolute, NULL, 4, 0),
      Relocation__UNDEF);
  NativeBlock_makeInstruction_st200_idest_isrc2_src1(
      block_2, Instance_st231_ldw_idest_isrc2_src1,
      Register_st200_GR26,
      Constant_Ctor(constant, ConstantType_Absolute, NULL, 80, 0),
      Register_st200_GR12,
      Relocation__UNDEF);
  NativeBlock_makeInstruction_st200_dest_src2(
      block_2, Instance_st231_mov_dest_src2,
      Register_st200_GR27, Register_st200_GR16);
  NativeBlock_makeInstruction_st200_dest_src1_src2(
      block_2, Instance_st231_add_dest_src1_src2,
      Register_st200_GR27, Register_st200_GR26,
      Register_st200_GR10);
#endif//MDS_CORE_st231
  {
    printf("Processor %s:\n", Processor_name_(processor));
    NativeStream_getCodeSize(stream, (PlatformUInt)codeBuffer);
    NativeStream_encode(stream, (PlatformUInt)codeBuffer, codeBuffer, NULL, NULL, NULL);
    NativeStream_pretty(stream, stdout);
    NativeStream_FOREACH_NativeBlock(stream, nativeBlock) {
      NativeBlock_FOREACH_Instruction(nativeBlock, instruction) {
        int writeCount = 0, readCount = 0, i;
        const InstructionAction_ *actions = NULL;
        Instance instance = Instruction_INSTANCE(instruction);
        OperandsBuffer_ buffer_, *buffer = OperandsBuffer_Ctor(&buffer_);
        Operands operands = Instance_operands(Instruction_INSTANCE(instruction));
        (*Operands_decode(operands))(Instruction_OPCODES(instruction), buffer);
        actions = Instruction_makeActions(instruction, buffer);
        writeCount = Instruction_WRITECOUNT(instruction);
        readCount = Instruction_READCOUNT(instruction);
        fputc('\t', stdout);
        Instruction_pretty(instruction, stdout, stream);
        for (i = 0; i < writeCount; i++) {
          StorageCell cell = InstructionAction_CELL(actions + i);
          printf(" \tWrite(%s)", StorageCell_name(cell));
        }
        for (i = 0; i < readCount; i++) {
          StorageCell cell = InstructionAction_CELL(actions + writeCount + i);
          printf(" \tRead(%s)", StorageCell_name(cell));
        }
        fputc('\n', stdout);
      } NativeBlock_ENDEACH_Instruction;
    } NativeStream_ENDEACH_NativeBlock;
  }
  NativeStream_delete(stream);
}

#line 1182 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Instruction.xcc"
//
{
  printf("sizeof(InstructionStack_) = %d\n", sizeof(InstructionStack_));
}


#endif//Instruction__c_INCLUDED
