#ifndef NativeBlock_c_INCLUDED
#define NativeBlock_c_INCLUDED

#line 15 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
#include "AIR/AIR_.h"

#line 20 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 40 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
#ifndef ECL_NTRACE
ETableEntry_ NativeBlockFlagEntries[] = {
  ETableENTRY(NativeBlockFlag, Literals),
  ETableENTRY(NativeBlockFlag, Entry),
  ETableENTRY(NativeBlockFlag, Exit),
  ETableENTRY(NativeBlockFlag, Protected),
  ETableENTRY(NativeBlockFlag, Catch),
  ETableENTRY(NativeBlockFlag, Finally),
  ETableENTRY(NativeBlockFlag, Fault),
  ETableENTRY(NativeBlockFlag, Filter),
  ETableENTRY(NativeBlockFlag, Bundled),
  ETableENTRY_NULL
};
ETable_ NativeBlockFlag_Table[1];
#endif//ECL_NTRACE

#line 85 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
NativeBlock
NativeBlock_Ctor(NativeBlock this,
                 Memory memory, Processor processor, NativeBlockFlags flags)
{
  InstructionStack_Ctor(NativeBlock_INSTRUCTIONS(this), memory, 64);
  IDList_Ctor(NativeBlock_LITERALS(this), memory);
  *NativeBlock__NATIVESTREAM(this) = NULL;
  *NativeBlock__PROCESSOR(this) = processor;
  *NativeBlock__FILLEMPTY(this) = !Processor_interlocks(processor);
  *NativeBlock__FLAGS(this) = flags;
  *NativeBlock__LABEL(this) = NULL;
  *NativeBlock__LASTDATE(this) = -1;
  *NativeBlock__GROUPCOUNT(this) = -1;
  *NativeBlock__GROUPS(this) = NULL;
  *NativeBlock__CODESIZE(this) = 0;
  return this;
}

#line 103 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
void
NativeBlock_Dtor(NativeBlock this)
{
  Memory memory = NativeBlock_MEMORY(this);
  InstructionStack_Dtor(NativeBlock_INSTRUCTIONS(this));
  IDList_Dtor(NativeBlock_LITERALS(this));
  Memory_free(memory, NativeBlock_GROUPS(this));
}

#line 112 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
size_t
NativeBlock_Size(Memory memory, Processor processor, NativeBlockFlags flags)
{
  return sizeof(NativeBlock_);
}

#line 132 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
#ifndef NativeBlock_POOLED
#define NativeBlock_POOLED 128
#endif//NativeBlock_POOLED

#line 136 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
NativeBlock
NativeBlock_new(Memory parent, Processor processor, NativeBlockFlags flags)
{
  Memory memory = Memory_new(parent, NativeBlock_POOLED);
  size_t size = NativeBlock_Size(memory, processor, flags);
  NativeBlock this = Memory_alloc(memory, size);
  return NativeBlock_Ctor(this, memory, processor, flags);
}

#line 151 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
NativeBlock
NativeBlock_delete(NativeBlock this)
{
  if (this != NULL) {
    Memory memory = NativeBlock_MEMORY(this);
#ifndef ECL_NDTOR
    NativeBlock_Dtor(this);
    Memory_free_(memory, this);
#endif//ECL_NDTOR
    Memory_delete(memory);
  }
  return NULL;
}

#line 165 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 246 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
bool
NativeBlock_scoreboardInstructions(NativeBlock this, Scoreboard scoreboard)
{
  int lastDate = -1;
  unsigned modified = 0;
  if (FORCE_PIPELINE > 1) {
    Pipeline_ pipeline[1];
    Memory memory = NativeBlock_MEMORY(this);
    Processor processor = NativeBlock_PROCESSOR(this);
    InstructionStack instructions = NativeBlock_INSTRUCTIONS(this);
    Pipeline_Ctor(pipeline, memory, processor, instructions);
    Pipeline_makeCritical(pipeline);
    Pipeline_schedule(pipeline);
#if 0
    Pipeline_Dtor(pipeline);
#endif
  }
  NativeBlock_FOREACH_Instruction(this, instruction) {
    int startDate = Scoreboard_tryInstruction(scoreboard, instruction);
    modified |= Scoreboard_addInstruction(scoreboard, instruction, startDate);
    if (lastDate < startDate) lastDate = startDate;
  } NativeBlock_ENDEACH_Instruction;
  *NativeBlock__LASTDATE(this) = lastDate;
  return modified != 0;
}

#line 280 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
void
NativeBlock_reorderInstructions(NativeBlock this)
{
  InstructionStack instructions = NativeBlock_INSTRUCTIONS(this);
  int32_t count = InstructionStack_count(instructions);
  void *base = InstructionStack_base_(instructions);
  HackerPtr_Sort(base, 0, count - 1, InstructionTask_compare);
  if (count != 0) {
    Instruction *instructions = (Instruction *)base;
    int span = Instruction_STARTDATE(instructions[count - 1])
             - Instruction_STARTDATE(instructions[0]) + 1;
    AIR_TRACE && fprintf(AIR_TRACE, "*** NativeBlock count=%d span=%d IPC=%g\n",
                                    count, span, (count*1.0)/span);
  }
}

#line 305 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
void
NativeBlock_assumeScheduled(NativeBlock this)
{
  int lastDate = -1;
  Except_REQUIRE(!NativeBlock_isLiterals(this));
  NativeBlock_FOREACH_Instruction(this, instruction) {
    int startDate = Instruction_STARTDATE(instruction);
    if (lastDate < startDate) lastDate = startDate;
    Except_CHECK(startDate >= 0);
  } NativeBlock_ENDEACH_Instruction;
  *NativeBlock__LASTDATE(this) = lastDate;
}

#line 324 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
void
NativeBlock_assumeUnscheduled(NativeBlock this)
{
  Except_REQUIRE(!NativeBlock_isLiterals(this));
  NativeBlock_FOREACH_Instruction(this, instruction) {
    *Instruction__STARTDATE(instruction) = -1;
  } NativeBlock_ENDEACH_Instruction;
  *NativeBlock__LASTDATE(this) = -1;
}

#line 365 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 401 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction(NativeBlock this, Instance instance,
                            const_OperandsBuffer buffer, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  Instruction_Ctor(instruction, instance, buffer, relocation);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 412 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 484 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 494 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
void
NativeBlock_bundleInstructions(NativeBlock this, PlatformUInt nativePC)
{
  PlatformUInt codeSize = 0;
  Memory memory = NativeBlock_MEMORY(this);
  int lastDate = NativeBlock_LASTDATE(this);
  bool fillEmpty = NativeBlock_FILLEMPTY(this);
  int groupCount = lastDate + 1, i = 0;
  InstructionGroup_ *groups = NULL;
  Except_REQUIRE(!NativeBlock_isLiterals(this));
  Except_REQUIRE(NativeBlock_GROUPS(this) == NULL);
  // Initialize NativeBlock_GROUPS.
  if (NativeBlock_isScheduled(this)) {
    // NativeBlock is scheduled.
    Except_CHECK(groupCount > 0);
    groups = Memory_alloc(memory, groupCount*sizeof(InstructionGroup_));
    for (i = 0; i < groupCount; i++) {
      InstructionGroup_Ctor(groups + i);
    }
    // Bucket sort the Instruction(s) into InstructionGroup(s).
    NativeBlock_FOREACH_Instruction(this, instruction) {
      int startDate = Instruction_startDate(instruction);
      InstructionGroup group = groups + startDate;
      InstructionGroup_addInstruction(group, instruction);
    } NativeBlock_ENDEACH_Instruction;
  } else {
    // NativeBlock is not scheduled.
    groupCount = InstructionStack_count(NativeBlock_INSTRUCTIONS(this));
    groups = Memory_alloc(memory, groupCount*sizeof(InstructionGroup_));
    NativeBlock_FOREACH_Instruction(this, instruction) {
      InstructionGroup group = InstructionGroup_Ctor(groups + i++);
      InstructionGroup_addInstruction(group, instruction);
    } NativeBlock_ENDEACH_Instruction;
  }
#if Bundle_ISSUE_MAX
  // Find a Template for each InstructionGroup of NativeBlock_GROUPS.
  for (i = 0; i < groupCount; i++) {
    PlatformUInt currentPC = nativePC + codeSize;
    InstructionGroup group = groups + i;
    if (InstructionGroup_COUNT(group) || fillEmpty) {
      Template template = InstructionGroup_findTemplate(group, currentPC);
      codeSize += Template_increment(template);
    }
  }
#endif//Bundle_ISSUE_MAX
  *NativeBlock__FLAGS(this) |= NativeBlockFlag_Bundled;
  *NativeBlock__GROUPCOUNT(this) = groupCount;
  *NativeBlock__GROUPS(this) = groups;
}

#line 544 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 555 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
PlatformUInt
NativeBlock_getCodeSize(NativeBlock this, PlatformUInt nativePC)
{
  PlatformUInt codeSize = nativePC;
  if (NativeBlock_isLiterals(this)) {
    NativeBlock_FOREACH_Literal(this, literal) {
      NativeType nativeType = Literal_NATIVETYPE(literal);
      size_t sizeOf = NativeType_sizeOf(nativeType);
      codeSize += sizeOf;
    } NativeBlock_ENDEACH_Literal;
  } else {
    if (NativeBlock_GROUPS(this) == NULL) {
      NativeBlock_bundleInstructions(this, nativePC);
    }
    NativeBlock_FOREACH_InstructionGroup(this, group) {
#if Bundle_ISSUE_MAX
      Template template = InstructionGroup_TEMPLATE(group);
      codeSize += Template_increment(template);
#else//!Bundle_ISSUE_MAX
      Instruction instruction = InstructionGroup_INSTRUCTION(group);
      if (instruction != NULL) {
        Instance instance = Instruction_INSTANCE(instruction);
        codeSize += Instance_increment(instance);
        Except_CHECK(Instance_increment(instance) > 0);
      }
#endif//Bundle_ISSUE_MAX
    } NativeBlock_ENDEACH_InstructionGroup;
  }
  codeSize -= nativePC;
  *NativeBlock__CODESIZE(this) = codeSize;
  return codeSize;
}

#line 597 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
void
NativeBlock_encode(NativeBlock this, PlatformUInt nativePC, void *buffer,
                   InstructionRelocationFixup instruction_fixup_function,
                   LiteralRelocationFixup literal_fixup_function,
                   void* user_data)

#line 603 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
{
  NativeStream stream = NativeBlock_NATIVESTREAM(this);
  PlatformUInt codeSize = 0;
  if (NativeBlock_isLiterals(this)) {
    NativeBlock_FOREACH_Literal(this, literal) {
      void *address = (char *)buffer + codeSize;
      PlatformUInt currentPC = nativePC + codeSize;
      codeSize += Literal_encode(literal, currentPC, address,
                                 literal_fixup_function, user_data, stream);
    } NativeBlock_ENDEACH_Literal;
  } else {
    bool fillEmpty = NativeBlock_FILLEMPTY(this);
    Except_REQUIRE(NativeBlock_isBundled(this));
    NativeBlock_FOREACH_InstructionGroup(this, group) {
#if Bundle_ISSUE_MAX
      if (InstructionGroup_COUNT(group) || fillEmpty)
#else//!Bundle_ISSUE_MAX
      Instruction instruction = InstructionGroup_INSTRUCTION(group);
      if (instruction != NULL)
#endif//Bundle_ISSUE_MAX
      {
        void *address = (char *)buffer + codeSize;
        PlatformUInt currentPC = nativePC + codeSize;
#if Bundle_ISSUE_MAX
        Template template = InstructionGroup_TEMPLATE(group);
        PlatformUInt increment = Template_increment(template);
#else//!Bundle_ISSUE_MAX
        Instance instance = Instruction_INSTANCE(instruction);
        PlatformUInt increment = Instance_increment(instance);
#endif//Bundle_ISSUE_MAX
        InstructionGroup_encode(group, currentPC, address,
                                instruction_fixup_function,
                                user_data, stream);
        codeSize += increment;
      }
    } NativeBlock_ENDEACH_InstructionGroup;
  }
  Except_ENSURE(codeSize == NativeBlock_CODESIZE(this));
}

#line 643 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 651 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
#ifndef ECL_NTRACE
bool
NativeBlock_pretty(const_NativeBlock this, FILE *file, int offset)
{
  char print[16];
  NativeStream stream = NativeBlock_NATIVESTREAM(this);
  uint8_t *codeBuffer = stream? NativeStream_CODEBUFFER(stream): NULL;
  uint8_t *encoded = codeBuffer + offset;
  NativeBlockFlags flags = NativeBlock_FLAGS(this);
  Label label = NativeBlock_LABEL(this);
  if (file == NULL) file = stderr;
  if (label != NULL) {
    const char *(*makeLabelName)(const void *Label) =
        stream?  NativeStream_MAKELABELNAME(stream): NULL;
    const char *name = makeLabelName != NULL? (*makeLabelName)(label): print;
    if (name == print) sprintf(print, "L?%p", label);
    fprintf(file, "    %s:\n", name);
  }
  if (flags != 0) {
    fputs("\t//\t", file);
    ETable_prettyFlags(NativeBlockFlag_Table, flags, "\t", file);
    fputc('\n', file);
  }
  if (NativeBlock_isLiterals(this)) {
    NativeBlock_FOREACH_Literal(this, literal) {
      ImmediateValue value = Literal_VALUE(literal);
      NativeType nativeType = Literal_NATIVETYPE(literal);
      const char *format = NativeType_format(nativeType);
      size_t width = NativeType_width(nativeType);
      size_t slice = NativeType_slice(nativeType);
      if (codeBuffer != NULL) {
        size_t codeSize = NativeType_sizeOf(nativeType);
        int i;
        fprintf(file, "%08x\t", encoded - codeBuffer);
        for (i = Encoding_SIZE_MAX - 1; i >= codeSize; i--) {
          fprintf(file, "   ");
        }
        for (i = codeSize - 1; i >= 0; i--) {
          fprintf(file, "%02x ", encoded[i]);
        }
        encoded += codeSize;
      }
      fputc('\t', file);
      if (slice == width) {
        fprintf(file, format, value);
      } else {
        int i;
        size_t slices[8];
        size_t mask = (1<<slice) - 1;
        int count = (width + slice - 1)/slice;
        Except_CHECK(count <= 8);
        if (1 /*FIXME! Platform_endian(processor) != PlatformEndian_Big*/) {
          for (i = 0; i < count; i++) {
            slices[i] = value & mask;
            value >>= slice;
          }
        } else {
          for (i = count - 1; i >= 0; i++) {
            slices[i] = value & mask;
            value >>= slice;
          }
        }
        fprintf(file, format,
                slices[0], slices[1], slices[2], slices[3],
                slices[4], slices[5], slices[6], slices[7]);
      }
      if (!Literal_isAbsolute(literal)) {
        void *handle = Literal_HANDLE(literal);
        long long offset = (long long)Literal_OFFSET(literal);
        const char *format = offset != 0? "\t# %s%+lld": "\t# %s";
        if (Literal_isLabel(literal)) {
          const char *(*makeLabelName)(const void *Label) =
              stream?  NativeStream_MAKELABELNAME(stream): NULL;
          const char* name = makeLabelName != NULL?
              (*makeLabelName)(handle): print;
          if (name == print) sprintf(print, "L?%p", handle);
          fprintf(file, format, name, offset);
        } else {
          const char *(*makeSymbolName)(const void *Symbol) =
              stream?  NativeStream_MAKESYMBOLNAME(stream): NULL;
          const char *name = makeSymbolName != NULL?
              (*makeSymbolName)(handle): print;
          if (name == print) sprintf(print, "S?%p", handle);
          fprintf(file, format, name, offset);
        }
      }
      fputc('\n', file);
    } NativeBlock_ENDEACH_Literal;
  } else if (NativeBlock_GROUPS(this) != NULL) {
    NativeBlock_FOREACH_InstructionGroup(this, group) {
#if Bundle_ISSUE_MAX
      Template template = InstructionGroup_TEMPLATE(group);
      InstructionGroup_pretty(group, file, stream, offset);
      offset += Template_increment(template);
#else//!Bundle_ISSUE_MAX
      Instruction instruction = InstructionGroup_INSTRUCTION(group);
      if (instruction != NULL) {
        Instance instance = Instruction_INSTANCE(instruction);
        InstructionGroup_pretty(group, file, stream, offset);
        offset += Instance_increment(instance);
      }
#endif//Bundle_ISSUE_MAX
      fprintf(file, ";;\n");
    } NativeBlock_ENDEACH_InstructionGroup;
  } else {
    NativeBlock_FOREACH_Instruction(this, instruction) {
      Instance instance = Instruction_INSTANCE(instruction);
      Encoding encoding = Instance_encoding(instance);
      int codeSize = Encoding_wordSize(encoding)*Encoding_wordCount(encoding), i;
      const uint8_t *encoded = (const uint8_t *)Instruction_OPCODES(instruction);
      fputc('\t', file);
      for (i = Encoding_SIZE_MAX - 1; i >= codeSize; i--) {
        fprintf(file, "   ");
      }
      for (i = codeSize - 1; i >= 0; i--) {
        fprintf(file, "%02x ", encoded[i]);
      }
      fputc('\t', file);
      Instruction_pretty(instruction, file, stream);
      fputc('\n', file);
    } NativeBlock_ENDEACH_Instruction;
  }
  return true;
}
#endif//ECL_NTRACE

#line 777 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 779 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
//FIXME! Because of target/NativeBlock.xcc
#include "MDS/MDS_.h"
#define OperandsEncode__UNDEF OperandsEncode_

#line 783 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 795 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
#ifndef ECL_NTRACE
void
NativeBlock_INIT(void)
{
  ETable_Ctor(NativeBlockFlag_Table, Memory_Root, NativeBlockFlagEntries);
}
#endif//ECL_NTRACE

#line 813 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
#ifndef ECL_NTRACE
void
NativeBlock_FINI(void)
{
  ETable_Dtor(NativeBlockFlag_Table);
}
#endif//ECL_NTRACE

#line 821 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
#if XCC__C
static void
NativeBlock_TEST(void)
{
#include "AIR/NativeBlock_.c"
}

#line 828 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeBlock.xcc"
int
main(int argc, char **argv)
{
  AIR_Test(NativeBlock_TEST);
  return 0;
}
#endif

#line 11 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_dest_src1_src2(NativeBlock this, Instance instance, Register dest, Register src1, Register src2)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)dest;
  decoded[1] = (OperandDecoded)src1;
  decoded[2] = (OperandDecoded)src2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_dest_src1_src2(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 31 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_idest_src1_isrc2(NativeBlock this, Instance instance, Register idest, Register src1, Constant isrc2, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)idest;
  decoded[1] = (OperandDecoded)src1;
  decoded[2] = (OperandDecoded)isrc2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_idest_src1_isrc2(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_idest_src1_isrc2);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 53 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_idest_src1_xsrc2(NativeBlock this, Instance instance, Register idest, Register src1, Constant xsrc2, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)idest;
  decoded[1] = (OperandDecoded)src1;
  decoded[2] = (OperandDecoded)xsrc2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_idest_src1_xsrc2(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_idest_src1_xsrc2);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 75 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_dest_bdest_src1_src2_scond(NativeBlock this, Instance instance, Register dest, Register bdest, Register src1, Register src2, Register scond)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)dest;
  decoded[1] = (OperandDecoded)bdest;
  decoded[2] = (OperandDecoded)src1;
  decoded[3] = (OperandDecoded)src2;
  decoded[4] = (OperandDecoded)scond;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_dest_bdest_src1_src2_scond(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 97 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_bdest_src1_src2(NativeBlock this, Instance instance, Register bdest, Register src1, Register src2)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)bdest;
  decoded[1] = (OperandDecoded)src1;
  decoded[2] = (OperandDecoded)src2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_bdest_src1_src2(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 117 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_ibdest_src1_isrc2(NativeBlock this, Instance instance, Register ibdest, Register src1, Constant isrc2, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)ibdest;
  decoded[1] = (OperandDecoded)src1;
  decoded[2] = (OperandDecoded)isrc2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_ibdest_src1_isrc2(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_ibdest_src1_isrc2);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 139 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_ibdest_src1_xsrc2(NativeBlock this, Instance instance, Register ibdest, Register src1, Constant xsrc2, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)ibdest;
  decoded[1] = (OperandDecoded)src1;
  decoded[2] = (OperandDecoded)xsrc2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_ibdest_src1_xsrc2(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_ibdest_src1_xsrc2);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 161 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_bcond_btarg(NativeBlock this, Instance instance, Register bcond, Constant btarg, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)bcond;
  decoded[1] = (OperandDecoded)btarg;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_bcond_btarg(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_bcond_btarg);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 182 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction__UNDEF(NativeBlock this, Instance instance)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  ;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode__UNDEF(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 200 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_idest_src1(NativeBlock this, Instance instance, Register idest, Register src1)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)idest;
  decoded[1] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_idest_src1(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 219 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_btarg(NativeBlock this, Instance instance, Constant btarg, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)btarg;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_btarg(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_btarg);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 239 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_imm(NativeBlock this, Instance instance, Constant imm)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)imm;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_imm(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 257 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_nlidest_isrc2_src1(NativeBlock this, Instance instance, Register nlidest, Constant isrc2, Register src1, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)nlidest;
  decoded[1] = (OperandDecoded)isrc2;
  decoded[2] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_nlidest_isrc2_src1(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_nlidest_isrc2_src1);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 279 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_nlidest_xsrc2_src1(NativeBlock this, Instance instance, Register nlidest, Constant xsrc2, Register src1, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)nlidest;
  decoded[1] = (OperandDecoded)xsrc2;
  decoded[2] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_nlidest_xsrc2_src1(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_nlidest_xsrc2_src1);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 301 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_idest_isrc2_src1(NativeBlock this, Instance instance, Register idest, Constant isrc2, Register src1, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)idest;
  decoded[1] = (OperandDecoded)isrc2;
  decoded[2] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_idest_isrc2_src1(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_idest_isrc2_src1);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 323 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_idest_xsrc2_src1(NativeBlock this, Instance instance, Register idest, Constant xsrc2, Register src1, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)idest;
  decoded[1] = (OperandDecoded)xsrc2;
  decoded[2] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_idest_xsrc2_src1(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_idest_xsrc2_src1);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 345 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_nldest_src1_src2(NativeBlock this, Instance instance, Register nldest, Register src1, Register src2)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)nldest;
  decoded[1] = (OperandDecoded)src1;
  decoded[2] = (OperandDecoded)src2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_nldest_src1_src2(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 365 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_nlidest_src1_isrc2(NativeBlock this, Instance instance, Register nlidest, Register src1, Constant isrc2, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)nlidest;
  decoded[1] = (OperandDecoded)src1;
  decoded[2] = (OperandDecoded)isrc2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_nlidest_src1_isrc2(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_nlidest_src1_isrc2);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 387 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_nlidest_src1_xsrc2(NativeBlock this, Instance instance, Register nlidest, Register src1, Constant xsrc2, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)nlidest;
  decoded[1] = (OperandDecoded)src1;
  decoded[2] = (OperandDecoded)xsrc2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_nlidest_src1_xsrc2(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_nlidest_src1_xsrc2);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 409 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_isrc2_src1(NativeBlock this, Instance instance, Constant isrc2, Register src1, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)isrc2;
  decoded[1] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_isrc2_src1(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_isrc2_src1);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 430 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_xsrc2_src1(NativeBlock this, Instance instance, Constant xsrc2, Register src1, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)xsrc2;
  decoded[1] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_xsrc2_src1(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_xsrc2_src1);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 451 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_sbrknum(NativeBlock this, Instance instance, Constant sbrknum)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)sbrknum;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_sbrknum(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 469 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_dest_scond_src1_src2(NativeBlock this, Instance instance, Register dest, Register scond, Register src1, Register src2)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)dest;
  decoded[1] = (OperandDecoded)scond;
  decoded[2] = (OperandDecoded)src1;
  decoded[3] = (OperandDecoded)src2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_dest_scond_src1_src2(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 490 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_idest_scond_src1_isrc2(NativeBlock this, Instance instance, Register idest, Register scond, Register src1, Constant isrc2, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)idest;
  decoded[1] = (OperandDecoded)scond;
  decoded[2] = (OperandDecoded)src1;
  decoded[3] = (OperandDecoded)isrc2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_idest_scond_src1_isrc2(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_idest_scond_src1_isrc2);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 513 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_idest_scond_src1_xsrc2(NativeBlock this, Instance instance, Register idest, Register scond, Register src1, Constant xsrc2, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)idest;
  decoded[1] = (OperandDecoded)scond;
  decoded[2] = (OperandDecoded)src1;
  decoded[3] = (OperandDecoded)xsrc2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_idest_scond_src1_xsrc2(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_idest_scond_src1_xsrc2);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 536 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_isrc2_src1_src2(NativeBlock this, Instance instance, Constant isrc2, Register src1, Register src2, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)isrc2;
  decoded[1] = (OperandDecoded)src1;
  decoded[2] = (OperandDecoded)src2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_isrc2_src1_src2(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_isrc2_src1_src2);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 558 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_xsrc2_src1_src2(NativeBlock this, Instance instance, Constant xsrc2, Register src1, Register src2, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)xsrc2;
  decoded[1] = (OperandDecoded)src1;
  decoded[2] = (OperandDecoded)src2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_xsrc2_src1_src2(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_xsrc2_src1_src2);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 580 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_dest_src2_src1(NativeBlock this, Instance instance, Register dest, Register src2, Register src1)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)dest;
  decoded[1] = (OperandDecoded)src2;
  decoded[2] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_dest_src2_src1(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 600 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_idest_scond(NativeBlock this, Instance instance, Register idest, Register scond)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)idest;
  decoded[1] = (OperandDecoded)scond;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_idest_scond(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 619 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_bdest_src1(NativeBlock this, Instance instance, Register bdest, Register src1)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)bdest;
  decoded[1] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_bdest_src1(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 638 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_dest_src2(NativeBlock this, Instance instance, Register dest, Register src2)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)dest;
  decoded[1] = (OperandDecoded)src2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_dest_src2(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 657 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_idest_isrc2(NativeBlock this, Instance instance, Register idest, Constant isrc2, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)idest;
  decoded[1] = (OperandDecoded)isrc2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_idest_isrc2(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_idest_isrc2);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 678 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_idest_xsrc2(NativeBlock this, Instance instance, Register idest, Constant xsrc2, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)idest;
  decoded[1] = (OperandDecoded)xsrc2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_idest_xsrc2(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_idest_xsrc2);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 699 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_src2(NativeBlock this, Instance instance, Register src2)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)src2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_src2(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 717 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_bdest2_src1_src2(NativeBlock this, Instance instance, Register bdest2, Register src1, Register src2)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)bdest2;
  decoded[1] = (OperandDecoded)src1;
  decoded[2] = (OperandDecoded)src2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_bdest2_src1_src2(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 737 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_dest_src1(NativeBlock this, Instance instance, Register dest, Register src1)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)dest;
  decoded[1] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_dest_src1(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 756 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_nldest_scond_src1_src2(NativeBlock this, Instance instance, Register nldest, Register scond, Register src1, Register src2)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)nldest;
  decoded[1] = (OperandDecoded)scond;
  decoded[2] = (OperandDecoded)src1;
  decoded[3] = (OperandDecoded)src2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_nldest_scond_src1_src2(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 777 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_bdest2_src1(NativeBlock this, Instance instance, Register bdest2, Register src1)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)bdest2;
  decoded[1] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_bdest2_src1(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 796 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_dest_scond(NativeBlock this, Instance instance, Register dest, Register scond)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)dest;
  decoded[1] = (OperandDecoded)scond;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_dest_scond(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 815 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_bdest2_bsrc1_bsrc2(NativeBlock this, Instance instance, Register bdest2, Register bsrc1, Register bsrc2)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)bdest2;
  decoded[1] = (OperandDecoded)bsrc1;
  decoded[2] = (OperandDecoded)bsrc2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_bdest2_bsrc1_bsrc2(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 835 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_nldest_src1(NativeBlock this, Instance instance, Register nldest, Register src1)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)nldest;
  decoded[1] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_nldest_src1(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 854 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_brknum(NativeBlock this, Instance instance, Constant brknum)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)brknum;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_brknum(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 872 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_nlidest_pcond_isrc2_src1(NativeBlock this, Instance instance, Register nlidest, Register pcond, Constant isrc2, Register src1, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)nlidest;
  decoded[1] = (OperandDecoded)pcond;
  decoded[2] = (OperandDecoded)isrc2;
  decoded[3] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_nlidest_pcond_isrc2_src1(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_nlidest_pcond_isrc2_src1);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 895 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_nlidest_pcond_xsrc2_src1(NativeBlock this, Instance instance, Register nlidest, Register pcond, Constant xsrc2, Register src1, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)nlidest;
  decoded[1] = (OperandDecoded)pcond;
  decoded[2] = (OperandDecoded)xsrc2;
  decoded[3] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_nlidest_pcond_xsrc2_src1(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_nlidest_pcond_xsrc2_src1);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 918 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_idestp_isrc2_src1(NativeBlock this, Instance instance, Register idestp, Constant isrc2, Register src1, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)idestp;
  decoded[1] = (OperandDecoded)isrc2;
  decoded[2] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_idestp_isrc2_src1(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_idestp_isrc2_src1);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 940 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_idestp_xsrc2_src1(NativeBlock this, Instance instance, Register idestp, Constant xsrc2, Register src1, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)idestp;
  decoded[1] = (OperandDecoded)xsrc2;
  decoded[2] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_idestp_xsrc2_src1(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_idestp_xsrc2_src1);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 962 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_idestp_pcond_isrc2_src1(NativeBlock this, Instance instance, Register idestp, Register pcond, Constant isrc2, Register src1, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)idestp;
  decoded[1] = (OperandDecoded)pcond;
  decoded[2] = (OperandDecoded)isrc2;
  decoded[3] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_idestp_pcond_isrc2_src1(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_idestp_pcond_isrc2_src1);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 985 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_idestp_pcond_xsrc2_src1(NativeBlock this, Instance instance, Register idestp, Register pcond, Constant xsrc2, Register src1, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)idestp;
  decoded[1] = (OperandDecoded)pcond;
  decoded[2] = (OperandDecoded)xsrc2;
  decoded[3] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_idestp_pcond_xsrc2_src1(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_idestp_pcond_xsrc2_src1);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 1008 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_idest_pcond_isrc2_src1(NativeBlock this, Instance instance, Register idest, Register pcond, Constant isrc2, Register src1, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)idest;
  decoded[1] = (OperandDecoded)pcond;
  decoded[2] = (OperandDecoded)isrc2;
  decoded[3] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_idest_pcond_isrc2_src1(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_idest_pcond_isrc2_src1);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 1031 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_idest_pcond_xsrc2_src1(NativeBlock this, Instance instance, Register idest, Register pcond, Constant xsrc2, Register src1, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)idest;
  decoded[1] = (OperandDecoded)pcond;
  decoded[2] = (OperandDecoded)xsrc2;
  decoded[3] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_idest_pcond_xsrc2_src1(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_idest_pcond_xsrc2_src1);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 1054 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_bdest2_bsrc1(NativeBlock this, Instance instance, Register bdest2, Register bsrc1)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)bdest2;
  decoded[1] = (OperandDecoded)bsrc1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_bdest2_bsrc1(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 1073 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_pcond_isrc2_src1(NativeBlock this, Instance instance, Register pcond, Constant isrc2, Register src1, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)pcond;
  decoded[1] = (OperandDecoded)isrc2;
  decoded[2] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_pcond_isrc2_src1(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_pcond_isrc2_src1);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 1095 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_pcond_xsrc2_src1(NativeBlock this, Instance instance, Register pcond, Constant xsrc2, Register src1, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)pcond;
  decoded[1] = (OperandDecoded)xsrc2;
  decoded[2] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_pcond_xsrc2_src1(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_pcond_xsrc2_src1);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 1117 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_isrc2_src1_pcond_src2(NativeBlock this, Instance instance, Constant isrc2, Register src1, Register pcond, Register src2, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)isrc2;
  decoded[1] = (OperandDecoded)src1;
  decoded[2] = (OperandDecoded)pcond;
  decoded[3] = (OperandDecoded)src2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_isrc2_src1_pcond_src2(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_isrc2_src1_pcond_src2);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 1140 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_xsrc2_src1_pcond_src2(NativeBlock this, Instance instance, Constant xsrc2, Register src1, Register pcond, Register src2, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)xsrc2;
  decoded[1] = (OperandDecoded)src1;
  decoded[2] = (OperandDecoded)pcond;
  decoded[3] = (OperandDecoded)src2;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_xsrc2_src1_pcond_src2(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_xsrc2_src1_pcond_src2);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 1163 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_isrc2_src1_src2p(NativeBlock this, Instance instance, Constant isrc2, Register src1, Register src2p, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)isrc2;
  decoded[1] = (OperandDecoded)src1;
  decoded[2] = (OperandDecoded)src2p;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_isrc2_src1_src2p(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_isrc2_src1_src2p);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 1185 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_xsrc2_src1_src2p(NativeBlock this, Instance instance, Constant xsrc2, Register src1, Register src2p, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)xsrc2;
  decoded[1] = (OperandDecoded)src1;
  decoded[2] = (OperandDecoded)src2p;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_xsrc2_src1_src2p(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_xsrc2_src1_src2p);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 1207 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_isrc2_src1_pcond_src2p(NativeBlock this, Instance instance, Constant isrc2, Register src1, Register pcond, Register src2p, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)isrc2;
  decoded[1] = (OperandDecoded)src1;
  decoded[2] = (OperandDecoded)pcond;
  decoded[3] = (OperandDecoded)src2p;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_isrc2_src1_pcond_src2p(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_isrc2_src1_pcond_src2p);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 1230 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_xsrc2_src1_pcond_src2p(NativeBlock this, Instance instance, Constant xsrc2, Register src1, Register pcond, Register src2p, Relocation relocation)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)xsrc2;
  decoded[1] = (OperandDecoded)src1;
  decoded[2] = (OperandDecoded)pcond;
  decoded[3] = (OperandDecoded)src2p;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_xsrc2_src1_pcond_src2p(buffer, Instruction_OPCODES(instruction));
  InstructionRelocatable_Ctor(Instruction_RELOCATABLE(instruction),
                              buffer, relocation, Operands_st200_xsrc2_src1_pcond_src2p);
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 1253 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_bdest2_src2_src1(NativeBlock this, Instance instance, Register bdest2, Register src2, Register src1)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)bdest2;
  decoded[1] = (OperandDecoded)src2;
  decoded[2] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_bdest2_src2_src1(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}

#line 1273 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/st200/NativeBlock.xcc"
Instruction
NativeBlock_makeInstruction_st200_dest_scond_src2_src1(NativeBlock this, Instance instance, Register dest, Register scond, Register src2, Register src1)
{
  Memory memory = NativeBlock_MEMORY(this);
  Instruction instruction = Memory_alloc(memory, sizeof(Instruction_));
  OperandsBuffer_ buffer_, *buffer = &buffer_;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  decoded[0] = (OperandDecoded)dest;
  decoded[1] = (OperandDecoded)scond;
  decoded[2] = (OperandDecoded)src2;
  decoded[3] = (OperandDecoded)src1;
  Instruction_Ctor(instruction, instance, NULL, Relocation__UNDEF);
  OperandsEncode_st200_dest_scond_src2_src1(buffer, Instruction_OPCODES(instruction));
  InstructionStack_push2(NativeBlock_INSTRUCTIONS(this), instruction);
  return instruction;
}


#endif//NativeBlock_c_INCLUDED
