#ifndef NativeStream_c_INCLUDED
#define NativeStream_c_INCLUDED

#line 15 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
#include "AIR/AIR_.h"

#line 20 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 39 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
NativeStream
NativeStream_Ctor(NativeStream this,
                  Memory memory, int32_t aboutBlocks)
{
  ConstantList_Ctor(NativeStream_LABELS(this), memory);
  ConstantList_Ctor(NativeStream_SYMBOLS(this), memory);
  IDList_Ctor(NativeStream_NATIVEBLOCKS(this), memory);
  *NativeStream__NATIVEPC(this) = 0;
  *NativeStream__CODESIZE(this) = 0;
  *NativeStream__CODEBUFFER(this) = NULL;
  *NativeStream__MAKELABELNAME(this) =
      (const char *(*)(const void *))Label_name;
  *NativeStream__MAKESYMBOLNAME(this) =
      (const char *(*)(const void *))Symbol_name;
  return this;
}

#line 56 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
void
NativeStream_Dtor(NativeStream this)
{
  ConstantList_Dtor(NativeStream_LABELS(this));
  ConstantList_Dtor(NativeStream_SYMBOLS(this));
  IDList_empty(NativeStream_NATIVEBLOCKS(this),
               (IDListItemRelease)NativeBlock_Dtor);
  IDList_Dtor(NativeStream_NATIVEBLOCKS(this));
}

#line 66 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
size_t
NativeStream_Size(Memory memory, int32_t aboutBlocks)
{
  return sizeof(NativeStream_);
}

#line 86 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
#ifndef NativeStream_POOLED
#define NativeStream_POOLED 128
#endif//NativeStream_POOLED

#line 90 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
NativeStream
NativeStream_new(Memory parent, int32_t aboutBlocks)
{
  Memory memory = Memory_new(parent, NativeStream_POOLED);
  size_t size = NativeStream_Size(memory, aboutBlocks);
  NativeStream this = Memory_alloc(memory, size);
  return NativeStream_Ctor(this, memory, aboutBlocks);
}

#line 105 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
NativeStream
NativeStream_delete(NativeStream this)
{
  if (this != NULL) {
    Memory memory = NativeStream_MEMORY(this);
#ifndef ECL_NDTOR
    NativeStream_Dtor(this);
    Memory_free_(memory, this);
#endif//ECL_NDTOR
    Memory_delete(memory);
  }
  return NULL;
}

#line 119 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 152 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 185 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 215 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
struct NativeBlock_ *
NativeStream_pushNativeBlock(NativeStream this, Processor processor,
                             NativeBlockFlags flags, Label label)
{
  Memory memory = NativeStream_MEMORY(this);
  size_t size = NativeBlock_Size(memory, processor, flags);
  IDList nativeBlocks = NativeStream_NATIVEBLOCKS(this);
  NativeBlock nativeBlock = IDList_push(nativeBlocks, size);
  NativeBlock_Ctor(nativeBlock, memory, processor, flags);
  *NativeBlock__NATIVESTREAM(nativeBlock) = this;
  if (label != NULL) {
    *NativeBlock__LABEL(nativeBlock) = label;
  }
  return nativeBlock;
}

#line 231 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 258 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
void
NativeStream_setMakeLabelName(NativeStream this,
                              const char *(*makeLabelName)(const void *Label))
{
  *NativeStream__MAKELABELNAME(this) = makeLabelName;
}

#line 272 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
void
NativeStream_setMakeSymbolName(NativeStream this,
                               const char *(*makeSymbolName)(const void *Symbol))
{
  *NativeStream__MAKESYMBOLNAME(this) = makeSymbolName;
}

#line 279 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 290 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
void
NativeStream_scoreboardInstructions(NativeStream this, int windowSize)
{
  Processor processor = Processor__UNDEF;
  Memory memory = NativeStream_MEMORY(this);
  Scoreboard_ scoreboard_, *scoreboard = NULL;
  NativeStream_FOREACH_NativeBlock(this, nativeBlock) {
    if (NativeBlock_isLiterals(nativeBlock)) continue;
    if (processor != NativeBlock_PROCESSOR(nativeBlock)) {
      processor = NativeBlock_PROCESSOR(nativeBlock);
      if (scoreboard != NULL) Scoreboard_Dtor(scoreboard);
      scoreboard = Scoreboard_Ctor(&scoreboard_, memory, processor, windowSize);
    }
    Scoreboard_reset(scoreboard, 0);
    NativeBlock_scoreboardInstructions(nativeBlock, scoreboard);
  } NativeStream_ENDEACH_NativeBlock;
  if (scoreboard != NULL) Scoreboard_Dtor(scoreboard);
}

#line 318 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
void
NativeStream_assumeScheduled(NativeStream this)
{
  NativeStream_FOREACH_NativeBlock(this, nativeBlock) {
    if (NativeBlock_isLiterals(nativeBlock)) continue;
    NativeBlock_assumeScheduled(nativeBlock);
  } NativeStream_ENDEACH_NativeBlock;
}

#line 336 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
void
NativeStream_assumeUnscheduled(NativeStream this)
{
  NativeStream_FOREACH_NativeBlock(this, nativeBlock) {
    if (NativeBlock_isLiterals(nativeBlock)) continue;
    NativeBlock_assumeUnscheduled(nativeBlock);
  } NativeStream_ENDEACH_NativeBlock;
}

#line 345 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 356 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
PlatformUInt
NativeStream_getCodeSize(NativeStream this, PlatformUInt nativePC)
{
  PlatformUInt codeSize = 0;
  *NativeStream__NATIVEPC(this) = nativePC;
  NativeStream_FOREACH_NativeBlock(this, nativeBlock) {
    // Compute the code size for the nativeBlock, implying bundling.
    nativePC += NativeBlock_getCodeSize(nativeBlock, nativePC);
  } NativeStream_ENDEACH_NativeBlock;
  codeSize = nativePC - NativeStream_NATIVEPC(this);
  *NativeStream__CODESIZE(this) = codeSize;
  return codeSize;
}

#line 382 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
void
NativeStream_encode(NativeStream this,
                    PlatformUInt nativePC, void *codeBuffer,
                    InstructionRelocationFixup instruction_fixup_function,
                    LiteralRelocationFixup literal_fixup_function,
                    void* user_data)
{
  *NativeStream__NATIVEPC(this) = nativePC;
  *NativeStream__CODEBUFFER(this) = codeBuffer;
  Except_REQUIRE(NativeStream_CODESIZE(this) != 0);
  // Resolve this NativeStream Symbol Constant(s).
  NativeStream_SYMBOLS_FOREACH_Constant(this, constant) {
    Symbol symbol = Constant_symbol(constant);
    ImmediateValue value = Symbol_value(symbol);
    Constant_setValue(constant, value + Constant_offset(constant));
  } NativeStream_SYMBOLS_ENDEACH_Constant;
  // Resolve this NativeStream Label Constant(s).
  NativeStream_FOREACH_NativeBlock(this, nativeBlock) {
    Label label = NativeBlock_LABEL(nativeBlock);
    if (label != NULL) Label_setValue(label, nativePC);
    nativePC += NativeBlock_CODESIZE(nativeBlock);
  } NativeStream_ENDEACH_NativeBlock;
  // Resolve this NativeStream Label Constant(s).
  NativeStream_LABELS_FOREACH_Constant(this, constant) {
    Label label = Constant_label(constant);
    ImmediateValue value = Label_value(label);
    Constant_setValue(constant, value + Constant_offset(constant));
  } NativeStream_LABELS_ENDEACH_Constant;
  // Resolve all NativeBlock Symbol and Label Literal(s).
  NativeStream_FOREACH_NativeBlock(this, nativeBlock) {
    if (NativeBlock_isLiterals(nativeBlock)) {
      NativeBlock_FOREACH_Literal(nativeBlock, literal) {
        if (Literal_isSymbol(literal)) {
          Symbol symbol = Literal_symbol(literal);
          ImmediateValue value = Symbol_value(symbol);
          Literal_setValue(literal, value + Literal_offset(literal));
        } else if (Literal_isLabel(literal)) {
          Label label = Literal_label(literal);
          ImmediateValue value = Label_value(label);
          Literal_setValue(literal, value + Literal_offset(literal));
        }
      } NativeBlock_ENDEACH_Literal;
    }
  } NativeStream_ENDEACH_NativeBlock;
  // Encode this NativeStream NativeBlock Instruction(s).
  nativePC = NativeStream_NATIVEPC(this);
  NativeStream_FOREACH_NativeBlock(this, nativeBlock) {
    PlatformUInt codeSize = NativeBlock_CODESIZE(nativeBlock);
    NativeBlock_encode(nativeBlock, nativePC, codeBuffer,
                       instruction_fixup_function, literal_fixup_function,
                       user_data);
    codeBuffer = (char *)codeBuffer + codeSize;
    nativePC += codeSize;
  } NativeStream_ENDEACH_NativeBlock;
}

#line 438 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 446 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
#ifndef ECL_NTRACE
bool
NativeStream_pretty(const_NativeStream this, FILE *file)
{
  PlatformUInt offset = 0;
  if (file == NULL) file = stderr;
  NativeStream_FOREACH_NativeBlock(this, nativeBlock) {
    NativeBlock_pretty(nativeBlock, file, offset);
    offset += NativeBlock_CODESIZE(nativeBlock);
    fprintf(file, "\n");
  } NativeStream_ENDEACH_NativeBlock;
  return true;
}
#endif//ECL_NTRACE

#line 461 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 473 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
#if XCC__C
static void
NativeStream_TEST(void)
{
#include "AIR/NativeStream_.c"
}

#line 480 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/NativeStream.xcc"
int
main(int argc, char **argv)
{
  AIR_Test(NativeStream_TEST);
  return 0;
}
#endif


#endif//NativeStream_c_INCLUDED
