#ifndef Allocator_c_INCLUDED
#define Allocator_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Allocator.xcc"
#include "CGO/CGO_.h"

#line 21 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Allocator.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 32 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Allocator.xcc"
Allocator
Allocator_Ctor(Allocator this,
               Memory memory, CodeRegion codeRegion)
{
  *Allocator__MEMORY(this) = memory;
  *Allocator__CODEREGION(this) = codeRegion;
  return this;
}

#line 41 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Allocator.xcc"
void
Allocator_Dtor(Allocator this)
{
}

#line 46 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Allocator.xcc"
size_t
Allocator_Size(Memory memory, CodeRegion codeRegion)
{
  return sizeof(Allocator_);
}

#line 61 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Allocator.xcc"
#ifndef Allocator_POOLED
#define Allocator_POOLED 128
#endif//Allocator_POOLED

#line 65 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Allocator.xcc"
Allocator
Allocator_new(Memory parent, CodeRegion codeRegion)
{
  Memory memory = Memory_new(parent, Allocator_POOLED);
  size_t size = Allocator_Size(memory, codeRegion);
  Allocator this = Memory_alloc(memory, size);
  return Allocator_Ctor(this, memory, codeRegion);
}

#line 78 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Allocator.xcc"
Allocator
Allocator_delete(Allocator this)
{
  if (this != NULL) {
    Memory memory = Allocator_MEMORY(this);
#ifndef ECL_NDTOR
    Allocator_Dtor(this);
    Memory_free_(memory, this);
#endif//ECL_NDTOR
    Memory_delete(memory);
  }
  return NULL;
}

#line 92 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Allocator.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 100 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Allocator.xcc"
Memory
Allocator_memory(Allocator this)
{
  return Allocator_MEMORY(this);
}

#line 112 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Allocator.xcc"
CodeRegion
Allocator_codeRegion(Allocator this)
{
  return Allocator_CODEREGION(this);
}

#line 124 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Allocator.xcc"
#ifndef ECL_NTRACE
bool
Allocator_pretty(Allocator this, FILE *file)
{
  if (file == NULL) file = stderr;
  return true;
}
#endif//ECL_NTRACE

#line 133 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Allocator.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 145 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Allocator.xcc"
#if XCC__C
static void
Allocator_TEST(void)
{
#include "CGO/Allocator_.c"
}

#line 152 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Allocator.xcc"
int
main(int argc, char **argv)
{
  CGO_Test(Allocator_TEST);
  return 0;
}
#endif


#endif//Allocator_c_INCLUDED
