#ifndef CGO_c_INCLUDED
#define CGO_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/CGO.xcc"
#include "CGO/CGO_.h"

#line 29 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/CGO.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 76 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/CGO.xcc"
#undef CGO_TRACE 
FILE *CGO_TRACE = NULL;

#line 89 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/CGO.xcc"
static int CGO_Initialized = 0;

#line 91 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/CGO.xcc"
void
CGO_INIT(void)
{
  if (CGO_Initialized++ == 0) {
    if (GETENV("CGO_TRACE")) {
      int file = 0;
      sscanf(GETENV("CGO_TRACE"), "%d", &file);
      if (file == 1) CGO_TRACE = stdout;
      else if (file == 2) CGO_TRACE = stderr;
    }
    CCL_INIT();
    MDS_INIT();
    AIR_INIT();
    LIR_INIT();
    PFA_INIT();
    ControlFlow_INIT();
    Predicator_INIT();
    Pipeliner_INIT();
    Allocator_INIT();
    ELinearScan_INIT();
    DomTreeScan_INIT();
    Scoreboarder_INIT();
  }
}

#line 122 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/CGO.xcc"
void
CGO_FINI(void)
{
  if (--CGO_Initialized == 0) {
    Scoreboarder_FINI();
    DomTreeScan_FINI();
    ELinearScan_FINI();
    Allocator_FINI();
    Pipeliner_FINI();
    Predicator_FINI();
    ControlFlow_FINI();
    PFA_FINI();
    LIR_FINI();
    AIR_FINI();
    MDS_FINI();
    CCL_FINI();
  }
}

#line 147 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/CGO.xcc"
void
CGO_Test(void (*test)(void))
{
  CGO_INIT();
  (*test)();
  CGO_FINI();
}

#line 155 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/CGO.xcc"
#if XCC__C
static void
CGO_TEST(void)
{
#include "CGO/CGO_.c"
}

#line 162 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/CGO.xcc"
int
main(int argc, char **argv)
{
  CGO_Test(CGO_TEST);
  return 0;
}
#endif


#endif//CGO_c_INCLUDED
