#ifndef ControlFlow__c_INCLUDED
#define ControlFlow__c_INCLUDED

#line 80 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/ControlFlow.xcc"
//
{
  printf("sizeof(ControlFlow_) = %d\n", sizeof(ControlFlow_));
}

#line 466 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/ControlFlow.xcc"
//
{
  // Testing the CLEAN algorithm
  Program program = Program_new(Memory_Root);
  Memory memory = Program_memory(program);
  SymbolTable symbolTable = Program_symbolTable(program);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "lost-copy");
  Procedure procedure = Program_makeProcedure(program, symbol);
  LabelTable labelTable = Program_labelTable(program);
  Label L1 = LabelTable_lookup(labelTable, 1, "L1");
  Label L2 = LabelTable_lookup(labelTable, 2, "L2");
  Label L3 = LabelTable_lookup(labelTable, 3, "L3");
  Label L4 = LabelTable_lookup(labelTable, 4, "L4");
  Label L5 = LabelTable_lookup(labelTable, 5, "L5");
  Label L6 = LabelTable_lookup(labelTable, 6, "L6");
  Label L7 = LabelTable_lookup(labelTable, 7, "L7");
  Label L8 = LabelTable_lookup(labelTable, 8, "L8");
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l5 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l6 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l7 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l8 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  BasicBlock_addLabels(block_l2, 1, &L2);
  BasicBlock_addLabels(block_l3, 1, &L3);
  BasicBlock_addLabels(block_l4, 1, &L4);
  BasicBlock_addLabels(block_l5, 1, &L5);
  BasicBlock_addLabels(block_l6, 1, &L6);
  BasicBlock_addLabels(block_l7, 1, &L7);
  BasicBlock_addLabels(block_l8, 1, &L8);
  BasicBlock_makeEdge(block_l1, block_l2, 0.5);
  BasicBlock_makeEdge(block_l1, block_l2, 0.5);
  BasicBlock_makeEdge(block_l2, block_l3, 0.5);
  BasicBlock_makeEdge(block_l2, block_l5, 0.5);
  BasicBlock_makeEdge(block_l3, block_l4, 1.0);
  BasicBlock_makeEdge(block_l4, block_l7, 1.0);
  BasicBlock_makeEdge(block_l5, block_l7, 0.5);
  BasicBlock_makeEdge(block_l5, block_l6, 0.5);
  BasicBlock_makeEdge(block_l7, block_l8, 1.0);
  BasicBlock_makeEdge(block_l6, block_l8, 1.0);
  Procedure_buildCodeRegions(procedure);
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Temporary temporary_x = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_a1 = Procedure_makeAbsoluteTemporary(procedure, 1, Relocation__UNDEF);
    Temporary temporary_l2 = Procedure_makeLabelTemporary(procedure, L2, 0, Relocation__UNDEF);
    Temporary temporary_l5 = Procedure_makeLabelTemporary(procedure, L5, 0, Relocation__UNDEF);
    Temporary temporary_l6 = Procedure_makeLabelTemporary(procedure, L6, 0, Relocation__UNDEF);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l1), temporary_x, temporary_a1);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l2), temporary_x, temporary_a1);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l3), temporary_x, temporary_a1);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l5), temporary_x, temporary_a1);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l6), temporary_x, temporary_a1);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l8), temporary_x, temporary_a1);
    Selector_makeOperation_0_2(BasicBlock_selector(block_l1),
                               Operator_GOTRUE, temporary_x, temporary_l2);
    Selector_makeOperation_0_2(BasicBlock_selector(block_l2),
                               Operator_GOTRUE, temporary_x, temporary_l5);
    Selector_makeOperation_0_2(BasicBlock_selector(block_l5),
                               Operator_GOTRUE, temporary_x, temporary_l6);
    CodeRegion_pretty(codeRegion, stdout);
    printf("\n*** Prior to cleaning the CodeRegion ***\n");
    {
      ControlFlow controlFlow = ControlFlow_new(memory, codeRegion);
      ControlFlow_clean(controlFlow);
      ControlFlow_delete(controlFlow);
    }
    printf("\n*** After cleaning the CodeRegion ***\n");
    CodeRegion_pretty(codeRegion, stdout);
  }
}

#line 1118 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/ControlFlow.xcc"
//
{
  // Testing the Pettis-Hansen algorithm
  Program program = Program_new(Memory_Root);
  Memory memory = Program_memory(program);
  SymbolTable symbolTable = Program_symbolTable(program);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "lost-copy");
  Procedure procedure = Program_makeProcedure(program, symbol);
  LabelTable labelTable = Program_labelTable(program);
  Label L1 = LabelTable_lookup(labelTable, 1, "L1");
  Label L2 = LabelTable_lookup(labelTable, 2, "L2");
  Label L3 = LabelTable_lookup(labelTable, 3, "L3");
  Label L4 = LabelTable_lookup(labelTable, 4, "L4");
  Label L5 = LabelTable_lookup(labelTable, 5, "L5");
  Label L6 = LabelTable_lookup(labelTable, 6, "L6");
  Label L7 = LabelTable_lookup(labelTable, 7, "L7");
  Label L8 = LabelTable_lookup(labelTable, 8, "L8");
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 100.0);
  BasicBlock block_l2 = Procedure_makeBasicBlock(procedure, 0, 0, 100.0);
  BasicBlock block_l3 = Procedure_makeBasicBlock(procedure, 0, 0, 100.0);
  BasicBlock block_l4 = Procedure_makeBasicBlock(procedure, 0, 0, 100.0);
  BasicBlock block_l5 = Procedure_makeBasicBlock(procedure, 0, 0, 100.0);
  BasicBlock block_l6 = Procedure_makeBasicBlock(procedure, 0, 0, 100.0);
  BasicBlock block_l7 = Procedure_makeBasicBlock(procedure, 0, 0, 100.0);
  BasicBlock block_l8 = Procedure_makeBasicBlock(procedure, 0, 0, 100.0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  BasicBlock_addLabels(block_l2, 1, &L2);
  BasicBlock_addLabels(block_l3, 1, &L3);
  BasicBlock_addLabels(block_l4, 1, &L4);
  BasicBlock_addLabels(block_l5, 1, &L5);
  BasicBlock_addLabels(block_l6, 1, &L6);
  BasicBlock_addLabels(block_l7, 1, &L7);
  BasicBlock_addLabels(block_l8, 1, &L8);
  BasicBlock_makeEdge(block_l1, block_l2, 1.0);
  BasicBlock_makeEdge(block_l2, block_l3, 0.5);
  BasicBlock_makeEdge(block_l2, block_l5, 0.5);
  BasicBlock_makeEdge(block_l3, block_l4, 1.0);
  BasicBlock_makeEdge(block_l4, block_l7, 1.0);
  BasicBlock_makeEdge(block_l5, block_l7, 0.5);
  BasicBlock_makeEdge(block_l5, block_l6, 0.5);
  BasicBlock_makeEdge(block_l7, block_l8, 1.0);
  BasicBlock_makeEdge(block_l6, block_l8, 1.0);
  Procedure_setEntryBlock(procedure, block_l1);
  Procedure_setExitBlock(procedure, block_l8);
  Procedure_buildCodeRegions(procedure);
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Temporary temporary_x = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_a1 = Procedure_makeAbsoluteTemporary(procedure, 1, Relocation__UNDEF);
    Temporary temporary_l2 = Procedure_makeLabelTemporary(procedure, L2, 0, Relocation__UNDEF);
    Temporary temporary_l5 = Procedure_makeLabelTemporary(procedure, L5, 0, Relocation__UNDEF);
    Temporary temporary_l6 = Procedure_makeLabelTemporary(procedure, L6, 0, Relocation__UNDEF);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l1), temporary_x, temporary_a1);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l2), temporary_x, temporary_a1);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l3), temporary_x, temporary_a1);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l5), temporary_x, temporary_a1);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l6), temporary_x, temporary_a1);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l8), temporary_x, temporary_a1);
    Selector_makeOperation_0_2(BasicBlock_selector(block_l2),
                               Operator_GOTRUE, temporary_x, temporary_l5);
    Selector_makeOperation_0_2(BasicBlock_selector(block_l5),
                               Operator_GOTRUE, temporary_x, temporary_l6);
    printf("\n*** Prior to positioning ***\n");
    CodeRegion_pretty(codeRegion, stdout);
    {
      ControlFlow controlFlow = ControlFlow_new(memory, codeRegion);
      printf ("Original Pettis-Hansen code ordering\n\n");
      ControlFlow_bottomUpOrderCode(controlFlow);
      CodeRegion_pretty(codeRegion, stdout);
      printf ("\n\nReverse postorder code ordering\n\n");
      ControlFlow_reversePostOrderCode(controlFlow);
      CodeRegion_pretty(codeRegion, stdout);
      printf ("\n\nPettis-Hansen + reverse postorder code ordering\n\n");
      ControlFlow_bottomUpPostorder(controlFlow);
      CodeRegion_pretty(codeRegion, stdout);
      ControlFlow_delete(controlFlow);
    }
  }
}

#line 1383 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/ControlFlow.xcc"
//
if (0) {
  // Example graph of atoi function to test BB frequency computation taken from 
  // Y. Wu, J. R. Larus "Static Branch Frequency and Program Profile Analysis"
  Symbol_ symbol_;
  Program program = Program_new(Memory_Root);
  Procedure procedure = Program_makeProcedure(program, &symbol_);
  BasicBlock block_1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_5 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_6 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_makeEdge(block_1, block_2, 0.948);
  BasicBlock_makeEdge(block_1, block_6, 0.052);
  BasicBlock_makeEdge(block_2, block_3, 0.885);
  BasicBlock_makeEdge(block_2, block_5, 0.115);
  BasicBlock_makeEdge(block_3, block_4, 1.0);
  BasicBlock_makeEdge(block_4, block_4, 0.88);
  BasicBlock_makeEdge(block_4, block_5, 0.12);
  Procedure_setEntryBlock(procedure, block_1);
  Procedure_buildCodeRegions(procedure);
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    ControlFlow controlFlow = ControlFlow_new(Memory_Root, codeRegion);
    printf("\n\n Testing Block Frequency computation : atoi():\n");
    CodeRegion_pretty(codeRegion, stdout);
    ControlFlow_computeBlockFrequency(controlFlow);
    printf("\n\n After frequency computation :\n");
    CodeRegion_pretty(codeRegion, stdout);
  }
  Program_delete(program);
}

#line 1417 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/ControlFlow.xcc"
//
if (0) {
  Symbol_ symbol_;
  Program program = Program_new(Memory_Root);
  Procedure procedure = Program_makeProcedure(program, &symbol_);
  // Example taken from F. Bourdoncle's PhD thesis ``Semantique des langages
  // imperatifs d'ordre superieur et interpretation abstraite'', 1992, Figure
  // 3.6 at page 39.
  // Expected frequencies at output:
  //   block_1 : 1.0
  //   block_2 : 2.185512695
  //   block_3 : 2.140869141
  //   block_4 : 1.0
  BasicBlock block_1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_makeEdge(block_1, block_2, 0.43);
  BasicBlock_makeEdge(block_1, block_3, 0.57);
  BasicBlock_makeEdge(block_2, block_3, 0.72);
  BasicBlock_makeEdge(block_2, block_4, 0.28);
  BasicBlock_makeEdge(block_3, block_2, 0.82);
  BasicBlock_makeEdge(block_3, block_4, 0.18);
  Procedure_setEntryBlock(procedure, block_1);
  Procedure_buildCodeRegions(procedure);
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    ControlFlow controlFlow = ControlFlow_new(Memory_Root, codeRegion);
    printf("\n\n Testing Block Frequency computation : Irreducible loop:\n");
    CodeRegion_pretty(codeRegion, stdout);
    ControlFlow_computeBlockFrequency(controlFlow);
    printf("\n\n After frequency computation :\n");
    CodeRegion_pretty(codeRegion, stdout);
  }
  Program_delete(program);
}


#endif//ControlFlow__c_INCLUDED
