#ifndef ControlFlow__h_INCLUDED
#define ControlFlow__h_INCLUDED

//
#include "CGO/ControlFlow.h"

//
struct ControlFlow_ {
  //@args	Memory memory, CodeRegion codeRegion
  CodeRegion CODEREGION;
  PQueue CP_WORKLIST;
  Sparse CP_CHAINS;
  uintptr_t *CP_BLOCK_PRIO;
  PQueue CP_EDGE_QUEUE;
  uintptr_t *CP_EDGE_PRIO;
  bool *CP_RPO_VISITED;   // Used by code ordering and BB frequency calculation
  LoopForest LOOP_FOREST;
  BasicBlockStack_ CP_RPO_STACK_;
  //@access CP_RPO_STACK	ControlFlow__CP_RPO_STACK_(this)
  IStack_ PROBABILITYMAP_;
    //@access PROBABILITYMAP	ControlFlow__PROBABILITYMAP_(this)
    //@access MEMORY	IStack_memory(ControlFlow_PROBABILITYMAP(this))
    //@access PROBABILITIES	(float *)IStack_base(ControlFlow_PROBABILITYMAP(this))
};

extern ControlFlow
ControlFlow_Ctor(ControlFlow this, Memory memory, CodeRegion codeRegion);

extern ControlFlow
ControlFlow_Copy(ControlFlow this, const_ControlFlow that);

extern void
ControlFlow_Dtor(ControlFlow this);

extern size_t
ControlFlow_Size(Memory memory, CodeRegion codeRegion);

#define ControlFlow_CODEREGION(this) ((this)->CODEREGION)
#define ControlFlow__CODEREGION(this) (&(this)->CODEREGION)
#define ControlFlow_CP_WORKLIST(this) ((this)->CP_WORKLIST)
#define ControlFlow__CP_WORKLIST(this) (&(this)->CP_WORKLIST)
#define ControlFlow_CP_CHAINS(this) ((this)->CP_CHAINS)
#define ControlFlow__CP_CHAINS(this) (&(this)->CP_CHAINS)
#define ControlFlow_CP_BLOCK_PRIO(this) ((this)->CP_BLOCK_PRIO)
#define ControlFlow__CP_BLOCK_PRIO(this) (&(this)->CP_BLOCK_PRIO)
#define ControlFlow_CP_EDGE_QUEUE(this) ((this)->CP_EDGE_QUEUE)
#define ControlFlow__CP_EDGE_QUEUE(this) (&(this)->CP_EDGE_QUEUE)
#define ControlFlow_CP_EDGE_PRIO(this) ((this)->CP_EDGE_PRIO)
#define ControlFlow__CP_EDGE_PRIO(this) (&(this)->CP_EDGE_PRIO)
#define ControlFlow_CP_RPO_VISITED(this) ((this)->CP_RPO_VISITED)
#define ControlFlow__CP_RPO_VISITED(this) (&(this)->CP_RPO_VISITED)
#define ControlFlow_LOOP_FOREST(this) ((this)->LOOP_FOREST)
#define ControlFlow__LOOP_FOREST(this) (&(this)->LOOP_FOREST)
#define ControlFlow_CP_RPO_STACK_(this) ((this)->CP_RPO_STACK_)
#define ControlFlow__CP_RPO_STACK_(this) (&(this)->CP_RPO_STACK_)
#define ControlFlow_PROBABILITYMAP_(this) ((this)->PROBABILITYMAP_)
#define ControlFlow__PROBABILITYMAP_(this) (&(this)->PROBABILITYMAP_)
#define ControlFlow_PROBABILITIES(this) ((float *)IStack_base(ControlFlow_PROBABILITYMAP(this)))
#define ControlFlow_MEMORY(this) (IStack_memory(ControlFlow_PROBABILITYMAP(this)))
#define ControlFlow_CP_RPO_STACK(this) (ControlFlow__CP_RPO_STACK_(this))
#define ControlFlow_PROBABILITYMAP(this) (ControlFlow__PROBABILITYMAP_(this))


/*
 * ControlFlow_INIT --	Initialize the ControlFlow module.
 */
void
ControlFlow_INIT(void);

/*
 * ControlFlow_FINI --	Finalize the ControlFlow module.
 */
void
ControlFlow_FINI(void);


#endif//ControlFlow__h_INCLUDED
