#ifndef ParallelCopy_h_INCLUDED
#define ParallelCopy_h_INCLUDED

/*
 * !!!!	ParallelCopy.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 * Francois de Ferriere (Francois.de-Ferriere@st.com).
 * Christophe Guillon (Christophe.Guillon@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * ParallelCopy_resolveDuplication -- Takes a colored coderegion and resolves
 * all duplications in parallel copies or equivalent operations (set of phis).
 * The purpose is to leave resersal parallel copies instead of non-reversal ones.
 * Parameter regFile is used to select regFile to be considered. Set
 * RegFile__UNDEF to consider all register files
 */
extern bool
ParallelCopy_resolveDuplication(CodeRegion codeRegion, RegFile regFile);


#endif//ParallelCopy_h_INCLUDED
