#ifndef ParallelCopy__c_INCLUDED
#define ParallelCopy__c_INCLUDED

#line 1092 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/ParallelCopy.xcc"
//
{
#ifdef MDS_FAMILY_st200
  Program programTmp = Program_new(Memory_Root);
  Memory memory = Program_memory(programTmp);
  SymbolTable symbolTable = Program_symbolTable(programTmp);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "parCopy");
  Procedure procedure = Program_makeProcedure(programTmp, symbol);
  LabelTable labelTable = Program_labelTable(programTmp);
  Label L1 = LabelTable_lookup(labelTable, 1, "L1");
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 1.0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  Procedure_buildCodeRegions(procedure);
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Temporary temporary_resR0 = Procedure_makeAssignedTemporary(procedure,
                                                                Register_st200_GR0);
    Temporary temporary_resR1 = Procedure_makeAssignedTemporary(procedure,
                                                                Register_st200_GR1);
    Temporary temporary_resR3 = Procedure_makeAssignedTemporary(procedure,
                                                                Register_st200_GR3);
    Temporary temporary_argR2 = Procedure_makeAssignedTemporary(procedure,
                                                                Register_st200_GR2);
    Temporary temporary_argR1 = Procedure_makeAssignedTemporary(procedure,
                                                                Register_st200_GR1);
    Operation parCopy = BasicBlock_makeOperationPCOPY(block_l1, NULL, true, 3,
                                                      1);
    bool result;
    Operation_addtoParCopy(parCopy, temporary_resR0, temporary_argR2); 
    Operation_addtoParCopy(parCopy, temporary_resR1, temporary_argR2);
    Operation_addtoParCopy(parCopy, temporary_resR3, temporary_argR1);
    CodeRegion_makeGlobalTable(codeRegion, TemporaryFlag_Constant, 0);
    result = ParallelCopy_resolveDuplication(codeRegion, RegFile__UNDEF);
    // Duplication scheme is:
    // R2
    // | \    .
    // R1 R0
    // |
    // R3
    // Best way to solve the duplication is removing the R2 to R0 arc.
    // This is done by doing the copy before the parallel copy.
    // Excepted result is:
    // R0 = mov R2
    // R2
    // |     
    // R1  R0
    // |  |  \  // <- edge on itself
    // R3  \_/
    // Check we have that.
    if(result) {
      Temporary temporary_argR0 = NULL;
      result = false;
      BasicBlock_FOREACH_Operation(block_l1, operation) {
        if(operation == parCopy && temporary_argR0 != NULL) {
          bool okTempR0 = false;
          bool okTempR1 = false;
          bool okTempR3 = false;
          Operation_RESULTS_FOREACH_Temporary(operation, tempRes) {
            Temporary arg =
              Operation_getArgument(operation, Operation_RESULTS_INDEX);
            if(tempRes == temporary_resR1 && arg == temporary_argR2) {
              okTempR1 ^= true;
              if(!okTempR1) {
                break;
              }
            } else if(tempRes == temporary_resR3 && arg == temporary_argR1) {
              okTempR3 ^= true;
              if(!okTempR3) {
                break;
              }
            } else if(tempRes == temporary_resR0 && arg == temporary_argR0) {
              okTempR0 ^= true;
              if(!okTempR0) {
                break;
              }
            }
          } Operation_RESULTS_ENDEACH_Temporary;
          result = okTempR0 & okTempR1 & okTempR3;
        } else if(Operator_isSeqCopy(Operation_operator(operation))
                  && Operation_getArgument(operation, 0) == temporary_argR2
                  && Temporary_register(Operation_getResult(operation, 0))
                  == Register_st200_GR0) {
          temporary_argR0 = Operation_getResult(operation, 0);
        }
      } BasicBlock_ENDEACH_Operation;
    }
    if(!result) {
      printf("*** Test 1 FAILED\n");
    } else {
      printf("*** Test 1 succeed\n");
    }
  }
#endif//MDS_FAMILY_st200
}

#line 1187 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/ParallelCopy.xcc"
//
{
#ifdef MDS_FAMILY_st200
  Program programTmp = Program_new(Memory_Root);
  Memory memory = Program_memory(programTmp);
  SymbolTable symbolTable = Program_symbolTable(programTmp);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "parCopy");
  Procedure procedure = Program_makeProcedure(programTmp, symbol);
  LabelTable labelTable = Program_labelTable(programTmp);
  Label L1 = LabelTable_lookup(labelTable, 1, "L1");
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 1.0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  Procedure_buildCodeRegions(procedure);
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Temporary temporary_resR0 = Procedure_makeAssignedTemporary(procedure,
                                                                Register_st200_GR0);
    Temporary temporary_resR1 = Procedure_makeAssignedTemporary(procedure,
                                                                Register_st200_GR1);
    Temporary temporary_resR3 = Procedure_makeAssignedTemporary(procedure,
                                                                Register_st200_GR3);
    Temporary temporary_resR4 = Procedure_makeAssignedTemporary(procedure,
                                                                Register_st200_GR4);
    Temporary temporary_argR2 = Procedure_makeAssignedTemporary(procedure,
                                                                Register_st200_GR2);
    Temporary temporary_argR1 = Procedure_makeAssignedTemporary(procedure,
                                                                Register_st200_GR1);
    Temporary temporary_argR0 = Procedure_makeAssignedTemporary(procedure,
                                                                Register_st200_GR0);
    Operation parCopy = BasicBlock_makeOperationPCOPY(block_l1, NULL, true, 4,
                                                      1);
    bool result;
    Operation_addtoParCopy(parCopy, temporary_resR0, temporary_argR2); 
    Operation_addtoParCopy(parCopy, temporary_resR1, temporary_argR2);
    Operation_addtoParCopy(parCopy, temporary_resR3, temporary_argR1);
    Operation_addtoParCopy(parCopy, temporary_resR4, temporary_argR0);
    CodeRegion_makeGlobalTable(codeRegion, TemporaryFlag_Constant, 0);
    result = ParallelCopy_resolveDuplication(codeRegion, RegFile__UNDEF);
    // Duplication scheme is:
    // R2
    // | \    .
    // R1 R0
    // |  |
    // R3 R4
    // Resolution will use R4 if edge R2 to R1 is removed or R3 if edge
    // R2 to R0 is removed. We except these possiblities, because otherwise we
    // get a cycle
    // Excepted result is:
    // R3 = mov R2
    // R2
    // |    /\       .
    // R1  | R0
    // |   / |
    // R3 |  R4
    //  \_/
    // Check we have that.
    if(result) {
      Temporary temporary_argR4 = NULL;
      Temporary temporary_argR3 = NULL;
      result = false;
      BasicBlock_FOREACH_Operation(block_l1, operation) {
        if(operation == parCopy) {
          if(temporary_argR3 != NULL && temporary_argR4 == NULL) {
            bool okTempR0 = false;
            bool okTempR1 = false;
            bool okTempR3 = false;
            bool okTempR4 = false;
            Operation_RESULTS_FOREACH_Temporary(operation, tempRes) {
              Temporary arg =
                Operation_getArgument(operation, Operation_RESULTS_INDEX);
              if(tempRes == temporary_resR1 && arg == temporary_argR2) {
                okTempR1 ^= true;
                if(!okTempR1) {
                  break;
                }
              } else if(tempRes == temporary_resR3 && arg == temporary_argR1) {
                okTempR3 ^= true;
                if(!okTempR3) {
                  break;
                }
              } else if(tempRes == temporary_resR0 && arg == temporary_argR3) {
                okTempR0 ^= true;
                if(!okTempR0) {
                  break;
                }
              } else if(tempRes == temporary_resR4 && arg == temporary_argR0) {
                okTempR4 ^= true;
                if(!okTempR4) {
                  break;
                }
              }
            } Operation_RESULTS_ENDEACH_Temporary;
            result = okTempR0 & okTempR1 & okTempR3 & okTempR4;
          } else if(temporary_argR4 != NULL && temporary_argR3 == NULL) {
            bool okTempR0 = false;
            bool okTempR1 = false;
            bool okTempR3 = false;
            bool okTempR4 = false;
            Operation_RESULTS_FOREACH_Temporary(operation, tempRes) {
              Temporary arg =
                Operation_getArgument(operation, Operation_RESULTS_INDEX);
              if(tempRes == temporary_resR1 && arg == temporary_argR4) {
                okTempR1 ^= true;
                if(!okTempR1) {
                  break;
                }
              } else if(tempRes == temporary_resR3 && arg == temporary_argR1) {
                okTempR3 ^= true;
                if(!okTempR3) {
                  break;
                }
              } else if(tempRes == temporary_resR0 && arg == temporary_argR2) {
                okTempR0 ^= true;
                if(!okTempR0) {
                  break;
                }
              } else if(tempRes == temporary_resR4 && arg == temporary_argR0) {
                okTempR4 ^= true;
                if(!okTempR4) {
                  break;
                }
              }
            } Operation_RESULTS_ENDEACH_Temporary;
            result = okTempR0 & okTempR1 & okTempR3 & okTempR4;
          }
        } else if(Operator_isSeqCopy(Operation_operator(operation))
                  && Operation_getArgument(operation, 0) == temporary_argR2) {
          if(Temporary_register(Operation_getResult(operation, 0))
             == Register_st200_GR4) {
            temporary_argR4 = Operation_getResult(operation, 0);
          } else if (Temporary_register(Operation_getResult(operation, 0))
             == Register_st200_GR3) {
            temporary_argR3 = Operation_getResult(operation, 0);
          }
        }
      } BasicBlock_ENDEACH_Operation;
    }
    if(!result) {
      printf("*** Test 1 FAILED\n");
    } else {
      printf("*** Test 1 succeed\n");
    }
  }
#endif//MDS_FAMILY_st200
}


#endif//ParallelCopy__c_INCLUDED
