#ifndef Predicator__c_INCLUDED
#define Predicator__c_INCLUDED

#line 100 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Predicator.xcc"
//
{
  CGO_TRACE = stdout;
  printf("sizeof(Predicator_) = %d\n", sizeof(Predicator_));
}

#line 877 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Predicator.xcc"
//
{
  // Test the IF-conversion
  // Small example - one triangle hammock
  Program program = Program_new(Memory_Root);
  Optimize optimize = Program_optimize(program);
  SymbolTable symbolTable = Program_symbolTable(program);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "basic-triangle");
  Procedure procedure = Program_makeProcedure(program, symbol);
  LabelTable labelTable = Program_labelTable(program);
  Label L1 = LabelTable_lookup(labelTable, 1, "L1");
  Label L2 = LabelTable_lookup(labelTable, 2, "L2");
  Label L3 = LabelTable_lookup(labelTable, 3, "L3");
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 10.0);
  BasicBlock block_l2 = Procedure_makeBasicBlock(procedure, 0, 0, 10.0);
  BasicBlock block_l3 = Procedure_makeBasicBlock(procedure, 0, 0, 10.0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  BasicBlock_addLabels(block_l2, 1, &L2);
  BasicBlock_addLabels(block_l3, 1, &L3);
  BasicBlock_makeEdge(block_l1, block_l3, 0.0);
  BasicBlock_makeEdge(block_l1, block_l2, 0.0);
  BasicBlock_makeEdge(block_l2, block_l3, 0.0);
  *Optimize__CONVERSION(optimize) = OptimizeConversion_Folding;
  Procedure_buildCodeRegions(procedure);
  printf("\nSmall example to test IF-conversion (basic triangle hammock):\n");
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Temporary temporary_x = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_y = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_z = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_c1 = Procedure_makeAbsoluteTemporary(procedure, 1, Relocation__UNDEF);
    Temporary temporary_c2 = Procedure_makeAbsoluteTemporary(procedure, 2, Relocation__UNDEF);
    Temporary temporary_l2 = Procedure_makeLabelTemporary(procedure, L2, 0, Relocation__UNDEF);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_x, temporary_c1);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_z, temporary_c1);
    Selector_makeOperation_0_2(BasicBlock_selector(block_l1),
                               Operator_GOTRUE, temporary_z, temporary_l2);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l2),
                               Operator_APPLY, temporary_x, temporary_c2);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                               Operator_APPLY, temporary_y, temporary_x);
    {
      SSAForm ssaForm = SSAForm_construct(Memory_Root, codeRegion, true);
      Predicator_delete(Predicator_new(Memory_Root, ssaForm));
      //FIXME! SSAForm_destruct(ssaForm);
    }
  }
}

#line 928 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Predicator.xcc"
//
{
  // Test the IF-conversion
  // Small example - triangle hammock with back-edge!
  Program program = Program_new(Memory_Root);
  Optimize optimize = Program_optimize(program);
  SymbolTable symbolTable = Program_symbolTable(program);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "backedge-triangle");
  Procedure procedure = Program_makeProcedure(program, symbol);
  LabelTable labelTable = Program_labelTable(program);
  Label L1 = LabelTable_lookup(labelTable, 1, "L1");
  Label L2 = LabelTable_lookup(labelTable, 2, "L2");
  Label L3 = LabelTable_lookup(labelTable, 3, "L3");
  Label L4 = LabelTable_lookup(labelTable, 4, "L4");
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 5.0);
  BasicBlock block_l2 = Procedure_makeBasicBlock(procedure, 0, 0, 10.0);
  BasicBlock block_l3 = Procedure_makeBasicBlock(procedure, 0, 0, 5.0);
  BasicBlock block_l4 = Procedure_makeBasicBlock(procedure, 0, 0, 5.0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  BasicBlock_addLabels(block_l2, 1, &L2);
  BasicBlock_addLabels(block_l3, 1, &L3);
  BasicBlock_addLabels(block_l4, 1, &L4);
  BasicBlock_makeEdge(block_l1, block_l2, 1.0);
  BasicBlock_makeEdge(block_l2, block_l3, 0.5);
  BasicBlock_makeEdge(block_l2, block_l4, 0.5);
  BasicBlock_makeEdge(block_l3, block_l2, 1.0);
  BasicBlock_makeEdge(block_l3, block_l4, 0.0);
  *Optimize__CONVERSION(optimize) = OptimizeConversion_Folding;
  Procedure_buildCodeRegions(procedure);
  printf("\nSmall example to test IF-conversion (triangle hammock with back-edge):\n");
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
  /*  Temporary temporary_x = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_y = Procedure_makeVirtualTemporary(procedure, 0); */
    Temporary temporary_cond1 = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_cond2 = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_c1 = Procedure_makeAbsoluteTemporary(procedure, 1, Relocation__UNDEF);
    Temporary temporary_c2 = Procedure_makeAbsoluteTemporary(procedure, 2, Relocation__UNDEF);
    Temporary temporary_l2 = Procedure_makeLabelTemporary(procedure, L2, 0, Relocation__UNDEF);
    Temporary temporary_l4 = Procedure_makeLabelTemporary(procedure, L4, 0, Relocation__UNDEF);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_cond1, temporary_c1);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_cond2, temporary_c1); 
    Selector_makeOperation_0_2(BasicBlock_selector(block_l2),
                               Operator_GOTRUE, temporary_cond1, temporary_l4);
    Selector_makeOperation_0_2(BasicBlock_selector(block_l3),
                               Operator_GOTRUE, temporary_cond2, temporary_l2);
  /*  Selector_makeOperation_1_1(BasicBlock_selector(block_l2),
                               Operator_APPLY, temporary_x, temporary_c2);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                               Operator_APPLY, temporary_y, temporary_x); */
    {
      SSAForm ssaForm = SSAForm_construct(Memory_Root, codeRegion, true);
      Predicator_delete(Predicator_new(Memory_Root, ssaForm));
      //FIXME! SSAForm_destruct(ssaForm);
    }
  }
}

#line 988 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Predicator.xcc"
//
{
  // Test the IF-conversion
  // Small example - basic diamond hammock
  Program program = Program_new(Memory_Root);
  Optimize optimize = Program_optimize(program);
  SymbolTable symbolTable = Program_symbolTable(program);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "basic-diamond");
  Procedure procedure = Program_makeProcedure(program, symbol);
  LabelTable labelTable = Program_labelTable(program);
  Label L1 = LabelTable_lookup(labelTable, 1, "L1");
  Label L2 = LabelTable_lookup(labelTable, 2, "L2");
  Label L3 = LabelTable_lookup(labelTable, 3, "L3");
  Label L4 = LabelTable_lookup(labelTable, 4, "L4");
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 10.0);
  BasicBlock block_l2 = Procedure_makeBasicBlock(procedure, 0, 0, 5.0);
  BasicBlock block_l3 = Procedure_makeBasicBlock(procedure, 0, 0, 5.0);
  BasicBlock block_l4 = Procedure_makeBasicBlock(procedure, 0, 0, 10.0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  BasicBlock_addLabels(block_l2, 1, &L2);
  BasicBlock_addLabels(block_l3, 1, &L3);
  BasicBlock_addLabels(block_l4, 1, &L4);
  BasicBlock_makeEdge(block_l1, block_l2, 0.5);
  BasicBlock_makeEdge(block_l1, block_l3, 0.5);
  BasicBlock_makeEdge(block_l2, block_l4, 1.0);
  BasicBlock_makeEdge(block_l3, block_l4, 1.0);
  *Optimize__CONVERSION(optimize) = OptimizeConversion_Folding;
  Procedure_buildCodeRegions(procedure);
  printf("\nSmall example to test IF-conversion (basic diamond hammock):\n");
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Temporary temporary_x = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_y = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_cond = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_c1 = Procedure_makeAbsoluteTemporary(procedure, 1, Relocation__UNDEF);
    Temporary temporary_c2 = Procedure_makeAbsoluteTemporary(procedure, 2, Relocation__UNDEF);
    Temporary temporary_c3 = Procedure_makeAbsoluteTemporary(procedure, 3, Relocation__UNDEF);
    Temporary temporary_l3 = Procedure_makeLabelTemporary(procedure, L3, 0, Relocation__UNDEF);
    Temporary temporary_l4 = Procedure_makeLabelTemporary(procedure, L4, 0, Relocation__UNDEF);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_x, temporary_c1);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_cond, temporary_c1);
    Selector_makeOperation_0_2(BasicBlock_selector(block_l1),
                               Operator_GOTRUE, temporary_cond, temporary_l3);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l2),
                               Operator_APPLY, temporary_x, temporary_c2);
    Selector_selectGOTO(BasicBlock_selector(block_l2), L4);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                               Operator_APPLY, temporary_x, temporary_c3);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l4),
                               Operator_APPLY, temporary_y, temporary_x);
    {
      SSAForm ssaForm = SSAForm_construct(Memory_Root, codeRegion, true);
      Predicator_delete(Predicator_new(Memory_Root, ssaForm));
      //FIXME! SSAForm_destruct(ssaForm);
    }
  }
}

#line 1048 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Predicator.xcc"
//
{
  // Test the IF-conversion
  // Exmaple from Bruel's presentation.
  Program program = Program_new(Memory_Root);
  Optimize optimize = Program_optimize(program);
  SymbolTable symbolTable = Program_symbolTable(program);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "if-conversion");
  Procedure procedure = Program_makeProcedure(program, symbol);
  LabelTable labelTable = Program_labelTable(program);
  Label L1 = LabelTable_lookup(labelTable, 1, "L1");
  Label L2 = LabelTable_lookup(labelTable, 2, "L2");
  Label L3 = LabelTable_lookup(labelTable, 3, "L3");
  Label L4 = LabelTable_lookup(labelTable, 4, "L4");
  Label L5 = LabelTable_lookup(labelTable, 5, "L5");
  Label L6 = LabelTable_lookup(labelTable, 6, "L6");
  Label L7 = LabelTable_lookup(labelTable, 7, "L7");
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 10.0);
  BasicBlock block_l2 = Procedure_makeBasicBlock(procedure, 0, 0, 20.0);
  BasicBlock block_l3 = Procedure_makeBasicBlock(procedure, 0, 0, 10.0);
  BasicBlock block_l4 = Procedure_makeBasicBlock(procedure, 0, 0, 5.0);
  BasicBlock block_l5 = Procedure_makeBasicBlock(procedure, 0, 0, 20.0);
  BasicBlock block_l6 = Procedure_makeBasicBlock(procedure, 0, 0, 20.0);
  BasicBlock block_l7 = Procedure_makeBasicBlock(procedure, 0, 0, 10.0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  BasicBlock_addLabels(block_l2, 1, &L2);
  BasicBlock_addLabels(block_l3, 1, &L3);
  BasicBlock_addLabels(block_l4, 1, &L4);
  BasicBlock_addLabels(block_l5, 1, &L5);
  BasicBlock_addLabels(block_l6, 1, &L6);
  BasicBlock_addLabels(block_l7, 1, &L7);
  BasicBlock_makeEdge(block_l1, block_l2, 1.0);
  BasicBlock_makeEdge(block_l2, block_l3, 0.5);
  BasicBlock_makeEdge(block_l2, block_l5, 0.5);
  BasicBlock_makeEdge(block_l3, block_l4, 0.5);
  BasicBlock_makeEdge(block_l3, block_l5, 0.5);
  BasicBlock_makeEdge(block_l4, block_l5, 1.0);
  BasicBlock_makeEdge(block_l5, block_l6, 1.0);
  BasicBlock_makeEdge(block_l5, block_l7, 0.0);
  BasicBlock_makeEdge(block_l6, block_l7, 0.5);
  BasicBlock_makeEdge(block_l6, block_l2, 0.5);
  *Optimize__CONVERSION(optimize) = OptimizeConversion_Folding;
  Procedure_buildCodeRegions(procedure);
  printf("\nExample from Bruel's presentation:\n");
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Temporary temporary_x = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_y = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_c1 = Procedure_makeAbsoluteTemporary(procedure, 1, Relocation__UNDEF);
    Temporary temporary_c3 = Procedure_makeAbsoluteTemporary(procedure, 3, Relocation__UNDEF);
    Temporary temporary_c4 = Procedure_makeAbsoluteTemporary(procedure, 4, Relocation__UNDEF);
    Temporary temporary_l2 = Procedure_makeLabelTemporary(procedure, L4, 0, Relocation__UNDEF);
    Temporary temporary_l5 = Procedure_makeLabelTemporary(procedure, L5, 0, Relocation__UNDEF);
    Temporary temporary_l7 = Procedure_makeLabelTemporary(procedure, L7, 0, Relocation__UNDEF);
    // Conditions
    Temporary temporary_cond1 = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_cond2 = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_cond3 = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_cond4 = Procedure_makeVirtualTemporary(procedure, 0);
    // block 1
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_cond1, temporary_c1);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_cond2, temporary_c1);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_cond3, temporary_c1);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_cond4, temporary_c1);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_x, temporary_c1);
    // block 2
    Selector_makeOperation_1_2(BasicBlock_selector(block_l2),
                               Operator_ADD, temporary_x, temporary_x, temporary_c1);
    Selector_makeOperation_0_2(BasicBlock_selector(block_l2),
                               Operator_GOTRUE, temporary_cond1, temporary_l5);
    // block 3
    Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                               Operator_APPLY, temporary_x, temporary_c3);
    Selector_makeOperation_0_2(BasicBlock_selector(block_l3),
                               Operator_GOTRUE, temporary_cond2, temporary_l5);
    // block 4
    Selector_makeOperation_1_1(BasicBlock_selector(block_l4),
                               Operator_APPLY, temporary_x, temporary_c4);
    // block 5
    Selector_makeOperation_1_2(BasicBlock_selector(block_l5),
                               Operator_ADD, temporary_x, temporary_x, temporary_c1);
    Selector_makeOperation_0_2(BasicBlock_selector(block_l5),
                               Operator_GOTRUE, temporary_cond3, temporary_l7);
    // block 6
    Selector_makeOperation_1_2(BasicBlock_selector(block_l6),
                               Operator_MUL, temporary_x, temporary_x, temporary_c3);
    Selector_makeOperation_0_2(BasicBlock_selector(block_l6),
                               Operator_GOTRUE, temporary_cond4, temporary_l2);
    // block 7
    Selector_makeOperation_1_1(BasicBlock_selector(block_l7),
                               Operator_APPLY, temporary_y, temporary_x);
    {
      SSAForm ssaForm = SSAForm_construct(Memory_Root, codeRegion, true);
      Predicator_delete(Predicator_new(Memory_Root, ssaForm));
      //FIXME! SSAForm_destruct(ssaForm);
    }
  }
}


#endif//Predicator__c_INCLUDED
