#ifndef SSAReconstruct__c_INCLUDED
#define SSAReconstruct__c_INCLUDED

#line 645 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/SSAReconstruct.xcc"
//
{
  // Test of DefUses_pretty.
  Program program = Program_new(Memory_Root);
  Memory memory = Program_memory(program);
  SymbolTable symbolTable = Program_symbolTable(program);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "lost-copy");
  Procedure procedure = Program_makeProcedure(program, symbol);
  LabelTable labelTable = Program_labelTable(program);
  Label L1 = LabelTable_lookup(labelTable, 1, "L1");
  Label L2 = LabelTable_lookup(labelTable, 2, "L2");
  Label L3 = LabelTable_lookup(labelTable, 3, "L3");
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  BasicBlock_addLabels(block_l2, 1, &L2);
  BasicBlock_addLabels(block_l3, 1, &L3);
  BasicBlock_makeEdge(block_l1, block_l2, 0.0);
  BasicBlock_makeEdge(block_l2, block_l2, 0.0);
  BasicBlock_makeEdge(block_l2, block_l3, 0.0);
  Procedure_buildCodeRegions(procedure);
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Temporary temporary_x = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_y = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_a1 = Procedure_makeAbsoluteTemporary(procedure, 1, Relocation__UNDEF);
    Temporary temporary_a2 = Procedure_makeAbsoluteTemporary(procedure, 2, Relocation__UNDEF);
    // remove references to ssa form to be linkable with lir only
    Temporary temporary_x1 = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_x2 = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_y1 = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_y2 = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_y3 = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_y4 = Procedure_makeVirtualTemporary(procedure, 0);
    TemporarySet set1 = TemporarySet_make(memory, 6);
    TemporarySet set2 = TemporarySet_make(memory, 3);
    struct Operation_*phiOperation_x = BasicBlock_makeOperationPHI(block_l2, NULL);
    struct Operation_*phiOperation_y = BasicBlock_makeOperationPHI(block_l2, NULL);
    DefUses_ defUsesX1[1], defUsesX2[1], defUsesY1[1], defUsesY2[1];
    struct Operation_*tmp = NULL;
    DefUses_Ctor(defUsesX1, memory);
    DefUses_Ctor(defUsesX2, memory);
    DefUses_Ctor(defUsesY1, memory);
    DefUses_Ctor(defUsesY2, memory);
    Operation_setResult(phiOperation_x, 0, temporary_x2);
    DefUses_setDef(defUsesX2, phiOperation_x, 0);
    Operation_setArgument(phiOperation_x, 0, temporary_x1);
    DefUses_addUse(defUsesX1, phiOperation_x, 0);
    Operation_setArgument(phiOperation_x, 1, temporary_y2);
    DefUses_addUse(defUsesY2, phiOperation_x, 1);
    Operation_setResult(phiOperation_y, 0, temporary_y2);
    DefUses_setDef(defUsesY2, phiOperation_y, 0);
    Operation_setArgument(phiOperation_y, 0, temporary_y1);
    DefUses_addUse(defUsesY1, phiOperation_y, 0);
    Operation_setArgument(phiOperation_y, 1, temporary_x2);
    DefUses_addUse(defUsesX2, phiOperation_y, 1);
    TemporarySet_insert(set1, temporary_x1);
    TemporarySet_insert(set1, temporary_x2);
    TemporarySet_insert(set1, temporary_y1);
    TemporarySet_insert(set1, temporary_y2);
    TemporarySet_insert(set1, temporary_y3);
    TemporarySet_insert(set1, temporary_y4);
    TemporarySet_insert(set2, temporary_x2);
    TemporarySet_insert(set2, temporary_y1);
    TemporarySet_insert(set2, temporary_y2);
    CodeRegion_setLiveSets(codeRegion, 1, set1, set2, NULL, NULL);
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                                     Operator_APPLY, temporary_x1, temporary_a1);
    DefUses_setDef(defUsesX1, tmp, 0);
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                                     Operator_APPLY, temporary_y1, temporary_a2);
    DefUses_setDef(defUsesY1, tmp, 0);
    fprintf(stdout, "Def - Uses\n");
    fprintf(stdout, "* X1:\n");
    DefUses_pretty(defUsesX1, stdout, true);
    fprintf(stdout, "* X2:\n");
    DefUses_pretty(defUsesX2, stdout, true);
    fprintf(stdout, "* Y1:\n");
    DefUses_pretty(defUsesY1, stdout, true);
    fprintf(stdout, "* Y2:\n");
    DefUses_pretty(defUsesY2, stdout, true);
    DefUses_Dtor(defUsesX1);
    DefUses_Dtor(defUsesX2);
    DefUses_Dtor(defUsesY1);
    DefUses_Dtor(defUsesY2);
  }
}

#line 1180 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/SSAReconstruct.xcc"
//
{
  // No self test for now
}


#endif//SSAReconstruct__c_INCLUDED
