#ifndef Scoreboarder_c_INCLUDED
#define Scoreboarder_c_INCLUDED

#line 15 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
#include "CGO/CGO_.h"

#line 20 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 37 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
ScoreboarderState
ScoreboarderState_Ctor(ScoreboarderState this,
                       Memory memory, Processor processor, int windowSize)
{
  *ScoreboarderState__BASICBLOCK(this) = NULL;
  *ScoreboarderState__ISLISTED(this) = false;
  *ScoreboarderState__PROCESSOR(this) = processor;
  *ScoreboarderState__WORKNEXT(this) = NULL;
  *ScoreboarderState__STAMP(this) = 0;
  Scoreboard_Ctor(ScoreboarderState_SCOREBOARD(this),
                  memory, processor, windowSize);
  return this;
}

#line 51 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
void
ScoreboarderState_Dtor(ScoreboarderState this)
{
  Memory memory = ScoreboarderState_MEMORY(this);
  Scoreboard_Dtor(ScoreboarderState_SCOREBOARD(this));
}

#line 63 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 71 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
bool
ScoreboarderState_schedule(ScoreboarderState this, Scoreboard temp_scoreboard)
{
  BasicBlock basicBlock = ScoreboarderState_BASICBLOCK(this);
  Scoreboard scoreboard = ScoreboarderState_SCOREBOARD(this);
  NativeBlock nativeBlock = BasicBlock_NATIVEBLOCK(basicBlock);
  // Propagate temp_scoreboard along the basicBlock.
if (   FORCE_ONLYCOUNT <= 0
    || FORCE_ONLYCOUNT == InstructionStack_count(NativeBlock_instructions(nativeBlock))) {
  bool modified = NativeBlock_scoreboardInstructions(nativeBlock, temp_scoreboard);
  int lastDate = NativeBlock_lastDate(nativeBlock);
  int padding = BasicBlock_padding(basicBlock);
  //CGO_TRACE && fprintf(CGO_TRACE, "\tBEFORE SORT\n");
  //CGO_TRACE && BasicBlock_pretty(basicBlock, CGO_TRACE);
  NativeBlock_reorderInstructions(nativeBlock);
  //CGO_TRACE && fprintf(CGO_TRACE, "\tAFTER SORT\n");
  //CGO_TRACE && BasicBlock_pretty(basicBlock, CGO_TRACE);
  Scoreboard_advance(temp_scoreboard, lastDate + padding);
  // Assign temp_scoreboard to scoreboard.
  // FIXME! Should compute modified here.
  Scoreboard_reset(scoreboard, 0);
  Scoreboard_merge(scoreboard, temp_scoreboard, 0);
  if (FORCE_PIPELINE > 0) modified = false;
  return modified;
} else return false;
}

#line 98 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 122 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
Scoreboarder
Scoreboarder_Ctor(Scoreboarder this,
                  Memory memory, CodeRegion codeRegion)
{
  Optimize optimize = CodeRegion_optimize(codeRegion);
  int scoreboarding = Optimize_SCOREBOARDING(optimize);
  int windowSize = Optimize_WINDOWSIZE(optimize);
  Processor processor = CodeRegion_processor(codeRegion);
  *Scoreboarder__MEMORY(this) = memory;
  *Scoreboarder__CODEREGION(this) = codeRegion;
  Scoreboard_Ctor(Scoreboarder_SCOREBOARD(this),
                  memory, processor, windowSize);
  *Scoreboarder__STAMP(this) = 0;
  *Scoreboarder__ITERCOUNT(this) = 0;
  *Scoreboarder__BLOCKCOUNT(this) = 0;
  *Scoreboarder__BASESTATE(this) = NULL;
  *Scoreboarder__WORKTAIL(this) = NULL;
  *Scoreboarder__WORKHEAD(this) = NULL;
  if (scoreboarding != 0) {
    int32_t blockCount = CodeRegion_blockCount(codeRegion), i;
    size_t totalSize = blockCount*sizeof(ScoreboarderState_);
    ScoreboarderState_ *baseState = Memory_alloc(memory, totalSize);
    for (i = 0; i < blockCount; i++) {
      ScoreboarderState_Ctor(baseState + i, memory, processor, windowSize);
    }
    *Scoreboarder__BLOCKCOUNT(this) = blockCount;
    *Scoreboarder__BASESTATE(this) = baseState;
    Except_REQUIRE(windowSize >= 0);
    CGO_TRACE && fprintf(CGO_TRACE, "*** Scoreboarder(%d,%d)\n",
                         scoreboarding, windowSize);
    Scoreboarder_activateState(this, CodeRegion_rootBlock(codeRegion));
    CGO_TRACE && fprintf(CGO_TRACE, "\n");
    if (scoreboarding & OptimizeScoreboarding_Iterate) Scoreboarder_doIterate(this);
    else if (scoreboarding & OptimizeScoreboarding_Fixup) Scoreboarder_doFixup(this);
    else Except_NEVER(true);
    Scoreboarder_writeBack(this);
  }
  return this;
}

#line 162 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
void
Scoreboarder_Dtor(Scoreboarder this)
{
  Memory memory = Scoreboarder_MEMORY(this);
  int32_t blockCount = Scoreboarder_BLOCKCOUNT(this), i;
  ScoreboarderState_ *baseState = Scoreboarder_BASESTATE(this);
  if (baseState != NULL) {
    for (i = 0; i < blockCount; i++) ScoreboarderState_Dtor(baseState + i);
    Memory_free_(memory, baseState);
  }
  Scoreboard_Dtor(Scoreboarder_SCOREBOARD(this));
}

#line 175 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
size_t
Scoreboarder_Size(Memory memory, CodeRegion codeRegion)
{
	return sizeof(Scoreboarder_);
}

#line 190 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
#ifndef Scoreboarder_POOLED
#define Scoreboarder_POOLED 128
#endif//Scoreboarder_POOLED

#line 194 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
Scoreboarder
Scoreboarder_new(Memory parent, CodeRegion codeRegion)
{
  Memory memory = Memory_new(parent, Scoreboarder_POOLED);
  size_t size = Scoreboarder_Size(memory, codeRegion);
  Scoreboarder this = Memory_alloc(memory, size);
  return Scoreboarder_Ctor(this, memory, codeRegion);
}

#line 207 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
Scoreboarder
Scoreboarder_delete(Scoreboarder this)
{
  if (this != NULL) {
    Memory memory = Scoreboarder_MEMORY(this);
#ifndef ECL_NDTOR
    Scoreboarder_Dtor(this);
    Memory_free_(memory, this);
#endif//ECL_NDTOR
    Memory_delete(memory);
  }
  return NULL;
}

#line 221 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 255 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 257 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
static inline ScoreboarderState
Scoreboarder_workTail(Scoreboarder this)
{
  return Scoreboarder_WORKTAIL(this);
}

#line 263 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
static inline ScoreboarderState
Scoreboarder_workHead(Scoreboarder this)
{
  return Scoreboarder_WORKHEAD(this);
}

#line 269 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
static inline bool
Scoreboarder_workIsEmpty(Scoreboarder this)
{
  return Scoreboarder_WORKTAIL(this) == NULL;
}

#line 275 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
#ifndef Scoreboarder_WORKINSERT
// Push state at head of worklist.
static inline void
Scoreboarder_workPush(Scoreboarder this, ScoreboarderState state)
{
  ScoreboarderState workHead = Scoreboarder_WORKHEAD(this);
  Except_CHECK(ScoreboarderState_WORKNEXT(state) == NULL);
  if (workHead == NULL) {
    *Scoreboarder__WORKTAIL(this) = state;
  } else {
    *ScoreboarderState__WORKNEXT(state) = workHead;
  }
  *Scoreboarder__WORKHEAD(this) = state;
}
#else//Scoreboarder_WORKINSERT
#define Scoreboarder_workPush Scoreboarder_workInsert
#endif//Scoreboarder_WORKINSERT

#line 293 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
// Insert state in FREQUENCY order.
static void
Scoreboarder_workInsert(Scoreboarder this, ScoreboarderState state);

#line 297 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
static void
Scoreboarder_workInsert(Scoreboarder this, ScoreboarderState state)
{
  ScoreboarderState workHead = Scoreboarder_WORKHEAD(this);
  Except_CHECK(ScoreboarderState_WORKNEXT(state) == NULL);
  if (workHead == NULL) {
    *Scoreboarder__WORKTAIL(this) = state;
    *Scoreboarder__WORKHEAD(this) = state;
  } else {
    ScoreboarderState curr_state = workHead, next_state = NULL;
    do {
      if (ScoreboarderState_FREQUENCY(state) >=
          ScoreboarderState_FREQUENCY(curr_state)) {
        *ScoreboarderState__WORKNEXT(state) = curr_state;
        if (next_state != NULL) {
          *ScoreboarderState__WORKNEXT(next_state) = state;
        } else {
          *Scoreboarder__WORKHEAD(this) = state;
        }
        return;
      }
      next_state = curr_state;
      curr_state = ScoreboarderState_WORKNEXT(curr_state);
    } while (curr_state != NULL);
    *Scoreboarder__WORKTAIL(this) = state;
    *ScoreboarderState__WORKNEXT(next_state) = state;
  }
}

#line 326 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
// Put state at tail of worklist.
static inline void
Scoreboarder_workPut(Scoreboarder this, ScoreboarderState state)
{
  ScoreboarderState workTail = Scoreboarder_WORKTAIL(this);
  Except_CHECK(ScoreboarderState_WORKNEXT(state) == NULL);
  *Scoreboarder__WORKTAIL(this) = state;
  if (workTail == NULL) {
    *Scoreboarder__WORKHEAD(this) = state;
  } else {
    *ScoreboarderState__WORKNEXT(workTail) = state;
  }
}

#line 340 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
// Pop state at head of worklist.
static inline void
Scoreboarder_workPop(Scoreboarder this)
{
  ScoreboarderState workTail = Scoreboarder_WORKTAIL(this);
  ScoreboarderState workHead = Scoreboarder_WORKHEAD(this);
  if (workTail == workHead) {
    *Scoreboarder__WORKTAIL(this) = *Scoreboarder__WORKHEAD(this) = NULL;
  } else {
    *Scoreboarder__WORKHEAD(this) = ScoreboarderState_WORKNEXT(workHead);
  }
  *ScoreboarderState__WORKNEXT(workHead) = NULL;
}

#line 373 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
void
Scoreboarder_activateState(Scoreboarder this, BasicBlock curr_block)
{
  int32_t index = 1;
  Scoreboard this_scoreboard = Scoreboarder_SCOREBOARD(this);
  ScoreboarderState_ *baseState = Scoreboarder_BASESTATE(this);
  ScoreboarderState curr_state = baseState + BasicBlock_index(curr_block);
  Operation last_operation = BasicBlock_lastOperation(curr_block);
  int minTaken = Processor_minTaken(BasicBlock_processor(curr_block));
  Except_CHECK(BasicBlock_index(curr_block) >= 0);
  // Forward DFS on CodeRegion.
  *ScoreboarderState__BASICBLOCK(curr_state) = curr_block;
  *ScoreboarderState__ISLISTED(curr_state) = true;
  BasicBlock_FOREACH_Operation(curr_block, operation) {
    Instruction instruction = Operation_instruction(operation);
    Instruction_setStartDate(instruction, -1);
    //Operation_setStartDate(operation, -1);
    Operation_setIndex(operation, index++);
  } BasicBlock_ENDEACH_Operation;
  if (BasicBlock_enterCount(curr_block) > 1) {
    float curr_frequency = BasicBlock_frequency(curr_block);
    BasicBlock_ENTER_FOREACH_BasicBlockEdge(curr_block, edge) {
      BasicBlock pred_block = BasicBlockEdge_origBlock(edge);
      float pred_frequency = BasicBlock_frequency(pred_block);
      if (pred_frequency*3 < curr_frequency) {
        BasicBlock_setPadding(pred_block, 2);
      }
    } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
  }
  BasicBlock_LEAVE_FOREACH_BasicBlockEdge(curr_block, edge) {
    int elapsed = minTaken + 1;
    BasicBlock succ_block = BasicBlockEdge_destBlock(edge);
    ScoreboarderState succ_state = baseState + BasicBlock_index(succ_block);
    Except_CHECK(BasicBlock_index(succ_block) >= 0);
    if (!ScoreboarderState_ISLISTED(succ_state)) {
      Scoreboarder_activateState(this, succ_block);
    }
    // Update the BasicBlockEdge fields.
    if (BasicBlockEdge_destBlock(edge) == BasicBlock_next(curr_block)) {
      // Fall-through edge.
      if (last_operation == NULL) {
        elapsed = 0;
      } else if (Operation_isRoutine(last_operation)) {
        elapsed = 2*minTaken + 1;
      } else {
        elapsed = 1;
      }
    }
    *BasicBlockEdge__ELAPSED(edge) = elapsed;
    Except_CHECK(BasicBlockEdge_ELAPSED(edge) == elapsed);
  } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
  // Postorder push last on worklist excluding ROOTBLOCK.
  if (BasicBlock_index(curr_block) != 0) {
    Scoreboarder_workPush(this, curr_state);
    CGO_TRACE && fprintf(CGO_TRACE, "\tPUSH Block_%d", BasicBlock_index(curr_block));
  } else {
    *ScoreboarderState__STAMP(curr_state) = ++*Scoreboarder__STAMP(this);
  }
}

#line 441 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
void
Scoreboarder_doIterate(Scoreboarder this)
{
  ScoreboarderState_ *baseState = Scoreboarder_BASESTATE(this);
  Scoreboard this_scoreboard = Scoreboarder_SCOREBOARD(this);
  while (!Scoreboarder_workIsEmpty(this)) {
    int assigned = 0, modified = 0;
    ScoreboarderState curr_state = Scoreboarder_workHead(this);
    BasicBlock curr_block = ScoreboarderState_BASICBLOCK(curr_state);
    uint32_t curr_stamp = ScoreboarderState_STAMP(curr_state);
    // Pop curr_state from the worklist.
    *ScoreboarderState__ISLISTED(curr_state) = false;
    Scoreboarder_workPop(this);
    CGO_TRACE && fprintf(CGO_TRACE, "\tPOP\tBlock_%d\tfrequency=%g\n",
                         BasicBlock_index(curr_block),
                         BasicBlock_frequency(curr_block));
    // Merge the incoming Scoreboard(s) after elapsed cycles.
    BasicBlock_ENTER_FOREACH_BasicBlockEdge(curr_block, edge) {
      int elapsed = BasicBlockEdge_ELAPSED(edge);
      BasicBlock pred_block = BasicBlockEdge_origBlock(edge);
      ScoreboarderState pred_state = baseState + BasicBlock_index(pred_block);
      Scoreboard pred_scoreboard = ScoreboarderState_SCOREBOARD(pred_state);
      uint32_t pred_stamp = ScoreboarderState_STAMP(pred_state);
      Except_CHECK(BasicBlock_index(pred_block) >= 0);
      // pred_state must be initialized by Scoreboarder_activateState
      Except_CHECK(ScoreboarderState_BASICBLOCK(pred_state) != NULL);
      if (pred_stamp >= curr_stamp) {
        CGO_TRACE && fprintf(CGO_TRACE, "\tMERGE\tBlock_%d\telapsed=%d\n",
                             BasicBlock_index(pred_block), elapsed);
        //CGO_TRACE && Scoreboard_pretty(pred_scoreboard, CGO_TRACE);
        if (!assigned++) {
          Scoreboard_reset(this_scoreboard, 0);
          Scoreboard_merge(this_scoreboard, pred_scoreboard, elapsed);
        } else {
          Scoreboard_merge(this_scoreboard, pred_scoreboard, elapsed);
        }
      }
      Except_CHECK(elapsed >= 0);
    } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
    Except_CHECK(assigned != 0);
    ++*Scoreboarder__ITERCOUNT(this);
    // Schedule the current ScoreboardState.
    CGO_TRACE && fprintf(CGO_TRACE, "\tSTART\tBlock_%d\n", BasicBlock_index(curr_block));
    //CGO_TRACE && Scoreboard_pretty(this_scoreboard, CGO_TRACE);
    modified = ScoreboarderState_schedule(curr_state, this_scoreboard);
    // If changes, push successors on worklist.
    if (modified) {
      *ScoreboarderState__STAMP(curr_state) = ++*Scoreboarder__STAMP(this);
      BasicBlock_LEAVE_FOREACH_BasicBlockEdge(curr_block, edge) {
        BasicBlock succ_block = BasicBlockEdge_destBlock(edge);
        ScoreboarderState succ_state = baseState + BasicBlock_index(succ_block);
        Except_CHECK(BasicBlock_index(succ_block) >= 0);
        if (BasicBlock_index(succ_block) == 0) continue;
        if (!ScoreboarderState_ISLISTED(succ_state)) {
          Scoreboarder_workPush(this, succ_state);
          *ScoreboarderState__ISLISTED(succ_state) = true;
          CGO_TRACE && fprintf(CGO_TRACE, "\tPUSH\tBlock_%d\tfrequency=%g\n",
                               BasicBlock_index(succ_block),
                               BasicBlock_frequency(succ_block));
        }
      } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
    }
  }
}

#line 512 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
void
Scoreboarder_doFixup(Scoreboarder this)
{
  Except_NEVER(true);	// TODO.
}

#line 524 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
void
Scoreboarder_writeBack(Scoreboarder this)
{
  intptr_t prev_traceId = -1;
  int firstDate = 0, lastDate = -1;
  CodeRegion codeRegion = Scoreboarder_CODEREGION(this);
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    Selector selector = BasicBlock_selector(basicBlock);
    NativeBlock nativeBlock = BasicBlock_nativeBlock(basicBlock);
    intptr_t traceId = BasicBlock_traceId(basicBlock);
    if (traceId == 0 || traceId != prev_traceId) {
      firstDate = 0, lastDate = -1;
    } else {
      // Assume fall-through in trace.
      firstDate = lastDate + 1;
    }
    BasicBlock_setFlags(basicBlock, BasicBlockFlag_Scheduled);
    NativeBlock_FOREACH_Instruction(nativeBlock, instruction) {
      Operation operation = (Operation)Instruction_INDEXED(instruction);
      Selector_moveOperationLast(selector, operation);
      lastDate = firstDate + Instruction_startDate(instruction);
      Operation_setStartDate(operation, lastDate);
      Operation_setIndex(operation, -1);
    } NativeBlock_ENDEACH_Instruction;
    if (traceId != prev_traceId) {
      Selector selector = BasicBlock_selector(basicBlock);
      Operation first_operation = BasicBlock_firstOperation(basicBlock);
      if (first_operation != NULL) {
        Instruction first_instruction = Operation_instruction(first_operation);
        int first_date = Instruction_startDate(first_instruction), date;
        for (date = first_date - 1; date >= 0; date--) {
          Operation skip_operation = Selector_makeOperationSKIP(selector);
          Selector_moveOperationFirst(selector, skip_operation);
          Operation_setStartDate(skip_operation, date);
        }
      }
    }
    prev_traceId = traceId;
  } CodeRegion_ENDEACH_BasicBlock;
  CGO_TRACE && fprintf(CGO_TRACE, "*** Scoreboarder\tBLOCKCOUNT=%d\tITERCOUNT=%d\n",
                       Scoreboarder_BLOCKCOUNT(this), Scoreboarder_ITERCOUNT(this));
}

#line 567 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 579 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
#if XCC__C
static void
Scoreboarder_TEST(void)
{
#include "CGO/Scoreboarder_.c"
}

#line 586 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Scoreboarder.xcc"
int
main(int argc, char **argv)
{
  CGO_Test(Scoreboarder_TEST);
  return 0;
}
#endif


#endif//Scoreboarder_c_INCLUDED
