#ifndef Scoreboarder_h_INCLUDED
#define Scoreboarder_h_INCLUDED

/*
 * !!!!	Scoreboarder.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * Scoreboarder --	Scoreboard scheduling in a CodeRegion.
 *
 * Scheduling is done by Scoreboard(ing) windowSize operation(s) along all paths until
 * fixed-point dates. This is similar to a forward data-flow fixed-point computation.
 */
struct Scoreboarder_;
typedef struct Scoreboarder_ Scoreboarder_, *Scoreboarder;
typedef const struct Scoreboarder_ *const_Scoreboarder;
typedef struct Scoreboarder_ * restrict_Scoreboarder;

//
Scoreboarder
Scoreboarder_new(Memory parent, CodeRegion codeRegion);

//
Scoreboarder
Scoreboarder_delete(Scoreboarder this);


#endif//Scoreboarder_h_INCLUDED
