#ifndef JIT_c_INCLUDED
#define JIT_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/JIT/JIT.xcc"
#include "JIT/JIT_.h"

#line 30 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/JIT/JIT.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 51 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/JIT/JIT.xcc"
#undef JIT_TRACE
FILE *JIT_TRACE = NULL;

#line 64 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/JIT/JIT.xcc"
static int JIT_Initialized = 0;

#line 66 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/JIT/JIT.xcc"
void
JIT_INIT(void)
{
  if (JIT_Initialized++ == 0) {
    if (GETENV("JIT_TRACE")) {
      int file = 0;
      sscanf(GETENV("JIT_TRACE"), "%d", &file);
      if (file == 1) JIT_TRACE = stdout;
      else if (file == 2) JIT_TRACE = stderr;
    }
    CCL_INIT();
    MDS_INIT();
    AIR_INIT();
    LIR_INIT();
    PFA_INIT();
    CGO_INIT();
    Compiler_INIT();
  }
}

#line 92 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/JIT/JIT.xcc"
void
JIT_FINI(void)
{
  if (--JIT_Initialized == 0) {
    Compiler_FINI();
    CGO_FINI();
    PFA_FINI();
    LIR_FINI();
    AIR_FINI();
    MDS_FINI();
    CCL_FINI();
  }
}

#line 112 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/JIT/JIT.xcc"
void
JIT_Test(void (*test)(void))
{
  JIT_INIT();
  (*test)();
  JIT_FINI();
}

#line 120 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/JIT/JIT.xcc"
#if XCC__C
static void
JIT_TEST(void)
{
#include "JIT/JIT_.c"
}

#line 127 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/JIT/JIT.xcc"
int
main(int argc, char **argv)
{
  JIT_Test(JIT_TEST);
  return 0;
}
#endif


#endif//JIT_c_INCLUDED
