#ifndef JIT_h_INCLUDED
#define JIT_h_INCLUDED

/*
 * !!!!	JIT.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

//
#include "CCL.h"
#include "ECL.h"
#include "MDS/MDS.h"
#include "AIR/AIR.h"
#include "LIR/LIR.h"
#include "PFA/PFA.h"
#include "CGO/CGO.h"

/*
 * The JIT (Just-In-Time) compiler library contains the following modules:
 * *	<Compiler Compiler.html> JIT Compiler driver (to do).
 */

//
#include "JIT/Compiler.h"

/*
 * JIT_TRACE --	File handle used to print the JIT traces.
 */
extern FILE *JIT_TRACE;
#ifdef ECL_NTRACE
#define JIT_TRACE NULL
#endif//ECL_NTRACE

/*
 * Variables used to control JIT in non-release mode.
 */

/*
 * JIT_INIT --	Initialize the JIT library.
 */
void
JIT_INIT(void);

/*
 * JIT_FINI --	Finalize the JIT library.
 */
void
JIT_FINI(void);


#endif//JIT_h_INCLUDED
