#ifndef Dependence_c_INCLUDED
#define Dependence_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Dependence.xcc"
#include "LIR/LIR_.h"

#line 21 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Dependence.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 52 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Dependence.xcc"
#ifndef ECL_NTRACE
const char *
DependenceKind_name_(DependenceKind kind)
{
  DependenceKind this = DependenceKind(kind);
  static const char *_[] = {
    "Flow",
    "Anti",
    "Input",
    "Output",
    "Spill",
    "Other",
    "Relax",
    "RAW",
    "WAR",
    "WAW",
    "Life",
    "Link",
    "Reuse",
    "Some",
    "Margin",
  };
  return _[this];
}
#endif//ECL_NTRACE

#line 78 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Dependence.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 98 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Dependence.xcc"
DependenceArc
DependenceArc_Ctor(DependenceArc this,
                   struct Operation_ *tail, struct Operation_ *head,
                   int latency, int omega, DependenceKind kind)
{
  *DependenceArc__TAIL(this) = tail;
  *DependenceArc__HEAD(this) = head;
  *DependenceArc__LATENCY(this) = latency;
  *DependenceArc__OMEGA(this) = omega;
  *DependenceArc__KIND(this) = kind;
  return this;
}

#line 116 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Dependence.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 131 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Dependence.xcc"
DependenceTable
DependenceTable_Ctor(DependenceTable this,
                     Memory memory)
{
  PtrSet_Ctor(DependenceTable_NODES(this), memory, 0);
  IBList_Ctor(DependenceTable_ARCS(this),
              memory, sizeof(DependenceArc_), 30);
  return this;
}

#line 141 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Dependence.xcc"
void
DependenceTable_Dtor(DependenceTable this)
{
  PtrSet_Dtor(DependenceTable_NODES(this));
  IBList_Dtor(DependenceTable_ARCS(this));
}

#line 148 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Dependence.xcc"
size_t
DependenceTable_Size(Memory memory)
{
  return sizeof(DependenceTable_);
}

#line 221 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Dependence.xcc"
DependenceArc
DependenceTable_makeArc(DependenceTable this,
                        Operation tail_operation, Operation head_operation,
                        int latency, int omega, DependenceKind kind) {
  DependenceArc arc = IBList_push(DependenceTable_ARCS(this));
  return DependenceArc_Ctor(arc, tail_operation, head_operation, latency, omega, kind);
}

#line 229 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Dependence.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 235 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Dependence.xcc"
#ifndef ECL_NTRACE
bool
Dependence_DTD(FILE *file)
{
  fputs(
	"<!ENTITY % Operation 'IDREF' >"
        "<!ELEMENT Dependence EMPTY >"
        "<!ATTLIST Dependence"
	"	  OperationTail %Operation; #IMPLIED"
	"	  OperationHead %Operation; #IMPLIED"
	"	  Omega %int32_t; #IMPLIED"
        ">"
       , file);
  return true;
}
#endif//ECL_NTRACE

#line 266 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Dependence.xcc"
#ifndef ECL_NTRACE
bool
Dependence_dumpXML(DependenceArc this, XMLGen gen)
{
  char attval[64]="";
  Operation tail_operation = DependenceArc_TAIL(this);
  Operation head_operation = DependenceArc_HEAD(this);
  XMLGenElement elemDep = XMLGen_declareElement(gen, "Dependence");
  XMLGenAttribute attOperTail = XMLGen_declareAttribute(gen, "OperationTail");
  XMLGenAttribute attOperHead = XMLGen_declareAttribute(gen, "OperationHead");
  XMLGenAttribute attOmega = XMLGen_declareAttribute(gen, "Omega");
  XMLGen_startElement(gen, elemDep);
  sprintf(attval,"Operation_%d", Operation_identity(tail_operation));
  XMLGen_addAttribute(gen, attOperTail, attval);
  sprintf(attval,"Operation_%d", Operation_identity(head_operation));
  XMLGen_addAttribute(gen, attOperHead, attval);
  sprintf(attval, "%d", DependenceArc_OMEGA(this));
  XMLGen_addAttribute(gen, attOmega, attval);
  XMLGen_endEmptyElement(gen);
  return true;
}
#endif//ECL_NTRACE

#line 289 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Dependence.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 301 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Dependence.xcc"
#if XCC__C
static void
Dependence_TEST(void)
{
#include "LIR/Dependence_.c"
}

#line 308 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Dependence.xcc"
int
main(int argc, char **argv)
{
  LIR_Test(Dependence_TEST);
  return 0;
}
#endif


#endif//Dependence_c_INCLUDED
