#ifndef LIR_c_INCLUDED
#define LIR_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LIR.xcc"
#include "LIR/LIR_.h"

#line 27 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LIR.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 73 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LIR.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 192 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LIR.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 206 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LIR.xcc"
#undef LIR_TRACE
FILE *LIR_TRACE = NULL;

#line 227 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LIR.xcc"
int FORCE_ACTIVATION;
int FORCE_CONVERSION;
int FORCE_COALESCING;
int FORCE_PREDICATION;
int FORCE_SCHEDULING;
int FORCE_ALLOCATION;
int FORCE_RCMSSOLVING;
int FORCE_RCMSPROBLEM;
int FORCE_LOGTIMEOUT;
int FORCE_SCOREBOARDING;
int FORCE_WINDOWSIZE;
int FORCE_PREPADDING;
int FORCE_POSTPADDING;
int FORCE_PROFILING;

#line 255 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LIR.xcc"
int FORCE_COMPENSATION;
int FORCE_SPECULATION;
int FORCE_RELAXATION;
int FORCE_PIPELINING;
int FORCE_RENAMING;
int FORCE_BOOSTING;
int FORCE_ALIASING;
int FORCE_PRELOADING;
int FORCE_L1MISSEXTRA;

#line 269 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LIR.xcc"
bool
LIR_IndentXML(FILE *file, int indent)
{
  int i;
  for (i = 0; i < indent; i++) {
    fputc(' ', file);
    fputc(' ', file);
  }
  return true;
}

#line 280 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LIR.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 288 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LIR.xcc"
bool
LIR_Help(FILE *file)
{
  fprintf(file, "FORCE_ACTIVATION= comma separated list of:\n");
  ETable_pretty(OptimizeActivation_Table, " ", file);
  fprintf(file, " Force the activation of LAO phases.\n"
	  " The default is given by the context of invocation.\n\n");
  fprintf(file, "FORCE_CONVERSION= comma separated list of:\n");
  ETable_pretty(OptimizeConversion_Table, " ", file);
  fprintf(file, " Force flags for the SSA construction.\n"
	  " The default value is: ");
  OptimizeConversion_prettyFlags(OptimizeConversion_default, file);
  fprintf(file, "\n\n");
  fprintf(file, "FORCE_COALESCING= comma separated list of:\n");
  ETable_pretty(OptimizeCoalescing_Table, " ", file);
  fprintf(file, " Force flags for the SSA variable coalescing.\n"
	  " The default value is: ");
  OptimizeCoalescing_prettyFlags(OptimizeCoalescing_default, file);
  fprintf(file, "\n\n");
  fprintf(file, "FORCE_ALLOCATION= comma separated list of:\n");
  ETable_pretty(OptimizeAllocation_Table, " ", file);
  fprintf(file, " Force flags for the register allocation.\n"
	  " The default value is: ");
  OptimizeAllocation_prettyFlags(OptimizeAllocation_default, file);
  fprintf(file, "\n\n");
  fprintf(file, "FORCE_RCMSSOLVING= comma separated list of:\n");
  ETable_pretty(OptimizeRCMSSolving_Table, " ", file);
  fprintf(file, " Force flags for the linear programming formulation of modulo scheduling.\n"
	  " The default value is: ");
  OptimizeRCMSSolving_prettyFlags(OptimizeRCMSSolving_default, file);
  fprintf(file, "\n\n");
  fprintf(file, "FORCE_RCMSPROBLEM= comma separated list of:\n");
  ETable_pretty(OptimizeRCMSProblem_Table, " ", file);
  fprintf(file, " Force flags for the resource-constrained modulo scheduling plugin.\n"
	  " The default value is: ");
  OptimizeRCMSProblem_prettyFlags(OptimizeRCMSProblem_default, file);
  fprintf(file, "\n\n");
  fprintf(file, "FORCE_PROFILING= comma separated list of:\n");
  ETable_pretty(OptimizeProfiling_Table, " ", file);
  fprintf(file, " Force flags for the profiling information type.\n"
	  " The default value is: ");
  OptimizeProfiling_prettyFlags(OptimizeProfiling_default, file);
  fprintf(file, "\n\n");
  return true;
}

#line 339 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LIR.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 347 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LIR.xcc"
static int LIR_Initialized = 0;

#line 349 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LIR.xcc"
void
LIR_INIT(void)
{
  if (LIR_Initialized++ == 0) {
    CCL_INIT();
    MDS_INIT();
    AIR_INIT();
    Optimize_INIT();
    Configure_INIT();
    Temporary_INIT();
    Operation_INIT();
    Variable_INIT();
    Selector_INIT();
    BasicBlock_INIT();
    Dependence_INIT();
    LoopScope_INIT();
    CodeRegion_INIT();
    Procedure_INIT();
    Program_INIT();

#line 369 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LIR.xcc"
    if (GETENV("HELP")) {
      LIR_Help(stderr);
    }
    FORCE_ACTIVATION = -1;
    if (GETENV("FORCE_ACTIVATION")) {
      FORCE_ACTIVATION = OptimizeActivation_parseFlags(GETENV("FORCE_ACTIVATION"));
      fprintf(stderr, "*** FORCE_ACTIVATION=");
      OptimizeActivation_prettyFlags(FORCE_ACTIVATION, stderr);
      fprintf(stderr, "\n");
    }
    FORCE_CONVERSION = -1;
    if (GETENV("FORCE_CONVERSION")) {
      FORCE_CONVERSION = OptimizeConversion_parseFlags(GETENV("FORCE_CONVERSION"));
      fprintf(stderr, "*** FORCE_CONVERSION=");
      OptimizeConversion_prettyFlags(FORCE_CONVERSION, stderr);
      fprintf(stderr, "\n");
    }
    FORCE_COALESCING = -1;
    if (GETENV("FORCE_COALESCING")) {
      FORCE_COALESCING = OptimizeCoalescing_parseFlags(GETENV("FORCE_COALESCING"));
      fprintf(stderr, "*** FORCE_COALESCING=");
      OptimizeCoalescing_prettyFlags(FORCE_COALESCING, stderr);
      fprintf(stderr, "\n");
    }
    FORCE_PREDICATION = -1;
    if (GETENV("FORCE_PREDICATION")) {
      sscanf(GETENV("FORCE_PREDICATION"), "%d", &FORCE_PREDICATION);
      fprintf(stderr, "*** FORCE_PREDICATION=%d\n", FORCE_PREDICATION);
    }
    FORCE_SCHEDULING = -1;
    if (GETENV("FORCE_SCHEDULING")) {
      sscanf(GETENV("FORCE_SCHEDULING"), "%d", &FORCE_SCHEDULING);
      fprintf(stderr, "*** FORCE_SCHEDULING=%d\n", FORCE_SCHEDULING);
    }
    FORCE_ALLOCATION = -1;
    if (GETENV("FORCE_ALLOCATION")) {
      FORCE_ALLOCATION = OptimizeAllocation_parseFlags(GETENV("FORCE_ALLOCATION"));
      fprintf(stderr, "*** FORCE_ALLOCATION=");
      OptimizeAllocation_prettyFlags(FORCE_ALLOCATION, stderr);
      fprintf(stderr, "\n");
    }
    FORCE_RCMSSOLVING = -1;
    if (GETENV("FORCE_RCMSSOLVING")) {
      FORCE_RCMSSOLVING = OptimizeRCMSSolving_parseFlags(GETENV("FORCE_RCMSSOLVING"));
      fprintf(stderr, "*** FORCE_RCMSSOLVING=");
      OptimizeRCMSSolving_prettyFlags(FORCE_RCMSSOLVING, stderr);
      fprintf(stderr, "\n");
    }
    FORCE_RCMSPROBLEM = -1;
    if (GETENV("FORCE_RCMSPROBLEM")) {
      FORCE_RCMSPROBLEM = OptimizeRCMSProblem_parseFlags(GETENV("FORCE_RCMSPROBLEM"));
      fprintf(stderr, "*** FORCE_RCMSPROBLEM=");
      OptimizeRCMSProblem_prettyFlags(FORCE_RCMSPROBLEM, stderr);
      fprintf(stderr, "\n");
    }
    FORCE_LOGTIMEOUT = -1;
    if (GETENV("FORCE_LOGTIMEOUT")) {
      FORCE_LOGTIMEOUT = OptimizeLogTimeOut_parseFlags(GETENV("FORCE_LOGTIMEOUT"));
      fprintf(stderr, "*** FORCE_LOGTIMEOUT=");
      OptimizeLogTimeOut_prettyFlags(FORCE_LOGTIMEOUT, stderr);
      fprintf(stderr, "\n");
    }
    FORCE_PROFILING = -1;
    if (GETENV("FORCE_PROFILING")) {
      FORCE_PROFILING = OptimizeProfiling_parseFlags(GETENV("FORCE_PROFILING"));
      fprintf(stderr, "*** FORCE_PROFILING=");
      OptimizeProfiling_prettyFlags(FORCE_PROFILING, stderr);
      fprintf(stderr, "\n");
    }
    FORCE_SCOREBOARDING = -1;
    if (GETENV("FORCE_SCOREBOARDING")) {
      sscanf(GETENV("FORCE_SCOREBOARDING"), "%d", &FORCE_SCOREBOARDING);
      fprintf(stderr, "*** FORCE_SCOREBOARDING=%d\n", FORCE_SCOREBOARDING);
    }
    FORCE_WINDOWSIZE = -1;
    if (GETENV("FORCE_WINDOWSIZE")) {
      sscanf(GETENV("FORCE_WINDOWSIZE"), "%d", &FORCE_WINDOWSIZE);
      fprintf(stderr, "*** FORCE_WINDOWSIZE=%d\n", FORCE_WINDOWSIZE);
    }
    FORCE_PREPADDING = -1;
    if (GETENV("FORCE_PREPADDING")) {
      sscanf(GETENV("FORCE_PREPADDING"), "%d", &FORCE_PREPADDING);
      fprintf(stderr, "*** FORCE_PREPADDING=%d\n", FORCE_PREPADDING);
    }
    FORCE_POSTPADDING = -1;
    if (GETENV("FORCE_POSTPADDING")) {
      sscanf(GETENV("FORCE_POSTPADDING"), "%d", &FORCE_POSTPADDING);
      fprintf(stderr, "*** FORCE_POSTPADDING=%d\n", FORCE_POSTPADDING);
    }
    //
    FORCE_COMPENSATION = -1;
    if (GETENV("FORCE_COMPENSATION")) {
      sscanf(GETENV("FORCE_COMPENSATION"), "%d", &FORCE_COMPENSATION);
      fprintf(stderr, "*** FORCE_COMPENSATION=%d\n", FORCE_COMPENSATION);
    }
    FORCE_SPECULATION = -1;
    if (GETENV("FORCE_SPECULATION")) {
      sscanf(GETENV("FORCE_SPECULATION"), "%d", &FORCE_SPECULATION);
      fprintf(stderr, "*** FORCE_SPECULATION=%d\n", FORCE_SPECULATION);
    }
    FORCE_RELAXATION = -1;
    if (GETENV("FORCE_RELAXATION")) {
      sscanf(GETENV("FORCE_RELAXATION"), "%d", &FORCE_RELAXATION);
      fprintf(stderr, "*** FORCE_RELAXATION=%d\n", FORCE_RELAXATION);
    }
    FORCE_PIPELINING = -1;
    if (GETENV("FORCE_PIPELINING")) {
      sscanf(GETENV("FORCE_PIPELINING"), "%d", &FORCE_PIPELINING);
      fprintf(stderr, "*** FORCE_PIPELINING=%d\n", FORCE_PIPELINING);
    }
    FORCE_RENAMING = -1;
    if (GETENV("FORCE_RENAMING")) {
      sscanf(GETENV("FORCE_RENAMING"), "%d", &FORCE_RENAMING);
      fprintf(stderr, "*** FORCE_RENAMING=%d\n", FORCE_RENAMING);
    }
    FORCE_BOOSTING = -1;
    if (GETENV("FORCE_BOOSTING")) {
      sscanf(GETENV("FORCE_BOOSTING"), "%d", &FORCE_BOOSTING);
      fprintf(stderr, "*** FORCE_BOOSTING=%d\n", FORCE_BOOSTING);
    }
    FORCE_ALIASING = -1;
    if (GETENV("FORCE_ALIASING")) {
      sscanf(GETENV("FORCE_ALIASING"), "%d", &FORCE_ALIASING);
      fprintf(stderr, "*** FORCE_ALIASING=%d\n", FORCE_ALIASING);
    }
    FORCE_PRELOADING = -1;
    if (GETENV("FORCE_PRELOADING")) {
      sscanf(GETENV("FORCE_PRELOADING"), "%d", &FORCE_PRELOADING);
      fprintf(stderr, "*** FORCE_PRELOADING=%d\n", FORCE_PRELOADING);
    }
    FORCE_L1MISSEXTRA = -1;
    if (GETENV("FORCE_L1MISSEXTRA")) {
      sscanf(GETENV("FORCE_L1MISSEXTRA"), "%d", &FORCE_L1MISSEXTRA);
      fprintf(stderr, "*** FORCE_L1MISSEXTRA=%d\n", FORCE_L1MISSEXTRA);
    }
    if (GETENV("LIR_TRACE")) {
      int file = 0;
      sscanf(GETENV("LIR_TRACE"), "%d", &file);
      if (file == 1) LIR_TRACE = stdout;
      else if (file == 2) LIR_TRACE = stderr;
    }
  }
}

#line 519 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LIR.xcc"
void
LIR_FINI(void)
{
  if (--LIR_Initialized == 0) {
    Program_FINI();
    Procedure_FINI();
    CodeRegion_FINI();
    LoopScope_FINI();
    Dependence_FINI();
    BasicBlock_FINI();
    Selector_FINI();
    Variable_FINI();
    Operation_FINI();
    Temporary_FINI();
    Configure_FINI();
    Optimize_FINI();
    AIR_FINI();
    MDS_FINI();
    CCL_FINI();
  }
}

#line 547 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LIR.xcc"
void
LIR_Test(void (*test)(void))
{
  LIR_INIT();
  (*test)();
  LIR_FINI();
}

#line 555 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LIR.xcc"
#if XCC__C
static void
LIR_TEST(void)
{
#include "LIR/LIR_.c"
}

#line 562 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LIR.xcc"
int
main(int argc, char **argv)
{
  LIR_Test(LIR_TEST);
  return 0;
}
#endif


#endif//LIR_c_INCLUDED
