#ifndef LoopScope_c_INCLUDED
#define LoopScope_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
#include "LIR/LIR_.h"

#line 26 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 42 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
#ifndef ECL_NTRACE
ETableEntry_ LoopScopeFlagEntries[] = {
  ETableENTRY(LoopScopeFlag, Inner),
  ETableENTRY(LoopScopeFlag, Simple),
  ETableENTRY(LoopScopeFlag, Hardware),
  ETableENTRY(LoopScopeFlag, Remainder),
  ETableENTRY_NULL
};
ETable_ LoopScopeFlag_Table[1];
#endif//ECL_NTRACE

#line 112 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
LoopScope
LoopScope_Ctor(LoopScope this,
               Memory memory, BasicBlock headerBlock, Configure configure)
{
  Indexed_Ctor(LoopScope____(this), LoopScope_Factory);
  *LoopScope__MEMORY(this) = memory;
  *LoopScope__HEADERBLOCK(this) = headerBlock;
  *LoopScope__TRIPCOUNT(this) = NULL;
  *LoopScope__PARENT(this) = NULL;
  *LoopScope__DEPENDENCETABLE(this) = NULL;
  Configure_Copy(LoopScope_CONFIGURE(this), configure);
  *LoopScope__FLAGS(this) = 0;
  *LoopScope__NESTING(this) = 0;
  *LoopScope__BLOCKCOUNT(this) = 0;
  *LoopScope__PEELCOUNT(this) = 0;
  *LoopScope__UNROLLED(this) = 0;
  *LoopScope__KUNROLL(this) = 0;
  *LoopScope__LAMBDA(this) = 0;
  *LoopScope__LENGTH(this) = 0;
  *LoopScope__LATENCY(this) = 0;
  *LoopScope__DISTANCE(this) = 0;
  return this;
}

#line 136 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
void
LoopScope_Dtor(LoopScope this)
{
  LoopScope_killDependenceTable(this);
}

#line 142 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
size_t
LoopScope_Size(Memory memory, BasicBlock headerBlock, Configure configure)
{
  return sizeof(LoopScope_);
}

#line 153 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 302 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
DependenceTable
LoopScope_makeDependenceTable(LoopScope this)
{
  DependenceTable dependenceTable = LoopScope_DEPENDENCETABLE(this);
  if (dependenceTable == NULL) {
    Memory memory = LoopScope_MEMORY(this);
    size_t size = DependenceTable_Size(memory);
    dependenceTable = Memory_alloc(memory, size);
    DependenceTable_Ctor(dependenceTable, memory);
    *LoopScope__DEPENDENCETABLE(this) = dependenceTable;
  }
  return dependenceTable;
}

#line 322 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
void
LoopScope_killDependenceTable(LoopScope this)
{
  DependenceTable dependenceTable = LoopScope_DEPENDENCETABLE(this);
  if (dependenceTable != NULL) {
    Memory memory = LoopScope_MEMORY(this);
    DependenceTable_Dtor(dependenceTable);
    Memory_free_(memory, dependenceTable);
  }
  *LoopScope__DEPENDENCETABLE(this) = NULL;
}

#line 349 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
void
LoopScope_transfer(LoopScope this, LoopScope that)
{
  Except_REQUIRE(LoopScope_DEPENDENCETABLE(this) == NULL);
  *LoopScope__DEPENDENCETABLE(this) = LoopScope_DEPENDENCETABLE(that);
  *LoopScope__DEPENDENCETABLE(that) = NULL;
  *LoopScope_CONFIGURE(this) = *LoopScope_CONFIGURE(that);
}

#line 365 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
void
LoopScope_update(LoopScope this, LoopScope parent_scope,
                int blockCount, bool isSimpleLoop, bool isInnerLoop)
{
  LoopScopeFlags flags = LoopScope_FLAGS(this);
  Except_REQUIRE(parent_scope != this);
  *LoopScope__PARENT(this) = parent_scope;
  *LoopScope__BLOCKCOUNT(this) = blockCount;
  *LoopScope__NESTING(this) = LoopScope_NESTING(parent_scope) + 1;
  flags &= ~(LoopScopeFlag_Inner | LoopScopeFlag_Simple);
  if (isInnerLoop) flags |= LoopScopeFlag_Inner;
  if (isSimpleLoop) flags |= LoopScopeFlag_Simple;
  *LoopScope__FLAGS(this) = flags;
}

#line 380 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 388 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
#ifndef ECL_NTRACE
bool
LoopScope_pretty(const_LoopScope this, FILE *file)
{
  if (file == NULL) file = stderr;
  fprintf(file, "    LoopScope_%d:", LoopScope_IDENTITY(this));
  fprintf(file, "\n\tconfigure:");
  Configure_pretty(LoopScope_CONFIGURE(this), file);
  fprintf(file, "\n\tattributes:");
  if (LoopScope_HEADERBLOCK(this) != NULL) {
    BasicBlock headerBlock = LoopScope_HEADERBLOCK(this);
    fprintf(file, "\theader=%d:Block_%d",
        BasicBlock_identity(headerBlock),
        BasicBlock_index(headerBlock));
  }
  if (LoopScope_PARENT(this) != NULL) {
    fprintf(file, "\tparent=LoopScope_%d", LoopScope_IDENTITY(LoopScope_PARENT(this)));
  }
  if (LoopScope_isInner(this)) fprintf(file, "\tisInner");
  if (LoopScope_isSimple(this)) fprintf(file, "\tisSimple");
  if (LoopScope_isHardware(this)) fprintf(file, "\tisHardware");
  if (LoopScope_isRemainder(this)) fprintf(file, "\tisRemainder");
  if (LoopScope_TRIPCOUNT(this) != NULL) {
    fprintf(file, "\ttripCount=");
    Temporary_pretty(LoopScope_TRIPCOUNT(this), file);
  }
  if (LoopScope_UNROLLED(this) != 0) {
    fprintf(file, "\tunrolled=%d", LoopScope_UNROLLED(this));
  }
  fprintf(file, "\n");
  if (LoopScope_DEPENDENCETABLE(this) != NULL) {
    DependenceTable_FOREACH_DependenceArc(LoopScope_DEPENDENCETABLE(this), arc) {
      Operation tail_operation = DependenceArc_TAIL(arc);
      Operation head_operation = DependenceArc_HEAD(arc);
      uint32_t tail_identity = Operation_identity(tail_operation);
      uint32_t head_identity = Operation_identity(head_operation);
      int omega = DependenceArc_OMEGA(arc);
      fprintf(file, "\t(%d:,%d:)=>%d", tail_identity, head_identity, omega);
    } DependenceTable_ENDEACH_DependenceArc;
    fprintf(file, "\n");
  }
  return true;
}
#endif//ECL_NTRACE

#line 433 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
//////////////////////////////////////////////////////////////////////////////

#line 439 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
#ifndef ECL_NTRACE
bool
LoopScope_DTD(FILE *file)
{
  fputs(
	"<!ENTITY % Temporary 'IDREF' >"
	"<!ENTITY % Parent 'IDREF' >"
        "<!ELEMENT LoopScope (Dependence)* >"
        "<!ATTLIST LoopScope"
	"	HeaderBlock %BasicBlock; #IMPLIED"
	"	Parent %Parent; #IMPLIED "
	"	TripCount %Temporary; #IMPLIED" 
	"	Flags NMTOKENS #IMPLIED"
	"	Nesting %int16_t; #IMPLIED"
	"	BlockCount %int16_t; #IMPLIED"
	"	Unrolled %int16_t; #IMPLIED"
	"	Kunrolled %int16_t; #IMPLIED"
	"	Lambda %int16_t; #IMPLIED"
	"	Length %int16_t; #IMPLIED"
	"	Latency %int16_t; #IMPLIED"
	"	Distance %int16_t; #IMPLIED"
	"	Processor NMTOKEN #IMPLIED"
	"	Compensation NMTOKEN #IMPLIED"
	"	Speculation NMTOKEN #IMPLIED"
	"	Relaxation NMTOKEN #IMPLIED"
	"	Renaming NMTOKEN #IMPLIED"
	"	Boosting NMTOKEN #IMPLIED"
	"	Aliasing NMTOKEN #IMPLIED"
	"	TripModulus NMTOKEN #IMPLIED "
	"	TripResidue NMTOKEN #IMPLIED"
	"	Pipelining NMTOKEN #IMPLIED"
	"	PreLoading NMTOKEN #IMPLIED"
	"	L1MissExtra NMTOKEN #IMPLIED"
        ">"
       , file);
  return true;
}
#endif//ECL_NTRACE

#line 491 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
#ifndef ECL_NTRACE
bool
LoopScope_dumpXML(LoopScope this, XMLGen gen)
{
  int arcs=0, i;
  char attval[64]="";
  Configure configure = LoopScope_configure(this);
  XMLGenElement elemLoop = XMLGen_declareElement(gen, "LoopScope");
  XMLGenAttribute attHeader = XMLGen_declareAttribute(gen, "HeaderBlock");
  XMLGenAttribute attUnroll = XMLGen_declareAttribute(gen, "Unrolled");
  XMLGenAttribute attParent = XMLGen_declareAttribute(gen, "Parent");
  XMLGenAttribute attTrip = XMLGen_declareAttribute(gen, "TripCount");
  XMLGenAttribute attFlags = XMLGen_declareAttribute(gen, "Flags");
  XMLGen_startElement(gen, elemLoop);
  if (LoopScope_HEADERBLOCK(this) != NULL) {
    BasicBlock headerBlock = LoopScope_HEADERBLOCK(this);
    sprintf(attval, "BasicBlock_%d",  BasicBlock_identity(headerBlock));
    XMLGen_addAttribute(gen, attHeader, attval);
  }
  if (LoopScope_PARENT(this) != NULL) {
    sprintf(attval, "LoopScope_%d", LoopScope_IDENTITY(LoopScope_PARENT(this)));
    XMLGen_addAttribute(gen, attParent, attval);
  }
  if (LoopScope_UNROLLED(this) != 0) {
    sprintf(attval, "%d", LoopScope_UNROLLED(this));
    XMLGen_addAttribute(gen, attUnroll, attval);
  }
  if (LoopScope_TRIPCOUNT(this) != NULL) {
    Temporary trip = LoopScope_TRIPCOUNT(this);
    sprintf(attval, "Temporary_%d", Temporary_IDENTITY(trip));
    XMLGen_addAttribute(gen, attTrip, attval);
  }
  attval[0]='\0';
  for (i = 0; i < ConfigureItem__; i++) {
    const char *name = ConfigureItem_name_(i);
    int value = Configure_ITEMS(configure)[i];
    if (value >= 0){
      sprintf(attval, "%d",value);
      XMLGen_addAttributeLiteral(gen, name, attval);
    }
  }
  attval[0]='\0';
  if (LoopScope_isInner(this))
    sprintf(attval, "%s Inner ", attval);
  if (LoopScope_isSimple(this))
    sprintf(attval, "%s Simple ", attval);
  if (LoopScope_isHardware(this))
    sprintf(attval, "%s Hardware ", attval);
  if (LoopScope_isRemainder(this))
    sprintf(attval, "%s Remainder ", attval);
  if (LoopScope_isCounted(this))
    sprintf(attval, "%s Counted ", attval);
  if (strcmp(attval,"\0"))
   XMLGen_addAttribute(gen, attFlags, attval);
  if (LoopScope_DEPENDENCETABLE(this) != NULL) {
    DependenceTable_FOREACH_DependenceArc(LoopScope_DEPENDENCETABLE(this), arc) {
      arcs=1;
      Dependence_dumpXML(arc, gen);
    } DependenceTable_ENDEACH_DependenceArc;
    if (arcs)
      XMLGen_endElement(gen);
    else
      XMLGen_endEmptyElement(gen);
  }
  else{
    XMLGen_endEmptyElement(gen);
  }
  return true;
}
#endif//ECL_NTRACE

#line 562 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 570 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
IndexedFactory_ LoopScope_Factory[1];

#line 572 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
void
LoopScope_INIT(void)
{
  IndexedFactory_Ctor(LoopScope_Factory);
#ifndef ECL_NTRACE
  ETable_Ctor(LoopScopeFlag_Table, Memory_Root, LoopScopeFlagEntries);
#endif//ECL_NTRACE
}

#line 591 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
#ifndef ECL_NTRACE
void
LoopScope_FINI(void)
{
  ETable_Dtor(LoopScopeFlag_Table);
}
#endif//ECL_NTRACE

#line 599 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
#if XCC__C
static void
LoopScope_TEST(void)
{
#include "LIR/LoopScope_.c"
}

#line 606 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/LoopScope.xcc"
int
main(int argc, char **argv)
{
  LIR_Test(LoopScope_TEST);
  return 0;
}
#endif


#endif//LoopScope_c_INCLUDED
