#ifndef Operation_c_INCLUDED
#define Operation_c_INCLUDED

#line 17 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
#include "LIR/LIR_.h"

#line 27 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 54 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
#ifndef ECL_NTRACE
ETableEntry_ OperationFlagEntries[] = {
  ETableENTRY(OperationFlag, PartialDef),
  ETableENTRY(OperationFlag, SpillCode),
  ETableENTRY(OperationFlag, Volatile),
  ETableENTRY(OperationFlag, SPUpdate),
  ETableENTRY(OperationFlag, Prefetch),
  ETableENTRY(OperationFlag, Preload),
  ETableENTRY(OperationFlag, Barrier),
  ETableENTRY(OperationFlag, Clobber),
  ETableENTRY(OperationFlag, Hoisted),
  ETableENTRY(OperationFlag, DeadCode),
  ETableENTRY(OperationFlag, Processed),
  ETableENTRY(OperationFlag, SafeAccess),
  ETableENTRY(OperationFlag, SafePerfs),
  ETableENTRY(OperationFlag, EntryCode),
  ETableENTRY(OperationFlag, ExitCode),
  ETableENTRY_NULL
};
ETable_ OperationFlag_Table[1];
#endif//ECL_NTRACE

#line 167 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
Operation
Operation_Ctor(Operation this,
               Operator operator, int32_t resCount, int32_t arcCount,
               const_RegisterSet clobberSet, struct BasicBlock_ *basicBlock)
{
  Indexed_Ctor(Operation____(this), Operation_Factory);
  *Operation__REPLICATED(this) = NULL;
  *Operation__BASICBLOCK(this) = basicBlock;
  *Operation__TASK(this) = NULL;
  *Operation__OPERATOR(this) = operator;
  *Operation__FLAGS(this) = clobberSet != NULL? OperationFlag_Clobber: 0;
  *Operation__ORDERING(this) = 0;
  *Operation__BOOSTING(this) = 0;
  *Operation__ITERATION(this) = 0;
  *Operation__STARTDATE(this) = -1;
  *Operation__RESCOUNT(this) = resCount;
  *Operation__ARGCOUNT(this) = arcCount;
  *Operation__OPERANDS(this) = NULL;
  *Operation__REGISTERS(this) = NULL;
  *Operation__MAXCOUNT(this) = 0;
  if (clobberSet != NULL) {
    RegisterSet_Copy(Operation_CLOBBERSET(this), clobberSet);
  }
  return this;
}

#line 193 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
size_t
Operation_Size(Operator operator, int32_t resCount, int32_t arcCount,
               const_RegisterSet clobberSet, struct BasicBlock_ *basicBlock)
{
  return (sizeof(Operation_) + (clobberSet != NULL? sizeof(RegisterSet_): 0));
}

#line 205 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 536 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
void
Operation_makeRegisters(Operation this)
{
  int32_t operandCount = Operation_operandCount(this);
  Register *registers = Operation_REGISTERS(this);
  BasicBlock basicBlock = Operation_BASICBLOCK(this);
  Selector selector = BasicBlock_SELECTOR(basicBlock);
  Memory memory = Selector_MEMORY(selector);
  Except_CHECK(registers == NULL);
  Except_CHECK(!Operator_isParCopy(Operation_operator(this)));
  Except_CHECK(Operation_operator(this) != Operator_PHI);
  registers = Memory_alloc(memory, operandCount*sizeof(Register));
  Operation_OPERANDS_FOREACH_Temporary(this, temporary) {
    Register registre = Register__UNDEF;
    if (Temporary_hasRegister(temporary)) {
      registre = Temporary_REGISTER(temporary);
    }
    registers[Operation_OPERANDS_INDEX] = registre;
  } Operation_OPERANDS_ENDEACH_Temporary;
  *Operation__REGISTERS(this) = registers;
}

#line 706 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 716 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
void
Operation_refreshFlags(Operation this, Register stackRegister)
{
  Operation_RESULTS_FOREACH_Temporary(this, result) {
    if (   Temporary_hasRegister(result)
        && Temporary_REGISTER(result) == stackRegister) {
      *Operation__FLAGS(this) |= OperationFlag_SPUpdate;
      break;
    }
  } Operation_RESULTS_ENDEACH_Temporary;
}

#line 734 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
bool
Operation_isCritical(const_Operation this)
{
  Operator operator = Operation_OPERATOR(this);
  unsigned flags = Operation_FLAGS(this);
  if (  flags
      & (  OperationFlag_Volatile
         | OperationFlag_SPUpdate
         | OperationFlag_Prefetch
         | OperationFlag_Barrier /*
         | OperationFlag_EntryCode
         | OperationFlag_ExitCode */)) return true;
  if (Operation_resCount(this) == 0) return true;
  Operation_RESULTS_FOREACH_Temporary(this, result) {
    if (!Temporary_isVariable(result)) return true;
  } Operation_RESULTS_ENDEACH_Temporary;
  if (Operator_isControl(operator)) return true;
  if (Operator_isMemoryEffect(operator)) return true;
  return false;
}

#line 763 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
bool
Operation_hasDedicatedResult(const_Operation this, bool alsoConstant)
{
  if (alsoConstant) {
    Operation_RESULTS_FOREACH_Temporary(this, temporary) {
      if (Temporary_isDedicated(temporary)) return true;
    } Operation_RESULTS_ENDEACH_Temporary;
  } else {
    Operation_RESULTS_FOREACH_Temporary(this, temporary) {
      if (Temporary_isDedicated(temporary) &&
          !Temporary_isConstant(temporary)) return true;
    } Operation_RESULTS_ENDEACH_Temporary;
  }
  return false;
}

#line 787 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
bool
Operation_hasDedicatedArgument(const_Operation this, bool alsoConstant)
{
  if (alsoConstant) {
    Operation_ARGUMENTS_FOREACH_Temporary(this, temporary) {
      if (Temporary_isDedicated(temporary)) return true;
    } Operation_ARGUMENTS_ENDEACH_Temporary;
  } else {
    Operation_ARGUMENTS_FOREACH_Temporary(this, temporary) {
      if (Temporary_isDedicated(temporary) &&
          !Temporary_isConstant(temporary)) return true;
    } Operation_ARGUMENTS_ENDEACH_Temporary;
  }
  return false;
}

#line 809 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
void
Operation_getDedicatedResults(const_Operation this, RegisterSet dedicatedSet)
{
  Operation_RESULTS_FOREACH_Temporary(this, temporary) {
    if (Temporary_isDedicated(temporary)) {
      Register registre = Temporary_REGISTER(temporary);
      RegisterSet_insert(dedicatedSet, registre);
    }
  } Operation_RESULTS_ENDEACH_Temporary;
}

#line 826 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
void
Operation_getDedicatedArguments(const_Operation this, RegisterSet dedicatedSet)
{
  Operation_ARGUMENTS_FOREACH_Temporary(this, temporary) {
    if (Temporary_isDedicated(temporary)) {
      Register registre = Temporary_REGISTER(temporary);
      RegisterSet_insert(dedicatedSet, registre);
    }
  } Operation_ARGUMENTS_ENDEACH_Temporary;
}

#line 843 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
int32_t
Operation_appendResult(Operation this, Temporary temporary)
{
  int32_t resCount = Operation_RESCOUNT(this), i;
  Temporary *results = Operation_RESULTS(this);
  Except_REQUIRE(Operation_MAINEFFECTS(this) == NULL);
  for (i = 0; i < resCount; i++) {
    if (results[i] == NULL) {
      results[i] = temporary;
      return i;
    }
  }
  Except_NEVER(true);
  return -1;
}

#line 865 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
int32_t
Operation_appendArgument(Operation this, Temporary temporary)
{
  int32_t argCount = Operation_ARGCOUNT(this), i;
  Temporary *arguments = Operation_ARGUMENTS(this);
  Except_REQUIRE(Operation_MAINEFFECTS(this) == NULL);
  for (i = 0; i < argCount; i++) {
    if (arguments[i] == NULL) {
      arguments[i] = temporary;
      return i;
    }
  }
  Except_NEVER(true);
  return -1;
}

#line 931 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
void
Operation_resizeOperands(Operation this, int32_t resCount, int32_t argCount)
{
  int32_t old_resCount = Operation_RESCOUNT(this), i;
  int32_t old_argCount = Operation_ARGCOUNT(this), j;
  int32_t old_clp2 = HackerU32_clp2(old_resCount + old_argCount);
  Temporary *old_operands = Operation_OPERANDS(this);
  Temporary *old_results = old_operands + 0;
  Temporary *old_arguments = old_operands + old_resCount;
  if (resCount + argCount <= old_clp2) {
    // No need to reallocate operands.
    Temporary *results = old_results;
    Temporary *arguments = old_operands + resCount;
    int32_t min_argCount = old_argCount < argCount? old_argCount: argCount;
    if (resCount > old_resCount) {
      // Move right the arguments by old_resCount - resCount positions.
      for (j = min_argCount - 1; j >= 0; j--) arguments[j] = old_arguments[j];
    } else
    if (resCount < old_resCount) {
      // Move left the arguments by old_resCount - resCount positions.
      for (j = 0; j < min_argCount; j++) arguments[j] = old_arguments[j];
    }
    // Clear the unused results.
    for (i = old_resCount; i < resCount; i++) results[i] = NULL;
    // Clear the unused arguments.
    for (j = min_argCount; j < old_argCount + old_resCount - resCount; j++) {
      arguments[j] = NULL;
    }
  } else {
    // Need to allocate new OPERANDS array.
    BasicBlock basicBlock = Operation_BASICBLOCK(this);
    Selector selector = BasicBlock_SELECTOR(basicBlock);
    Memory memory = Selector_MEMORY(selector);
    int32_t clp2Size = HackerU32_clp2(resCount + argCount)*sizeof(Temporary);
    Temporary *operands = memset(Memory_alloc(memory, clp2Size), 0, clp2Size);
    Temporary *results = operands + 0;
    Temporary *arguments = operands + resCount;
    // Copy results.
    if (old_resCount > resCount) old_resCount = resCount;
    for (i = 0; i < old_resCount; i++) results[i] = old_results[i];
    // Copy arguments.
    if (old_argCount > argCount) old_argCount = argCount;
    for (j = 0; j < old_argCount; j++) arguments[j] = old_arguments[j];
    *Operation__OPERANDS(this) = operands;
    Memory_free(memory, old_operands);
  }
  *Operation__ARGCOUNT(this) = argCount;
  *Operation__RESCOUNT(this) = resCount;
}

#line 1015 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1059 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
bool
Operation_maySpeculate(const_Operation this, Processor processor, int speculation)
{
  Operator operator = Operation_OPERATOR(this);
  OperationFlags this_flags = Operation_FLAGS(this);
  OperationFlags forbid_flags = OperationFlag_Volatile
                              | OperationFlag_SPUpdate
                              | OperationFlag_Prefetch
                              | OperationFlag_Barrier
                              | OperationFlag_EntryCode
                              | OperationFlag_ExitCode;
  OperationFlags allow_flags = OperationFlag_SafeAccess;
  int this_speculation = ConfigureSpeculation_SafeArith;
  if (this_flags & forbid_flags) return false;
  if (Operator_isControl(operator)) return false;
  if (    Operator_isStalling(operator)
      && !(this_flags & OperationFlag_SafePerfs)) return false;
  if (Operator_isMemoryEffect(operator)) return false;
  if (Operator_isMemoryRead(operator)) {
    this_speculation = ConfigureSpeculation_MayExcept;
    if (   (this_flags & allow_flags)
        || Operator_isSafeLoad(operator)) {
      this_speculation = ConfigureSpeculation_SafeAccess;
    } else {
      Operator speculate = Operator_speculate(operator, processor);
      if (speculate != operator && speculate != Operator__UNDEF) {
        this_speculation = ConfigureSpeculation_SafeVariant;
      }
    }
  }
  if (this_speculation > speculation) return false;
  return true;
}

#line 1101 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
void
Operation_speculate(Operation this, Processor processor)
{
  if (!Operation_isSafeAccess(this)) {
    Operator operator = Operator_speculate(Operation_OPERATOR(this), processor);
    Except_CHECK(operator != Operator__UNDEF);
    *Operation__OPERATOR(this) = operator;
  }
}

#line 1117 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
bool
Operation_mayCompensate(const_Operation this, Processor processor, int compensation)
{
  Operator operator = Operation_OPERATOR(this);
  OperationFlags this_flags = Operation_FLAGS(this);
  OperationFlags forbid_flags = OperationFlag_Volatile
                              | OperationFlag_SPUpdate
                              | OperationFlag_Prefetch
                              | OperationFlag_Barrier
                              | OperationFlag_EntryCode
                              | OperationFlag_ExitCode;
  OperationFlags allow_flags = OperationFlag_SafeAccess;
  int this_compensation = ConfigureCompensation_Local;
  if (this_flags & forbid_flags) return false;
  if (Operator_isControl(operator)) return false;
  if (Operator_isMemory(operator)) {
    this_compensation = ConfigureCompensation_Global;
  }
  if (Operator_isMemoryRead(operator)) {
    if (   (this_flags & allow_flags)
        || Operator_isSafeLoad(operator)) {
      this_compensation = ConfigureCompensation_Local;
    }
  }
  if (this_compensation > compensation) return false;
  return true;
}

#line 1151 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
bool
Operation_mayPredicatePositive(const_Operation this, Processor processor)
{
  Operator operator = Operator_predicatePositive(Operation_OPERATOR(this), processor);
  return operator != Operator__UNDEF;
}

#line 1164 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
bool
Operation_mayPredicateNegative(const_Operation this, Processor processor)
{
  Operator operator = Operator_predicateNegative(Operation_OPERATOR(this), processor);
  return operator != Operator__UNDEF;
}

#line 1178 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
bool
Operation_predicate(Operation this, Processor processor,
                    Temporary predicate, int polarity)
{
  Temporary *arguments = NULL;
  int32_t resCount = Operation_RESCOUNT(this);
  int32_t argCount = Operation_ARGCOUNT(this);
  Operator operator = Operation_OPERATOR(this);
  Operator predicated = polarity > 0?
                        Operator_predicatePositive(operator, processor):
                        Operator_predicateNegative(operator, processor);
  int32_t predicateIndex = Operator_predicateIndex(predicated), argIndex;
  if ((predicated != Operator__UNDEF && predicateIndex >= 0)) {
    Operation_resizeOperands(this, resCount, argCount + 1);
    arguments = Operation_ARGUMENTS(this);
    for (argIndex = argCount - 1; argIndex >= predicateIndex; argIndex--) {
      arguments[argIndex + 1] = arguments[argIndex];
    }
    arguments[predicateIndex] = predicate;
    *Operation__OPERATOR(this) = predicated;
    return true;
  }
  return false;
}

#line 1209 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
bool
Operation_mayUnpredicate(const_Operation this, Processor processor)
{
  Operator operator = Operator_unpredicate(Operation_OPERATOR(this), processor);
  return operator != Operator__UNDEF;
}

#line 1222 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
void
Operation_unpredicate(Operation this, Processor processor)
{
  Temporary *arguments = Operation_ARGUMENTS(this);
  int32_t resCount = Operation_RESCOUNT(this);
  int32_t argCount = Operation_ARGCOUNT(this);
  Operator operator = Operation_OPERATOR(this);
  Operator unpredicated = Operator_unpredicate(operator, processor);
  int32_t predicateIndex = Operator_predicateIndex(operator), argIndex;
  Except_CHECK(unpredicated != Operator__UNDEF && predicateIndex >= 0);
  for (argIndex = predicateIndex; argIndex < argCount - 1; argIndex++) {
    arguments[argIndex] = arguments[argIndex + 1];
  }
  Operation_resizeOperands(this, resCount, argCount - 1);
  *Operation__OPERATOR(this) = unpredicated;
}

#line 1245 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
Temporary
Operation_getPredicate(Operation this)
{
  Operator operator = Operation_OPERATOR(this);
  int predicateIndex = Operator_predicateIndex(operator);
  if (predicateIndex >= 0) {
    Temporary *arguments = Operation_ARGUMENTS(this);
    Temporary predicate = arguments[predicateIndex];
    return predicate;
  }
  return NULL;
}

#line 1308 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
bool
Operation_mayPreload(const_Operation this, int32_t regIndex)
{
  Operator operator = Operation_OPERATOR(this);
  if (Operator_isMemoryRead(operator)) {
    return regIndex == Operator_baseAddressIndex(operator);
  }
  return false;
}

#line 1324 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
int
Operation_unitCost(const_Operation this, Processor processor)
{
  Operator operator = Operation_OPERATOR(this);
  Instance instance = Operator_instance(operator, processor);
  return Instance_unitCost(instance);
}

#line 1386 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
int
Operation_getRelaxable(const_Operation this, int32_t regIndex, int overlap, int64_t step)
{
  int relaxable = overlap + 1;
  Operator operator = Operation_OPERATOR(this);
  int32_t immediateIndex = Operator_immediateIndex(operator);
  Except_REQUIRE(overlap >= 0);
  if (immediateIndex >= 0) {
    const Temporary *arguments = Operation_ARGUMENTS(this);
    Temporary temporary = arguments[immediateIndex];
    if (Temporary_isRelaxable(temporary)) {
      const_OperatorParameter immediateParameter =
          Operator_readParameter(operator, immediateIndex);
      Immediate immediate = OperatorParameter_enum(immediateParameter);
      int64_t min = Immediate_minValue(immediate);
      int64_t max = Immediate_maxValue(immediate);
      ImmediateValue m = Temporary_isAbsolute(temporary)?
                         TemporaryInvariant_VALUE(Temporary_INVARIANT(temporary)): 0;
      Except_CHECK(OperatorParameter_type(immediateParameter) == OperandType_Immediate);
      if (Operator_isAdditive(operator, regIndex, immediateIndex)) {
        // Cases like LOAD(ADD(x, step), m): m -> m+relaxable*step
        if (step > 0) {
          for (; relaxable > 0; --relaxable) {
            if (m + relaxable*step <= max) return relaxable;
          }
        } else if (step < 0) {
          for (; relaxable > 0; --relaxable) {
            if (m + relaxable*step >= min) return relaxable;
          }
        } else return relaxable;
      } else if (Operator_isSubtractive(operator, regIndex, immediateIndex)) {
        // Cases like CMPEQ(ADD(x, step), m): m -> m-relaxable*step
        if (step > 0) {
          for (; relaxable > 0; --relaxable) {
            if (m - relaxable*step >= min) return relaxable;
          }
        } else if (step < 0) {
          for (; relaxable > 0; --relaxable) {
            if (m - relaxable*step <= max) return relaxable;
          }
        } else return relaxable;
      }
    }
  }
  return 0;
}

#line 1442 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
bool
Operation_isPaddedLoad(const_Operation this,
                       int prePadding,
                       int postPadding,
                       int64_t distance)
{
  Operator operator = Operation_OPERATOR(this);
  if (Operator_isMemoryRead(operator)) {
    int accessSize = Operator_memoryAccessSize(operator);
    if ((distance >= 0 && distance + accessSize <= postPadding) ||
        (distance < 0 && -distance + accessSize <= prePadding)) {
      return true;
    }
  }
  return false;
}

#line 1472 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
int
Operation_getMemoryDistance(const_Operation this, const_Operation that,
                            int adjust, int overlap, int64_t step)
{
  Operator this_operator = Operation_OPERATOR(this);
  Operator that_operator = Operation_OPERATOR(that);
  int this_size = Operator_memoryAccessSize(this_operator);
  int that_size = Operator_memoryAccessSize(that_operator);
  int carried = Operation_INDEX(this) >= Operation_INDEX(that);
  Except_REQUIRE(this_size != 0 && that_size != 0 && overlap >= 0);
  if (this_size > 0 && that_size > 0) {
    int this_immediateIndex = Operator_immediateIndex(this_operator);
    int that_immediateIndex = Operator_immediateIndex(that_operator);
    if (this_immediateIndex >= 0 && that_immediateIndex >= 0) {
      Temporary this_temporary = Operation_ARGUMENTS(this)[this_immediateIndex];
      Temporary that_temporary = Operation_ARGUMENTS(that)[that_immediateIndex];
      if (Temporary_isAbsolute(this_temporary) &&
          Temporary_isAbsolute(that_temporary)) {
        TemporaryInvariant this_invariant = Temporary_INVARIANT(this_temporary);
        TemporaryInvariant that_invariant = Temporary_INVARIANT(that_temporary);
        int64_t this_offset = TemporaryInvariant_VALUE(this_invariant);
        int64_t that_offset = TemporaryInvariant_VALUE(that_invariant)
                            + step*(adjust + carried);
        if (this_offset == that_offset) return carried;
        if (this_offset < that_offset) {
          if (step >= 0) {
            if (this_offset + this_size <= that_offset) return overlap + 1;
            else return carried;
          } else /* step < 0 */ {
            int omega = 0;
            for (; omega <= overlap - carried; omega++) {
              int64_t bias_offset = that_offset + step*omega;
              if (this_offset + this_size > bias_offset) break;
            }
            return omega + carried;
          }
        } else /* this_offset > that_offset */ {
          if (step <= 0) {
            if (that_offset + that_size <= this_offset) return overlap + 1;
            else return carried;
          } else /* step > 0 */ {
            int omega = 0;
            for (; omega <= overlap - carried; omega++) {
              int64_t bias_offset = that_offset + step*omega;
              if (bias_offset + that_size <= this_offset) break;
            }
            return omega + carried;
          }
        }
      }
    }
  }
  return carried;
}

#line 1527 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1535 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
Instruction
Operation_makeInstruction(Operation this, Processor processor, NativeBlock block)
{
  OperandsBuffer_ buffer[1];
  Relocation relocation = Relocation__UNDEF;
  OperandDecoded *decoded = OperandsBuffer_DECODED(buffer);
  Constant_ constant_[Operands_IMMEDIATE_COUNT_MAX], *constant = constant_;
  Operator operator = Operation_OPERATOR(this);
  const_OperatorParameterArray parameterArray = Operator_parameterArray(operator);
  const OperatorParameter_ *writeParameters =
      OperatorParameterArray_writeParameters(parameterArray);
  const OperatorParameter_ *readParameters =
      OperatorParameterArray_readParameters(parameterArray);
  int readCount = OperatorParameterArray_readCount(parameterArray);
  int writeCount = OperatorParameterArray_writeCount(parameterArray);
  Instance instance = Operator_selectInstance(operator, processor);	// FIXME!
  Temporary *arguments = Operation_ARGUMENTS(this);
  Temporary *results = Operation_RESULTS(this);
  int argCount = Operation_argCount(this);
  int resCount = Operation_resCount(this);
  int regMaskIndex = Operands_COUNT_MAX;
  NativeStream stream = NativeBlock_nativeStream(block);
  Operation_RESULTS_FOREACH_Temporary(this, temporary) {
    const_OperatorParameter parameter = writeParameters;
    int rank = OperatorParameter_rank(parameter), index = rank - 1;
    if (--writeCount < 0) break;
    if (rank > 0) {
      if (Temporary_hasRegister(temporary)) {
        decoded[index] = Temporary_REGISTER(temporary);
      } else Except_NEVER(true);
    }
    ++writeParameters;
    ++results, --resCount;
  } Operation_RESULTS_ENDEACH_Temporary;
  Operation_ARGUMENTS_FOREACH_Temporary(this, temporary) {
    const_OperatorParameter parameter = readParameters;
    int rank = OperatorParameter_rank(parameter), index = rank - 1;
    if (--readCount < 0) break;
    if (rank > 0) {
      OperandType operandType = OperatorParameter_type(parameter);
      if (Temporary_hasRegister(temporary)) {
        decoded[index] = Temporary_REGISTER(temporary);
      } else if (operandType == OperandType_Immediate) {
        TemporaryInvariant invariant = Temporary_INVARIANT(temporary);
        relocation = TemporaryInvariant_RELOCATION(invariant);
        if (Temporary_isAbsolute(temporary)) {
          ImmediateValue value = TemporaryInvariant_VALUE(invariant);
          Constant_Ctor(constant, ConstantType_Absolute, NULL, value, 0);
          decoded[index] = (OperandDecoded)constant;
          ++constant;
        } else if (Temporary_isSymbol(temporary)) {
          Symbol symbol = TemporaryInvariant_SYMBOL(invariant);
          ImmediateValue offset = TemporaryInvariant_OFFSET(invariant);
          Constant constant = NativeStream_makeSymbolConstant(stream, symbol, offset);
          decoded[index] = (OperandDecoded)constant;
        } else if (Temporary_isLabel(temporary)) {
          Label label = TemporaryInvariant_LABEL(invariant);
          ImmediateValue offset = TemporaryInvariant_OFFSET(invariant);
          Constant constant = NativeStream_makeLabelConstant(stream, label, offset);
          decoded[index] = (OperandDecoded)constant;
        } else if (operandType == OperandType_Modifier) {
          Modifier modifier = TemporaryInvariant_MODIFIER(invariant);
          ModifierMember member = TemporaryInvariant_MEMBER(invariant);
          decoded[index] = (OperandDecoded)member;
        } else if (operandType == OperandType_RegMask) {
          regMaskIndex = index;
        } else Except_NEVER(true);
      } else Except_NEVER(true);
    }
    ++readParameters;
    ++arguments, --argCount;
  } Operation_ARGUMENTS_ENDEACH_Temporary;
  if (regMaskIndex < Operands_COUNT_MAX) {
    Temporary* temporaries = argCount > 0 ? arguments : results;
    int count = argCount > 0 ? argCount : resCount;
    RegisterSet_ regMask[1];
    Except_REQUIRE((argCount == 0 && resCount > 0) || (argCount > 0 && resCount == 0));
    for (; count > 0; ++temporaries, --count) {
      Temporary temporary = *temporaries;
      Register reg = Temporary_REGISTER(temporary);
      Except_REQUIRE(Temporary_hasRegister(temporary));
      RegisterSet_insert(regMask, reg);
    }
    decoded[regMaskIndex] = (OperandDecoded)regMask;
  }
  {
    Instruction instruction = NativeBlock_makeInstruction(block, instance, buffer, relocation);
    InstructionFlags flags = OperationFlags_makeInstructionFlags(Operation_FLAGS(this));
    //if (Operator_isControl(operator)) flags |= InstructionFlag_Control;
    Instruction_setIndexed(instruction, Operation__(this));
    Instruction_setFlags(instruction, flags);
    Instruction_makeActions(instruction, buffer);
    return instruction;
  }
}

#line 1637 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
int
Operation_compareIndices(const void *this_pointer, const void *that_pointer)
{
  const_Operation this = this_pointer;
  const_Operation that = that_pointer;
  intptr_t this_index = Operation_INDEX(this);
  intptr_t that_index = Operation_INDEX(that);
  return (this_index > that_index) - (this_index < that_index);
}

#line 1647 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1655 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
#ifndef ECL_NTRACE
bool
Operation_pretty(const_Operation this, FILE *file)
{
  const char *sep = " ";
  Temporary decoded[Operands_COUNT_MAX];
  Operator operator = Operation_OPERATOR(this);
  BasicBlock basicBlock = Operation_BASICBLOCK(this);
  Processor processor = basicBlock != NULL?
                        BasicBlock_PROCESSOR(basicBlock):
                        Processor__UNDEF;
  Instance instance = Operator_instance(operator, processor);
  const char* syntax = Instance_syntax(instance);
  const_OperatorParameterArray parameterArray =
      Operator_parameterArray(operator);
  const OperatorParameter_ *writeParameters =
      OperatorParameterArray_writeParameters(parameterArray);
  const OperatorParameter_ *readParameters =
      OperatorParameterArray_readParameters(parameterArray);
  Temporary *arguments = Operation_ARGUMENTS(this);
  Temporary *results = Operation_RESULTS(this);
  if (file == NULL) file = stderr;
  fprintf(file, "\t%3d:%s", Operation_IDENTITY(this), Operator_mnemonic(operator));
  if (Operation_ITERATION(this) > 0) fprintf(file, "#%d", Operation_ITERATION(this));
  if (Operation_INDEX(this) >= 0) fprintf(file, "_%d", Operation_INDEX(this));
  if (Operation_ORDERING(this) > 0) fprintf(file, "[%d]", Operation_ORDERING(this));
  if (   Operation_INDEX(this) >= 0
      || Operation_ITERATION(this) > 0
      || Operation_ORDERING(this) > 0) fprintf(file, "\t");
  else fprintf(file, "  \t");
  Operation_RESULTS_FOREACH_Temporary(this, temporary) {
    Register defRegister = Operation_getDefRegister(this, Operation_RESULTS_INDEX);
    if (Operation_RESULTS_INDEX < Operator_writeCount(operator)) {
      int rank = OperatorParameter_rank(writeParameters + Operation_RESULTS_INDEX);
      if (rank > 0) decoded[rank - 1] = temporary;
    }
    fprintf(file, "%s", sep);
    Temporary_pretty(temporary, file);
    if (defRegister != Register__UNDEF  &&
	(!Temporary_hasRegFile(temporary) ||
	 defRegister != Temporary_REGISTER(temporary))) {
      fprintf(file, "^%s", Register_names(defRegister)[0]);
    }
    sep = ", ";
  } Operation_RESULTS_ENDEACH_Temporary;
  sep = (*sep == ' ')? " ": " = ";
  Operation_ARGUMENTS_FOREACH_Temporary(this, temporary) {
    Register useRegister = Operation_getUseRegister(this, Operation_ARGUMENTS_INDEX);
    if (Operation_ARGUMENTS_INDEX < Operator_readCount(operator)) {
      int rank = OperatorParameter_rank(readParameters + Operation_ARGUMENTS_INDEX);
      if (rank > 0) decoded[rank - 1] = temporary;
    }
    fprintf(file, "%s", sep);
    Temporary_pretty(temporary, file);
    if (useRegister != Register__UNDEF &&
	(!Temporary_hasRegFile(temporary) ||
	 useRegister != Temporary_REGISTER(temporary))) {
      fprintf(file, "^%s", Register_names(useRegister)[0]);
    }
    sep = ", ";
  } Operation_ARGUMENTS_ENDEACH_Temporary;
  if (Operation_hasClobber(this)) {
    RegisterSet clobberSet = Operation_CLOBBERSET(this);
    fprintf(file, "\t{");
    RegisterSet_pretty(clobberSet, file);
    fprintf(file, "}");
  }
  if (Operation_STARTDATE(this) >= 0) {
    fprintf(file, "\tdate=%d", Operation_STARTDATE(this));
  }
  {
    OperationFlags flags = Operation_FLAGS(this)
                         & ~(OperationFlag_Clobber);
    if (flags != 0) {
      fputs("\t", file);
      ETable_prettyFlags(OperationFlag_Table, flags, ",", file);
    }
  }
  if (syntax != NULL) {
    fputs("\t\"", file);
    while (*syntax) {
      if (*syntax == '%') {
        if (isdigit(*++syntax)) {
          int rank = (*syntax - '0');
          while (isdigit(*++syntax)) rank = rank*10 + (*syntax - '0');
          if (rank == 0) fputs(Operator_mnemonic(operator), file);
          else if (rank <= Operands_COUNT_MAX) {
            Temporary_pretty(decoded[rank - 1], file);
          } else fprintf(file, "<error:%%%d>", rank);
        } else fputc(*syntax++, file);
      }
      else fputc(*syntax++, file);
    }
    fputs("\"", file);
  }
  fprintf(file, "\n");
  return true;
}
#endif//ECL_NTRACE

#line 1755 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1767 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
int32_t
OperationENTRY_appendResult(Operation this, Temporary result)
{
  int32_t resCount = Operation_RESCOUNT(this);
  int32_t argCount = Operation_ARGCOUNT(this);
  Temporary *operands = Operation_OPERANDS(this);
  Except_CHECK(Operation_OPERATOR(this) == Operator_ENTRY);
  Except_CHECK(argCount == 0);
  operands[resCount] =  result;
  *Operation__RESCOUNT(this) = resCount + 1;
  return resCount + 1;
}

#line 1786 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
int32_t
Operation_addtoParCopy(Operation this, Temporary destination, Temporary origin)
{
  int32_t maxCount = Operation_MAXCOUNT(this);
  int32_t resCount = Operation_RESCOUNT(this);
  int32_t argCount = Operation_ARGCOUNT(this);
  int32_t index = resCount + argCount + 1;
  Temporary *operands = Operation_OPERANDS(this);
  Register *registers = Operation_REGISTERS(this);
  Except_CHECK(Operator_isParCopy(Operation_OPERATOR(this)));
  Except_CHECK(resCount < maxCount && argCount < maxCount);
  operands[index--] = origin;
  if (registers != NULL) {
    for (; index > resCount; index--) {
      operands[index] = operands[index - 1];
      registers[index] = registers[index - 1];
    }
    registers[resCount] = Register__UNDEF;
  } else {
    for (; index > resCount; index--) {
      operands[index] = operands[index - 1];
    }
  }
  operands[index] = destination;
  *Operation__RESCOUNT(this) = resCount + 1;
  *Operation__ARGCOUNT(this) = argCount + 1;
  return index;
}

#line 1822 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
int32_t
OperationPCOPY_putCopy(Operation this, Temporary destination, Temporary origin)
{
  int32_t maxCount = Operation_MAXCOUNT(this);
  int32_t resCount = Operation_RESCOUNT(this);
  int32_t argCount = Operation_ARGCOUNT(this);
  int32_t index = resCount + argCount + 1;
  Temporary *operands = Operation_OPERANDS(this);
  Except_CHECK(Operator_isParCopy(Operation_OPERATOR(this)));
  Except_CHECK(resCount < maxCount && argCount < maxCount);
  for (; index > resCount + 1; index--) {
    operands[index] = operands[index - 2];
  }
  operands[index--] = origin;
  for (; index > 0; index--) {
    operands[index] = operands[index - 1];
  }
  operands[index] = destination;
  *Operation__RESCOUNT(this) = resCount + 1;
  *Operation__ARGCOUNT(this) = argCount + 1;
  return index;
}

#line 1845 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1865 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
OperationStack
OperationStack_Ctor(OperationStack this,
                    Memory memory, int maxCount)
{
  PtrSeq_Ctor(OperationStack____(this), memory, maxCount);
  return this;
}

#line 1873 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
void
OperationStack_Dtor(OperationStack this)
{
  PtrSeq_Dtor(OperationStack____(this));
}

#line 1938 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1952 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
OperationList
OperationList_Ctor(OperationList this, Memory memory)
{
  IDList_Ctor(OperationList____(this), memory);
  return this;
}

#line 1959 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
void
OperationList_Dtor(OperationList this)
{
  IDList_Dtor(OperationList____(this));
}

#line 2053 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 2125 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 2153 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 2185 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 2217 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 2223 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
#ifndef ECL_NTRACE
bool
Operation_DTD(FILE *file)
{
  fputs(
	"<!ENTITY % BasicBlock 'IDREF' >"
	"<!ENTITY % Operator 'IDREF' >"
	"<!ENTITY % Operands 'IDREFS' >"
	"<!ENTITY % Registers 'IDREFS' >"
        "<!ELEMENT Operation EMPTY>"
        "<!ATTLIST Operation"
	"	  ID ID #REQUIRED"
	"	  Operator %Operator; #IMPLIED" 
	" 	  Flags NMTOKENS #IMPLIED"
	"	  Ordering %int32_t; #IMPLIED"
	"	  Boosting %int8_t; #IMPLIED"
	"	  Iteration %uint8_t; #IMPLIED"
	"	  StartDate %int16_t; #IMPLIED"
	"	  Result %Operands; #IMPLIED"
	"	  Arguments %Operands; #IMPLIED"
	"	  Registers %Registers; #IMPLIED"
        ">"
       , file);
  return true;
}
#endif//ECL_NTRACE

#line 2264 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
#ifndef ECL_NTRACE
bool
Operation_dumpXML(Operation this, XMLGen gen)
{
  char attval[1024]="";
  char attReg[512]="";
  Operator operator = Operation_OPERATOR(this);
  XMLGenElement elemOperation = XMLGen_declareElement(gen, "Operation");
  XMLGenAttribute attID = XMLGen_declareAttribute(gen, "ID");
  XMLGenAttribute attOperator = XMLGen_declareAttribute(gen, "Operator");
  XMLGenAttribute attOrder = XMLGen_declareAttribute(gen, "Ordering");
  XMLGenAttribute attIter = XMLGen_declareAttribute(gen, "Iteration");
  XMLGenAttribute attResult = XMLGen_declareAttribute(gen, "Result");
  XMLGenAttribute attArguments = XMLGen_declareAttribute(gen, "Arguments");
  XMLGenAttribute attStartDate = XMLGen_declareAttribute(gen, "StartDate");
  XMLGenAttribute attRegs = XMLGen_declareAttribute(gen, "Registers");
  XMLGenAttribute attFlags = XMLGen_declareAttribute(gen, "Flags");
  XMLGen_startElement(gen, elemOperation);
  sprintf(attval, "Operation_%d", Operation_IDENTITY(this));
  XMLGen_addAttribute(gen, attID, attval);
  sprintf(attval, "Operator_%s", Operator_name_(operator));
  XMLGen_addAttribute(gen, attOperator, attval);
  sprintf(attval, "%d", Operation_ITERATION(this));
  XMLGen_addAttribute(gen, attIter, attval);
  sprintf(attval, "%d", Operation_ORDERING(this));
  XMLGen_addAttribute(gen, attOrder, attval);
  sprintf(attval, "%d", Operation_startDate(this));
  XMLGen_addAttribute(gen, attStartDate, attval);
 attval[0]='\0';
  if (Operation_isPartialDef(this))
    sprintf(attval, "%s PartialDef ", attval);
  if (Operation_isSpillCode(this))
    sprintf(attval, "%s SpillCode ", attval);
 if (Operation_isVolatile(this))
    sprintf(attval, "%s Volatile ", attval);
 if (Operation_isSPUpdate(this))
    sprintf(attval, "%s SPUpdate ", attval);
 if (Operation_isPrefetch(this))
    sprintf(attval, "%s Prefetch ", attval);
 if (Operation_isPreload(this))
    sprintf(attval, "%s Preload ", attval);
 if (Operation_isBarrier(this))
    sprintf(attval, "%s Barrier ", attval);
 if (Operation_hasClobber(this))
    sprintf(attval, "%s Clobber ", attval);
 if (Operation_isHoisted(this))
    sprintf(attval, "%s Hoisted ", attval);
 if (Operation_isDeadCode(this))
    sprintf(attval, "%s DeadCode ", attval);
 if (Operation_isProcessed(this))
    sprintf(attval, "%s Processed ", attval);
 if (Operation_isSafeAccess(this))
    sprintf(attval, "%s SafeAccess ", attval);
 if (Operation_isSafePerfs(this))
    sprintf(attval, "%s SafePerfs ", attval);
 if (Operation_isEntryCode(this))
    sprintf(attval, "%s EntryCode ", attval);
 if (Operation_isExitCode(this))
    sprintf(attval, "%s ExitCode ", attval);
 if (strcmp(attval,"\0"))
   XMLGen_addAttribute(gen, attFlags, attval);
  attval[0]='\0';
  Operation_RESULTS_FOREACH_Temporary(this, temporary) {
    sprintf(attval, "%s Temporary_%d ", attval, Temporary_IDENTITY(temporary));
    if (Operation_hasRegisters(this)){
      Register defRegister = Operation_getDefRegister(this, Operation_RESULTS_INDEX);
      if (defRegister != Register__UNDEF  &&
	  (!Temporary_hasRegFile(temporary) ||
	   defRegister != Temporary_REGISTER(temporary))) {
	sprintf(attReg, "%s %s ", attReg, Register_names(defRegister)[0]);
      }    
    }
  } Operation_RESULTS_ENDEACH_Temporary;
  if (strcmp(attval,"\0"))
    XMLGen_addAttribute(gen, attResult, attval);
  attval[0]='\0';
  Operation_ARGUMENTS_FOREACH_Temporary(this, temporary) {
    sprintf(attval, "%s Temporary_%d ", attval, Temporary_IDENTITY(temporary));
    if (Operation_hasRegisters(this)){
      Register useRegister = Operation_getDefRegister(this, Operation_ARGUMENTS_INDEX);
      if (useRegister != Register__UNDEF &&
	  (!Temporary_hasRegFile(temporary) ||
	   useRegister != Temporary_REGISTER(temporary))) {
	sprintf(attReg, "%s %s ", attReg, Register_names(useRegister)[0]);
      }
    }
  } Operation_ARGUMENTS_ENDEACH_Temporary;
  XMLGen_addAttribute(gen, attArguments, attval);
  if (strcmp(attReg,"\0"))
    XMLGen_addAttribute(gen, attRegs, attReg);
  XMLGen_endEmptyElement(gen);
  return true;
}
#endif//ECL_NTRACE

#line 2359 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 2367 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
IndexedFactory_ Operation_Factory[1];

#line 2369 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
void
Operation_INIT(void)
{
  IndexedFactory_Ctor(Operation_Factory);
#ifndef ECL_NTRACE
  ETable_Ctor(OperationFlag_Table, Memory_Root, OperationFlagEntries);
#endif//ECL_NTRACE
}

#line 2388 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
#ifndef ECL_NTRACE
void
Operation_FINI(void)
{
  ETable_Dtor(OperationFlag_Table);
}
#endif//ECL_NTRACE

#line 2396 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
#if XCC__C
static void
Operation_TEST(void)
{
#include "LIR/Operation_.c"
}

#line 2403 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Operation.xcc"
int
main(int argc, char **argv)
{
  LIR_Test(Operation_TEST);
  return 0;
}
#endif

#line 17 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Operation.xcc"
/*
 * Operation_mayComplementResult --	Check this Operation may be complemented on result.
 */
bool
Operation_mayComplementResult(const_Operation this,
                              Processor processor,
                              int32_t resIndex)
{
  Operator operator = Operation_OPERATOR(this);
  Operator new_operator = Operator_complementWrite(operator, processor, resIndex);
  return (new_operator != Operator__UNDEF);
}

#line 30 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Operation.xcc"
/*
 * Operation_complementResult --	Complement this operation on the designated result.
 */
void
Operation_complementResult(Operation this,
                           Processor processor,
                           int32_t resIndex)
{
  Operator operator = Operation_OPERATOR(this);
  Operator new_operator = Operator_complementWrite(operator, processor, resIndex);
  *Operation__OPERATOR(this) = new_operator;
  Except_ENSURE(new_operator != Operator__UNDEF);
}

#line 44 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Operation.xcc"
/*
 * Operation_mayComplementArgument --	Check this Operation may be complemented on argument.
 */
bool
Operation_mayComplementArgument(const_Operation this,
                                Processor processor,
                                int32_t argIndex)
{
  Operator operator = Operation_OPERATOR(this);
  Operator new_operator = Operator_complementRead(operator, processor, argIndex);
  return (new_operator != Operator__UNDEF);
}

#line 57 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Operation.xcc"
/*
 * Operation_complementArgument --	Complement this operation on the designated argument.
 */
void
Operation_complementArgument(Operation this,
                             Processor processor,
                             int32_t argIndex)
{
  Operator operator = Operation_OPERATOR(this);
  Operator new_operator = Operator_complementRead(operator, processor, argIndex);
  *Operation__OPERATOR(this) = new_operator;
  Except_ENSURE(new_operator != Operator__UNDEF);
}


#endif//Operation_c_INCLUDED
