#ifndef Procedure_c_INCLUDED
#define Procedure_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
#include "LIR/LIR_.h"

#line 26 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 72 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
Procedure
Procedure_Ctor(Procedure this,
               Memory memory, Symbol symbol, struct Program_ *program)
{
  Indexed_Ctor(Procedure____(this), Procedure_Factory);
  *Procedure__PROGRAM(this) = program;
  IBList_Ctor(Procedure_TEMPORARIES(this), memory, sizeof(Temporary_), 30);
  HTable_Ctor(Procedure_REMATERMAP(this), memory, 16);
  HTable_Ctor(Procedure_HOMEABLEMAP(this), memory, 16);
  IDList_Ctor(Procedure_BLOCKCHAIN(this), memory);
  IDList_Ctor(Procedure_DISCARDED(this), memory);
  IDList_Ctor(Procedure_CODEREGIONS(this), memory);
  HTable_Ctor(Procedure_LOOPSCOPES(this), memory, 16);
  *Procedure__SYMBOL(this) = symbol;
  {
    SymbolTable symbolTable = Program_SYMBOLTABLE(program);
    Symbol symbolSP = SymbolTable_makeSymbol(symbolTable, ".SP_block");
    Symbol symbolFP = SymbolTable_makeSymbol(symbolTable, ".FP_block");
    Symbol symbolGP = SymbolTable_makeSymbol(symbolTable, ".GP_block");
    Symbol_setClasses(symbolSP, SymbolClass_BLOCK, SymbolStore_AUTO, SymbolExport_LOCAL);
    Symbol_setClasses(symbolFP, SymbolClass_BLOCK, SymbolStore_AUTO, SymbolExport_LOCAL);
    Symbol_setClasses(symbolGP, SymbolClass_BLOCK, SymbolStore_AUTO, SymbolExport_LOCAL);
    *Procedure__SYMBOLSP(this) = symbolSP;
    *Procedure__SYMBOLFP(this) = symbolFP;
    *Procedure__SYMBOLGP(this) = symbolGP;
  }
  return this;
}

#line 101 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
void
Procedure_Dtor(Procedure this)
{
  IBList_Dtor(Procedure_TEMPORARIES(this));
  HTable_empty(Procedure_REMATERMAP(this), NULL);
  HTable_Dtor(Procedure_REMATERMAP(this));
  HTable_empty(Procedure_HOMEABLEMAP(this), NULL);
  HTable_Dtor(Procedure_HOMEABLEMAP(this));
  IDList_empty(Procedure_BLOCKCHAIN(this), (IDListItemRelease)BasicBlock_Dtor);
  IDList_Dtor(Procedure_BLOCKCHAIN(this));
  IDList_empty(Procedure_DISCARDED(this), (IDListItemRelease)BasicBlock_Dtor);
  IDList_Dtor(Procedure_DISCARDED(this));
  IDList_empty(Procedure_CODEREGIONS(this), (IDListItemRelease)CodeRegion_Dtor);
  IDList_Dtor(Procedure_CODEREGIONS(this));
  HTable_empty(Procedure_LOOPSCOPES(this), (HTableValueRelease)LoopScope_Dtor);
  HTable_Dtor(Procedure_LOOPSCOPES(this));
}

#line 119 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
size_t
Procedure_Size(Memory memory, Symbol symbol, struct Program_ *program)
{
  return sizeof(Procedure_);
}

#line 134 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
#ifndef Procedure_POOLED
#define Procedure_POOLED 128
#endif//Procedure_POOLED

#line 138 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
Procedure
Procedure_new(Memory parent, Symbol symbol, struct Program_ *program)
{
  Memory memory = Memory_new(parent, Procedure_POOLED);
  size_t size = Procedure_Size(memory, symbol, program);
  void *alloc = Memory_alloc(memory, size);
  return Procedure_Ctor(alloc, memory, symbol, program);
}

#line 151 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
Procedure
Procedure_delete(Procedure this)
{
  if (this != NULL) {
    Memory memory = Procedure_MEMORY(this);
#ifndef ECL_NDTOR
    Procedure_Dtor(this);
    Memory_free_(memory, this);
#endif//ECL_NDTOR
    Memory_delete(memory);
  }
  return NULL;
}

#line 165 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 173 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
Memory
Procedure_memory(Procedure this)
{
  return Procedure_MEMORY(this);
}

#line 185 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
struct Program_ *
Procedure_program(Procedure this)
{
  return Procedure_PROGRAM(this);
}

#line 197 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
struct Temporary_ *
Procedure_dedicated(Procedure this)
{
  return Procedure_DEDICATED(this);
}

#line 209 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
Symbol
Procedure_symbol(const_Procedure this)
{
  return Procedure_SYMBOL(this);
}

#line 226 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
IBList
Procedure_temporaries(Procedure this)
{
  return Procedure_TEMPORARIES(this);
}

#line 240 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 248 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
Temporary
Procedure_makeVirtualTemporary(Procedure this, RegFile regFile)
{
  Temporary temporary = Temporary_make(Procedure_TEMPORARIES(this),
                                       TemporaryType_Virtual, TemporaryFlag_RenameOK);
  *Temporary__REGISTER(temporary) = RegFile_lowRegister(regFile);
  return temporary;
}

#line 263 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
Temporary
Procedure_copyVirtualTemporary(Procedure this, const_Temporary register_temporary)
{
  Temporary temporary = Temporary_make(Procedure_TEMPORARIES(this),
                                       TemporaryType_Virtual, TemporaryFlag_RenameOK);
  Except_CHECK(Temporary_hasRegFile(register_temporary));
  *Temporary__REGISTER(temporary) = Temporary_REGISTER(register_temporary);
  *Temporary__WIDTH(temporary) = Temporary_WIDTH(register_temporary);
  return temporary;
}

#line 280 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
Temporary
Procedure_makeAssignedTemporary(Procedure this, Register registre)
{
  Temporary temporary = Temporary_make(Procedure_TEMPORARIES(this),
                                       TemporaryType_Virtual, TemporaryFlag_Register);
  *Temporary__REGISTER(temporary) = registre;
  return temporary;
}

#line 297 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
Temporary
Procedure_makeDedicatedTemporary(Procedure this, Register registre)
{
  Temporary dedicated = Procedure_DEDICATED(this);
  Temporary temporary = dedicated + registre;
  Except_CHECK(Temporary_isDedicated(temporary));
  Except_CHECK(Temporary_hasRegister(temporary));
  return temporary;
}

#line 314 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
Temporary
Procedure_makeAbsoluteTemporary(Procedure this,
                                ImmediateValue value, Relocation relocation)
{
  unsigned flags = TemporaryFlag_Constant;
  IBList invariants = Procedure_INVARIANTS(this);
  Temporary temporary = Temporary_make(invariants, TemporaryType_Absolute, flags);
  TemporaryInvariant invariant = Temporary_INVARIANT(temporary);
  *TemporaryInvariant__RELOCATION(invariant) = relocation;
  *TemporaryInvariant__VALUE(invariant) = value;
  return temporary;
}

#line 334 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
Temporary
Procedure_makeSymbolTemporary(Procedure this, Symbol symbol,
                              ImmediateValue offset, Relocation relocation)
{
  unsigned flags = TemporaryFlag_Constant;
  IBList invariants = Procedure_INVARIANTS(this);
  Temporary temporary = Temporary_make(invariants, TemporaryType_Symbol, flags);
  TemporaryInvariant invariant = Temporary_INVARIANT(temporary);
  Except_REQUIRE(symbol != NULL);
  *TemporaryInvariant__SYMBOL(invariant) = symbol;
  *TemporaryInvariant__RELOCATION(invariant) = relocation;
  *TemporaryInvariant__OFFSET(invariant) = offset;
  return temporary;
}

#line 356 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
Temporary
Procedure_makeLabelTemporary(Procedure this, Label label,
                             ImmediateValue offset, Relocation relocation)
{
  unsigned flags = TemporaryFlag_Constant;
  IBList invariants = Procedure_INVARIANTS(this);
  Temporary temporary = Temporary_make(invariants, TemporaryType_Label, flags);
  TemporaryInvariant invariant = Temporary_INVARIANT(temporary);
  Except_REQUIRE(label != NULL);
  *TemporaryInvariant__LABEL(invariant) = label;
  *TemporaryInvariant__RELOCATION(invariant) = relocation;
  *TemporaryInvariant__OFFSET(invariant) = offset;
  return temporary;
}

#line 377 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
Temporary
Procedure_makeModifierTemporary(Procedure this, Modifier modifier, ModifierMember member)
{
  unsigned flags = TemporaryFlag_Constant;
  IBList invariants = Procedure_INVARIANTS(this);
  Temporary temporary = Temporary_make(invariants, TemporaryType_Modifier, flags);
  TemporaryInvariant invariant = Temporary_INVARIANT(temporary);
  Except_REQUIRE(modifier != Modifier__UNDEF);
  *TemporaryInvariant__MODIFIER(invariant) = modifier;
  *TemporaryInvariant__MEMBER(invariant) = member;
  return temporary;
}

#line 396 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
Temporary
Procedure_makeRegMaskTemporary(Procedure this)
{
  unsigned flags = TemporaryFlag_Constant;
  IBList invariants = Procedure_INVARIANTS(this);
  Temporary temporary = Temporary_make(invariants, TemporaryType_RegMask, flags);
  TemporaryInvariant invariant = Temporary_INVARIANT(temporary);
  return temporary;
}

#line 406 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 414 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
Temporary
Procedure_getRemater(const_Procedure this, Temporary temporary)
{
  const_HTable rematerMap = Procedure_REMATERMAP(this);
  Except_REQUIRE(Temporary_isRemater(temporary));
  return *(Temporary *)HTable_search(rematerMap, (HTableKey)temporary);
}

#line 428 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
void
Procedure_setRemater(Procedure this, Temporary temporary, Temporary value)
{
  HTable rematerMap = Procedure_REMATERMAP(this);
  Except_REQUIRE(Temporary_isInvariant(value));
  *(Temporary *)HTable_lookup_(rematerMap,
                               (HTableKey)temporary,
                               sizeof(Temporary)) = value;
  Temporary_setFlags(temporary, TemporaryFlag_Remater);
}

#line 445 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
Temporary
Procedure_getHomeable(const_Procedure this, Temporary temporary)
{
  const_HTable homeableMap = Procedure_HOMEABLEMAP(this);
  Except_REQUIRE(Temporary_isHomeable(temporary));
  return *(Temporary *)HTable_search(homeableMap, (HTableKey)temporary);
}

#line 459 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
void
Procedure_setHomeable(Procedure this, Temporary temporary, Temporary location)
{
  HTable homeableMap = Procedure_HOMEABLEMAP(this);
  Except_REQUIRE(Temporary_isSymbol(location));
  *(Temporary *)HTable_lookup_(homeableMap,
                               (HTableKey)temporary,
                               sizeof(Temporary)) = location;
  Temporary_setFlags(temporary, TemporaryFlag_Homeable);
}

#line 470 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 478 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
IDList
Procedure_blockChain(Procedure this)
{
  return Procedure_BLOCKCHAIN(this);
}

#line 507 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
int32_t
Procedure_blockCount(Procedure this)
{
  return Procedure_BLOCKCOUNT(this);
}

#line 519 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
IDList
Procedure_discarded(Procedure this)
{
  return Procedure_DISCARDED(this);
}

#line 542 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
BasicBlock
Procedure_makeBasicBlock(Procedure this, Processor processor, intptr_t regionId, float frequency)
{
  Memory memory = Procedure_MEMORY(this);
  IDList codeRegions = Procedure_CODEREGIONS(this);
  IDList blockChain = Procedure_BLOCKCHAIN(this);
  CodeRegion codeRegion = Procedure_findCodeRegion(this, regionId);
  size_t size = BasicBlock_Size(memory, this, processor, codeRegion, frequency);
  BasicBlock basicBlock = IDList_push(blockChain, size);
  if (codeRegion == NULL) {
    Program program = Procedure_PROGRAM(this);
    Optimize optimize = Program_OPTIMIZE(program);
    Configure configure = Program_CONFIGURE(program);
    size_t size = CodeRegion_Size(memory, this, processor, regionId, optimize, configure);
    codeRegion = CodeRegion_Ctor(IDList_push(codeRegions, size),
                                 memory, this, processor, regionId, optimize, configure);
  }
  Except_CHECK(CodeRegion_isEmpty(codeRegion));
  BasicBlock_Ctor(basicBlock, memory, this, processor, codeRegion, frequency);
  return basicBlock;
}

#line 570 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
void
Procedure_chainBasicBlocks(Procedure this, BasicBlock pred_block, BasicBlock succ_block)
{
  IDList discarded = Procedure_DISCARDED(this);
  IDList blockChain = Procedure_BLOCKCHAIN(this);
  Except_REQUIRE(pred_block != succ_block);
  Except_REQUIRE(BasicBlock_INDEX(pred_block) != 0);
  Except_REQUIRE(BasicBlock_INDEX(succ_block) != 0);
  Except_CHECK(IDList_contains(blockChain, pred_block));
  if (IDList_contains(discarded, succ_block)) {
    IDList_remove_(discarded, succ_block);
  } else {
    Except_CHECK(IDList_contains(blockChain, succ_block));
    IDList_remove_(blockChain, succ_block);
  }
  IDList_append_(blockChain, pred_block, succ_block);
  BasicBlock_setTraceId(succ_block, BasicBlock_traceId(pred_block));
}

#line 595 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
void
Procedure_unchainBasicBlock(Procedure this, BasicBlock basicBlock)
{
  IDList discarded = Procedure_DISCARDED(this);
  IDList blockChain = Procedure_BLOCKCHAIN(this);
  Except_REQUIRE(BasicBlock_INDEX(basicBlock) != 0);
  Except_CHECK(IDList_contains(blockChain, basicBlock));
  IDList_remove_(blockChain, basicBlock);
  IDList_push_(discarded, basicBlock);
  BasicBlock_setTraceId(basicBlock, 0);
}

#line 607 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 615 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
IDList
Procedure_codeRegions(Procedure this)
{
  return Procedure_CODEREGIONS(this);
}

#line 645 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
CodeRegion
Procedure_firstRegion(Procedure this)
{
  return Procedure_FIRSTREGION(this);
}

#line 657 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
CodeRegion
Procedure_lastRegion(Procedure this)
{
  return Procedure_LASTREGION(this);
}

#line 669 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
CodeRegion
Procedure_findCodeRegion(Procedure this, intptr_t regionId)
{
  Procedure_FORBACK_CodeRegion(this, codeRegion) {
    if (CodeRegion_REGIONID(codeRegion) == regionId) return codeRegion;
  } Procedure_ENDBACK_CodeRegion;
  return NULL;
}

#line 678 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 686 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
HTable
Procedure_loopScopes(Procedure this)
{
  return Procedure_LOOPSCOPES(this);
}

#line 708 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
LoopScope
Procedure_findLoopScope(Procedure this, BasicBlock headerBlock)
{
  HTableKey key = (void *)headerBlock;
  HTable loopScopes = Procedure_LOOPSCOPES(this);
  return HTable_search(loopScopes, key);
}

#line 722 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
LoopScope
Procedure_makeLoopScope(Procedure this, BasicBlock headerBlock, Configure configure)
{
  HTableKey key = (void *)headerBlock;
  Memory memory = Procedure_MEMORY(this);
  HTable loopScopes = Procedure_LOOPSCOPES(this);
  int32_t count = HTable_count(loopScopes);
  size_t size = LoopScope_Size(memory, headerBlock, configure);
  LoopScope loopScope = HTable_lookup_(loopScopes, key, size);
  if (HTable_count(loopScopes) != count) {
    LoopScope_Ctor(loopScope, memory, headerBlock, configure);
  }
  return loopScope;
}

#line 743 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
bool
Procedure_removeLoopScope(Procedure this, BasicBlock headerBlock)
{
  HTable loopScopes = Procedure_LOOPSCOPES(this);
#ifndef ECL_NDTOR
  return HTable_remove(loopScopes, headerBlock, (HTableValueRelease)LoopScope_Dtor);
#else//!ECL_NDTOR
  return HTable_remove_(loopScopes, headerBlock) != NULL;
#endif//ECL_NDTOR
}

#line 754 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 762 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
void
Procedure_setEntryBlock(Procedure this, BasicBlock basicBlock)
{
  //Except_CHECK(IDList_isEmpty(Procedure_CODEREGIONS(this)));
  BasicBlock_setFlags(basicBlock, BasicBlockFlag_Entry);
}

#line 775 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
void
Procedure_setExitBlock(Procedure this, BasicBlock basicBlock)
{
  //Except_CHECK(IDList_isEmpty(Procedure_CODEREGIONS(this)));
  BasicBlock_setFlags(basicBlock,  BasicBlockFlag_Exit);
}

#line 788 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
void
Procedure_setStartBlock(Procedure this, BasicBlock basicBlock)
{
  BasicBlock_setFlags(basicBlock, BasicBlockFlag_Start);
}

#line 794 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 806 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
void
Procedure_fixupOpen64(Procedure this, OptimizeFlags activate)
{
  Program program = Procedure_PROGRAM(this);
  Convention convention = Program_CONVENTION(program);
  // Fill the missing routine call arguments and results.
  const_RegisterSet reservedSet = Convention_roleRegisterSet(convention, ConventionRole_Reserved);
  const_RegisterSet argumentSet = Convention_roleRegisterSet(convention, ConventionRole_Argument);
  const_RegisterSet resultSet = Convention_roleRegisterSet(convention, ConventionRole_Result);
  const_RegisterSet structSet = Convention_roleRegisterSet(convention, ConventionRole_Struct);
  const_RegisterSet calleeSet = Convention_roleRegisterSet(convention, ConventionRole_Callee);
  const_RegisterSet returnSet = Convention_roleRegisterSet(convention, ConventionRole_Return);
  const_RegisterSet staticSet = Convention_roleRegisterSet(convention, ConventionRole_Static);
  const_RegisterSet wiredSet = Convention_roleRegisterSet(convention, ConventionRole_Wired);
  RegisterSet_ filterArguments[1], filterResults[1], definedSet[1];
  RegisterSet_Copy(filterArguments, argumentSet);
  RegisterSet_union(filterArguments, structSet);
  RegisterSet_union(filterArguments, staticSet);
  RegisterSet_Copy(filterResults, resultSet);
  RegisterSet_Copy(definedSet, reservedSet);
  RegisterSet_diff(definedSet, wiredSet);
  Except_REQUIRE(convention != Convention__UNDEF);
  Procedure_FOREACH_BasicBlock(this, basicBlock) {
    Operation last_operation = BasicBlock_lastOperation(basicBlock);
    if (last_operation != NULL) {
      Operator last_operator = Operation_OPERATOR(last_operation);
      int32_t argCount = Operation_argCount(last_operation);
      int32_t resCount = Operation_resCount(last_operation);
      if (Operator_isRoutine(last_operator)) {
        Operation routine_operation = last_operation;
        int32_t routineArgCount = 0, routineResCount = 0;
        BasicBlock next_block = BasicBlock_next(basicBlock);
        RegisterSet_ routineArguments[1], routineResults[1];
        RegisterSet_Ctor(routineArguments);
        RegisterSet_Ctor(routineResults);
        if (activate & (OptimizeActivation_PrePass | OptimizeActivation_RegAlloc)) {
          // Collect the dedicated results of other Operation(s) in block.
          BasicBlock_FOREACH_Operation(basicBlock, operation) {
            if (operation != last_operation) {
              Operation_getDedicatedResults(operation, routineArguments);
            }
          } BasicBlock_ENDEACH_Operation;
	  // FdF 20090608: The fall-through successor of the routine
	  // may be empty or may just contain an unconditional branch.
	  // In these cases the uses of dedicated must be searched in
	  // the next successor.
	  if ((next_block != NULL)
	      && !BasicBlock_isExit(next_block)
	      && BasicBlock_leaveCount(next_block) == 1
	      && (BasicBlock_firstOperation(next_block) == NULL
		  || Operator_isGoTo(Operation_operator(BasicBlock_firstOperation(next_block))))) {
	    next_block = BasicBlockEdge_destBlock(BasicBlock_leaveFirst(next_block));
	  }
	  if (next_block != NULL) {
            // Collect the dedicated arguments of Operation(s) in next block.
            RegisterSet_ localArg[1];
            RegisterSet_ localRes[1];
            RegisterSet_Ctor(localArg);
            RegisterSet_Ctor(localRes);
            BasicBlock_FOREACH_Operation(next_block, operation) {
              Operation_getDedicatedArguments(operation, localArg);
              RegisterSet_diff(localArg, localRes);
              RegisterSet_union(routineResults,  localArg);
              Operation_getDedicatedResults(operation, localRes);
            } BasicBlock_ENDEACH_Operation;
          }
          RegisterSet_inter(routineArguments, filterArguments);
          RegisterSet_inter(routineResults, filterResults);
        } else
        if (activate & OptimizeActivation_PostPass) {
          RegisterSet_union(routineArguments, filterArguments);
          RegisterSet_union(routineResults, filterResults);
        }
        RegisterSet_union(routineArguments, definedSet);
        routineArgCount = RegisterSet_count(routineArguments);
        routineResCount = RegisterSet_count(routineResults);
        if (routineArgCount > 0 || routineResCount > 0) {
          Operation_resizeOperands(routine_operation,
                                   resCount + routineResCount,
                                   argCount + routineArgCount);
          RegisterSet_FOREACH_Register(routineArguments, registre) {
            Temporary temporary = Procedure_makeDedicatedTemporary(this, registre);
            Operation_appendArgument(routine_operation, temporary);
          } RegisterSet_ENDEACH_Register;
          RegisterSet_FOREACH_Register(routineResults, registre) {
            Temporary temporary = Procedure_makeDedicatedTemporary(this, registre);
            Operation_appendResult(routine_operation, temporary);
          } RegisterSet_ENDEACH_Register;
        }
        RegisterSet_Dtor(routineArguments);
        RegisterSet_Dtor(routineResults);
      } else
      if (Operator_isReturn(last_operator)) {
        Operation return_operation = last_operation;
        int32_t returnArgCount = 0;
        RegisterSet_ returnArguments[1];
        RegisterSet_Ctor(returnArguments);
        if (activate & (OptimizeActivation_PrePass | OptimizeActivation_RegAlloc)) {
          BasicBlock_FOREACH_Operation(basicBlock, operation) {
            Operation_getDedicatedResults(operation, returnArguments);
          } BasicBlock_ENDEACH_Operation;
          RegisterSet_inter(returnArguments, filterResults);
        } else
        if (activate & OptimizeActivation_PostPass) {
          RegisterSet_union(returnArguments, filterResults);
        }
        RegisterSet_union(returnArguments, definedSet);
        RegisterSet_union(returnArguments, calleeSet);
        returnArgCount = RegisterSet_count(returnArguments);
        if (returnArgCount > 0) {
          Operation_resizeOperands(return_operation, resCount, argCount + returnArgCount);
          RegisterSet_FOREACH_Register(returnArguments, registre) {
            Temporary temporary = Procedure_makeDedicatedTemporary(this, registre);
            Operation_appendArgument(return_operation, temporary);
          } RegisterSet_ENDEACH_Register;
        }
      } else
      if (Operator_isBranch(last_operator) &&
          BasicBlock_isExit(basicBlock)) {
        // Non-local branch, assume it results from tail-call optimization.
        // In case of tail-call, the function arguments are prepared and the
        // callee-saved registers are restored before the branch.
        Operation branch_operation = last_operation;
        int32_t branchArgCount = 0;
        RegisterSet_ branchArguments[1];
        RegisterSet_ filterOperands[1];
        RegisterSet_Ctor(branchArguments);
        RegisterSet_Copy(filterOperands, returnSet);
        RegisterSet_union(filterOperands, filterArguments);
        RegisterSet_union(filterOperands, filterResults);
        if (activate & (OptimizeActivation_PrePass | OptimizeActivation_RegAlloc)) {
          BasicBlock_FOREACH_Operation(basicBlock, operation) {
            Operation_getDedicatedResults(operation, branchArguments);
          } BasicBlock_ENDEACH_Operation;
          RegisterSet_inter(branchArguments, filterOperands);
        } else
        if (activate & OptimizeActivation_PostPass) {
          RegisterSet_union(branchArguments, filterOperands);
        }
        RegisterSet_union(branchArguments, calleeSet);
        branchArgCount = RegisterSet_count(branchArguments);
        if (branchArgCount > 0) {
          Operation_resizeOperands(branch_operation, resCount, argCount + branchArgCount);
          RegisterSet_FOREACH_Register(branchArguments, registre) {
            Temporary temporary = Procedure_makeDedicatedTemporary(this, registre);
            Operation_appendArgument(branch_operation, temporary);
          } RegisterSet_ENDEACH_Register;
        }
        RegisterSet_Dtor(filterOperands);
      }
    }
    // We cannot set this flag, because since entry and exit code are
    // linear, it add a constraint on graph coloring that cannot be satisfied
    // when we reduce the number of available colors. (See insertion of spill
    // operation in ECL/CGO/Spill.xcc)
    // With parallel copy (and with suppression of duplication in that copy),
    // this should be ok.
    if (activate & (OptimizeActivation_PrePass/* | OptimizeActivation_RegAlloc*/)) {
      if (BasicBlock_isEntry(basicBlock)) {
        BasicBlock_flagEntryCode(basicBlock, convention);
      }
      if (BasicBlock_isExit(basicBlock)) {
        BasicBlock_flagExitCode(basicBlock, convention);
      }
    }
  } Procedure_ENDEACH_BasicBlock;
  RegisterSet_Dtor(filterArguments);
  RegisterSet_Dtor(filterResults);
}

#line 984 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
/*
 * Temporary_dedicatedButRenameOK --  Returns true if it can be renamed.
 * Any temporary can be renamed except the wired registers and the
 * temporaries that must be allocated between actual operations (exceptions)
 * to well defined register. Hence we exclude:
 * - reserved registers : we don't rename them as they have an unknown meaning,
 * - stack, local thread pointer, program counter : they must well defined in
 * case of exception,
 * - wired : we preserved wired use/def as they hold a defined value.
 */
static bool
Temporary_dedicatedButRenameOK(Procedure this, Temporary temporary)
{
  Register reg;
  Convention convention = Program_CONVENTION(Procedure_PROGRAM(this));

#line 1000 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
  bool assigned =  Temporary_isDedicated(temporary)
                || Temporary_isAssigned(temporary);
  if (!assigned) return false;
  reg = Temporary_register(temporary);
  return    !RegisterSet_contains(Convention_reservedRegisterSet(convention), reg)
         && !RegisterSet_contains(Convention_programRegisterSet(convention), reg)
         && !RegisterSet_contains(Convention_stackRegisterSet(convention), reg)
         && !RegisterSet_contains(Convention_localRegisterSet(convention), reg)
         && !RegisterSet_contains(Convention_wiredRegisterSet(convention), reg);
}

#line 1011 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
/*
 * Operation_mustHaveRegisters --	Return true if the operation must
 * hold some register constraint.
 */
static bool
Operation_mustHaveRegisters(Operation this)
{
  Operator operator = Operation_operator(this);
  return Operator_isControl(operator) || Operator_isEntry(operator);
}

#line 1022 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
static void
Procedure_fixupDedicatedPostOrder(Procedure this, BasicBlock basicBlock, HTable dedicatedMap, RegisterSet dedicatedRefs)
{
  // Do a post order traversal of the CFG and rename in the the backward
  // walk. The renaming map is simple because dedicated liveranges span only
  // linear regions. This algorithm will not work for instance in:
  // r <-
  // if ... goto B
  // A: ... <- r; exit
  // B: ... <- r; exit
  // Though it works for the case of local live range, or the case of
  // a live range spanning two consecutive BB with no side exit.
  if (BasicBlock_MARK(basicBlock) != 0)
    return;
  // Remove back edges
  *BasicBlock__MARK(basicBlock) = 1;

#line 1039 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
  BasicBlock_LEAVE_FOREACH_BasicBlockEdge(basicBlock, edge) {
    BasicBlock succ_block = BasicBlockEdge_destBlock(edge);
    Procedure_fixupDedicatedPostOrder(this, succ_block, dedicatedMap, dedicatedRefs);
  } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
  //
  0 && LIR_TRACE && fprintf(LIR_TRACE, "%s: BB:%d\n", __FUNCTION__, BasicBlock_INDEX(basicBlock));
  //
  BasicBlock_FORBACK_Operation(basicBlock, operation) {
    if (Operation_hasClobber(operation)) {
      RegisterSet clobberSet = Operation_clobberSet(operation);
      RegisterSet_ additionalRegisters[1];
      RegisterSet_Copy(additionalRegisters, clobberSet);
      if (Operation_mustHaveRegisters(operation)) {
	Operation_RESULTS_FOREACH_Temporary(operation, result) {
	  if (Temporary_hasRegister(result)) {
	    if (Temporary_dedicatedButRenameOK(this, result)) {
	      RegisterSet_remove(additionalRegisters, Temporary_REGISTER(result));
	    }
	  }
	} Operation_RESULTS_ENDEACH_Temporary;
      }
      RegisterSet_inter(additionalRegisters, dedicatedRefs);
      Operation_resizeOperands(operation,
			       Operation_resCount(operation) + RegisterSet_count(additionalRegisters),
			       Operation_argCount(operation));
      RegisterSet_FOREACH_Register(additionalRegisters, registre) {
	Temporary temporary = Procedure_makeDedicatedTemporary(this, registre);
	Operation_appendResult(operation, temporary);
      } RegisterSet_ENDEACH_Register;
    }
    Operation_RESULTS_FOREACH_Temporary(operation, result) {
      if (Temporary_hasRegister(result)) {
	// Lazily store dedicated and assigned constraints for the operation.
	if (Operation_mustHaveRegisters(operation) && !Operation_hasRegisters(operation))
	  Operation_makeRegisters(operation);
	if (Temporary_dedicatedButRenameOK(this, result)) {
	  Temporary new_result, *new_result_ptr =
	    (Temporary *)HTable_search(dedicatedMap, (HTableKey)(uint32_t)Temporary_REGISTER(result));
	  if (new_result_ptr == NULL) {
	    // A dead dedicated definition
	    new_result =
	      Procedure_makeVirtualTemporary(this, Temporary_regFile(result));
	    0 && LIR_TRACE && fprintf(LIR_TRACE, "%s: Dead definition:", __FUNCTION__) &&
	      Temporary_pretty(result, LIR_TRACE) && fprintf(LIR_TRACE, "\n");
	  } else {
	    new_result = *new_result_ptr;
	  }
	  Operation_setResult(operation, Operation_RESULTS_INDEX, new_result);
	  0 && LIR_TRACE && fprintf(LIR_TRACE, "%s: Rename result:", __FUNCTION__) &&
	    Temporary_pretty(result, LIR_TRACE) && fprintf(LIR_TRACE, " into: ") &&
	    Temporary_pretty(new_result, LIR_TRACE) && fprintf(LIR_TRACE, "\n");
	  HTable_remove(dedicatedMap, (HTableKey)(uint32_t)Temporary_REGISTER(result), NULL);
	}
      }
    } Operation_RESULTS_ENDEACH_Temporary;
    Operation_ARGUMENTS_FOREACH_Temporary(operation, argument) {
      if (Temporary_hasRegister(argument)) {
	// Lazily store dedicated and assigned constraints for the operation.
	if (Operation_mustHaveRegisters(operation) && !Operation_hasRegisters(operation))
	  Operation_makeRegisters(operation);
	if (Temporary_dedicatedButRenameOK(this, argument)) {
	  Temporary new_argument, *new_argument_ptr =
	    (Temporary *)HTable_search(dedicatedMap, (HTableKey)(uint32_t)Temporary_REGISTER(argument));
	  if (new_argument_ptr == NULL) {
	    // An exposed use
	    new_argument =
	      Procedure_makeVirtualTemporary(this, Temporary_regFile(argument));
	    *(Temporary *)HTable_lookup_(dedicatedMap, (HTableKey)(uint32_t)Temporary_REGISTER(argument),
					 sizeof(Temporary)) = new_argument;
	    0 && LIR_TRACE && fprintf(LIR_TRACE, "%s: Exposed use:", __FUNCTION__) &&
	      Temporary_pretty(argument, LIR_TRACE) && fprintf(LIR_TRACE, "\n");
	  } else {
	    new_argument = *new_argument_ptr;
	  }
	  Operation_setArgument(operation, Operation_ARGUMENTS_INDEX, new_argument);
	  0 && LIR_TRACE && fprintf(LIR_TRACE, "%s: Rename argument:", __FUNCTION__) &&
	    Temporary_pretty(argument, LIR_TRACE) && fprintf(LIR_TRACE, " into: ") &&
	    Temporary_pretty(new_argument, LIR_TRACE) && fprintf(LIR_TRACE, "\n");
	}
      }
    } Operation_ARGUMENTS_ENDEACH_Temporary;
  } BasicBlock_ENDBACK_Operation;
  if (BasicBlock_isEntry(basicBlock)) {
    // Insert entry operator for all input dedicated arguments
    Selector selector = BasicBlock_SELECTOR(basicBlock);
    Operation entryOperation = Selector_makeOperationENTRY(selector, HTable_count(dedicatedMap));
    Operation firstOperation = BasicBlock_firstOperation(basicBlock);
    if (firstOperation != NULL) {
      Selector_moveOperationBefore(selector, firstOperation, entryOperation);
    }
    HTable_FOREACH(dedicatedMap, dedicated, void, _) {
      Register registre = (intptr_t)dedicated;
      OperationENTRY_appendResult(entryOperation, Procedure_makeDedicatedTemporary(this, registre));
    } HTable_ENDEACH;
    Operation_makeRegisters(entryOperation);
    Operation_RESULTS_FOREACH_Temporary(entryOperation, result) {
      Temporary new_result =
	*(Temporary *)HTable_search(dedicatedMap, (HTableKey)(uint32_t)Temporary_REGISTER(result));
	Operation_setResult(entryOperation, Operation_RESULTS_INDEX, new_result);
	0 && LIR_TRACE && fprintf(LIR_TRACE, "%s: Rename result:", __FUNCTION__) &&
	  Temporary_pretty(result, LIR_TRACE) && fprintf(LIR_TRACE, " into: ") &&
	  Temporary_pretty(new_result, LIR_TRACE) && fprintf(LIR_TRACE, "\n");
    } Operation_RESULTS_ENDEACH_Temporary;
  }
}

#line 1145 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
void
Procedure_fixupDedicated(Procedure this, OptimizeFlags activate)
{
  int index = 0;
  HTable_ dedicatedMap[1];
  RegisterSet_ dedicatedRefs[1];
  HTable_Ctor(dedicatedMap, Procedure_MEMORY(this), 16);
  RegisterSet_Ctor(dedicatedRefs);
  Procedure_FOREACH_BasicBlock(this, basicBlock) {
    *BasicBlock__MARK(basicBlock) = 0;
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      Operation_OPERANDS_FOREACH_Temporary(operation, operand) {
	if (Temporary_hasRegister(operand)) {
	  if (Temporary_dedicatedButRenameOK(this, operand)) {
	    RegisterSet_insert(dedicatedRefs, Temporary_REGISTER(operand));
	  }
	}
      } Operation_OPERANDS_ENDEACH_Temporary;
    } BasicBlock_ENDEACH_Operation;
  } Procedure_ENDEACH_BasicBlock;
  Procedure_FOREACH_BasicBlock(this, basicBlock) {
    if (BasicBlock_isEntry(basicBlock)) {
      Procedure_fixupDedicatedPostOrder(this, basicBlock, dedicatedMap, dedicatedRefs);
      HTable_empty(dedicatedMap, NULL);
    }
  } Procedure_ENDEACH_BasicBlock;
  HTable_Dtor(dedicatedMap);
  RegisterSet_Dtor(dedicatedRefs);
}

#line 1181 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
void
Procedure_buildCodeRegions(Procedure this)
{
  // Push the BasicBlock(s) on their respective CodeRegion.
  Procedure_FOREACH_BasicBlock(this, basicBlock) {
    CodeRegion codeRegion = BasicBlock_CODEREGION(basicBlock);
    CodeRegion_pushBasicBlock(codeRegion, basicBlock);
  } Procedure_ENDEACH_BasicBlock;
  // Mark the BasicBlock(s) that have a predecessor or successor inside their CodeRegion.
  Procedure_FOREACH_BasicBlock(this, basicBlock) {
    CodeRegion codeRegion = BasicBlock_CODEREGION(basicBlock);
    BasicBlock_LEAVE_FOREACH_BasicBlockEdge(basicBlock, edge) {
      BasicBlock destBlock = BasicBlockEdge_DESTBLOCK(edge);
      if (BasicBlock_CODEREGION(destBlock) == codeRegion) {
        *BasicBlock__MARK(destBlock) |= 1;
        *BasicBlock__MARK(basicBlock) |= 2;
      }
    } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
  } Procedure_ENDEACH_BasicBlock;
  // Collect the CodeRegion entry and exit BasicBlock(s).
  Procedure_FOREACH_BasicBlock(this, basicBlock) {
    CodeRegion codeRegion = BasicBlock_CODEREGION(basicBlock);
    // The BasicBlock(s) without predecessors inside their CodeRegion are entering blocks.
    if (!(BasicBlock_MARK(basicBlock) & 1) || BasicBlock_isEntry(basicBlock)) {
      CodeRegion_setEnterBlock(codeRegion, basicBlock);
    }
    // The BasicBlock(s) without successors inside their CodeRegion are leaving blocks.
    if (!(BasicBlock_MARK(basicBlock) & 2) || BasicBlock_isExit(basicBlock)) {
      CodeRegion_setLeaveBlock(codeRegion, basicBlock);
    }
    *BasicBlock__MARK(basicBlock) = 0;
  } Procedure_ENDEACH_BasicBlock;
}

#line 1215 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1223 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
void
Procedure_updateTargetedOperation(Procedure this, Operation operation, Label label)
{
  int32_t targetIndex = Operation_ARGCOUNT(operation) - 1;	// HACK ALERT!
  //TODO int32_t targetIndex = Operator_targetIndex(Operation_operator(operation));
  Temporary target_temporary = Operation_getArgument(operation, targetIndex);
  TemporaryInvariant target_invariant = Temporary_INVARIANT(target_temporary);
  ImmediateValue offset = TemporaryInvariant_OFFSET(target_invariant);
  Relocation relocation = TemporaryInvariant_RELOCATION(target_invariant);
  Except_REQUIRE(Temporary_isLabel(target_temporary));
  target_temporary = Procedure_makeLabelTemporary(this, label, offset, relocation);
  Operation_setArgument(operation, targetIndex, target_temporary);
}

#line 1244 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
void
Procedure_updateRelaxedOperation(Procedure this, Operation operation,
                                 int32_t regIndex, int64_t step, int iteration)
{
  ImmediateValue bias = 0;
  Operator operator = Operation_OPERATOR(operation);
  int32_t immediateIndex = Operator_immediateIndex(operator);
  Temporary temporary = Operation_getArgument(operation, immediateIndex);
  TemporaryInvariant invariant = Temporary_INVARIANT(temporary);
  Relocation relocation = TemporaryInvariant_RELOCATION(invariant);
  Except_REQUIRE(regIndex >= 0 && immediateIndex >= 0);
  if (Operator_isAdditive(operator, regIndex, immediateIndex)) {
    // Cases like LOAD(ADD(x, step), m) -> LOAD(x, m+step)
    bias += step*iteration;
  } else if (Operator_isSubtractive(operator, regIndex, immediateIndex)) {
    // Cases like CMPEQ(ADD(x, step), m) -> CMPEQ(x, m-step)
    bias -= step*iteration;
  } else Except_NEVER(true);
  if (Temporary_isAbsolute(temporary)) {
    ImmediateValue value = TemporaryInvariant_VALUE(invariant) + bias;
    temporary = Procedure_makeAbsoluteTemporary(this, value, relocation);
  } else if (Temporary_isSymbol(temporary)) {
    Symbol symbol = TemporaryInvariant_SYMBOL(invariant);
    ImmediateValue offset = TemporaryInvariant_OFFSET(invariant) + bias;
    temporary = Procedure_makeSymbolTemporary(this, symbol, offset, relocation);
  } else Except_NEVER(true);
  Operation_setArgument(operation, immediateIndex, temporary);
}

#line 1273 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1281 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
#ifndef ECL_NTRACE
bool
Procedure_pretty(Procedure this, FILE* file)
{
  if (this == NULL) return true;
  if (file == NULL) file = stderr;
  fprintf(file, "Procedure %s\n", Procedure_name(this));
  Procedure_FOREACH_BasicBlock(this, basicBlock) {
    BasicBlock_pretty(basicBlock, file);
  } Procedure_ENDEACH_BasicBlock;
  return true;
}
#endif // ECL_NTRACE

#line 1295 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1320 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
ProcedureTable
ProcedureTable_Ctor(ProcedureTable this,
                    Memory memory, int32_t estimate)
{
  IndexedTable_Ctor(ProcedureTable____(this), memory, estimate);
  return this;
}

#line 1328 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
void
ProcedureTable_Dtor(ProcedureTable this)
{
  IndexedTable_Dtor(ProcedureTable____(this));
}

#line 1377 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
#ifndef ECL_NTRACE
bool
ProcedureTable_pretty(const_ProcedureTable this, FILE *file)
{
  if (file == NULL) file = stderr;
  fprintf(file, "{");
  ProcedureTable_FOREACH_Procedure(this, procedure) {
    fprintf(file, " [%d]", Procedure_INDEX(procedure));
  } ProcedureTable_ENDEACH_Procedure;
  fprintf(file, " }");
  return true;
}
#endif//ECL_NTRACE

#line 1391 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1397 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
#ifndef ECL_NTRACE
bool
Procedure_DTD(FILE *file)
{
  fputs(
        "<!ELEMENT Procedure (BasicBlock|Operation|Label|Temporary|LoopScope)*>"
       , file);
  return true;
}
#endif//ECL_NTRACE

#line 1422 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
#ifndef ECL_NTRACE
bool
Procedure_dumpXML(Procedure this, XMLGen gen)
{
  XMLGenElement elemProc = XMLGen_declareElement(gen, "Procedure");
  XMLGen_startElement(gen, elemProc);
  Procedure_FOREACH_Temporary(this, temporary) {
    Temporary_dumpXML(temporary, gen);
  } Procedure_ENDEACH_Temporary;
  Procedure_FOREACH_BasicBlock(this, basicBlock) {
    BasicBlock_dumpXML(basicBlock,  gen);
  } Procedure_ENDEACH_BasicBlock;
  Procedure_FOREACH_LoopScope(this, loopScope) {
    LoopScope_dumpXML(loopScope, gen);
  } Procedure_ENDEACH_LoopScope;
  XMLGen_endElement(gen);
  return true;
}
#endif//ECL_NTRACE

#line 1442 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1450 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
IndexedFactory_ Procedure_Factory[1];

#line 1452 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
void
Procedure_INIT(void)
{
  IndexedFactory_Ctor(Procedure_Factory);
}

#line 1463 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
#if XCC__C
static void
Procedure_TEST(void)
{
#include "LIR/Procedure_.c"
}

#line 1470 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Procedure.xcc"
int
main(int argc, char **argv)
{
  LIR_Test(Procedure_TEST);
  return 0;
}
#endif


#endif//Procedure_c_INCLUDED
