#ifndef Program_c_INCLUDED
#define Program_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
#include "LIR/LIR_.h"

#line 21 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 44 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
Program
Program_Ctor(Program this,
             Memory memory)
{
  LabelTable_Ctor(Program_LABELTABLE(this), memory, 512);
  SymbolTable_Ctor(Program_SYMBOLTABLE(this), memory, 512);
  ProcedureTable_Ctor(Program_PROCEDURETABLE(this), memory, 256);
  Optimize_Ctor(Program_OPTIMIZE(this));
  Configure_Ctor(Program_CONFIGURE(this));
  {
    int registre;
    Convention convention = Program_CONVENTION(this);
    Temporary_ *dedicated = Memory_alloc(memory, sizeof(Temporary_)*Register__XCOUNT);
    const_RegisterSet wiredSet = Convention_roleRegisterSet(convention, ConventionRole_Wired);
    memset(dedicated, 0, sizeof(Temporary_));
    for (registre = 1; registre < Register__COUNT; registre++) {
      TemporaryFlags flags = RegisterSet_contains(wiredSet, registre)?
                             TemporaryFlag_Constant + TemporaryFlag_Register:
                             TemporaryFlag_Register;
      Temporary temporary = Temporary_Ctor(dedicated + registre, TemporaryType_Dedicated, flags);
      *Temporary__REGISTER(temporary) = registre;
    }
    Temporary_Ctor(dedicated + Register__Volatile, TemporaryType_Volatile, 0);
    Temporary_Ctor(dedicated + Register__Control, TemporaryType_Control, 0);
    Temporary_Ctor(dedicated + Register__Memory, TemporaryType_Memory, 0);
    *Program__DEDICATED(this) = dedicated;
  }
  IBList_Ctor(Program_INVARIANTS(this), memory, sizeof(TemporaryInvariant_), 30);
  return this;
}

#line 75 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
void
Program_Dtor(Program this)
{
  Memory memory = Program_MEMORY(this);
  LabelTable_Dtor(Program_LABELTABLE(this));
  SymbolTable_Dtor(Program_SYMBOLTABLE(this));
  Program_FOREACH_Procedure(this, procedure) {
    Procedure_delete(procedure);
  } Program_ENDEACH_Procedure;
  ProcedureTable_Dtor(Program_PROCEDURETABLE(this));
  Memory_free_(memory, Program_DEDICATED(this));
  IBList_Dtor(Program_INVARIANTS(this));
  Optimize_Dtor(Program_OPTIMIZE(this));
  Configure_Dtor(Program_CONFIGURE(this));
}

#line 91 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
size_t
Program_Size(Memory memory)
{
  return sizeof(Program_);
}

#line 106 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
#ifndef Program_POOLED
#define Program_POOLED 128
#endif//Program_POOLED

#line 110 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
#ifndef ECL_NTRACE
int count=0;
#endif//Program_POOLED

#line 115 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
Program
Program_new(Memory parent)
{
  Memory memory = Memory_new(parent, Program_POOLED);
  size_t size = Program_Size(memory);
  void *alloc = Memory_alloc(memory, size);
  return Program_Ctor(alloc, memory);
}

#line 128 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
Program
Program_delete(Program this)
{
  if (this != NULL) {
    Memory memory = Program_MEMORY(this);
#ifndef ECL_NDTOR
    Program_Dtor(this);
    Memory_free_(memory, this);
#endif//ECL_NDTOR
    Memory_delete(memory);
  }
  return NULL;
}

#line 155 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 163 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
Memory
Program_memory(Program this)
{
  return Program_MEMORY(this);
}

#line 175 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
LabelTable
Program_labelTable(Program this)
{
  return Program_LABELTABLE(this);
}

#line 187 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
SymbolTable
Program_symbolTable(Program this)
{
  return Program_SYMBOLTABLE(this);
}

#line 199 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
ProcedureTable
Program_procedureTable(Program this)
{
  return Program_PROCEDURETABLE(this);
}

#line 219 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
Optimize
Program_optimize(Program this)
{
  return Program_OPTIMIZE(this);
}

#line 231 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
Convention
Program_convention(Program this)
{
  return Program_CONVENTION(this);
}

#line 243 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
Configure
Program_configure(Program this)
{
  return Program_CONFIGURE(this);
}

#line 255 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
struct Temporary_ *
Program_dedicated(Program this)
{
  return Program_DEDICATED(this);
}

#line 267 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
IBList
Program_invariants(Program this)
{
  return Program_INVARIANTS(this);
}

#line 293 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 301 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
Temporary
Program_makeAbsoluteTemporary(Program this, ImmediateValue value, Relocation relocation)
{
  unsigned flags = TemporaryFlag_Constant;
  IBList invariants = Program_INVARIANTS(this);
  Temporary temporary = Temporary_make(invariants, TemporaryType_Absolute, flags);
  TemporaryInvariant invariant = Temporary_INVARIANT(temporary);
  *TemporaryInvariant__RELOCATION(invariant) = relocation;
  *TemporaryInvariant__VALUE(invariant) = value;
  return temporary;
}

#line 319 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
Procedure
Program_makeProcedure(Program this, Symbol symbol)
{
  Memory memory = Program_MEMORY(this);
  Procedure procedure = Procedure_new(memory, symbol, this);
  ProcedureTable_insert(Program_PROCEDURETABLE(this), procedure);
  *Procedure__PROGRAM(procedure) = this;
  *Symbol__PROCEDURE(symbol) = procedure;
  return procedure;
}

#line 338 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
void
Program_killProcedure(Program this, Procedure procedure)
{
  Symbol symbol = Procedure_SYMBOL(procedure);
  *Symbol__PROCEDURE(symbol) = NULL;
  Procedure_delete(procedure);
}

#line 346 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 352 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
#ifndef ECL_NTRACE
bool
Program_DTD(FILE *file)
{
  fputs(
	"<!DOCTYPE XMLDUMP ["
	"<!ELEMENT XMLDUMP (Register|Processor|Convention|RegFile|Bundling|Relocation|Reservation|Scheduling|Immediate|Operator|Program)*>"
	"<!ELEMENT Program (Temporary|Procedure)* >"
	"<!ATTLIST Program"
	"          Activation NMTOKEN #IMPLIED"
	"          LogMaxBBOC NMTOKEN #IMPLIED"
	"          Convention NMTOKEN #IMPLIED"
	"          Profiling NMTOKEN #IMPLIED"
	"          RegionType NMTOKEN #IMPLIED"
	"          Conversion NMTOKEN #IMPLIED"
	"          Coalescing NMTOKEN #IMPLIED"
	"          Numbering NMTOKEN #IMPLIED"
	"          Propagation NMTOKEN #IMPLIED"
	"          Predication NMTOKEN #IMPLIED"
	"          Scheduling NMTOKEN #IMPLIED"
	"          Allocation NMTOKEN #IMPLIED"
	"          Formulation NMTOKEN #IMPLIED"
	"          Scoreboarding NMTOKEN #IMPLIED"
	"          WindowSize NMTOKEN #IMPLIED"
	"          PrePadding NMTOKEN #IMPLIED"
	"          PostPadding NMTOKEN #IMPLIED"
	"          RCMSProblem NMTOKEN #IMPLIED"
	"	Processor NMTOKEN #IMPLIED"
	"	Compensation NMTOKEN #IMPLIED"
	"	Speculation NMTOKEN #IMPLIED"
	"	Relaxation NMTOKEN #IMPLIED"
	"	Renaming NMTOKEN #IMPLIED"
	"	Boosting NMTOKEN #IMPLIED"
	"	Aliasing NMTOKEN #IMPLIED"
	"	TripModulus NMTOKEN #IMPLIED "
	"	TripResidue NMTOKEN #IMPLIED"
	"	Pipelining NMTOKEN #IMPLIED"
	"	PreLoading NMTOKEN #IMPLIED"
	"	L1MissExtra NMTOKEN #IMPLIED"
	">"
	"<!ENTITY % Register.dtd SYSTEM 'Register.dtd'>"
        "<!ENTITY % Processor.dtd SYSTEM 'Processor.dtd'>"
        "<!ENTITY % Convention.dtd SYSTEM 'Convention.dtd'>"
        "<!ENTITY % RegFile.dtd SYSTEM 'RegFile.dtd'>"
        "<!ENTITY % Bundling.dtd SYSTEM 'Bundling.dtd'>"
        "<!ENTITY % Relocation.dtd SYSTEM 'Relocation.dtd'>"
        "<!ENTITY % Reservation.dtd SYSTEM 'Reservation.dtd'>"
        "<!ENTITY % Scheduling.dtd SYSTEM 'Scheduling.dtd'>"
        "<!ENTITY % Temporary.dtd SYSTEM 'Temporary.dtd'>"
        "<!ENTITY % Operator.dtd SYSTEM 'Operator.dtd'>"
        "<!ENTITY % BasicBlock.dtd SYSTEM 'BasicBlock.dtd'>"
        "<!ENTITY % Dependence.dtd SYSTEM 'Dependence.dtd'>"
        "<!ENTITY % LoopScope.dtd SYSTEM 'LoopScope.dtd'>"
        "<!ENTITY % Operation.dtd SYSTEM 'Operation.dtd'>"
        "<!ENTITY % Procedure.dtd SYSTEM 'Procedure.dtd'>"
        "<!ENTITY % Label.dtd SYSTEM 'Label.dtd'>"
        "<!ENTITY % Immediate.dtd SYSTEM 'Immediate.dtd'>"
        "<!ENTITY Register.xml SYSTEM 'Register.xml'>"
        "<!ENTITY Processor.xml SYSTEM 'Processor.xml'>"
        "<!ENTITY Convention.xml SYSTEM 'Convention.xml'>"
        "<!ENTITY RegFile.xml SYSTEM 'RegFile.xml'>"
        "<!ENTITY Bundling.xml SYSTEM 'Bundling.xml'>"
        "<!ENTITY Relocation.xml SYSTEM 'Relocation.xml'>"
        "<!ENTITY Reservation.xml SYSTEM 'Reservation.xml'>"
        "<!ENTITY Scheduling.xml SYSTEM 'Scheduling.xml'>"
        "<!ENTITY Operator.xml SYSTEM 'Operator.xml'>"
        "<!ENTITY Immediate.xml SYSTEM 'Immediate.xml'>"	
	"%Register.dtd;"
        "%Processor.dtd;"
        "%Convention.dtd;"
        "%RegFile.dtd;"
        "%Bundling.dtd;"
        "%Relocation.dtd;"
        "%Reservation.dtd;"
        "%Scheduling.dtd;"
        "%Temporary.dtd;"
        "%Operator.dtd;"
        "%Procedure.dtd;"
        "%Dependence.dtd;"
        "%Operation.dtd;"
        "%BasicBlock.dtd;"
        "%Label.dtd;"
        "%Immediate.dtd;"
        "%LoopScope.dtd;"
        "]>"
	"<XMLDUMP>\n"
	"&Register.xml;\n"
	"&Processor.xml;\n"
	"&Convention.xml;\n"
	"&RegFile.xml;\n"
	"&Bundling.xml;\n"
	"&Relocation.xml;\n"
	"&Reservation.xml;\n"
	"&Scheduling.xml;\n"
	"&Operator.xml;\n"	
	"&Immediate.xml;\n"
	, file);
  return true;
}
#endif//ECL_NTRACE

#line 458 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
#ifndef ECL_NTRACE
bool
Program_dumpXML(Program this)
{
  char attval[64]="";
  char fileName[15]="";
  int escapeExt=1;
  FILE *fileDump;
  Optimize optim = Program_optimize(this);
  Configure configure = Program_configure(this);
  XMLGen gen = XMLGen_new(Memory_Root);
  XMLGen_startDocFile(gen,escapeExt);
  sprintf(fileName, "dump%d.xml", count++);
  fileDump = fopen(fileName,"a");
  Program_DTD(fileDump);
  {
    XMLGenElement elemProg = XMLGen_declareElement(gen, "Program");
    int i;
    XMLGen_startElement(gen, elemProg);
    attval[0]='\0';
    for (i = 0; i < OptimizeItem__; i++) {
      const char *name = OptimizeItem_name_(i);
      int value = Optimize_ITEMS(optim)[i];
      if (value >= 0){
	sprintf(attval, "%d",value);
	XMLGen_addAttributeLiteral(gen, name, attval);
      }
    }
    attval[0]='\0';
    for (i = 0; i < ConfigureItem__; i++) {
      const char *name = ConfigureItem_name_(i);
      int value = Configure_ITEMS(configure)[i];
      if (value >= 0){
	sprintf(attval, "%d",value);
	 XMLGen_addAttributeLiteral(gen, name, attval);
      }
    }
    Program_DEDICATED_FOREACH_Temporary(this, temporary) {
      Register registre = Temporary_REGISTER(temporary);
      if (registre == Register__UNDEF) continue;
      Temporary_dumpXML(temporary, gen);
    } Program_DEDICATED_ENDEACH_Temporary;
     Program_FOREACH_TemporaryInvariant(this, invariant){
       Temporary temporary = TemporaryInvariant__(invariant);
       Temporary_dumpXML(temporary, gen);
    } Program_ENDEACH_TemporaryInvariant;
    Program_FOREACH_Procedure(this, procedure) {
      Procedure_dumpXML(procedure, gen);
    } Program_ENDEACH_Procedure;
    XMLGen_endElement(gen);
  }
  XMLGen_endDocument(gen, fileDump);
  fileDump = fopen(fileName,"a");
  fputs("</XMLDUMP>",fileDump);
  fclose(fileDump);
  XMLGen_delete(gen);
  return true;
}
#endif//ECL_NTRACE

#line 518 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 523 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
Program program;

#line 535 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
#if XCC__C
static void
Program_TEST(void)
{
#include "LIR/Program_.c"
}

#line 542 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Program.xcc"
int
main(int argc, char **argv)
{
  LIR_Test(Program_TEST);
  return 0;
}
#endif


#endif//Program_c_INCLUDED
