#ifndef Program__h_INCLUDED
#define Program__h_INCLUDED

//
#include "LIR/Program.h"

//
struct Program_ {
  //@args	Memory memory
  LabelTable_ LABELTABLE[1];		// The LabelTable of this Program.
  SymbolTable_ SYMBOLTABLE[1];		// The SymbolTable of this Program.
  //@access MEMORY	SymbolTable_memory(Program_SYMBOLTABLE(this))
  //@access STRINGS	SymbolTable_strings(Program_SYMBOLTABLE(this))
  ProcedureTable_ PROCEDURETABLE[1];	// IndexedTable of Procedure(s).
  //@access PROCEDURECOUNT	ProcedureTable_count(Program_PROCEDURETABLE(this))
  IBList_ INVARIANTS[1];		// TemporaryInvariant(s) for this Program.
  Temporary_ *DEDICATED;		// Dedicated Temporary(ies).
  Optimize_ OPTIMIZE[1];
  //@access CONVENTION	Optimize_CONVENTION(Program_OPTIMIZE(this))
  Configure_ CONFIGURE[1];
};

extern Program
Program_Ctor(Program this, Memory memory);

extern Program
Program_Copy(Program this, const_Program that);

extern void
Program_Dtor(Program this);

extern size_t
Program_Size(Memory memory);

#define Program_LABELTABLE(this) ((this)->LABELTABLE)
#define Program__LABELTABLE(this) (&(this)->LABELTABLE)
#define Program_SYMBOLTABLE(this) ((this)->SYMBOLTABLE)
#define Program__SYMBOLTABLE(this) (&(this)->SYMBOLTABLE)
#define Program_PROCEDURETABLE(this) ((this)->PROCEDURETABLE)
#define Program__PROCEDURETABLE(this) (&(this)->PROCEDURETABLE)
#define Program_INVARIANTS(this) ((this)->INVARIANTS)
#define Program__INVARIANTS(this) (&(this)->INVARIANTS)
#define Program_DEDICATED(this) ((this)->DEDICATED)
#define Program__DEDICATED(this) (&(this)->DEDICATED)
#define Program_OPTIMIZE(this) ((this)->OPTIMIZE)
#define Program__OPTIMIZE(this) (&(this)->OPTIMIZE)
#define Program_CONFIGURE(this) ((this)->CONFIGURE)
#define Program__CONFIGURE(this) (&(this)->CONFIGURE)
#define Program_STRINGS(this) (SymbolTable_strings(Program_SYMBOLTABLE(this)))
#define Program_CONVENTION(this) (Optimize_CONVENTION(Program_OPTIMIZE(this)))
#define Program_PROCEDURECOUNT(this) (ProcedureTable_count(Program_PROCEDURETABLE(this)))
#define Program_MEMORY(this) (SymbolTable_memory(Program_SYMBOLTABLE(this)))


/*
 * Program_INIT --	Initialize the Program module.
 */
#define Program_INIT()

/*
 * Program_FINI --	Finalize the Program module.
 */
#define Program_FINI()


#endif//Program__h_INCLUDED
