#ifndef Selector_c_INCLUDED
#define Selector_c_INCLUDED

#line 17 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
#include "LIR/LIR_.h"

#line 22 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 44 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
Selector
Selector_Ctor(Selector this,
              Memory memory, void *procedure,
              Processor processor, bool isBlock)
{
  IDList_Ctor(Selector_OPERATIONS(this), memory);
  *Selector__PROCEDURE(this) = procedure;
  *Selector__PROCESSOR(this) = processor;
  *Selector__ISBLOCK(this) = -(isBlock != 0);
  *Selector__PHICOUNT(this) = 0;
  Except_CHECK(memory == Procedure_memory((Procedure)procedure));
  return this;
}

#line 58 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
void
Selector_Dtor(Selector this)
{
  IDList_Dtor(Selector_OPERATIONS(this));
  *Selector__PROCEDURE(this) = NULL;
}

#line 81 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 204 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 212 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
void
Selector_attachFirst(Selector this, Operation operation)
{
  BasicBlock basicBlock = Selector_BASICBLOCK(this);
  Except_REQUIRE(Operation_BASICBLOCK(operation) == NULL);
  IDList_put_(Selector_OPERATIONS(this), operation);
  *Operation__BASICBLOCK(operation) = basicBlock;
}

#line 227 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
void
Selector_attachLast(Selector this, Operation operation)
{
  BasicBlock basicBlock = Selector_BASICBLOCK(this);
  Except_REQUIRE(Operation_BASICBLOCK(operation) == NULL);
  IDList_push_(Selector_OPERATIONS(this), operation);
  *Operation__BASICBLOCK(operation) = basicBlock;
}

#line 242 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
Operation
Selector_detachFirst(Selector this)
{
  Operation operation = IDList_firstItem(Selector_OPERATIONS(this));
  Except_REQUIRE(Operation_BASICBLOCK(operation) == Selector_BASICBLOCK(this));
  IDList_drop_(Selector_OPERATIONS(this));
  *Operation__BASICBLOCK(operation) = NULL;
  return operation;
}

#line 258 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
Operation
Selector_detachLast(Selector this)
{
  Operation operation = IDList_lastItem(Selector_OPERATIONS(this));
  Except_REQUIRE(Operation_BASICBLOCK(operation) == Selector_BASICBLOCK(this));
  IDList_pop_(Selector_OPERATIONS(this));
  *Operation__BASICBLOCK(operation) = NULL;
  return operation;
}

#line 276 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
void
Selector_detachOperation(Selector this, Operation operation)
{
  Except_REQUIRE(Operation_BASICBLOCK(operation) == Selector_BASICBLOCK(this));
  Except_CHECK(IDList_contains(Selector_OPERATIONS(this), operation));
  IDList_remove_(Selector_OPERATIONS(this), operation);
  *Operation__BASICBLOCK(operation) = NULL;
}

#line 291 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
void
Selector_moveOperationFirst(Selector this, Operation operation)
{
  IDList operations = Selector_OPERATIONS(this);
  Except_CHECK(Operation_BASICBLOCK(operation) == Selector_BASICBLOCK(this));
  IDList_remove_(operations, operation);
  IDList_put_(operations, operation);
}

#line 306 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
void
Selector_moveOperationLast(Selector this, Operation operation)
{
  IDList operations = Selector_OPERATIONS(this);
  Except_CHECK(Operation_BASICBLOCK(operation) == Selector_BASICBLOCK(this));
  IDList_remove_(operations, operation);
  IDList_push_(operations, operation);
}

#line 321 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
void
Selector_moveOperationBefore(Selector this, Operation before, Operation operation)
{
  IDList operations = Selector_OPERATIONS(this);
  Except_CHECK(Operation_BASICBLOCK(before) == Selector_BASICBLOCK(this));
  Except_CHECK(Operation_BASICBLOCK(operation) == Selector_BASICBLOCK(this));
  IDList_remove_(operations, operation);
  IDList_insert_(operations, before, operation);
}

#line 337 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
void
Selector_moveOperationAfter(Selector this, Operation after, Operation operation)
{
  IDList operations = Selector_OPERATIONS(this);
  Except_CHECK(Operation_BASICBLOCK(after) == Selector_BASICBLOCK(this));
  Except_CHECK(Operation_BASICBLOCK(operation) == Selector_BASICBLOCK(this));
  IDList_remove_(operations, operation);
  IDList_append_(operations, after, operation);
}

#line 347 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 362 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
Operation
Selector_makeOperation_(Selector this, Operator operator,
                        int32_t resCount, int32_t argCount,
                        const_RegisterSet clobberSet)
{
  Memory memory = Selector_MEMORY(this);
  IDList operations = Selector_OPERATIONS(this);
  BasicBlock basicBlock = Selector_BASICBLOCK(this);
  int32_t clp2Size = HackerU32_clp2(resCount + argCount)*sizeof(Temporary);
  size_t size = Operation_Size(operator, resCount, argCount, clobberSet, basicBlock);
  Operation operation = IDList_push(operations, size);
  Operation_Ctor(operation, operator, resCount, argCount, clobberSet, basicBlock);
  Except_CHECK(resCount >= 0 && argCount >= 0);
  if (clp2Size > 0) {
    Temporary *operands = memset(Memory_alloc(memory, clp2Size), 0, clp2Size);
    *Operation__OPERANDS(operation) = operands;
  }
  if (Operator_isConditional(operator) && resCount != 0) {
    *Operation__FLAGS(operation) |= OperationFlag_PartialDef;
  }
  return operation;
}

#line 700 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 711 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
Operation
Selector_makeOperation(Selector this, Operator operator,
                       int32_t resCount, int32_t argCount,
                       Temporary *results, Temporary *arguments,
                       const_RegisterSet clobberSet)
{
  int32_t i;
  Operation operation = Selector_makeOperation_(this, operator,
                                                resCount, argCount,
                                                clobberSet);
  Temporary *this_arguments = Operation_arguments(operation);
  Temporary *this_results = Operation_results(operation);
  if (arguments != NULL) {
    for (i = 0; i < argCount; i++) {
      this_arguments[i] = arguments[i];
    }
  }
  if (results != NULL) {
    for (i = 0; i < resCount; i++) {
      this_results[i] = results[i];
    }
  }
  return operation;
}

#line 744 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
Operation
Selector_replicateOperation(Selector this, const_Operation operation)
{
  int32_t argCount = Operation_ARGCOUNT(operation);
  int32_t resCount = Operation_RESCOUNT(operation);
  Operation that = Selector_makeOperation(this, Operation_OPERATOR(operation),
                                          resCount, argCount,
                                          Operation_RESULTS(operation),
                                          Operation_ARGUMENTS(operation),
                                          Operation_clobberSet(operation));
  *Operation__INDEX(that) = Operation_INDEX(operation);
  *Operation__FLAGS(that) |= Operation_FLAGS(operation);
  *Operation__REPLICATED(that) = operation;
  return that;
}

#line 760 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 768 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
Operation
Selector_makeOperationLABEL(Selector this, Label label)
{
  Procedure procedure = Selector_PROCEDURE(this);
  Temporary temporary = Procedure_makeLabelTemporary(procedure, label, 0, Relocation__UNDEF);
  return Selector_makeOperation_0_1(this, Operator_LABEL, temporary);
}

#line 782 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
Operation
Selector_makeOperationGOTO(Selector this, Label label)
{
  Procedure procedure = Selector_PROCEDURE(this);
  Temporary temporary = Procedure_makeLabelTemporary(procedure, label, 0, Relocation__UNDEF);
  return Selector_makeOperation_0_1(this, Operator_GOTO, temporary);
}

#line 796 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
Operation
Selector_makeOperationLOOP(Selector this, Label label)
{
  Procedure procedure = Selector_PROCEDURE(this);
  Temporary temporary = Procedure_makeLabelTemporary(procedure, label, 0, Relocation__UNDEF);
  return Selector_makeOperation_0_1(this, Operator_LOOP, temporary);
}

#line 810 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
Operation
Selector_makeOperationFALL(Selector this, Label label)
{
  Procedure procedure = Selector_PROCEDURE(this);
  Temporary temporary = Procedure_makeLabelTemporary(procedure, label, 0, Relocation__UNDEF);
  return Selector_makeOperation_0_1(this, Operator_FALL, temporary);
}

#line 874 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
Operation
Selector_makeOperationParCopy(Selector this, Operator operator, int32_t maxCount, bool registers)
{
  Memory memory = Selector_MEMORY(this);
  Operation operation =  Selector_makeOperation_(this, operator, maxCount, maxCount, NULL);
  *Operation__RESCOUNT(operation) = *Operation__ARGCOUNT(operation) = 0;
  *Operation__MAXCOUNT(operation) = maxCount;
  Except_CHECK(Operator_isParCopy(operator));
  if (registers) {
    size_t allocSize = maxCount*2*sizeof(Register);
    Register *registers = Memory_alloc(memory, allocSize);
    memset(registers, Register__UNDEF, allocSize);
    Except_CHECK(Operation_REGISTERS(operation) == NULL);
    *Operation__REGISTERS(operation) = registers;
  }
  return operation;
}

#line 892 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1004 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1016 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
#if XCC__C
static void
Selector_TEST(void)
{
#include "LIR/Selector_.c"
}

#line 1023 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Selector.xcc"
int
main(int argc, char **argv)
{
  LIR_Test(Selector_TEST);
  return 0;
}
#endif

#line 17 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
#include "MDS/MDS_.h"

#line 19 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Forward declarations. See implementation for description.
 */
static Operator get_load_operator(Selector this, RegFile class, NativeType type,
                                  Temporary offset);
static Operator get_store_operator(Selector this, RegFile class, NativeType type,
                                  Temporary offset);
static Temporary Generate_Absolute(Selector this, RegFile regFile, NativeType nativeType, int64_t value);
static Temporary Get_DummyReg(Selector this, RegFile regFile);
static Temporary Get_SP(Selector this);
static Temporary Get_FP(Selector this);
static Temporary Get_GP(Selector this);
static Symbol Get_Symbol_SP(Selector this);
static Symbol Get_Symbol_FP(Selector this);
static Symbol Get_Symbol_GP(Selector this);
static inline void checkRegSrc1Src2(Selector this,
                                    Temporary* reg_src1, Temporary* new_src2,
                                    Temporary  src1, Temporary src2);

#line 38 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Selector_selectLOAD --	Selector a load from memory
 */
void
Selector_selectLOAD(Selector this, NativeType nativeType, Temporary dst, Temporary base,
              Temporary offset)
{
  Procedure procedure = Selector_PROCEDURE(this);
  RegFile regFile = Temporary_regFile(dst);
  Operator operator;
  Temporary load_dst;

#line 50 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  Except_ENSURE(Temporary_hasRegFile(dst));
  Except_ENSURE(Temporary_isInvariant(offset));
  Except_ENSURE(Temporary_hasRegFile(base));
  Except_ENSURE(Temporary_regFile(base) == RegFile_st200_GR);

#line 55 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  if (regFile == RegFile_st200_GR) {
    load_dst = dst;
    operator = get_load_operator(this, regFile, nativeType, offset);
  } else {
    /* For BRC regFile we must load a GRC and move it into dst. */
    load_dst = Procedure_makeVirtualTemporary(procedure, RegFile_st200_GR);
    operator = get_load_operator(this, RegFile_st200_GR,
                                 RegFile_getNativeType(RegFile_st200_GR), offset);
  }
  Except_ENSURE(operator != Operator__UNDEF);

#line 66 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  Selector_makeOperation_1_2(this, operator, load_dst, offset, base);

#line 68 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  if (regFile == RegFile_st200_BR) {
    Selector_selectMOVE(this, dst, load_dst);
  }
}

#line 73 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Selector_selectSTORE --	Selector a store from memory
 */
void
Selector_selectSTORE(Selector this, NativeType nativeType, Temporary src, Temporary base,
               Temporary offset)
{
  Procedure procedure = Selector_PROCEDURE(this);
  RegFile regFile = Temporary_regFile(src);
  Operator operator;
  Temporary store_src;

#line 85 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  Except_ENSURE(Temporary_hasRegFile(src));
  Except_ENSURE(Temporary_isInvariant(offset));
  Except_ENSURE(Temporary_hasRegFile(base));
  Except_ENSURE(Temporary_regFile(base) == RegFile_st200_GR);

#line 90 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  if (regFile == RegFile_st200_GR) {
    store_src = src;
    operator = get_store_operator(this, regFile, nativeType, offset);
  } else {
    /* For BRC regFile we must first move into GRC and then store. */
    store_src = Procedure_makeVirtualTemporary(procedure, RegFile_st200_GR);
    Selector_selectMOVE(this, store_src, src);
    operator = get_store_operator(this, RegFile_st200_GR,
                                  RegFile_getNativeType(RegFile_st200_GR), offset);
  }
  Except_ENSURE(operator != Operator__UNDEF);

#line 102 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  Selector_makeOperation_0_3(this, operator, offset, base, store_src);
}

#line 105 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Selector_selectMOVE --	Selector a move between different regFile tns.
 */
void
Selector_selectMOVE(Selector this, Temporary dst, Temporary src)
{
  Except_ENSURE(Temporary_regFile(dst) != Temporary_regFile(src));
  if (Temporary_regFile(dst) == RegFile_st200_BR) {
    /* Move GRC -> BRC */
    Selector_makeOperation_1_1(this, Operator_st200_mtb_1branch_2general, dst, src);
  } else {
    /* Move BRC -> GRC */
    Selector_makeOperation_1_1(this, Operator_st200_mfb_1general_2branch, dst, src);
  }
}

#line 121 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Selector_selectCOPY --	Selector a copy between same regFile temporaries
 */
void
Selector_selectCOPY(Selector this, Temporary dst, Temporary src)
{
  Except_ENSURE(Temporary_regFile(dst) == Temporary_regFile(src));
  if (Temporary_regFile(dst) == RegFile_st200_BR) {
    /* Copy BRC -> BRC */
#ifdef MDS_CORE_st240
    if (Selector_processor(this) == Processor_st240_cpu) {
      Selector_makeOperation_1_1(this, Operator_st200_mov_bsrc_bdest_1branch_2branch, dst, src);
      return;
    }
#endif //MDS_CORE_st240
    {
      /* For BRC regFile copy we must a temporary GRC of value -1 and perform an addcg. */
      Temporary mone = Generate_Absolute(this, RegFile_st200_GR, NativeType_st200_Int32, -1);
      Temporary zero = Generate_Absolute(this, RegFile_st200_GR, NativeType_st200_Int32, 0);
      Temporary dummy = Get_DummyReg(this, RegFile_st200_GR);
      Selector_makeOperation_2_3(this,
                                 Operator_st200_addcg_1general_2branch_3general_4general_5branch,
                                 dummy, dst, zero, mone, src);
    }
  } else {
    /* Move GRC -> GRC */
    Selector_makeOperation_1_1(this, Operator_st200_mov_1general_2general, dst, src);
  }
}

#line 151 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Selector_selectCOPYOnTrue -- See interface description.
 */
void
Selector_selectCOPYOnTrue(Selector this, Temporary dst, Temporary cond, Temporary src)
{
  Except_ENSURE(Temporary_regFile(dst) == Temporary_regFile(src));
  Except_ENSURE(Temporary_regFile(dst) == RegFile_st200_GR);
  Except_ENSURE(Temporary_regFile(cond) == RegFile_st200_BR);
  Selector_makeOperation_1_3(this,
                             Operator_st200_slct_1general_2branch_3general_4general,
                             dst, cond, src, dst);
}

#line 165 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Selector_selectCOPYOnFalse -- See interface description.
 */
void
Selector_selectCOPYOnFalse(Selector this, Temporary dst, Temporary cond, Temporary src)
{
  Except_ENSURE(Temporary_regFile(dst) == Temporary_regFile(src));
  Except_ENSURE(Temporary_regFile(dst) == RegFile_st200_GR);
  Except_ENSURE(Temporary_regFile(cond) == RegFile_st200_BR);
  Selector_makeOperation_1_3(this,
                             Operator_st200_slctf_1general_2branch_3general_4general,
                             dst, cond, src, dst);
}

#line 179 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Selector_selectSWAP -- See interface description.
 */
void
Selector_selectSWAP(Selector this, Temporary dst1, Temporary dst2)
{
  Operator operator;
  Except_ENSURE(Temporary_regFile(dst1) == Temporary_regFile(dst2));
  Except_ENSURE(Temporary_regFile(dst1) == RegFile_st200_GR);

#line 189 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  operator = Operator_st200_xor_1general_2general_3general;
  Selector_makeOperation_1_2(this, operator, dst1, dst1, dst2);
  Selector_makeOperation_1_2(this, operator, dst2, dst1, dst2);
  Selector_makeOperation_1_2(this, operator, dst1, dst1, dst2);
}

#line 195 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Selector_selectGOTO --	Selector a control transfer to label.
 */
void
Selector_selectGOTO(Selector this, Label label)
{
  Procedure procedure = Selector_PROCEDURE(this);
  Temporary label_temporary = Procedure_makeLabelTemporary(procedure, label, 0,
                                                           Relocation_st200_btarg);
  Selector_makeOperation_0_1(this, Operator_st200_goto_1btarg, label_temporary);
}

#line 207 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Selector_selectGOTRUE --	Generates code to implement a GOTRUE
 */
void
Selector_selectGOTRUE(Selector this, Temporary condition, Label label)
{
  Procedure procedure = Selector_PROCEDURE(this);
  Temporary new_condition = condition;
  Temporary label_temporary;

#line 217 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  Except_REQUIRE(Temporary_hasRegFile(condition));

#line 219 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  label_temporary = Procedure_makeLabelTemporary(procedure,
                                                 label, 0, Relocation_st200_btarg);
  // Make copy if necessary
  if (Temporary_regFile(condition) != RegFile_st200_BR) {
    new_condition = Procedure_makeVirtualTemporary(procedure, RegFile_st200_BR);
    Selector_selectMOVE(this, new_condition, condition);
  }

#line 227 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  Selector_makeOperation_0_2(this, Operator_st200_br_1branch_2btarg,
                                   new_condition, label_temporary);
}

#line 232 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Selector_selectLAND --	Generates a logical AND
 */
void
Selector_selectLAND(Selector this, Temporary dst, Temporary src1, Temporary src2)
{
  // TODO: Do we need to support when both src1 and src2 are invariant?
  //       Can we common functions with LOr?
  Procedure procedure = Selector_PROCEDURE(this);
  Operator  operator = Operator__UNDEF;
  Temporary reg_temp1 = NULL;
  Temporary temp2 = NULL;

#line 245 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  Except_REQUIRE(   Temporary_hasRegFile(dst)
                 && (   Temporary_regFile(dst) == RegFile_st200_GR
                     || Temporary_regFile(dst) == RegFile_st200_BR));

#line 249 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  checkRegSrc1Src2(this, &reg_temp1, &temp2, src1, src2);

#line 251 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  if (Temporary_hasRegFile(temp2)) {
    if (Temporary_regFile(dst) == RegFile_st200_GR)
      operator = Operator_st200_andl_1general_2general_3general;
    else
      operator = Operator_st200_andl_1branch_2general_3general;
  }
  else if (Temporary_isAbsolute(temp2)) {
    TemporaryInvariant temp2_invariant = Temporary_INVARIANT(temp2);
    if (Immediate_canEncode(Immediate_st200_isrc2,
                            TemporaryInvariant_VALUE(temp2_invariant)))
    {
      if (Temporary_regFile(dst) == RegFile_st200_GR)
        operator = Operator_st200_andl_1general_2general_3isrc2;
      else
        operator = Operator_st200_andl_1branch_2general_3isrc2;
    }
    else {
      if (Temporary_regFile(dst) == RegFile_st200_GR)
        operator = Operator_st200_andl_1general_2general_3xsrc2;
      else
        operator = Operator_st200_andl_1branch_2general_3xsrc2;
    }
  } else Except_NEVER(true);
  Selector_makeOperation_1_2(this, operator, dst, reg_temp1, temp2);
}

#line 278 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Selector_selectLNOT --	Generates a logical NOT
 */
void
Selector_selectLNOT(Selector this, Temporary dst, Temporary src)
{
  // TODO: Do we need to support when src is invariant?
  Procedure procedure = Selector_PROCEDURE(this);
  Operator  operator = Operator__UNDEF;
  Temporary new_source = src;

#line 289 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  Except_REQUIRE(Temporary_hasRegFile(dst));
  Except_REQUIRE(Temporary_hasRegFile(src));
  Except_ENSURE(  Temporary_regFile(dst) == RegFile_st200_GR
                || Temporary_regFile(dst) == RegFile_st200_BR);

#line 294 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  // Select the appropriate operator
  if (Temporary_regFile(dst) == RegFile_st200_GR)
    operator = Operator_st200_norl_1general_2general_3general;
  else if (Temporary_regFile(dst) == RegFile_st200_BR)
    operator = Operator_st200_norl_1branch_2general_3general;

#line 300 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  // Make copy if necessary
  if (Temporary_regFile(src) != RegFile_st200_GR) {
    new_source = Procedure_makeVirtualTemporary(procedure, RegFile_st200_GR);
    Selector_selectMOVE(this, new_source, src);
  }
  // Make the LNot operation.
  Except_ENSURE(operator != Operator__UNDEF);
  Selector_makeOperation_1_2(this, operator, dst, new_source,
                             Procedure_makeDedicatedTemporary(procedure, Register_st200_GR0));
}

#line 312 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Selector_selectLOR --	Generates a logical OR
 */
void
Selector_selectLOR(Selector this, Temporary dst, Temporary src1, Temporary src2)
{
  // TODO: Do we need to support when both src1 and src2 are invariant?
  //       Can we common functions with LAnd?
  Procedure procedure = Selector_PROCEDURE(this);
  Operator  operator = Operator__UNDEF;
  Temporary reg_temp1 = NULL;
  Temporary temp2 = NULL;

#line 325 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  Except_REQUIRE(Temporary_hasRegFile(dst));
  Except_ENSURE(  Temporary_regFile(dst) == RegFile_st200_GR
                || Temporary_regFile(dst) == RegFile_st200_BR);

#line 329 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  checkRegSrc1Src2(this, &reg_temp1, &temp2, src1, src2);

#line 331 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  if (Temporary_hasRegFile(temp2)) {
    if (Temporary_regFile(dst) == RegFile_st200_GR)
      operator = Operator_st200_orl_1general_2general_3general;
    else
      operator = Operator_st200_orl_1branch_2general_3general;
  }
  else if (Temporary_isAbsolute(temp2)) {
    TemporaryInvariant temp2_invariant = Temporary_INVARIANT(temp2);
    if (Immediate_canEncode(Immediate_st200_isrc2,
                            TemporaryInvariant_VALUE(temp2_invariant)))
    {
      if (Temporary_regFile(dst) == RegFile_st200_GR)
        operator = Operator_st200_orl_1general_2general_3isrc2;
      else
        operator = Operator_st200_orl_1branch_2general_3isrc2;
    }
    else {
      if (Temporary_regFile(dst) == RegFile_st200_GR)
        operator = Operator_st200_orl_1general_2general_3xsrc2;
      else
        operator = Operator_st200_orl_1branch_2general_3xsrc2;
    }
  } else Except_NEVER(true);
  Selector_makeOperation_1_2(this, operator, dst, reg_temp1, temp2);
}

#line 358 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Selector_selectSELECT --	Generates a select
 */
void
Selector_selectSELECT(Selector this, Temporary dst, Temporary cond,
                               Temporary src1, Temporary src2)
{
  // TODO: Do we need to support when both src1 and src2 are invariant?
  //       Can we common functions with LAnd?
  Procedure procedure = Selector_PROCEDURE(this);
  Operator  operator = Operator__UNDEF;
  Temporary reg_temp1 = NULL;
  Temporary temp2 = NULL;

#line 372 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  Except_REQUIRE(Temporary_hasRegFile(dst));
  Except_REQUIRE(Temporary_hasRegFile(cond));

#line 375 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  checkRegSrc1Src2(this, &reg_temp1, &temp2, src1, src2);

#line 377 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  if (Temporary_regFile(cond) != RegFile_st200_BR) {
    Temporary new_cond = Procedure_makeVirtualTemporary(procedure, RegFile_st200_BR);
    Selector_selectMOVE(this, new_cond, cond);
    cond = new_cond;
  }

#line 383 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  if (Temporary_hasRegFile(temp2)) {
    operator = Operator_st200_slct_1general_2branch_3general_4general;
  }
  else if (Temporary_isAbsolute(temp2)) {
    TemporaryInvariant temp2_invariant = Temporary_INVARIANT(temp2);
    if (Immediate_canEncode(Immediate_st200_isrc2,
                            TemporaryInvariant_VALUE(temp2_invariant)))
    {
      operator = Operator_st200_slct_1general_2branch_3general_4isrc2;
    }
    else {
      operator = Operator_st200_slct_1general_2branch_3general_4xsrc2;
    }
  } else Except_NEVER(true);
  Selector_makeOperation_1_3(this, operator, dst, cond, reg_temp1, temp2);
}

#line 400 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Selector_selectMAKEAbsolute --	Selector an absolute value into dst.
 */
void
Selector_selectMAKEAbsolute(Selector this, NativeType nativeType, Temporary dst, int64_t value)
{
  Procedure procedure = Selector_PROCEDURE(this);
  RegFile regFile = Temporary_regFile(dst);

#line 409 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  if (value == 0 && regFile == RegFile_st200_GR) {
    Selector_selectCOPY(this, dst, Procedure_makeDedicatedTemporary(procedure, Register_st200_GR0));
  } else if (regFile == RegFile_st200_GR) {
    /* Build value into a GRC. */
    Temporary absolute = Procedure_makeAbsoluteTemporary(procedure, (ImmediateValue)value, Relocation__UNDEF);
    Selector_makeOperation_1_1(this, Operator_st200_mov_1general_2isrc2, dst, absolute);
  } else {
    /* Build value into a BRC. */
    if (value == 0) {
      Selector_selectMOVE(this, dst, Generate_Absolute(this, RegFile_st200_GR, NativeType_st200_Int32, 0));
    } else {
      Selector_selectMOVE(this, dst, Generate_Absolute(this, RegFile_st200_GR, NativeType_st200_Int32, 1));
    }
  }
}

#line 425 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Get_Address_Base_and_Offset --	Get the temporary pair (base, offset)
 * for building a symbol+offset address.
 * Currently handle:
 * - SP based
 * - FP based
 * - GP based
 * Does not handle:
 * - relocations
 */
static void
Get_Address_Base_and_Offset(Selector this, Symbol symbol, int64_t offset, Temporary *t_base, Temporary *t_offset)
{
  Procedure procedure = Selector_PROCEDURE(this);
  Program program = Procedure_PROGRAM(procedure);
  SymbolTable symbolTable = Program_SYMBOLTABLE(program);
  // Ensure symbol is allocated
  //Allocate_Symbol(this, symbol);
  if (Symbol_store(symbol) == SymbolStore_AUTO) {
    *t_offset = Procedure_makeSymbolTemporary(procedure, symbol, offset, Relocation__UNDEF);
    /* If an FP based symbol base register is FP else SP. */
    if (SymbolTable_getBaseSymbol(symbolTable, symbol) == Get_Symbol_FP(this)) {
      *t_base = Get_FP(this);
    } else {
      *t_base = Get_SP(this);
    }
  } else {
    *t_offset = Procedure_makeSymbolTemporary(procedure, symbol, offset, Relocation__UNDEF);
    /* If an GP based symbol base register is GP, else no base. */
    if (SymbolTable_getBaseSymbol(symbolTable, symbol) == Get_Symbol_GP(this)) {
      *t_base = Get_GP(this);
    } else {
      *t_base = NULL;
    }
  }
}

#line 462 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Selector_selectMAKEAddress --	Selector a symbolic address + offset into dst.
 */
void
Selector_selectMAKEAddress(Selector this, NativeType nativeType, Temporary dst, Symbol symbol, int64_t offset)
{
  Temporary t_base, t_offset;
  Except_ENSURE(Temporary_regFile(dst) == RegFile_st200_GR);

#line 471 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  Get_Address_Base_and_Offset(this, symbol, offset, &t_base, &t_offset);
  if (t_base != NULL) {
    Selector_makeOperation_1_2(this, Operator_st200_add_1general_2general_3isrc2,
                      dst, t_base, t_offset);
  } else {
    Selector_makeOperation_1_1(this, Operator_st200_mov_1general_2xsrc2, dst, t_offset);
  }
}

#line 480 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Selector_selectDirectLOAD --	Selector a direct load at address symbol+offset
 */
void
Selector_selectDirectLOAD(Selector this, NativeType nativeType, Temporary dst, Symbol symbol, int64_t offset)
{
  Temporary t_base, t_offset;
  Except_ENSURE(Temporary_hasRegFile(dst));

#line 489 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  Get_Address_Base_and_Offset(this,symbol, offset, &t_base, &t_offset);
  if (t_base != NULL) {
    Selector_selectLOAD(this, nativeType, dst, t_base, t_offset);
  } else {
    Temporary t_zero = Generate_Absolute(this, RegFile_st200_GR, NativeType_st200_Int32, 0);
    Selector_selectLOAD(this, nativeType, dst, t_zero, t_offset);
  }
}

#line 498 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Selector_selectDirectSTORE --	Selector a direct store at address symbol+offset
 */
void
Selector_selectDirectSTORE(Selector this, NativeType nativeType, Temporary src, Symbol symbol, int64_t offset)
{
  Temporary t_base, t_offset;
  Except_ENSURE(Temporary_hasRegFile(src));

#line 507 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  Get_Address_Base_and_Offset(this, symbol, offset, &t_base, &t_offset);
  if (t_base != NULL) {
    Selector_selectSTORE(this, nativeType, src, t_base, t_offset);
  } else {
    Temporary t_zero = Generate_Absolute(this, RegFile_st200_GR, NativeType_st200_Int32, 0);
    Selector_selectSTORE(this, nativeType, src, t_zero, t_offset);
  }
}

#line 516 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Generate_Absolute --	Selector an absolute value into a new register
 * or get a register with this value.
 */
static Temporary
Generate_Absolute(Selector this, RegFile regFile, NativeType nativeType, int64_t value)
{
  Procedure procedure = Selector_PROCEDURE(this);
  Temporary dst;
  if (value == 0 && regFile == RegFile_st200_GR)
    /* Hardwired sero reg. */
    return Procedure_makeDedicatedTemporary(procedure, Register_st200_GR0);

#line 529 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  if (regFile == RegFile_st200_GR) {
    /* Build value into a GRC. */
    Temporary absolute = Procedure_makeAbsoluteTemporary(procedure, (ImmediateValue)value, Relocation__UNDEF);
    dst = Procedure_makeVirtualTemporary(procedure, RegFile_st200_GR);
    Selector_makeOperation_1_1(this, Operator_st200_mov_1general_2isrc2, dst, absolute);
  } else {
    /* Build value into a BRC. */
    dst = Procedure_makeVirtualTemporary(procedure, RegFile_st200_BR);
    if (value == 0) {
      Selector_selectMOVE(this, dst, Generate_Absolute(this, RegFile_st200_GR, NativeType_st200_Int32, 0));
    } else {
      Selector_selectMOVE(this, dst, Generate_Absolute(this, RegFile_st200_GR, NativeType_st200_Int32, 1));
    }
  }
  return dst;
}

#line 546 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Get_DummyReg --	Get a register that can be read/write
 * without side effect or generate a temporary if no such register
 * is available.
 */
static Temporary
Get_DummyReg(Selector this, RegFile regFile)
{
  Procedure procedure = Selector_PROCEDURE(this);
  if (regFile == RegFile_st200_GR) {
    return Procedure_makeDedicatedTemporary(procedure, Register_st200_GR0);
  }
  return Procedure_makeVirtualTemporary(procedure, regFile);
}

#line 561 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Get_SP --	Get the stack pointer.
 */
static Temporary
Get_SP(Selector this)
{
  Procedure procedure = Selector_PROCEDURE(this);
  return Procedure_makeDedicatedTemporary(procedure, Register_st200_GR12);
}

#line 571 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Get_FP --	Get the frame pointer.
 */
static Temporary
Get_FP(Selector this)
{
  Procedure procedure = Selector_PROCEDURE(this);
  return Procedure_makeDedicatedTemporary(procedure, Register_st200_GR7);
}

#line 581 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Get_GP --	Get the global pointer.
 */
static Temporary
Get_GP(Selector this)
{
  /* Not in the current ABI. */
  return NULL;
}

#line 591 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Get_Symbol_SP --	Get an unique symbol for SP based block
 */
static Symbol
Get_Symbol_SP(Selector this)
{
  Procedure procedure = Selector_PROCEDURE(this);
  return Procedure_SYMBOLSP(procedure);
}

#line 601 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Get_Symbol_FP --	Get an unique symbol for FP based block
 */
static Symbol
Get_Symbol_FP(Selector this)
{
  Procedure procedure = Selector_PROCEDURE(this);
  return Procedure_SYMBOLFP(procedure);
}

#line 611 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Get_Symbol_GP --	Get an unique symbol for GP based block
 */
static Symbol
Get_Symbol_GP(Selector this)
{
  Procedure procedure = Selector_PROCEDURE(this);
  return Procedure_SYMBOLGP(procedure);
}

#line 621 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Get machine operator for load of NativeType (type)
 * into register of RegFile (regFile).
 */
static Operator
get_load_operator(Selector this, RegFile regFile, NativeType nativeType,
                  Temporary offset)
{
  Operator operator;
  TemporaryInvariant offset_invariant = Temporary_INVARIANT(offset);
  Except_ENSURE(regFile == RegFile_st200_BR || regFile == RegFile_st200_GR);
  /* No load of BR. */
  if (regFile == RegFile_st200_BR) return Operator__UNDEF;
  //
  if (   Temporary_isAbsolute(offset)
      && Immediate_canEncode(Immediate_st200_isrc2,
                             TemporaryInvariant_VALUE(offset_invariant))) {
    switch(nativeType) {
    case NativeType_st200_UInt8:
      operator = Operator_st200_ldbu_1nolink_2isrc2_3general; break;
    case NativeType_st200_Int8:
      operator = Operator_st200_ldb_1nolink_2isrc2_3general; break;
    case NativeType_st200_UInt16:
      operator = Operator_st200_ldhu_1nolink_2isrc2_3general; break;
    case NativeType_st200_Int16:
      operator = Operator_st200_ldh_1nolink_2isrc2_3general; break;
    case NativeType_st200_UInt32:
    case NativeType_st200_Int32:
      operator = Operator_st200_ldw_1general_2isrc2_3general; break;
    default:
      operator = Operator__UNDEF;
    }
  } else {
    switch(nativeType) {
    case NativeType_st200_UInt8:
      operator = Operator_st200_ldbu_1nolink_2xsrc2_3general; break;
    case NativeType_st200_Int8:
      operator = Operator_st200_ldb_1nolink_2xsrc2_3general; break;
    case NativeType_st200_UInt16:
      operator = Operator_st200_ldhu_1nolink_2xsrc2_3general; break;
    case NativeType_st200_Int16:
      operator = Operator_st200_ldh_1nolink_2xsrc2_3general; break;
    case NativeType_st200_UInt32:
    case NativeType_st200_Int32:
      operator = Operator_st200_ldw_1general_2xsrc2_3general; break;
    default:
      operator = Operator__UNDEF;
    }
  }
  return operator;
}

#line 673 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * Get machine operator for store of NativeType (type)
 * from register of RegFile (regFile).
 */
static Operator
get_store_operator(Selector this, RegFile regFile, NativeType nativeType,
                   Temporary offset)
{
  Operator operator;
  TemporaryInvariant offset_invariant = Temporary_INVARIANT(offset);
  Except_ENSURE(regFile == RegFile_st200_BR || regFile == RegFile_st200_GR);
  /* No store of BR. */
  if (regFile == RegFile_st200_BR) return Operator__UNDEF;
  if (   Temporary_isAbsolute(offset)
      && Immediate_canEncode(Immediate_st200_isrc2,
                             TemporaryInvariant_VALUE(offset_invariant))) {
    switch(nativeType) {
    case NativeType_st200_UInt8:
    case NativeType_st200_Int8:
      operator = Operator_st200_stb_1isrc2_2general_3general; break;
    case NativeType_st200_UInt16:
    case NativeType_st200_Int16:
      operator = Operator_st200_sth_1isrc2_2general_3general; break;
    case NativeType_st200_UInt32:
    case NativeType_st200_Int32:
      operator = Operator_st200_stw_1isrc2_2general_3general; break;
    default:
      operator = Operator__UNDEF;
    }
  } else {
    switch(nativeType) {
    case NativeType_st200_UInt8:
    case NativeType_st200_Int8:
      operator = Operator_st200_stb_1xsrc2_2general_3general; break;
    case NativeType_st200_UInt16:
    case NativeType_st200_Int16:
      operator = Operator_st200_sth_1xsrc2_2general_3general; break;
    case NativeType_st200_UInt32:
    case NativeType_st200_Int32:
      operator = Operator_st200_stw_1xsrc2_2general_3general; break;
    default:
      operator = Operator__UNDEF;
    }
  }
  return operator;
}

#line 720 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
/*
 * The following function will generate the appropriate moves or
 * swaps such that a GR register temporary is returned in reg_src1
 * and a GR register or invariant temporary is returned in new_src2
 * given a src1 and src2.
 */
static inline void
checkRegSrc1Src2(Selector this, Temporary* reg_src1, Temporary* new_src2,
                                Temporary  src1, Temporary src2)
{
  // This code relies on a decent inliner to avoid the redundant checks
  Procedure procedure = Selector_PROCEDURE(this);
  if (Temporary_hasRegFile(src1)) {
    *reg_src1 = src1;
    *new_src2 = src2;
  }
  else if (Temporary_hasRegFile(src2)) {
    *reg_src1 = src2;
    *new_src2 = src1;
  }
  else if (Temporary_isAbsolute(src1)) {
    Temporary new_temp = Procedure_makeVirtualTemporary(procedure, RegFile_st200_GR);
    TemporaryInvariant src1_invariant = Temporary_INVARIANT(src1);
    if (Immediate_canEncode(Immediate_st200_isrc2,
                            TemporaryInvariant_VALUE(src1_invariant)))
    {
      Selector_makeOperation_1_1(this, Operator_st200_mov_1general_2isrc2, new_temp, src1);
    }
    else {
      Selector_makeOperation_1_1(this, Operator_st200_mov_1general_2xsrc2, new_temp, src1);
    }
    *reg_src1 = new_temp;
    *new_src2 = src2;
  } else Except_NEVER(true);

#line 755 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  if (Temporary_regFile(*reg_src1) != RegFile_st200_GR) {
    Temporary new_temp = Procedure_makeVirtualTemporary(procedure, RegFile_st200_GR);
    Selector_selectMOVE(this, new_temp, *reg_src1);
    *reg_src1 = new_temp;
  }

#line 761 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/st200-Selector.xcc"
  if (Temporary_hasRegFile(*new_src2)) {
    if (Temporary_regFile(*new_src2) != RegFile_st200_GR) {
      Temporary new_temp = Procedure_makeVirtualTemporary(procedure, RegFile_st200_GR);
      Selector_selectMOVE(this, new_temp, *new_src2);
      *new_src2 = new_temp;
    }
  }
}


#endif//Selector_c_INCLUDED
