#ifndef Selector__h_INCLUDED
#define Selector__h_INCLUDED

//
#include "LIR/Selector.h"

/*
 * Selector_incrementPhiCount --	Increment the PHICOUNT of this Selector.
 */
static inline int
Selector_incrementPhiCount(Selector this)
{
  int phiCount = Selector_PHICOUNT(this) + 1;
  *Selector__PHICOUNT(this) = phiCount;
  Except_CHECK(phiCount == Selector_PHICOUNT(this));
  return phiCount;
}

/*
 * Selector_decrementPhiCount --	Decrement the PHICOUNT of this Selector.
 */
static inline int
Selector_decrementPhiCount(Selector this)
{
  int phiCount = Selector_PHICOUNT(this) - 1;
  *Selector__PHICOUNT(this) = phiCount;
  Except_CHECK(phiCount == Selector_PHICOUNT(this));
  return phiCount;
}

/*
 * Selector_INIT --	Initialize Selector module.
 */
#define Selector_INIT()

/*
 * Selector_FINI --	Finalize Selector module.
 */
#define Selector_FINI()


#endif//Selector__h_INCLUDED
