#ifndef Temporary_c_INCLUDED
#define Temporary_c_INCLUDED

#line 122 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
#include "LIR/LIR_.h"

#line 132 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 184 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
#ifndef ECL_NTRACE
const char *
TemporaryType_name_(TemporaryType this)
{
  static const char *_[] = {
    "Dedicated",
    "Virtual",
    "Variable",
    "Absolute",
    "Symbol",
    "Label",
    "Modifier",
    "RegMask",
    "Volatile",
    "Control",
    "Memory",
  };
  Except_REQUIRE((unsigned)this < TemporaryType__);
  return _[this];
}
#endif//ECL_NTRACE

#line 206 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 228 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
#ifndef ECL_NTRACE
ETableEntry_ TemporaryFlagEntries[] = {
  ETableENTRY(TemporaryFlag, Constant),
  ETableENTRY(TemporaryFlag, Register),
  ETableENTRY(TemporaryFlag, Global),
  ETableENTRY(TemporaryFlag, Killed),
  ETableENTRY(TemporaryFlag, Remater),
  ETableENTRY(TemporaryFlag, Homeable),
  ETableENTRY(TemporaryFlag, RenameOK),
  ETableENTRY(TemporaryFlag, Recycled),
  ETableENTRY_NULL
};
ETable_ TemporaryFlag_Table[1];
#endif//ECL_NTRACE

#line 311 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
Temporary
Temporary_Ctor(Temporary this,
               TemporaryType type, unsigned flags)
{
  Indexed_Ctor(Temporary____(this), Temporary_Factory);
  *Temporary__WEBROOT(this) = NULL;
  *Temporary__TYPE(this) = type;
  *Temporary__FLAGS(this) = flags;
  *Temporary__REGISTER(this) = Register__UNDEF;
  *Temporary__WIDTH(this) = 0;
  return this;
}

#line 329 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 409 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 515 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 549 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
int
Temporary_compare(const_Temporary this, const_Temporary that)
{
  int this_type = Temporary_TYPE(this);
  int that_type = Temporary_TYPE(that);
  int this_register = Temporary_REGISTER(this);
  int that_register = Temporary_REGISTER(that);
  uint32_t this_identity = Temporary_IDENTITY(this);
  uint32_t that_identity = Temporary_IDENTITY(that);
  int compare_type = that_type - this_type;
  int compare_register = this_register - that_register;
  int compare_identity = (this_identity > that_identity) -
                         (this_identity < that_identity);
  if (compare_type) return compare_type;
  if (compare_register &&
      Temporary_hasRegister(this)) return compare_register;
  return compare_identity;
}

#line 574 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
#ifndef ECL_NTRACE
#include <ctype.h>
bool
Temporary_pretty(const_Temporary this, FILE *file)
{
  if (this == NULL) return true;
  if (file == NULL) file = stderr;
  if (Temporary_hasRegFile(this)) {
    Register registre = Temporary_REGISTER(this);
    RegFile regFile = Register_regFile(registre);
    const char *name = RegFile_name(regFile);
    char c = Temporary_isGlobal(this)? toupper(*name): tolower(*name);
    if (Temporary_isDedicated(this)) {
      Except_CHECK(Temporary_hasRegister(this));
      fprintf(file, "%s", Register_names(registre)[0]);
    } else if (Temporary_isAssigned(this)) {
      Except_CHECK(Temporary_hasRegister(this));
      fprintf(file, "%c%d", c, Temporary_IDENTITY(this));
      fprintf(file, "(%s)", Register_names(registre)[0]);
    } else if (Temporary_isVirtual(this)) {
      fprintf(file, "%c%d", c, Temporary_IDENTITY(this));
    } else if (Temporary_isVariable(this)) {
      Variable_pretty(Temporary_VARIABLE(this), file, 0);
    } else {
      fprintf(file, "ERROR(Register)");
    }
  } else if (Temporary_isInvariant(this)) {
    TemporaryInvariant invariant = Temporary_INVARIANT(this);
    if (Temporary_isAbsolute(this)) {
      fprintf(file, "%lld", (long long)TemporaryInvariant_VALUE(invariant));
    } else if (Temporary_isSymbol(this)) {
      Symbol symbol = TemporaryInvariant_SYMBOL(invariant);
      ImmediateValue offset = TemporaryInvariant_OFFSET(invariant);
      if (offset == 0)
        fprintf(file, "%s", Symbol_NAME(symbol));
      else
        fprintf(file, "%s%+lld", Symbol_NAME(symbol), (long long)offset);
    } else if (Temporary_isLabel(this)) {
      Label label = TemporaryInvariant_LABEL(invariant);
      ImmediateValue offset = TemporaryInvariant_OFFSET(invariant);
      if (offset == 0)
        fprintf(file, "%s", Label_NAME(label));
      else
        fprintf(file, "%s%+lld", Label_NAME(label), (long long)offset);
    } else if (Temporary_isModifier(this)) {
      Modifier modifier = TemporaryInvariant_MODIFIER(invariant);
      ModifierMember member = TemporaryInvariant_MEMBER(invariant);
      fprintf(file, ModifierMember_name_(member));
    } else if (Temporary_isRegMask(this)) {
      fprintf(file, "RegMask)");
    } else {
      fprintf(file, "ERROR(Invariant)");
    }
  } else if (Temporary_isVolatile(this)) {
    fprintf(file, "Volatile");
  } else if (Temporary_isControl(this)) {
    fprintf(file, "Control");
  } else if (Temporary_isMemory(this)) {
    fprintf(file, "Memory");
  } else {
    fprintf(file, "ERROR(?)");
  }
  return true;
}
#endif//ECL_NTRACE

#line 658 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
void
Temporary_assignRegister(Temporary this, Register registre)
{
  Except_REQUIRE(Temporary_hasRegFile(this));
  Except_REQUIRE(Temporary_REGFILE(this) == Register_regFile(registre));
  *Temporary__FLAGS(this) |= TemporaryFlag_Register;
  *Temporary__REGISTER(this) = registre;
}

#line 673 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
void
Temporary_unassignRegister(Temporary this)
{
  Register registre = Temporary_REGISTER(this);
  RegFile regFile = Register_regFile(registre);
  Except_REQUIRE(Temporary_hasRegFile(this));
  *Temporary__FLAGS(this) &= ~TemporaryFlag_Register;
  *Temporary__REGISTER(this) = RegFile_lowRegister(regFile);
}

#line 692 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 714 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
TemporaryStack
TemporaryStack_Ctor(TemporaryStack this,
                    Memory memory, int maxCount)
{
  PtrSeq_Ctor(TemporaryStack____(this), memory, maxCount);
  return this;
}

#line 722 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
void
TemporaryStack_Dtor(TemporaryStack this)
{
  PtrSeq_Dtor(TemporaryStack____(this));
}

#line 787 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 810 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
TemporarySet
TemporarySet_Ctor(TemporarySet this,
                  Memory memory, int32_t estimate)
{
  PtrSet_Ctor(TemporarySet____(this), memory, estimate);
  return this;
}

#line 818 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
void
TemporarySet_Dtor(TemporarySet this)
{
  PtrSet_Dtor(TemporarySet____(this));
}

#line 824 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
size_t
TemporarySet_Size(Memory memory, int32_t estimate)
{
	return sizeof(TemporarySet_);
}

#line 907 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
TemporarySet
TemporarySet_make(Memory memory, int32_t estimate)
{
  size_t size = TemporarySet_Size(memory, estimate);
  TemporarySet this = Memory_alloc(memory, size);
  return TemporarySet_Ctor(this, memory, estimate);
}

#line 919 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
TemporarySet
TemporarySet_kill(TemporarySet this)
{
  if (this != NULL) {
    Memory memory = TemporarySet_MEMORY(this);
    TemporarySet_Dtor(this);
    Memory_free_(memory, this);
  }
  return NULL;
}

#line 936 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
#ifndef ECL_NTRACE
bool
TemporarySet_pretty(TemporarySet this, FILE *file)
{
  if (file == NULL) file = stderr;
  fprintf(file, "{");
  TemporarySet_FORSORT_Temporary(this, Temporary_compare, temporary) {
    fprintf(file, " ");
    Temporary_pretty(temporary, file);
  } TemporarySet_ENDSORT_Temporary;
  fprintf(file, " }");
  return true;
}
#endif//ECL_NTRACE

#line 957 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
#ifndef ECL_NTRACE
bool
TemporarySet_display(TemporarySet this, FILE *file)
{
  if (file == NULL) file = stderr;
  if (this == NULL || TemporarySet_isEmpty(this)) {
    fprintf(file, "--");
  } else {
    int i = 1;
    int count = TemporarySet_count(this);
    TemporarySet_FORSORT_Temporary(this, Temporary_compare, temporary) {
      Temporary_pretty(temporary, file);
      if (i % 4 == 0 && i != count)
        fprintf(file, "\\n");
      else
        fprintf(file, "\\ ");
      i++;
    } TemporarySet_ENDSORT_Temporary;
  }
  return true;
}
#endif//ECL_NTRACE

#line 980 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1005 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
TemporaryTable
TemporaryTable_Ctor(TemporaryTable this,
                    Memory memory, int32_t estimate)
{
  IndexedTable_Ctor(TemporaryTable____(this), memory, estimate);
  return this;
}

#line 1013 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
void
TemporaryTable_Dtor(TemporaryTable this)
{
  IndexedTable_Dtor(TemporaryTable____(this));
}

#line 1062 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
#ifndef ECL_NTRACE
bool
TemporaryTable_pretty(const_TemporaryTable this, FILE *file)
{
  if (file == NULL) file = stderr;
  fprintf(file, "{");
  TemporaryTable_FOREACH_Temporary(this, temporary) {
    fprintf(file, " [%d]", Temporary_INDEX(temporary));
    Temporary_pretty(temporary, file);
  } TemporaryTable_ENDEACH_Temporary;
  fprintf(file, " }");
  return true;
}
#endif//ECL_NTRACE

#line 1077 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1101 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
TemporarySparse
TemporarySparse_Ctor(TemporarySparse this,
                     Memory memory, TemporaryTable table)
{
  IndexedTable indexedTable = TemporaryTable__(table);
  IndexedSparse_Ctor(TemporarySparse____(this), memory, indexedTable);
  return this;
}

#line 1110 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
void
TemporarySparse_Dtor(TemporarySparse this)
{
  IndexedSparse_Dtor(TemporarySparse____(this));
}

#line 1180 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
void
TemporarySparse_insertSet(TemporarySparse this, const_TemporarySet temporarySet)
{
  const_TemporaryTable temporaryTable = TemporarySparse_table_const(this);
  TemporarySet_FOREACH_Temporary(temporarySet, temporary) {
    if (TemporaryTable_contains(temporaryTable, temporary)) {
      TemporarySparse_insert(this, temporary);
    }
  } TemporarySet_ENDEACH_Temporary;
}

#line 1195 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
#ifndef ECL_NTRACE
bool
TemporarySparse_pretty(const_TemporarySparse this, FILE *file)
{
  if (file == NULL) file = stderr;
  fprintf(file, "{");
  TemporarySparse_FOREACH_Temporary(this, temporary) {
    fprintf(file, " [%d]", Temporary_INDEX(temporary));
    Temporary_pretty(temporary, file);
  } TemporarySparse_ENDEACH_Temporary;
  fprintf(file, " }");
  return true;
}
#endif//ECL_NTRACE

#line 1210 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1227 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
TemporaryMap
TemporaryMap_Ctor(TemporaryMap this,
                  Memory memory, int32_t maxCount, size_t itemSize)
{
  size_t totalSize = maxCount*itemSize;
  *TemporaryMap__MEMORY(this) = memory;
  *TemporaryMap__MAXCOUNT(this) = 0;
  *TemporaryMap__ITEMSIZE(this) = itemSize;
  *TemporaryMap__BASE(this) = NULL;
  if (maxCount > 0) TemporaryMap_resize(this, maxCount);
  return this;
}

#line 1240 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
void
TemporaryMap_Dtor(TemporaryMap this)
{
  TemporaryMap_release(this, NULL);
}

#line 1257 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
void
TemporaryMap_resize(TemporaryMap this, int32_t maxCount)
{
  Memory memory = TemporaryMap_MEMORY(this);
  size_t itemSize = TemporaryMap_ITEMSIZE(this);
  size_t totalSize = maxCount*itemSize;
  Except_REQUIRE(TemporaryMap_MAXCOUNT(this) == 0);
  if (maxCount > 0) {
    *TemporaryMap__MAXCOUNT(this) = maxCount;
    *TemporaryMap__BASE(this) = Memory_alloc(memory, totalSize);
  }
}

#line 1276 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
void
TemporaryMap_release(TemporaryMap this, void (*release)(void * item))
{
  Memory memory = TemporaryMap_MEMORY(this);
  void *base = TemporaryMap_BASE(this);
  if (base != NULL && release != NULL) {
    char *item = base;
    size_t itemSize = TemporaryMap_ITEMSIZE(this);
    int32_t maxCount = TemporaryMap_MAXCOUNT(this), i;
    for (i = 0; i < maxCount; i++) {
      (*release)((void *)item);
      item += itemSize;
    }
  }
  Memory_free(memory, base);
}

#line 1293 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1344 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
void *
TemporaryMap_access(TemporaryMap this, Temporary temporary)
{
  int32_t index = Temporary_INDEX(temporary);
  char *base = TemporaryMap_BASE(this);
  int32_t maxCount = TemporaryMap_MAXCOUNT(this);
  size_t itemSize = TemporaryMap_ITEMSIZE(this);
  Except_REQUIRE(index >= 0 && index < maxCount);
  return base + itemSize*index;
}

#line 1355 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1361 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
#ifndef ECL_NTRACE
bool
Temporary_DTD(FILE *file)
{
  fputs(
	"<!ENTITY % bool 'NMTOKEN' >"
	"<!ENTITY % char 'NMTOKEN' >"
	"<!ENTITY % int8_t 'NMTOKEN' >"
	"<!ENTITY % uint8_t 'NMTOKEN' >"
	"<!ENTITY % int16_t 'NMTOKEN' >"
	"<!ENTITY % uint16_t 'NMTOKEN' >"
	"<!ENTITY % int32_t 'NMTOKEN' >"
	"<!ENTITY % uint32_t 'NMTOKEN' >"
	"<!ENTITY % int64_t 'NMTOKEN' >"
	"<!ENTITY % uint64_t 'NMTOKEN'> "
	"<!ENTITY % intptr_t 'NMTOKEN' >"
	"<!ENTITY % uintptr_t 'NMTOKEN' >"
	"<!ENTITY % size_t 'NMTOKEN' >"
	"<!ENTITY % float 'NMTOKEN' >"
	"<!ENTITY % Variable 'IDREF' >"
	"<!ENTITY % Register 'IDREF' >"
	"<!ENTITY % RegFile 'IDREF' >"
	"<!ENTITY % Immediate 'IDREF' >"
        "<!ELEMENT Temporary EMPTY >"
        "<!ATTLIST Temporary"
        "  ID ID #REQUIRED"
	"  Variable %Variable; #IMPLIED"
	"  Type  ( Dedicated | Virtual | Variable | Absolute | Symbol | Label | Modifier | RegMask | Volatile | Control | Memory) #REQUIRED"
	"  Flags NMTOKENS #IMPLIED"
	"  Register %Register; #IMPLIED"
	"  Width %int8_t; #IMPLIED"
	"  Value %int64_t; #IMPLIED"
	"  Offset %int64_t; #IMPLIED"
	"  SymbolName CDATA #IMPLIED"
	"  LabelValue %int64_t; #IMPLIED"
	"  Label CDATA #IMPLIED"
	"  Relocation %Immediate; #IMPLIED"
        ">"
	, file);
  return true;
}
#endif//ECL_NTRACE

#line 1419 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
#ifndef ECL_NTRACE
bool
Temporary_dumpXML(Temporary this, XMLGen gen)
{
  char regType[64]="";
  char attval[64]="";
  XMLGenElement elemTemp = XMLGen_declareElement(gen, "Temporary");
  XMLGenAttribute attID = XMLGen_declareAttribute(gen, "ID");
  XMLGenAttribute attRegister = XMLGen_declareAttribute(gen, "Register");
  XMLGenAttribute attValue = XMLGen_declareAttribute(gen, "Value");
  XMLGenAttribute attLabelValue = XMLGen_declareAttribute(gen, "LabelValue");
  XMLGenAttribute attLabel = XMLGen_declareAttribute(gen, "Label");
  XMLGenAttribute attOffset = XMLGen_declareAttribute(gen, "Offset");
  XMLGenAttribute attSymbol = XMLGen_declareAttribute(gen, "SymbolName");
  XMLGenAttribute attFlags = XMLGen_declareAttribute(gen, "Flags");
  XMLGenAttribute attReloc = XMLGen_declareAttribute(gen, "Relocation");
  XMLGen_startElement(gen, elemTemp);
  sprintf(attval, "Temporary_%d", Temporary_identity(this));
  XMLGen_addAttribute(gen, attID, attval);
  attval[0]='\0';
  if (Temporary_isConstant(this)) sprintf(attval, "%s Constant ", attval);
  if (Temporary_hasRegister(this)) sprintf(attval, "%s Register ", attval);
  if (Temporary_isGlobal(this)) sprintf(attval, "%s Global ", attval);
  if (Temporary_isKilled(this)) sprintf(attval, "%s Killed ", attval);
  if (Temporary_isRemater(this)) sprintf(attval, "%s Remater ", attval);
  if (Temporary_isHomeable(this)) sprintf(attval, "%s Homeable ", attval);
  if (Temporary_isRenameOK(this)) sprintf(attval, "%s RenameOK ", attval);
  if (Temporary_isRecycled(this)) sprintf(attval, "%s Recycled ", attval);
  if (strcmp(attval,"\0")) XMLGen_addAttribute(gen, attFlags, attval);
  if (Temporary_isDedicated(this)){
    Register registre = Temporary_REGISTER(this);
    sprintf(regType, "Register_%s", Register_name_(registre));
    XMLGen_addAttributeLiteral(gen, "Type", "Dedicated");
    XMLGen_addAttribute(gen, attRegister, regType);
  }
  else if (Temporary_isAssigned(this)){
    Register registre = Temporary_REGISTER(this);
    sprintf(regType, "Register_%s", Register_name_(registre));
    XMLGen_addAttributeLiteral(gen, "Type", "Assigned");
    XMLGen_addAttribute(gen, attRegister, regType);
  }
  else if (Temporary_isVirtual(this)){
    Register registre = Temporary_REGISTER(this);
    RegFile regFile = Register_regFile(registre);
    sprintf(regType, "RegFile_%s", RegFile_name_(regFile));
    XMLGen_addAttributeLiteral(gen, "Type", "Virtual");
    XMLGen_addAttribute(gen, attRegister, regType);
    if (   Temporary_isVariable(this)
      && !Temporary_isRenameOK(this)) {
      //Variable_dumpXML(Temporary_VARIABLE(this), file, indent, gen);
    }
  }
  else if (Temporary_isAbsolute(this)){
    TemporaryInvariant invariant = Temporary_INVARIANT(this);
    Relocation reloc;
    XMLGen_addAttributeLiteral(gen, "Type", "Absolute");
    sprintf(attval, "%lld",(long long) TemporaryInvariant_value(invariant));
    XMLGen_addAttribute(gen, attValue, attval);
    reloc =  TemporaryInvariant_relocation(invariant);
    sprintf(attval, "Immediate_%s",Relocation_name_(reloc));
    XMLGen_addAttribute(gen, attReloc, attval);
  }
  else if (Temporary_isSymbol(this)){
    TemporaryInvariant invariant = Temporary_INVARIANT(this);
    Symbol symbol = TemporaryInvariant_SYMBOL(invariant);
    XMLGen_addAttributeLiteral(gen, "Type", "Symbol");
    sprintf(attval, "%s", Symbol_NAME(symbol));
    XMLGen_addAttribute(gen, attSymbol, attval);
    sprintf(attval, "%lld", TemporaryInvariant_OFFSET(invariant));
    XMLGen_addAttribute(gen, attOffset, attval);
  }
  else if (Temporary_isLabel(this)){
    TemporaryInvariant invariant = Temporary_INVARIANT(this);
    Label label = TemporaryInvariant_LABEL(invariant);  
    XMLGen_addAttributeLiteral(gen, "Type", "Label");
    sprintf(attval, "%d", Label_IDENTITY(label));
    XMLGen_addAttribute(gen, attLabelValue, attval);
    sprintf(attval, "%s", Label_NAME(label));
    XMLGen_addAttribute(gen, attLabel, attval);
  }
  else if (Temporary_isModifier(this))
    XMLGen_addAttributeLiteral(gen, "Type", "Modifier");
  else if (Temporary_isRegMask(this))
    XMLGen_addAttributeLiteral(gen, "Type", "RegMask");
  else if (Temporary_isVolatile(this))
    XMLGen_addAttributeLiteral(gen, "Type", "Volatile");
  else if (Temporary_isControl(this))
    XMLGen_addAttributeLiteral(gen, "Type", "Control");
  else if (Temporary_isMemory(this))
    XMLGen_addAttributeLiteral(gen, "Type", "Memory");
  XMLGen_endEmptyElement(gen);
  return true;
}
#endif//ECL_NTRACE

#line 1514 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1522 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
IndexedFactory_ Temporary_Factory[1];

#line 1524 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
void
Temporary_INIT(void)
{
  IndexedFactory_Ctor(Temporary_Factory);
#ifndef ECL_NTRACE
  ETable_Ctor(TemporaryFlag_Table, Memory_Root, TemporaryFlagEntries);
#endif//ECL_NTRACE
}

#line 1543 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
#ifndef ECL_NTRACE
void
Temporary_FINI(void)
{
  ETable_Dtor(TemporaryFlag_Table);
}
#endif//ECL_NTRACE

#line 1551 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
#if XCC__C
static void
Temporary_TEST(void)
{
#include "LIR/Temporary_.c"
}

#line 1558 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Temporary.xcc"
int
main(int argc, char **argv)
{
  LIR_Test(Temporary_TEST);
  return 0;
}
#endif


#endif//Temporary_c_INCLUDED
