#ifndef Variable_c_INCLUDED
#define Variable_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
#include "LIR/LIR_.h"

#line 21 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 112 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
Variable
Variable_Ctor(Variable this,
              Temporary origin)
{
  Temporary temporary = Variable____(this);
  Temporary_Ctor(temporary, TemporaryType_Variable, 0);
  *Temporary__REGISTER(temporary) = Temporary_REGISTER(origin);
  *Temporary__INDEX(temporary) = Temporary_INDEX(origin);
  *Variable__ORIGIN(this) = origin;
  OperationResult_Clear(Variable_PRODUCER(this));
  IDList_Ctor(Variable_CONSUMERS(this), NULL);
  *Variable__WEBLINK(this) = NULL;
  *Variable__WEBRANK(this) = 0;
  *Variable__FLAGS(this) = 0;
  *Variable__PINNED(this) = Register__UNDEF;
  *Variable__LOCALLY(this) = Register__UNDEF;
  *Variable__GLOBALLY(this) = Register__UNDEF;
  *Variable__CLASSNEXT(this) = NULL;
  *Variable__CONGRUENCE(this) = NULL;
  *Variable__NEIGHBORS(this) = NULL;
  *Variable__ORDERING(this) = 0;
  *Variable__IDOM(this) = NULL;
  *Variable__WEIGHT(this) = 0;
  *Variable__EQUIVALUE(this) = this;
  *Variable__EQUALANCIN(this) = NULL;
  *Variable__EQUALANCOUT(this) = NULL;
  return this;
}

#line 141 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
void
Variable_Dtor(Variable this)
{
  IDList_Dtor(Variable_CONSUMERS(this));
}

#line 180 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
void
Variable_addConsumer(Variable this, Operation operation, int32_t argIndex)
{
  IDList consumers = Variable_CONSUMERS(this);
  Except_CHECK(Variable_isConsuming(this) && IDList_memory(consumers) != NULL);
  OperationArgument_Ctor(IDList_push(consumers, sizeof(OperationArgument_)),
                         operation, argIndex);
}

#line 195 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
void
Variable_makeConsumers(Variable this, Memory memory)
{
  IDList consumers = Variable_CONSUMERS(this);
  if (IDList_memory(consumers) != NULL) {
    IDList_empty(consumers, NULL);
  } else {
    IDList_Ctor(consumers, memory);
  }
  Variable_raiseConsuming(this);
}

#line 213 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
void
Variable_killConsumers(Variable this)
{
  IDList consumers = Variable_CONSUMERS(this);
  if (IDList_memory(consumers) != NULL) {
    IDList_empty(consumers, NULL);
    IDList_Ctor(consumers, NULL);
  }
  Variable_clearConsuming(this);
}

#line 232 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
void
Variable_setOperationResult(Variable this, Operation operation, int32_t resIndex)
{
  Operator operator = Operation_operator(operation);
  OperationResult_Ctor(Variable_PRODUCER(this), operation, resIndex);
#if 0
  Except_CHECK(   Variable_ORDERING(this) == 0
               || Variable_CONGRUENCE(this) == NULL
               || Variable_ORDERING(this) == Operation_ordering(operation));
#endif
  *Variable__ORDERING(this) = Operation_ordering(operation);
  Operation_setResult(operation, resIndex, Variable_TEMPORARY(this));
  if (Operator_isSeqCopy(operator) || Operator_isParCopy(operator)) {
    Temporary argument = Operation_getArgument(operation, resIndex);
    if (Temporary_isVariable(argument)) {
      Variable v1 = this, v2 = Temporary_VARIABLE(argument);
      if (Variable_EQUIVALUE(v1) != v1) *Variable__EQUIVALUE(v2) = Variable_EQUIVALUE(v1);
      else if (Variable_EQUIVALUE(v2) != v2) *Variable__EQUIVALUE(v1) = Variable_EQUIVALUE(v2);
      else {
        uint32_t id1 = Temporary_IDENTITY(Variable_TEMPORARY(v1));
        uint32_t id2 = Temporary_IDENTITY(Variable_TEMPORARY(v2));
        if (id1 > id2) *Variable__EQUIVALUE(v1) = Variable_EQUIVALUE(v2);
        else *Variable__EQUIVALUE(v2) = Variable_EQUIVALUE(v1);
      }
    }
  }
}

#line 268 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
void
Variable_setOperationArgument(Variable this, Operation operation, int32_t argIndex)
{
  if (Variable_isConsuming(this)) {
    Temporary oldTemp = Operation_getArgument(operation, argIndex);
    Variable oldVar = oldTemp? Temporary_VARIABLE(oldTemp): NULL;
    if (oldVar) {
      OperationArgument oldOpArg = NULL;
      Variable_CONSUMERS_FOREACH_OperationArgument(oldVar, argument) {
        Operation thisOp = OperationArgument_OPERATION(argument);
        int32_t thisArgIndex = OperationArgument_ARGINDEX(argument);
        if (thisOp == operation && thisArgIndex == argIndex) {
          oldOpArg = argument;
          break;
        }
      } Variable_CONSUMERS_ENDEACH_OperationArgument;
      if (oldOpArg) IDList_remove(Variable_CONSUMERS(oldVar), oldOpArg, NULL);
    }
  }
  Operation_setArgument(operation, argIndex, Variable____(this));
  if (Variable_isConsuming(this)) {
    Variable_addConsumer(this, operation, argIndex);
  }
}

#line 293 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 301 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
Variable
Variable_findWebRoot(Variable this)
{
  Variable root = this;
  Variable webLink = Variable_WEBLINK(this);
  /* Find root */
  while (webLink != NULL) {
    root = webLink;
    webLink = Variable_WEBLINK(webLink);
  }
  /* Update weblinks */
  webLink = this;
  while (webLink != root) {
    *Variable__WEBLINK(webLink) = root;
    webLink = Variable_WEBLINK(webLink);
  }
  return root;
}

#line 326 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
Variable
Variable_linkWebRoots(Variable this, Variable that)
{
  Variable root = this;
  Register pinned = Register__UNDEF;
  int this_rank = Variable_WEBRANK(this);
  int that_rank = Variable_WEBRANK(that);
  Register this_pinned = Variable_PINNED(this);
  Register that_pinned = Variable_PINNED(that);
  Except_CHECK(this != that);
  Except_CHECK(Variable_WEBLINK(this) == NULL);
  Except_CHECK(Variable_WEBLINK(that) == NULL);
  Except_CHECK((this_pinned == Register__UNDEF) || (that_pinned == Register__UNDEF) ||
	       (this_pinned == that_pinned));
  if (this_pinned != Register__UNDEF) pinned = this_pinned;
  if (that_pinned != Register__UNDEF) pinned = that_pinned;
  if (this_rank > that_rank) {
    *Variable__WEBLINK(that) = this;
  } else
  if (this_rank < that_rank) {
    *Variable__WEBLINK(this) = that;
    root = that;
  } else
  if (this != that) {
    *Variable__WEBLINK(that) = this;
    *Variable__WEBRANK(this) = this_rank + 1;
  }
  *Variable__PINNED(root) = pinned;
0 &&
  LIR_TRACE && fprintf(LIR_TRACE, "LinkWebRoots(") && Variable_pretty(this, LIR_TRACE, false)
            && fprintf(LIR_TRACE, "[%d],", this_rank) &&  Variable_pretty(that, LIR_TRACE, false)
            && fprintf(LIR_TRACE, "[%d])=", that_rank) &&  Variable_pretty(root, LIR_TRACE, false)
            && fprintf(LIR_TRACE, "[%d]\n", Variable_WEBRANK(root));
  return root;
}

#line 368 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
int
Variable_compare(const_Variable this, const_Variable that)
{
  int32_t this_ordering = Variable_ORDERING(this);
  int32_t that_ordering = Variable_ORDERING(that);
  uint32_t this_identity = Variable_IDENTITY(this);
  uint32_t that_identity = Variable_IDENTITY(that);
  if (sizeof(int) >= sizeof(int32_t)) {
    if (this_ordering != that_ordering) {
      return this_ordering - that_ordering;
    }
    return (int)(this_identity - that_identity);
  } else {
    if (this_ordering != that_ordering) {
      return (this_ordering > that_ordering)
           - (this_ordering < that_ordering);
    }
    return (this_identity > that_identity)
         - (this_identity < that_identity);
  }
}

#line 390 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
static inline bool
Variable_GT(const_Variable this, const_Variable that)
{
  int32_t this_ordering = Variable_ORDERING(this);
  int32_t that_ordering = Variable_ORDERING(that);
  if (this_ordering > that_ordering) return true;
  else if (this_ordering == that_ordering) {
    uint32_t this_identity = Variable_IDENTITY(this);
    uint32_t that_identity = Variable_IDENTITY(that);
    if (this_identity > that_identity) return true;
  }
  return false;
}

#line 412 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
void
Variable_Sort(Variable *base, int32_t count)
{
  int32_t n = count, i = count/2;
  while (true) {
    int32_t parent, child;
    Variable temp;
    if (i > 0) {
      temp = base[--i];
    } else if (n > 1) {
      temp = base[--n];
      base[n] = base[0];
    } else break;
    parent = i, child = i*2 + 1;
    while (child < n) {
      if (   child + 1 < n
          && Variable_GT(base[child + 1], base[child])) {
        child = child + 1;
      }
      if (Variable_GT(base[child], temp)) {
        base[parent] = base[child];
        parent = child;
        child = child*2 + 1;
      } else break;
    }
    base[parent] = temp;
  }
}

#line 447 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
#ifndef ECL_NTRACE
bool
Variable_pretty(const_Variable this, FILE *file, int flags)
{
  const_Temporary temporary = Variable____(this);
  const_Temporary origin = Variable_ORIGIN(this);
  if (file == NULL) file = stderr;
  fprintf(file, "V%d", Temporary_IDENTITY(temporary));
  if (origin != NULL) {
    fprintf(file, "(");
    Temporary_pretty(origin, file);
    fprintf(file, ")");
  }
  if (Temporary_hasRegister(temporary)) {
    Register registre = Temporary_REGISTER(temporary);
    fprintf(file, "^%s", Register_names(registre)[0]);
  }
  if (flags) fprintf(file, "@%d", Variable_ORDERING(this));
  return true;
}
#endif//ECL_NTRACE

#line 473 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
#ifndef ECL_NTRACE
bool
Variable_prettyNeighbors(const_Variable this, FILE *file, int flags)
{
  PtrSet neighbors = Variable_NEIGHBORS(this);
  if (file == NULL) file = stderr;
  fprintf(file, "{");
  PtrSet_FORSORT(neighbors, Variable_compare, Variable, variable) {
    fprintf(file, " ");
    if (flags) {
      fprintf(file, "@%d", Variable_ORDERING(variable));
    }
    Variable_pretty(variable, file, 0);
  } PtrSet_ENDSORT;
  fprintf(file, " }");
  return true;
}
#endif//ECL_NTRACE

#line 496 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 518 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
VariableStack
VariableStack_Ctor(VariableStack this,
                   Memory memory, int maxCount)
{
  PtrSeq_Ctor(VariableStack____(this), memory, maxCount);
  return this;
}

#line 526 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
void
VariableStack_Dtor(VariableStack this)
{
  PtrSeq_Dtor(VariableStack____(this));
}

#line 591 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 607 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
VariableClass
VariableClass_Ctor(VariableClass this,
                   Variable variable)
{
  if (variable != NULL) {
    Except_CHECK(Variable_CLASSNEXT(variable) == NULL);
    *Variable__CONGRUENCE(variable) = this;
    *VariableClass__FIRST(this) = variable;
    *VariableClass__LAST(this) = variable;
    *VariableClass__COUNT(this) = 1;
  } else {
    *VariableClass__FIRST(this) = NULL;
    *VariableClass__LAST(this) = NULL;
    *VariableClass__COUNT(this) = 0;
  }
  *VariableClass__REGISTER(this) = Register__UNDEF;
  *VariableClass__CURDOM(this) = NULL;
  *VariableClass__CURPHI(this) = NULL;
  return this;
};

#line 628 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
void
VariableClass_Dtor(VariableClass this)
{
}

#line 680 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
bool
VariableClass_contains(const_VariableClass this, const_Variable variable)
{
  int32_t ordering = Variable_ORDERING(variable);
  uint32_t identity = Variable_IDENTITY(variable);
  Except_CHECK(Variable_ORDERING(variable) != 0);
  VariableClass_FOREACH_Variable(this, member) {
    if (member == variable) return true;
    if (   (Variable_ORDERING(member) > ordering)
        || (   Variable_ORDERING(member) == ordering
            && Variable_IDENTITY(member) > identity)) return false;
  } VariableClass_ENDEACH_Variable;
  return false;
}

#line 699 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
bool
VariableClass_insert(VariableClass this, Variable variable)
{
  Variable prev_member = NULL;
  int32_t ordering = Variable_ORDERING(variable);
  uint32_t identity = Variable_IDENTITY(variable);
  Except_CHECK(Variable_ORDERING(variable) != 0);
  Except_CHECK(Variable_CLASSNEXT(variable) == NULL);
  VariableClass_FOREACH_Variable(this, member) {
    if (member == variable) return false;
    if (   (Variable_ORDERING(member) > ordering)
        || (   Variable_ORDERING(member) == ordering
            && Variable_IDENTITY(member) > identity)) {
      if (prev_member == NULL) {
        // Insert as first member.
        *VariableClass__FIRST(this) = variable;
        *Variable__CLASSNEXT(variable) = member;
      } else {
        // Insert between prev_member and member.
        *Variable__CLASSNEXT(prev_member) = variable;
        *Variable__CLASSNEXT(variable) = member;
      }
      ++*VariableClass__COUNT(this);
      *Variable__CONGRUENCE(variable) = this;
      Except_DEBUG(VariableClass_check(this));
      return true;
    }
    prev_member = member;
  } VariableClass_ENDEACH_Variable;
  // Insert as last member.
  if (prev_member != NULL) {
    *Variable__CLASSNEXT(prev_member) = variable;
    *VariableClass__LAST(this) = variable;
  } else {
    *VariableClass__FIRST(this) = variable;
    *VariableClass__LAST(this) = variable;
  }
  ++*VariableClass__COUNT(this);
  *Variable__CONGRUENCE(variable) = this;
  Except_DEBUG(VariableClass_check(this));
  return true;
}

#line 746 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
bool
VariableClass_remove(VariableClass this, Variable variable)
{
  Variable prev_member = NULL;
  int32_t ordering = Variable_ORDERING(variable);
  uint32_t identity = Variable_IDENTITY(variable);
  Except_CHECK(Variable_ORDERING(variable) != 0);
  VariableClass_FOREACH_Variable(this, member) {
    if (member == variable) {
      Variable next_member = Variable_CLASSNEXT(member);
      if (prev_member == NULL) {
        // Remove first member.
        *VariableClass__FIRST(this) = next_member;
      } else {
        *Variable__CLASSNEXT(prev_member) = next_member;
      }
      if (next_member == NULL) {
        // Remove last member.
        *VariableClass__LAST(this) = prev_member;
      }
      --*VariableClass__COUNT(this);
      *Variable__CLASSNEXT(variable) = NULL;
      *Variable__CONGRUENCE(variable) = NULL;
      Except_DEBUG(VariableClass_check(this));
      return true;
    }
    if (   (Variable_ORDERING(member) > ordering)
        || (   Variable_ORDERING(member) == ordering
            && Variable_IDENTITY(member) > identity)) return false;
    prev_member = member;
  } VariableClass_ENDEACH_Variable;
  return false;
}

#line 784 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
void
VariableClass_merge(VariableClass this, VariableClass that)
{
  Variable this_first = VariableClass_FIRST(this);
  Variable that_first = VariableClass_FIRST(that);
  Variable this_last = VariableClass_LAST(this);
  Variable that_last = VariableClass_LAST(that);
  int32_t that_count = VariableClass_COUNT(that);
  Except_CHECK(this != that);
  if (that_first == NULL) return;
  if (this_last == NULL) {
    Except_CHECK(this_first == NULL);
    *VariableClass__FIRST(this) = that_first;
    *VariableClass__LAST(this) = that_last;
    *VariableClass__COUNT(this) = that_count;
  } else {
    Variable_ meld_;
    Variable meld = &meld_;
    Variable item1 = this_first;
    Variable item2 = that_first;
    Except_CHECK(item1 != NULL && item2 != NULL);
    do {
      if (Variable_GT(item2, item1)) {
        *Variable__CLASSNEXT(meld) = item1;
        item1 = Variable_CLASSNEXT((meld = item1));
        *Variable__CONGRUENCE(meld) = this;
      } else {
        *Variable__CLASSNEXT(meld) = item2;
        item2 = Variable_CLASSNEXT((meld = item2));
        *Variable__CONGRUENCE(meld) = this;
      }
    } while (item1 != NULL && item2 != NULL);
    if (item1 != NULL) {
      *Variable__CLASSNEXT(meld) = item1;
      do {
        item1 = Variable_CLASSNEXT((meld = item1));
        *Variable__CONGRUENCE(meld) = this;
      } while (item1 != NULL);
    }
    if (item2 != NULL) {
      *Variable__CLASSNEXT(meld) = item2;
      do {
        item2 = Variable_CLASSNEXT((meld = item2));
        *Variable__CONGRUENCE(meld) = this;
      } while (item2 != NULL);
    }
    *VariableClass__FIRST(this) = Variable_CLASSNEXT(&meld_);
    *VariableClass__LAST(this) = meld;
    *VariableClass__COUNT(this) += that_count;
  }
  *VariableClass__FIRST(that) = NULL;
  *VariableClass__LAST(that) = NULL;
  *VariableClass__COUNT(that) = 0;
  if (VariableClass_REGISTER(this) == Register__UNDEF)
    *VariableClass__REGISTER(this) = VariableClass_REGISTER(that);
  else
    Except_CHECK((VariableClass_REGISTER(that) == Register__UNDEF) ||
		 (VariableClass_REGISTER(this) == VariableClass_REGISTER(that)));

#line 843 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
  Except_DEBUG(VariableClass_check(this));
}

#line 850 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
void
VariableClass_update(VariableClass this, Variable variable)
{
  Variable prev_member = NULL;
  Variable member = VariableClass_FIRST(this);
  while (member != NULL) {
    Variable next_member = Variable_CLASSNEXT(member);
    if (member == variable) {
      if (   (prev_member == NULL || Variable_GT(member, prev_member))
          && (next_member == NULL || Variable_GT(next_member, member))) {
        Except_DEBUG(VariableClass_check(this));
        return;
      }
      if (prev_member == NULL) {
        // Remove first member.
        *VariableClass__FIRST(this) = next_member;
      } else {
        *Variable__CLASSNEXT(prev_member) = next_member;
      }
      if (next_member == NULL) {
        // Remove last member.
        *VariableClass__LAST(this) = prev_member;
      }
      --*VariableClass__COUNT(this);
      *Variable__CLASSNEXT(variable) = NULL;
      *Variable__CONGRUENCE(variable) = NULL;
      Except_DEBUG(VariableClass_check(this));
      break;
    }
    prev_member = member;
    member = next_member;
  }
  Except_CHECK(member != NULL);
  VariableClass_insert(this, variable);
}

#line 890 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
bool
VariableClass_hasStrongInterference(VariableClass congruence0, VariableClass congruence1) {
  //if ((congruence0 == NULL) || (congruence1 == NULL)) return false;
  if (   (congruence0 != congruence1)
      && (VariableClass_REGISTER(congruence0) != Register__UNDEF)
      && (VariableClass_REGISTER(congruence1) != Register__UNDEF)) {
    Except_CHECK(VariableClass_REGISTER(congruence0) != VariableClass_REGISTER(congruence1));
    return true;
  }
  return false;
}

#line 906 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
bool
VariableClass_check(const_VariableClass this)
{
  int32_t count = 0;
  Variable prev_member = NULL;
  Variable member = VariableClass_FIRST(this);
  while (member != NULL) {
    Variable next_member = Variable_CLASSNEXT(member);
    if (prev_member != NULL) {
      Except_ALWAYS(Variable_GT(member, prev_member));
    }
    Except_ALWAYS(Variable_CONGRUENCE(member) == this);
    Except_CHECK(Variable_ORDERING(member) != 0);
    prev_member = member;
    member = next_member;
    count++;
  }
  Except_ALWAYS(prev_member == VariableClass_LAST(this));
  Except_ALWAYS(count == VariableClass_COUNT(this));
  return true;
}

#line 932 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
#ifndef ECL_NTRACE
bool
VariableClass_pretty(const_VariableClass this, FILE *file, bool flags)
{
  if (file == NULL) file = stderr;
  fprintf(file, "{");
  VariableClass_FOREACH_Variable(this, variable) {
    fprintf(file, " ");
    if (flags) {
      fprintf(file, "@%d", Variable_ORDERING(variable));
    }
    Variable_pretty(variable, file, 0);
  } VariableClass_ENDEACH_Variable;
  fprintf(file, " }");
  if (VariableClass_REGISTER(this) != Register__UNDEF) {
    fprintf(file, "^%s", Register_names(VariableClass_REGISTER(this))[0]);
  }
  return true;
}
#endif//ECL_NTRACE

#line 953 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 959 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
#ifndef ECL_NTRACE
bool
Variable_dumpXML(Variable this, FILE *file, int indent, XMLGen gen)
{
  char attval[64]="";
  const_Temporary temporary = Variable____(this);
  const_Temporary origin = Variable_ORIGIN(this);
  XMLGenElement elemVar = XMLGen_declareElement(gen, "Variable");
  XMLGenAttribute attID = XMLGen_declareAttribute(gen, "ID");
  XMLGenAttribute attOrigin = XMLGen_declareAttribute(gen, "Origin");
  XMLGen_startElement(gen, elemVar);
  sprintf(attval, "%d", Temporary_IDENTITY(temporary));
  XMLGen_addAttribute(gen, attID, attval);
  if (origin != NULL) {
    sprintf(attval, "Temporary_%d", Temporary_IDENTITY(temporary));
    XMLGen_addAttribute(gen, attOrigin, attval);
  }
  XMLGen_endElement(gen);
  return true;

#line 979 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
}
#endif//ECL_NTRACE

#line 982 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 994 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
#if XCC__C
static void
Variable_TEST(void)
{
#include "LIR/Variable_.c"
}

#line 1001 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Variable.xcc"
int
main(int argc, char **argv)
{
  LIR_Test(Variable_TEST);
  return 0;
}
#endif


#endif//Variable_c_INCLUDED
