#ifndef Encoding__h_INCLUDED
#define Encoding__h_INCLUDED

//
#include "MDS/Encoding.h"

//
typedef enum {
#define Encoding(NAME, PROCESSOR, WORDTYPE, WORDCOUNT) \
  Encoding_##NAME,
  Encoding_,
#include /*MDS*/"Encoding.enum"
  Encoding__
#undef Encoding
} enum_Encoding;

/*
 * Encoding word types.
 */
#define WORDTYPE(type) type
#define Encoding(NAME, PROCESSOR, WORDTYPE, WORDCOUNT) \
  typedef WORDTYPE Encoding_##NAME##_t;
#include "Encoding.enum"
#undef WORDTYPE

/*
 * Encoding word counts.
 */
enum {
#define WORDCOUNT(d) d
#define Encoding(NAME, PROCESSOR, WORDTYPE, WORDCOUNT) \
  Encoding_##NAME##_count = WORDCOUNT,
#include "Encoding.enum"
#undef WORDCOUNT
};

/*
 * Encoding_INIT --	Initialize the Encoding module.
 */
#define Encoding_INIT()

/*
 * Encoding_FINI --	Finalize the Encoding module.
 */
#define Encoding_FINI()


#endif//Encoding__h_INCLUDED
