#ifndef Instance__c_INCLUDED
#define Instance__c_INCLUDED

#line 53 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//
{
  printf("sizeof(Instance_Actions)\t%d\n", sizeof(Instance_Actions));
}

#line 82 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//
{
  int instance = 0;
  for (instance = 0; instance < Instance__; instance++) {
    printf("Instance_%s\t%d\n", Instance_name_(instance), instance);
  }
}

#line 117 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//
{
  int instance = 0;
  for (instance = 0; instance < Instance__; instance++) {
    Scheduling scheduling = Instance_scheduling(instance);
    printf("\nScheduling(%s)\t%s", Instance_name_(instance), Scheduling_name_(scheduling));
  }
  printf("\n");
  printf("sizeof(Instance_Scheduling)\t%d\n", sizeof(Instance_Scheduling));
}

#line 155 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//
{
  int instance = 0;
  for (instance = 0; instance < Instance__; instance++) {
    int encoding = Instance_encoding(instance);
    printf("\nEncoding(%s)\t%s", Instance_name_(instance), Encoding_name_(encoding));
  }
  printf("\n");
  printf("sizeof(Instance_Encoding)\t%d\n", sizeof(Instance_Encoding));
}

#line 207 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//
{
  int instance = 0;
  for (instance = 0; instance < Instance__; instance++) {
    int encoding = Instance_encoding(instance);
    const_InstanceOpcodes opcodes = Instance_opcodes(instance);
    Instance (*decode)(const void *) = Encoding_decode(encoding);
    if (decode != NULL) {
      Instance result = (*decode)(opcodes);
      if (result != instance) {
        printf("\nDecode(Encode(%s))\t%s",
               Instance_name_(instance),
               Instance_name_(result));
        if (result == Instance_) {
          printf("\t%x\t%x\n", opcodes->WORDS[0], opcodes->WORDS[1]);
        }
      }
    }
  }
}

#line 255 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//
{
  int instance = 0;
  for (instance = 0; instance < Instance__; instance++) {
    int operands = Instance_operands(instance);
    printf("\nOperands(%s)\t%s", Instance_name_(instance), Operands_name_(operands));
  }
  printf("\n");
  printf("sizeof(Instance_Operands)\t%d\n", sizeof(Instance_Operands));
}

#line 297 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//
#if !Bundle_ISSUE_MAX
{
  int instance = 0;
  for (instance = 0; instance < Instance__; instance++) {
    int increment = Instance_increment(instance);
    printf("\nIncrement(%s)\t%d", Instance_name_(instance), increment);
  }
  printf("\n");
  printf("sizeof(Instance_Increment)\t%d\n", sizeof(Instance_Increment));
}
#endif//!Bundle_ISSUE_MAX

#line 339 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//
{
  int instance = 0;
  for (instance = 0; instance < Instance__; instance++) {
    printf("\nMnemonic(%s)\t%s", Instance_name_(instance), Instance_mnemonic(instance));
  }
  printf("\n");
  printf("sizeof(Instance_Mnemonic)\t%d\n", sizeof(Instance_Mnemonic));
}

#line 378 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//
{
  int instance = 0;
  for (instance = 0; instance < Instance__; instance++) {
    printf("\nSyntax(%s)\t%s", Instance_name_(instance), Instance_syntax(instance));
  }
  printf("\n");
  printf("sizeof(Instance_Syntax)\t%d\n", sizeof(Instance_Syntax));
}

#line 454 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//
{
  int instance = 0;
  for (; instance < Instance__; instance++) {
    const_RegisterActionArray actionArray = Instance_actionArray(instance);
    printf("Instance_%s:\n", Instance_name_(instance));
    printf("\treadCount=%d\treadStart=%d\twriteCount=%d\twriteStart=%d\n",
           RegisterActionArray_readCount(actionArray),
           RegisterActionArray_readStart(actionArray),
           RegisterActionArray_writeCount(actionArray),
           RegisterActionArray_writeStart(actionArray));
    RegisterActionArray_FORREAD_RegisterAction(actionArray, action) {
      int registre = RegisterAction_register(action);
      int regClass = RegisterAction_regClass(action);
      int xxxIndex = RegisterAction_xxxIndex(action);
      int rank = RegisterAction_rank(action);
      int stage = RegisterAction_stage(action);
      printf("\tRegister(%s)\tRegClass(%s)\txxxIndex=%d\trank=%d\tstage=%d\n",
             Register_name_(registre), RegClass_name_(regClass), xxxIndex, rank, stage);
    } RegisterActionArray_ENDREAD_RegisterAction;
    RegisterActionArray_FORWRITE_RegisterAction(actionArray, action) {
      int registre = RegisterAction_register(action);
      int regClass = RegisterAction_regClass(action);
      int xxxIndex = RegisterAction_xxxIndex(action);
      int rank = RegisterAction_rank(action);
      int stage = RegisterAction_stage(action);
      printf("\tRegister(%s)\tRegClass(%s)\txxxIndex=%d\trank=%d\tstage=%d\n",
             Register_name_(registre), RegClass_name_(regClass), xxxIndex, rank, stage);
    } RegisterActionArray_ENDWRITE_RegisterAction;
  }
  printf("sizeof(Instance_ActionArray)\t%d\n", sizeof(Instance_ActionArray));
}

#line 514 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//
{
  int instance = 0;
  for (instance = 0; instance < Instance__; instance++) {
    int operator = Instance_operator(instance);
    printf("\nOperator(%s)\t%s", Instance_name_(instance), Operator_name_(operator));
  }
  printf("\n");
  printf("sizeof(Instance_Operator)\t%d\n", sizeof(Instance_Operator));
}

#line 590 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//
{
  int instance = 0;
  for (; instance < Instance__; instance++) {
    if (Instance_attributes(instance)) {
      printf("Instance_%s:", Instance_name_(instance));
      if (Instance_isControl(instance)) printf("\tisControl");
      if (Instance_isMemoryRead(instance)) printf("\tisMemoryRead");
      if (Instance_isMemoryWrite(instance)) printf("\tisMemoryWrite");
      if (Instance_isFixRegisterRAW(instance)) printf("\tisFixRegisterRAW");
      printf("\n");
    }
  }
  printf("sizeof(Instance_Attributes)\t%d\n", sizeof(Instance_Attributes));
}


#endif//Instance__c_INCLUDED
