#ifndef MDS_c_INCLUDED
#define MDS_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/MDS.xcc"
#include "MDS/MDS_.h"

#line 33 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/MDS.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 512 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/MDS.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 576 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/MDS.xcc"
#undef MDS_TRACE
FILE *MDS_TRACE = NULL;

#line 585 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/MDS.xcc"
int FORCE_MAXISSUE;
int FORCE_MINTAKEN;

#line 588 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/MDS.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 594 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/MDS.xcc"
void
MDS_setMaxIssue(Processor processor, int maxIssue)
{
#if Bundle_ISSUE_MAX
  Except_ALWAYS(maxIssue <= Bundle_ISSUE_MAX);
  Processor_setMaxIssue(processor, maxIssue);
  Reservation_InitializeODot();
#endif//Bundle_ISSUE_MAX
}

#line 608 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/MDS.xcc"
void
MDS_setMinTaken(Processor processor, int minTaken)
{
  Except_ALWAYS(minTaken >= 0);
  Processor_setMinTaken(processor, minTaken);
}

#line 619 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/MDS.xcc"
void
MDS_setReserved(Convention convention, Register registre)
{
  Convention_setRole(convention, ConventionRole_Reserved, registre);
}

#line 625 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/MDS.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 633 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/MDS.xcc"
static int MDS_Initialized = 0;

#line 635 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/MDS.xcc"
void
MDS_INIT(void)
{
  if (MDS_Initialized++ == 0) {
    if (GETENV("MDS_TRACE")) {
      int file = 0;
      sscanf(GETENV("MDS_TRACE"), "%d", &file);
      if (file == 1) MDS_TRACE = stdout;
      else if (file == 2) MDS_TRACE = stderr;
    }
    FORCE_MAXISSUE = -1;
    if (GETENV("FORCE_MAXISSUE")) {
      sscanf(GETENV("FORCE_MAXISSUE"), "%d", &FORCE_MAXISSUE);
      fprintf(stderr, "*** FORCE_MAXISSUE=%d\n", FORCE_MAXISSUE);
    }
    FORCE_MINTAKEN = 1;
    if (GETENV("FORCE_MINTAKEN")) {
      sscanf(GETENV("FORCE_MINTAKEN"), "%d", &FORCE_MINTAKEN);
      fprintf(stderr, "*** FORCE_MINTAKEN=%d\n", FORCE_MINTAKEN);
    }
    Platform_INIT();
    Processor_INIT();
    Encoding_INIT();
    NativeType_INIT();
    Storage_INIT();
    Register_INIT();
    RegFile_INIT();
    RegClass_INIT();
    RegMask_INIT();
    Modifier_INIT();
    Relocation_INIT();
    Immediate_INIT();
    Operand_INIT();
    Format_INIT();
    Syntax_INIT();
    Instance_INIT();
    Operator_INIT();
    Bundling_INIT();
    Template_INIT();
    Bundle_INIT();
    Resource_INIT();
    Reservation_INIT();
    Scheduling_INIT();
    Convention_INIT();
    Decode_INIT();
    if (FORCE_MAXISSUE > 0) {
      int processor = 0;
      for (; processor < Processor__; processor++) {
        MDS_setMaxIssue(processor, FORCE_MAXISSUE);
      }
    }
    if (FORCE_MINTAKEN >= 0) {
      int processor = 0;
      for (; processor < Processor__; processor++) {
        MDS_setMinTaken(processor, FORCE_MINTAKEN);
      }
    }
  }
}

#line 701 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/MDS.xcc"
void
MDS_FINI(void)
{
  if (--MDS_Initialized == 0) {
    Decode_FINI();
    Convention_FINI();
    Scheduling_FINI();
    Reservation_FINI();
    Resource_FINI();
    Bundle_FINI();
    Template_FINI();
    Bundling_FINI();
    Operator_FINI();
    Instance_FINI();
    Operand_FINI();
    Format_FINI();
    Syntax_FINI();
    Immediate_FINI();
    Relocation_FINI();
    Modifier_FINI();
    RegMask_FINI();
    RegClass_FINI();
    RegFile_FINI();
    Register_FINI();
    Storage_FINI();
    NativeType_FINI();
    Encoding_FINI();
    Processor_FINI();
    Platform_FINI();
  }
}

#line 739 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/MDS.xcc"
void
MDS_Test(void (*test)(void))
{
  MDS_INIT();
  (*test)();
  MDS_FINI();
}

#line 747 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/MDS.xcc"
#if XCC__C
static void
MDS_TEST(void)
{
#include "MDS/MDS_.c"
}

#line 754 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/MDS.xcc"
int
main(int argc, char **argv)
{
  MDS_Test(MDS_TEST);
  return 0;
}
#endif


#endif//MDS_c_INCLUDED
