#ifndef Operand__h_INCLUDED
#define Operand__h_INCLUDED

//
#include "MDS/Operand.h"

//
typedef enum {
#define Operand(NAME, METHOD, WORDTYPE, ENCODE, DECODE) \
  Operand_##NAME,
  Operand_,
#include /*MDS*/"Operand.enum"
  Operand__
#undef Operand
} enum_Operand;

//
typedef enum {
#define Operands(NAME, OPERANDS, RELOCATABLE, ENCODE, DECODE) \
  Operands_##NAME,
  Operands_,
#include /*MDS*/"Operand.enum"
  Operands__
#undef Operand
} enum_Operands;

/*
  Decode_Operand function prototypes.
 */
#define Operand(NAME, METHOD, WORDTYPE, ENCODE, DECODE) \
void \
Decode_Operand_##NAME(const void *opcodes, void *restrict result);
#include "Operand.enum"

/*
 * OperandsEncode function prototypes.
 */
#define Operands(NAME, OPERANDS, RELOCATABLE, ENCODE, DECODE) \
void \
OperandsEncode_##NAME(const_OperandsBuffer buffer, void *restrict opcodes);
#include "Operand.enum"
void
OperandsEncode_(const_OperandsBuffer buffer, void *restrict opcodes);

/*
 * Decode_Operands function prototypes.
 */
#ifndef NDECODE
#define Operands(NAME, OPERANDS, RELOCATABLE, ENCODE, DECODE) \
void \
Decode_Operands_##NAME(const void *opcodes, OperandsBuffer buffer);
#include "Operand.enum"
#endif//NDECODE

/*
 * Operand_INIT --	Initialize the Operand module.
 */
#define Operand_INIT()

/*
 * Operand_FINI --	Finalize the Operand module.
 */
#define Operand_FINI()


#endif//Operand__h_INCLUDED
