#ifndef Operator__c_INCLUDED
#define Operator__c_INCLUDED

#line 97 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  printf("sizeof(OperatorParameter_)\t%d\n", sizeof(OperatorParameter_));
}

#line 189 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  printf("sizeof(Operator_Parameters)\t%d\n", sizeof(Operator_Parameters));
}

#line 205 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  printf("sizeof(OperatorParameterArray_)\t%d\n", sizeof(OperatorParameterArray_));
}

#line 302 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    printf("Operator_%s\t%d\n", Operator_name_(operator), operator);
  }
}

#line 379 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    int processor = 0;
    printf("Instances(%s)\t", Operator_name_(operator));
    for (processor = Processor_ + 1; processor < Processor__; processor++) {
      int instance = Operator_instance(operator, processor);
      printf("%s\t", Instance_name_(instance));
    }
    printf("\n");
  }
  printf("sizeof(Operator_Instances)\t%d\n", sizeof(Operator_Instances));
}

#line 470 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    const_OperatorParameterArray parameterArray = Operator_parameterArray(operator);
    printf("Parameters(%s)\n\twriteCount=%d\treadCount=%d\n", Operator_name_(operator),
           Operator_writeCount(operator), Operator_readCount(operator));
    OperatorParameterArray_FOREACH_OperatorParameter(parameterArray, parameter) {
      OperatorParameterKind kind = OperatorParameter_kind(parameter);
      int rank = OperatorParameter_rank(parameter);
      OperandType type = OperatorParameter_type(parameter);
      int same = OperatorParameter_same(parameter);
      printf("\tkind=%s\trank=%d\ttype=%s",
             OperatorParameterKind_name_(kind), rank, OperandType_name_(type));
      if (type == OperandType_Register) {
        int registre = OperatorParameter_enum(parameter);
        printf("\tRegister %s", Register_name_(registre));
      } else if (type == OperandType_RegClass) {
        int regClass = OperatorParameter_enum(parameter);
        printf("\tRegClass_%s", RegClass_name_(regClass));
      } else if (type == OperandType_Immediate) {
        int immediate = OperatorParameter_enum(parameter);
        printf("\tImmediate_%s", Immediate_name_(immediate));
      } else if (type == OperandType_Modifier) {
        int modifier = OperatorParameter_enum(parameter);
        printf("\tModifier_%s", Modifier_name_(modifier));
      } else if (type == OperandType_RegMask) {
        int regMask = OperatorParameter_enum(parameter);
        printf("\tRegMask_%s", RegMask_name_(regMask));
      } else Except_NEVER(true);
      printf("\tsame=%d", same);
      printf("\tconflicts={");
      OperatorParameter_FOREACH_ConflictIndex(parameter,index) {
        printf(" %d", index);
      } OperatorParameter_ENDEACH_ConflictIndex;
      printf(" }");
      printf("\n");
    } OperatorParameterArray_ENDEACH_OperatorParameter;
  }
  printf("sizeof(Operator_ParameterArray)\t%d\n", sizeof(Operator_ParameterArray));
}

#line 563 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    int8_t immediateIndex = Operator_immediateIndex(operator);
    if (immediateIndex >= 0) {
      printf("ImmediateIndex(%s)\t%d\n", Operator_name_(operator), immediateIndex);
    }
  }
}

#line 599 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    int8_t baseIndex = Operator_baseIndex(operator);
    if (baseIndex >= 0) {
      printf("BaseIndex(%s)\t%d\n", Operator_name_(operator), baseIndex);
    }
  }
}

#line 614 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    int8_t offsetIndex = Operator_offsetIndex(operator);
    if (offsetIndex >= 0) {
      printf("OffsetIndex(%s)\t%d\n", Operator_name_(operator), offsetIndex);
    }
  }
}

#line 629 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    int8_t storedIndex = Operator_storedIndex(operator);
    if (storedIndex >= 0) {
      printf("StoredIndex(%s)\t%d\n", Operator_name_(operator), storedIndex);
    }
  }
}

#line 646 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    int8_t leftIndex = Operator_leftIndex(operator);
    int8_t rightIndex = Operator_rightIndex(operator);
    if (rightIndex >= 0 || leftIndex >= 0) {
      printf("LeftRightIndex(%s)\t%d\t%d\n", Operator_name_(operator), leftIndex, rightIndex);
    }
  }
}

#line 738 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isSsa(operator)) {
      printf("IsSsa(%s)\n", Operator_name_(operator));
    }
  }
}

#line 748 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isPseudo(operator)) {
      printf("IsPseudo(%s)\n", Operator_name_(operator));
    }
  }
}

#line 758 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isControl(operator)) {
      printf("IsControl(%s)\n", Operator_name_(operator));
    }
  }
}

#line 768 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isMemoryRead(operator)) {
      printf("IsMemoryRead(%s)\n", Operator_name_(operator));
    }
  }
}

#line 778 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isMemoryWrite(operator)) {
      printf("IsMemoryWrite(%s)\n", Operator_name_(operator));
    }
  }
}

#line 788 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isMemoryEffect(operator)) {
      printf("IsMemoryEffect(%s)\n", Operator_name_(operator));
    }
  }
}

#line 798 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isMemory(operator)) {
      printf("IsMemory(%s)\n", Operator_name_(operator));
    }
  }
}

#line 808 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isStalling(operator)) {
      printf("IsPerformanceEffect(%s)\n", Operator_name_(operator));
    }
  }
}

#line 818 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isConditional(operator)) {
      printf("IsConditional(%s)\n", Operator_name_(operator));
    }
  }
}

#line 828 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isParCopy(operator)) {
      printf("IsParCopy(%s)\n", Operator_name_(operator));
    }
  }
}

#line 846 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isSeqCopy(operator)) {
      printf("IsCopy(%s)\n", Operator_name_(operator));
    }
  }
}

#line 862 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isAdd(operator)) {
      printf("IsAdd(%s)\n", Operator_name_(operator));
    }
  }
}

#line 921 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isGoTo(operator)) {
      printf("IsGoTo(%s)\n", Operator_name_(operator));
    }
  }
}

#line 939 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isJump(operator)) {
      printf("IsJump(%s)\n", Operator_name_(operator));
    }
  }
}

#line 957 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isBranch(operator)) {
      printf("IsBranch(%s)\n", Operator_name_(operator));
    }
  }
}

#line 975 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isCall(operator)) {
      printf("IsCall(%s)\n", Operator_name_(operator));
    }
  }
}

#line 991 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isLink(operator)) {
      printf("IsLink(%s)\n", Operator_name_(operator));
    }
  }
}

#line 1007 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isRoutine(operator)) {
      printf("IsRoutine(%s)\n", Operator_name_(operator));
    }
  }
}

#line 1023 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isReturn(operator)) {
      printf("IsReturn(%s)\n", Operator_name_(operator));
    }
  }
}

#line 1039 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isGNUASM(operator)) {
      printf("IsGNUASM(%s)\n", Operator_name_(operator));
    }
  }
}

#line 1055 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isMemoryBarrier(operator)) {
      printf("IsMemoryBarrier(%s)\n", Operator_name_(operator));
    }
  }
}

#line 1074 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isStalling(operator)) {
      printf("IsStalling(%s)\n", Operator_name_(operator));
    }
  }
}

#line 1090 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isPrefetch(operator)) {
      printf("IsPrefetch(%s)\n", Operator_name_(operator));
    }
  }
}

#line 1106 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    if (Operator_isSafeLoad(operator)) {
      printf("IsSafeLoad(%s)\n", Operator_name_(operator));
    }
  }
}

#line 1122 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    int processor = 0;
    for (processor = Processor_ + 1; processor < Processor__; processor++) {
      int speculate = Operator_speculate(operator, processor);
      if (speculate != Operator_ && speculate != operator) {
        printf("Speculate(%s,%s)=\t%s\n", Operator_name_(operator),
               Processor_name_(processor), Operator_name_(speculate));
      }
    }
  }
}

#line 1143 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    int processor = 0;
    for (processor = Processor_ + 1; processor < Processor__; processor++) {
      int predicatePositive = Operator_predicatePositive(operator, processor);
      if (predicatePositive != Operator_) {
        printf("PredicatePositive(%s,%s)=\t%s\n", Operator_name_(operator),
               Processor_name_(processor), Operator_name_(predicatePositive));
      }
    }
  }
}

#line 1164 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    int processor = 0;
    for (processor = Processor_ + 1; processor < Processor__; processor++) {
      int predicateNegative = Operator_predicateNegative(operator, processor);
      if (predicateNegative != Operator_) {
        printf("PredicateNegative(%s,%s)=\t%s\n", Operator_name_(operator),
               Processor_name_(processor), Operator_name_(predicateNegative));
      }
    }
  }
}

#line 1185 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    int predicateIndex = Operator_predicateIndex(operator);
    if (predicateIndex >= 0) {
      printf("PredicateIndex(%s)=\t%d\n", Operator_name_(operator), predicateIndex);
    }
  }
}

#line 1202 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    int predicatePolarity = Operator_predicatePolarity(operator);
    if (predicatePolarity != 0) {
      printf("PredicatePolarity(%s)=\t%d\n", Operator_name_(operator), predicatePolarity);
    }
  }
}

#line 1219 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    int processor = 0;
    for (processor = Processor_ + 1; processor < Processor__; processor++) {
      int unpredicate = Operator_unpredicate(operator, processor);
      if (unpredicate != Operator_) {
        printf("Unpredicate(%s,%s)=\t%s\n", Operator_name_(operator),
               Processor_name_(processor), Operator_name_(unpredicate));
      }
    }
  }
}

#line 1240 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    int processor = 0;
    for (processor = Processor_ + 1; processor < Processor__; processor++) {
      int writeCount = Operator_writeCount(operator), writeIndex = 0;
      for (; writeIndex < writeCount; writeIndex++) {
        int complementWrite = Operator_complementWrite(operator, processor, writeIndex);
        if (complementWrite != Operator_) {
          printf("ComplementWrite(%s,%s,%d)=\t%s\n", Operator_name_(operator),
                 Processor_name_(processor), writeIndex, Operator_name_(complementWrite));
        }
      }
    }
  }
}

#line 1264 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    int processor = 0;
    for (processor = Processor_ + 1; processor < Processor__; processor++) {
      int readCount = Operator_readCount(operator), readIndex = 0;
      for (; readIndex < readCount; readIndex++) {
        int complementRead = Operator_complementRead(operator, processor, readIndex);
        if (complementRead != Operator_) {
          printf("ComplementRead(%s,%s,%d)=\t%s\n", Operator_name_(operator),
                 Processor_name_(processor), readIndex, Operator_name_(complementRead));
        }
      }
    }
  }
}

#line 1364 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//
{
#ifndef ECL_NTRACE
  FILE *dtd = fopen("Operator.dtd", "w");
  FILE *xml = fopen("Operator.xml", "w");
  dtd && Operator_DTD(dtd);
  xml && Operator_XML(xml);
  dtd && fclose(dtd);
  xml && fclose(xml);
#endif//ECL_NTRACE
}


#endif//Operator__c_INCLUDED
