#ifndef Processor_c_INCLUDED
#define Processor_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
#include "MDS/MDS_.h"

#line 31 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
const int Processor__COUNT = Processor__;

#line 33 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 41 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
#ifndef ECL_NTRACE
const char *
Processor_name_(Processor this)
{
  static const char *_[] = {
#define Processor(NAME, MINTAKEN, INTERLOCKS, AVAILABILITY) \
    #NAME,
    "_UNDEF",
#include "Processor.enum"
  };
  Except_REQUIRE((unsigned)this < Processor__);
  return _[this];
}
#endif//ECL_NTRACE

#line 64 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 72 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
extern /*const*/ int8_t
Processor_MinTaken[];
int
Processor_minTaken(Processor this)
{
  Except_REQUIRE((unsigned)this < Processor__);
  return Processor_MinTaken[this];
}

#line 81 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
/*const*/ int8_t
Processor_MinTaken[] = {
#define MINTAKEN(d) d
#define Processor(NAME, MINTAKEN, INTERLOCKS, AVAILABILITY) \
  MINTAKEN,
  MINTAKEN(0),
#include "Processor.enum"
};

#line 96 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
void
Processor_setMinTaken(Processor this, int minTaken)
{
  Except_REQUIRE((unsigned)this < Processor__);
  Processor_MinTaken[this] = minTaken;
}

#line 103 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 111 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
int
Processor_maxTakenCost(Processor this)
{
  int maxTaken = 1;
  int maxIssue = Resource_availability(Resource__ISSUE, this);
  return maxIssue*maxTaken;
}

#line 119 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 127 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
extern const bool
Processor_Interlocks[];
bool
Processor_interlocks(Processor this)
{
  Except_REQUIRE((unsigned)this < Processor__);
  return Processor_Interlocks[this];
}

#line 136 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
const bool
Processor_Interlocks[] = {
#define INTERLOCKS(b) b
#define Processor(NAME, MINTAKEN, INTERLOCKS, AVAILABILITY) \
  INTERLOCKS,
  INTERLOCKS(0),
#include "Processor.enum"
};

#line 145 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 153 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
extern /*const*/ ResourceVector_
Processor_Availability[];
const_ResourceVector
Processor_availability(Processor this)
{
  Except_REQUIRE((unsigned)this < Processor__);
  return Processor_Availability + this;
}

#line 162 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
/*const*/ ResourceVector_
Processor_Availability[] = {
#define AVAILABLE(resource, units) units,
#define AVAILABILITY(items) { { 1/*Resource_*/, items } }
#define Processor(NAME, MINTAKEN, INTERLOCKS, AVAILABILITY) \
  AVAILABILITY,
  AVAILABILITY(/**/),
#include "Processor.enum"
#undef AVAILABILITY
};

#line 191 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 199 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
void
Processor_setMaxIssue(Processor this, int maxIssue)
{
  int resource, scheduling, issue_resource = Resource__ISSUE;
  int issueWidth = Resource_availability(issue_resource, this);
  if (maxIssue == issueWidth) return;
  for (resource = Resource__ISSUE; resource < Resource__; resource++) {
    int available = Resource_availability(resource, this);
    int newAvailable = MAX((available*maxIssue)/issueWidth, 1);
    ResourceVector_UNITS(Processor_Availability + this)[resource] = newAvailable;
    for (scheduling = 0; scheduling < Scheduling__; scheduling++) {
      if (Scheduling_processor(scheduling) == this) {
        int reservation = Scheduling_reservation(scheduling);
        ReservationTable table = Reservation_Table + reservation;
        ResourceVector_ *columns = ReservationTable_COLUMNS(table);
        int columnCount = ReservationTable_COLUMNCOUNT(table), i;
        for (i = 0; i < columnCount; i++) {
          ResourceVector column = columns + i;
          int required = ResourceVector_UNITS(column)[resource];
          if (required > newAvailable) {
            ResourceVector_UNITS(column)[resource] = newAvailable;
          }
        }
      }
    }
  }
}

#line 227 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 233 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
#ifndef ECL_NTRACE
bool
Processor_DTD(FILE *file)
{
  fputs(
        "<!ELEMENT Processor EMPTY >"
        "<!ATTLIST Processor"
        "  ID ID #REQUIRED"
        ">"
       , file);
  return true;
}
#endif//ECL_NTRACE

#line 251 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
#ifndef ECL_NTRACE
bool
Processor_XML(FILE *file)
{
  int processor = 0;
  for (processor = 0; processor < Processor__; processor++) {
    fprintf(file, "<Processor ID=\"Processor_%s\" />\n", Processor_name_(processor));
  }
  return true;
}
#endif//ECL_NTRACE

#line 275 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 287 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
#if XCC__C
static void
Processor_TEST(void)
{
#include "MDS/Processor_.c"
}

#line 294 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
int
main(int argc, char **argv)
{
  MDS_Test(Processor_TEST);
  return 0;
}
#endif


#endif//Processor_c_INCLUDED
