#ifndef Processor__h_INCLUDED
#define Processor__h_INCLUDED

//
#include "MDS/Processor.h"

//
typedef enum {
#define Processor(NAME, MINTAKEN, INTERLOCKS, AVAILABILITY) \
  Processor_##NAME,
  Processor_,
#include /*MDS*/"Processor.enum"
  Processor__
#undef Processor
} enum_Processor;

/*
 * Processor_setMinTaken --	Change the minimum branch taken penalty.
 */
void
Processor_setMinTaken(Processor this, int minTaken);

/*
 * Processor_setMaxIssue --	Change the maxIssue.
 */
void
Processor_setMaxIssue(Processor this, int maxIssue);

/*
 * Processor_INIT --	Initialize the Processor module.
 */
#define Processor_INIT()

/*
 * Processor_FINI --	Finalize the Processor module.
 */
#define Processor_FINI()


#endif//Processor__h_INCLUDED
