#ifndef RegClass_h_INCLUDED
#define RegClass_h_INCLUDED

/*
 * !!!!	RegClass.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * RegClass_name_ --	Names for the RegClass enumeration.
 */
extern const char *
RegClass_name_(RegClass this);

/*
 * RegClass_regFile --	The RegFile this RegClass belongs to.
 */
RegFile
RegClass_regFile(RegClass this);

/*
 * RegClass_registerList --	This RegClass Register(s) as a RegisterList.
 */
const_RegisterList
RegClass_registerList(RegClass this);
#define RegClass_firstRegister(this) RegisterList_first(RegClass_registerList(this))
#define RegClass_lastRegister(this) RegisterList_last(RegClass_registerList(this))

/*
 * RegClass_registerSet --	This RegClass Register(s) as a RegisterSet.
 */
const_RegisterSet
RegClass_registerSet(RegClass this);

/*
 * RegClass_minReadStage --	This RegClass minimum read stage for each Processor.
 */
int
RegClass_minReadStage(RegClass this, Processor processor);


#endif//RegClass_h_INCLUDED
