#ifndef RegFile_h_INCLUDED
#define RegFile_h_INCLUDED

/*
 * !!!!	RegFile.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * RegFile_name_ --	Names for the RegFile enumeration.
 */
extern const char *
RegFile_name_(RegFile this);
extern const char *
RegFile_name(RegFile this);

/*
 * RegFile_width --	This RegFile Width attribute.
 */
unsigned
RegFile_width(RegFile this);

/*
 * RegFile_getNativeType --	Return the default NativeType for this RegFile.
 * If this regFile has no associated storage type, return NativeType_.
 */
NativeType
RegFile_getNativeType(RegFile this);

/*
 * RegFile_lowRegister --	This RegFile low Register.
 */
Register
RegFile_lowRegister(RegFile this);

/*
 * RegFile_highRegister --	This RegFile high Register.
 */
Register
RegFile_highRegister(RegFile this);

/*
 * RegFile_FOREACH_Register --	Iterate in this RegFile Registers
 */
#define RegFile_FOREACH_Register(this, reg) { \
  int RegFile_LOWREGISTER = RegFile_lowRegister(this), reg; \
  int RegFile_HIGHREGISTER = RegFile_highRegister(this); \
  for (reg = RegFile_LOWREGISTER; reg <= RegFile_HIGHREGISTER; reg++) {
#define RegFile_ENDEACH_Register \
  } \
}

/*
 * RegFile_registerSet --	A RegisterSet with the members of this RegFile.
 */
const_RegisterSet
RegFile_registerSet(RegFile this);

//
bool
RegFile_DTD(FILE *file);

//
bool
RegFile_XML(FILE *file);


#endif//RegFile_h_INCLUDED
