#ifndef RegMask__h_INCLUDED
#define RegMask__h_INCLUDED

//
#include "MDS/RegMask.h"

//
typedef enum {
#define RegMask(NAME, REGISTERS, REGFILE, ENCODE, DECODE) \
  RegMask_##NAME,
  RegMask_,
#include /*MDS*/"RegMask.enum"
  RegMask__
#undef RegMask
} enum_RegMask;

/*
 * RegMaskEncode functions.
 */
#define ENCODE(e) e
#define RegMask(NAME, REGISTERS, REGFILE, ENCODE, DECODE) \
static inline OperandEncoded \
RegMaskEncode_##NAME(OperandDecoded decoded) \
{ \
  RegisterSet registerSet = (RegisterSet)decoded; \
  RegisterSetWord *WORDS = RegisterSet_WORDS(registerSet); \
  RegisterSetWord WORD = 0; \
  ENCODE; \
  return (OperandEncoded)WORD; \
}
#include "RegMask.enum"
#undef ENCODE

/*
 * RegMask_INIT --	Initialize the RegMask module.
 */
void
RegMask_INIT(void);

/*
 * RegMask_FINI --	Finalize the RegMask module.
 */
#define RegMask_FINI()


#endif//RegMask__h_INCLUDED
