#ifndef Relocation_h_INCLUDED
#define Relocation_h_INCLUDED

/*
 * !!!!	Relocation.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * Relocation_name_ --	Names for the Relocation enumeration.
 */
extern const char *
Relocation_name_(Relocation this);

/*
 * RelocationRelative --	Enumeration for the Relocation_relative values.
 */
typedef enum {
  RelocationRelative__UNDEF,
  RelocationRelative_PC,
  RelocationRelative_GP,
} enum_RelocationRelative;
typedef uint8_t RelocationRelative;
#define Relocation_isRelativePC(this) (Relocation_relative(this) == RelocationRelative_PC)
#define Relocation_isRelativeGP(this) (Relocation_relative(this) == RelocationRelative_GP)

/*
 * Relocation_relative --	This Relocation RelocationRelative.
 */
RelocationRelative
Relocation_relative(Relocation this);

//
bool
Relocation_DTD(FILE *file);

//
bool
Relocation_XML(FILE *file);


#endif//Relocation_h_INCLUDED
