#ifndef Template_h_INCLUDED
#define Template_h_INCLUDED

/*
 * !!!!	Template.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * Template_name_ --	Names for the Template enumeration.
 */
extern const char *
Template_name_(Template this);

/*
 * Template_increment --	This Template increment of the PC.
 */
int
Template_increment(Template this);

/*
 * Template_count --	This Template count of Syllables.
 */
int
Template_count(Template this);

/*
 * Template_distances --	This Template Syllable PC distances from Bundle PC.
 */
const uint8_t *
Template_distances(Template this);

/*
 * Template_encode --	This Template encode function.
 */
typedef void
(*TemplateEncode)(const_InstanceOpcodes *restrict opcodes, void *restrict buffer);
TemplateEncode
Template_encode(Template this);


#endif//Template_h_INCLUDED
