#ifndef Boissinot_h_INCLUDED
#define Boissinot_h_INCLUDED

/*
 * !!!! Boissinot.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 * Nikola Puzovic (Nikola.Puzovic@st.com).
 * Christophe Guillon (Christophe.Guillon@st.com).
 * Fabrice Rastello (Fabrice.Rastello@ens-lyon.fr).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * Boissinot --       SSA Form destruction using Boissinot et al. algorithms.
 */
struct Boissinot_;
typedef struct Boissinot_ Boissinot_, *Boissinot;
typedef const struct Boissinot_ *const_Boissinot;
typedef struct Boissinot_ * restrict_Boissinot;

//
Boissinot
Boissinot_new(Memory parent, CodeRegion codeRegion, SSAForm ssaForm);

//
Boissinot
Boissinot_delete(Boissinot this);

/*
 * Boissinot_doBoissinot_III --	Exact out of SSA method with phi virtualization
 */
void
Boissinot_doBoissinot_III(Boissinot this);
/* Require:  Interference free CONGRUENCES
 * Output: Generated move operations around PHIs
 *         All newly created variables put in the same phi congruence class
 */


#endif//Boissinot_h_INCLUDED
