#ifndef Coalescer_c_INCLUDED
#define Coalescer_c_INCLUDED

#line 18 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
#include "PFA/PFA_.h"

#line 34 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
#ifndef Coalescer_INTERGRAPH
int Coalescer_INTERGRAPH = 1;
#endif//Coalescer_INTERGRAPH

#line 48 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
#ifndef Coalescer_SEQCOPIES
int Coalescer_SEQCOPIES = 0;
#endif//Coalescer_SEQCOPIES

#line 62 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
#ifndef Coalescer_EQUIVALUE
int Coalescer_EQUIVALUE = 1;
#endif//Coalescer_EQUIVALUE

#line 76 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
#ifndef Coalescer_DOMFOREST
int Coalescer_DOMFOREST = 1;
#endif//Coalescer_DOMFOREST

#line 80 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 113 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
Coalescer
Coalescer_Ctor(Coalescer this,
               Memory memory, CodeRegion codeRegion, TemporaryTable temporaryTable,
               Dominance dominance, OptimizeFlags coalescingFlags)
{
  *Coalescer__CODEREGION(this) = codeRegion;
  *Coalescer__TEMPORARYTABLE(this) = temporaryTable;
  *Coalescer__DOMINANCE(this) = dominance;
  IBList_Ctor(Coalescer_CONGRUENCES(this), memory, sizeof(VariableClass_), 32);
  VariableStack_Ctor(Coalescer_DOMSTACK(this), memory, 0);
  *Coalescer__INTERFERENCE(this) = NULL;
  *Coalescer__LIVENESS(this) = NULL;
  *Coalescer__LIVECHECK(this) = NULL;
  *Coalescer__CONSUMING(this) = false;
  if (   (Coalescer_INTERGRAPH==0 || Coalescer_INTERGRAPH==2)
      || (LiveCheck_LIVENESS==0 || LiveCheck_LIVENESS==2)
      || (coalescingFlags & OptimizeCoalescing_Virtualize)  ) {
    *Coalescer__CONSUMING(this) = true;
  }
  *Coalescer__FLAGS(this) = coalescingFlags;
  Coalescer_initClasses(this);
  return this;
}

#line 137 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
void
Coalescer_Dtor(Coalescer this)
{
  /* Memory statistics */
  if (!FORCE_POOLED) {
    fprintf(stderr, "*** Coalescer Variable(s):\tcount=%d\n",
            TemporaryTable_count(Coalescer_TEMPORARYTABLE(this)));
  }
  if (!FORCE_POOLED && Coalescer_LIVECHECK(this) != NULL) {
    fprintf(stderr, "*** Coalescer LiveCheck:\ttotalAlloc=%u\n",
            Memory_TOTALSIZE(LiveCheck_memory(Coalescer_LIVECHECK(this))));
  }
  if (!FORCE_POOLED && Coalescer_INTERFERENCE(this) != NULL) {
    fprintf(stderr, "*** Coalescer Interference:\ttotalAlloc=%u\n",
            Memory_TOTALSIZE(Interference_memory(Coalescer_INTERFERENCE(this))));
  }
  if (!FORCE_POOLED) {
    fprintf(stderr, "*** Coalescer:\tblock_count=%d\n",
            CodeRegion_blockCount(Coalescer_CODEREGION(this)));
  }
  IBList_empty(Coalescer_CONGRUENCES(this), (IBListItemRelease)VariableClass_Dtor);
  IBList_Dtor(Coalescer_CONGRUENCES(this));
  VariableStack_Dtor(Coalescer_DOMSTACK(this));
  Interference_kill(Coalescer_INTERFERENCE(this));
  Liveness_kill(Coalescer_LIVENESS(this));
  LiveCheck_kill(Coalescer_LIVECHECK(this));
}

#line 170 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 178 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
void
Coalescer_initClasses(Coalescer this)
{
  VariableClass *dedicatedClass = NULL;
  Memory memory = Coalescer_MEMORY(this);
  IBList congruences = Coalescer_CONGRUENCES(this);
  TemporaryTable temporaryTable = Coalescer_TEMPORARYTABLE(this);
  TemporaryTable_FOREACH_Temporary(temporaryTable, temporary) {
    Variable variable = Temporary_VARIABLE(temporary);
    Register registre = Variable_PINNED(variable);
    VariableClass congruence = NULL;
    // Ensure the congruence fields are cleared.
    *Variable__CLASSNEXT(variable) = NULL;
    *Variable__CONGRUENCE(variable) = NULL;
    // If the variable is constrained to a specific register we must mark the congruence class.
    if (registre != Register__UNDEF) {
      if (dedicatedClass == NULL) {
        dedicatedClass = Memory_alloc(memory, Register__COUNT*sizeof(VariableClass));
        memset(dedicatedClass, 0, Register__COUNT*sizeof(VariableClass));
      }
      if (dedicatedClass[registre] == NULL) {
        congruence = IBList_push(congruences);
        dedicatedClass[registre] = congruence;
        VariableClass_Ctor(congruence, variable);
        *VariableClass__REGISTER(congruence) = registre;
      } else {
        congruence = dedicatedClass[registre];
        VariableClass_insert(congruence, variable);
      }
    } else {
      congruence = IBList_push(congruences);
      VariableClass_Ctor(congruence, variable);
    }
  } TemporaryTable_ENDEACH_Temporary;
  if (0&& PFA_TRACE && dedicatedClass != NULL) {
    fprintf(PFA_TRACE, "*** Congruences Precoalesced\n");
    TemporaryTable_FOREACH_Temporary(temporaryTable, temporary) {
      Variable variable = Temporary_VARIABLE(temporary);
      VariableClass congruence = Variable_CONGRUENCE(variable);
      PFA_TRACE && Temporary_pretty(temporary, PFA_TRACE)
                && fprintf(PFA_TRACE, " => ")
                && VariableClass_pretty(congruence, PFA_TRACE, false)
                && fprintf(PFA_TRACE, "\n");
    } TemporaryTable_ENDEACH_Temporary;
  }
  if (dedicatedClass != NULL) {
    Memory_free(memory, dedicatedClass);
  }
}

#line 234 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
void
Coalescer_complete(Coalescer this)
{
  Memory memory = Coalescer_MEMORY(this);
  CodeRegion codeRegion = Coalescer_CODEREGION(this);
  TemporaryTable temporaryTable = Coalescer_TEMPORARYTABLE(this);
  Dominance dominance = NULL;
  Liveness liveness = NULL;
  LiveCheckMode mode = 0;
  /* Comment from fab:
     - Mplex is necessary for Sreedhar. Otherwise, by lack of interference test, it may bug.
       But Sreedhar is not robust enough and might not be used in the future.
     - Mplex might also be used for register allocation (tree scan) when considering that edges
       can be split. But this semantic is not very clean.
     - Idealy, SEQCOPIES may not use Mplex. The IR should do the work by updating correctly
       the ordering of the use point of a phi. Mplex is a pessimistic approximation of SEQCOPIES.
     - Copy mode is nothing else than a Mixed mode where no phis are processed.
   */
  Except_ALWAYS(!Coalescer_isSreedhar(this) || LiveCheck_LIVENESS>0);
  Except_ALWAYS(!Coalescer_isDecoalesce(this) || Coalescer_EQUIVALUE==0);
  if (Coalescer_isDecoalesce(this)) {
    // Decoalescer implies Liveness in mixed mode (bd3 -- was copy mode?).
    mode = LiveCheckMode_Mixed;
  } else if (!Coalescer_SEQCOPIES) {
    // Parallel copies imply Liveness in mixed mode.
    mode = LiveCheckMode_Mixed;
  } else {
    // Sequential copies imply Liveness in mplex mode.
    mode = LiveCheckMode_Mplex;
  }
  // Make the LiveCheck object if required.
  if (LiveCheck_LIVENESS==0 || LiveCheck_LIVENESS==2) {
    dominance = Coalescer_DOMINANCE(this);
  }
  // Make Liveness with phiSets in case Interference is required or to debug LiveCheck.
  // fab: what is phiSets?
  if (Coalescer_INTERGRAPH>0 || LiveCheck_LIVENESS>0) {
    liveness = Liveness_make(memory, codeRegion, temporaryTable, true);
    if (!FORCE_POOLED && liveness != NULL) {
      fprintf(stderr, "*** Coalescer Liveness:\ttotalAlloc=%u\n",
              Memory_TOTALSIZE(Liveness_memory(liveness)));
    }
  }
  if (Coalescer_INTERGRAPH>0) {
    // Make interference in non-Chaintin mode, that is, pure intersection graph.
    *Coalescer__INTERFERENCE(this) = Interference_make(memory, codeRegion, liveness, false);
  }
  *Coalescer__LIVECHECK(this) = LiveCheck_make(memory, dominance, liveness);
  *Coalescer__LIVENESS(this) = liveness;
}

#line 285 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 293 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
IBList
Coalescer_congruences(Coalescer this)
{
  return Coalescer_CONGRUENCES(this);
}

#line 320 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
void
Coalescer_coalesceCongruences(Coalescer this)
{
  CodeRegion codeRegion = Coalescer_CODEREGION(this);
  PFA_TRACE && fprintf(PFA_TRACE, "*** Congruence Coalescing:\n");
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      Operator operator = Operation_operator(operation);
      if (Operator_isSeqCopy(operator) || Operator_isParCopy(operator)) {
        int32_t argCount = Operation_argCount(operation), index;
        for (index = 0; index < argCount; index++) {
          Temporary temporary_x = Operation_getResult(operation, index);
          Temporary temporary_y = Operation_getArgument(operation, index);
          if (   Temporary_isVariable(temporary_x)
              && Temporary_isVariable(temporary_y)) {
            Variable variable_x = Temporary_VARIABLE(temporary_x);
            Variable variable_y = Temporary_VARIABLE(temporary_y);
            VariableClass congruence_x = Variable_CONGRUENCE(variable_x);
            VariableClass congruence_y = Variable_CONGRUENCE(variable_y);
            if (congruence_x == congruence_y) {
              Variable_raiseCoalesced(variable_x);
              PFA_TRACE && fprintf (PFA_TRACE, "Coalescing ");
            } else {
              bool result = false;
              PFA_TIMER && fprintf(PFA_TIMER, "@@@ STAT ICC\n");
              if (Coalescer_interferesCCRegisters(this, congruence_x, congruence_y)) {
                result = true;
              } else
              if (Coalescer_EQUIVALUE || Coalescer_DOMFOREST) {
                result = Coalescer_interferesDomForest(this, congruence_x, congruence_y);
              } else {
                // Sreedhar trick: knows that COPYies are being coalesced.
                VariableClass_FOREACH_Variable(congruence_x, resource_x) {
                  VariableClass_FOREACH_Variable(congruence_y, resource_y) {
                    if (   resource_x != variable_x
                        && Coalescer_interferesVV(this, resource_x, resource_y)) {
                      result = true;
                      goto leave;
                    }
                    if (   resource_y != variable_y
                        && Coalescer_interferesVV(this, resource_x, resource_y)) {
                      result = true;
                      goto leave;
                    }
                  } VariableClass_ENDEACH_Variable;
                } VariableClass_ENDEACH_Variable;
              }
              leave:
              if (result) {
                PFA_TRACE && fprintf (PFA_TRACE, "Interfere ");
              } else {
                Variable_raiseCoalesced(variable_x);
                PFA_TRACE && fprintf (PFA_TRACE, "Coalescing ");
                // Merge the congruence classes.
                Coalescer_mergeCongruencesCC(this, congruence_y, congruence_x);
              }
            }
            PFA_TRACE && Temporary_pretty(temporary_x, PFA_TRACE)
                      && fprintf (PFA_TRACE, " ")
                      && Temporary_pretty(temporary_y, PFA_TRACE)
                      && fprintf (PFA_TRACE, "\n");
          }
        }
      }
    } BasicBlock_ENDEACH_Operation;
  } CodeRegion_ENDEACH_BasicBlock;
}

#line 394 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
void
Coalescer_markCoalescedCopies(Coalescer this)
{
  CodeRegion codeRegion = Coalescer_CODEREGION(this);
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      Operator operator = Operation_operator(operation);
      if (Operator_isSeqCopy(operator) || Operator_isParCopy(operator)) {
        int32_t argCount = Operation_argCount(operation), index;
        for (index = 0; index < argCount; index++) {
          Temporary temporary_x = Operation_getResult(operation, index);
          Temporary temporary_y = Operation_getArgument(operation, index);
          if (   Temporary_isVariable(temporary_x)
              && Temporary_isVariable(temporary_y)) {
	    Variable variable_x = Temporary_VARIABLE(temporary_x);
            VariableClass class_x = Variable_CONGRUENCE(variable_x);
            VariableClass class_y = Variable_CONGRUENCE(Temporary_VARIABLE(temporary_y));
            if ( class_x && class_y && class_x==class_y ) {
              Variable_raiseCoalesced(variable_x);
            } else {
	      Except_CHECK(!Variable_isCoalesced(variable_x));
	    }
	  }
	}
      }
    } BasicBlock_ENDEACH_Operation;
  } CodeRegion_ENDEACH_BasicBlock;
}

#line 423 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 431 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
bool
Coalescer_dominatesVV(const_Coalescer this, const_Variable a, const_Variable b)
{
  const_OperationResult producer_a = Variable_PRODUCER(a);
  const_OperationResult producer_b = Variable_PRODUCER(b);
  Operation operation_a = OperationResult_OPERATION(producer_a);
  Operation operation_b = OperationResult_OPERATION(producer_b);
  BasicBlock block_a = Operation_basicBlock(operation_a);
  BasicBlock block_b = Operation_basicBlock(operation_b);
  if (block_a != block_b) {
    Dominance dominance = Coalescer_DOMINANCE(this);
    return Dominance_dominates(dominance, block_a, block_b);
  }
  return Variable_ORDERING(a) <= Variable_ORDERING(b);
}

#line 453 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
bool
Coalescer_dominatesVB(const_Coalescer this, const_Variable a, const_BasicBlock block_b)
{
  const_Dominance dominance = Coalescer_DOMINANCE(this);
  const_OperationResult producer_a = Variable_PRODUCER(a);
  Operation operation_a = OperationResult_OPERATION(producer_a);
  BasicBlock block_a = Operation_basicBlock(operation_a);
  return Dominance_dominates(dominance, block_a, block_b);
}

#line 463 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 471 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
bool
Coalescer_intersectsVV(Coalescer this, Variable a, Variable b)
{
  bool exists = false;
  Except_CHECK(a != b);
  PFA_TIMER && fprintf(PFA_TIMER, "@@@ STAT XVV\n");
  if (Variable_ORDERING(a) < Variable_ORDERING(b)) {
    Variable tmp = a; a = b; b = tmp;
  }
  if (Coalescer_INTERGRAPH>0) { //fab: we do not know if INTERGRAPH is an intersection graph or an interference graph. Maybe we should rename it to avoid confusion.
    // Compute intersection with Interference.
    Interference interference = Coalescer_INTERFERENCE(this);
    exists = Interference_exists(interference, Variable_TEMPORARY(a), Variable_TEMPORARY(b));
  }
  if (Coalescer_INTERGRAPH==0 || Coalescer_INTERGRAPH==2) {
    // Compute intersection with ordering(s).
    LiveCheck liveCheck = Coalescer_LIVECHECK(this);
    Operation operation_a = OperationResult_OPERATION(Variable_PRODUCER(a));
    Operation operation_b = OperationResult_OPERATION(Variable_PRODUCER(b));
    int32_t ordering_a = Variable_ORDERING(a);
    int32_t ordering_b = Variable_ORDERING(b);
    BasicBlock block_a = Operation_basicBlock(operation_a);
    Except_CHECK(Variable_ORDERING(a) >= Variable_ORDERING(b)); /* a is defined after b */
    if (ordering_a == ordering_b) {
      Except_CHECK(Coalescer_INTERGRAPH <= 0 || exists == true);
      return true;
    }
    if (!Coalescer_SEQCOPIES) { //fab: /!\ we are never in Copy mode? What if we use liveness sets only in copy mode?
      // LiveCheckMode_Mixed.
      if (LiveCheck_isLiveOutOrdering(liveCheck, block_a, ordering_a, b, LiveCheckMode_Mixed))
        return true;
    } else {
      // LiveCheckMode_Mplex.
      if (LiveCheck_isLiveOutOrdering(liveCheck, block_a, ordering_a, b, LiveCheckMode_Mplex))
        return true;
    }	
    Except_CHECK(Coalescer_INTERGRAPH <= 0 || exists == false);
    return false;
  } else {
    Except_CHECK(Coalescer_INTERGRAPH>0);
    return exists;
  }
}

#line 521 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
bool
Coalescer_interferesVV(Coalescer this, Variable a, Variable b)
{
  bool result;
  if (   Coalescer_EQUIVALUE
      && Variable_EQUIVALUE(a) == Variable_EQUIVALUE(b)) {
    result = false;
  } else {
    result = Coalescer_intersectsVV(this, a, b);
  }
  PFA_TRACE && 0 && fprintf(PFA_TRACE, "I(")
            && Variable_pretty(a, PFA_TRACE, 1)
            && fprintf(PFA_TRACE, ",")
            && Variable_pretty(b, PFA_TRACE, 1)
            && fprintf(PFA_TRACE, ",%d)\n", result);
  return result;
}

#line 547 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
static bool
Coalescer_interferesDomForestVV(Coalescer this, Variable a, Variable b)
{
  bool result;
  Except_CHECK(a != NULL);
  Except_CHECK(Coalescer_DOMFOREST);
  if (Coalescer_EQUIVALUE) {
    Except_CHECK(b == NULL || Variable_ORDERING(a) >= Variable_ORDERING(b));
    *Variable__EQUALANCOUT(a) = NULL;
    if (b != NULL && Variable_CONGRUENCE(a) == Variable_CONGRUENCE(b))
      b = Variable_EQUALANCOUT(b);
    if (b == NULL) return false;
    if (Variable_EQUIVALUE(a) != Variable_EQUIVALUE(b)) {
      // return chain_intersect(a, b)
      Variable tmp = b;
      while (   tmp != NULL
             && !Coalescer_intersectsVV(this, a, tmp)) {
        tmp = Variable_EQUALANCIN(tmp);
      }
      result = tmp != NULL;
    } else {
      // update equal_anc_out(a, b).
      Variable tmp = b;
      while (   tmp != NULL
             && !Coalescer_intersectsVV(this, a, tmp)) {
        tmp = Variable_EQUALANCIN(tmp);
      }
      *Variable__EQUALANCOUT(a) = tmp;
      result = false;
    }
  } else {
    if (b == NULL) {
      return false;
    } else if (Variable_CONGRUENCE(a) == Variable_CONGRUENCE(b)) {
      result = false;
    } else {
      result = Coalescer_intersectsVV(this, a, b);
    }
  }
  PFA_TRACE && 0 && fprintf(PFA_TRACE, "I(")
    && Variable_pretty(a, PFA_TRACE, 1)
    && fprintf(PFA_TRACE, ",")
    && Variable_pretty(b, PFA_TRACE, 1)
    && fprintf(PFA_TRACE, ",%d)\n", result);
  return result;
}

#line 604 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
bool
Coalescer_interferesDomForest(Coalescer this,
			      VariableClass class_x,
			      VariableClass class_y)
{
  int32_t i = 0, j = 0, nb_x = 0, nb_y = 0;
  int32_t count_x = VariableClass_count(class_x);
  int32_t count_y = VariableClass_count(class_y);
  VariableStack domStack = Coalescer_DOMSTACK(this);
  Dominance dominance = Coalescer_DOMINANCE(this);
  const int32_t *preDFN = Dominance_PREDFN(dominance);
  const int32_t *lastDFN = Dominance_LASTDFN(dominance);
  Variable ordered_x = VariableClass_FIRST(class_x);
  Variable ordered_y = VariableClass_FIRST(class_y);
  Except_CHECK(count_x > 0 && count_y > 0);
  Except_CHECK(Coalescer_DOMFOREST);
  VariableStack_empty(domStack);
  VariableStack_resize(domStack, count_x + count_y);
  /* Was: (i < count_x || j < count_y) */
  while (   i < count_x + nb_x
         && j < count_y + nb_y
         && (i < count_x || j < count_y)) {
    Variable curr = NULL, top = NULL;
    Operation curr_operation = NULL;
    int32_t curr_block_index = 0;
    Except_CHECK(i < count_x || j < count_y);
    if (j == count_y) {
      curr = ordered_x;
      ordered_x = Variable_CLASSNEXT(ordered_x);
      i++, nb_x++;
    } else if (i == count_x) {
      curr = ordered_y;
      ordered_y = Variable_CLASSNEXT(ordered_y);
      j++, nb_y++;
    } else if (Variable_ORDERING(ordered_x) < Variable_ORDERING(ordered_y)) {
      curr = ordered_x;
      ordered_x = Variable_CLASSNEXT(ordered_x);
      i++, nb_x++;
    } else {
      curr = ordered_y;
      ordered_y = Variable_CLASSNEXT(ordered_y);
      j++, nb_y++;
    }
    curr_operation = OperationResult_OPERATION(Variable_PRODUCER(curr));
    curr_block_index = BasicBlock_index(Operation_basicBlock(curr_operation));
    while (!VariableStack_isEmpty(domStack)) {
      top = VariableStack_top(domStack);
      // Break iff top dominates curr.
      if (Variable_ORDERING(top) <= Variable_ORDERING(curr)) {
	Operation top_operation = OperationResult_OPERATION(Variable_PRODUCER(top));
	int32_t top_index = BasicBlock_index(Operation_basicBlock(top_operation));
	if (lastDFN[top_index] >= preDFN[curr_block_index]) break;
      }
      if (Variable_CONGRUENCE(top) == class_x) nb_x--;
      else nb_y--;
      VariableStack_pop(domStack);
    }
    VariableStack_push(domStack, curr);
    if (Coalescer_interferesDomForestVV(this, curr, top)) return true;
  }
  return false;
}

#line 675 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
VariableClass
Coalescer_mergeCongruencesCC(Coalescer this, VariableClass class_x, VariableClass class_y)
{
  PFA_TIMER && fprintf(PFA_TIMER, "@@@ STAT MCC\n");
  VariableClass_merge(class_x, class_y);
  if (Coalescer_DOMFOREST && Coalescer_EQUIVALUE) {
    // Require class_x and class_y with EQUALANCIN and EQUALANCOUT set.
    // EQUALANCIN points to the same class.
    // EQUALANCOUT points to the other class before the merge.
    VariableClass_FOREACH_Variable(class_x, variable) {
      Variable in = Variable_EQUALANCIN(variable);
      Variable out = Variable_EQUALANCOUT(variable);
      if (   in == NULL
          || (   out != NULL
              && Variable_ORDERING(out) > Variable_ORDERING(in))) {
        *Variable__EQUALANCIN(variable) = out;
      }
    } VariableClass_ENDEACH_Variable;
  }
  return class_x;
}

#line 705 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
void
Coalescer_classesFromSSAwebs(Coalescer this)
{
  CodeRegion codeRegion = Coalescer_CODEREGION(this);
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      Operator operator = Operation_operator(operation);
      if (Operator_isPhi(operator)) {
        Coalescer_mergePhiCongruences(this, operation, NULL);
      }
      else if (   Operator_isSeqCopy(operator)
               || Operator_isParCopy(operator)) {
        int32_t argCount = Operation_argCount(operation), i;
        Temporary *arguments = Operation_arguments(operation);
        Temporary *results = Operation_results(operation);
        for (i = 0; i < argCount; i++) {
          if (   Temporary_isVariable(arguments[i])
              && Temporary_isVariable(results[i])) {
            Variable source = Temporary_VARIABLE(arguments[i]);
            Variable target = Temporary_VARIABLE(results[i]);
            if (Variable_isCoalesced(target)) {
              VariableClass congruence_source = Variable_CONGRUENCE(source);
              VariableClass congruence_target = Variable_CONGRUENCE(target);
              if ((congruence_source != congruence_target))
                VariableClass_merge(congruence_source, congruence_target);
           }
         }
       }
      }
    } BasicBlock_ENDEACH_Operation;
  } CodeRegion_ENDEACH_BasicBlock;
}

#line 749 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
void
Coalescer_mergePhiCongruences(Coalescer this, Operation operation, CoalescerFilter filter)
{
  Temporary *operands = Operation_operands(operation);
  Variable variable_0 = Temporary_VARIABLE(operands[0]);
  VariableClass congruence_0 = Variable_CONGRUENCE(variable_0);
  int32_t operandCount = Operation_operandCount(operation), i;
  for (i = 1; i < operandCount; i++) {
    Variable variable_i = Temporary_VARIABLE(operands[i]);
    VariableClass congruence_i = Variable_CONGRUENCE(variable_i);
    if ((congruence_i != congruence_0) &&
	((filter == NULL) || filter(variable_0, congruence_0, variable_i, congruence_i))) {
      VariableClass_merge(congruence_0, congruence_i);
    }
  }
}

#line 772 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
void
Coalescer_mergeCopyCongruences(Coalescer this, Operation operation, CoalescerFilter filter)
{
  int32_t argCount = Operation_argCount(operation), index;
  for (index = 0; index < argCount; index++) {
    Temporary temporary_x = Operation_getResult(operation, index);
    Temporary temporary_y = Operation_getArgument(operation, index);
    if (   Temporary_isVariable(temporary_x)
	&& Temporary_isVariable(temporary_y)) {
      Variable variable_x = Temporary_VARIABLE(temporary_x);
      Variable variable_y = Temporary_VARIABLE(temporary_y);
      VariableClass congruence_x = Variable_CONGRUENCE(variable_x);
      VariableClass congruence_y = Variable_CONGRUENCE(variable_y);
      if ((congruence_x != congruence_y) &&
	  ((filter == NULL) || filter(variable_x, congruence_x, variable_y, congruence_y))) {
	VariableClass_merge(congruence_x, congruence_y);
      }
    }
  }
}

#line 814 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
bool
Coalescer_interferesCC(Coalescer this, VariableClass class_x, VariableClass class_y)
{
  bool result = false;
  Except_CHECK(class_x != NULL && class_y != NULL);
  if (class_y == class_x) goto leave;
  // There is only one dedicated variable class per register
  // and two dedicated variable class interfere.
  if (Coalescer_interferesCCRegisters(this, class_x, class_y)) {
    result = true;
  } else
  if (Coalescer_DOMFOREST) {
    result = Coalescer_interferesDomForest(this, class_x, class_y);
  } else {
    VariableClass_FOREACH_Variable(class_x, resource_x) {
      VariableClass_FOREACH_Variable(class_y, resource_y) {
        if (Coalescer_interferesVV(this, resource_x, resource_y)) {
          result = true;
          goto leave;
        }
      } VariableClass_ENDEACH_Variable;
    } VariableClass_ENDEACH_Variable;
  }
leave:
  return result;
}

#line 847 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
bool
Coalescer_interferesCP(Coalescer this, VariableClass X, Operation phi)
{
  // FIXME: use livein & liveout sets with a trick for branch bool instead
  BasicBlock B0 = Operation_basicBlock(phi);
  LiveCheck liveCheck = Coalescer_LIVECHECK(this);
  PFA_TRACE && 0 && fprintf(PFA_TRACE, "Checking interferesCphi phi:")
            && Operation_pretty(phi, PFA_TRACE) && fprintf(PFA_TRACE, "X: ")
            && VariableClass_pretty(X, PFA_TRACE, 0) && fprintf(PFA_TRACE, "\n");
  //foreach xi in X
  VariableClass_FOREACH_Variable(X, xi) {
    //foreach Bj
    Operation_OPERANDS_FOREACH_Temporary(phi, temp_aj) {
      int32_t j = Operation_OPERANDS_INDEX;
      Variable aj = Temporary_VARIABLE(temp_aj);
      if (Coalescer_EQUIVALUE && (Variable_EQUIVALUE(aj) == Variable_EQUIVALUE(xi))) continue;
      if (!Coalescer_EQUIVALUE && (aj == xi)) continue;
      if (j == 0) {
        if (!Coalescer_SEQCOPIES) {
          // LiveCheckMode_Mixed.
          if (LiveCheck_isLiveInBasicBlock(liveCheck, B0, xi, LiveCheckMode_Mixed)) return true;
        } else {
          // LiveCheckMode_Mplex.
          if (LiveCheck_isLiveInBasicBlock(liveCheck, B0, xi, LiveCheckMode_Mplex)) return true;
        }
      }
      else {
        BasicBlock Bj = BasicBlockEdge_origBlock(BasicBlock_getPhiEnterEdge(B0, j - 1));
        //PFA_TRACE && fprintf(PFA_TRACE,"DEBUG: j=%d, Bj=%d\n",j, BasicBlock_index(Bj));
        if (!Coalescer_SEQCOPIES) {
          // LiveCheckMode_Mixed.
          if (LiveCheck_isLiveOutBasicBlock(liveCheck, Bj, xi, LiveCheckMode_Mixed)) return true;
        } else {
          // LiveCheckMode_Mplex.
          if (LiveCheck_isLiveOutBasicBlock(liveCheck, Bj, xi, LiveCheckMode_Mplex)) return true;
        }
      }
    } Operation_OPERANDS_ENDEACH_Temporary;
  } VariableClass_ENDEACH_Variable;
  return false;
}

#line 897 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
void
Coalescer_addInterferenceVS(Coalescer this,
                            Variable variable_x,
                            TemporarySet set_y)
{
  if (Coalescer_INTERGRAPH <= 0) {
  } else {
    Temporary temporary_x = Variable_TEMPORARY(variable_x);
    Interference interference = Coalescer_INTERFERENCE(this);
    PFA_TRACE && fprintf(PFA_TRACE, "addInterferenceVC: ")
              && Variable_pretty(variable_x, PFA_TRACE, 0)
              && TemporarySet_pretty(set_y, PFA_TRACE)
              && fprintf(PFA_TRACE, "\n");
    TemporarySet_FOREACH_Temporary(set_y, temporary_y) {
      if (temporary_x != temporary_y) {
        Interference_add(interference, temporary_x, temporary_y);
      }
    } TemporarySet_ENDEACH_Temporary;
  }
}

#line 918 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 926 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
void
Coalescer_emptyClasses(Coalescer this)
{
  TemporaryTable temporaryTable = Coalescer_TEMPORARYTABLE(this);
  TemporaryTable_FOREACH_Temporary(temporaryTable, temporary) {
    Variable variable = Temporary_VARIABLE(temporary);
    Except_CHECK(Temporary_isVariable(temporary));
    *Variable__CONGRUENCE(variable) = NULL;
    *Variable__CLASSNEXT(variable) = NULL;
  } TemporaryTable_ENDEACH_Temporary;
}

#line 944 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
void
Coalescer_fillFromWebs(Coalescer this)
{
  IBList congruences = Coalescer_CONGRUENCES(this);
  TemporaryTable temporaryTable = Coalescer_TEMPORARYTABLE(this);
  TemporaryTable_FOREACH_Temporary(temporaryTable, temporary) {
    Variable variable = Temporary_VARIABLE(temporary);
    Except_CHECK(Temporary_isVariable(temporary));
    *Variable__CONGRUENCE(variable) = NULL;
    *Variable__CLASSNEXT(variable) = NULL;
  } TemporaryTable_ENDEACH_Temporary;
  TemporaryTable_FOREACH_Temporary(temporaryTable, temporary) {
    Variable variable = Temporary_VARIABLE(temporary);
    Variable root = Variable_findWebRoot(variable);
    VariableClass congruence = Variable_CONGRUENCE(root);
    if (congruence == NULL) {
      congruence = IBList_push(congruences);
      VariableClass_Ctor(congruence, root);
    }
    if (variable != root) {
      VariableClass_insert(congruence, variable);
    }
  } TemporaryTable_ENDEACH_Temporary;
}

#line 969 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
static bool
OperationPHI_isTrivial(Operation phi, Variable variable) {
  Temporary temporary = Variable_TEMPORARY(variable);
  Operation_ARGUMENTS_FOREACH_Temporary(phi, argument) {
    if (argument != temporary) return false;
  } Operation_ARGUMENTS_ENDEACH_Temporary;
  return true;
}

#line 984 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
VariableClass
Coalescer_findInterferingClass(Coalescer this)
{
  Coalescer_CONGRUENCES_FOREACH_VariableClass(this, congruence) {
    VariableClass_FOREACH_Variable(congruence, variable_1) {
      VariableClass_FOREACH_Variable(congruence, variable_2) {
        if (   variable_1 != variable_2
            && Coalescer_interferesVV(this, variable_1, variable_2)) {
          // No interference between two PHIs in the same basic block with the same arguments.
          Operation def_1 = OperationResult_OPERATION(Variable_PRODUCER(variable_1));
          Operation def_2 = OperationResult_OPERATION(Variable_PRODUCER(variable_2));
          bool interfere = true;
          if (   (Operation_BASICBLOCK(def_1) == Operation_BASICBLOCK(def_2))
              && (   Operator_isPhi(Operation_operator(def_1))
                  && Operator_isPhi(Operation_operator(def_2)))) {
            interfere = false;
            Operation_ARGUMENTS_FOREACH_Temporary(def_1, argument) {
              if (argument != Operation_getArgument(def_2, Operation_ARGUMENTS_INDEX)) {
                interfere = true;
                break;
              }
            } Operation_ARGUMENTS_ENDEACH_Temporary;
          }
          // No interference between a PHI and its arguments if they are all the same.
          else if (   (   Operator_isPhi(Operation_operator(def_1))
                       && OperationPHI_isTrivial(def_1, variable_2))
                   || (   Operator_isPhi(Operation_operator(def_2))
                       && OperationPHI_isTrivial(def_2, variable_1)))
            interfere = false;
          if (!interfere) continue;
          PFA_TRACE && fprintf(PFA_TRACE, " *** SSA Interference: ")
                    && Temporary_pretty(Variable_TEMPORARY(variable_1), PFA_TRACE)
                    && Temporary_pretty(Variable_TEMPORARY(variable_2), PFA_TRACE)
                    && fprintf(PFA_TRACE, "\n");
	  PFA_TRACE && fflush(PFA_TRACE);
          return congruence;
        }
      } VariableClass_ENDEACH_Variable;
    } VariableClass_ENDEACH_Variable;
  } Coalescer_CONGRUENCES_ENDEACH_VariableClass;
  return NULL;
}

#line 1033 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
VariableClass
Coalescer_findIntersectingClass(Coalescer this)
{
  Coalescer_CONGRUENCES_FOREACH_VariableClass(this, congruence) {
    VariableClass_FOREACH_Variable(congruence, variable_1) {
      VariableClass_FOREACH_Variable(congruence, variable_2) {
        if (   variable_1 != variable_2
            && Coalescer_intersectsVV(this, variable_1, variable_2)) {
          PFA_TRACE && fprintf(PFA_TRACE, " *** SSA Intersection ")
                    && Temporary_pretty(Variable_TEMPORARY(variable_1), PFA_TRACE)
                    && Temporary_pretty(Variable_TEMPORARY(variable_2), PFA_TRACE)
                    && fprintf(PFA_TRACE, "\n");
          return congruence;
        }
      } VariableClass_ENDEACH_Variable;
    } VariableClass_ENDEACH_Variable;
  } Coalescer_CONGRUENCES_ENDEACH_VariableClass;
  return NULL;
}

#line 1059 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
bool
Coalescer_isNeededPhiOutClass(Coalescer this, BasicBlock basicBlock, Temporary temporary)
{
  BasicBlock_LEAVE_FOREACH_BasicBlockEdge(basicBlock, edge) {
    BasicBlock succ_block = BasicBlockEdge_destBlock(edge);
    BasicBlock_FOREACH_Operation(succ_block, operation) {
      if (Operator_isPhi(Operation_operator(operation))) {
        Operation_ARGUMENTS_FOREACH_Temporary(operation, argument) {
          if (argument == temporary) {
            BasicBlockEdge edge = BasicBlock_getPhiEnterEdge(succ_block, Operation_ARGUMENTS_INDEX);
            if (BasicBlockEdge_origBlock(edge) == basicBlock) return true;
          }
        } Operation_ARGUMENTS_ENDEACH_Temporary;
      } else break;
    } BasicBlock_ENDEACH_Operation;
  } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
  return false;
}

#line 1085 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
void
Coalescer_explicitPhi(Coalescer this, Operation phi)
{
  CodeRegion codeRegion = Coalescer_CODEREGION(this);
  BasicBlock L0 = Operation_basicBlock(phi);
  VariableClass classPhi;
  // Set classPhi: the congruence class of the phi variable
  if (Operation_COLOR(phi) == NULL) {
    Memory memory = Coalescer_MEMORY(this);
    VariableClass congruence = IBList_push(Coalescer_CONGRUENCES(this));
    *Operation__COLOR(phi) = VariableClass_Ctor(congruence, NULL);
  }
  classPhi = Operation_COLOR(phi);
  PFA_TRACE && fprintf(PFA_TRACE, "\t\t\t\tEXPLICIT") && Operation_pretty(phi, PFA_TRACE)
            && fprintf(PFA_TRACE, "\t\t\t\t\tPHIVAR: ")
            && VariableClass_pretty(classPhi, PFA_TRACE, 0) && fprintf(PFA_TRACE, "\n");
  // Foreach Lj, j-th predecessor of L:
  Operation_ARGUMENTS_FOREACH_Temporary(phi, temp_aj) {
    Operation pcj = NULL;
    Variable aj = Temporary_VARIABLE(temp_aj);
    VariableClass class_aj = Variable_CONGRUENCE(aj);
    BasicBlock Lj = BasicBlockEdge_origBlock(BasicBlock_getPhiEnterEdge(L0, Operation_ARGUMENTS_INDEX));
    PFA_TRACE && fprintf(PFA_TRACE, "\t\t\t\t\tAj: ")
              && ( (class_aj && VariableClass_pretty(class_aj, PFA_TRACE, 0) && fprintf(PFA_TRACE, "\n"))
		   || (Variable_pretty(aj, PFA_TRACE, 1) && fprintf(PFA_TRACE, "\n")) );
    if (classPhi != class_aj) { // split
      Variable ajp = NULL;
      // Create ajp and coalesce to classPhi.
      Except_CHECK(!pcj || (!Coalescer_SEQCOPIES));
      if (!Coalescer_SEQCOPIES) {
        // LiveCheckMode_Mixed.
        // Check if the copy already exists.
        pcj = BasicBlock_makeOperationLCOPY(Lj);
        Operation_RESULTS_FOREACH_Temporary(pcj, result) {
          Variable V_dst = Temporary_VARIABLE(result);
          VariableClass classDst = Variable_CONGRUENCE(V_dst);
          if (classDst == classPhi) {
            Except_CHECK(Variable_EQUIVALUE(aj) == Variable_EQUIVALUE(Temporary_VARIABLE(Operation_getArgument(pcj, Operation_RESULTS_INDEX))));
            ajp = V_dst;
            break;
          }
        } Operation_RESULTS_ENDEACH_Temporary;
      }
      if (ajp == NULL) {
        // Create the copy.
        int resIndex;
        Operation copy;
        Temporary temp_ajp = CodeRegion_makeVariableTemporary(codeRegion, Variable_ORIGIN(aj));
        ajp = Temporary_VARIABLE(temp_ajp);
        TemporaryTable_insert(Coalescer_TEMPORARYTABLE(this), temp_ajp);
        if (pcj != NULL) {
          copy = pcj;
          resIndex = Operation_addtoParCopy(pcj, temp_ajp, temp_aj);
        } else {
          copy = BasicBlock_makeLateOperationCOPY(Lj, temp_ajp, temp_aj);
          resIndex = 0;
        }
        Variable_setOperationResult(ajp, copy, resIndex);
        VariableClass_insert(classPhi, ajp);
        if (Coalescer_CONSUMING(this)) Variable_raiseConsuming(ajp);
        Variable_setOperationArgument(aj, copy, resIndex);
        0 &&
        PFA_TRACE && fprintf(PFA_TRACE, "\t\t\t\t\tCOPY: ") && Operation_pretty(copy, PFA_TRACE);
      }
      // Update the phi operand
      Variable_setOperationArgument(ajp, phi, Operation_ARGUMENTS_INDEX);
      // Update liveness sets
      if (LiveCheck_LIVENESS>0) {
	if (!Coalescer_SEQCOPIES) {
          // LiveCheckMode_Mixed.
	  TemporarySet_insert(Coalescer_LIVEOUTSETS(this)+BasicBlock_index(Lj), ajp);
	} else {
          // LiveCheckMode_Mplex.
	  if(!Coalescer_isNeededPhiOutClass(this, Lj, temp_aj)) {
	    TemporarySet_remove(Coalescer_PHIOUTSETS(this)+BasicBlock_index(Lj), aj);
          }
	  TemporarySet_insert(Coalescer_PHIOUTSETS(this)+BasicBlock_index(Lj), ajp);
	}
      }
      // Update interference graph
      if (Coalescer_INTERGRAPH>0) {
        Except_CHECK(LiveCheck_LIVENESS>0);
	if (!Coalescer_SEQCOPIES) {
          // LiveCheckMode_Mixed.
	  // ajp interferes with all variables liveout of the parallel copy
	  Coalescer_addInterferenceVS(this, ajp, Coalescer_LIVEOUTSETS(this)+BasicBlock_index(Lj));
	  // FIXME: addInterference with branching bool
	} else {
          // LiveCheckMode_Mplex.
	  // ajp interferes with all variables liveout of the late instruction point
	  Coalescer_addInterferenceVS(this, ajp, Coalescer_PHIOUTSETS(this)+BasicBlock_index(Lj));
	  Coalescer_addInterferenceVS(this, ajp, Coalescer_LIVEOUTSETS(this)+BasicBlock_index(Lj));
	  // FIXME: addInterference with branching bool
	}
      }
    } else { // merge
      // Update the liveness sets
      if (LiveCheck_LIVENESS>0) {
	TemporarySet_insert(Coalescer_LIVEOUTSETS(this)+BasicBlock_index(Lj), aj);
        // Update the interference graph
        if (Coalescer_INTERGRAPH>0) {
          if (!Coalescer_SEQCOPIES) {
            // LiveCheckMode_Mixed.
            // Additional interference with variables defined by the pcopy.
            // Already interferes with LIVEOUTCLASS + branch bool.
            Coalescer_addInterferenceVS(this, aj, Coalescer_LIVEOUTSETS(this)+BasicBlock_index(Lj));
            // FIXME: restrict to PCOPY defs.
          } // else nothing to do.
        }
      }
    }
  } Operation_ARGUMENTS_ENDEACH_Temporary;
  // L0 (j == 0)
  {
    Temporary temp_a0 = Operation_getResult(phi, 0);
    Variable a0 = Temporary_VARIABLE(temp_a0);
    VariableClass class_a0 = Variable_CONGRUENCE(a0);
    PFA_TRACE && fprintf(PFA_TRACE, "\t\t\t\t\tA0: ")
              && ( (class_a0 && VariableClass_pretty(class_a0, PFA_TRACE, 0) && fprintf(PFA_TRACE, "\n"))
		   || (Variable_pretty(a0, PFA_TRACE, 1) && fprintf(PFA_TRACE, "\n")) );
    if (class_a0 != classPhi) { //split
      // Create a0p and coalesce to classPhi
      int resIndex;
      Operation copy;
      Operation pc0 = NULL;
      Temporary temp_a0p = CodeRegion_makeVariableTemporary(codeRegion, Variable_ORIGIN(a0));
      Variable a0p = Temporary_VARIABLE(temp_a0p);
      TemporaryTable_insert(Coalescer_TEMPORARYTABLE(this), temp_a0p);
      // Create the copy
      if (!Coalescer_SEQCOPIES) {
        // LiveCheckMode_Mixed.
        pc0 = BasicBlock_makeOperationECOPY(L0);
        copy = pc0;
        resIndex = Operation_addtoParCopy(pc0, temp_a0p, temp_a0);
      } else {
        // LiveCheckMode_Mplex.
        copy = BasicBlock_makeEarlyOperationCOPY(L0, temp_a0p, temp_a0);
        resIndex = 0;
      }
      Variable_setOperationResult(a0, copy, resIndex);
      if (class_a0) Variable_updateCongruence(a0);
      Variable_setOperationArgument(a0p, copy, resIndex);
      Variable_setOperationResult(a0p, phi, 0);
      VariableClass_insert(classPhi, a0p);
      if (Coalescer_CONSUMING(this)) Variable_raiseConsuming(a0p);
      // Update the liveness sets
      if (LiveCheck_LIVENESS>0) {
	if (!Coalescer_SEQCOPIES) {
          // LiveCheckMode_Mixed.
	  TemporarySet_insert(Coalescer_LIVEINSETS(this)+BasicBlock_index(L0), a0p);
	} else {
          // LiveCheckMode_Mplex.
	  TemporarySet_remove(Coalescer_PHIINSETS(this)+BasicBlock_index(L0), a0);
	  TemporarySet_insert(Coalescer_PHIINSETS(this)+BasicBlock_index(L0), a0p);
	}
      }
      // update interference graph
      if (Coalescer_INTERGRAPH>0) {
	if (!Coalescer_SEQCOPIES) {
          // LiveCheckMode_Mixed.
	  // a0p interferes with all variables livein of the parallel copy
	  Coalescer_addInterferenceVS(this, a0p, Coalescer_LIVEINSETS(this)+BasicBlock_index(L0));
	} else {
          // LiveCheckMode_Mplex.
	  // a0p interferes with all variables livein of the early instruction point
          // (here neighbors of a0p are neighbors of a0)
	  Coalescer_addInterferenceVS(this, a0p, Coalescer_PHIINSETS(this)+BasicBlock_index(L0));
	  Coalescer_addInterferenceVS(this, a0p, Coalescer_LIVEINSETS(this)+BasicBlock_index(L0));
	}
      }
    } else { //merge
      // update liveness sets
      if (LiveCheck_LIVENESS>0) {
	if (!Coalescer_SEQCOPIES) {
          // LiveCheckMode_Mixed.
	  TemporarySet_insert(Coalescer_LIVEINSETS(this)+BasicBlock_index(L0), a0);
	}
        // update interference graph
        if (Coalescer_INTERGRAPH>0) {
          if (!Coalescer_SEQCOPIES) {
            // LiveCheckMode_Mixed.
            // Additional interference with variables used by the pcopy.
            // Already interferes with LIVEINCLASS.
            // FIXME: use pcopy uses instead this trick
            if (Coalescer_PHIINSETS(this)) {
              Coalescer_addInterferenceVS(this, a0, Coalescer_PHIINSETS(this)+BasicBlock_index(L0));
            } else {
              Coalescer_addInterferenceVS(this, a0, Coalescer_LIVEINSETS(this)+BasicBlock_index(L0));
            }
          }
        }
      }
    }
  }
}

#line 1281 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1296 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
#ifndef Coalescer_INIT
void
Coalescer_INIT(void)
{
#ifndef Coalescer_INTERGRAPH
  if (GETENV("Coalescer_INTERGRAPH")) {
    sscanf(GETENV("Coalescer_INTERGRAPH"), "%d", &Coalescer_INTERGRAPH);
    fprintf(stderr, "*** Coalescer_INTERGRAPH=%d\n", Coalescer_INTERGRAPH);
  }
  if (Coalescer_INTERGRAPH>0) Except_ALWAYS(LiveCheck_LIVENESS>0);
#endif//Coalescer_INTERGRAPH
#ifndef Coalescer_SEQCOPIES
  if (GETENV("Coalescer_SEQCOPIES")) {
    sscanf(GETENV("Coalescer_SEQCOPIES"), "%d", &Coalescer_SEQCOPIES);
    fprintf(stderr, "*** Coalescer_SEQCOPIES=%d\n", Coalescer_SEQCOPIES);
  }
#endif//Coalescer_SEQCOPIES
#ifndef Coalescer_EQUIVALUE
  if (GETENV("Coalescer_EQUIVALUE")) {
    sscanf(GETENV("Coalescer_EQUIVALUE"), "%d", &Coalescer_EQUIVALUE);
    fprintf(stderr, "*** Coalescer_EQUIVALUE=%d\n", Coalescer_EQUIVALUE);
  }
#endif//Coalescer_EQUIVALUE
#ifndef Coalescer_DOMFOREST
  if (GETENV("Coalescer_DOMFOREST")) {
    sscanf(GETENV("Coalescer_DOMFOREST"), "%d", &Coalescer_DOMFOREST);
    fprintf(stderr, "*** Coalescer_DOMFOREST=%d\n", Coalescer_DOMFOREST);
  }
#endif//Coalescer_DOMFOREST
  // There is a lurking bug according to Fabrice -- BD3 2008-08-01.
  if (Coalescer_DOMFOREST > 0 && Coalescer_EQUIVALUE <= 0) {
    fprintf(stderr, "*** BUG ALERT! DOMFOREST only works with EQUIVALUE set!\n");
  }
}
#endif//Coalescer_INIT

#line 1337 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
#if XCC__C
static void
Coalescer_TEST(void)
{
#include "PFA/Coalescer_.c"
}

#line 1344 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Coalescer.xcc"
int
main(int argc, char **argv)
{
  PFA_Test(Coalescer_TEST);
  return 0;
}
#endif


#endif//Coalescer_c_INCLUDED
