#ifndef Dominance_c_INCLUDED
#define Dominance_c_INCLUDED

#line 17 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
#include "PFA/PFA_.h"

#line 27 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 74 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
Dominance
Dominance_Ctor(Dominance this,
               Memory memory, CodeRegion codeRegion, DominanceFlags flags)
{
  int32_t blockCount = CodeRegion_blockCount(codeRegion), index;
  BasicBlock rootBlock = CodeRegion_rootBlock(codeRegion);
  size_t postOrderSize = sizeof(BasicBlock)*3*blockCount;
  size_t postDFNSize = sizeof(int32_t)*5*blockCount;
  size_t childrenSize = sizeof(BasicBlockStack_)*blockCount;
  size_t frontiersSize = sizeof(PtrSet_)*blockCount;
  size_t mergeSetsSize = sizeof(PtrSet_)*blockCount;
  if (flags & DominanceFlag_MergeSets) {
    if (Dominance_TDMSC) {
      flags |= DominanceFlag_TreeOrder | DominanceFlag_JoinEdges;
    } else {
      flags |= DominanceFlag_Frontiers;
    }
  }
  *Dominance__MEMORY(this) = memory;
  *Dominance__CODEREGION(this) = codeRegion;
  *Dominance__BLOCKCOUNT(this) = blockCount;
  *Dominance__BLOCKMAP(this) = CodeRegion_blockTableBase(codeRegion);
  *Dominance__POSTORDER(this) = Memory_alloc(memory, postOrderSize);
  memset(Dominance_POSTORDER(this), 0, postOrderSize);
  *Dominance__DOMDFS(this) = Dominance_POSTORDER(this) + blockCount;
  *Dominance__POSTCOUNT(this) = 0;
  *Dominance__POSTDFN(this) = Memory_alloc(memory, postDFNSize);
  memset(Dominance_POSTDFN(this), -1, postDFNSize);
  *Dominance__IDOMIDX(this) = Dominance_POSTDFN(this) + blockCount;
  *Dominance__CHILDREN(this) = Memory_alloc(memory, childrenSize);
  for (index = 0; index < blockCount; index++) {
    BasicBlockStack_Ctor(Dominance_CHILDREN(this) + index, memory, 0);
  }
  *Dominance__PREDFN(this) = Dominance_POSTDFN(this) + 2*blockCount;
  *Dominance__LASTDFN(this) = Dominance_POSTDFN(this) + 3*blockCount;
  *Dominance__TREELEVEL(this) = NULL;
  *Dominance__TREEORDER(this) = NULL;
  if (flags & DominanceFlag_TreeOrder) {
    *Dominance__TREELEVEL(this) = Dominance_POSTDFN(this) + 4*blockCount;
    *Dominance__TREEORDER(this) = Dominance_POSTORDER(this) + 2*blockCount;
  }
  *Dominance__FRONTIERS(this) = NULL;
  if (flags & DominanceFlag_Frontiers) {
    *Dominance__FRONTIERS(this) = Memory_alloc(memory, frontiersSize);
    for (index = 0; index < blockCount; index++) {
      PtrSet_Ctor(Dominance_FRONTIERS(this) + index, memory, 0);
    }
  }
  *Dominance__MERGESETS(this) = NULL;
  if (flags & DominanceFlag_MergeSets) {
    *Dominance__MERGESETS(this) = Memory_alloc(memory, mergeSetsSize);
    for (index = 0; index < blockCount; index++) {
      PtrSet_Ctor(Dominance_MERGESETS(this) + index, memory, 0);
    }
  }
  *Dominance__JOINTCOUNT(this) = -1;
  *Dominance__VISITED(this) = NULL;
  *Dominance__FLAGS(this) = flags;
  // Make IDOMIDX with the Cooper-Harvey-Kennedy algorithm.
  Dominance_makeIDOMIDX(this, rootBlock, flags);
  // Make CHILDREN from IDOMIDX.
  Dominance_makeCHILDREN(this);
  // Make PREDFN and LASTDFN from CHILDREN.
  Dominance_makePREDFN(this, rootBlock);
  // Mark DJ-Graph Join Edges if requested.
  if (flags & DominanceFlag_JoinEdges) {
    Dominance_markJoinEdges(this);
  }
  // Make TREEORDER and TREELEVEL from CHILDREN if requested.
  if (flags & DominanceFlag_TreeOrder) {
    Dominance_makeTREEORDER(this, rootBlock);
  }
  // Make FRONTIERS from CHILDREN if requested.
  if (flags & DominanceFlag_Frontiers) {
    Dominance_makeFRONTIERS(this, flags);
  }
  // Make MERGESETS from CHILDREN if requested.
  if (flags & DominanceFlag_MergeSets) {
    Dominance_makeMERGESETS(this, flags);
  }
  return this;
}

#line 157 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
void
Dominance_Dtor(Dominance this)
{
  Memory memory = Dominance_MEMORY(this);
  int32_t blockCount = Dominance_BLOCKCOUNT(this), index;
  for (index = 0; index < blockCount; index++) {
    BasicBlockStack_Dtor(Dominance_CHILDREN(this) + index);
  }
  Memory_free_(memory, Dominance_CHILDREN(this));
  Memory_free_(memory, Dominance_POSTDFN(this));
  Memory_free_(memory, Dominance_POSTORDER(this));
  if (Dominance_FRONTIERS(this) != NULL) {
    for (index = 0; index < blockCount; index++) {
      PtrSet_Dtor(Dominance_FRONTIERS(this) + index);
    }
    Memory_free_(memory, Dominance_FRONTIERS(this));
  }
  if (Dominance_MERGESETS(this) != NULL) {
    for (index = 0; index < blockCount; index++) {
      PtrSet_Dtor(Dominance_MERGESETS(this) + index);
    }
    Memory_free_(memory, Dominance_MERGESETS(this));
  }
  Memory_free(memory, Dominance_VISITED(this));
}

#line 183 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
size_t
Dominance_Size(Memory memory, CodeRegion codeRegion, DominanceFlags flags)
{
  return sizeof(Dominance_);
}

#line 198 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
#ifndef Dominance_POOLED
#define Dominance_POOLED 128
#endif//Dominance_POOLED

#line 202 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
Dominance
Dominance_new(Memory parent, CodeRegion codeRegion, DominanceFlags flags)
{
  Memory memory = Memory_new(parent, Dominance_POOLED);
  size_t size = Dominance_Size(memory, codeRegion, flags);
  Dominance this = Memory_alloc(memory, size);
  return Dominance_Ctor(this, memory, codeRegion, flags);
}

#line 215 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
Dominance
Dominance_delete(Dominance this)
{
  if (this != NULL) {
    Memory memory = Dominance_MEMORY(this);
#ifndef ECL_NDTOR
    Dominance_Dtor(this);
    Memory_free_(memory, this);
#endif//ECL_NDTOR
    Memory_delete(memory);
  }
  return NULL;
}

#line 229 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 235 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
/*
 * The Cooper-Harvey-Kennedy algorithm for computing immediate dominators.
 *
 *	 1:  for all nodes, n
 *	 2:    DOM[n] = {1 . . .N}
 *	 3:  Changed = true
 *	 4:  while (Changed)
 *	 5:    Changed = false
 *	 6:    for all nodes, n, in reverse postorder
 *	 7:    new set = ((for all p from preds(n)) intersection DOM[p]) union {n}
 *	 8:    if (new set != DOM[n])
 *	 9:      DOM[n] = new set
 *	10:      Changed = true
 */
void
Dominance_makeIDOMIDX(Dominance this, BasicBlock rootBlock, DominanceFlags flags)
{
  bool changed = true;
  int32_t *idomIdx = Dominance_IDOMIDX(this);
  BasicBlock *postOrder = Dominance_POSTORDER(this);
  int32_t *postDFN = Dominance_POSTDFN(this);
  int32_t *_postCount = Dominance__POSTCOUNT(this), i;
  *Dominance__POSTCOUNT(this) = idomIdx[0] = 0;
  if (!(flags & DominanceFlag_Backward)) {
    Dominance_doForwardDFS(this, rootBlock, _postCount, postOrder, postDFN);
    Except_CHECK(*_postCount <= Dominance_BLOCKCOUNT(this));
    while (changed) {
      changed = false;
      for (i = *_postCount - 2; i >= 0; --i) {
        BasicBlock block = postOrder[i];
        int32_t b = BasicBlock_index(block), new_idom = -1;
        BasicBlock_ENTER_FOREACH_BasicBlockEdge(block, edge) {
          BasicBlock pred_block = BasicBlockEdge_origBlock(edge);
          int32_t p = BasicBlock_index(pred_block);
          if (idomIdx[p] >= 0) {
            if (new_idom < 0) new_idom = p;
            else {
              // new_idom = intersect(p, new_idom)
              int32_t finger1 = p, finger2 = new_idom;
              while (finger1 != finger2) {
                if (postDFN[finger1] < postDFN[finger2]) finger1 = idomIdx[finger1];
                else if (postDFN[finger2] < postDFN[finger1]) finger2 = idomIdx[finger2];
              }
              new_idom = finger1;
            }
          }
        } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
        if (idomIdx[b] != new_idom) {
          idomIdx[b] = new_idom;
          changed = true;
        }
      }
    }
  } else {
    Dominance_doBackwardDFS(this, rootBlock, _postCount, postOrder, postDFN);
    Except_CHECK(*_postCount <= Dominance_BLOCKCOUNT(this));
    while (changed) {
      changed = false;
      for (i = *_postCount - 2; i >= 0; --i) {
        BasicBlock block = postOrder[i];
        int32_t b = BasicBlock_index(block), new_idom = -1;
        BasicBlock_LEAVE_FOREACH_BasicBlockEdge(block, edge) {
          BasicBlock pred_block = BasicBlockEdge_destBlock(edge);
          int32_t p = BasicBlock_index(pred_block);
          if (idomIdx[p] >= 0) {
            if (new_idom < 0) new_idom = p;
            else {
              // new_idom = intersect(p, new_idom)
              int32_t finger1 = p, finger2 = new_idom;
              while (finger1 != finger2) {
                if (postDFN[finger1] < postDFN[finger2]) finger1 = idomIdx[finger1];
                else if (postDFN[finger2] < postDFN[finger1]) finger2 = idomIdx[finger2];
              }
              new_idom = finger1;
            }
          }
        } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
        if (idomIdx[b] != new_idom) {
          idomIdx[b] = new_idom;
          changed = true;
        }
      }
    }
  }
}

#line 326 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
// DFS of the forward control graph to compute POSTDFN and POSTORDER.
void
Dominance_doForwardDFS(Dominance this, BasicBlock block,
                       int32_t *_postCount, BasicBlock *postOrder, int32_t *postDFN)
{
  int32_t index = BasicBlock_index(block);
  postDFN[index] = 0;
  BasicBlock_LEAVE_FOREACH_BasicBlockEdge(block, edge) {
    BasicBlock dest_block = BasicBlockEdge_destBlock(edge);
    int32_t dest_index = BasicBlock_index(dest_block);
    if (postDFN[dest_index] < 0) {
      Dominance_doForwardDFS(this, dest_block, _postCount, postOrder, postDFN);
    }
    *BasicBlockEdge__ISJOIN(edge) = false;
  } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
  postDFN[index] = *_postCount;
  postOrder[*_postCount] = block;
  ++*_postCount;
}

#line 351 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
// DFS of the backward control graph to compute POSTDFN and POSTORDER.
void
Dominance_doBackwardDFS(Dominance this, BasicBlock block,
                        int32_t *_postCount, BasicBlock *postOrder, int32_t *postDFN)
{
  int32_t index = BasicBlock_index(block);
  postDFN[index] = 0;
  BasicBlock_ENTER_FOREACH_BasicBlockEdge(block, edge) {
    BasicBlock orig_block = BasicBlockEdge_origBlock(edge);
    int32_t orig_index = BasicBlock_index(orig_block);
    if (postDFN[orig_index] < 0) {
      Dominance_doBackwardDFS(this, orig_block, _postCount, postOrder, postDFN);
    }
    *BasicBlockEdge__ISJOIN(edge) = false;
  } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
  postDFN[index] = *_postCount;
  postOrder[*_postCount] = block;
  ++*_postCount;
}

#line 375 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
// Make CHILDREN from IDOMIDX.
void
Dominance_makeCHILDREN(Dominance this)
{
  int32_t *idomIdx = Dominance_IDOMIDX(this);
  BasicBlockStack_ *children = Dominance_CHILDREN(this);
  CodeRegion codeRegion = Dominance_CODEREGION(this);
  CodeRegion_FOREACH_BasicBlock(codeRegion, block) {
    int32_t index = BasicBlock_index(block);
    if (idomIdx[index] < 0) idomIdx[index] = 0;
    BasicBlockStack_push2(children + idomIdx[index], block);
  } CodeRegion_ENDEACH_BasicBlock;
}

#line 393 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
void
Dominance_makePREDFN(Dominance this, BasicBlock rootBlock)
{
  int32_t preCount = 0;
  int32_t *preDFN = Dominance_PREDFN(this);
  int32_t *lastDFN = Dominance_LASTDFN(this);
  BasicBlock *domDFS = Dominance_DOMDFS(this);
  Dominance_doDominatorDFS(this, rootBlock, &preCount, preDFN, lastDFN, domDFS);
}

#line 408 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
/*
 * DFS of the dominator tree to compute PREDFN and LASTDFN and TREELEVEL.
 */
void
Dominance_doDominatorDFS(Dominance this, BasicBlock block, int32_t *_preCount,
                         int32_t *preDFN, int32_t *lastDFN, BasicBlock *domDFS)
{
  int32_t index = BasicBlock_index(block);
  domDFS[*_preCount] = block;
  preDFN[index] = (*_preCount)++;
  Dominance_BasicBlock_FORCHILDREN_BasicBlock(this, block, child_block) {
    Dominance_doDominatorDFS(this, child_block, _preCount, preDFN, lastDFN, domDFS);
  } Dominance_BasicBlock_ENDCHILDREN_BasicBlock;
  lastDFN[index] = *_preCount - 1;
}

#line 428 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
/*
 * Set the BasicBlockEdge_ISJOIN and BasicBlockEdge_INDEX for DJ-Graph Join edges.
 */
void
Dominance_markJoinEdges(Dominance this)
{
  int32_t joinCount = 0;
  int32_t *preDFN = Dominance_PREDFN(this);
  int32_t *lastDFN = Dominance_LASTDFN(this);
  int32_t *postDFN = Dominance_POSTDFN(this);
  BasicBlock *postOrder = Dominance_POSTORDER(this);
  int32_t postCount = Dominance_POSTCOUNT(this), i;
  for (i = postCount - 1; i >= 0; --i) {
    BasicBlock this_block = postOrder[i];
    int32_t this_index = BasicBlock_index(this_block);
    BasicBlock_LEAVE_FOREACH_BasicBlockEdge(this_block, edge) {
      BasicBlock that_block = BasicBlockEdge_destBlock(edge);
      int32_t that_index = BasicBlock_index(that_block);
      if (   this_block == that_block
          || !Dominance_DOMINATES(preDFN, lastDFN, this_index, that_index)) {
        *BasicBlockEdge__ISJOIN(edge) = true;
        *BasicBlockEdge__INDEX(edge) = joinCount++;
      }
    } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
  }
  *Dominance__JOINTCOUNT(this) = joinCount;
}

#line 460 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
/*
 * BFS of the dominator tree to fill the TREELEVEL and TREEORDER arrays.
 */
void
Dominance_makeTREEORDER(Dominance this, BasicBlock rootBlock)
{
  BasicBlock *treeOrder = Dominance_TREEORDER(this);
  int32_t *treeLevel = Dominance_TREELEVEL(this);
  BasicBlock *queueFirst = treeOrder;
  BasicBlock *queuePast = treeOrder;
  *queuePast++ = rootBlock;
  treeLevel[0] = 0;
  while (queueFirst != queuePast) {
    BasicBlock block = *queueFirst++;
    int32_t index = BasicBlock_index(block);
    int32_t child_treeLevel = treeLevel[index] + 1;
    Dominance_BasicBlock_FORCHILDREN_BasicBlock(this, block, child_block) {
      int32_t child_index = BasicBlock_index(child_block);
      treeLevel[child_index] = child_treeLevel;
      *queuePast++ = child_block;
    } Dominance_BasicBlock_ENDCHILDREN_BasicBlock;
  }
  Except_CHECK(queuePast - treeOrder == Dominance_POSTCOUNT(this));
}

#line 489 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
/*
 * The Cooper-Harvey-Kennedy algorithm for computing dominance frontiers.
 *
 *	 1:  for all nodes, b
 *	 2:    if the number of predecessors of b >= 2
 *	 3:      for all predecessors, p, of b
 *	 4:        runner = p
 *	 5:        while runner != doms[b]
 *	 6:          add b to runner's dominance frontier set
 *	 7:          runner = doms[runner]
 */
void
Dominance_makeFRONTIERS(Dominance this, DominanceFlags flags)
{
  int32_t *idomIdx = Dominance_IDOMIDX(this);
  PtrSet_ *frontiers = Dominance_FRONTIERS(this);
  CodeRegion codeRegion = Dominance_CODEREGION(this);
  int32_t blockCount = Dominance_BLOCKCOUNT(this), index;
  // Creating the frontiers.
  if (!(flags & DominanceFlag_Backward)) {
    CodeRegion_FOREACH_BasicBlock(codeRegion, block) {
      if (BasicBlock_enterCount(block) >= 2) {
        int32_t b = BasicBlock_index(block);
        BasicBlock_ENTER_FOREACH_BasicBlockEdge(block, edge) {
          BasicBlock pred_block = BasicBlockEdge_origBlock(edge);
          int32_t runner = BasicBlock_index(pred_block);
          Except_CHECK(runner != -1);
          while (runner != idomIdx[b]) {
            PtrSet_addMember(frontiers + runner, (PtrSetMember)b);
            runner = idomIdx[runner];
            Except_CHECK(runner != -1);
          }
        } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
      }
    } CodeRegion_ENDEACH_BasicBlock;
  } else {
    CodeRegion_FOREACH_BasicBlock(codeRegion, block) {
      if (BasicBlock_leaveCount(block) >= 2) {
        int32_t b = BasicBlock_index(block);
        BasicBlock_LEAVE_FOREACH_BasicBlockEdge(block, edge) {
          BasicBlock pred_block = BasicBlockEdge_destBlock(edge);
          int32_t runner = BasicBlock_index(pred_block);
          Except_CHECK(runner != -1);
          while (runner != idomIdx[b]) {
            PtrSet_addMember(frontiers + runner, (PtrSetMember)b);
            runner = idomIdx[runner];
            Except_CHECK(runner != -1);
          }
        } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
      }
    } CodeRegion_ENDEACH_BasicBlock;
  }
  // Convert into sets.
  for (index = 0; index < blockCount; index++) {
    PtrSet_makeOrder(frontiers + index);
  }
}

#line 551 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
void
Dominance_makeMERGESETS(Dominance this, DominanceFlags flags)
{
  Memory memory = Dominance_MEMORY(this);
  if (Dominance_TDMSC > 0 && !(flags & DominanceFlag_Backward)) {
    int32_t joinCount = Dominance_JOINTCOUNT(this);
    bool *visited = Memory_alloc(memory, sizeof(bool)*joinCount);
    Except_CHECK(flags & DominanceFlag_JoinEdges);
    Except_CHECK(flags & DominanceFlag_TreeOrder);
    *Dominance__VISITED(this) = visited;
    do {
      memset(visited, false, sizeof(bool)*joinCount);
    } while (Dominance_doForwardTDMSC(this, visited));
  } else {
    PtrSet_ *mergeSets = Dominance_MERGESETS(this);
    CodeRegion codeRegion = Dominance_CODEREGION(this);
    int32_t blockCount = Dominance_BLOCKCOUNT(this), index;
    bool *visited = Memory_alloc(memory, sizeof(bool)*blockCount);
    BasicBlockStack_ worklist[1];
    BasicBlockStack_Ctor(worklist, memory, blockCount);
    *Dominance__VISITED(this) = visited;
    // Worklist algorithm to build the dominance frontiers.
    CodeRegion_FOREACH_BasicBlock(codeRegion, block) {
      memset(visited, false, sizeof(bool)*blockCount);
      BasicBlockStack_push(worklist, block);
      while (!BasicBlockStack_isEmpty(worklist)) {
        BasicBlock current_block = BasicBlockStack_top(worklist);
        BasicBlockStack_pop(worklist);
        Dominance_BasicBlock_FORFRONTIER_BasicBlock(this, current_block, frontier_block) {
          int32_t frontier_index = BasicBlock_index(frontier_block);
          if (!visited[frontier_index]) {
            visited[frontier_index] = true;
            BasicBlockStack_push(worklist, frontier_block);
            PtrSet_addMember(mergeSets + BasicBlock_index(block), (PtrSetMember)frontier_index);
          }
        } Dominance_BasicBlock_ENDFRONTIER_BasicBlock;
      }
    } CodeRegion_ENDEACH_BasicBlock;
    // Convert into sets.
    for (index = 0; index < blockCount; index++) {
      PtrSet_makeOrder(mergeSets + index);
    }
    // Release resources.
    BasicBlockStack_Dtor(worklist);
  }
}

#line 602 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
/*
 * The Das-Ramakrishna algorithm Top Down Merge Set Computation (TOPLAS 27, 3).
 *
 * We replace the BFS to 'traverse the DJ graph top down, level by level' by iterator
 * =Dominance_FORDOWNLEVEL_BasicBlock=.
 *
 * TODO: Implement the algorithm for backward control-flow too!
 */
bool
Dominance_doForwardTDMSC(Dominance this, bool visited[])
{
  bool anotherPass = false;
  int32_t *idomIdx = Dominance_IDOMIDX(this);
  PtrSet_ *mergeSets = Dominance_MERGESETS(this);
  int32_t *treeLevel = Dominance_TREELEVEL(this);
  const BasicBlock *blockMap = Dominance_BLOCKMAP(this);
  Dominance_FORDOWNLEVEL_BasicBlock(this, n) {
    BasicBlock_ENTER_FOREACH_BasicBlockEdge(n, e) {
      int32_t e_index = BasicBlockEdge_INDEX(e);
      if (BasicBlockEdge_ISJOIN(e) && !visited[e_index]) {
        BasicBlock s = BasicBlockEdge_ORIGBLOCK(e);
        BasicBlock t = BasicBlockEdge_DESTBLOCK(e);
        int32_t s_index = BasicBlock_index(s);
        int32_t t_index = BasicBlock_index(t);
        int32_t tmp = s_index, l_index = -1;
        visited[e_index] = true;
        while (treeLevel[tmp] >= treeLevel[t_index]) {
          PtrSet_union(mergeSets + tmp, mergeSets + t_index);
          PtrSet_insert(mergeSets + tmp, (PtrSetMember)t_index);
          l_index = tmp, tmp = idomIdx[tmp];
        }
        Except_CHECK(l_index >= 0);
        BasicBlock_ENTER_FOREACH_BasicBlockEdge(blockMap[l_index], e1) {
          int32_t e1_index = BasicBlockEdge_INDEX(e1);
          if (BasicBlockEdge_ISJOIN(e1) && visited[e1_index]) {
            BasicBlock s1 = BasicBlockEdge_ORIGBLOCK(e1);
            int32_t s1_index = BasicBlock_index(s1);
            if (PtrSet_comprises(mergeSets + s1_index, mergeSets + l_index));
            else if (Dominance_TDMSC > 1) {
              // Code for TDMSC-II algorithm.
              int32_t tmp1 = s1_index, l1_index = -1;
              while (treeLevel[tmp1] >= treeLevel[l_index]) {
                PtrSet_union(mergeSets + tmp1, mergeSets + l_index);
                l1_index = tmp1, tmp1 = idomIdx[tmp1];
              }
              // Code for AnIncomingJEdgeInconsistent(l1_index);
              Except_CHECK(l1_index >= 0);
              BasicBlock_ENTER_FOREACH_BasicBlockEdge(blockMap[l1_index], e2) {
                int32_t e2_index = BasicBlockEdge_INDEX(e2);
                if (BasicBlockEdge_ISJOIN(e2) && visited[e2_index]) {
                  BasicBlock s2 = BasicBlockEdge_ORIGBLOCK(e2);
                  int32_t s2_index = BasicBlock_index(s2);
                  if (PtrSet_comprises(mergeSets + s2_index, mergeSets + l1_index));
                  else {
                    anotherPass = true;
                    break;
                  }
                }
              } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
            } else {
              // Code for TDMSC-I algorithm.
              anotherPass = true;
            }
          }
        } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
      }
    } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
  } Dominance_ENDDOWNLEVEL_BasicBlock;
  return anotherPass;
}

#line 673 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 681 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
Memory
Dominance_memory(Dominance this)
{
  return Dominance_MEMORY(this);
}

#line 693 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
CodeRegion
Dominance_codeRegion(Dominance this)
{
  return Dominance_CODEREGION(this);
}

#line 705 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
unsigned
Dominance_flags(Dominance this)
{
  return Dominance_FLAGS(this);
}

#line 717 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
int32_t
Dominance_blockCount(Dominance this)
{
  return Dominance_BLOCKCOUNT(this);
}

#line 729 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
const BasicBlock *
Dominance_blockMap(Dominance this)
{
  return Dominance_BLOCKMAP(this);
}

#line 741 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
const BasicBlock *
Dominance_postOrder(Dominance this)
{
  return Dominance_POSTORDER(this);
}

#line 753 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
const BasicBlock *
Dominance_domDFS(Dominance this)
{
  return Dominance_DOMDFS(this);
}

#line 765 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
int32_t
Dominance_postCount(Dominance this)
{
  return Dominance_POSTCOUNT(this);
}

#line 822 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
const int32_t *
Dominance_idomIdx(const_Dominance this)
{
  return Dominance_IDOMIDX(this);
}

#line 834 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
BasicBlock
Dominance_basicBlockDominator(const_Dominance this, const_BasicBlock basicBlock)
{
  const BasicBlock *blockMap = Dominance_BLOCKMAP(this);
  const int32_t *idomIdx = Dominance_IDOMIDX(this);
  int32_t idomIndex = idomIdx[BasicBlock_index(basicBlock)];
  return blockMap[idomIndex];
}

#line 849 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
const int32_t *
Dominance_preDFN(const_Dominance this)
{
  return Dominance_PREDFN(this);
}

#line 861 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
const int32_t *
Dominance_lastDFN(const_Dominance this)
{
  return Dominance_LASTDFN(this);
}

#line 873 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
const int32_t *
Dominance_treeLevel(const_Dominance this)
{
  return Dominance_TREELEVEL(this);
}

#line 886 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
BasicBlockStack_ *
Dominance_children(Dominance this)
{
  return Dominance_CHILDREN(this);
}

#line 908 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
const_BasicBlockStack
Dominance_basicBlockChildren(const_Dominance this, const_BasicBlock basicBlock)
{
  const_BasicBlockStack children = Dominance_CHILDREN(this);
  return children + BasicBlock_index(basicBlock);
}

#line 919 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
BasicBlock
Dominance_basicBlockIdom(Dominance this, BasicBlock block) {
  int32_t idomIndex = Dominance_IDOMIDX(this)[BasicBlock_index(block)];
  return idomIndex >=0? Dominance_blockMap(this)[idomIndex]: NULL;
}

#line 932 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
const BasicBlock *
Dominance_treeOrder(Dominance this)
{
  return Dominance_TREEORDER(this);
}

#line 975 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
PtrSet_ *
Dominance_frontiers(Dominance this)
{
  return Dominance_FRONTIERS(this);
}

#line 1000 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
PtrSet_ *
Dominance_mergeSets(Dominance this)
{
  return Dominance_MERGESETS(this);
}

#line 1036 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
bool
Dominance_dominates(const_Dominance this,
                    const_BasicBlock this_block,
                    const_BasicBlock that_block)
{
  const int32_t *preDFN = Dominance_PREDFN(this);
  const int32_t *lastDFN = Dominance_LASTDFN(this);
  int32_t this_index = BasicBlock_index(this_block);
  int32_t that_index = BasicBlock_index(that_block);
  return Dominance_DOMINATES(preDFN, lastDFN, this_index, that_index);
}

#line 1048 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1056 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
#ifndef ECL_NTRACE
bool
Dominance_pretty(Dominance this, FILE *file)
{
  CodeRegion codeRegion = Dominance_CODEREGION(this);
  int32_t *treeLevel = Dominance_TREELEVEL(this);
  if (file == NULL) file = stderr;
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    fprintf(file, "block_%d:", BasicBlock_index(basicBlock));
    if (Dominance_hasChildren(this)) {
      fprintf(file, "\tCHILDREN={");
      Dominance_BasicBlock_FORCHILDREN_BasicBlock(this, basicBlock, doms_block) {
        fprintf(file, " block_%d", BasicBlock_index(doms_block));
      } Dominance_BasicBlock_ENDCHILDREN_BasicBlock;
    }
    if (Dominance_hasFrontiers(this)) {
      fprintf(file, " }");
      fprintf(file, "\tFRONTIER={");
      Dominance_BasicBlock_FORFRONTIER_BasicBlock(this, basicBlock, frontier_block) {
        fprintf(file, " block_%d", BasicBlock_index(frontier_block));
      } Dominance_BasicBlock_ENDFRONTIER_BasicBlock;
    }
    if (Dominance_hasMergeSets(this)) {
      fprintf(file, " }");
      fprintf(file, "\tMERGESET={");
      Dominance_BasicBlock_FORMERGESET_BasicBlock(this, basicBlock, mergeset_block) {
        fprintf(file, " block_%d", BasicBlock_index(mergeset_block));
      } Dominance_BasicBlock_ENDMERGESET_BasicBlock;
    }
    fprintf(file, " }");
    if (Dominance_hasTreeOrder(this)) {
      fprintf(file, "\tTREELEVEL=%d", treeLevel[BasicBlock_index(basicBlock)]);
    }
    fprintf(file, "\n");
  } CodeRegion_ENDEACH_BasicBlock;
  if (Dominance_hasTreeOrder(this)) {
    fprintf(file, "treeOrder:");
    Dominance_FORDOWNLEVEL_BasicBlock(this, basicBlock) {
      fprintf(file, "\tblock_%d=>%d", BasicBlock_index(basicBlock),
              treeLevel[BasicBlock_index(basicBlock)]);
    } Dominance_ENDDOWNLEVEL_BasicBlock;
    fprintf(file, "\n");
  }
  return true;
}
#endif//ECL_NTRACE

#line 1411 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1423 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
#if XCC__C
static void
Dominance_TEST(void)
{
#include "PFA/Dominance_.c"
}

#line 1430 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
int
main(int argc, char **argv)
{
  PFA_Test(Dominance_TEST);
  return 0;
}
#endif


#endif//Dominance_c_INCLUDED
