#ifndef Dominance__c_INCLUDED
#define Dominance__c_INCLUDED

#line 189 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
//
{
  printf("sizeof(Dominance_) = %d\n", sizeof(Dominance_));
}

#line 1103 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
//
// Test forward Dominance_makeFrontiers.
{
  Symbol_ symbol_;
  Program program = Program_new(Memory_Root);
  Procedure procedure = Program_makeProcedure(program, &symbol_);
  // Example taken from "Computing Dominators and Dominance Frontiers" by
  // Preston Briggs and Tim Harvey, Technical Report, June 1994.
  BasicBlock block_1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_5 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_6 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_7 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_8 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_9 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_10 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_11 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_12 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_13 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_makeEdge(block_1, block_2, 0.0);
  BasicBlock_makeEdge(block_1, block_8, 0.0);
  BasicBlock_makeEdge(block_1, block_11, 0.0);
  BasicBlock_makeEdge(block_2, block_3, 0.0);
  BasicBlock_makeEdge(block_2, block_6, 0.0);
  BasicBlock_makeEdge(block_3, block_4, 0.0);
  BasicBlock_makeEdge(block_4, block_5, 0.0);
  BasicBlock_makeEdge(block_5, block_1, 0.0);
  BasicBlock_makeEdge(block_5, block_4, 0.0);
  BasicBlock_makeEdge(block_6, block_4, 0.0);
  BasicBlock_makeEdge(block_6, block_7, 0.0);
  BasicBlock_makeEdge(block_7, block_4, 0.0);
  BasicBlock_makeEdge(block_8, block_9, 0.0);
  BasicBlock_makeEdge(block_8, block_11, 0.0);
  BasicBlock_makeEdge(block_8, block_12, 0.0);
  BasicBlock_makeEdge(block_9, block_10, 0.0);
  BasicBlock_makeEdge(block_10, block_5, 0.0);
  BasicBlock_makeEdge(block_10, block_9, 0.0);
  BasicBlock_makeEdge(block_13, block_10, 0.0);
  BasicBlock_makeEdge(block_12, block_13, 0.0);
  BasicBlock_makeEdge(block_11, block_12, 0.0);
  Procedure_setEntryBlock(procedure, block_1);
  Procedure_buildCodeRegions(procedure);
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Dominance dom = Dominance_new(Memory_Root, codeRegion,
                                  DominanceFlag_Forward+
                                  DominanceFlag_TreeOrder+
                                  DominanceFlag_Frontiers+
                                  DominanceFlag_MergeSets);
    printf("Briggs-Harvey Forward:\n");
    Dominance_pretty(dom, stdout);
    CodeRegion_FOREACH_BasicBlock(codeRegion, this_block) {
      printf("block_%d dominates:", BasicBlock_index(this_block));
      CodeRegion_FOREACH_BasicBlock(codeRegion, that_block) {
        if (Dominance_dominates(dom, this_block, that_block)) {
          printf("\tblock_%d", BasicBlock_index(that_block));
        }
      } CodeRegion_ENDEACH_BasicBlock;
      printf("\n");
    } CodeRegion_ENDEACH_BasicBlock;
    Dominance_delete(dom);
  }
  Program_delete(program);
}

#line 1170 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
//
// Test forward Dominance_makeFrontiers.
{
  Symbol_ symbol_;
  Program program = Program_new(Memory_Root);
  Procedure procedure = Program_makeProcedure(program, &symbol_);
  // Figure 2 from "A Simple, Fast Dominance Algorithn" by Keith Cooper,
  // Timothy Harvey and Ken Kennedy, Softw. Oract. Exper. 2001.
  BasicBlock block_1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_5 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_makeEdge(block_5, block_4, 0.0);
  BasicBlock_makeEdge(block_5, block_3, 0.0);
  BasicBlock_makeEdge(block_4, block_1, 0.0);
  BasicBlock_makeEdge(block_3, block_2, 0.0);
  BasicBlock_makeEdge(block_2, block_1, 0.0);
  BasicBlock_makeEdge(block_1, block_2, 0.0);
  Procedure_setEntryBlock(procedure, block_5);
  Procedure_buildCodeRegions(procedure);
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Dominance dom = Dominance_new(Memory_Root, codeRegion,
                                  DominanceFlag_Forward+
                                  DominanceFlag_TreeOrder+
                                  DominanceFlag_Frontiers+
                                  DominanceFlag_MergeSets);
    printf("Cooper-Harvey-Kennedy Figure 2:\n");
    Dominance_pretty(dom, stdout);
    CodeRegion_FOREACH_BasicBlock(codeRegion, this_block) {
      printf("block_%d dominates:", BasicBlock_index(this_block));
      CodeRegion_FOREACH_BasicBlock(codeRegion, that_block) {
        if (Dominance_dominates(dom, this_block, that_block)) {
          printf("\tblock_%d", BasicBlock_index(that_block));
        }
      } CodeRegion_ENDEACH_BasicBlock;
      printf("\n");
    } CodeRegion_ENDEACH_BasicBlock;
    printf("post-order:\n");
    Dominance_FORCFGPOST_BasicBlock(dom, block) {
      printf("\tblock_%d", BasicBlock_index(block));
    } Dominance_ENDCFGPOST_BasicBlock;
    printf("\n");
    printf("reverse post-order:\n");
    Dominance_FORCFGRPO_BasicBlock(dom, block) {
      printf("\tblock_%d", BasicBlock_index(block));
    } Dominance_ENDCFGRPO_BasicBlock;
    printf("\n");
    Dominance_delete(dom);
  }
  Program_delete(program);
}

#line 1224 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
//
// Test forward Dominance_makeFrontiers.
{
  Symbol_ symbol_;
  Program program = Program_new(Memory_Root);
  Procedure procedure = Program_makeProcedure(program, &symbol_);
  // Figure 4 from "A Simple, Fast Dominance Algorithn" by Keith Cooper,
  // Timothy Harvey and Ken Kennedy, Softw. Oract. Exper. 2001.
  BasicBlock block_1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_5 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_6 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_makeEdge(block_6, block_5, 0.0);
  BasicBlock_makeEdge(block_6, block_4, 0.0);
  BasicBlock_makeEdge(block_5, block_1, 0.0);
  BasicBlock_makeEdge(block_4, block_3, 0.0);
  BasicBlock_makeEdge(block_4, block_2, 0.0);
  BasicBlock_makeEdge(block_3, block_2, 0.0);
  BasicBlock_makeEdge(block_2, block_3, 0.0);
  BasicBlock_makeEdge(block_2, block_1, 0.0);
  BasicBlock_makeEdge(block_1, block_2, 0.0);
  Procedure_setEntryBlock(procedure, block_6);
  Procedure_buildCodeRegions(procedure);
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Dominance dom = Dominance_new(Memory_Root, codeRegion,
                                  DominanceFlag_Forward+
                                  DominanceFlag_TreeOrder+
                                  DominanceFlag_Frontiers+
                                  DominanceFlag_MergeSets);
    printf("Cooper-Harvey-Kennedy Figure 4:\n");
    Dominance_pretty(dom, stdout);
    CodeRegion_FOREACH_BasicBlock(codeRegion, this_block) {
      printf("block_%d dominates:", BasicBlock_index(this_block));
      CodeRegion_FOREACH_BasicBlock(codeRegion, that_block) {
        if (Dominance_dominates(dom, this_block, that_block)) {
          printf("\tblock_%d", BasicBlock_index(that_block));
        }
      } CodeRegion_ENDEACH_BasicBlock;
      printf("\n");
    } CodeRegion_ENDEACH_BasicBlock;
    Dominance_delete(dom);
  }
  Program_delete(program);
}

#line 1272 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
//
// Test backward Dominance
{
  Symbol_ symbol_;
  Program program = Program_new(Memory_Root);
  Procedure procedure = Program_makeProcedure(program, &symbol_);
  // Example taken from "Computing Dominators and Dominators Frontiers" by
  // Preston Briggs and Tim Harvey, Technical Report, June 1994.
  BasicBlock block_1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_5 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_6 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_makeEdge(block_1, block_2, 0.0);
  BasicBlock_makeEdge(block_1, block_6, 0.0);
  BasicBlock_makeEdge(block_2, block_4, 0.0);
  BasicBlock_makeEdge(block_2, block_3, 0.0);
  BasicBlock_makeEdge(block_3, block_5, 0.0);
  BasicBlock_makeEdge(block_4, block_5, 0.0);
  BasicBlock_makeEdge(block_5, block_6, 0.0);
  Procedure_setExitBlock(procedure, block_6);
  Procedure_buildCodeRegions(procedure);
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Dominance dom = Dominance_new(Memory_Root, codeRegion,
                                  DominanceFlag_Backward+
                                  DominanceFlag_TreeOrder+
                                  DominanceFlag_Frontiers+
                                  DominanceFlag_MergeSets);
    printf("Briggs-Harvey Backward:\n");
    Dominance_pretty(dom, stdout);
    CodeRegion_FOREACH_BasicBlock(codeRegion, this_block) {
      printf("block_%d dominates:", BasicBlock_index(this_block));
      CodeRegion_FOREACH_BasicBlock(codeRegion, that_block) {
        if (Dominance_dominates(dom, this_block, that_block)) {
          printf("\tblock_%d", BasicBlock_index(that_block));
        }
      } CodeRegion_ENDEACH_BasicBlock;
      printf("\n");
    } CodeRegion_ENDEACH_BasicBlock;
    Dominance_delete(dom);
  }
  Program_delete(program);
}

#line 1318 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Dominance.xcc"
//
// Test forward Dominance_makeFrontiers.
{
  Symbol_ symbol_;
  Program program = Program_new(Memory_Root);
  Procedure procedure = Program_makeProcedure(program, &symbol_);
  // Example taken from "A Practical and Fast Iterative Algorithm for PHI-
  // Function Computation Using DJ Graphs", D. DAS, U. Ramakrishna, TOPLAS 27, 3.
  BasicBlock block_1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_5 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_6 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_7 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_8 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_9 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_10 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_11 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_12 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_13 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_14 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_15 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_16 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_17 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_18 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_19 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_20 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_21 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_22 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_23 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_makeEdge(block_2, block_3, 0.0);
  BasicBlock_makeEdge(block_3, block_4, 0.0);
  BasicBlock_makeEdge(block_3, block_5, 0.0);
  BasicBlock_makeEdge(block_3, block_8, 0.0);
  BasicBlock_makeEdge(block_3, block_23, 0.0);
  BasicBlock_makeEdge(block_4, block_5, 0.0);
  BasicBlock_makeEdge(block_5, block_6, 0.0);
  BasicBlock_makeEdge(block_5, block_7, 0.0);
  BasicBlock_makeEdge(block_6, block_7, 0.0);
  BasicBlock_makeEdge(block_7, block_5, 0.0);
  BasicBlock_makeEdge(block_7, block_8, 0.0);
  BasicBlock_makeEdge(block_8, block_9, 0.0);
  BasicBlock_makeEdge(block_8, block_10, 0.0);
  BasicBlock_makeEdge(block_8, block_14, 0.0);
  BasicBlock_makeEdge(block_9, block_10, 0.0);
  BasicBlock_makeEdge(block_10, block_11, 0.0);
  BasicBlock_makeEdge(block_11, block_12, 0.0);
  BasicBlock_makeEdge(block_12, block_13, 0.0);
  //BasicBlock_makeEdge(block_13, block_1, 0.0);
  BasicBlock_makeEdge(block_14, block_15, 0.0);
  BasicBlock_makeEdge(block_14, block_16, 0.0);
  BasicBlock_makeEdge(block_15, block_16, 0.0);
  BasicBlock_makeEdge(block_16, block_17, 0.0);
  BasicBlock_makeEdge(block_16, block_22, 0.0);
  BasicBlock_makeEdge(block_17, block_18, 0.0);
  BasicBlock_makeEdge(block_17, block_21, 0.0);
  BasicBlock_makeEdge(block_18, block_19, 0.0);
  BasicBlock_makeEdge(block_18, block_20, 0.0);
  BasicBlock_makeEdge(block_19, block_20, 0.0);
  BasicBlock_makeEdge(block_20, block_18, 0.0);
  BasicBlock_makeEdge(block_20, block_21, 0.0);
  BasicBlock_makeEdge(block_21, block_22, 0.0);
  BasicBlock_makeEdge(block_22, block_10, 0.0);
  BasicBlock_makeEdge(block_23, block_5, 0.0);
  BasicBlock_makeEdge(block_23, block_8, 0.0);
  Procedure_setEntryBlock(procedure, block_1);
  Procedure_setEntryBlock(procedure, block_2);
  Procedure_buildCodeRegions(procedure);
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Dominance dom = Dominance_new(Memory_Root, codeRegion,
                                  DominanceFlag_Forward+
                                  DominanceFlag_TreeOrder+
                                  DominanceFlag_Frontiers+
                                  DominanceFlag_MergeSets);
    printf("Das-Ramakrishna Forward:\n");
    Dominance_pretty(dom, stdout);
    //CodeRegion_pretty(codeRegion, stdout);
    CodeRegion_FOREACH_BasicBlock(codeRegion, this_block) {
      printf("block_%d dominates:", BasicBlock_index(this_block));
      CodeRegion_FOREACH_BasicBlock(codeRegion, that_block) {
        if (Dominance_dominates(dom, this_block, that_block)) {
          printf("\tblock_%d", BasicBlock_index(that_block));
        }
      } CodeRegion_ENDEACH_BasicBlock;
      printf("\n");
    } CodeRegion_ENDEACH_BasicBlock;
    Dominance_delete(dom);
  }
  Program_delete(program);
}


#endif//Dominance__c_INCLUDED
