#ifndef LiveCheck__c_INCLUDED
#define LiveCheck__c_INCLUDED

#line 185 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LiveCheck.xcc"
//
{
  printf("sizeof(LiveCheck_) = %d\n", sizeof(LiveCheck_));
}

#line 1583 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LiveCheck.xcc"
//
{
  // Run LiveCheck_check() on a simple if hammock.
  // Figure 1 in Sreedhar's paper.
  Program program = Program_new(Memory_Root);
  SymbolTable symbolTable = Program_symbolTable(program);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "sreedhar-figure-1");
  Procedure procedure = Program_makeProcedure(program, symbol);
  LabelTable labelTable = Program_labelTable(program);
  Label L1 = LabelTable_lookup(labelTable, 1, "L1");
  Label L2 = LabelTable_lookup(labelTable, 2, "L2");
  Label L3 = LabelTable_lookup(labelTable, 3, "L3");
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  BasicBlock_addLabels(block_l2, 1, &L2);
  BasicBlock_addLabels(block_l3, 1, &L3);
  BasicBlock_makeEdge(block_l1, block_l2, 0.0);
  BasicBlock_makeEdge(block_l1, block_l3, 0.0);
  BasicBlock_makeEdge(block_l2, block_l3, 0.0);
  Procedure_buildCodeRegions(procedure);
  printf("\nFigure 1 in Sreedhar's paper:\n");
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Temporary temporary_null = Procedure_makeAssignedTemporary(procedure, Register__UNDEF);
    Temporary temporary_x = Procedure_makeVirtualTemporary(procedure, 1);
    Temporary temporary_y = Procedure_makeVirtualTemporary(procedure, 1);
    Temporary temporary_a1 = Procedure_makeAbsoluteTemporary(procedure, 1, Relocation__UNDEF);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_x, temporary_a1);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_y, temporary_a1);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l2), temporary_x, temporary_y);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                               Operator_APPLY, temporary_null, temporary_x);
    {
      LiveCheck liveCheck;
      Coalescer_ coalescer[1];
      SSAForm ssaForm = SSAForm_construct(Memory_Root, codeRegion, true);
      Dominance dominance = SSAForm_DOMINANCE(ssaForm);
      TemporaryTable_empty(CodeRegion_globalTable(codeRegion));
      SSAForm_fillTemporaryTable(ssaForm, CodeRegion_globalTable(codeRegion));
      CodeRegion_makeConsumers(codeRegion, CodeRegion_globalTable(codeRegion));
      SSAForm_makeOrderings(ssaForm, 4);
#if !ECL_OPTIMIZE
      LiveCheck_LIVENESS = 2;
#endif//ECL_OPTIMIZE
      Coalescer_Ctor(coalescer, Memory_Root, codeRegion,
                     CodeRegion_globalTable(codeRegion), dominance, OptimizeCoalescing_Sreedhar);
      Coalescer_complete(coalescer);
      liveCheck = Coalescer_LIVECHECK(coalescer);
#ifndef ECL_NTRACE
      if (LiveCheck_TRACE) LiveCheck_dumpCFG(liveCheck);
#endif
      LiveCheck_checkLiveness(liveCheck);
      Coalescer_Dtor(coalescer);
      SSAForm_destruct(ssaForm);
    }
  }
  Program_delete(program);
}

#line 1646 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LiveCheck.xcc"
//
{
  // Run Livecheck_check().
  // Figure 3 in Boissinot's CGO paper.
  Program program = Program_new(Memory_Root);
  Optimize optimize = Program_optimize(program);
  SymbolTable symbolTable = Program_symbolTable(program);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "boissinot-figure-3");
  Procedure procedure = Program_makeProcedure(program, symbol);
  LabelTable labelTable = Program_labelTable(program);
  Label L1 = LabelTable_lookup(labelTable, 1, "L1");
  Label L2 = LabelTable_lookup(labelTable, 2, "L2");
  Label L3 = LabelTable_lookup(labelTable, 3, "L3");
  Label L4 = LabelTable_lookup(labelTable, 4, "L4");
  Label L5 = LabelTable_lookup(labelTable, 5, "L5");
  Label L6 = LabelTable_lookup(labelTable, 6, "L6");
  Label L7 = LabelTable_lookup(labelTable, 7, "L7");
  Label L8 = LabelTable_lookup(labelTable, 8, "L8");
  Label L9 = LabelTable_lookup(labelTable, 9, "L9");
  Label L10 = LabelTable_lookup(labelTable, 10, "L10");
  Label L11 = LabelTable_lookup(labelTable, 11, "L11");
  Label LEXIT = LabelTable_lookup(labelTable, 12, "Lexit");
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l5 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l6 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l7 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l8 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l9 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l10 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l11 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_lexit = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  BasicBlock_addLabels(block_l2, 1, &L2);
  BasicBlock_addLabels(block_l3, 1, &L3);
  BasicBlock_addLabels(block_l4, 1, &L4);
  BasicBlock_addLabels(block_l5, 1, &L5);
  BasicBlock_addLabels(block_l6, 1, &L6);
  BasicBlock_addLabels(block_l7, 1, &L7);
  BasicBlock_addLabels(block_l8, 1, &L8);
  BasicBlock_addLabels(block_l9, 1, &L9);
  BasicBlock_addLabels(block_l10, 1, &L10);
  BasicBlock_addLabels(block_l11, 1, &L11);
  BasicBlock_addLabels(block_lexit, 1, &LEXIT);
  BasicBlock_makeEdge(block_l1, block_l2, 0.0);
  BasicBlock_makeEdge(block_l2, block_l3, 0.0);
  BasicBlock_makeEdge(block_l3, block_l4, 0.0);
  BasicBlock_makeEdge(block_l4, block_l5, 0.0);
  BasicBlock_makeEdge(block_l5, block_l6, 0.0);
  BasicBlock_makeEdge(block_l6, block_l5, 0.0);
  BasicBlock_makeEdge(block_l6, block_l7, 0.0);
  BasicBlock_makeEdge(block_l7, block_l2, 0.0);
  BasicBlock_makeEdge(block_l7, block_lexit, 0.0);
  BasicBlock_makeEdge(block_l3, block_l8, 0.0);
  BasicBlock_makeEdge(block_l8, block_l9, 0.0);
  BasicBlock_makeEdge(block_l9, block_l6, 0.0);
  BasicBlock_makeEdge(block_l9, block_l10, 0.0);
  BasicBlock_makeEdge(block_l10, block_l8, 0.0);
  BasicBlock_makeEdge(block_l2, block_l11, 0.0);
  BasicBlock_makeEdge(block_l11, block_lexit, 0.0);
  Procedure_buildCodeRegions(procedure);
  *Optimize__CONVERSION(optimize) |= OptimizeConversion_Cleaning;
  printf("\nFigure 3 in Boissinot's CGO paper:\n");
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Temporary temporary_null = Procedure_makeAssignedTemporary(procedure, Register__UNDEF);
    Temporary temporary_w = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_x = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_y = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_z = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_a1 = Procedure_makeAbsoluteTemporary(procedure, 1, Relocation__UNDEF);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                               Operator_APPLY, temporary_w, temporary_a1);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                               Operator_APPLY, temporary_x, temporary_a1);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                               Operator_APPLY, temporary_y, temporary_a1);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l4),
                               Operator_APPLY, temporary_null, temporary_w);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l5),
                               Operator_APPLY, temporary_null, temporary_y);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l9),
                               Operator_APPLY, temporary_null, temporary_x);
    {
      LiveCheck liveCheck;
      Coalescer_ coalescer[1];
      SSAForm ssaForm = SSAForm_construct(Memory_Root, codeRegion, true);
      Dominance dominance = SSAForm_DOMINANCE(ssaForm);
      TemporaryTable_empty(CodeRegion_globalTable(codeRegion));
      SSAForm_fillTemporaryTable(ssaForm, CodeRegion_globalTable(codeRegion));
      CodeRegion_makeConsumers(codeRegion, CodeRegion_globalTable(codeRegion));
      SSAForm_makeOrderings(ssaForm, 4);
#if !ECL_OPTIMIZE
      LiveCheck_LIVENESS = 2;
#endif//ECL_OPTIMIZE
      Coalescer_Ctor(coalescer, Memory_Root, codeRegion, CodeRegion_globalTable(codeRegion), dominance, OptimizeCoalescing_Sreedhar);
      Coalescer_complete(coalescer);
      liveCheck = Coalescer_LIVECHECK(coalescer);
#ifndef ECL_NTRACE
      if (LiveCheck_TRACE) LiveCheck_dumpCFG(liveCheck);
#endif
      LiveCheck_checkLiveness(liveCheck);
      Coalescer_Dtor(coalescer);
      SSAForm_destruct(ssaForm);
    }
  }
  Program_delete(program);
}

#line 1757 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LiveCheck.xcc"
//
{
  // Run Livecheck_check().
  // Figure 1 in Boissinot's presentation.
  Program program = Program_new(Memory_Root);
  SymbolTable symbolTable = Program_symbolTable(program);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "boissinot-presentation-1");
  Procedure procedure = Program_makeProcedure(program, symbol);
  Optimize optimize = Program_optimize(program);
  LabelTable labelTable = Program_labelTable(program);
  Label LE = LabelTable_lookup(labelTable, 1, "LE");
  Label L0 = LabelTable_lookup(labelTable, 2, "L0");
  Label L1 = LabelTable_lookup(labelTable, 3, "L1");
  Label L2 = LabelTable_lookup(labelTable, 4, "L2");
  Label L3 = LabelTable_lookup(labelTable, 5, "L3");
  Label L4 = LabelTable_lookup(labelTable, 6, "L4");
  Label L5 = LabelTable_lookup(labelTable, 7, "L5");
  Label L6 = LabelTable_lookup(labelTable, 8, "L6");
  Label L7 = LabelTable_lookup(labelTable, 9, "L7");
  Label L8 = LabelTable_lookup(labelTable, 10, "L8");
  Label L9 = LabelTable_lookup(labelTable, 11, "L9");
  Label LEXIT = LabelTable_lookup(labelTable, 12, "Lexit");
  BasicBlock block_le = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l0 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l5 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l6 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l7 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l8 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l9 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_lexit = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_addLabels(block_le, 0, &LE);
  BasicBlock_addLabels(block_l0, 1, &L0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  BasicBlock_addLabels(block_l2, 1, &L2);
  BasicBlock_addLabels(block_l3, 1, &L3);
  BasicBlock_addLabels(block_l4, 1, &L4);
  BasicBlock_addLabels(block_l5, 1, &L5);
  BasicBlock_addLabels(block_l6, 1, &L6);
  BasicBlock_addLabels(block_l7, 1, &L7);
  BasicBlock_addLabels(block_l8, 1, &L8);
  BasicBlock_addLabels(block_l9, 1, &L9);
  BasicBlock_addLabels(block_lexit, 1, &LEXIT);
  BasicBlock_makeEdge(block_le, block_l0, 0.0);
  BasicBlock_makeEdge(block_l0, block_l1, 0.0);
  BasicBlock_makeEdge(block_l1, block_l2, 0.0);
  BasicBlock_makeEdge(block_l2, block_l3, 0.0);
  BasicBlock_makeEdge(block_l3, block_l2, 0.0);
  BasicBlock_makeEdge(block_l3, block_l4, 0.0);
  BasicBlock_makeEdge(block_l4, block_l0, 0.0);
  BasicBlock_makeEdge(block_l4, block_lexit, 0.0);
  BasicBlock_makeEdge(block_l1, block_l5, 0.0);
  BasicBlock_makeEdge(block_l5, block_l6, 0.0);
  BasicBlock_makeEdge(block_l6, block_l7, 0.0);
  BasicBlock_makeEdge(block_l7, block_l5, 0.0);
  BasicBlock_makeEdge(block_l7, block_l8, 0.0);
  BasicBlock_makeEdge(block_l8, block_l3, 0.0);
  BasicBlock_makeEdge(block_l8, block_l6, 0.0);
  BasicBlock_makeEdge(block_l0, block_l9, 0.0);
  BasicBlock_makeEdge(block_l9, block_lexit, 0.0);
  Procedure_buildCodeRegions(procedure);
  *Optimize__CONVERSION(optimize) |= OptimizeConversion_Cleaning;
  printf("\nFigure 1 in Boissinot's presentation:\n");
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Temporary temporary_null = Procedure_makeAssignedTemporary(procedure, Register__UNDEF);
    Temporary temporary_x = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_y = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_z = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_a1 = Procedure_makeAbsoluteTemporary(procedure, 1, Relocation__UNDEF);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_x, temporary_a1);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_y, temporary_a1);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l2),
                               Operator_APPLY, temporary_null, temporary_y);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l6),
                               Operator_APPLY, temporary_null, temporary_x);
    {
      LiveCheck liveCheck;
      Coalescer_ coalescer[1];
      SSAForm ssaForm = SSAForm_construct(Memory_Root, codeRegion, true);
      Dominance dominance = SSAForm_DOMINANCE(ssaForm);
      TemporaryTable_empty(CodeRegion_globalTable(codeRegion));
      SSAForm_fillTemporaryTable(ssaForm, CodeRegion_globalTable(codeRegion));
      CodeRegion_makeConsumers(codeRegion, CodeRegion_globalTable(codeRegion));
      SSAForm_makeOrderings(ssaForm, 4);
#if !ECL_OPTIMIZE
      LiveCheck_LIVENESS = 2;
#endif//ECL_OPTIMIZE
      Coalescer_Ctor(coalescer, Memory_Root, codeRegion, CodeRegion_globalTable(codeRegion), dominance, OptimizeCoalescing_Sreedhar);
      Coalescer_complete(coalescer);
      liveCheck = Coalescer_LIVECHECK(coalescer);
#ifndef ECL_NTRACE
      if (LiveCheck_TRACE) LiveCheck_dumpCFG(liveCheck);
#endif
      LiveCheck_checkLiveness(liveCheck);
      Coalescer_Dtor(coalescer);
      SSAForm_destruct(ssaForm);
    }
  }
  Program_delete(program);
}


#endif//LiveCheck__c_INCLUDED
