#ifndef Liveness_c_INCLUDED
#define Liveness_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
#include "PFA/PFA_.h"

#line 21 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 38 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
LivenessState
LivenessState_Ctor(LivenessState this,
                   Memory memory, int32_t temporaryCount,
                   TemporarySet liveInSet, TemporarySet liveOutSet)
{
  *LivenessState__BASICBLOCK(this) = NULL;
  *LivenessState__ISLISTED(this) = false;
  *LivenessState__WORKNEXT(this) = NULL;
  TemporarySet_Ctor(LivenessState_USEINSET(this), memory, temporaryCount);
  TemporarySet_Ctor(LivenessState_KILLEDSET(this), memory, temporaryCount);
  *LivenessState__LIVEINSET(this) = liveInSet;
  *LivenessState__LIVEOUTSET(this) = liveOutSet;
  return this;
}

#line 53 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
void
LivenessState_Dtor(LivenessState this)
{
  TemporarySet_Dtor(LivenessState_USEINSET(this));
  TemporarySet_Dtor(LivenessState_KILLEDSET(this));
}

#line 65 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 79 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
void
LivenessState_analyzeOperations(LivenessState this,
                                TemporarySparse useInSparse,
                                struct Temporary_ dedicated[])
{
  TemporarySet useInSet = LivenessState_USEINSET(this);
  TemporarySet killedSet = LivenessState_KILLEDSET(this);
  BasicBlock basicBlock = LivenessState_BASICBLOCK(this);
  TemporaryTable temporaryTable = TemporarySparse_table(useInSparse);
  BasicBlock_FORBACK_Operation(basicBlock, operation) {
    RegisterSet clobberSet = Operation_clobberSet(operation);
    // Operation results.
    Operation_RESULTS_FOREACH_Temporary(operation, result) {
      if (Temporary_hasRegister(result)) {
        result = dedicated + Temporary_REGISTER(result);
      }
      if (TemporaryTable_contains(temporaryTable, result)) {
        if (Operation_isPartialDef(operation)) {
          TemporarySparse_insert(useInSparse, result);
        } else {
          TemporarySet_addMember(killedSet, result);
          TemporarySparse_remove(useInSparse, result);
        }
      }
    } Operation_RESULTS_ENDEACH_Temporary;
    // Operation clobbers.
    if (clobberSet != NULL) {
      RegisterSet_FOREACH_Register(clobberSet, registre) {
        Temporary clobbered = dedicated + registre;
        if (TemporaryTable_contains(temporaryTable, clobbered)) {
          TemporarySet_addMember(killedSet, clobbered);
          TemporarySparse_remove(useInSparse, clobbered);
        }
      } RegisterSet_ENDEACH_Register;
    }
    if (!Operator_isPhi(Operation_operator(operation))) {
      // Operation arguments for non-PHI operations.
      Operation_ARGUMENTS_FOREACH_Temporary(operation, argument) {
        if (Temporary_hasRegister(argument)) {
          argument = dedicated + Temporary_REGISTER(argument);
        }
        if (TemporaryTable_contains(temporaryTable, argument)) {
          TemporarySparse_insert(useInSparse, argument);
        }
      } Operation_ARGUMENTS_ENDEACH_Temporary;
    }
  } BasicBlock_ENDBACK_Operation;
  // Transfer the contents of useInSparse to LivenessState_USEINSET.
  TemporarySparse_FOREACH_Temporary(useInSparse, temporary) {
    TemporarySet_addMember(LivenessState_USEINSET(this), temporary);
  } TemporarySparse_ENDEACH_Temporary;
  // Reorder KILLEDSET and USEINSET for normal TemporarySet operation.
  TemporarySet_makeOrder(killedSet);
  TemporarySet_makeOrder(useInSet);
0 &&
  PFA_TRACE && fprintf(PFA_TRACE, "*** LOCAL Block_%d", BasicBlock_index(basicBlock))
            && fprintf(PFA_TRACE, "\tuseInSet={ ")
            && TemporarySet_pretty(useInSet, PFA_TRACE)
            && fprintf(PFA_TRACE, "}\tkilledSet={ ")
            && TemporarySet_pretty(killedSet, PFA_TRACE)
            && fprintf(PFA_TRACE, "}\n");
}

#line 142 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
/*
 * LivenessState_countLiveOutSet --	The count of the LIVEOUTSET Set.
 *
 * This is used to see if more iterations of the data-flow are required.
 */
static inline int32_t
LivenessState_countLiveOutSet(LivenessState this)
{
  return TemporarySet_count(LivenessState_LIVEOUTSET(this));
}

#line 159 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
#ifndef ECL_NTRACE
bool
LivenessState_pretty(LivenessState this, FILE *file)
{
  if (file == NULL) file = stderr;
  fprintf(file, "\tliveInSet:\t");
  TemporarySet_pretty(LivenessState_LIVEINSET(this), file);
  fprintf(file, "\n\tliveOutSet:\t");
  TemporarySet_pretty(LivenessState_LIVEOUTSET(this), file);
  fprintf(file, "\n\tkilledSet:\t");
  TemporarySet_pretty(LivenessState_KILLEDSET(this), file);
  fprintf(file, "\n\tuseInSet:\t");
  TemporarySet_pretty(LivenessState_USEINSET(this), file);
  fprintf(file, "\n");
  return true;
}
#endif//ECL_NTRACE

#line 177 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 208 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
Liveness
Liveness_Ctor(Liveness this,
              Memory memory, CodeRegion codeRegion,
              TemporaryTable temporaryTable, bool phiSets)
{
  int32_t blockCount = CodeRegion_blockCount(codeRegion);
  Procedure procedure = CodeRegion_procedure(codeRegion);
  Temporary_ *dedicated = Procedure_dedicated(procedure);
  size_t StatesSize = blockCount*sizeof(LivenessState_);
  size_t liveSetsSize = blockCount*sizeof(TemporarySet_);
  LivenessState_ *baseState = Memory_alloc(memory, StatesSize);
  TemporarySet_ *liveInSets = Memory_alloc(memory, liveSetsSize);
  TemporarySet_ *liveOutSets = Memory_alloc(memory, liveSetsSize);
  int32_t temporaryCount = TemporaryTable_count(temporaryTable), index;
  PFA_TRACE && fprintf(PFA_TRACE, "*** Liveness\tphiSets=%d\n", phiSets);
  *Liveness__MEMORY(this) = memory;
  *Liveness__CODEREGION(this) = codeRegion;
  *Liveness__DEDICATED(this) = dedicated;
  *Liveness__ITERCOUNT(this) = 0;
  *Liveness__BLOCKCOUNT(this) = blockCount;
  *Liveness__BASESTATE(this) = baseState;
  *Liveness__LIVEINSETS(this) = liveInSets;
  *Liveness__LIVEOUTSETS(this) = liveOutSets;
  *Liveness__PHIINSETS(this) = NULL;
  *Liveness__PHIOUTSETS(this) = NULL;
  *Liveness__WORKTAIL(this) = NULL;
  *Liveness__WORKHEAD(this) = NULL;
  TemporarySparse_Ctor(Liveness_SPARSESET(this), memory, temporaryTable);
  for (index = 0; index < blockCount; index++) {
    TemporarySet liveInSet = liveInSets + index;
    TemporarySet liveOutSet = liveOutSets + index;
    TemporarySet_Ctor(liveInSet, memory, temporaryCount);
    TemporarySet_Ctor(liveOutSet, memory, temporaryCount);
    LivenessState_Ctor(baseState + index, memory, temporaryCount, liveInSet, liveOutSet);
  }
  if (phiSets) {
    // Allocate and initialize the PHIINSETS and PHIOUTSETS.
    size_t liveSetsSize = blockCount*sizeof(TemporarySet_);
    TemporarySet_ *phiInSets = Memory_alloc(memory, liveSetsSize);
    TemporarySet_ *phiOutSets = Memory_alloc(memory, liveSetsSize);
    for (index = 0; index < blockCount; index++) {
      TemporarySet phiInSet = phiInSets + index;
      TemporarySet phiOutSet = phiOutSets + index;
      TemporarySet_Ctor(phiInSet, memory, temporaryCount);
      TemporarySet_Ctor(phiOutSet, memory, temporaryCount);
    }
    *Liveness__PHIINSETS(this) = phiInSets;
    *Liveness__PHIOUTSETS(this) = phiOutSets;
  }
  // Nullify dedicated if must skip local analysis.
  if (temporaryCount == 0) {
    *Liveness__DEDICATED(this) = NULL;
  }
  Liveness_activateState(this, CodeRegion_rootBlock(codeRegion), phiSets);
  //PFA_TRACE && fprintf(PFA_TRACE, "\n");
  Liveness_doIterate(this);
  if (phiSets) {
    // Fill the PHIINSETS with the Phi results.
    TemporarySet_ *phiInSets = Liveness_PHIINSETS(this);
    Liveness_FOREACH_LivenessState(this, state) {
      BasicBlock basicBlock = LivenessState_BASICBLOCK(state);
      TemporarySet phiInSet = phiInSets + BasicBlock_index(basicBlock);
      if (BasicBlock_phiCount(basicBlock) != 0) {
        BasicBlock_FOREACH_Operation(basicBlock, operation) {
          if (Operator_isPhi(Operation_operator(operation))) {
            Temporary result = Operation_getResult(operation, 0);
            if (Temporary_hasRegister(result)) {
              result = dedicated + Temporary_REGISTER(result);
            }
            if (TemporaryTable_contains(temporaryTable, result)) {
              TemporarySet_addMember(phiInSet, result);
            }
          } else break;
        } BasicBlock_ENDEACH_Operation;
      }
      TemporarySet_makeOrder(phiInSet);
    } Liveness_ENDEACH_LivenessState;
  }
  PFA_TRACE && fprintf(PFA_TRACE, "*** Liveness\tBLOCKCOUNT=%d\tITERCOUNT=%d\n",
                       Liveness_BLOCKCOUNT(this), Liveness_ITERCOUNT(this));
  return this;
}

#line 291 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
void
Liveness_Dtor(Liveness this)
{
  Memory memory = Liveness_MEMORY(this);
  CodeRegion codeRegion = Liveness_CODEREGION(this);
  int32_t blockCount = Liveness_BLOCKCOUNT(this), index;
  LivenessState_ *baseState = Liveness_BASESTATE(this);
  TemporarySet_ *liveInSets = Liveness_LIVEINSETS(this);
  TemporarySet_ *liveOutSets = Liveness_LIVEOUTSETS(this);
  TemporarySet_ *phiInSets = Liveness_PHIINSETS(this);
  TemporarySet_ *phiOutSets = Liveness_PHIOUTSETS(this);
  if (baseState != NULL) {
    for (index = 0; index < blockCount; index++) {
      TemporarySet_Dtor(liveInSets + index);
      TemporarySet_Dtor(liveOutSets + index);
      LivenessState_Dtor(baseState + index);
      if (phiInSets != NULL) TemporarySet_Dtor(phiInSets + index);
      if (phiOutSets != NULL) TemporarySet_Dtor(phiOutSets + index);
    }
    Memory_free_(memory, baseState);
    Memory_free_(memory, liveInSets);
    Memory_free_(memory, liveOutSets);
    if (phiInSets != NULL) Memory_free_(memory, phiInSets);
    if (phiOutSets != NULL) Memory_free_(memory, phiOutSets);
  }
  TemporarySparse_Dtor(Liveness_SPARSESET(this));
}

#line 319 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
size_t
Liveness_Size(Memory memory, CodeRegion codeRegion,
              TemporaryTable temporaryTable, bool phiSets)
{
  return sizeof(Liveness_);
}

#line 335 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
#ifndef Liveness_POOLED
#define Liveness_POOLED 128
#endif//Liveness_POOLED

#line 339 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
Liveness
Liveness_make(Memory parent, CodeRegion codeRegion, TemporaryTable temporaryTable, bool phiSets)
{
  Memory memory = Memory_new(parent, Liveness_POOLED);
  size_t size = Liveness_Size(memory, codeRegion, temporaryTable, phiSets);
  Liveness this = Memory_alloc(memory, size);
  Liveness_Ctor(this, memory, codeRegion, temporaryTable, phiSets);
  CodeRegion_setLiveSets(codeRegion,
                         Liveness_BLOCKCOUNT(this),
                         Liveness_LIVEINSETS(this),
                         Liveness_LIVEOUTSETS(this),
                         Liveness_PHIINSETS(this),
                         Liveness_PHIOUTSETS(this));
  return this;
}

#line 359 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
Liveness
Liveness_kill(Liveness this)
{
  if (this != NULL) {
    Memory memory = Liveness_MEMORY(this);
    CodeRegion codeRegion = Liveness_CODEREGION(this);
    CodeRegion_resetLiveSets(codeRegion);
#ifndef ECL_NDTOR
    Liveness_Dtor(this);
    Memory_free_(memory, this);
#endif//ECL_NDTOR
    Memory_delete(memory);
  }
  return NULL;
}

#line 375 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 383 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
Memory
Liveness_memory(const_Liveness this)
{
  return Liveness_MEMORY(this);
}

#line 395 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
int32_t
Liveness_blockCount(const_Liveness this)
{
  return Liveness_BLOCKCOUNT(this);
}

#line 407 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
TemporarySet_ *
Liveness_liveInSets(const_Liveness this)
{
  return Liveness_LIVEINSETS(this);
}

#line 419 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
TemporarySet_ *
Liveness_liveOutSets(const_Liveness this)
{
  return Liveness_LIVEOUTSETS(this);
}

#line 431 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
TemporarySet_ *
Liveness_phiInSets(const_Liveness this)
{
  return Liveness_PHIINSETS(this);
}

#line 443 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
TemporarySet_ *
Liveness_phiOutSets(const_Liveness this)
{
  return Liveness_PHIOUTSETS(this);
}

#line 455 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
LivenessState_ *
Liveness_baseState(const_Liveness this)
{
  return Liveness_BASESTATE(this);
}

#line 481 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
#ifndef ECL_NTRACE
bool
Liveness_pretty(Liveness this, FILE *file)
{
  if (file == NULL) file = stderr;
  Liveness_FOREACH_LivenessState(this, state) {
    BasicBlock basicBlock = LivenessState_BASICBLOCK(state);
    fprintf(file, "    block_%d:", BasicBlock_index(basicBlock));
    BasicBlock_LEAVE_FOREACH_BasicBlockEdge(basicBlock, edge) {
      BasicBlock succ_block = BasicBlockEdge_destBlock(edge);
      fprintf(file, "\tblock_%d", BasicBlock_index(succ_block));
    } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
    LivenessState_pretty(state, file);
    fprintf(file, "\n");
  } Liveness_ENDEACH_LivenessState;
  return true;
}
#endif//ECL_NTRACE

#line 500 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
static inline LivenessState
Liveness_workTail(Liveness this)
{
  return Liveness_WORKTAIL(this);
}

#line 506 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
static inline LivenessState
Liveness_workHead(Liveness this)
{
  return Liveness_WORKHEAD(this);
}

#line 512 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
static inline bool
Liveness_workIsEmpty(Liveness this)
{
  return Liveness_WORKTAIL(this) == NULL;
}

#line 518 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
// Push state at head of worklist.
static inline void
Liveness_workPush(Liveness this, LivenessState state)
{
  LivenessState workHead = Liveness_WORKHEAD(this);
  Except_CHECK(LivenessState_WORKNEXT(state) == NULL);
  if (workHead == NULL) {
    *Liveness__WORKTAIL(this) = state;
  } else {
    *LivenessState__WORKNEXT(state) = workHead;
  }
  *Liveness__WORKHEAD(this) = state;
}

#line 532 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
// Put state at tail of worklist.
static inline void
Liveness_workPut(Liveness this, LivenessState state)
{
  LivenessState workTail = Liveness_WORKTAIL(this);
  Except_CHECK(LivenessState_WORKNEXT(state) == NULL);
  *Liveness__WORKTAIL(this) = state;
  if (workTail == NULL) {
    *Liveness__WORKHEAD(this) = state;
  } else {
    *LivenessState__WORKNEXT(workTail) = state;
  }
}

#line 546 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
// Pop state at head of worklist.
static inline void
Liveness_workPop(Liveness this)
{
  LivenessState workTail = Liveness_WORKTAIL(this);
  LivenessState workHead = Liveness_WORKHEAD(this);
  if (workTail == workHead) {
    *Liveness__WORKTAIL(this) = *Liveness__WORKHEAD(this) = NULL;
  } else {
    *Liveness__WORKHEAD(this) = LivenessState_WORKNEXT(workHead);
  }
  *LivenessState__WORKNEXT(workHead) = NULL;
}

#line 579 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
void
Liveness_activateState(Liveness this, BasicBlock curr_block, bool phiSets)
{
  Temporary_ *dedicated = Liveness_DEDICATED(this);
  LivenessState_ *baseState = Liveness_BASESTATE(this);
  int32_t curr_index = BasicBlock_index(curr_block);
  LivenessState curr_state = baseState + curr_index;
  Except_CHECK(BasicBlock_index(curr_block) >= 0);
  // Forward DFS inside the CodeRegion.
  *LivenessState__BASICBLOCK(curr_state) = curr_block;
  *LivenessState__ISLISTED(curr_state) = true;
  // Local liveness analysis.
  if (dedicated != NULL) {
    TemporarySparse useInSparse = Liveness_SPARSESET(this);
    TemporaryTable temporaryTable = Liveness_TEMPORARYTABLE(this);
    // Collect the PHI arguments of successors in useInSparse.
    TemporarySparse_empty(useInSparse);
    BasicBlock_LEAVE_FOREACH_BasicBlockEdge(curr_block, edge) {
      int32_t argIndex = BasicBlockEdge_ARGINDEX(edge);
      BasicBlock succ_block = BasicBlockEdge_destBlock(edge);
      if (BasicBlock_phiCount(succ_block) != 0) {
        BasicBlock_FOREACH_Operation(succ_block, operation) {
          if (Operator_isPhi(Operation_operator(operation))) {
            Temporary argument = Operation_getArgument(operation, argIndex);
            if (Temporary_hasRegister(argument)) {
              argument = dedicated + Temporary_REGISTER(argument);
            }
            if (TemporaryTable_contains(temporaryTable, argument)) {
              TemporarySparse_insert(useInSparse, argument);
            }
          } else break;
        } BasicBlock_ENDEACH_Operation;
      }
    } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
    if (phiSets) {
      // Fill the PHIOUTSETS with the PHI arguments of successors.
      TemporarySet phiOutSet = Liveness_PHIOUTSETS(this) + curr_index;
      TemporarySparse_FOREACH_Temporary(useInSparse, temporary) {
        TemporarySet_addMember(phiOutSet, temporary);
      } TemporarySparse_ENDEACH_Temporary;
      TemporarySet_makeOrder(phiOutSet);
    }
    // Local liveness analysis.
    LivenessState_analyzeOperations(curr_state, useInSparse, dedicated);
  }
  BasicBlock_LEAVE_FOREACH_BasicBlockEdge(curr_block, edge) {
    BasicBlock succ_block = BasicBlockEdge_destBlock(edge);
    LivenessState succ_state = baseState + BasicBlock_index(succ_block);
    Except_CHECK(BasicBlock_index(succ_block) >= 0);
    if (!LivenessState_ISLISTED(succ_state)) {
      Liveness_activateState(this, succ_block, phiSets);
    }
  } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
  // Postorder put first on worklist including ROOTBLOCK.
  Liveness_workPut(this, curr_state);
  //PFA_TRACE && fprintf(PFA_TRACE, "\tPUT Block_%d", BasicBlock_index(curr_block));
}

#line 648 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
void
Liveness_doIterate(Liveness this)
{
  LivenessState_ *baseState = Liveness_BASESTATE(this);
  //PFA_TRACE && fprintf(PFA_TRACE, "Liveness_doIterate\n");
  //PFA_TRACE && Liveness_pretty(this, PFA_TRACE);
  while (!Liveness_workIsEmpty(this)) {
    LivenessState curr_state = Liveness_workHead(this);
    int32_t countLiveOutSet = LivenessState_countLiveOutSet(curr_state);
    BasicBlock curr_block = LivenessState_BASICBLOCK(curr_state);
    // Pop curr_state from the worklist.
    *LivenessState__ISLISTED(curr_state) = false;
    Liveness_workPop(this);
//PFA_TRACE && fprintf(PFA_TRACE, "popped block_%d:\n", BasicBlock_index(curr_block));
//PFA_TRACE && LivenessState_pretty(curr_state, PFA_TRACE) && fprintf(PFA_TRACE, "\n");
    BasicBlock_LEAVE_FOREACH_BasicBlockEdge(curr_block, edge) {
      BasicBlock succ_block = BasicBlockEdge_destBlock(edge);
      LivenessState succ_state = baseState + BasicBlock_index(succ_block);
      Except_CHECK(BasicBlock_index(succ_block) >= 0);
      if (BasicBlock_index(succ_block) == 0) continue;
      // LIVEINSET[succ] = USEINSET[succ] U (LIVEOUTSET[succ] - KILLEDSET[succ]).
      TemporarySet_assign(LivenessState_LIVEINSET(succ_state),
                          LivenessState_LIVEOUTSET(succ_state));
      TemporarySet_diff(LivenessState_LIVEINSET(succ_state),
                        LivenessState_KILLEDSET(succ_state));
      TemporarySet_union(LivenessState_LIVEINSET(succ_state),
                         LivenessState_USEINSET(succ_state));
//PFA_TRACE && fprintf(PFA_TRACE, "\tprocess\tBlock_%d\n", BasicBlock_index(succ_block));
//PFA_TRACE && LivenessState_pretty(succ_state, PFA_TRACE);
      // LIVEOUTSET[curr] U= LIVEINSET[succ], for succ a successor of curr.
      TemporarySet_union(LivenessState_LIVEOUTSET(curr_state),
                         LivenessState_LIVEINSET(succ_state));
      //PFA_TRACE && Liveness_pretty(this, PFA_TRACE);
    } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
    ++*Liveness__ITERCOUNT(this);
//PFA_TRACE && fprintf(PFA_TRACE, "result block_%d:\n", BasicBlock_index(curr_block));
//PFA_TRACE && LivenessState_pretty(curr_state, PFA_TRACE) && fprintf(PFA_TRACE, "\n");
    // In case of change, push the predecessors on the worklist.
    if (LivenessState_countLiveOutSet(curr_state) != countLiveOutSet) {
      BasicBlock_ENTER_FOREACH_BasicBlockEdge(curr_block, edge) {
        BasicBlock pred_block = BasicBlockEdge_origBlock(edge);
        LivenessState pred_state = baseState + BasicBlock_index(pred_block);
        Except_CHECK(BasicBlock_index(pred_block) >= 0);
        if (BasicBlock_index(pred_block) == 0) continue;
        // pred_state must be initialized by Liveness_activateState
        Except_CHECK(LivenessState_BASICBLOCK(pred_state) != NULL);
        if (!LivenessState_ISLISTED(pred_state)) {
          Liveness_workPush(this, pred_state);
          *LivenessState__ISLISTED(pred_state) = true;
          //PFA_TRACE && fprintf(PFA_TRACE, "\tPUSH\tBlock_%d\n",
                               //BasicBlock_index(pred_block));
        }
      } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
    }
  }
}

#line 705 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
/*
 * Liveness_doUpward --	Initialize the live-in and live-out sets as upward exposed uses.
 */
static void
Liveness_doUpward(Liveness this)
{
  LivenessState_ *baseState = Liveness_BASESTATE(this);
  int32_t blockCount = Liveness_blockCount(this), index;
  TemporaryTable temporaryTable = Liveness_TEMPORARYTABLE(this);
  // Fill the base state LIVEINSET and LIVEOUTSET with the Global Temporary(ies).
  TemporarySet liveInSet = LivenessState_LIVEINSET(baseState);
  TemporarySet liveOutSet = LivenessState_LIVEOUTSET(baseState);
  TemporaryTable_FOREACH_Temporary(temporaryTable, temporary) {
    if (Temporary_isGlobal(temporary)) {
      TemporarySet_addMember(liveInSet, temporary);
    }
  } TemporaryTable_ENDEACH_Temporary;
  TemporarySet_makeOrder(liveInSet);
  TemporarySet_assign(liveOutSet, liveInSet);
  // Assign the LIVEINSET and LIVEOUTSET of non-base states.
  for (index = 1; index < blockCount; index++) {
    LivenessState state = baseState + index;
    TemporarySet_assign(LivenessState_LIVEINSET(state), liveInSet);
    TemporarySet_assign(LivenessState_LIVEOUTSET(state), liveOutSet);
  }
}

#line 732 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
/*
 * Liveness_doLinear --	Linear pass to compute approximate Liveness.
 *
 * We initialize the live-out and live-out sets with the upward exposed uses then
 * refine the computation with one linear pass in post-order.
 */
static void
Liveness_doLinear(Liveness this)
{
  LivenessState_ *baseState = Liveness_BASESTATE(this);
  Liveness_doUpward(this);
  Liveness_FORWORK_LivenessState(this, curr_state) {
    BasicBlock curr_block = LivenessState_BASICBLOCK(curr_state);
    BasicBlock_LEAVE_FOREACH_BasicBlockEdge(curr_block, edge) {
      BasicBlock succ_block = BasicBlockEdge_destBlock(edge);
      LivenessState succ_state = baseState + BasicBlock_index(succ_block);
      Except_CHECK(BasicBlock_index(succ_block) >= 0);
      if (BasicBlock_index(succ_block) == 0) continue;
      // LIVEINSET[succ] = USEINSET[succ] U (LIVEOUTSET[succ] - KILLEDSET[succ]).
      TemporarySet_assign(LivenessState_LIVEINSET(succ_state),
                          LivenessState_LIVEOUTSET(succ_state));
      TemporarySet_diff(LivenessState_LIVEINSET(succ_state),
                        LivenessState_KILLEDSET(succ_state));
      TemporarySet_union(LivenessState_LIVEINSET(succ_state),
                         LivenessState_USEINSET(succ_state));
      // LIVEOUTSET[curr] U= LIVEINSET[succ], for succ a successor of curr.
      TemporarySet_union(LivenessState_LIVEOUTSET(curr_state),
                         LivenessState_LIVEINSET(succ_state));
      ++*Liveness__ITERCOUNT(this);
    } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
  } Liveness_ENDWORK_LivenessState;
}

#line 771 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
void
Liveness_multiplex(Liveness this)
{
  Memory memory = Liveness_MEMORY(this);
  TemporarySet_ *liveInSets = Liveness_LIVEINSETS(this);
  TemporarySet_ *liveOutSets = Liveness_LIVEOUTSETS(this);
  TemporarySet_ *phiInSets = Liveness_PHIINSETS(this);
  TemporarySet_ *phiOutSets = Liveness_PHIOUTSETS(this);
  int32_t blockCount = Liveness_blockCount(this), index;
  Except_REQUIRE(phiInSets != NULL && phiOutSets != NULL);
  for (index = 0; index < blockCount; index++) {
    TemporarySet_union(liveInSets + index, phiInSets + index);
    TemporarySet_union(liveOutSets + index, phiOutSets + index);
#ifndef ECL_NDTOR
    TemporarySet_Dtor(phiInSets + index);
    TemporarySet_Dtor(phiOutSets + index);
#endif//ECL_NDTOR
  }
#ifndef ECL_NDTOR
  Memory_free_(memory, phiInSets);
  Memory_free_(memory, phiOutSets);
#endif//ECL_NDTOR
  *Liveness__PHIINSETS(this) = NULL;
  *Liveness__PHIOUTSETS(this) = NULL;
  CodeRegion_setLiveSets(Liveness_CODEREGION(this),
                         Liveness_BLOCKCOUNT(this),
                         Liveness_LIVEINSETS(this),
                         Liveness_LIVEOUTSETS(this),
                         Liveness_PHIINSETS(this),
                         Liveness_PHIOUTSETS(this));
}

#line 803 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 815 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
#if XCC__C
static void
Liveness_TEST(void)
{
#include "PFA/Liveness_.c"
}

#line 822 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Liveness.xcc"
int
main(int argc, char **argv)
{
  PFA_Test(Liveness_TEST);
  return 0;
}
#endif


#endif//Liveness_c_INCLUDED
