#ifndef LoopForest_c_INCLUDED
#define LoopForest_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
#include "PFA/PFA_.h"

#line 21 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 47 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
LoopForestNode
LoopForestNode_Ctor(LoopForestNode this,
                    LoopForestNodeType type, BasicBlock block)
{
  *LoopForestNode__TYPE(this) = type;
  *LoopForestNode__DEPTH(this) = -1;
  *LoopForestNode__BLOCK(this) = block;
  *LoopForestNode__CHILD(this) = NULL;
  *LoopForestNode__NEXT(this) = NULL;
  return this;
}

#line 59 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
void
LoopForestNode_Dtor(LoopForestNode this)
{
}

#line 112 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
static inline void
LoopForestNode_putContents(LoopForestNode this, LoopForestNode childNode)
{
  *LoopForestNode__DEPTH(childNode) = LoopForestNode_DEPTH(this) + 1;
  *LoopForestNode__NEXT(childNode) = LoopForestNode_CHILD(this);
  *LoopForestNode__CHILD(this) = childNode;
}

#line 125 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
#ifndef ECL_NTRACE
bool
LoopForestNode_pretty(const_LoopForestNode this, FILE *file,
                      bool (*block_pretty)(BasicBlock, FILE*))
{
  LoopForestNodeType type = LoopForestNode_TYPE(this);
  if (file == NULL) file = stderr;
  if (type == LoopForestNodeType_Block) {
    BasicBlock block = LoopForestNode_BLOCK(this);
    if (block_pretty != NULL) (*block_pretty)(block, file);
    else fprintf(file, "%d", BasicBlock_index(block));
  } else {
    const char *sep = "";
    if (type == LoopForestNodeType_SCC) fprintf(file, "(");
    if (type == LoopForestNodeType_Loop) fprintf(file, "[");
    //if (type == LoopForestNodeType_Root) fprintf(file, "{");
    LoopForestNode_CONTENTS_FOREACH_LoopForestNode(this, node) {
      fputs(sep, file);
      LoopForestNode_pretty(node, file, block_pretty);
      sep = " ";
    } LoopForestNode_CONTENTS_ENDEACH_LoopForestNode;
    //if (type == LoopForestNodeType_Root) fprintf(file, "}");
    if (type == LoopForestNodeType_Loop) fprintf(file, "]");
    if (type == LoopForestNodeType_SCC) fprintf(file, ")");
  }
  return true;
}
#endif//ECL_NTRACE

#line 154 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 174 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
LoopForest
LoopForest_Ctor(LoopForest this,
                Memory memory, CodeRegion codeRegion)
{
  int32_t count = CodeRegion_blockCount(codeRegion);
  LoopForestNode rootNode = LoopForest_ROOTNODE(this);
  *LoopForest__CODEREGION(this) = codeRegion;
  *LoopForest__CONFIGURE(this) = CodeRegion_configure(codeRegion);
  *LoopForest__PREDFN(this) = Memory_alloc(memory, sizeof(int32_t)*count);
  *LoopForest__PAST(this) = Memory_alloc(memory, sizeof(BasicBlock)*count);
  LoopForestNode_Ctor(rootNode, LoopForestNodeType_Root, NULL);
  IBList_Ctor(LoopForest_NODES(this), memory,
              sizeof(LoopForestNode_), 30);
  LoopForest_makeNSCC(this);
  return this;
}

#line 191 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
void
LoopForest_Dtor(LoopForest this)
{
  Memory memory = LoopForest_MEMORY(this);
  LoopForestNode rootNode = LoopForest_ROOTNODE(this);
  LoopForestNode childNode = LoopForestNode_CHILD(rootNode);
  Memory_free_(memory, LoopForest_PREDFN(this));
  Memory_free_(memory, LoopForest_PAST(this));
  IBList_empty(LoopForest_NODES(this),
               (IBListItemRelease)LoopForestNode_Dtor);
  IBList_Dtor(LoopForest_NODES(this));
}

#line 204 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
size_t
LoopForest_Size(Memory memory, CodeRegion codeRegion)
{
  return sizeof(LoopForest_);
}

#line 219 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
#ifndef LoopForest_POOLED
#define LoopForest_POOLED 128
#endif//LoopForest_POOLED

#line 223 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
LoopForest
LoopForest_new(Memory parent, CodeRegion codeRegion)
{
  Memory memory = Memory_new(parent, LoopForest_POOLED);
  size_t size = LoopForest_Size(memory, codeRegion);
  LoopForest this = Memory_alloc(memory, size);
  return LoopForest_Ctor(this, memory, codeRegion);
}

#line 236 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
LoopForest
LoopForest_delete(LoopForest this)
{
  if (this != NULL) {
    Memory memory = LoopForest_MEMORY(this);
#ifndef ECL_NDTOR
    LoopForest_Dtor(this);
    Memory_free_(memory, this);
#endif//ECL_NDTOR
    Memory_delete(memory);
  }
  return NULL;
}

#line 250 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 258 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
Memory
LoopForest_memory(LoopForest this)
{
  return LoopForest_MEMORY(this);
}

#line 270 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
CodeRegion
LoopForest_codeRegion(LoopForest this)
{
  return LoopForest_CODEREGION(this);
}

#line 280 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
LoopForestNode
LoopForest_rootNode(LoopForest this)
{
  return LoopForest_ROOTNODE(this);
}

#line 286 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
static inline LoopForestNode
LoopForest_makeNode(LoopForest this, LoopForestNodeType type, BasicBlock block)
{
  void *item = IBList_push(LoopForest_NODES(this));
  return LoopForestNode_Ctor(item, type, block);
}

#line 298 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
#ifndef ECL_NTRACE
bool
LoopForest_pretty(const_LoopForest this, FILE *file,
                  bool (*block_pretty)(BasicBlock, FILE*))
{
  const_LoopForestNode rootNode = LoopForest_ROOTNODE(this);
  if (file == NULL) file = stderr;
  LoopForestNode_pretty(rootNode, file, block_pretty);
  fprintf(file, "\n");
  return true;
}
#endif//ECL_NTRACE

#line 311 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
/*
  This is the classic SCC algorithm from Tarjan adapted from F. Bourdoncle's
  Ph. D. thesis ``Semantique des langages imperatifs d'ordre superieur et interpretation
  abstraite'', 1992, Figure 3.8 p. 41.
 */
static int32_t
LoopForest_visitTarjan(LoopForest this, BasicBlock block,
                       LoopForestNode parent_node, int32_t *_number)
{
  bool loop = false;
  int32_t index = BasicBlock_index(block);
  int32_t *preDFN = LoopForest_PREDFN(this);
  int32_t headDFN = preDFN[index] = ++*_number;
  *LoopForest_PAST(this) = block;
  ++*LoopForest__PAST(this);
  BasicBlock_LEAVE_FOREACH_BasicBlockEdge(block, edge) {
    BasicBlock succ_block = BasicBlockEdge_destBlock(edge);
    int32_t succ_index = BasicBlock_index(succ_block), minDFN = 0;
    if (!succ_index) continue;	// skip rootNode
    if (preDFN[succ_index] <= 0) {
      minDFN = LoopForest_visitTarjan(this, succ_block, parent_node, _number);
    } else {
      minDFN = preDFN[succ_index];
    }
    if (minDFN <= headDFN) {
      headDFN = minDFN;
      loop = true;
    }
  } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
  if (headDFN == preDFN[index]) {
    BasicBlock scc_block = NULL;
    LoopForestNode node = NULL;
    if (loop) {
      node = LoopForest_makeNode(this, LoopForestNodeType_SCC, block);
      LoopForestNode_putContents(parent_node, node);
      parent_node = node;
    }
    do {
      --*LoopForest__PAST(this);
      scc_block = *LoopForest_PAST(this);
      preDFN[BasicBlock_index(scc_block)] = INT32_MAX;
      node = LoopForest_makeNode(this, LoopForestNodeType_Block, scc_block);
      LoopForestNode_putContents(parent_node, node);
    } while (scc_block != block);
  }
  return headDFN;
}

#line 359 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
/*
 * This implementation is adapted from F. Bourdoncle's paper, ``Efficient Chaotic
 * Iteration Strategies with Widenings'', Proc. of the International Conference
 * on Formal Methods in Programming and their Applications, Lecture Notes in
 * Computer Science 735, Springer-Verlag 1993. The Tarjan-Bourdoncle algorithm
 * runs in O(de), where d is the maximum loop nesting depth.
 *
 * The algorithm is extended to detect the extra loop entry blocks as proposed by
 * Steensgaard in ``Sequentializing Program Dependence Graphs for Irreducible
 * Programs''. The resulting loop forest is not Steengaard's though, because
 * the SCC root blocks are removed one at a time. In Steensgaard's forest, all
 * the heads of looping arcs are removed before reprocessing the current SCC.
 */
static int32_t
LoopForest_visitBourdoncle(LoopForest this, BasicBlock block,
                           LoopForestNode parent_node, int32_t *_number)
{
  bool loop = false;
  int32_t index = BasicBlock_index(block);
  int32_t *preDFN = LoopForest_PREDFN(this);
  int32_t headDFN = preDFN[index] = ++*_number;
  *LoopForest_PAST(this) = block;
  ++*LoopForest__PAST(this);
  BasicBlock_LEAVE_FOREACH_BasicBlockEdge(block, edge) {
    BasicBlock succ_block = BasicBlockEdge_destBlock(edge);
    int32_t succ_index = BasicBlock_index(succ_block), minDFN = 0;
    if (!succ_index) continue;	// skip rootNode
    if (preDFN[succ_index] <= 0) {
      minDFN = LoopForest_visitBourdoncle(this, succ_block, parent_node, _number);
    } else {
      minDFN = preDFN[succ_index];
    }
    if (minDFN <= headDFN) {
      headDFN = minDFN;
      loop = true;
    }
  } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
  if (headDFN == preDFN[index]) {
    BasicBlock *_last = --*LoopForest__PAST(this);
    BasicBlock scc_block = *_last, *_block = NULL;
    LoopForestNode node = NULL;
    preDFN[index] = INT32_MAX;
    if (loop) {
      int32_t stamp = -1;
      LoopForestNodeType node_type = LoopForestNodeType_Loop;
      BasicBlockFlags block_flags = BasicBlockFlag_Widening+BasicBlockFlag_Natural;
      // Erase the preDFN numbers of the SCC to prepare for recursive SCC search.
      while (scc_block != block) {
        preDFN[BasicBlock_index(scc_block)] = stamp;
        --*LoopForest__PAST(this);
        scc_block = *LoopForest_PAST(this);
      }
      // Traverse the SCC excluding its root to identify the other loop entry blocks.
      for (_block = LoopForest_PAST(this) + 1; _block <= _last; _block++) {
        BasicBlock_clearFlags(*_block, block_flags);
        BasicBlock_ENTER_FOREACH_BasicBlockEdge(*_block, edge) {
          BasicBlock orig_block = BasicBlockEdge_origBlock(edge);
          int32_t orig_index = BasicBlock_index(orig_block);
          *BasicBlockEdge__ISLOOP(edge) = false;
          if (orig_block != block && preDFN[orig_index] != stamp) {
            BasicBlock_setFlags(*_block, BasicBlockFlag_Widening);
            node_type = LoopForestNodeType_SCC;
            block_flags = BasicBlockFlag_Widening;
          }
        } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
      }
      // Add attributes to the SCC root and its entering edges.
      BasicBlock_setFlags(block, block_flags);
      BasicBlock_ENTER_FOREACH_BasicBlockEdge(block, edge) {
        BasicBlock orig_block = BasicBlockEdge_origBlock(edge);
        int32_t orig_index = BasicBlock_index(orig_block);
        *BasicBlockEdge__ISLOOP(edge) = false;
        if (orig_block == block || preDFN[orig_index] == stamp) {
          *BasicBlockEdge__ISLOOP(edge) = true;
        }
      } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
      // Create the LoopForestNode for the current SCC.
      node = LoopForest_makeNode(this, node_type, block);
      LoopForestNode_putContents(parent_node, node);
      parent_node = node;
      BasicBlock_LEAVE_FOREACH_BasicBlockEdge(block, edge) {
        BasicBlock succ_block = BasicBlockEdge_destBlock(edge);
        int32_t succ_index = BasicBlock_index(succ_block);
        if (preDFN[succ_index] <= 0) {
          LoopForest_visitBourdoncle(this, succ_block, parent_node, _number);
        }
      } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
    }
    node = LoopForest_makeNode(this, LoopForestNodeType_Block, scc_block);
    LoopForestNode_putContents(parent_node, node);
  }
  return headDFN;
}

#line 459 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
void
LoopForest_makeSCC(LoopForest this)
{
  int32_t number = 0;
  int32_t *preDFN = LoopForest_PREDFN(this);
  int32_t count = LoopForest_BLOCKCOUNT(this);
  LoopForestNode rootNode = LoopForest_ROOTNODE(this);
  CodeRegion codeRegion = LoopForest_CODEREGION(this);
#ifndef ECL_NDTOR
  IBList_empty(LoopForest_NODES(this), (IBListItemRelease)LoopForestNode_Dtor);
#endif//ECL_NDTOR
  LoopForestNode_Ctor(rootNode, LoopForestNodeType_Root, NULL);
  memset(LoopForest_PREDFN(this), 0, sizeof(int32_t)*count);
  CodeRegion_FORENTER_BasicBlock(codeRegion, entryBlock) {
    if (preDFN[BasicBlock_index(entryBlock)] <= 0) {
      LoopForest_visitTarjan(this, entryBlock, rootNode, &number);
    }
  } CodeRegion_ENDENTER_BasicBlock;
}

#line 491 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
void
LoopForest_makeNSCC(LoopForest this)
{
  int32_t number = 0;
  int32_t *preDFN = LoopForest_PREDFN(this);
  int32_t count = LoopForest_BLOCKCOUNT(this);
  LoopForestNode rootNode = LoopForest_ROOTNODE(this);
  CodeRegion codeRegion = LoopForest_CODEREGION(this);
#ifndef ECL_NDTOR
  IBList_empty(LoopForest_NODES(this), (IBListItemRelease)LoopForestNode_Dtor);
#endif//ECL_NDTOR
  LoopForestNode_Ctor(rootNode, LoopForestNodeType_Root, NULL);
  memset(LoopForest_PREDFN(this), 0, sizeof(int32_t)*count);
  CodeRegion_FORENTER_BasicBlock(codeRegion, entryBlock) {
    if (preDFN[BasicBlock_index(entryBlock)] <= 0) {
      LoopForest_visitBourdoncle(this, entryBlock, rootNode, &number);
    }
  } CodeRegion_ENDENTER_BasicBlock;
}

#line 511 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 776 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 788 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
#if XCC__C
static void
LoopForest_TEST(void)
{
#include "PFA/LoopForest_.c"
}

#line 795 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
int
main(int argc, char **argv)
{
  PFA_Test(LoopForest_TEST);
  return 0;
}
#endif


#endif//LoopForest_c_INCLUDED
