#ifndef LoopForest__c_INCLUDED
#define LoopForest__c_INCLUDED

#line 64 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
//
{
  printf("sizeof(LoopForestNode_) = %d\n", sizeof(LoopForestNode_));
}

#line 210 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
//
{
  printf("sizeof(LoopForest_) = %d\n", sizeof(LoopForest_));
}

#line 513 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
//
// Test DGraph_makeNSCC.
{
  Symbol_ symbol_;
  Program program = Program_new(Memory_Root);
  Procedure procedure = Program_makeProcedure(program, &symbol_);
  // Example taken from F. Bourdoncle's Ph. D. thesis ``Semantique des langages
  // imperatifs d'ordre superieur et interpretation abstraite'', 1992, Figure
  // 3.6 at page 39.
  BasicBlock block_1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_makeEdge(block_1, block_2, 0.0);
  BasicBlock_makeEdge(block_1, block_3, 0.0);
  BasicBlock_makeEdge(block_2, block_3, 0.0);
  BasicBlock_makeEdge(block_2, block_4, 0.0);
  BasicBlock_makeEdge(block_3, block_2, 0.0);
  BasicBlock_makeEdge(block_3, block_4, 0.0);
  Procedure_setEntryBlock(procedure, block_1);
  Procedure_buildCodeRegions(procedure);
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    LoopForest loopForest = LoopForest_new(Memory_Root, codeRegion);
    printf("Irreducible:\n");
    printf("SCC:\t");
    LoopForest_makeSCC(loopForest);
    LoopForest_pretty(loopForest, stdout, NULL);
    printf("NSCC:\t");
    LoopForest_makeNSCC(loopForest);
    LoopForest_pretty(loopForest, stdout, NULL);
    LoopForest_delete(loopForest);
  }
  Program_delete(program);
}

#line 549 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
//
// Test Procedure_makeNSCC.
{
  Symbol_ symbol_;
  Program program = Program_new(Memory_Root);
  Procedure procedure = Program_makeProcedure(program, &symbol_);
  // Example taken from F. Bourdoncle's Ph. D. thesis ``Semantique des langages
  // imperatifs d'ordre superieur et interpretation abstraite'', 1992, Figure
  // 3.5 at page 39.
  BasicBlock block_1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_5 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_6 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_7 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_8 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_9 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_makeEdge(block_1, block_2, 0.0);
  BasicBlock_makeEdge(block_1, block_4, 0.0);
  BasicBlock_makeEdge(block_1, block_5, 0.0);
  BasicBlock_makeEdge(block_2, block_3, 0.0);
  BasicBlock_makeEdge(block_2, block_4, 0.0);
  BasicBlock_makeEdge(block_4, block_4, 0.0);
  BasicBlock_makeEdge(block_5, block_6, 0.0);
  BasicBlock_makeEdge(block_6, block_7, 0.0);
  BasicBlock_makeEdge(block_7, block_6, 0.0);
  BasicBlock_makeEdge(block_7, block_8, 0.0);
  BasicBlock_makeEdge(block_7, block_9, 0.0);
  BasicBlock_makeEdge(block_8, block_8, 0.0);
  BasicBlock_makeEdge(block_9, block_5, 0.0);
  BasicBlock_makeEdge(block_9, block_7, 0.0);
  Procedure_setEntryBlock(procedure, block_1);
  Procedure_buildCodeRegions(procedure);
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    LoopForest loopForest = LoopForest_new(Memory_Root, codeRegion);
    printf("Bourdoncle figure 3.5:\n");
    printf("SCC:\t");
    LoopForest_makeSCC(loopForest);
    LoopForest_pretty(loopForest, stdout, NULL);
    printf("NSCC:\t");
    LoopForest_makeNSCC(loopForest);
    LoopForest_pretty(loopForest, stdout, NULL);
    LoopForest_delete(loopForest);
  }
  Program_delete(program);
}

#line 598 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
//
// Test Procedure_makeNSCC.
{
  Symbol_ symbol_;
  Program program = Program_new(Memory_Root);
  Procedure procedure = Program_makeProcedure(program, &symbol_);
  // Example taken from F. Bourdoncle's paper ``Efficient Chaotic Iteration
  // Strategies with Widenings'', Figure 2.
  BasicBlock block_1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_makeEdge(block_1, block_4, 0.0);
  BasicBlock_makeEdge(block_1, block_2, 0.0);
  BasicBlock_makeEdge(block_2, block_3, 0.0);
  BasicBlock_makeEdge(block_3, block_1, 0.0);
  BasicBlock_makeEdge(block_4, block_3, 0.0);
  Procedure_setEntryBlock(procedure, block_1);
  Procedure_buildCodeRegions(procedure);
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    LoopForest loopForest = LoopForest_new(Memory_Root, codeRegion);
    printf("Bourdoncle figure 2:\n");
    printf("SCC:\t");
    LoopForest_makeSCC(loopForest);
    LoopForest_pretty(loopForest, stdout, NULL);
    printf("NSCC:\t");
    LoopForest_makeNSCC(loopForest);
    LoopForest_pretty(loopForest, stdout, NULL);
    LoopForest_delete(loopForest);
  }
  Program_delete(program);
}

#line 632 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
//
// Test Procedure_makeNSCC.
{
  Symbol_ symbol_;
  Program program = Program_new(Memory_Root);
  Procedure procedure = Program_makeProcedure(program, &symbol_);
  // Example taken from F. Bourdoncle's paper ``Efficient Chaotic Iteration
  // Strategies with Widenings'', Figure 5.
  BasicBlock block_1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_5 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_6 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_7 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_8 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_9 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_10 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_11 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_12 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_13 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_14 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_15 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_16 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_makeEdge(block_1, block_2, 0.0);
  BasicBlock_makeEdge(block_1, block_4, 0.0);
  BasicBlock_makeEdge(block_2, block_3, 0.0);
  BasicBlock_makeEdge(block_3, block_6, 0.0);
  BasicBlock_makeEdge(block_4, block_11, 0.0);
  BasicBlock_makeEdge(block_5, block_6, 0.0);
  BasicBlock_makeEdge(block_6, block_15, 0.0);
  BasicBlock_makeEdge(block_11, block_12, 0.0);
  BasicBlock_makeEdge(block_11, block_14, 0.0);
  BasicBlock_makeEdge(block_12, block_13, 0.0);
  BasicBlock_makeEdge(block_13, block_16, 0.0);
  BasicBlock_makeEdge(block_14, block_1, 0.0);
  BasicBlock_makeEdge(block_16, block_5, 0.0);
  BasicBlock_makeEdge(block_15, block_16, 0.0);
  Procedure_setEntryBlock(procedure, block_1);
  Procedure_buildCodeRegions(procedure);
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    LoopForest loopForest = LoopForest_new(Memory_Root, codeRegion);
    printf("Bourdoncle figure 5:\n");
    printf("SCC:\t");
    LoopForest_makeSCC(loopForest);
    LoopForest_pretty(loopForest, stdout, NULL);
    printf("NSCC:\t");
    LoopForest_makeNSCC(loopForest);
    LoopForest_pretty(loopForest, stdout, NULL);
    LoopForest_delete(loopForest);
  }
  Program_delete(program);
}

#line 687 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
//
// Test Procedure_makeNSCC.
{
  Symbol_ symbol_;
  Program program = Program_new(Memory_Root);
  Procedure procedure = Program_makeProcedure(program, &symbol_);
  // Example taken from G. Ramalingam's report ``On Loops, Dominators, and
  // Dominance Frontiers'', figure 1.
  BasicBlock block_1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_5 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_6 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_makeEdge(block_1, block_2, 0.0);
  BasicBlock_makeEdge(block_1, block_3, 0.0);
  BasicBlock_makeEdge(block_2, block_4, 0.0);
  BasicBlock_makeEdge(block_3, block_5, 0.0);
  BasicBlock_makeEdge(block_4, block_2, 0.0);
  BasicBlock_makeEdge(block_4, block_5, 0.0);
  BasicBlock_makeEdge(block_4, block_6, 0.0);
  BasicBlock_makeEdge(block_5, block_3, 0.0);
  BasicBlock_makeEdge(block_5, block_4, 0.0);
  BasicBlock_makeEdge(block_5, block_6, 0.0);
  Procedure_setEntryBlock(procedure, block_1);
  Procedure_buildCodeRegions(procedure);
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    LoopForest loopForest = LoopForest_new(Memory_Root, codeRegion);
    printf("Ramalingam figure 1:\n");
    printf("SCC:\t");
    LoopForest_makeSCC(loopForest);
    LoopForest_pretty(loopForest, stdout, NULL);
    printf("NSCC:\t");
    LoopForest_makeNSCC(loopForest);
    LoopForest_pretty(loopForest, stdout, NULL);
    LoopForest_delete(loopForest);
  }
  Program_delete(program);
}

#line 728 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/LoopForest.xcc"
//
// Test Procedure_makeNSCC.
{
  Symbol_ symbol_;
  Program program = Program_new(Memory_Root);
  Procedure procedure = Program_makeProcedure(program, &symbol_);
  BasicBlock block_1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_5 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_6 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_7 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_8 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_9 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_10 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_makeEdge(block_1, block_2, 0.0);
  BasicBlock_makeEdge(block_2, block_3, 0.0);
  BasicBlock_makeEdge(block_2, block_5, 0.0);
  BasicBlock_makeEdge(block_2, block_6, 0.0);
  BasicBlock_makeEdge(block_3, block_4, 0.0);
  BasicBlock_makeEdge(block_3, block_5, 0.0);
  BasicBlock_makeEdge(block_5, block_5, 0.0);
  BasicBlock_makeEdge(block_6, block_7, 0.0);
  BasicBlock_makeEdge(block_7, block_8, 0.0);
  BasicBlock_makeEdge(block_8, block_7, 0.0);
  BasicBlock_makeEdge(block_8, block_9, 0.0);
  BasicBlock_makeEdge(block_8, block_10, 0.0);
  BasicBlock_makeEdge(block_9, block_9, 0.0);
  BasicBlock_makeEdge(block_10, block_6, 0.0);
  BasicBlock_makeEdge(block_10, block_8, 0.0);
  Procedure_setEntryBlock(procedure, block_1);
  Procedure_buildCodeRegions(procedure);
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    LoopForest loopForest = LoopForest_new(Memory_Root, codeRegion);
    printf("Quicksort:\n");
    printf("SCC:\t");
    LoopForest_makeSCC(loopForest);
    LoopForest_pretty(loopForest, stdout, NULL);
    printf("NSCC:\t");
    LoopForest_makeNSCC(loopForest);
    LoopForest_pretty(loopForest, stdout, NULL);
    LoopForest_delete(loopForest);
  }
  Program_delete(program);
}


#endif//LoopForest__c_INCLUDED
