#ifndef PFA_c_INCLUDED
#define PFA_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
#include "PFA/PFA_.h"

#line 28 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 64 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
Timer
Timer_Ctor(Timer this,
           Memory memory, int count)
{
  *Timer__MEMORY(this) = memory;
  *Timer__COUNT(this) = count;
#if defined (linux) || defined (__linux__) || defined (__linux)
  *Timer__TIMERS(this) = Memory_alloc(memory, count*2*sizeof(struct timeval));
#endif//linux
  return this;
}

#line 76 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
void
Timer_Dtor(Timer this)
{
     Memory_free(Timer_MEMORY(this), Timer_TIMERS(this));
}

#line 118 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
#if defined (linux) || defined (__linux__) || defined (__linux)

#line 120 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
#define TIMEVAL_TO_USEC(x) ((int64_t)(x)->tv_usec + (int64_t)(x)->tv_sec*1000000)

#line 122 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
int64_t
Timer_value(Timer this, int timer_id)
{
  struct timeval *total_tv = &Timer_TIMERS(this)[(timer_id<<1) + 1];
  return TIMEVAL_TO_USEC(total_tv);
}

#line 129 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
int64_t
Timer_lastValue(Timer this, int timer_id)
{
  struct timeval *tv = &Timer_TIMERS(this)[timer_id<<1];
  return TIMEVAL_TO_USEC(tv);
}

#line 137 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
int64_t
Timer_start(Timer this, int timer_id)
{
  struct rusage r;
  struct timeval *tv = &Timer_TIMERS(this)[timer_id<<1];
  struct timeval *total_tv = &Timer_TIMERS(this)[(timer_id<<1) + 1];
  getrusage(RUSAGE_SELF, &r);
  *tv = r.ru_utime;
  return TIMEVAL_TO_USEC(total_tv);
}

#line 148 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
int64_t
Timer_stop(Timer this, int timer_id)
{
  struct timeval stop;
  struct rusage r;
  struct timeval *tv = &Timer_TIMERS(this)[timer_id<<1];
  struct timeval *total_tv = &Timer_TIMERS(this)[(timer_id<<1) + 1];
  getrusage(RUSAGE_SELF, &r);
  stop = r.ru_utime;
  tv->tv_sec = stop.tv_sec - tv->tv_sec;
  tv->tv_usec = stop.tv_usec - tv->tv_usec;
  total_tv->tv_sec += tv->tv_sec;
  total_tv->tv_usec += tv->tv_usec;
  return TIMEVAL_TO_USEC(total_tv);
}

#line 164 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
void
Timer_reset(Timer this, int timer_id)
{
  struct timeval *tv = &Timer_TIMERS(this)[timer_id<<1];
  struct timeval *total_tv = &Timer_TIMERS(this)[(timer_id<<1) + 1];
  tv->tv_sec = tv->tv_usec = 0;
  total_tv->tv_sec = total_tv->tv_usec = 0;
}

#line 173 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
void
Timer_resetAll(Timer this)
{
  int i;
  for (i = 0; i < Timer_COUNT(this); i++)
    Timer_reset(this, i);
}

#line 181 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
#endif//linux

#line 191 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
#undef PFA_TRACE
FILE *PFA_TRACE = NULL;

#line 202 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
#undef MAXLIVE_TRACE
FILE *MAXLIVE_TRACE = NULL;

#line 214 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
#undef PFA_TIMER
FILE *PFA_TIMER = NULL;

#line 225 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
#undef PFA_STATS
FILE *PFA_STATS = NULL;

#line 235 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
int FORCE_SUPERGROW;
int FORCE_REUSELIMIT;

#line 244 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
static int PFA_Initialized = 0;

#line 246 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
void
PFA_INIT(void)
{
  if (PFA_Initialized++ == 0) {
    if (GETENV("PFA_TRACE")) {
      int file = 0;
      sscanf(GETENV("PFA_TRACE"), "%d", &file);
      if (file == 1) PFA_TRACE = stdout;
      else if (file == 2) PFA_TRACE = stderr;
    }
    if (GETENV("MAXLIVE_TRACE")) {
      int file = 0;
      sscanf(GETENV("MAXLIVE_TRACE"), "%d", &file);
      if (file == 1) MAXLIVE_TRACE = stdout;
      else if (file == 2) MAXLIVE_TRACE = stderr;
    }
    if (GETENV("PFA_TIMER")) {
      int file = 0;
      sscanf(GETENV("PFA_TIMER"), "%d", &file);
      if (file == 1) PFA_TIMER = stdout;
      else if (file == 2) PFA_TIMER = stderr;
    }
    if (GETENV("PFA_STATS")) {
      int file = 0;
      sscanf(GETENV("PFA_STATS"), "%d", &file);
      if (file == 1) PFA_STATS = stdout;
      else if (file == 2) PFA_STATS = stderr;
    }
    FORCE_SUPERGROW = 2;
    if (GETENV("FORCE_SUPERGROW")) {
      sscanf(GETENV("FORCE_SUPERGROW"), "%d", &FORCE_SUPERGROW);
      fprintf(stderr, "*** FORCE_SUPERGROW=%d\n", FORCE_SUPERGROW);
    }
    FORCE_REUSELIMIT = 0;
    if (GETENV("FORCE_REUSELIMIT")) {
      sscanf(GETENV("FORCE_REUSELIMIT"), "%d", &FORCE_REUSELIMIT);
      fprintf(stderr, "*** FORCE_REUSELIMIT=%d\n", FORCE_REUSELIMIT);
    }
    CCL_INIT();
    MDS_INIT();
    AIR_INIT();
    LIR_INIT();
    Liveness_INIT();
    Dominance_INIT();
    LoopForest_INIT();
    ValueNumber_INIT();
    Interference_INIT();
    SSAForm_INIT();
    SSAConstruct_INIT();
    LiveCheck_INIT();
    Coalescer_INIT();
    Decoalescer_INIT();
    Boissinot_INIT();
    Sreedhar_INIT();
  }
}

#line 309 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
void
PFA_FINI(void)
{
  if (--PFA_Initialized == 0) {
    Sreedhar_FINI();
    Boissinot_FINI();
    Decoalescer_FINI();
    Coalescer_FINI();
    LiveCheck_FINI();
    SSAConstruct_FINI();
    SSAForm_FINI();
    Interference_FINI();
    ValueNumber_FINI();
    LoopForest_FINI();
    Dominance_FINI();
    Liveness_FINI();
    LIR_FINI();
    AIR_FINI();
    MDS_FINI();
    CCL_FINI();
  }
}

#line 338 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
void
PFA_Test(void (*test)(void))
{
  PFA_INIT();
  (*test)();
  PFA_FINI();
}

#line 346 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
#if XCC__C
static void
PFA_TEST(void)
{
#include "PFA/PFA_.c"
}

#line 353 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/PFA.xcc"
int
main(int argc, char **argv)
{
  PFA_Test(PFA_TEST);
  return 0;
}
#endif


#endif//PFA_c_INCLUDED
