#ifndef PFA__h_INCLUDED
#define PFA__h_INCLUDED

//
#include "PFA/PFA.h"

//
#if defined (linux) || defined (__linux__) || defined (__linux)
#include <sys/resource.h>
#endif//linux

//
struct Timer_ {
  //@args       Memory memory, int count
  Memory MEMORY;
  int COUNT;
  struct timeval *TIMERS;     		// Timers.
};

extern Timer
Timer_Ctor(Timer this, Memory memory, int count);

extern Timer
Timer_Copy(Timer this, const_Timer that);

extern void
Timer_Dtor(Timer this);

extern size_t
Timer_Size(Memory memory, int count);

#define Timer_MEMORY(this) ((this)->MEMORY)
#define Timer__MEMORY(this) (&(this)->MEMORY)
#define Timer_COUNT(this) ((this)->COUNT)
#define Timer__COUNT(this) (&(this)->COUNT)
#define Timer_TIMERS(this) ((this)->TIMERS)
#define Timer__TIMERS(this) (&(this)->TIMERS)


//
#include "PFA/Liveness_.h"
#include "PFA/Dominance_.h"
#include "PFA/LoopForest_.h"
#include "PFA/ValueNumber_.h"
#include "PFA/Interference_.h"
#include "PFA/SSAForm_.h"
#include "PFA/SSAConstruct_.h"
#include "PFA/LiveCheck_.h"
#include "PFA/Coalescer_.h"
#include "PFA/Decoalescer_.h"
#include "PFA/Boissinot_.h"
#include "PFA/Sreedhar_.h"

/*
 * PFA_Test --	Setup and execute a PFA test.
 */
void
PFA_Test(void (*test)(void));


#endif//PFA__h_INCLUDED
