#ifndef SSAForm_c_INCLUDED
#define SSAForm_c_INCLUDED

#line 17 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
#include "PFA/PFA_.h"

#line 28 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
#ifndef SSAForm_MERGESETS
int SSAForm_MERGESETS = 0;
#endif//SSAForm_MERGESETS

#line 32 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 48 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
SSAForm
SSAForm_Ctor(SSAForm this,
             Memory memory, CodeRegion codeRegion)
{
  int32_t blockCount = CodeRegion_blockCount(codeRegion);
  *SSAForm__MEMORY(this) = memory;
  *SSAForm__CODEREGION(this) = codeRegion;
  *SSAForm__DOMINANCE(this) = NULL;
  return this;
}

#line 59 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
void
SSAForm_Dtor(SSAForm this)
{
  Memory memory = SSAForm_MEMORY(this);
  Dominance_delete(SSAForm_DOMINANCE(this));
}

#line 66 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
size_t
SSAForm_Size(Memory memory, CodeRegion codeRegion)
{
  return sizeof(SSAForm_);
}

#line 81 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
#ifndef SSAForm_POOLED
#define SSAForm_POOLED 128
#endif//SSAForm_POOLED

#line 85 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
SSAForm
SSAForm_construct(Memory parent, CodeRegion codeRegion, bool sortEnterEdges)
{
  Memory memory = Memory_new(parent, SSAForm_POOLED);
  size_t size = SSAForm_Size(memory, codeRegion);
  void *alloc = Memory_alloc(memory, size);
  SSAForm this = SSAForm_Ctor(alloc, memory, codeRegion);
  CodeRegion_setSSAForm(codeRegion, this);
  // Make the BasicBlock ENTEREDGES of BasicBlock(s).
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    BasicBlock_makeEnterEdges(basicBlock, memory, sortEnterEdges);
  } CodeRegion_ENDEACH_BasicBlock;
  // Ensure a call is followed by a BB with no more than one predecessor
  SSAForm_splitAfterCall(this);
  // Prepare the TEMPORARYTABLE and DOMINANCE for SSAForm.
  {
    TemporaryFlags mask = TemporaryFlag_Constant|TemporaryFlag_RenameOK;
    TemporaryTable globalTable = CodeRegion_makeGlobalTable(codeRegion, mask,
                                                            TemporaryFlag_RenameOK);
    Dominance dominance = SSAForm_MERGESETS?
                          SSAForm_makeDominance(this, DominanceFlag_MergeSets):
                          SSAForm_makeDominance(this, DominanceFlag_Frontiers);
    SSAConstruct_delete(SSAConstruct_new(memory, this));
  }
  return this;
}

#line 116 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
void
SSAForm_checkConventional(SSAForm this, TemporaryTable globalTable)
{
  Coalescer_ coalescer[1];
  VariableClass class = NULL;
  Memory memory = SSAForm_MEMORY(this);
  CodeRegion codeRegion = SSAForm_codeRegion(this);
  Dominance dominance = SSAForm_makeDominance(this, 0);
  Coalescer_Ctor(coalescer, memory, codeRegion, globalTable, dominance, 0);
  Coalescer_complete(coalescer);
  Coalescer_classesFromSSAwebs(coalescer);
  class = Coalescer_findInterferingClass(coalescer);
  if (class != NULL) {
    fprintf(stderr, "Interfering class: ");
    VariableClass_pretty(class, stderr, true);
    fprintf(stderr, "\n");
    Except_CHECK(class == NULL);
  }
  Coalescer_Dtor(coalescer);
}

#line 142 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
SSAForm
SSAForm_destruct(SSAForm this)
{
  if (this != NULL) {
    Memory memory = SSAForm_MEMORY(this);
    CodeRegion codeRegion = SSAForm_CODEREGION(this);
    TemporaryTable globalTable = CodeRegion_globalTable(codeRegion);
    SSAForm_makeConventional(this, globalTable);
    if (!ECL_OPTIMIZE)
      SSAForm_checkConventional(this, globalTable);
    // Prepare for the SSA elimination: rebuild web links.
    // Coalesce phis & Coalesce copies that have Variable_isCoalesced Flag.
    SSAForm_weblinksInit(this, globalTable);
    SSAForm_weblinksFromSSAwebs(this, globalTable);
    // Eliminate the SSA operations and variables.
    SSAForm_eliminate(this);
    // Kill the BasicBlock ENTEREDGES of BasicBlock(s).
    CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
      BasicBlock_killEnterEdges(basicBlock, memory);
    } CodeRegion_ENDEACH_BasicBlock;
    CodeRegion_setSSAForm(codeRegion, NULL);
    PFA_STATS && SSAForm_dumpStats(this, PFA_STATS);
#ifndef ECL_NDTOR
    SSAForm_Dtor(this);
    Memory_free_(memory, this);
#endif//ECL_NDTOR
    Memory_delete(memory);
    PFA_TRACE && (GETENV("SSA_TRACE"))
      && fprintf(PFA_TRACE, " *** After SSA destruct\n")
      && CodeRegion_pretty(codeRegion, PFA_TRACE);
  }
  return NULL;
}

#line 182 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
void
SSAForm_makeConventional(SSAForm this, TemporaryTable temporaryTable)
{
  Memory memory = SSAForm_MEMORY(this);
  CodeRegion codeRegion = SSAForm_CODEREGION(this);
  Optimize optimize = CodeRegion_optimize(codeRegion);
  OptimizeFlags coalescingFlags = Optimize_COALESCING(optimize);
  Dominance dominance = SSAForm_makeDominance(this, 0);
  SSAForm_prepareDedicated(this);
  // Fill the temporaryTable with PHI-related resources, and optionally
  // other candidates to coalescing. Here we include pcopy operands
  // that may have been inserted for register constraints.
  TemporaryTable_empty(temporaryTable);
  Dominance_FORDOMDFS_BasicBlock(dominance, basicBlock) {
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      Operator operator = Operation_operator(operation);
      if (Operator_isSsa(operator) || Operator_isParCopy(operator)) {
        Operation_OPERANDS_FOREACH_Temporary(operation, operand) {
          Except_CHECK(Temporary_isVariable(operand));
          TemporaryTable_insert(temporaryTable, operand);
        } Operation_OPERANDS_ENDEACH_Temporary;
      } else if (Operator_isSeqCopy(operator)) {
        Temporary result = Operation_getResult(operation, 0);
        Temporary argument = Operation_getArgument(operation, 0);
        if (Temporary_isVariable(result) && Temporary_isVariable(argument)) {
          TemporaryTable_insert(temporaryTable, result);
          TemporaryTable_insert(temporaryTable, argument);
        }
      }
    } BasicBlock_ENDEACH_Operation;
  } Dominance_ENDDOMDFS_BasicBlock;
  // Make Operation ORDERING(s).
  SSAForm_makeOrderings(this, 2);
  if (coalescingFlags & OptimizeCoalescing_Decoalesce) {
    Decoalescer decoalescer = Decoalescer_new(memory, codeRegion, this);
    Decoalescer_delete(decoalescer);
  } 
  else if (coalescingFlags & OptimizeCoalescing_Boissinot) {
    Boissinot boissinot = Boissinot_new(memory, codeRegion, this);
    Boissinot_delete(boissinot);
  } 
  else if (coalescingFlags & OptimizeCoalescing_Sreedhar) {
    Sreedhar sreedhar = Sreedhar_new(memory, codeRegion, this);
    Sreedhar_delete(sreedhar);
  }
  Except_CHECK(SSAForm_checkOrderings(this));
  Except_CHECK(SSAForm_checkProducerConsumers(this));
}

#line 240 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
void 
SSAForm_splitAfterCall(SSAForm this)
{
  CodeRegion codeRegion = SSAForm_CODEREGION(this);
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    Operation lastOp = BasicBlock_lastOperation(basicBlock);
    /* Note that exit block do not need to be followed by an empty block. */
    if (   !BasicBlock_isExit(basicBlock)
        && lastOp && Operator_isRoutine(Operation_OPERATOR(lastOp))) {
      BasicBlockEdge leaveEdge = BasicBlock_leaveFirst(basicBlock);
      Except_CHECK(leaveEdge);
      BasicBlockEdge_splitAndAction(leaveEdge, true, NULL, NULL, NULL);
    }
  } CodeRegion_ENDEACH_BasicBlock;
}

#line 262 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
void
SSAForm_prepareDedicated(SSAForm this)
{
  CodeRegion codeRegion = SSAForm_CODEREGION(this);
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    BasicBlockEdge leaveEdge = BasicBlock_leaveFirst(basicBlock);
    BasicBlock destBlock = BasicBlockEdge_destBlock(leaveEdge);
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      Selector selector = BasicBlock_selector(basicBlock);
      // Materialize register constraints of operation.
      if (   Operation_hasRegisters(operation)
          && !Operator_isParCopy(Operation_operator(operation))) {
	Operation pcopy_operation = NULL;
	Operation_ARGUMENTS_FOREACH_Temporary(operation, argument) {
	  int32_t argIdx = Operation_ARGUMENTS_INDEX, copyIdx = 0;
	  Register registre = Operation_getUseRegister(operation, argIdx);
	  if (Temporary_isVariable(argument) && registre != Register__UNDEF) {
            Variable variable = Temporary_VARIABLE(argument);
            Temporary origin = Variable_ORIGIN(variable);
            Temporary new_argument = CodeRegion_makeVariableTemporary(codeRegion, origin);
            Variable new_variable = Temporary_VARIABLE(new_argument);
	    *Variable__PINNED(new_variable) = registre;
	    if (pcopy_operation == NULL) {
              int32_t argCount = Operation_argCount(operation);
	      pcopy_operation = Selector_makeOperationParCopy(selector, Operator_PCOPY,
                                                              argCount, true);
	      Selector_moveOperationBefore(selector, operation, pcopy_operation);
	    }
            copyIdx = Operation_addtoParCopy(pcopy_operation, new_argument, argument);
            Variable_setOperationArgument(new_variable, operation, argIdx);
            Variable_setOperationArgument(variable, pcopy_operation, copyIdx);
            Variable_setOperationResult(new_variable, pcopy_operation, copyIdx);
            Operation_setDefRegister(pcopy_operation, copyIdx, registre);
	  }
	} Operation_ARGUMENTS_ENDEACH_Temporary;
	pcopy_operation = NULL;
	if (!Operator_isRoutine(Operation_OPERATOR(operation))) {
	  Operation_RESULTS_FOREACH_Temporary(operation, result) {
	    int32_t resIdx = Operation_RESULTS_INDEX, copyIdx = 0;
	    Register registre = Operation_getDefRegister(operation, resIdx);
	    if (Temporary_isVariable(result) && registre != Register__UNDEF) {
              Variable variable = Temporary_VARIABLE(result);
              Temporary origin = Variable_ORIGIN(variable);
              Temporary new_result = CodeRegion_makeVariableTemporary(codeRegion, origin);
              Variable new_variable = Temporary_VARIABLE(new_result);
	      *Variable__PINNED(new_variable) = registre;
	      if (pcopy_operation == NULL) {
                int32_t resCount = Operation_resCount(operation);
                pcopy_operation = Selector_makeOperationParCopy(selector, Operator_PCOPY,
                                                                resCount, true);
                Selector_moveOperationAfter(selector, operation, pcopy_operation);
	      }
	      copyIdx = Operation_addtoParCopy(pcopy_operation, result, new_result);
	      Variable_setOperationResult(new_variable, operation, resIdx);
	      Variable_setOperationArgument(new_variable, pcopy_operation, copyIdx);
	      Variable_setOperationResult(variable, pcopy_operation, copyIdx);
	      Operation_setUseRegister(pcopy_operation, copyIdx, registre);
	    }
	  } Operation_RESULTS_ENDEACH_Temporary;
	} else /*Operator_isRoutine(Operation_OPERATOR(operation))*/
	if (   BasicBlock_leaveCount(basicBlock) == 1
            && BasicBlock_enterCount(destBlock) == 1) {
	  Operation_RESULTS_FOREACH_Temporary(operation, result) {
	    int32_t resIdx = Operation_RESULTS_INDEX, copyIdx = 0;
	    Register registre = Operation_getDefRegister(operation, resIdx);
	    if (Temporary_isVariable(result) && registre != Register__UNDEF) {
              Variable variable = Temporary_VARIABLE(result);
              Temporary origin = Variable_ORIGIN(variable);
              Temporary new_result = CodeRegion_makeVariableTemporary(codeRegion, origin);
              Variable new_variable = Temporary_VARIABLE(new_result);
	      *Variable__PINNED(new_variable) = registre;
	      if (pcopy_operation == NULL) {
                int32_t resCount = Operation_resCount(operation);
                Selector nextSelector = BasicBlock_selector(destBlock);
                pcopy_operation = Selector_makeOperationParCopy(nextSelector, Operator_PCOPY,
                                                                resCount, true);
                Selector_moveOperationFirst(nextSelector, pcopy_operation);
	      }
	      copyIdx = Operation_addtoParCopy(pcopy_operation, result, new_result);
	      Variable_setOperationResult(new_variable, operation, resIdx);
	      Variable_setOperationArgument(new_variable, pcopy_operation, copyIdx);
	      Variable_setOperationResult(variable, pcopy_operation, copyIdx);
	      Operation_setUseRegister(pcopy_operation, copyIdx, registre);
	    }
	  } Operation_RESULTS_ENDEACH_Temporary;
	}
      }
    } BasicBlock_ENDEACH_Operation;
  } CodeRegion_ENDEACH_BasicBlock;
}

#line 353 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
////////////////////////////////////////////////////////////////////////////////////

#line 361 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
Memory
SSAForm_memory(SSAForm this)
{
  return SSAForm_MEMORY(this);
}

#line 373 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
CodeRegion
SSAForm_codeRegion(SSAForm this)
{
  return SSAForm_CODEREGION(this);
}

#line 385 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
void
SSAForm_makeOrderings(SSAForm this, int32_t increment)
{
  int32_t ordering = 0;
  Dominance dominance = SSAForm_DOMINANCE(this);
  Dominance_FORDOMDFS_BasicBlock(dominance, basicBlock) {
    ordering = BasicBlock_makeOrderings(basicBlock, ordering, increment);
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      Operation_RESULTS_FOREACH_Temporary(operation, result) {
        if (Temporary_isVariable(result)) {
          Variable variable = Temporary_VARIABLE(result);
          *Variable__ORDERING(variable) = Operation_ordering(operation);
        }
      } Operation_RESULTS_ENDEACH_Temporary;
    } BasicBlock_ENDEACH_Operation;
  } Dominance_ENDDOMDFS_BasicBlock;
}

#line 409 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
Dominance
SSAForm_makeDominance(SSAForm this, DominanceFlags flags)
{
  Memory memory = SSAForm_MEMORY(this);
  CodeRegion codeRegion = SSAForm_CODEREGION(this);
  Dominance dominance = SSAForm_DOMINANCE(this);
  flags &= ~DominanceFlag_Backward;
  flags |= DominanceFlag_Forward;
  if (   dominance == NULL
      || (Dominance_FLAGS(dominance) & flags) != flags) {
    dominance = Dominance_new(memory, codeRegion, flags);
    *SSAForm__DOMINANCE(this) = dominance;
  }
  return dominance;
}

#line 433 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
void
SSAForm_killDominance(SSAForm this)
{
  if (SSAForm_DOMINANCE(this) != NULL) {
    Dominance_delete(SSAForm_DOMINANCE(this));
  }
  *SSAForm__DOMINANCE(this) = NULL;
}

#line 448 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
IBList
SSAForm_variables(SSAForm this)
{
  return SSAForm_VARIABLES(this);
}

#line 470 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
bool
SSAForm_isStrict(const_SSAForm this)
{
  bool result = true;
  Dominance dominance = SSAForm_DOMINANCE(this);
  int32_t *preDFN = Dominance_PREDFN(dominance);
  int32_t *lastDFN = Dominance_LASTDFN(dominance);
  CodeRegion codeRegion = SSAForm_CODEREGION(this);
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    int32_t consumer_index = BasicBlock_index(basicBlock);
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      Except_CHECK(basicBlock == Operation_basicBlock(operation));
      Operation_ARGUMENTS_FOREACH_Temporary(operation, argument) {
        if (Temporary_isVariable(argument)) {
          Variable variable = Temporary_VARIABLE(argument);
          OperationResult producer = Variable_PRODUCER(variable);
          Operation producer_operation = OperationResult_OPERATION(producer);
          BasicBlock producer_block = Operation_basicBlock(producer_operation);
          int32_t producer_index = BasicBlock_index(producer_block);
          result |= Dominance_DOMINATES(preDFN, lastDFN, producer_index, consumer_index);
        }
      } Operation_ARGUMENTS_ENDEACH_Temporary;
    } BasicBlock_ENDEACH_Operation;
  } CodeRegion_ENDEACH_BasicBlock;
  return result;
}

#line 497 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 505 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
void
SSAForm_fillTemporaryTable(SSAForm this, TemporaryTable table)
{
  CodeRegion codeRegion = SSAForm_CODEREGION(this);
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      Operation_RESULTS_FOREACH_Temporary(operation, result) {
        if (Temporary_isVariable(result)) {
          TemporaryTable_insert(table, result);
        }
      } Operation_RESULTS_ENDEACH_Temporary;
    } BasicBlock_ENDEACH_Operation;
  } CodeRegion_ENDEACH_BasicBlock;
}

#line 526 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
bool
SSAForm_checkOrderings(SSAForm this)
{
  CodeRegion codeRegion = SSAForm_CODEREGION(this);
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    if (!BasicBlock_checkOrderings(basicBlock)) return false;
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      int32_t ordering = Operation_ordering(operation);
      Operation_RESULTS_FOREACH_Temporary(operation, result) {
        if (Temporary_isVariable(result)) {
          Variable variable = Temporary_VARIABLE(result);
          if (Variable_ORDERING(variable) != ordering) {
            Except_CHECK(Variable_ORDERING(variable) == ordering);
            return false;
          }
        }
      } Operation_RESULTS_ENDEACH_Temporary;
    } BasicBlock_ENDEACH_Operation;
  } CodeRegion_ENDEACH_BasicBlock;
  return true;
}

#line 554 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
bool
SSAForm_checkProducerConsumers(SSAForm this)
{
  CodeRegion codeRegion = SSAForm_CODEREGION(this);
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      Operation_RESULTS_FOREACH_Temporary(operation, result) {
        if (Temporary_isVariable(result)) {
          Variable variable = Temporary_VARIABLE(result);
          OperationResult producer = Variable_PRODUCER(variable);
          if (   OperationResult_OPERATION(producer) != operation
              || OperationResult_RESINDEX(producer) != Operation_RESULTS_INDEX) {
            Except_CHECK(OperationResult_OPERATION(producer) == operation);
            Except_CHECK(OperationResult_RESINDEX(producer) == Operation_RESULTS_INDEX);
            return false;
          }
        }
      } Operation_RESULTS_ENDEACH_Temporary;
      Operation_ARGUMENTS_FOREACH_Temporary(operation, argument) {
        if (Temporary_isVariable(argument)) {
          Variable variable = Temporary_VARIABLE(argument);
          if (Variable_isConsuming(variable)) {
            bool inUse = false;
            Variable_CONSUMERS_FOREACH_OperationArgument(variable, consumer) {
              if (    OperationArgument_OPERATION(consumer) == operation
                  &&  OperationArgument_ARGINDEX(consumer) == Operation_ARGUMENTS_INDEX) {
                inUse = true;
              }
            } Variable_CONSUMERS_ENDEACH_OperationArgument;
            if (!inUse) {
              Except_CHECK(variable == NULL);
              return false;
            }
          }
        }
      } Operation_ARGUMENTS_ENDEACH_Temporary;
    } BasicBlock_ENDEACH_Operation;
  } CodeRegion_ENDEACH_BasicBlock;
  return true;
}

#line 595 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 603 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
void 
SSAForm_emptyVariableWebs (SSAForm this, TemporaryTable globalTable)
{
  CodeRegion codeRegion = SSAForm_CODEREGION(this);
  TemporaryTable_FOREACH_Temporary(globalTable, temporary) {
    Variable variable = Temporary_VARIABLE(temporary);
    *Variable__WEBLINK(variable) = NULL;
    *Variable__WEBRANK(variable) = 0;
  } TemporaryTable_ENDEACH_Temporary;
}

#line 620 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
void
SSAForm_weblinksInit(SSAForm this, TemporaryTable temporaryTable)
{
  Variable *dedicatedRoot = NULL;
  Memory memory = SSAForm_MEMORY(this);
  CodeRegion codeRegion = SSAForm_codeRegion(this);
  TemporaryTable_FOREACH_Temporary(temporaryTable, temporary) {
    Variable variable = Temporary_VARIABLE(temporary);
    Register registre = Variable_PINNED(variable);
    // Ensure the congruence fields are cleared.
    *Variable__WEBLINK(variable) = NULL;
    *Variable__WEBRANK(variable) = 0;
    // If the variable is constrained to a specific register we must mark the congruence class.
    if (registre != Register__UNDEF) {
      if (dedicatedRoot == NULL) {
        dedicatedRoot = Memory_alloc(memory, Register__COUNT*sizeof(Variable));
        memset(dedicatedRoot, 0, Register__COUNT*sizeof(Variable));
      }
      if (dedicatedRoot[registre] == NULL) {
        dedicatedRoot[registre] = variable;
      } else {
        Variable_linkWebRoots(dedicatedRoot[registre], variable);
      }
    }
  } TemporaryTable_ENDEACH_Temporary;
  if (0&& PFA_TRACE && dedicatedRoot != NULL) {
    fprintf(PFA_TRACE, "*** Weblink initialized\n");
    TemporaryTable_FOREACH_Temporary(temporaryTable, temporary) {
      Variable variable = Temporary_VARIABLE(temporary);
      PFA_TRACE && Variable_pretty(variable, PFA_TRACE, false) && fprintf(PFA_TRACE, " => ")
                && Variable_pretty(Variable_findWebRoot(variable), PFA_TRACE, false)
                && fprintf(PFA_TRACE, "\n");
    } TemporaryTable_ENDEACH_Temporary;
  }
  if (dedicatedRoot != NULL) {
    Memory_free(memory, dedicatedRoot);
  }
}

#line 669 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
void
SSAForm_weblinksFromSSAwebs(SSAForm this, TemporaryTable temporaryTable)
{
  CodeRegion codeRegion = SSAForm_CODEREGION(this);
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      Operator operator = Operation_operator(operation);
      if (Operator_isSsa(operator)) {
        int32_t operandCount = Operation_operandCount(operation), i;
        Temporary *operands = Operation_operands(operation);
        Variable variable_0 = Temporary_VARIABLE(operands[0]);
        Variable webRoot_0 = Variable_findWebRoot(variable_0);
        for (i = 1; i < operandCount; i++) {
          Variable variable_i = Temporary_VARIABLE(operands[i]);
          Variable webRoot_i = Variable_findWebRoot(variable_i);
          if (webRoot_0 != webRoot_i) {
	    if (   TemporaryTable_contains(temporaryTable, Variable_TEMPORARY(webRoot_0)) 
		&& TemporaryTable_contains(temporaryTable, Variable_TEMPORARY(webRoot_i))) { 
	      webRoot_0 = Variable_linkWebRoots(webRoot_0, webRoot_i);
	    }
          }
        }
      } else
      if (   Operator_isSeqCopy(operator)
          || Operator_isParCopy(operator)) {
        int32_t argCount = Operation_argCount(operation), i;
        Temporary *arguments = Operation_arguments(operation);
        Temporary *results = Operation_results(operation);
        for (i = 0; i < argCount; i++) {
          if (   Temporary_isVariable(arguments[i])
              && Temporary_isVariable(results[i])) {
            Variable source = Temporary_VARIABLE(arguments[i]);
            Variable target = Temporary_VARIABLE(results[i]);
            if (Variable_isCoalesced(target)) {
              Variable source_webRoot = Variable_findWebRoot(source);
              Variable target_webRoot = Variable_findWebRoot(target);
              if (source_webRoot != target_webRoot) {
                Variable_linkWebRoots(source_webRoot, target_webRoot);
              }
            }
          }
        }
      }
    } BasicBlock_ENDEACH_Operation;
  } CodeRegion_ENDEACH_BasicBlock;
}

#line 724 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
void
SSAForm_eliminate(SSAForm this)
{
  CodeRegion codeRegion = SSAForm_CODEREGION(this);
  Optimize optimize = CodeRegion_optimize(codeRegion);
  Procedure procedure = CodeRegion_procedure(codeRegion);
  // Optionally limit the reuse of Virtual Temporary(ies) when eliminating variables.
  if (FORCE_REUSELIMIT > 0) {
    int32_t limit = FORCE_REUSELIMIT;
    CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
      BasicBlock_FOREACH_Operation(basicBlock, operation) {
        Operation_OPERANDS_FOREACH_Temporary(operation, temporary) {
          if (Temporary_isVariable(temporary)) {
            Variable variable = Temporary_VARIABLE(temporary);
            Temporary origin = Variable_ORIGIN(variable);
            Except_CHECK(Temporary_isVirtual(origin));
            if (Temporary_WEBROOT(origin) == NULL) {
              *Temporary__WEBROOT(origin) = (void *)0x1;
              if (--limit < 0) return;
            }
          }
        } Operation_OPERANDS_ENDEACH_Temporary;
      } BasicBlock_ENDEACH_Operation;
    } CodeRegion_ENDEACH_BasicBlock;
  }
  // First, eliminate PCOPY as the elimination algorithm requires Variable(s).
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      Operator operator = Operation_operator(operation);
      if (Operator_isParCopy(operator)) {
        SSAForm_expandParCopyOperation(this, operation);
        BasicBlock_detachOperation(basicBlock, operation);
      } else if (Operator_isSeqCopy(operator)) {
        Temporary result = Operation_getResult(operation, 0);
        Temporary argument = Operation_getArgument(operation, 0);
        if (Temporary_isVariable(result) && Temporary_isVariable(argument)) {
          Variable variable_0 = Temporary_VARIABLE(result);
          Variable variable_1 = Temporary_VARIABLE(argument);
          if (Variable_findWebRoot(variable_0) == Variable_findWebRoot(variable_1)) {
            BasicBlock_detachOperation(basicBlock, operation);
          }
        }
      } else if (Operator_isSsa(operator)) {
        BasicBlock_detachOperation(basicBlock, operation);
      }
    } BasicBlock_ENDEACH_Operation;
    Except_CHECK(BasicBlock_phiCount(basicBlock) == 0);
  } CodeRegion_ENDEACH_BasicBlock;
  // Then, rename the SSA webs into non-Variable Temporary(ies).
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      Operation_OPERANDS_FOREACH_Temporary(operation, temporary) {
        if (Temporary_isVariable(temporary)) {
          Variable variable = Temporary_VARIABLE(temporary);
          Variable webRoot = Variable_findWebRoot(variable);
          Temporary origin = Variable_ORIGIN(webRoot);
	  if (Variable_PINNED(webRoot) != Register__UNDEF) {
	    // Use dedicated temporary.
	    origin = Procedure_makeDedicatedTemporary(procedure, Variable_PINNED(webRoot));
	  } else {
	    Except_CHECK(Temporary_isVirtual(origin));
	    if (Temporary_WEBROOT(origin) != webRoot) {
	      // Virtual Temporary already in use, make another like it.
	      origin = Procedure_copyVirtualTemporary(procedure, origin);
	      *Temporary__WEBROOT(origin) = webRoot;
	      *Variable__ORIGIN(webRoot) = origin;
	    } else {
	      // Virtual Temporary not used yet for rename back.
	      *Temporary__WEBROOT(origin) = webRoot;
	    }
	    Except_CHECK(Temporary_isRenameOK(origin));
	  }
	  Operation_OPERANDS[Operation_OPERANDS_INDEX] = origin;
          0 &&
          PFA_TRACE && fprintf(PFA_TRACE, "Find webRoots")
                    && Temporary_pretty(temporary, PFA_TRACE)
                    && Temporary_pretty(origin, PFA_TRACE) 
	            && fprintf(PFA_TRACE, "\n");
        }
      } Operation_OPERANDS_ENDEACH_Temporary;
      // Reset Operation ORDERING.
      Operation_setOrdering(operation, -1);
    } BasicBlock_ENDEACH_Operation;
  } CodeRegion_ENDEACH_BasicBlock;
}

#line 823 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
void
SSAForm_expandParCopyOperation(SSAForm this, Operation pcopy)
{
  CodeRegion codeRegion = SSAForm_CODEREGION(this);
  BasicBlock basicBlock = Operation_basicBlock(pcopy);
  Selector selector = BasicBlock_selector(basicBlock);
  Operation first_point = pcopy, last_point = pcopy;
  Except_CHECK(Operator_isParCopy(Operation_operator(pcopy)));
  //
  // First, clear flags used and defined on operands.
  Operation_OPERANDS_FOREACH_Temporary(pcopy, operand) {
    Variable V = Variable_findWebRoot(Temporary_VARIABLE(operand));
    Except_CHECK(Temporary_isVariable(operand));
    Variable_clearPCOPYDef(V);
    Variable_clearPCOPYUse(V);
  } Operation_OPERANDS_ENDEACH_Temporary;
  //
  Operation_RESULTS_FOREACH_Temporary(pcopy, result) {
    Variable V_dst = Variable_findWebRoot(Temporary_VARIABLE(result));
    Temporary argument = Operation_getArgument(pcopy, Operation_RESULTS_INDEX);
    Variable V_src = Variable_findWebRoot(Temporary_VARIABLE(argument));
    if (V_dst != V_src && !Variable_isPCOPYDef(V_dst)) {
      if (   Variable_isPCOPYDef(V_src)
          && Variable_isPCOPYUse(V_dst)) {
        // Break cycle.
        Temporary origin = Variable_ORIGIN(V_dst);
        Temporary temporary = CodeRegion_makeVariableTemporary(codeRegion, origin);
        Variable V_tmp = Temporary_VARIABLE(temporary);
        Operation copy = NULL;
        //
        copy = Selector_makeOperationCOPY(selector, temporary, argument);
        Selector_moveOperationBefore(selector, first_point, copy);
        Variable_setOperationResult(V_tmp, copy, 0);
        Variable_setOperationArgument(V_src, copy, 0);
        first_point = copy;
        //
        copy = Selector_makeOperationCOPY(selector, result, temporary);
        Selector_moveOperationAfter(selector, last_point, copy);
        Variable_setOperationResult(V_dst, copy, 0);
        Variable_setOperationArgument(V_tmp, copy, 0);
        last_point = copy;
      }
      else if (Variable_isPCOPYDef(V_src)) {
        // Insert copy before first_point.
        Operation copy = Selector_makeOperationCOPY(selector, result, argument);
        Selector_moveOperationBefore(selector, first_point, copy);
        Variable_setOperationResult(V_dst, copy, 0);
        Variable_setOperationArgument(V_src, copy, 0);
        first_point = copy;
      }
      else {
        // Append copy after last_point.
        Operation copy = Selector_makeOperationCOPY(selector, result, argument);
        Selector_moveOperationAfter(selector, last_point, copy);
        Variable_setOperationResult(V_dst, copy, 0);
        Variable_setOperationArgument(V_src, copy, 0);
        last_point = copy;
      }
    }
    Variable_raisePCOPYUse(V_src);
    Variable_raisePCOPYDef(V_dst);
  } Operation_RESULTS_ENDEACH_Temporary;
}

#line 887 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 895 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
#ifndef ECL_NTRACE
bool
SSAForm_pretty(SSAForm this, FILE *file)
{
  if (file == NULL) file = stderr;
  SSAForm_FOREACH_Variable(this, variable) {
    Temporary temporary = Variable_TEMPORARY(variable);
    OperationResult producer = Variable_PRODUCER(variable);
    Operation producer_operation = OperationResult_OPERATION(producer);
    fprintf(file, "    ") && Temporary_pretty(temporary, file) && fprintf(file, ":\n");
    fprintf(file, "\tProducer") && Operation_pretty(producer_operation, file);
    Variable_CONSUMERS_FOREACH_OperationArgument(variable, consumer) {
      Operation consumer_operation = OperationArgument_OPERATION(consumer);
      fprintf(file, "\tConsumer") && Operation_pretty(consumer_operation, file);
    } Variable_CONSUMERS_ENDEACH_OperationArgument;
  } SSAForm_ENDEACH_Variable;
  return true;
}
#endif//ECL_NTRACE

#line 921 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
#ifndef ECL_NTRACE
bool
SSAForm_display(SSAForm this, FILE *file, const char *name)
{
  CodeRegion codeRegion = SSAForm_CODEREGION(this);
  if (file == NULL) file = stderr;
  // Start the graph
  fprintf(file, "digraph \"%s\" {\n", name);
  fprintf(file, "  node [shape=record];");
  // Add all basic blocks to the graph
  CodeRegion_FOREACH_BasicBlock(codeRegion, block) {
    int index = BasicBlock_index(block);
    fprintf(file, "  BB%d [label=\"{BB%d|", index, index);
    TemporarySet_display(BasicBlock_phiInSet(block), file);
    fprintf(file, "|");
    TemporarySet_display(BasicBlock_liveInSet(block), file);
    fprintf(file, "|");
    BasicBlock_FOREACH_Operation(block, operation) {
      if (   Operator_isPhi(Operation_operator(operation))
          || Operator_isSeqCopy(Operation_operator(operation))) {
        //Operation_pretty(operation, file);
        if (Operator_isSeqCopy(Operation_operator(operation)))
          fprintf (file, "COPY\\ :\\ ");
        Temporary_pretty(Operation_getResult(operation, 0), file);
        fprintf(file, "\\ =\\ ");
        if (Operator_isPhi(Operation_operator(operation)))
          fprintf(file, "PHI(");
        Operation_ARGUMENTS_FOREACH_Temporary(operation, argument) {
          Temporary_pretty(argument, file);
          if (Operation_ARGUMENTS_INDEX != Operation_ARGCOUNT-1)
            fprintf(file, ",\\ ");
        } Operation_ARGUMENTS_ENDEACH_Temporary;
        if (Operator_isPhi(Operation_operator(operation)))
          fprintf(file, ")");
        fprintf(file, "\\n");
      }
    } BasicBlock_ENDEACH_Operation;
    fprintf(file, "|");
    TemporarySet_display(BasicBlock_liveOutSet(block), file);
    fprintf(file, "|");
    TemporarySet_display(BasicBlock_phiOutSet(block), file);
    fprintf(file, "}\"];\n");
    // Now dump all the outgoing edges
    BasicBlock_LEAVE_FOREACH_BasicBlockEdge(block, edge) {
        fprintf(file, "  BB%d -> BB%d [label=\"%d\"];\n",
                BasicBlock_index(BasicBlockEdge_origBlock(edge)),
                BasicBlock_index(BasicBlockEdge_destBlock(edge)),
                BasicBlockEdge_ARGINDEX(edge));
    } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
  } CodeRegion_ENDEACH_BasicBlock;
  fprintf(file, "}\n");
  return true;
}
#endif//ECL_NTRACE

#line 982 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
#ifndef ECL_NTRACE
bool
SSAForm_dumpAppelGraph(SSAForm this, FILE *file, const char *name)
{
  int dump_phi = 1;
  int n_tmps = IndexedFactory_maxCount(Temporary_Factory);
  int n_dedicated;
  Memory memory = SSAForm_MEMORY(this);
  // We must first compute interferences
  CodeRegion codeRegion = SSAForm_CODEREGION(this);
  Program program = Procedure_program(CodeRegion_procedure(codeRegion));
  TemporaryTable globalTable = CodeRegion_globalTable(codeRegion);
  Liveness liveness = Liveness_make(memory, codeRegion, globalTable, true);
  Interference interference = Interference_make(memory, codeRegion, liveness, false);
  TemporarySet_ universe[1];
  int i;
  IBList_ congruences[1];
  VariableClass *dedicatedClass = NULL;
  n_dedicated = Register__COUNT > 1?
                Temporary_IDENTITY(Program_dedicated(program) + Register__COUNT -1) + 1: 0;
  TemporarySet_Ctor(universe, memory,
                    TemporaryTable_count(Liveness_TEMPORARYTABLE(liveness)));
  fprintf(file, "(* Procedure %s *)\n", name);
  fprintf(file, "%d %d\n\n", n_tmps, n_dedicated);
  fprintf(file, "(* INTERFERENCE format : x y -1 *)\n");
  fprintf(file, "(* COPY format         : res arg weight *)\n");
  fprintf(file, "(* PCOPY format        : res0 arg0 weight ... resn argn weight *)\n");
  fprintf(file, "(* PHI format          : (*@ PHIbb res arg0 ... argn @*) *)\n");
  fprintf(file, "(* DED format          : (*@ DED ded var0 ... varn @*) *)\n");
  fprintf(file, "\n");
  IBList_Ctor(congruences, memory, sizeof(VariableClass_), Register__COUNT);
  TemporaryTable_FOREACH_Temporary(globalTable, temporary) {
    Variable variable = Temporary_VARIABLE(temporary);
    VariableClass congruence;
    Register registre = Variable_PINNED(variable);
    if (registre != Register__UNDEF) {
      if (dedicatedClass == NULL) {
	int i;
	dedicatedClass = Memory_alloc(memory, Register__COUNT*sizeof(VariableClass));
	memset(dedicatedClass, 0, Register__COUNT*sizeof(VariableClass));
      }
      if (dedicatedClass[registre] == NULL) {
	congruence = IBList_push(congruences);
	dedicatedClass[registre] = congruence;
	VariableClass_Ctor(congruence, variable);
      } else {
	congruence = dedicatedClass[registre];
	VariableClass_insert(congruence, variable);
      }
    } 
  } TemporaryTable_ENDEACH_Temporary;
  if (dedicatedClass != NULL) {
    for(i = 0; i < Register__COUNT; i++) {
      if (dedicatedClass[i] != NULL) {
	fprintf(file, "(@ DED %d", Temporary_IDENTITY(&Program_dedicated(program)[i]));
	VariableClass_FOREACH_Variable(dedicatedClass[i], variable) {
	  fprintf(file, " %d", Temporary_IDENTITY(Variable_TEMPORARY(variable)));
	} VariableClass_ENDEACH_Variable;
	fprintf(file, " @)\n");
      }
    }
    Memory_free(memory, dedicatedClass);
  }
  IBList_empty(congruences, (IBListItemRelease)VariableClass_Dtor);
  CodeRegion_FOREACH_BasicBlock(codeRegion, block) {
    BasicBlock_FOREACH_Operation(block, operation) {
      if (Operator_isSeqCopy(Operation_operator(operation))) {
        Temporary result = Operation_getResult(operation, 0);
        Temporary argument = Operation_getArgument(operation, 0);
        fprintf(file, " %d %d %f\n", Temporary_IDENTITY(result),
                Temporary_IDENTITY(argument), BasicBlock_frequency(block));
        TemporarySet_addMember(universe, result);
        TemporarySet_addMember(universe, argument);
      } else if (Operator_isParCopy(Operation_operator(operation))) {
        const char *sep = " ";
        Operation_ARGUMENTS_FOREACH_Temporary(operation, argument) {
          Temporary result = Operation_getResult(operation, Operation_ARGUMENTS_INDEX);
          fprintf(file, "%s%d %d %f", sep, Temporary_IDENTITY(result),
                  Temporary_IDENTITY(argument), BasicBlock_frequency(block));
          TemporarySet_addMember(universe, result);
          TemporarySet_addMember(universe, argument);
        } Operation_ARGUMENTS_ENDEACH_Temporary;
        fprintf(file, "\n");
      } else if (dump_phi && Operator_isPhi(Operation_operator(operation))) {
        const char *sep = " ";
        fprintf(file, " (*@ PHI%d", BasicBlock_index(block));
        fprintf(file, " %d", Temporary_IDENTITY(Operation_getResult(operation, 0)));
        TemporarySet_addMember(universe, Operation_getResult(operation, 0));
        Operation_ARGUMENTS_FOREACH_Temporary(operation, argument) {
          fprintf(file, "%s%d", sep, Temporary_IDENTITY(argument));
          TemporarySet_addMember(universe, argument);
        } Operation_ARGUMENTS_ENDEACH_Temporary;
        fprintf(file, " @*)\n");
      }
    } BasicBlock_ENDEACH_Operation;
  } CodeRegion_ENDEACH_BasicBlock;
  // Dump Interferences
  TemporarySet_FOREACH_Temporary(universe, temporary_1) {
    TemporarySet_FOREACH_Temporary(universe, temporary_2) {
      if (Interference_exists(interference, temporary_1, temporary_2)) {
        if (Temporary_IDENTITY(temporary_1) > Temporary_IDENTITY(temporary_2)) {
          fprintf(file, " %d %d -1\n", Temporary_IDENTITY(temporary_1),
                  Temporary_IDENTITY(temporary_2));
        }
      }
    } TemporarySet_ENDEACH_Temporary;
  } TemporarySet_ENDEACH_Temporary;
  
  fprintf(file, "(* End Procedure %s *)\n", name);
  Liveness_kill(liveness);
  Interference_kill(interference);
  TemporarySet_Dtor(universe);
  return true;
}
#endif//ECL_NTRACE

#line 1105 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
#ifndef ECL_NTRACE
static bool
SSAForm_dumpStats(const_SSAForm this, FILE *file)
{
  CodeRegion codeRegion = SSAForm_CODEREGION(this);
  Procedure procedure = CodeRegion_procedure(codeRegion);
  const char *name = Procedure_name(procedure);
  int n_moves = 0;
  float weighted_moves = 0;
  int n_ops = 0;
  float n_weighted_ops = 0;
  CodeRegion_FOREACH_BasicBlock(codeRegion, block) {
    BasicBlock_FOREACH_Operation(block, operation) {
      n_ops++;
      n_weighted_ops += BasicBlock_frequency(block);
      if (Operator_isSeqCopy(Operation_operator(operation))) {
        n_moves++;
        weighted_moves += BasicBlock_frequency(block);
      }
    } BasicBlock_ENDEACH_Operation;
  } CodeRegion_ENDEACH_BasicBlock;

#line 1127 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
  fprintf(file, "<ECL.PFA.SSAForm.stats.n_moves> %d %s\n", n_moves, name);
  fprintf(file, "<ECL.PFA.SSAForm.stats.weighted_moves> %f %s\n", weighted_moves, name);
  fprintf(file, "<ECL.PFA.SSAForm.stats.n_ops> %d %s\n", n_ops, name);
  fprintf(file, "<ECL.PFA.SSAForm.stats.weighted_ops> %f %s\n", n_weighted_ops, name);
  return true;
}
#endif//ECL_NTRACE

#line 1135 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1200 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1212 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
#ifndef SSAForm_INIT
void
SSAForm_INIT(void)
{
#ifndef SSAForm_MERGESETS
  if (GETENV("SSAForm_MERGESETS")) {
    sscanf(GETENV("SSAForm_MERGESETS"), "%d", &SSAForm_MERGESETS);
    fprintf(stderr, "*** SSAForm_MERGESETS=%d\n", SSAForm_MERGESETS);
  }
#endif//SSAForm_MERGESETS
}
#endif//SSAForm_INIT

#line 1230 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
#if XCC__C
static void
SSAForm_TEST(void)
{
#include "PFA/SSAForm_.c"
}

#line 1237 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
int
main(int argc, char **argv)
{
  PFA_Test(SSAForm_TEST);
  return 0;
}
#endif


#endif//SSAForm_c_INCLUDED
