#ifndef Sreedhar_c_INCLUDED
#define Sreedhar_c_INCLUDED

#line 19 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
#include "PFA/PFA_.h"

#line 24 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 57 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
Sreedhar
Sreedhar_Ctor(Sreedhar this,
              Memory memory, CodeRegion codeRegion, SSAForm ssaForm)
{
  Optimize optimize = CodeRegion_optimize(codeRegion);
  OptimizeFlags coalescingFlags = Optimize_COALESCING(optimize);
  TemporaryTable temporaryTable = CodeRegion_globalTable(codeRegion);
  int32_t phiCount = TemporaryTable_count(temporaryTable);
  Dominance dominance = SSAForm_DOMINANCE(ssaForm);
  Coalescer coalescer = Sreedhar_COALESCER(this);
  Coalescer_Ctor(coalescer, memory, codeRegion, temporaryTable, dominance, coalescingFlags);
  if (Coalescer_CONSUMING(coalescer)) {
    CodeRegion_makeConsumers(codeRegion, temporaryTable);
  }
  OperationStack_Ctor(Sreedhar_PHIOPERATIONS(this), memory, phiCount);
  *Sreedhar__MAXPHIARITY(this) = Sreedhar_fillPhiOperations(this);
  PtrSet_Ctor(Sreedhar_CANDIDATESET(this), memory, 0);
  PtrSeq_Ctor(Sreedhar_UNRESOLVED(this), memory, Sreedhar_MAXPHIARITY(this));
  *Sreedhar__NEIGHBORSETS(this) = NULL;
  if (Sreedhar_MAXPHIARITY(this) > 0) {
    int32_t maxPhiArity = Sreedhar_MAXPHIARITY(this), i;
    size_t neighborSetsSize = sizeof(PtrSet_)*maxPhiArity;
    PtrSet_ *neighborSets = Memory_alloc(memory, neighborSetsSize);
    for (i = 0; i < maxPhiArity; i++) {
      PtrSet_Ctor(neighborSets + i, memory, 0);
    }
    *Sreedhar__NEIGHBORSETS(this) = neighborSets;
  }
  PFA_TRACE && fprintf(PFA_TRACE, "*** Before Sreedhar CSSA\n")
            && CodeRegion_pretty(codeRegion, PFA_TRACE)
            && SSAForm_pretty(ssaForm, PFA_TRACE);
  // Sreedhar I or III.
  Coalescer_complete(coalescer);
  {
    // Method III 2: for each phi operation.
    OperationStack phiOperations = Sreedhar_PHIOPERATIONS(this);
    OperationStack_FOREACH_Operation(phiOperations, operation) {
      Sreedhar_doMethod_III_3_4_5_6_7(this, operation, coalescingFlags);
    } OperationStack_ENDEACH_Operation;
    if (PFA_TRACE) {
      fprintf(PFA_TRACE, "*** SSA Congruences\n");
      TemporaryTable_FOREACH_Temporary(temporaryTable, temporary) {
        Variable variable = Temporary_VARIABLE(temporary);
        VariableClass congruence = Variable_CONGRUENCE(variable);
        PFA_TRACE && Temporary_pretty(temporary, PFA_TRACE)
                  && fprintf(PFA_TRACE, " => ")
                  && VariableClass_pretty(congruence, PFA_TRACE, false)
                  && fprintf(PFA_TRACE, "\n");
      } TemporaryTable_ENDEACH_Temporary;
    }
  }
  if (coalescingFlags & OptimizeCoalescing_Congruence) {
    Coalescer_coalesceCongruences(coalescer);
  }
  PFA_TRACE && (GETENV("SSA_TRACE"))
            && fprintf(PFA_TRACE, " *** After Sreedhar CSSA\n")
            && CodeRegion_pretty(codeRegion, PFA_TRACE);
  return this;
}

#line 117 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
void
Sreedhar_Dtor(Sreedhar this)
{
  Memory memory = Sreedhar_MEMORY(this);
  Coalescer_Dtor(Sreedhar_COALESCER(this));
  OperationStack_Dtor(Sreedhar_PHIOPERATIONS(this));
  PtrSet_Dtor(Sreedhar_CANDIDATESET(this));
  PtrSeq_Dtor(Sreedhar_UNRESOLVED(this));
  if (Sreedhar_MAXPHIARITY(this) > 0) {
    int32_t maxPhiArity = Sreedhar_MAXPHIARITY(this), i;
    PtrSet_ *neighborSets = Sreedhar_NEIGHBORSETS(this);
    for (i = 0; i < maxPhiArity; i++) {
      PtrSet_Dtor(neighborSets + i);
    }
    Memory_free_(memory, neighborSets);
  }
}

#line 135 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
size_t
Sreedhar_Size(Memory memory, CodeRegion codeRegion, SSAForm ssaForm)
{
  return sizeof(Sreedhar_);
}

#line 150 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
#ifndef Sreedhar_POOLED
#define Sreedhar_POOLED 128
#endif//Sreedhar_POOLED

#line 154 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
Sreedhar
Sreedhar_new(Memory parent, CodeRegion codeRegion, SSAForm ssaForm)
{
  Memory memory = Memory_new(parent, Sreedhar_POOLED);
  size_t size = Sreedhar_Size(memory, codeRegion, ssaForm);
  void *alloc = Memory_alloc(memory, size);
  return Sreedhar_Ctor(alloc, memory, codeRegion, ssaForm);
}

#line 167 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
Sreedhar
Sreedhar_delete(Sreedhar this)
{
  if (this != NULL) {
    Memory memory = Sreedhar_MEMORY(this);
    //#ifndef ECL_NDTOR
    Sreedhar_Dtor(this);
    Memory_free_(memory, this);
    //#endif//ECL_NDTOR
    Memory_delete(memory);
  }
  return NULL;
}

#line 181 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 187 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
int32_t
Sreedhar_fillPhiOperations(Sreedhar this)
{
  int32_t maxPhiArity = 0;
  CodeRegion codeRegion = Sreedhar_CODEREGION(this);
  TemporaryTable temporaryTable = Sreedhar_TEMPORARYTABLE(this);
  OperationStack phiOperations = Sreedhar_PHIOPERATIONS(this);
  // Fill the sortedBlocks.
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      if (Operator_isPhi(Operation_operator(operation))) {
        int32_t operandCount = Operation_operandCount(operation);
        if (maxPhiArity < operandCount) maxPhiArity = operandCount;
        if (!ECL_OPTIMIZE) {
          Operation_OPERANDS_FOREACH_Temporary(operation, operand) {
            Except_ALWAYS(TemporaryTable_contains(temporaryTable, operand));
          } Operation_OPERANDS_ENDEACH_Temporary;
        }
        OperationStack_push(phiOperations, operation);
      } else break;
    } BasicBlock_ENDEACH_Operation;
  } CodeRegion_ENDEACH_BasicBlock;
  if (PFA_TRACE) {
    BasicBlock prev_block = NULL;
    fprintf(PFA_TRACE, "*** PHI Operations\tmaxPhiArity=%d\n", maxPhiArity);
    OperationStack_FOREACH_Operation(phiOperations, operation) {
      BasicBlock basicBlock = Operation_basicBlock(operation);
      if (basicBlock != prev_block) {
        fprintf(PFA_TRACE, "    Block_%d\tfrequency=%g\n",
                BasicBlock_index(basicBlock), BasicBlock_frequency(basicBlock));
        prev_block = basicBlock;
      }
      Operation_pretty(operation, PFA_TRACE);
    } OperationStack_ENDEACH_Operation;
  }
  return maxPhiArity;
}

#line 225 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 235 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
void
Sreedhar_doMethod_III_3_4_5_6_7(Sreedhar this,
                                   Operation phi_operation,
                                   OptimizeFlags coalescingFlags)
{
  Coalescer coalescer = Sreedhar_COALESCER(this);
  PtrSet candidateSet = Sreedhar_CANDIDATESET(this);
  PtrSet_ *neighborSets = Sreedhar_NEIGHBORSETS(this);
  PtrSet_empty(candidateSet);
  // Method III 3: empty the unresolved neighbor sets.
  Operation_OPERANDS_FOREACH_Temporary(phi_operation, operand) {
    Variable variable = Temporary_VARIABLE(operand);
    PtrSet neighbors = neighborSets + Operation_OPERANDS_INDEX;
    Variable_clearUnresolved(variable);
    *Variable__NEIGHBORS(variable) = neighbors;
    PtrSet_empty(neighbors);
  } Operation_OPERANDS_ENDEACH_Temporary;
  if (coalescingFlags & OptimizeCoalescing_Virtualize) {
    PFA_TRACE && fprintf(PFA_TRACE, "*** Sreedhar Method III:\n");
    // Method III 4: process interferences among phi_operation resources.
    Sreedhar_processInterferences(this, phi_operation);
    // Method III 5: process unresolved resources.
    Sreedhar_processUnresolvedResources(this, phi_operation);
  } else {
    PFA_TRACE && fprintf(PFA_TRACE, "*** Sreedhar Method I:\n");
    // Method I: put each resource in candidate resource set.
    Operation_OPERANDS_FOREACH_Temporary(phi_operation, x_i) {
      PtrSet_insert(candidateSet, Temporary_VARIABLE(x_i));
    } Operation_OPERANDS_ENDEACH_Temporary;
  }
  // Method III 6: insertCopy for each in candidate resource set.
  PFA_TRACE && fprintf(PFA_TRACE, "*** Sreedhar COPY insertion:\n");
  if (PFA_TRACE) {
    PtrSet_FORSORT(candidateSet, Variable_compare, Variable, variable_i) {
      Sreedhar_insertCopy(this, phi_operation, Variable_TEMPORARY(variable_i));
    } PtrSet_ENDSORT;
  } else {
    PtrSet_FOREACH(candidateSet, Variable, variable_i) {
      Sreedhar_insertCopy(this, phi_operation, Variable_TEMPORARY(variable_i));
    } PtrSet_ENDEACH;
  }
  // Method III 7: merge phi congruence classes of PHI resources.
  Coalescer_mergePhiCongruences(coalescer, phi_operation, NULL);
}

#line 287 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
void
Sreedhar_processInterferences(Sreedhar this, Operation phi_operation)
{
  BasicBlock phi_block = Operation_basicBlock(phi_operation);
  Coalescer coalescer = Sreedhar_COALESCER(this);
  TemporarySet_ *liveOutSets = Coalescer_LIVEOUTSETS(coalescer);
  TemporarySet_ *phiOutSets = Coalescer_PHIOUTSETS(coalescer);
  TemporarySet liveInSet = Coalescer_LIVEINSETS(coalescer) + BasicBlock_index(phi_block);
  TemporarySet phiInSet = Coalescer_PHIINSETS(coalescer) + BasicBlock_index(phi_block);
  Operation_OPERANDS_FOREACH_Temporary(phi_operation, x_i) {
    Variable v_i = Temporary_VARIABLE(x_i);
    VariableClass congruence_i = Variable_CONGRUENCE(v_i);
    int32_t index_i = Operation_OPERANDS_INDEX, index_j = 0;
    TemporarySet liveSet_i = liveInSet, phiSet_i = phiInSet;
    if (index_i > 0) {
      // HACK! Operation_operands[index_i] is argument if index_i > 0.
      BasicBlockEdge edge_i = BasicBlock_getPhiEnterEdge(phi_block, index_i - 1);
      BasicBlock block_i = BasicBlockEdge_origBlock(edge_i);
      liveSet_i = liveOutSets + BasicBlock_index(block_i);
      phiSet_i = phiOutSets + BasicBlock_index(block_i);
    }
    for (index_j = index_i + 1; index_j < Operation_OPERANDCOUNT; index_j++) {
      Variable v_j = Temporary_VARIABLE(Operation_OPERANDS[index_j]);
      VariableClass congruence_j = Variable_CONGRUENCE(v_j);
      if (congruence_i != congruence_j) {
        if (Coalescer_interferesCC(coalescer, congruence_i, congruence_j)) {
          TemporarySet liveSet_j = liveInSet, phiSet_j = phiInSet;
          if (index_j > 0) {
            // HACK! Operation_operands[index_j] is argument if index_j > 0.
            BasicBlockEdge edge_j = BasicBlock_getPhiEnterEdge(phi_block, index_j - 1);
            BasicBlock block_j = BasicBlockEdge_origBlock(edge_j);
            liveSet_j = liveOutSets + BasicBlock_index(block_j);
            phiSet_j = phiOutSets + BasicBlock_index(block_j);
          }
          Sreedhar_breakInterferences(this, v_i, liveSet_i, phiSet_i,
                                            v_j, liveSet_j, phiSet_j);
        }
      }
    }
  } Operation_OPERANDS_ENDEACH_Temporary;
}

#line 335 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
void
Sreedhar_breakInterferences(Sreedhar this,
                            Variable v_i, TemporarySet liveSet_i, TemporarySet phiSet_i,
                            Variable v_j, TemporarySet liveSet_j, TemporarySet phiSet_j)
{
  PtrSet candidateSet = Sreedhar_CANDIDATESET(this);
  VariableClass congruence_i = Variable_CONGRUENCE(v_i);
  VariableClass congruence_j = Variable_CONGRUENCE(v_j);
  bool congruence_i_live_j = false, congruence_j_live_i = false;
  VariableClass_FOREACH_Variable(congruence_i, variable) {
    Temporary temporary = Variable_TEMPORARY(variable);
    if (   TemporarySet_contains(phiSet_j, temporary)
        || TemporarySet_contains(liveSet_j, temporary)) {
      congruence_i_live_j = true;
      break;
    }
  } VariableClass_ENDEACH_Variable;
  VariableClass_FOREACH_Variable(congruence_j, variable) {
    Temporary temporary = Variable_TEMPORARY(variable);
    if (   TemporarySet_contains(phiSet_i, temporary)
        || TemporarySet_contains(liveSet_i, temporary)) {
      congruence_j_live_i = true;
      break;
    }
  } VariableClass_ENDEACH_Variable;
  PFA_TRACE && fprintf(PFA_TRACE, " -- Breaking interference between\t")
            && Temporary_pretty(Variable_TEMPORARY(v_i), PFA_TRACE)
            && fprintf(PFA_TRACE, "  and  ")
            && Temporary_pretty(Variable_TEMPORARY(v_j), PFA_TRACE)
            && fprintf(PFA_TRACE, "\n");
  if (congruence_i_live_j && !congruence_j_live_i) {
    // Case 1:    congruenceClass[xi] * LiveOutSet[Lj] != {}
    //        and LiveOutSet[Li] * congruenceClass[xj] == {}
    PtrSet_insert(candidateSet, v_i);
    PFA_TRACE && fprintf(PFA_TRACE, "*** Case 1: candidate\t")
              && Temporary_pretty(Variable_TEMPORARY(v_i), PFA_TRACE)
              && fprintf(PFA_TRACE, "\n");
  } else
  if (!congruence_i_live_j && congruence_j_live_i) {
    // Case 2:    congruenceClass[xi] * LiveOutSet[Lj] == {}
    //        and LiveOutSet[Li] * congruenceClass[xj] != {}
    PtrSet_insert(candidateSet, v_j);
    PFA_TRACE && fprintf(PFA_TRACE, "*** Case 2: candidate\t")
              && Temporary_pretty(Variable_TEMPORARY(v_j), PFA_TRACE)
              && fprintf(PFA_TRACE, "\n");
  } else
  if (congruence_i_live_j && congruence_j_live_i) {
    // Case 3:    congruenceClass[xi] * LiveOutSet[Lj] != {}
    //        and LiveOutSet[Li] * congruenceClass[xj] != {}
    PtrSet_insert(candidateSet, v_i);
    PtrSet_insert(candidateSet, v_j);
    PFA_TRACE && fprintf(PFA_TRACE, "*** Case 3: candidates\t")
              && Temporary_pretty(Variable_TEMPORARY(v_i), PFA_TRACE)
              && fprintf(PFA_TRACE, "\t")
              && Temporary_pretty(Variable_TEMPORARY(v_j), PFA_TRACE)
              && fprintf(PFA_TRACE, "\n");
  } else
  /* (!congruence_i_live_j && !congruence_j_live_i) */ {
    // Case 4:    congruenceClass[xi] * LiveOutSet[Lj] == {}
    //        and LiveOutSet[Li] * congruenceClass[xj] == {}
    PtrSet_insert(Variable_NEIGHBORS(v_i), v_j);
    PtrSet_insert(Variable_NEIGHBORS(v_j), v_i);
    PFA_TRACE && fprintf(PFA_TRACE, "*** Case 4: unresolved\t")
              && Temporary_pretty(Variable_TEMPORARY(v_i), PFA_TRACE)
              && fprintf(PFA_TRACE, "\t")
              && Temporary_pretty(Variable_TEMPORARY(v_j), PFA_TRACE)
              && fprintf(PFA_TRACE, "\n");
  }
}

#line 411 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
void
Sreedhar_insertCopy(Sreedhar this, Operation phi_operation, Temporary resource_i)
{
  Memory memory = Sreedhar_MEMORY(this);
  SSAForm ssaForm = Sreedhar_SSAFORM(this);
  Coalescer coalescer = Sreedhar_COALESCER(this);
  IBList congruences = Sreedhar_CONGRUENCES(this);
  CodeRegion codeRegion = Sreedhar_CODEREGION(this);
  TemporaryTable temporaryTable = Sreedhar_TEMPORARYTABLE(this);
  BasicBlock block_0 = Operation_basicBlock(phi_operation);
  Temporary resource_0 = Operation_getResult(phi_operation, 0);
  Variable variable_i = Temporary_VARIABLE(resource_i);
  Temporary origin = Variable_ORIGIN(variable_i);
  PFA_TRACE && fprintf(PFA_TRACE, "\tinsert COPY for ")
            && Temporary_pretty(resource_i, PFA_TRACE)
            && fprintf(PFA_TRACE, "\n");
  Operation_ARGUMENTS_FOREACH_Temporary(phi_operation, argument) {
    if (argument == resource_i) {
      int resIndex = 0;
      Operation copy_operation = NULL;
      BasicBlockEdge edge_k = BasicBlock_getPhiEnterEdge(block_0, Operation_ARGUMENTS_INDEX);
      BasicBlock block_k = BasicBlockEdge_origBlock(edge_k);
      TemporarySet liveOutSet_k = Sreedhar_LIVEOUTSETS(this) + BasicBlock_index(block_k);
      TemporarySet phiOutSet_k = Sreedhar_PHIOUTSETS(this) + BasicBlock_index(block_k);
      Temporary new_resource_i = CodeRegion_makeVariableTemporary(codeRegion, origin);
      Variable new_variable_i = Temporary_VARIABLE(new_resource_i);
      VariableClass congruence = IBList_push(congruences);
      VariableClass_Ctor(congruence, new_variable_i);
      TemporaryTable_insert(temporaryTable, new_resource_i);
      // 1. Insert a copy x_newi = xi in the corresponding block.
      if (!Coalescer_SEQCOPIES) {
        copy_operation = BasicBlock_makeOperationLCOPY(block_k);
        resIndex = Operation_addtoParCopy(copy_operation, new_resource_i, resource_i);
      } else {
        copy_operation = BasicBlock_makeLateOperationCOPY(block_k, new_resource_i, resource_i);
      }
      Variable_setOperationResult(new_variable_i, copy_operation, resIndex);
      if (Coalescer_CONSUMING(coalescer)) Variable_raiseConsuming(new_variable_i);
      Variable_setOperationArgument(variable_i, copy_operation, resIndex);
      // 2. Replace xi with x_newi.
      Variable_setOperationArgument(new_variable_i, phi_operation, Operation_ARGUMENTS_INDEX);
      // 3. Add x_newi in congruenceClass of x_newi.
      // if (for Lj an immediate successor of Lk, xi not in LiveInSet[Lj] and
      //     not used in a phi instruction associated with Lk in Lj)
      //        LiveOutSet[Lk] -= xi
      // Corrected test as: (xi not a PHI target in Lj)
      /* FAB: we could avoid doing this test by simply
         duplicating variables in phiOutClass and removing them one by one */
      if (!Sreedhar_isNeededPhiOutClass(this, block_k, resource_i)) {
        TemporarySet_remove(phiOutSet_k, resource_i);
      }
      // Add interference edges between x_newi and LiveOutSet[Lk].
      /* Fixme: addInterference with the branch bool */
      Coalescer_addInterferenceVS(coalescer, new_variable_i, liveOutSet_k);
      Coalescer_addInterferenceVS(coalescer, new_variable_i, phiOutSet_k);
      // 4. LiveOutSet[Lk] += x_newi.
      TemporarySet_insert(phiOutSet_k, new_resource_i);
    }
  } Operation_ARGUMENTS_ENDEACH_Temporary;
  if (resource_i == resource_0) {
    int resIndex = 0;
    Operation copy_operation = NULL;
    Variable variable_0 = Temporary_VARIABLE(resource_0);
    TemporarySet liveInSet_0 = Sreedhar_LIVEINSETS(this) + BasicBlock_index(block_0);
    TemporarySet phiInSet_0 = Sreedhar_PHIINSETS(this) + BasicBlock_index(block_0);
    Temporary new_resource_0 = CodeRegion_makeVariableTemporary(codeRegion, origin);
    Variable new_variable_0 = Temporary_VARIABLE(new_resource_0);
    VariableClass congruence = IBList_push(congruences);
    VariableClass_Ctor(congruence, new_variable_0);
    TemporaryTable_insert(temporaryTable, new_resource_0);
    // Insert a copy x0 = xnew_0 in the PHI block.
    if (!Coalescer_SEQCOPIES) {
      copy_operation = BasicBlock_makeOperationECOPY(block_0);
      resIndex = Operation_addtoParCopy(copy_operation, resource_0, new_resource_0);
    } else {
      copy_operation = BasicBlock_makeEarlyOperationCOPY(block_0, resource_0, new_resource_0);
    }
    // Replace x0 with xnew_0 as the target.
    Variable_setOperationResult(variable_0, copy_operation, resIndex);
    Variable_updateCongruence(variable_0);
    Variable_setOperationArgument(new_variable_0, copy_operation, resIndex);
    Variable_setOperationResult(new_variable_0, phi_operation, 0);
    if (Coalescer_CONSUMING(coalescer)) Variable_raiseConsuming(new_variable_0);
    // LiveInSet[L0] -= x0.
    TemporarySet_remove(phiInSet_0, resource_0);
    // Add interference edges between xnew_0 and LiveInSet[L0].
    /* FAB: here Sreedhar is too conservative. It should make variable_0
       interfere with livein and with variables used in the parallel copy */
    Coalescer_addInterferenceVS(coalescer, new_variable_0, liveInSet_0);
    Coalescer_addInterferenceVS(coalescer, new_variable_0, phiInSet_0);
    // LiveInSet[L0] += xnew_0.
    TemporarySet_insert(phiInSet_0, new_resource_0);
  }
}

#line 512 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
bool
Sreedhar_isNeededPhiOutClass(Sreedhar this, BasicBlock basicBlock, Temporary temporary)
{
  // Sreedhar version: Not needed if
  // if (for Lj an immediate successor of Lk, xi not in LiveInSet[Lj] and
  //     not used in a phi instruction associated with Lk in Lj)
  //        LiveOutSet[Lk] -= xi
  // Corrected test as: (xi not in LiveInSet[Lj] or is a PHI target in Lj) and ...
  // Note that the difference is on the interpretation of livein
  // in the case where livein contains the PHI targets as it is the case,
  // we must indeed remove the PHI target from the check.
  // FAB: Corrected again as:
  //   if (for Lj an immediate successor of Lk xi not used
  //       in a phi instruction associated with Lk in Lj)
  //   then PhiOutSet -= xi
  // note that this test is not necessary for phiinset. Indeed a definition
  //   appears only once while a use may appears several times.
  // For all the basicBlock successors.
  BasicBlock_LEAVE_FOREACH_BasicBlockEdge(basicBlock, edge) {
    BasicBlock succ_block = BasicBlockEdge_destBlock(edge);
    bool isPhiResult = false;
    // Forall the PHI Operation(s) of successor BasicBlock.
    BasicBlock_FOREACH_Operation(succ_block, operation) {
      if (Operator_isPhi(Operation_operator(operation))) {
        // Needed if used as PHI argument of the successor block associated to basicBlock.
        Operation_ARGUMENTS_FOREACH_Temporary(operation, argument) {
          if (argument == temporary) {
            BasicBlockEdge edge = BasicBlock_getPhiEnterEdge(succ_block,
                                                             Operation_ARGUMENTS_INDEX);
            if (BasicBlockEdge_origBlock(edge) == basicBlock) return true;
          }
        } Operation_ARGUMENTS_ENDEACH_Temporary;
        if (Operation_getResult(operation, 0) == temporary) isPhiResult = true;
      } else break;
    } BasicBlock_ENDEACH_Operation;
  } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
  return false;
}

#line 571 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
void
Sreedhar_processUnresolvedResources(Sreedhar this, Operation phi_operation)
{
  PtrSet candidateSet = Sreedhar_CANDIDATESET(this);
  PtrSeq unresolved = Sreedhar_UNRESOLVED(this);
  PFA_TRACE && fprintf(PFA_TRACE, " === Processing unresolved resources === \n");
  // Fill the unresolved resources set.
  Operation_OPERANDS_FOREACH_Temporary(phi_operation, resource) {
    Variable variable = Temporary_VARIABLE(resource);
    // Do not process a resource already in candidateSet (fix to Sreedhar).
    if (!PtrSet_contains(candidateSet, variable)) {
      PtrSet neighbors = Variable_NEIGHBORS(variable);
      // Filter-out candidateSet from neighbors (fix to Sreedhar).
      PtrSet_diff(neighbors, candidateSet);
      if (PtrSet_count(neighbors) > 0) {
        if (!Variable_isUnresolved(variable)) {
          Variable_raiseUnresolved(variable);
          PtrSeq_push2(unresolved, variable);
          PFA_TRACE && fprintf(PFA_TRACE, "\tunresolved ")
                    && Temporary_pretty(resource, PFA_TRACE)
                    && fprintf(PFA_TRACE, "\tneighbors ")
                    && Variable_prettyNeighbors(variable, PFA_TRACE, false)
                    && fprintf(PFA_TRACE, "\n");
        }
      }
    }
  } Operation_OPERANDS_ENDEACH_Temporary;
  // Process unresolved resources in non-decreasing NEIGHBORS size.
  while (!PtrSeq_isEmpty(unresolved)) {
    Variable variable = (Variable)PtrSeq_top(unresolved);
    // Extract the resource with the minimal NEIGHBORS size from unresolved.
    PtrSeq_pop(unresolved);
    if (Variable_isUnresolved(variable)) {
      PtrSet neighbors = Variable_NEIGHBORS(variable);
      int32_t degree = PtrSet_count(neighbors);
      Variable *unresolved_base = (Variable *)PtrSeq_base_(unresolved);
      int32_t unresolved_count = PtrSeq_count(unresolved), index;
      for (index = 0; index < unresolved_count; index++) {
        Variable *_vertex = unresolved_base + index;
        Variable vertex = *_vertex;
        if (Variable_isUnresolved(vertex)) {
          PtrSet vertex_neighbors = Variable_NEIGHBORS(vertex);
          int32_t vertex_degree = PtrSet_count(vertex_neighbors);
          if (degree > vertex_degree) {
            *_vertex = variable;
            variable = vertex;
            neighbors = vertex_neighbors;
            degree = vertex_degree;
          }
        }
      }
      Except_CHECK(Variable_isUnresolved(variable));
      Variable_clearUnresolved(variable);
      PFA_TRACE && fprintf(PFA_TRACE, "\tindependent ")
                && Temporary_pretty(Variable_TEMPORARY(variable), PFA_TRACE)
                && fprintf(PFA_TRACE, "\tneighbors ")
                && Variable_prettyNeighbors(variable, PFA_TRACE, false)
                && fprintf(PFA_TRACE, "\n");
      // The resource goes to the independent set and its neighbors to the candidateSet.
      PtrSet_FOREACH(neighbors, Variable, vertex) {
        PtrSet vertex_neighbors = Variable_NEIGHBORS(vertex);
        // Add neighbor vertex to the candidateSet and remove it from unresolved.
        PtrSet_insert(candidateSet, vertex);
        Variable_clearUnresolved(vertex);
        // Remove vertex from the NEIGHBORS of its neighbors.
        PtrSet_FOREACH(vertex_neighbors, Variable, neighbor) {
          PtrSet neighbor_neighbors = Variable_NEIGHBORS(neighbor);
          PtrSet_remove(neighbor_neighbors, vertex);
        } PtrSet_ENDEACH;
      } PtrSet_ENDEACH;
    }
  }
}

#line 645 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1170 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1182 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
#if XCC__C
static void
Sreedhar_TEST(void)
{
#include "PFA/Sreedhar_.c"
}

#line 1189 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
int
main(int argc, char **argv)
{
  PFA_Test(Sreedhar_TEST);
  return 0;
}
#endif


#endif//Sreedhar_c_INCLUDED
