#ifndef Sreedhar__c_INCLUDED
#define Sreedhar__c_INCLUDED

#line 141 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
//
{
  printf("sizeof(Sreedhar_) = %d\n", sizeof(Sreedhar_));
}

#line 647 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
//
{
  // Test the translation out of SSA form.
  // Figure 1 in Sreedhar's paper.
  Program program = Program_new(Memory_Root);
  Optimize optimize = Program_optimize(program);
  SymbolTable symbolTable = Program_symbolTable(program);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "figure-1");
  Procedure procedure = Program_makeProcedure(program, symbol);
  LabelTable labelTable = Program_labelTable(program);
  Label L1 = LabelTable_lookup(labelTable, 1, "L1");
  Label L2 = LabelTable_lookup(labelTable, 2, "L2");
  Label L3 = LabelTable_lookup(labelTable, 3, "L3");
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  BasicBlock_addLabels(block_l2, 1, &L2);
  BasicBlock_addLabels(block_l3, 1, &L3);
  BasicBlock_makeEdge(block_l1, block_l2, 0.0);
  BasicBlock_makeEdge(block_l1, block_l3, 0.0);
  BasicBlock_makeEdge(block_l2, block_l3, 0.0);
  *Optimize__COALESCING(optimize) = OptimizeCoalescing_Sreedhar;
  Procedure_buildCodeRegions(procedure);
  printf("\nFigure 1 in Sreedhar's paper:\n");
  PFA_TRACE = NULL;
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Temporary temporary_x = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_y = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_z = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_m = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_a1 = Procedure_makeAbsoluteTemporary(procedure, 1, Relocation__UNDEF);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_x, temporary_a1);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_y, temporary_a1);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l2), temporary_x, temporary_y);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l3), temporary_z, temporary_x);
    {
      SSAForm ssaForm = SSAForm_construct(Memory_Root, codeRegion, true);
      PFA_TRACE = stdout;
      SSAForm_destruct(ssaForm);
      CodeRegion_pretty(codeRegion, stdout);
    }
  }
  Program_delete(program);
}

#line 696 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
//
{
  // Test the translation out of SSA form.
  // Figure 6 in Sreedhar's paper.
  Program program = Program_new(Memory_Root);
  Optimize optimize = Program_optimize(program);
  SymbolTable symbolTable = Program_symbolTable(program);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "lost-copy");
  Procedure procedure = Program_makeProcedure(program, symbol);
  LabelTable labelTable = Program_labelTable(program);
  Label L0 = LabelTable_lookup(labelTable, 0, "L0");
  Label L1 = LabelTable_lookup(labelTable, 1, "L1");
  Label L2 = LabelTable_lookup(labelTable, 2, "L2");
  Label L3 = LabelTable_lookup(labelTable, 3, "L3");
  Label L4 = LabelTable_lookup(labelTable, 4, "L4");
  BasicBlock block_l3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l0 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_addLabels(block_l0, 1, &L0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  BasicBlock_addLabels(block_l2, 1, &L2);
  BasicBlock_addLabels(block_l3, 1, &L3);
  BasicBlock_addLabels(block_l4, 1, &L4);
  BasicBlock_makeEdge(block_l3, block_l0, 0.0);
  BasicBlock_makeEdge(block_l3, block_l4, 0.0);
  BasicBlock_makeEdge(block_l4, block_l1, 0.0);
  BasicBlock_makeEdge(block_l4, block_l2, 0.0);
  BasicBlock_makeEdge(block_l1, block_l0, 0.0);
  BasicBlock_makeEdge(block_l2, block_l0, 0.0);
  *Optimize__COALESCING(optimize) = OptimizeCoalescing_Sreedhar;
  Procedure_buildCodeRegions(procedure);
  printf("\nFigure 6 in Sreedhar's paper:\n");
  PFA_TRACE = NULL;
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    SSAForm ssaForm = SSAForm_construct(Memory_Root, codeRegion, true);
    Temporary temporary_x = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_a1 = Procedure_makeAbsoluteTemporary(procedure, 1, Relocation__UNDEF);
    Temporary temporary_a2 = Procedure_makeAbsoluteTemporary(procedure, 2, Relocation__UNDEF);
    Temporary temporary_a3 = Procedure_makeAbsoluteTemporary(procedure, 3, Relocation__UNDEF);
    Temporary temporary_x0 = CodeRegion_makeVariableTemporary(codeRegion, temporary_x);
    Temporary temporary_x1 = CodeRegion_makeVariableTemporary(codeRegion, temporary_x);
    Temporary temporary_x2 = CodeRegion_makeVariableTemporary(codeRegion, temporary_x);
    Temporary temporary_x3 = CodeRegion_makeVariableTemporary(codeRegion, temporary_x);
    Operation apply_3 = Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                                         Operator_APPLY, temporary_x3, temporary_a1);
    Operation apply_1 = Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                                         Operator_APPLY, temporary_x1, temporary_a2);
    Operation apply_2 = Selector_makeOperation_1_1(BasicBlock_selector(block_l4),
                                         Operator_APPLY, temporary_x2, temporary_a3);
    Operation phiOperation_x = BasicBlock_makeOperationPHI(block_l0, NULL);
    Variable_setOperationResult(Temporary_VARIABLE(temporary_x3), apply_3, 0);
    Variable_setOperationResult(Temporary_VARIABLE(temporary_x1), apply_1, 0);
    Variable_setOperationResult(Temporary_VARIABLE(temporary_x2), apply_2, 0);
    Variable_setOperationResult(Temporary_VARIABLE(temporary_x0), phiOperation_x, 0);
    Variable_setOperationArgument(Temporary_VARIABLE(temporary_x3), phiOperation_x, 0);
    Variable_setOperationArgument(Temporary_VARIABLE(temporary_x1), phiOperation_x, 1);
    Variable_setOperationArgument(Temporary_VARIABLE(temporary_x2), phiOperation_x, 2);
    // SSAForm has been created before the setting of operations.
    PFA_TRACE = stdout;
    SSAForm_destruct(ssaForm);
    CodeRegion_pretty(codeRegion, stdout);
  }
  Program_delete(program);
}

#line 764 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
//
{
  // Test the translation out of SSA form.
  // Lost-Copy Problem in Sreedhar's paper.
  Program program = Program_new(Memory_Root);
  Optimize optimize = Program_optimize(program);
  SymbolTable symbolTable = Program_symbolTable(program);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "lost-copy");
  Procedure procedure = Program_makeProcedure(program, symbol);
  LabelTable labelTable = Program_labelTable(program);
  Label L1 = LabelTable_lookup(labelTable, 1, "L1");
  Label L2 = LabelTable_lookup(labelTable, 2, "L2");
  Label L3 = LabelTable_lookup(labelTable, 3, "L3");
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  BasicBlock_addLabels(block_l2, 1, &L2);
  BasicBlock_addLabels(block_l3, 1, &L3);
  BasicBlock_makeEdge(block_l1, block_l2, 0.0);
  BasicBlock_makeEdge(block_l2, block_l2, 0.0);
  BasicBlock_makeEdge(block_l2, block_l3, 0.0);
  *Optimize__CONVERSION(optimize) |= OptimizeConversion_Folding;
  *Optimize__COALESCING(optimize) = OptimizeCoalescing_Sreedhar;
  Procedure_buildCodeRegions(procedure);
  printf("\nLost-Copy Problem in Sreedhar's paper:\n");
  PFA_TRACE = NULL;
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Temporary temporary_x = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_y = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_z = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_a1 = Procedure_makeAbsoluteTemporary(procedure, 1, Relocation__UNDEF);
    Temporary temporary_a2 = Procedure_makeAbsoluteTemporary(procedure, 2, Relocation__UNDEF);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_x, temporary_a2);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l2), temporary_y, temporary_x);
    Selector_makeOperation_1_2(BasicBlock_selector(block_l2),
                               Operator_ADD, temporary_x, temporary_x, temporary_a1);
    Selector_makeOperation_1_2(BasicBlock_selector(block_l3),
                               Operator_SUB, temporary_z, temporary_y, temporary_a1);
    {
      SSAForm ssaForm = SSAForm_construct(Memory_Root, codeRegion, true);
      PFA_TRACE = stdout;
      SSAForm_destruct(ssaForm);
      CodeRegion_pretty(codeRegion, stdout);
    }
  }
  Program_delete(program);
}

#line 815 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
//
{
  // Test the translation out of SSA form.
  // Swap Problem in Sreedhar's paper.
  Program program = Program_new(Memory_Root);
  Optimize optimize = Program_optimize(program);
  SymbolTable symbolTable = Program_symbolTable(program);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "lost-copy");
  Procedure procedure = Program_makeProcedure(program, symbol);
  LabelTable labelTable = Program_labelTable(program);
  Label L1 = LabelTable_lookup(labelTable, 1, "L1");
  Label L2 = LabelTable_lookup(labelTable, 2, "L2");
  Label L3 = LabelTable_lookup(labelTable, 3, "L3");
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  BasicBlock_addLabels(block_l2, 1, &L2);
  BasicBlock_addLabels(block_l3, 1, &L3);
  BasicBlock_makeEdge(block_l1, block_l2, 0.0);
  BasicBlock_makeEdge(block_l2, block_l2, 0.0);
  BasicBlock_makeEdge(block_l2, block_l3, 0.0);
  *Optimize__CONVERSION(optimize) |= OptimizeConversion_Folding;
  *Optimize__COALESCING(optimize) = OptimizeCoalescing_Sreedhar;
  Procedure_buildCodeRegions(procedure);
  printf("\nSwap Problem in Sreedhar's paper:\n");
  PFA_TRACE = NULL;
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Temporary temporary_x = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_y = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_z = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_a = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_b = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_c1 = Procedure_makeAbsoluteTemporary(procedure, 1, Relocation__UNDEF);
    Temporary temporary_c2 = Procedure_makeAbsoluteTemporary(procedure, 2, Relocation__UNDEF);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_x, temporary_c1);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_y, temporary_c2);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l2), temporary_z, temporary_x);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l2), temporary_x, temporary_y);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l2), temporary_y, temporary_z);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                               Operator_APPLY, temporary_a, temporary_x);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                               Operator_APPLY, temporary_b, temporary_y);
    {
      SSAForm ssaForm = SSAForm_construct(Memory_Root, codeRegion, true);
      PFA_TRACE = stdout;
      SSAForm_destruct(ssaForm);
      CodeRegion_pretty(codeRegion, stdout);
    }
  }
  Program_delete(program);
}

#line 872 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
//
{
  // Test the translation out of SSA form.
  // Virtual swap Problem in Budmilic's paper.
  Program program = Program_new(Memory_Root);
  Optimize optimize = Program_optimize(program);
  SymbolTable symbolTable = Program_symbolTable(program);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "virtual-swap");
  Procedure procedure = Program_makeProcedure(program, symbol);
  LabelTable labelTable = Program_labelTable(program);
  Label L1 = LabelTable_lookup(labelTable, 1, "L1");
  Label L2 = LabelTable_lookup(labelTable, 2, "L2");
  Label L3 = LabelTable_lookup(labelTable, 3, "L3");
  Label L4 = LabelTable_lookup(labelTable, 4, "L4");
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  BasicBlock_addLabels(block_l2, 1, &L2);
  BasicBlock_addLabels(block_l3, 1, &L3);
  BasicBlock_addLabels(block_l4, 1, &L4);
  BasicBlock_makeEdge(block_l1, block_l2, 0.0);
  BasicBlock_makeEdge(block_l1, block_l3, 0.0);
  BasicBlock_makeEdge(block_l2, block_l4, 0.0);
  BasicBlock_makeEdge(block_l3, block_l4, 0.0);
  *Optimize__CONVERSION(optimize) |= OptimizeConversion_Folding;
  *Optimize__COALESCING(optimize) = OptimizeCoalescing_Sreedhar;
  Procedure_buildCodeRegions(procedure);
  printf("\nVirtual swap Problem in Budimlic's paper:\n");
  PFA_TRACE = NULL;
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Temporary temporary_x = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_y = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_z = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_a = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_b = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_c1 = Procedure_makeAbsoluteTemporary(procedure, 1, Relocation__UNDEF);
    Temporary temporary_c2 = Procedure_makeAbsoluteTemporary(procedure, 2, Relocation__UNDEF);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_a, temporary_c1);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_b, temporary_c2);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l2), temporary_x, temporary_a);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l2), temporary_y, temporary_b);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l3), temporary_x, temporary_b);
    Selector_makeOperationCOPY(BasicBlock_selector(block_l3), temporary_y, temporary_a);
    Selector_makeOperation_1_2(BasicBlock_selector(block_l4),
                               Operator_ADD, temporary_z, temporary_x, temporary_y);
    {
      SSAForm ssaForm = SSAForm_construct(Memory_Root, codeRegion, true);
      PFA_TRACE = stdout;
      SSAForm_destruct(ssaForm);
      CodeRegion_pretty(codeRegion, stdout);
    }
  }
  Program_delete(program);
}

#line 932 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
//
{
  // Test the translation out of SSA form.
  // Weird case!!!!
  Program program = Program_new(Memory_Root);
  Optimize optimize = Program_optimize(program);
  SymbolTable symbolTable = Program_symbolTable(program);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "weird-case");
  Procedure procedure = Program_makeProcedure(program, symbol);
  LabelTable labelTable = Program_labelTable(program);
  Label L1 = LabelTable_lookup(labelTable, 1, "L1");
  Label L2 = LabelTable_lookup(labelTable, 2, "L2");
  Label L3 = LabelTable_lookup(labelTable, 3, "L3");
  Label L4 = LabelTable_lookup(labelTable, 4, "L4");
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  BasicBlock_addLabels(block_l2, 1, &L2);
  BasicBlock_addLabels(block_l3, 1, &L3);
  BasicBlock_addLabels(block_l4, 1, &L4);
  BasicBlock_makeEdge(block_l1, block_l2, 0.0);
  BasicBlock_makeEdge(block_l1, block_l3, 0.0);
  BasicBlock_makeEdge(block_l2, block_l4, 0.0);
  BasicBlock_makeEdge(block_l3, block_l4, 0.0);
  *Optimize__CONVERSION(optimize) |= OptimizeConversion_Folding;
  *Optimize__COALESCING(optimize) = OptimizeCoalescing_Sreedhar;
  Procedure_buildCodeRegions(procedure);
  printf("\nWeird case:\n");
  PFA_TRACE = NULL;
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Temporary temporary_x = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_y = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_p = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_q = Procedure_makeVirtualTemporary(procedure, 0);
    // Constants
    Temporary temporary_c1 = Procedure_makeAbsoluteTemporary(procedure, 1, Relocation__UNDEF);
    Temporary temporary_c2 = Procedure_makeAbsoluteTemporary(procedure, 2, Relocation__UNDEF);
    Temporary temporary_c15 = Procedure_makeAbsoluteTemporary(procedure, 15, Relocation__UNDEF);
    // Operations for L1
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_x, temporary_c1);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_y, temporary_c15);
    // Operations to fill L2
    Selector_makeOperation_1_2(BasicBlock_selector(block_l2),
                               Operator_ADD, temporary_x, temporary_x, temporary_y);
    Selector_makeOperation_1_2(BasicBlock_selector(block_l2),
                               Operator_MUL, temporary_y, temporary_c2, temporary_x);
    // Copies in L3
    Selector_makeOperationCOPY(BasicBlock_selector(block_l3), temporary_y, temporary_x);
    // Final copies in L4
    Selector_makeOperation_1_2(BasicBlock_selector(block_l4),
                               Operator_ADD, temporary_q, temporary_x, temporary_c1);
    Selector_makeOperation_1_2(BasicBlock_selector(block_l4),
                               Operator_MUL, temporary_p, temporary_y, temporary_c1);
    {
      SSAForm ssaForm = SSAForm_construct(Memory_Root, codeRegion, true);
      PFA_TRACE = stdout;
      SSAForm_destruct(ssaForm);
      CodeRegion_pretty(codeRegion, stdout);
    }
  }
  Program_delete(program);
}

#line 1000 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
//
{
  // Test the SSA-based coalescing.
  // Figure 10 in Sreedhar's paper.
  // FIXME! Output is unexpected!
  Program program = Program_new(Memory_Root);
  Optimize optimize = Program_optimize(program);
  SymbolTable symbolTable = Program_symbolTable(program);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "lost-copy");
  Procedure procedure = Program_makeProcedure(program, symbol);
  LabelTable labelTable = Program_labelTable(program);
  Label L1 = LabelTable_lookup(labelTable, 0, "L1");
  Label L2 = LabelTable_lookup(labelTable, 1, "L2");
  Label L3 = LabelTable_lookup(labelTable, 2, "L3");
  Label L4 = LabelTable_lookup(labelTable, 3, "L4");
  Label L5 = LabelTable_lookup(labelTable, 4, "L5");
  Label L6 = LabelTable_lookup(labelTable, 5, "L6");
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l5 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l6 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  BasicBlock_addLabels(block_l2, 1, &L2);
  BasicBlock_addLabels(block_l3, 1, &L3);
  BasicBlock_addLabels(block_l4, 1, &L4);
  BasicBlock_addLabels(block_l5, 1, &L5);
  BasicBlock_addLabels(block_l6, 1, &L6);
  BasicBlock_makeEdge(block_l1, block_l2, 0.0);
  BasicBlock_makeEdge(block_l1, block_l3, 0.0);
  BasicBlock_makeEdge(block_l1, block_l4, 0.0);
  BasicBlock_makeEdge(block_l2, block_l5, 0.0);
  BasicBlock_makeEdge(block_l2, block_l6, 0.0);
  BasicBlock_makeEdge(block_l3, block_l5, 0.0);
  BasicBlock_makeEdge(block_l4, block_l6, 0.0);
  *Optimize__COALESCING(optimize) = OptimizeCoalescing_Sreedhar;
  *Optimize__COALESCING(optimize) |= OptimizeCoalescing_Congruence;
  Procedure_buildCodeRegions(procedure);
  printf("\nFigure 10 in Sreedhar's paper:\n");
  PFA_TRACE = NULL;
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    SSAForm ssaForm = SSAForm_construct(Memory_Root, codeRegion, true);
    Temporary temporary_x = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_y = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_a10 = Procedure_makeAbsoluteTemporary(procedure, 10, Relocation__UNDEF);
    Temporary temporary_a20 = Procedure_makeAbsoluteTemporary(procedure, 20, Relocation__UNDEF);
    Temporary temporary_a30 = Procedure_makeAbsoluteTemporary(procedure, 30, Relocation__UNDEF);
    Temporary temporary_x1 = CodeRegion_makeVariableTemporary(codeRegion, temporary_x);
    Temporary temporary_x2 = CodeRegion_makeVariableTemporary(codeRegion, temporary_x);
    Temporary temporary_x3 = CodeRegion_makeVariableTemporary(codeRegion, temporary_x);
    Temporary temporary_y1 = CodeRegion_makeVariableTemporary(codeRegion, temporary_y);
    Temporary temporary_y2 = CodeRegion_makeVariableTemporary(codeRegion, temporary_y);
    Temporary temporary_y3 = CodeRegion_makeVariableTemporary(codeRegion, temporary_y);
    Operation apply_1 = Selector_makeOperation_1_1(BasicBlock_selector(block_l2),
                                         Operator_APPLY, temporary_y1, temporary_a30);
    Operation copy_x_y = Selector_makeOperationCOPY(BasicBlock_selector(block_l2),
                                                    temporary_x1, temporary_y1);
    Operation def_y2 = Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                                         Operator_APPLY, temporary_y2, temporary_a10);
    Operation def_x2 = Selector_makeOperation_1_1(BasicBlock_selector(block_l4),
                                         Operator_APPLY, temporary_x2, temporary_a20);
    Operation phiOperation_y = BasicBlock_makeOperationPHI(block_l5, NULL);
    Operation use_y3 = Selector_makeOperation_0_1(BasicBlock_selector(block_l5),
                                                  Operator_CALL, temporary_y3);
    Operation phiOperation_x = BasicBlock_makeOperationPHI(block_l6, NULL);
    Operation use_x3 = Selector_makeOperation_0_1(BasicBlock_selector(block_l6),
                                                  Operator_CALL, temporary_x3);
    Variable_setOperationResult(Temporary_VARIABLE(temporary_y1), apply_1, 0);
    Variable_setOperationResult(Temporary_VARIABLE(temporary_x1), copy_x_y, 0);
    Variable_setOperationResult(Temporary_VARIABLE(temporary_y2), def_y2, 0);
    Variable_setOperationResult(Temporary_VARIABLE(temporary_x2), def_x2, 0);
    Variable_setOperationResult(Temporary_VARIABLE(temporary_y3), phiOperation_y, 0);
    Variable_setOperationArgument(Temporary_VARIABLE(temporary_y1), phiOperation_y, 0);
    Variable_setOperationArgument(Temporary_VARIABLE(temporary_y2), phiOperation_y, 1);
    Variable_setOperationResult(Temporary_VARIABLE(temporary_x3), phiOperation_x, 0);
    Variable_setOperationArgument(Temporary_VARIABLE(temporary_x1), phiOperation_x, 0);
    Variable_setOperationArgument(Temporary_VARIABLE(temporary_x2), phiOperation_x, 1);
    // SSAForm has been created before the setting of operations.
    PFA_TRACE = stdout;
    SSAForm_destruct(ssaForm);
    CodeRegion_pretty(codeRegion, stdout);
  }
  Program_delete(program);
}

#line 1087 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Sreedhar.xcc"
//
{
  // Test the SSA-based coalescing.
  // Figure 10 in Rastello's report.
  // FIXME! Output is unexpected!
  Program program = Program_new(Memory_Root);
  Optimize optimize = Program_optimize(program);
  SymbolTable symbolTable = Program_symbolTable(program);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "lost-copy");
  Procedure procedure = Program_makeProcedure(program, symbol);
  LabelTable labelTable = Program_labelTable(program);
  Label L1 = LabelTable_lookup(labelTable, 0, "L1");
  Label L2 = LabelTable_lookup(labelTable, 1, "L2");
  Label L3 = LabelTable_lookup(labelTable, 2, "L3");
  Label L4 = LabelTable_lookup(labelTable, 3, "L4");
  Label L5 = LabelTable_lookup(labelTable, 3, "L5");
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l5 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  BasicBlock_addLabels(block_l2, 1, &L2);
  BasicBlock_addLabels(block_l3, 1, &L3);
  BasicBlock_addLabels(block_l4, 1, &L4);
  BasicBlock_addLabels(block_l5, 1, &L5);
  BasicBlock_makeEdge(block_l1, block_l2, 0.0);
  BasicBlock_makeEdge(block_l2, block_l4, 0.0);
  BasicBlock_makeEdge(block_l2, block_l3, 0.0);
  BasicBlock_makeEdge(block_l3, block_l4, 0.0);
  BasicBlock_makeEdge(block_l4, block_l2, 0.0);
  BasicBlock_makeEdge(block_l4, block_l5, 0.0);
  *Optimize__COALESCING(optimize) = OptimizeCoalescing_Sreedhar;
  *Optimize__COALESCING(optimize) |= OptimizeCoalescing_Congruence;
  Procedure_buildCodeRegions(procedure);
  printf("\nFigure 10 in Rastello's paper:\n");
  PFA_TRACE = NULL;
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    SSAForm ssaForm = SSAForm_construct(Memory_Root, codeRegion, true);
    Temporary temporary_x = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_y = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_a10 = Procedure_makeAbsoluteTemporary(procedure, 10, Relocation__UNDEF);
    Temporary temporary_a20 = Procedure_makeAbsoluteTemporary(procedure, 20, Relocation__UNDEF);
    Temporary temporary_x1 = CodeRegion_makeVariableTemporary(codeRegion, temporary_x);
    Temporary temporary_x2 = CodeRegion_makeVariableTemporary(codeRegion, temporary_x);
    Temporary temporary_x3 = CodeRegion_makeVariableTemporary(codeRegion, temporary_x);
    Temporary temporary_y1 = CodeRegion_makeVariableTemporary(codeRegion, temporary_y);
    Temporary temporary_y2 = CodeRegion_makeVariableTemporary(codeRegion, temporary_y);
    Temporary temporary_y3 = CodeRegion_makeVariableTemporary(codeRegion, temporary_y);
    Operation def_x1 = Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                                                  Operator_APPLY, temporary_x1, temporary_a10);
    Operation def_y1 = Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                                                  Operator_APPLY, temporary_y1, temporary_a20);
    Operation phiOperation_y2 = BasicBlock_makeOperationPHI(block_l2, NULL);
    Operation phiOperation_x2 = BasicBlock_makeOperationPHI(block_l2, NULL);
    Operation phiOperation_y3 = BasicBlock_makeOperationPHI(block_l4, NULL);
    Operation phiOperation_x3 = BasicBlock_makeOperationPHI(block_l4, NULL);
    Operation use_x3_y3 = Selector_makeOperation_0_2(BasicBlock_selector(block_l5),
                                                     Operator_CALL, temporary_x3,
                                                     temporary_y3);
    Variable_setOperationResult(Temporary_VARIABLE(temporary_x1), def_x1, 0);
    Variable_setOperationResult(Temporary_VARIABLE(temporary_y1), def_y1, 0);
    Variable_setOperationResult(Temporary_VARIABLE(temporary_x2), phiOperation_x2, 0);
    Variable_setOperationArgument(Temporary_VARIABLE(temporary_x1), phiOperation_x2, 0);
    Variable_setOperationArgument(Temporary_VARIABLE(temporary_x3), phiOperation_x2, 1);
    Variable_setOperationResult(Temporary_VARIABLE(temporary_y2), phiOperation_y2, 0);
    Variable_setOperationArgument(Temporary_VARIABLE(temporary_y1), phiOperation_y2, 0);
    Variable_setOperationArgument(Temporary_VARIABLE(temporary_y3), phiOperation_y2, 1);
    Variable_setOperationResult(Temporary_VARIABLE(temporary_x3), phiOperation_x3, 0);
    Variable_setOperationArgument(Temporary_VARIABLE(temporary_x2), phiOperation_x3, 0);
    Variable_setOperationArgument(Temporary_VARIABLE(temporary_y2), phiOperation_x3, 1);
    Variable_setOperationResult(Temporary_VARIABLE(temporary_y3), phiOperation_y3, 0);
    Variable_setOperationArgument(Temporary_VARIABLE(temporary_y2), phiOperation_y3, 0);
    Variable_setOperationArgument(Temporary_VARIABLE(temporary_x2), phiOperation_y3, 1);
    // SSAForm has been created before the setting of operations.
    PFA_TRACE = stdout;
    SSAForm_destruct(ssaForm);
    CodeRegion_pretty(codeRegion, stdout);
  }
  Program_delete(program);
}


#endif//Sreedhar__c_INCLUDED
