#ifndef GRA_c_INCLUDED
#define GRA_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
#include "GRA/GRA_.h"

#line 30 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 53 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
bool
GRA_allocateCodeRegion(CodeRegion codeRegion, SSAForm ssaForm)
{
  return GraphColoring_allocateCodeRegion(codeRegion, ssaForm);
}

#line 66 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
OperationAndIdx
OperationAndIdx_Ctor(OperationAndIdx this, Operation operation, int32_t idx) {
  *OperationAndIdx__OPERATION(this) = operation;
  *OperationAndIdx__IDX(this) = idx;
  return this;
}

#line 77 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
bool
GRA_colorUsedIn(const Temporary *operands, Temporary colorTemp, int32_t nb) {
  int32_t i;
  Register colorReg = Temporary_register(colorTemp);
  for(i = 0; i < nb; ++i) {
    if(colorReg == Temporary_register(operands[i])) {
      return true;
    }
  }
  return false;
}

#line 96 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
void
GRA_removeCheckedColorFromParCopies(CodeRegion codeRegion, Memory memory,
                                    RegFile regFile, void* param,
                                    bool (*check)(Temporary, Operation,
                                                  int32_t, void*)) {
  IDList_ pcopiesToBeUpdated[1];
  PtrSet_ operationToBeDetached[1];
  IDList_Ctor(pcopiesToBeUpdated, memory);
  PtrSet_Ctor(operationToBeDetached, memory, 4);
  if(check == NULL) {
    return;
  }

#line 109 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      if(Operator_isParCopy(Operation_operator(operation))
         && Operation_resCount(operation) > 0
         && Temporary_regFile(Operation_getResult(operation, 0)) == regFile) {
        int32_t idx;
        for(idx = 0; idx < Operation_resCount(operation); ++idx) {
          Temporary res = Operation_getResult(operation, idx);
          Temporary arg = Operation_getArgument(operation, idx);
          
          if(check(res, operation, idx, param)
             || check(arg, operation, idx + Operation_resCount(operation), param)) {
            Selector_ curSelector[1];
            Selector blockSelector = BasicBlock_selector(basicBlock);
            Selector_Ctor(curSelector, Selector_memory(blockSelector),
                          Selector_procedure(blockSelector),
                          Selector_processor(blockSelector),
                          false);
            // one of the colors is unavailable for recoloring
            // either create a move upward or downward
            if(Temporary_register(res) == Temporary_register(arg)) {
              PCOPYUpdate_insert(pcopiesToBeUpdated, operation, idx);
            } else if(!GRA_colorUsedIn(Operation_results(operation), arg,
                                   Operation_resCount(operation))) {
              // Rx = RPC Ry
              // ->
              // ... = RPC ...
              // Rx = Ry
              Selector_selectCOPY(curSelector, res, arg);
              BasicBlock_appendSelector(basicBlock, operation, curSelector);
              PCOPYUpdate_insert(pcopiesToBeUpdated, operation, idx);
            } else if(!GRA_colorUsedIn(Operation_arguments(operation), res,
                                   Operation_argCount(operation))) {
              // Rx = RPC Ry
              // ->
              // Rx = Ry
              // ... = RPC ...
              Selector_selectCOPY(curSelector, res, arg);
              BasicBlock_insertSelector(basicBlock, operation, curSelector);
              PCOPYUpdate_insert(pcopiesToBeUpdated, operation, idx);
            } else {
              // save one of the color in a free one
              Except_CHECK(0 && "Not yet implemented");
            }
            Selector_Dtor(curSelector);
          }
        }
      }
    } BasicBlock_ENDEACH_Operation;
  } CodeRegion_ENDEACH_BasicBlock;
  
  GRA_updatePCOPIES(operationToBeDetached, pcopiesToBeUpdated);

#line 162 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
  IDList_Dtor(pcopiesToBeUpdated);
  PtrSet_FOREACH(operationToBeDetached, Operation, operation) {
    BasicBlock_detachOperation(Operation_basicBlock(operation), operation);
  } PtrSet_ENDEACH;
  PtrSet_Dtor(operationToBeDetached);
}

#line 174 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
void
PCOPYUpdate_insert(IDList pcopiesToBeUpdated, Operation operation,
                   int32_t idx) {
  IDListItem before = NULL;
  OperationAndIdx_ newItem;
  IDList_FOREACH(pcopiesToBeUpdated, OperationAndIdx_, opAndIdx) {
    if(idx > OperationAndIdx_IDX(opAndIdx)) {
      // found inserting point
      before = (IDListItem)opAndIdx;
      break;
    } else if(idx ==  OperationAndIdx_IDX(opAndIdx)
              && OperationAndIdx_OPERATION(opAndIdx) == operation) {
      // already in the list
      return;
    }
  } IDList_ENDEACH;
  OperationAndIdx_Ctor(&newItem, operation, idx);
  if(before != NULL) {
    *(OperationAndIdx)IDList_insert(pcopiesToBeUpdated, before, sizeof(OperationAndIdx_))
      = newItem;
  } else {
    IDList_PUSH(pcopiesToBeUpdated, OperationAndIdx_, newItem);
  }
}

#line 203 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
void
GRA_updatePCOPIES(PtrSet operationToBeDetached, IDList pcopiesToBeUpdated) {
  IDList_FOREACH(pcopiesToBeUpdated, OperationAndIdx_, opAndIdx) {
    Operation pcopy = OperationAndIdx_OPERATION(opAndIdx);
    int32_t idx  = OperationAndIdx_IDX(opAndIdx);
    int32_t lastIdx = Operation_resCount(pcopy) - 1;
    int32_t i, startIdx, argCount;
    Temporary* operands = Operation_operands(pcopy);
    Except_CHECK(Operator_isParCopy(Operation_operator(pcopy)));
    if(idx != lastIdx) {
      Operation_setResult(pcopy, idx, Operation_getResult(pcopy, lastIdx));
      Operation_setArgument(pcopy, idx, Operation_getArgument(pcopy, lastIdx));
    }
    // operands share the same array, so doing this simple modification is not
    // enough.
    //    *Operation__RESCOUNT(pcopy) = Operation_RESCOUNT(pcopy) - 1;
    //    *Operation__ARGCOUNT(pcopy) = Operation_ARGCOUNT(pcopy) - 1;
    // e.g.: 0, 1, 2 = 0, 1, 2
    // doing rescount - 1, we get
    // 0, 1 = 2, 0, 1 [, 2] // <- no more in array. Beginning of arg
    //                      //    is at rescount + 1
    // then, argcount - 1, we get
    // 0, 1 = 2, 0, [1 [, 2]]// <- no more in array. End of array is at
    //                        //    new rescount + argcount - 1
    startIdx = *Operation__RESCOUNT(pcopy) = Operation_RESCOUNT(pcopy) - 1;
    argCount = *Operation__ARGCOUNT(pcopy) = Operation_ARGCOUNT(pcopy) - 1;
    for(i = startIdx; i < startIdx + argCount; ++i) {
      operands[i] = operands[i + 1];
    }

#line 233 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
    if(Operation_resCount(pcopy) == 0) {
      PtrSet_insert(operationToBeDetached, pcopy);
    }
  } IDList_ENDEACH;
}

#line 251 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
void
GRA_exportSolution(TemporaryTable tmpTable, FILE* fout, RegFile regFile) {
  if(fout != NULL) {
    uint32_t index;
    bool isFirst = true;
    Register firstReg = RegFile_lowRegister(regFile);
    fprintf(fout, "%d %d\n", TemporaryTable_count(tmpTable),
            RegisterSet_count(RegFile_registerSet(regFile)));
    TemporaryTable_FOREACH_Temporary(tmpTable, temp) {
      Except_CHECK((isFirst || index < Temporary_index(temp))
                   && "TemporaryTable is not sorted");
      Except_CHECK(Temporary_hasRegFile(temp)
                   && Temporary_regFile(temp) == regFile
                   && "This temporary is not part of the solution");
      index = Temporary_index(temp);
      isFirst = false;
      fprintf(fout, "%d\n", Temporary_register(temp) - firstReg);
    } TemporaryTable_ENDEACH_Temporary;
  }
}

#line 279 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
void
GRA_statisticOnCodeRegion(CodeRegion codeRegion, const char* message,
                          FILE* file) {
  if(file != NULL) {
    uint32_t spillOpCount = 0;
    double spillOpCost = 0.0;
    uint32_t cpyCount = 0;
    double cpyCost = 0.0;
    uint32_t swapCount = 0;
    double swapCost = 0.0;
    Procedure procedure = CodeRegion_procedure(codeRegion);
    fprintf(file, "------- %s: %s -------\n", Procedure_name(procedure),
            message);

#line 293 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
    CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
      double frequency = BasicBlock_frequency(basicBlock);
      BasicBlock_FOREACH_Operation(basicBlock, operation) {
        if(Operation_isSpillCode(operation)) {
          ++spillOpCount;
          spillOpCost += frequency;
        } else if(Operator_isSeqCopy(Operation_operator(operation))) {
          ++cpyCount;
          cpyCost += frequency;
#ifdef MDS_TARGET_st200
        } else if(Operation_operator(operation) == Operator_st200_xor_1general_2general_3general) {
          ++swapCount;
          swapCost += frequency;
#endif//MDS_TARGET_st200
        }
      } BasicBlock_ENDEACH_Operation;
    } CodeRegion_ENDEACH_BasicBlock;
    fprintf(file, "       Count\tCost\n");
    fprintf(file, "Spill: %u\t%f\n", spillOpCount, spillOpCost);
    fprintf(file, "Copy: %u\t%f\n", cpyCount, cpyCost);
    fprintf(file, "Swap: %u\t%f\n", swapCount, swapCost);
    fprintf(file, "Total cost: %f\n", spillOpCost + cpyCost + swapCost);
    fprintf(file, "--------------\n");
  }
}

#line 327 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
#undef GRA_TRACE 
FILE *GRA_TRACE = NULL;

#line 338 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
#undef GRA_DISP_INTERFERENCE 
FILE *GRA_DISP_INTERFERENCE = NULL;

#line 349 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
#undef GRA_DISP_COST
FILE *GRA_DISP_COST = NULL;

#line 360 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
#undef GRA_DISP_COLORING
FILE *GRA_DISP_COLORING = NULL;

#line 372 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
#undef GRA_DISP_PCOPY_COST
FILE *GRA_DISP_PCOPY_COST = NULL;

#line 383 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
#undef GRA_STAT 
FILE *GRA_STAT = NULL;

#line 394 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
#undef GRA_MULTREGION 
FILE *GRA_MULTREGION = NULL;

#line 407 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
static int GRA_Initialized = 0;

#line 409 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
void
GRA_INIT(void)
{
  if (GRA_Initialized++ == 0) {
    if (GETENV("GRA_DISP_INTERFERENCE")) {
      int file = 0;
      sscanf(GETENV("GRA_DISP_INTERFERENCE"), "%d", &file);
      if (file == 1) GRA_DISP_INTERFERENCE = stdout;
      else if (file == 2) GRA_DISP_INTERFERENCE = stderr;
    }
    if (GETENV("GRA_DISP_COST")) {
      int file = 0;
      sscanf(GETENV("GRA_DISP_COST"), "%d", &file);
      if (file == 1) GRA_DISP_COST = stdout;
      else if (file == 2) GRA_DISP_COST = stderr;
    }
    if (GETENV("GRA_DISP_COLORING")) {
      int file = 0;
      sscanf(GETENV("GRA_DISP_COLORING"), "%d", &file);
      if (file == 1) GRA_DISP_COLORING = stdout;
      else if (file == 2) GRA_DISP_COLORING = stderr;
    }
    if (GETENV("GRA_DISP_PCOPY_COST")) {
      int file = 0;
      sscanf(GETENV("GRA_DISP_PCOPY_COST"), "%d", &file);
      if (file == 1) GRA_DISP_PCOPY_COST = stdout;
      else if (file == 2) GRA_DISP_PCOPY_COST = stderr;
    }
    if (GETENV("GRA_TRACE")) {
      int file = 0;
      sscanf(GETENV("GRA_TRACE"), "%d", &file);
      if (file == 1) GRA_TRACE = stdout;
      else if (file == 2) GRA_TRACE = stderr;
    }
    GRA_STAT = NULL;
    if (GETENV("GRA_STAT")) {
      int file;
      sscanf(GETENV("GRA_STAT"), "%d", &file);
      if (file == 1) GRA_STAT = stdout;
      else if (file == 2) GRA_STAT = stderr;
      else GRA_STAT=fopen("GRA.stat", "a");
    }
    GRA_MULTREGION = NULL;
    if (GETENV("GRA_MULTREGION")) {
      int file;
      sscanf(GETENV("GRA_MULTREGION"), "%d", &file);
      if (file == 1) GRA_MULTREGION = stdout;
      else if (file == 2) GRA_MULTREGION = stderr;
      else GRA_MULTREGION=fopen(GETENV("GRA_MULTREGION"), "a");
    }
    CCL_INIT();
    MDS_INIT();
    AIR_INIT();
    LIR_INIT();
    PFA_INIT();
    CGO_INIT();
    Equiv_INIT();
    Spill_INIT();
    InterfGraph_INIT();
    GraphColoring_INIT();
  }
}

#line 478 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
void
GRA_FINI(void)
{
  if (--GRA_Initialized == 0) {
    GraphColoring_FINI();
    InterfGraph_FINI();
    Spill_FINI();
    Equiv_FINI();
    CGO_FINI();
    PFA_FINI();
    LIR_FINI();
    AIR_FINI();
    MDS_FINI();
    CCL_FINI();
  }
}

#line 501 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
void
GRA_Test(void (*test)(void))
{
  GRA_INIT();
  (*test)();
  GRA_FINI();
}

#line 509 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
#if XCC__C
void
GRA_TEST(void)
{
#include "GRA/GRA_.c"
}

#line 516 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/GRA.xcc"
int
main(int argc, char **argv)
{
  GRA_Test(GRA_TEST);
  return 0;
}
#endif


#endif//GRA_c_INCLUDED
