#ifndef GRA__h_INCLUDED
#define GRA__h_INCLUDED

//
#include "GRA/GRA.h"

//
#include "GRA/InterfGraph_.h"
#include "GRA/OutOfColoredSSA_.h"
#include "GRA/Florent_.h"
#include "GRA/GraphColoring_.h"
#include "GRA/Equiv_.h"

//
struct OperationAndIdx_ {
  //@args Operation operation, int32_t idx
  Operation OPERATION;
  int32_t IDX;
};
typedef struct OperationAndIdx_ OperationAndIdx_, *OperationAndIdx;
typedef const struct OperationAndIdx_ *const_OperationAndIdx;
typedef struct OperationAndIdx_ * restrict_OperationAndIdx;

extern OperationAndIdx
OperationAndIdx_Ctor(OperationAndIdx this, Operation operation, int32_t idx);

extern OperationAndIdx
OperationAndIdx_Copy(OperationAndIdx this, const_OperationAndIdx that);

extern void
OperationAndIdx_Dtor(OperationAndIdx this);

extern size_t
OperationAndIdx_Size(Operation operation, int32_t idx);

#define OperationAndIdx_OPERATION(this) ((this)->OPERATION)
#define OperationAndIdx__OPERATION(this) (&(this)->OPERATION)
#define OperationAndIdx_IDX(this) ((this)->IDX)
#define OperationAndIdx__IDX(this) (&(this)->IDX)


/*
 * GRA_Test --	Setup and execute a GRA test.
 */
void
GRA_Test(void (*test)(void));


#endif//GRA__h_INCLUDED
