#ifndef InterfGraph_c_INCLUDED
#define InterfGraph_c_INCLUDED

#line 15 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
/*
 * This module implements interference graph support for GraphColoring.
 */

#line 19 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
#include "GRA/GRA_.h"

#line 24 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
// Constant used to enlarge the nodes array.
#define CST_GROW 30

#line 28 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 109 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
Operation
InterfMove_operation(InterfMove this) {
  return InterfMove_OPERATION(this);
}

#line 118 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
InterfNode
InterfMove_def(InterfMove this) {
  return InterfMove_DEF(this);
}

#line 127 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
InterfNode
InterfMove_use(InterfMove this) {
  return InterfMove_USE(this);
}

#line 136 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
int32_t
InterfMove_useIdx(InterfMove this) {
  return InterfMove_USEIDX(this);
}

#line 145 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
int32_t
InterfMove_defIdx(InterfMove this) {
  return InterfMove_DEFIDX(this);
}

#line 154 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
float
InterfMove_cost(InterfMove this) {
  return InterfMove_COST(this);
}

#line 159 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
InterfMove
InterfMove_Ctor(InterfMove this,
                Operation operation, struct InterfNode_ *def,
                struct InterfNode_ *use, int32_t defIdx, int32_t useIdx,
                float cost)
{
  *InterfMove__OPERATION(this) = operation;
  *InterfMove__DEF(this) = def;
  *InterfMove__USE(this) = use;
  *InterfMove__COST(this) = cost;
  *InterfMove__BELONGTO(this) = noneMove;
  *InterfMove__HIGH(this) = 0;
  *InterfMove__DEFIDX(this) = defIdx;
  *InterfMove__USEIDX(this) = useIdx;
  return this;
}

#line 176 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
void
InterfMove_Dtor(InterfMove this)
{
  *InterfMove__OPERATION(this) = NULL;
  *InterfMove__DEF(this) = NULL;
  *InterfMove__USE(this) = NULL;
  *InterfMove__BELONGTO(this) = noneMove;
  *InterfMove__HIGH(this) = 0;
}

#line 195 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
#ifndef ECL_NTRACE
bool
InterfMove_pretty(InterfMove interfMove, FILE* file)
{
	if (file == NULL) file = stderr;

#line 201 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
	fprintf( file, "Move Operation = ");
	Operation_pretty( InterfMove_OPERATION(interfMove), file);
	Temporary_pretty( InterfNode_TEMPORARY(InterfMove_DEF(interfMove)), file);
	fprintf( file, " - ");
	Temporary_pretty( InterfNode_TEMPORARY(InterfMove_USE(interfMove)), file);
	fprintf( file, " cost: %f ", InterfMove_COST(interfMove));
	fprintf( file, "list: ");
	switch(InterfMove_BELONGTO(interfMove)) {
	case noneMove:
		fprintf( file, "none\n");
		break;
	case _coalescedMoves:
		fprintf( file, "coalesced\n");
		break;
	case _constrainedMoves:
		fprintf( file, "constrained\n");
		break;
	case _frozenMoves:
		fprintf( file, "frozen\n");
		break;
	case _worklistMoves:
		fprintf( file, "worklist\n");
		break;
	case _activeMoves:
		fprintf( file, "active\n");
		break;
	default:
		fprintf( file, "ERROR\n");
		break;
	}
  //
  return true;
}
#endif//ECL_NTRACE

#line 260 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
IDList
InterfNode_uses(InterfNode this) {
  return InterfNode_USES(this);
}

#line 269 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
IDList
InterfNode_defs(InterfNode this) {
  return InterfNode_DEFS(this);
}

#line 278 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
Temporary
InterfNode_temporary(InterfNode this) {
  return InterfNode_TEMPORARY(this);
}

#line 287 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
IDList
InterfNode_movelist(InterfNode this) {
  return InterfNode_MOVELIST(this);
}

#line 293 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
InterfNode
InterfNode_Ctor(InterfNode this,
                Memory memory, Temporary temporary)
{
  *InterfNode__MEMORY(this) = memory;
  *InterfNode__TEMPORARY(this) = temporary;
  *InterfNode__ADJLIST(this) = Memory_alloc(memory, sizeof(IDList_));
  IDList_Ctor(*InterfNode__ADJLIST(this), memory);
  *InterfNode__ALIAS(this) = this;
  *InterfNode__BELONGTO(this) = noneNode;
  *InterfNode__MOVELIST(this) = Memory_alloc(memory, sizeof(IDList_));
  IDList_Ctor(*InterfNode__MOVELIST(this), memory);
  *InterfNode__DEGREE(this) = 0;
  if(Temporary_isDedicated(temporary) == true) {
    *InterfNode__COLOR(this) = Temporary_REGISTER(temporary);
  } else *InterfNode__COLOR(this) = Register__UNDEF;
  *InterfNode__USES(this) = Memory_alloc(memory, sizeof(IDList_));
  IDList_Ctor(*InterfNode__USES(this), memory);
  *InterfNode__DEFS(this) = Memory_alloc(memory, sizeof(IDList_));
  IDList_Ctor(*InterfNode__DEFS(this), memory);
  *InterfNode__SPILLCOST(this) = 0;
  *InterfNode__FLAGS(this) = 0;
  return this;
}

#line 318 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
void
InterfNode_Dtor(InterfNode this)
{
  Memory memory = InterfNode_MEMORY(this);
  *InterfNode__TEMPORARY(this) = NULL;
  IDList_Dtor(*InterfNode__ADJLIST(this));
  Memory_free(memory, InterfNode_ADJLIST(this));
  *InterfNode__ALIAS(this) = this;
  *InterfNode__BELONGTO(this) = noneNode;
  IDList_Dtor(*InterfNode__MOVELIST(this));
  Memory_free(memory, InterfNode_MOVELIST(this));
  *InterfNode__DEGREE(this) = 0;
  *InterfNode__COLOR(this) = Register__UNDEF;
  IDList_Dtor(*InterfNode__USES(this));
  Memory_free(memory, InterfNode_USES(this));
  IDList_Dtor(*InterfNode__DEFS(this));
  Memory_free(memory, InterfNode_DEFS(this));
  *InterfNode__SPILLCOST(this) = 0;
  *InterfNode__FLAGS(this) = 0;
}

#line 485 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
uint32_t
InterfNode_index( InterfNode interfNode)
{
  return InterfGraph_temporaryIdentity(InterfNode_TEMPORARY(interfNode));
}

#line 540 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
void
InterfNode_addUse( InterfNode interfNode, Operation operation)
{
  float weight = 0.0;
  IDList_PUSH( InterfNode_USES(interfNode), Operation, operation);
  if (Operation_operator(operation) == Operator_PHI) {
    // For a PHI the weight of the use is the weight of the corresponding
    // predecessor block.
    Temporary temporary = InterfNode_TEMPORARY(interfNode);
    Operation_ARGUMENTS_FOREACH_Temporary(operation, use) {
      BasicBlockEdge edge =
        BasicBlock_getPhiEnterEdge(Operation_basicBlock(operation),
                                   Operation_ARGUMENTS_INDEX);
      if (use == temporary) {
	weight = BasicBlock_frequency(BasicBlockEdge_origBlock(edge));
	break;
      }
    } Operation_ARGUMENTS_ENDEACH_Temporary;
  } else {
    weight = BasicBlock_frequency(Operation_basicBlock(operation));
  }
  *InterfNode__SPILLCOST(interfNode) = InterfNode_SPILLCOST(interfNode) +
    Spill_getReloadCost(InterfNode_TEMPORARY(interfNode))*weight;
}

#line 569 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
void
InterfNode_addDef( InterfNode interfNode, Operation operation)
{
	IDList_PUSH( InterfNode_DEFS(interfNode), Operation, operation);
	*InterfNode__SPILLCOST(interfNode) = InterfNode_SPILLCOST(interfNode) +
		Spill_getSpillCost(InterfNode_TEMPORARY(interfNode))*BasicBlock_frequency(Operation_basicBlock(operation));
}

#line 586 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
#ifndef ECL_NTRACE
bool
InterfNode_pretty(InterfNode interfNode, FILE *file)
{
	InterfNode interfWith = NULL;
	InterfMove interfMove = NULL;
	Operation operation = NULL;

#line 594 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
	if (file == NULL) file = stderr;
	fprintf( file, "Node n%u\n", InterfNode_index(interfNode));
	fprintf( file, "Temporary = ");
	Temporary_pretty( InterfNode_TEMPORARY(interfNode), file );
	fprintf( file, "\n");
	fprintf( file, "Alias n%u\n", InterfNode_index(InterfNode_getAlias(interfNode)));
	fprintf( file, "degree = %d\n", InterfNode_DEGREE(interfNode));

#line 602 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
	fprintf( file, "belongTo = ");
	switch(InterfNode_BELONGTO(interfNode)) {
	case noneNode:
		fprintf( file, "none\n");
		break;
	case _precolored:
		fprintf( file, "precolored\n");
		break;
	case _initial:
		fprintf( file, "initial\n");
		break;
	case _spillWorklist:
		fprintf( file, "spill\n");
		break;
	case _freezeWorklist:
		fprintf( file, "freeze\n");
		break;
	case _simplifyWorklist:
		fprintf( file, "simplify\n");
		break;
	case _selectStack:
		fprintf( file, "selected\n");
		break;
	case _spilledNodes:
		fprintf( file, "spilled\n");
		break;
	case _coalescedNodes:
		fprintf( file, "coalesced\n");
		break;
	case _coloredNodes:
		fprintf( file, "colored\n");
		break;
	case _discardedNodes:
		fprintf( file, "discarded\n");
		break;
	default:
		fprintf( file, "ERROR\n");
		break;
	}
		
	fprintf( file, "\nAdjacency list:\n");
	IDList_FOREACH( InterfNode_ADJLIST(interfNode), InterfNode, interfWith_p) {
		interfWith = *interfWith_p;
		fprintf( file, "\tNode n%u\t", InterfNode_index(interfWith));
		Temporary_pretty( InterfNode_TEMPORARY(interfWith), file );
		
		fprintf( file, " belongTo=%d\n", InterfNode_BELONGTO(interfWith));
	} IDList_ENDEACH;
	
	fprintf( file, "\nMove list:\n");
	IDList_FOREACH( InterfNode_MOVELIST(interfNode), InterfMove, interfMove_p) {
		interfMove = *interfMove_p;
		InterfMove_pretty(interfMove, file);
	} IDList_ENDEACH;

#line 657 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
	fprintf( file, "\nUses list:\n");
	IDList_FOREACH( InterfNode_USES(interfNode), Operation, operation_p) {
		Operation_pretty(*operation_p, file);
	} IDList_ENDEACH;

#line 662 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
	fprintf( file, "\nDefs list:\n");
	IDList_FOREACH( InterfNode_DEFS(interfNode), Operation, operation_p) {
		Operation_pretty(*operation_p, file);
	} IDList_ENDEACH;

#line 667 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
	return true;
}
#endif//ECL_NTRACE

#line 686 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
InterfGraph
InterfGraph_Ctor(InterfGraph this,
                 Memory memory)
{
  *InterfGraph__MEMORY(this) = memory;
  *InterfGraph__SIZE(this) = 0;
  *InterfGraph__ADJSET(this) = NULL;
  *InterfGraph__NODES(this) = NULL;
  return this;
}

#line 697 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
void
InterfGraph_Dtor(InterfGraph this)
{
  Memory memory = InterfGraph_MEMORY(this);
  *InterfGraph__SIZE(this) = 0;
  if (InterfGraph_ADJSET(this) != NULL) {
    BitSet_Dtor(InterfGraph_ADJSET(this));
    Memory_free(memory, InterfGraph_ADJSET(this));
  }
  if (InterfGraph_NODES(this) != NULL) {
    Memory_free(memory, InterfGraph_NODES(this));
  }
}

#line 719 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
void
InterfGraph_createAdjSet(InterfGraph interfGraph, uint32_t count)
{
  *InterfGraph__SIZE(interfGraph) = count;
  *InterfGraph__ADJSET(interfGraph) = Memory_alloc(InterfGraph_MEMORY(interfGraph), sizeof(BitSet_));
  BitSet_Ctor(InterfGraph_ADJSET(interfGraph), InterfGraph_MEMORY(interfGraph), BitMatrix_size(count));
  *InterfGraph__NODES(interfGraph) = Memory_alloc(InterfGraph_MEMORY(interfGraph), count*sizeof(InterfNode));
  memset(InterfGraph_NODES(interfGraph), 0, count*sizeof(InterfNode));
}

#line 790 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
bool
InterfGraph_isAdjacent(InterfGraph interfGraph,
			InterfNode interfNode1,
			InterfNode interfNode2 )
{
	return InterfGraph_isAdjacentIndex(interfGraph, InterfNode_index(interfNode1), InterfNode_index(interfNode2));
}

#line 864 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
#ifndef ECL_NTRACE
bool
InterfGraph_pretty(InterfGraph interfGraph, FILE *file)
{
	int i = 0;
	int j = 0;
	if (file == NULL) file = stderr;
		
	fprintf(file, "\n");
	for( i=0; i<InterfGraph_SIZE(interfGraph); i++) {
		for( j=0; j<InterfGraph_SIZE(interfGraph); j++) {
			InterfGraph_isAdjacentIndex(interfGraph, i, j)? fprintf(file, "X"): fprintf(file, ".");
		}
		fprintf(file, "\n");
	}
	fprintf( file, "\n");

#line 881 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
	return true;
}
#endif//ECL_NTRACE

#line 915 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
static void
InterfGraphBuilder_collectTemporaries(InterfGraphBuilder this);

#line 918 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
static void
InterfGraphBuilder_setNodes(InterfGraphBuilder this);

#line 921 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
static void
InterfGraphBuilder_setDedicated(InterfGraphBuilder this);

#line 924 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
static void
InterfGraphBuilder_setEdges(InterfGraphBuilder this);

#line 927 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
static void
InterfGraphBuilder_setUnAllocatable(InterfGraphBuilder this);

#line 930 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
InterfGraphBuilder
InterfGraphBuilder_Ctor(InterfGraphBuilder this,
                        Memory memory, CodeRegion codeRegion, RegFile regFile,
                        bool clobbersDoNotInterfer, bool newHandlingOfNegAff,
                        bool addMoveInterference, bool noMoveAffinity,
                        bool isSSA)
{
  *InterfGraphBuilder__CLOBBERSDONOTINTERFER(this) = clobbersDoNotInterfer;
  *InterfGraphBuilder__NEWHANDLINGOFNEGAFF(this) = newHandlingOfNegAff;
  *InterfGraphBuilder__ADDMOVEINTERFERENCE(this) = addMoveInterference;
  *InterfGraphBuilder__NOMOVEAFFINITY(this) = noMoveAffinity;
  *InterfGraphBuilder__MEMORY(this) = memory;
  *InterfGraphBuilder__CODEREGION(this) = codeRegion;
  *InterfGraphBuilder__REGFILE(this) = regFile;
  *InterfGraphBuilder__ISSSA(this) = isSSA;
  IDList_Ctor(InterfGraphBuilder_NODES(this), memory);
  IDList_Ctor(InterfGraphBuilder_MOVES(this), memory);
  InterfGraph_Ctor(InterfGraphBuilder_INTERFGRAPH(this), memory);
  TemporaryTable_Ctor(InterfGraphBuilder_TEMPORARIES(this), memory,
                      IndexedFactory_COUNTER(Temporary_Factory));
  *InterfGraphBuilder__LIVENESS(this) =
     Liveness_make(memory, codeRegion, CodeRegion_globalTable(codeRegion), true);
  Liveness_multiplex(InterfGraphBuilder_LIVENESS(this));
  IDList_Ctor(InterfGraphBuilder_SPECIALNODES(this), memory);

#line 955 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
  // Reproduce construction scheme seen in GraphColoring.xcc
  InterfGraphBuilder_collectTemporaries(this);
  InterfGraph_createAdjSet(InterfGraphBuilder_INTERFGRAPH(this),
                           PtrSeq_maxCount(IndexedTable____(TemporaryTable____(InterfGraphBuilder_TEMPORARIES(this)))));
  InterfGraphBuilder_setNodes(this);
  InterfGraphBuilder_setDedicated(this);
  InterfGraphBuilder_setEdges(this);
  if(getenv("SET_UNALLOCATABLE") != NULL)
    InterfGraphBuilder_setUnAllocatable(this);
  return this;
}

#line 967 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
void
InterfGraphBuilder_Dtor(InterfGraphBuilder this)
{
  IDList_Dtor(InterfGraphBuilder_NODES(this));
  IDList_Dtor(InterfGraphBuilder_MOVES(this));
  InterfGraph_Dtor(InterfGraphBuilder_INTERFGRAPH(this));
  TemporaryTable_Dtor(InterfGraphBuilder_TEMPORARIES(this));
  Liveness_kill(InterfGraphBuilder_LIVENESS(this));
  IDList_Dtor(InterfGraphBuilder_SPECIALNODES(this));
}

#line 978 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
static void
InterfGraphBuilder_addNode(InterfGraphBuilder this, Temporary temporary);

#line 1019 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
static bool
InterfGraphBuilder_isNode(InterfGraphBuilder this, Temporary temporary) {
  InterfGraph interfGraph = InterfGraphBuilder_INTERFGRAPH(this);
  int index = InterfGraph_temporaryIdentity(temporary);
  return index >= 0 && index < InterfGraph_SIZE(interfGraph)
    && InterfGraph_NODES(interfGraph)[index] != NULL
    && InterfGraph_temporaryIdentity(InterfNode_TEMPORARY(InterfGraph_NODES(interfGraph)[index]))
    == InterfGraph_temporaryIdentity(temporary);
}

#line 1037 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
InterfNode
InterfGraphBuilder_getNode(InterfGraphBuilder this, Temporary temporary) {
  Except_CHECK(InterfGraphBuilder_isNode(this, temporary));
  return InterfGraph_getNode(InterfGraphBuilder_INTERFGRAPH(this),
                             InterfGraph_temporaryIdentity(temporary));
}

#line 1044 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
static void
InterfGraphBuilder_collectTemporaries(InterfGraphBuilder this) {
  CodeRegion codeRegion = InterfGraphBuilder_CODEREGION(this);
  TemporaryTable table = InterfGraphBuilder_TEMPORARIES(this);
  RegFile regFile = InterfGraphBuilder_REGFILE(this);
  Register i;
  for(i = RegFile_lowRegister(regFile); i <= RegFile_highRegister(regFile);
      ++i) {
    Temporary dedicatedTempo1 = InterfGraphBuilder_getDedicated(this, i);
    TemporaryTable_insert(table, dedicatedTempo1);
  }

#line 1056 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    BasicBlock_liveOutSet_FORSORT_Temporary(basicBlock, temporary) {
      if(Temporary_regFile(temporary) == regFile) {
        TemporaryTable_insert(table, temporary);
      }
    } BasicBlock_liveOutSet_ENDSORT_Temporary;

#line 1063 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      Operation_ARGUMENTS_FOREACH_Temporary(operation, argument) {
        if (Temporary_regFile(argument) == regFile)
          TemporaryTable_insert(table, argument);
      } Operation_ARGUMENTS_ENDEACH_Temporary;
      Operation_RESULTS_FOREACH_Temporary(operation, result) {
        if (Temporary_regFile(result) == regFile)
          TemporaryTable_insert(table, result);
      } Operation_RESULTS_ENDEACH_Temporary;
    } BasicBlock_ENDEACH_Operation;
  } CodeRegion_ENDEACH_BasicBlock;
}

#line 1076 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
Temporary
InterfGraphBuilder_getDedicated(InterfGraphBuilder this, Register registre) {
  return
    Procedure_makeDedicatedTemporary(CodeRegion_procedure(InterfGraphBuilder_CODEREGION(this)),
                                     registre);
}

#line 1083 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
//FIXME: For dedicated, we should use on representative by register
static void
InterfGraphBuilder_addNode(InterfGraphBuilder this, Temporary temporary) {
  IDListItem item;
  InterfGraph interfGraph = InterfGraphBuilder_INTERFGRAPH(this);

#line 1089 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
  Except_CHECK(InterfGraph_temporaryIdentity(temporary) >= 0);
  Except_CHECK(InterfGraph_temporaryIdentity(temporary) < InterfGraph_SIZE(interfGraph));

#line 1092 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
  // Node creation
  item = IDList_push(InterfGraphBuilder_NODES(this), sizeof(InterfNode_));
  InterfNode_Ctor((InterfNode)item, InterfGraphBuilder_MEMORY(this), temporary);
  *InterfNode__BELONGTO((InterfNode)item) = _initial;
  
  // Attach node
  InterfGraph_addNode(interfGraph, (InterfNode)item);
  InterfGraph_addToAdjSet(interfGraph, (InterfNode)item, (InterfNode)item);
}

#line 1102 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
static void
InterfGraphBuilder_setNodes(InterfGraphBuilder this) {
  TemporaryTable_FOREACH_Temporary(InterfGraphBuilder_TEMPORARIES(this), temporary) {
    if(Temporary_regFile(temporary) == InterfGraphBuilder_REGFILE(this)
       && !InterfGraphBuilder_isNode(this, temporary)) {
      InterfGraphBuilder_addNode(this, temporary);
    }
  } TemporaryTable_ENDEACH_Temporary;
}

#line 1112 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
static void
InterfGraphBuilder_addAffinity_(InterfGraphBuilder this, Operation operation,
                                Temporary a, Temporary b, int32_t defIdx,
                                int32_t useIdx, float cost);

#line 1121 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
void
InterfGraphBuilder_addPCOPYAffinity(InterfGraphBuilder this, Operation operation, int32_t idx) {
  Temporary def = Operation_getResult(operation, idx);
  Temporary use = Operation_getArgument(operation, idx);
  float cost = BasicBlock_frequency(Operation_BASICBLOCK(operation));
  InterfGraphBuilder_addAffinity_(this, operation, def, use, idx, idx, cost);
}

#line 1133 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
void
InterfGraphBuilder_addMoveAffinity(InterfGraphBuilder this, Operation operation) {
  InterfGraphBuilder_addPCOPYAffinity(this, operation, 0);
}

#line 1138 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
static void
InterfGraphBuilder_addAffinity(InterfGraphBuilder this, Operation operation,
                               Temporary a, Temporary b, float cost) {
  InterfGraphBuilder_addAffinity_(this, operation, a, b, -1, -1, cost);
}

#line 1144 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
static void
InterfGraphBuilder_addAffinity_(InterfGraphBuilder this, Operation operation,
                                Temporary a, Temporary b, int32_t defIdx,
                                int32_t useIdx, float cost) {
  InterfMove affinity = (InterfMove)IDList_push(InterfGraphBuilder_MOVES(this),
                                                sizeof(InterfMove_));
  InterfNode nodeA = InterfGraphBuilder_getNode(this, a);
  InterfNode nodeB = InterfGraphBuilder_getNode(this, b);
  InterfMove_Ctor(affinity, operation, nodeA, nodeB, defIdx, useIdx, cost);
  *InterfMove__BELONGTO(affinity) = _worklistMoves;

#line 1155 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
  InterfNode_addToMoveList(nodeA, affinity);
  InterfNode_addToMoveList(nodeB, affinity);
}

#line 1169 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
SplitInfo
SplitInfo_Ctor(SplitInfo this, Operation point, Temporary splitVar,
               Temporary origVar, int32_t opndIdx) {
  *SplitInfo__POINT(this) = point;
  *SplitInfo__SPLITVAR(this) = splitVar;
  *SplitInfo__ORIGVAR(this) = origVar;
  *SplitInfo__OPERANDIDX(this) = opndIdx;
  return this;
}

#line 1179 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
static SplitInfo
InterfGraphBuilder_addSpecialNode(InterfGraphBuilder this, Operation operation,
                                  Temporary splitTemp, Temporary temp,
                                  float cost, int32_t opndIdx) {
  InterfGraph interfGraph = InterfGraphBuilder_INTERFGRAPH(this);
  SplitInfo_ splitInfo;
  SplitInfo_Ctor(&splitInfo, operation, splitTemp, temp, opndIdx);

#line 1187 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
  TemporaryTable_insert(InterfGraphBuilder_TEMPORARIES(this), splitTemp);
  if(InterfGraph_temporaryIdentity(splitTemp) >= InterfGraph_SIZE(interfGraph)) {
    BitSet_ adjSet[1];
    BitSet_Ctor(adjSet, InterfGraphBuilder_MEMORY(this),
                BitMatrix_size(InterfGraph_SIZE(interfGraph)));
    BitSet_FOREACH(InterfGraph_ADJSET(interfGraph), iter) {
      BitSet_insert(adjSet, iter);
    } BitSet_ENDEACH;
    // This call preserves NODES but not ADJSET
    InterfGraph_reallocAdjSet(interfGraph, InterfGraph_SIZE(interfGraph)
                              + CST_GROW);
    BitSet_FOREACH(adjSet, iter) {
      BitSet_insert(InterfGraph_ADJSET(interfGraph), iter);
    } BitSet_ENDEACH;
    BitSet_Dtor(adjSet);
  }
  InterfGraphBuilder_addNode(this, splitTemp);
  InterfGraphBuilder_addAffinity(this, operation, splitTemp, temp, cost);
  IDList_PUSH(InterfGraphBuilder_SPECIALNODES(this), SplitInfo_, splitInfo);
  return (SplitInfo)IDList_lastItem(InterfGraphBuilder_SPECIALNODES(this));
}

#line 1209 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
static SplitInfo
InterfGraphBuilder_addSpecialNode2(InterfGraphBuilder this, Operation operation,
                                   Temporary temp, int32_t opndIdx) {
  float cost = BasicBlock_frequency(Operation_basicBlock(operation));
  Temporary splitVar = 
    Procedure_makeVirtualTemporary(CodeRegion_procedure(InterfGraphBuilder_CODEREGION(this)),
                                   InterfGraphBuilder_REGFILE(this));
  return InterfGraphBuilder_addSpecialNode(this, operation, splitVar, temp,
                                           cost, opndIdx);
}

#line 1220 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
static void
InterfGraphBuilder_addPhiAffinities(InterfGraphBuilder this, Operation operation) {
  Temporary def = Operation_getResult(operation, 0);
  // For a PHI operation we add a move affinity between the def and each operand
  // the cost of the affinity is the frequency of the operand related edge.
  PHI_arguments_FOREACH_temporary(operation, edge, idx, use) {
    float cost = BasicBlock_frequency(BasicBlockEdge_origBlock(edge))
      * BasicBlockEdge_probability(edge);
    InterfMove affinity = (InterfMove)IDList_push(InterfGraphBuilder_MOVES(this),
                                                  sizeof(InterfMove_));
    InterfMove_Ctor(affinity, operation, InterfGraphBuilder_getNode(this, def),
                    InterfGraphBuilder_getNode(this, use), 0, idx,  cost);
    *InterfMove__BELONGTO(affinity) = _worklistMoves;

#line 1234 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
    InterfNode_addToMoveList(InterfGraphBuilder_getNode(this, def), affinity);
    InterfNode_addToMoveList(InterfGraphBuilder_getNode(this, use), affinity);
    //break;
  } PHI_arguments_ENDEACH_temporary;
}

#line 1240 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
static void
InterfGraphBuilder_addEdge(InterfGraphBuilder this, InterfNode interfNode1,
                           InterfNode interfNode2)
{
  /* procedure AddEdge(u,v)
   *   if((u,v) is not in adjSet) && (u != v) then
   *     adjSet <- adjSet union {(u,v), (v,u)}
   *     if u is not in precolored then
   *       adjList[u] <- adjList[u] union {v}
   *       degree[u] <- degree[u] + 1
   *     if v is not in precolored then
   *       adjList[v] <- adjList[v] union {u}
   *       degree[v] <- degree[v] + 1
   */
  InterfGraph interfGraph = InterfGraphBuilder_INTERFGRAPH(this);

#line 1256 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
  //ALGO: procedure AddEdge(u,v)

#line 1258 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
  //ALGO: if((u,v) is not in adjSet) && (u != v) then
  if( InterfGraph_isAdjacent(interfGraph, interfNode1, interfNode2) == false
      && (InterfNode_index(interfNode1) != InterfNode_index(interfNode2)) ) {

#line 1262 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
    //ALGO: adjSet <- adjSet union {(u,v), (v,u)}
    InterfGraph_addToAdjSet(interfGraph, interfNode1, interfNode2);

#line 1265 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
    //ALGO: if u is not in precolored then
    if( InterfNode_isPrecolored(interfNode1) == false ) {
      //ALGO: adjList[u] <- adjList[u] union {v}
      InterfNode_addToAdjList( interfNode1, interfNode2);
      //ALGO: degree[u] <- degree[u] + 1
      InterfNode_incDegree(interfNode1);
    }

#line 1273 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
    //ALGO: if v is not in precolored then
    if( InterfNode_isPrecolored(interfNode2) == false ) {
      //ALGO: adjList[v] <- adjList[v] union {u}
      InterfNode_addToAdjList( interfNode2, interfNode1);
      //ALGO: degree[u] <- degree[u] + 1
      InterfNode_incDegree(interfNode2);
    }
  }
}

#line 1283 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
static void
InterfGraphBuilder_remEdge(InterfGraphBuilder this, InterfNode aNode,
                           InterfNode bNode) {
  if(InterfGraph_isAdjacent(InterfGraphBuilder_INTERFGRAPH(this),
                            aNode, bNode)) {
    bool found = false;

#line 1290 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
    // remove arc in adjacency matrix
    BitSet_remove(InterfGraph_ADJSET(InterfGraphBuilder_INTERFGRAPH(this)),
                  BitMatrix_index(InterfNode_index(aNode),
                                  InterfNode_index(bNode)));
    // remove node in adjacency list of both node
    // if a is in adjacency list of b, then b is in adjacency list of a.
    IDList_FOREACH(InterfNode_ADJLIST(aNode), InterfNode, curNode_p) {
      if(*curNode_p == bNode) {
        found = true;
        // FIXME: Does it exist a quicker way instead of that loop?
        IDList_remove(InterfNode_ADJLIST(aNode), curNode_p, NULL);
        break;
      }
    } IDList_ENDEACH;
    Except_CHECK(found == true);
    found = false;
    IDList_FOREACH(InterfNode_ADJLIST(bNode), InterfNode, curNode_p) {
      if(*curNode_p == aNode) {
        found = true;
        // FIXME: Does it exist a quicker way instead of that loop?
        IDList_remove(InterfNode_ADJLIST(bNode), curNode_p, NULL);
        break;
      }
    } IDList_ENDEACH;
    Except_CHECK(found == true);
    
    // decrease degree
    *InterfNode__DEGREE(aNode) = InterfNode_DEGREE(aNode) - 1;
    *InterfNode__DEGREE(bNode) = InterfNode_DEGREE(bNode) - 1;
  }
}

#line 1322 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
void
InterfGraphBuilder_setRegClassConstraints(InterfGraphBuilder this, int32_t operandIdx,
                                          const_OperatorParameter parameter,
                                          const_RegisterSet regFileSet,
                                          Operation operation,
                                          Temporary temporary,
                                          PtrSet splitSet) {
  int32_t rank = OperatorParameter_rank(parameter);
  if(rank == operandIdx + 1) {
    OperandType opndType = OperatorParameter_type(parameter);
    if(opndType == OperandType_RegClass) {
      InterfNode node = InterfGraphBuilder_getNode(this, temporary);
      RegClass regClass = OperatorParameter_enum(parameter);
      const_RegisterSet regSet = RegClass_registerSet(regClass);
      RegisterSet_ interferenceReg[1];
      RegisterSet_Ctor(interferenceReg);
      RegisterSet_Copy(interferenceReg, regFileSet);
      RegisterSet_diff(interferenceReg, regSet);
      if(InterfGraphBuilder_CLOBBERSDONOTINTERFER(this) == true) {
        if(InterfGraphBuilder_NEWHANDLINGOFNEGAFF(this) == true) {
          if(RegisterSet_count(interferenceReg) != 0) {
            // we will add moves if affinity is not taken
            float cost = BasicBlock_frequency(Operation_basicBlock(operation));
            Temporary splitVar = 
              Procedure_makeVirtualTemporary(CodeRegion_procedure(InterfGraphBuilder_CODEREGION(this)),
                                             InterfGraphBuilder_REGFILE(this));
            InterfNode splitNode;
            PtrSet_insert(splitSet,
                          InterfGraphBuilder_addSpecialNode(this, operation,
                                                            splitVar, temporary,
                                                            cost, operandIdx));
            splitNode = InterfGraphBuilder_getNode(this, splitVar);

#line 1355 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
            RegisterSet_FOREACH_Register(interferenceReg, reg) {
              Temporary temporaryReg = InterfGraphBuilder_getDedicated(this, reg);
              InterfNode regNode = InterfGraphBuilder_getNode(this, temporaryReg);
              InterfGraphBuilder_addEdge(this, splitNode, regNode);
            } RegisterSet_ENDEACH_Register;
          }
        } else {
          float cost = BasicBlock_frequency(Operation_basicBlock(operation)) * -1;
          RegisterSet_FOREACH_Register(interferenceReg, reg) {
            Temporary temporaryReg = InterfGraphBuilder_getDedicated(this, reg);
            InterfNode regNode = InterfGraphBuilder_getNode(this, temporaryReg);
            InterfGraphBuilder_addAffinity(this, operation,
                                           temporaryReg, temporary, cost);
          } RegisterSet_ENDEACH_Register;
        }
      } else {
        RegisterSet_FOREACH_Register(interferenceReg, reg) {
          Temporary temporaryReg = InterfGraphBuilder_getDedicated(this, reg);
          InterfNode regNode = InterfGraphBuilder_getNode(this, temporaryReg);
          InterfGraphBuilder_addEdge(this, node, regNode);
        } RegisterSet_ENDEACH_Register;
      }
    }
  }
}

#line 1381 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
static void
addSameValue(TemporarySet* sameValues, IDList temporarySetsStorage,
             Temporary dst, Temporary src) {
  if(!Temporary_isDedicated(src) && !Temporary_isDedicated(dst)) {
    TemporarySet sameValueTempoSet = NULL;
    Except_CHECK(Temporary_regFile(src) == Temporary_regFile(dst));
    if(sameValues[Temporary_index(dst)] == NULL
       && sameValues[Temporary_index(src)] == NULL) {
      sameValueTempoSet =
        (TemporarySet)IDList_push(temporarySetsStorage, sizeof(TemporarySet_));
      TemporarySet_Ctor(sameValueTempoSet,
                        IDList_memory(temporarySetsStorage), 2);
      sameValues[Temporary_index(dst)] = sameValueTempoSet;
      sameValues[Temporary_index(src)] = sameValueTempoSet;
    } else if(sameValues[Temporary_index(dst)] == NULL) {
      sameValues[Temporary_index(dst)] = sameValues[Temporary_index(src)];
    } else {
      sameValues[Temporary_index(src)] = sameValues[Temporary_index(dst)];
    }
    // both share same temporary set, so take one of them
    sameValueTempoSet = sameValues[Temporary_index(dst)];
    TemporarySet_insert(sameValueTempoSet, dst);
    TemporarySet_insert(sameValueTempoSet, src);
  }
}

#line 1407 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
struct EltNTempSet_ {
  //@ctor Temporary elt, Memory memory
  Temporary ELT;
  TemporarySet_ TEMPSET_;
  //@access TEMPSET EltNTempSet__TEMPSET_(this)
};
typedef struct EltNTempSet_ EltNTempSet_, *EltNTempSet;
typedef const struct EltNTempSet_ *const_EltNTempSet;
typedef struct EltNTempSet_ * restrict_EltNTempSet;

#define EltNTempSet_ELT(this) ((this)->ELT)
#define EltNTempSet__ELT(this) (&(this)->ELT)
#define EltNTempSet_TEMPSET_(this) ((this)->TEMPSET_)
#define EltNTempSet__TEMPSET_(this) (&(this)->TEMPSET_)
#define EltNTempSet_TEMPSET(this) (EltNTempSet__TEMPSET_(this))


#line 1414 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
EltNTempSet
EltNTempSet_Ctor(EltNTempSet this, Temporary elt, Memory memory) {
  *EltNTempSet__ELT(this) = elt;
  TemporarySet_Ctor(EltNTempSet_TEMPSET(this), memory, 0);
  return this;
}

#line 1422 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
// Pseudo code:
// For all BB
//   {live} <- {BB.liveOut}
//   For all op in reverse order in BB
//     {def} <- {op.results}
//     SetRegClassConstraint({def}, op)* // add interference with forbidden colors
//                                       // specifically for this op
//     {use} <- {op.arguments}
//     SetRegClassConstraint({use}, op)*
//     If op is copy or op is phi
//       addAffinity(op)
//     {live} <- {live} \ {def}
//     For var in {live}
//       For definition in {def}
//         addEdge(var, definition) // Set an interference
//       For clobber in {op.clobbers}
//         addEdge(var, clobber)*
//     If op is not phi
//       {live} <- {live} U {use}
// * Support usage of negative affinity instead of interference
//
// Now, since negative affinity is not well supported, we propose a new version.
// The goal is to transform negative affinities in positive one with interference.
// For instance, assume V1 is a variable used in a operation op. Op has a
// constraint that says: Arg1 cannot be in R1 or R2. Here V1 is Arg1.
// Old version generates:
// V1 interfers with R1
// V1 interfers with R2
// i.e. V1 - R1
//         \ |
//          R2
// Or with negative affinities:
//    -w
// V1 -- R1
// -w \  |
//      R2
//
// The goal is to split the live range of V1. This means generate that:
//    2*w
// V1 --- V'1 - R1
//            \ |
//             R2
// The meaning is:
// op V1
// becomes
// V'1 mov V1
// op V'1
// V1 mov V'1
// Notice that afinity on edge V1 V'1 is 2*w because we make two moves.
// In fact, we generate something a little more complicated, because we want
// to release all coloring constraints.
// This means we do a split of all live variables plus all variables with
// constraint as soon as a constraint is detected.
// E.g.
// {live Var}
// op V1
// Becomes
// {split live Var} parallel copy {live Var}
// V'1 mov V1 // <- V'1 does not interfer with split var of V1
// op V'1
// {live Var} parallel copy {split live Var}
// Assume V1 cross op, the resulting interference graph is:
//     w
// V1 --- V''1(split var)
//   \    |
//  w \   | 1
//     \  |
//       V'1 - R1
//           \ |
//            R2
// Global scheme of split is:
// {splitLive} parallel copy {live}
// {splitUse} parallel copy {use}
// {splitDef} op {splitUse}
// {def} parallel copy {splitDef}
// {live} parallel copy {splitLive}
static void
InterfGraphBuilder_setEdges(InterfGraphBuilder this) {
  int i;

#line 1502 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
  TemporarySet live, use, def;
  PtrSet_ splitDef[1], splitUse[1], splitLive[1];
  PtrSet_ dedicatedCross[1], dedicatedUse[1], dedicatedDef[1];

#line 1506 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
  RegFile regFile = InterfGraphBuilder_REGFILE(this);
  BasicBlock flowNode = NULL;
  InterfNode interfNode = NULL;
  InterfMove interfMove = NULL;
  InterfNode interfN2 = NULL;
  uint32_t nbElts = PtrSeq_maxCount(IndexedTable____(TemporaryTable____(InterfGraphBuilder_TEMPORARIES(this))));

#line 1513 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
  TemporarySet *sameValues = NULL;
  IDList_ temporarySetsStorage[1];
  uint32_t sizeSameValues = sizeof(TemporarySet) * nbElts;

#line 1517 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
  uint32_t count = 0;
  uint32_t index = 0;

#line 1520 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
  IDList specialNodes = InterfGraphBuilder_SPECIALNODES(this);

#line 1522 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
  // same value handling
  sameValues = Memory_alloc(InterfGraphBuilder_MEMORY(this), sizeSameValues);
  bzero(sameValues, sizeSameValues);
  IDList_Ctor(temporarySetsStorage, InterfGraphBuilder_MEMORY(this));

#line 1527 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
  use = TemporarySet_make(InterfGraphBuilder_MEMORY(this), 0);
  def = TemporarySet_make(InterfGraphBuilder_MEMORY(this), 0);
  live = TemporarySet_make(InterfGraphBuilder_MEMORY(this), 0);
  PtrSet_Ctor(splitUse, InterfGraphBuilder_MEMORY(this), CST_GROW);
  PtrSet_Ctor(splitDef, InterfGraphBuilder_MEMORY(this), CST_GROW);
  PtrSet_Ctor(splitLive, InterfGraphBuilder_MEMORY(this), CST_GROW);

#line 1534 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
  PtrSet_Ctor(dedicatedCross, InterfGraphBuilder_MEMORY(this),
              RegisterSet_count(RegFile_registerSet(regFile)));
  PtrSet_Ctor(dedicatedUse, InterfGraphBuilder_MEMORY(this),
              RegisterSet_count(RegFile_registerSet(regFile)));
  PtrSet_Ctor(dedicatedDef, InterfGraphBuilder_MEMORY(this),
              RegisterSet_count(RegFile_registerSet(regFile)));

#line 1541 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
  //ALGO: procedure Build()

#line 1543 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
  //ALGO: forall b in 'blocks in program'
  CodeRegion_FOREACH_BasicBlock(InterfGraphBuilder_CODEREGION(this), basicBlock) {
    //ALGO: let live = liveOut(b)
    TemporarySet_empty(live);
    BasicBlock_liveOutSet_FORSORT_Temporary(basicBlock, temporary) {
      if(Temporary_regFile(temporary) == regFile
         /* && !Temporary_isDedicated(temporary) */) {
        TemporarySet_insert( live, temporary);
      }
    } BasicBlock_liveOutSet_ENDSORT_Temporary;

#line 1554 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
    //ALGO: forall I in instructions(b) in reverse order
    BasicBlock_FORBACK_Operation( basicBlock, operation) {
      bool hasSplit = Operation_hasClobber(operation);
      TemporarySet_empty(use);
      TemporarySet_empty(def);
      PtrSet_empty(splitUse);
      PtrSet_empty(splitDef);
      PtrSet_empty(splitLive);
      PtrSet_empty(dedicatedCross);
      PtrSet_empty(dedicatedUse);
      PtrSet_empty(dedicatedDef);
      {
        Operator operator = Operation_operator(operation);
        const_OperatorParameterArray parameterArray =
          Operator_parameterArray(operator);
        const OperatorParameter_* writeParameters =
          OperatorParameterArray_writeParameters(parameterArray);
        const OperatorParameter_* readParameters =
          OperatorParameterArray_readParameters(parameterArray);
        int32_t idx = 0;
        const_RegisterSet regFileSet =
          RegFile_registerSet(InterfGraphBuilder_REGFILE(this));
        // Construct def(I) and use(I)
        Operation_RESULTS_FOREACH_Temporary( operation, temporary) {
          if(Temporary_regFile(temporary) == regFile
             /* && !Temporary_isDedicated(temporary) */) {
            if(TemporarySet_insert(def, temporary) == true) {
              InterfNode_addDef(InterfGraphBuilder_getNode(this, temporary), operation);
              // Add interference between definitions
              TemporarySet_FOREACH_Temporary(def, defTemp) {
                if(defTemp != temporary) {
                  InterfGraphBuilder_addEdge(this, InterfGraphBuilder_getNode(this, temporary),
                                             InterfGraphBuilder_getNode(this, defTemp));
                }
              } TemporarySet_ENDEACH_Temporary;
            }
            if(idx < OperatorParameterArray_writeCount(parameterArray)
               && !Temporary_isDedicated(temporary)) {
              // Create that
              //     w
              // V1 --- V'1 - R1
              //            \ |
              //             R2
              int32_t splitCount = PtrSet_count(splitDef);
              InterfGraphBuilder_setRegClassConstraints(this, idx, writeParameters,
                                                        regFileSet, operation,
                                                        temporary, splitDef);
              hasSplit |= PtrSet_count(splitDef) - splitCount > 0;
            } else if(InterfGraphBuilder_NEWHANDLINGOFNEGAFF(this) == true
                      && InterfGraphBuilder_CLOBBERSDONOTINTERFER(this) == true) {
              // split def
              // If temporary_live is dedicated, def has a specific
              // semantic. We cannot break that
              if(!Temporary_isDedicated(temporary)) {
                // Create split def:
                //     w
                // V1 --- V''1
                PtrSet_insert(splitDef,
                              InterfGraphBuilder_addSpecialNode2(this, operation,
                                                                 temporary, idx));
              } else {
                PtrSet_insert(dedicatedDef, InterfGraphBuilder_getNode(this,
                                                                       temporary));
              }
            }
          }
          // Access to this variable is controled, so it is not important if
          // we go too far
          ++writeParameters;
          ++idx;
        } Operation_RESULTS_ENDEACH_Temporary;

#line 1626 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
        Operation_ARGUMENTS_FOREACH_Temporary( operation, temporary) {
          if(Temporary_regFile(temporary) == regFile
             /* && !Temporary_isDedicated(temporary) */) {
            if(TemporarySet_insert(use, temporary) == true) {
              InterfNode_addUse(InterfGraphBuilder_getNode(this, temporary), operation);
            }
            if(idx < OperatorParameterArray_readCount(parameterArray)
               && !Temporary_isDedicated(temporary)) {
              // Create that
              //     w
              // V1 --- V'1 - R1
              //            \ |
              //             R2
              int32_t splitCount = PtrSet_count(splitUse);
              InterfGraphBuilder_setRegClassConstraints(this, idx, readParameters,
                                                        regFileSet, operation, 
                                                       temporary, splitUse);
              hasSplit |= PtrSet_count(splitUse) - splitCount > 0;
            } else if(InterfGraphBuilder_NEWHANDLINGOFNEGAFF(this) == true
                      && InterfGraphBuilder_CLOBBERSDONOTINTERFER(this) == true) {
              // split use
              // If temporary_live is dedicated, def has a specific
              // semantic. We cannot break that
              if(!Temporary_isDedicated(temporary)) {
                // Create split use:
                //     w
                // V1 --- V''1
                PtrSet_insert(splitUse,
                              InterfGraphBuilder_addSpecialNode2(this, operation,
                                                                 temporary, idx));
              } else {
                PtrSet_insert(dedicatedUse, InterfGraphBuilder_getNode(this,
                                                                       temporary));
              }
            }
          }
          // Access to this variable is controled, so it is not important if
          // we go too far
          ++readParameters;
          ++idx;
        } Operation_ARGUMENTS_ENDEACH_Temporary;
        if(!hasSplit) {
          PtrSet_FOREACH(splitDef, SplitInfo, useInfo) {
            IDList_remove(specialNodes, useInfo, NULL);
          } PtrSet_ENDEACH;
          PtrSet_empty(splitDef);
          // no split on dedicated, nothing to remove
          PtrSet_empty(dedicatedDef);
          PtrSet_FOREACH(splitUse, SplitInfo, useInfo) {
            IDList_remove(specialNodes, useInfo, NULL);
          } PtrSet_ENDEACH;
          PtrSet_empty(splitUse);
          // no split on dedicated, nothing to remove
          PtrSet_empty(dedicatedUse);
        }
      }

#line 1683 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
      if (   Operator_isParCopy(Operation_operator(operation))
          || Operator_isSeqCopy( Operation_operator(operation))) {
        int32_t i = 0;
        float cost = BasicBlock_frequency(basicBlock);
        for(i = 0; i < Operation_argCount(operation); i++) {
          Temporary dst = Operation_getResult(operation, i);
          Temporary src = Operation_getArgument(operation, i);
          if(Temporary_regFile(dst) == regFile
             && Temporary_regFile(src) == regFile) {
            if(!InterfGraphBuilder_ADDMOVEINTERFERENCE(this)) {
              // if we remove src from live and we are handling a pcopy
              // add interference with all others definition
              if(TemporarySet_remove(live, src)
                 && Operator_isParCopy(Operation_operator(operation))) {
                int32_t j = 0;
                InterfNode srcNode = InterfGraphBuilder_getNode(this, src);
                for(j = 0; j < Operation_argCount(operation); j++) {
                  if(j != i) {
                    InterfGraphBuilder_addEdge(this,
                                               InterfGraphBuilder_getNode(this,Operation_getResult(operation, j)),
                                               srcNode);
                  }
                }

#line 1707 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
              }
              // too complicate for no ssa
              if(InterfGraphBuilder_ISSSA(this)) {
                addSameValue(sameValues, temporarySetsStorage, dst, src);
              }
            }

#line 1714 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
            if(!InterfGraphBuilder_NOMOVEAFFINITY(this)) {
              InterfGraphBuilder_addAffinity_(this, operation,
                                              dst, src, i, i, cost);
            }
          }
        }
      }

#line 1722 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
      // ALGO. if is PHI(I) add move affinities
      if (Operation_operator(operation) == Operator_PHI
          && Temporary_regFile(Operation_getResult(operation, 0)) == regFile) {
        InterfGraphBuilder_addPhiAffinities(this, operation);
      }

#line 1728 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
      //ALGO: live <- live union def(I)
// Do not unioned with def, since def are defined "after" operation execution,
// thus not affected by clobber
//      TemporarySet_union( live, def);
      TemporarySet_diff( live, def);	

#line 1734 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
      //ALGO: forall l in live
      TemporarySet_FORSORT_Temporary( live, Temporary_compare, temporary_live) {
        //ALGO: forall d in def(I)
        InterfNode interfNode_live = InterfGraphBuilder_getNode(this, temporary_live);
        TemporarySet_FORSORT_Temporary( def, Temporary_compare, temporary_def) {
          //ALGO: AddEdge(l, d)
          InterfGraphBuilder_addEdge(this, interfNode_live,
                                     InterfGraphBuilder_getNode(this, temporary_def));
        } TemporarySet_ENDSORT_Temporary;

#line 1744 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
        if(InterfGraphBuilder_NEWHANDLINGOFNEGAFF(this) == true
           && InterfGraphBuilder_CLOBBERSDONOTINTERFER(this) == true
           && hasSplit) {
          SplitInfo liveInfo = NULL;
          // If temporary_live is dedicated, temporary_live has a specific
          // semantic. We cannot break that
          if(!Temporary_isDedicated(temporary_live)) {
            // Create split live:
            //     w
            // V1 --- V''1
            liveInfo =
              InterfGraphBuilder_addSpecialNode2(this, operation, temporary_live,
                                                    -1);
            interfNode_live =
              InterfGraphBuilder_getNode(this, SplitInfo_SPLITVAR(liveInfo));
          }
          // def interfer with {splitLive}
          TemporarySet_FORSORT_Temporary( def, Temporary_compare, temporary_def) {
            InterfGraphBuilder_addEdge(this, interfNode_live,
                                       InterfGraphBuilder_getNode(this, temporary_def));
          } TemporarySet_ENDSORT_Temporary;

#line 1766 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
          // use interfer with {splitLive}
          TemporarySet_FORSORT_Temporary( use, Temporary_compare, temporary_use) {
            if(liveInfo == NULL || temporary_use != SplitInfo_ORIGVAR(liveInfo)) {
              InterfGraphBuilder_addEdge(this, interfNode_live,
                                         InterfGraphBuilder_getNode(this, temporary_use));
            }
          } TemporarySet_ENDSORT_Temporary;

#line 1774 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
          PtrSet_FOREACH(splitUse, SplitInfo, useInfo) {
            // Create that:
            // V''1 (split live var)
            //  |
            //  | 1
            // V'1 (split use var)
            if(liveInfo != NULL
               && SplitInfo_ORIGVAR(useInfo) == SplitInfo_ORIGVAR(liveInfo)) {
              InterfGraphBuilder_addAffinity(this, operation,
                                             SplitInfo_SPLITVAR(useInfo),
                                             SplitInfo_SPLITVAR(liveInfo),
                                             1);
            } else {
              // Assume split variables interfer.
              // FIXME: In fact, split variables must have the same
              // configuration as live variables in terms of interference.
              // But, interference on live variables will be know at the end of
              // the proceeding (done in reverse order), thus not here.
              // So a check pass should be done.
              // Currently this is not necessary because the definition of
              // liveness is: Two variables interfer if one is live at the
              // definition of the other regardless this definition
              // (interference also with same value)
              InterfNode interfNode_use =
                InterfGraphBuilder_getNode(this, SplitInfo_SPLITVAR(useInfo));
              InterfGraphBuilder_addEdge(this, interfNode_live, interfNode_use);
            }
          } PtrSet_ENDEACH;
          PtrSet_FOREACH(splitDef, SplitInfo, defInfo) {
            // Assume split variables interfer.
            // FIXME: same comment as previous
            InterfNode interfNode_def =
              InterfGraphBuilder_getNode(this, SplitInfo_SPLITVAR(defInfo));
            InterfGraphBuilder_addEdge(this, interfNode_live, interfNode_def);
          } PtrSet_ENDEACH;
          // Split lives interfer
          PtrSet_FOREACH(splitLive, SplitInfo, crossInfo) {
            // Assume split variables interfer.
            // FIXME: same comment as previous
            InterfNode interfNode_cross =
              InterfGraphBuilder_getNode(this, SplitInfo_SPLITVAR(crossInfo));
            InterfGraphBuilder_addEdge(this, interfNode_live, interfNode_cross);
          } PtrSet_ENDEACH;
          if(liveInfo != NULL) {
            PtrSet_insert(splitLive, liveInfo);
            PtrSet_FOREACH(dedicatedCross, InterfNode, interfNode_crossDedicated) {
              InterfGraphBuilder_addEdge(this, interfNode_live,
                                         interfNode_crossDedicated);
            } PtrSet_ENDEACH;
            PtrSet_FOREACH(dedicatedUse, InterfNode, interfNode_defDedicated) {
              InterfGraphBuilder_addEdge(this, interfNode_live,
                                         interfNode_defDedicated);
            } PtrSet_ENDEACH;
            PtrSet_FOREACH(dedicatedDef, InterfNode, interfNode_defDedicated) {
              InterfGraphBuilder_addEdge(this, interfNode_live,
                                         interfNode_defDedicated);
            } PtrSet_ENDEACH;
          } else {
            // dedicated which cross
            PtrSet_insert(dedicatedCross, interfNode_live);
          }
        }

#line 1837 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
        if(Operation_hasClobber(operation)) { // If this operation corrupts some registers.
          RegisterSet clobberSet = Operation_clobberSet(operation);
          Temporary temporary_clobber = NULL;

#line 1841 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
          if(InterfGraphBuilder_CLOBBERSDONOTINTERFER(this) == true
             && !InterfGraphBuilder_NEWHANDLINGOFNEGAFF(this)) {
            float cost = BasicBlock_frequency(basicBlock) * -1;
            RegisterSet_FOREACH_Register(clobberSet, clobber) {
              temporary_clobber = InterfGraphBuilder_getDedicated(this, clobber);
              if(Temporary_regFile(temporary_clobber) == regFile) {
                InterfGraphBuilder_addAffinity(this, operation, temporary_live, temporary_clobber, cost);
              }
            } RegisterSet_ENDEACH_Register;
          } else {
            RegisterSet_FOREACH_Register(clobberSet, clobber) {
              temporary_clobber = InterfGraphBuilder_getDedicated(this, clobber);
              if(Temporary_regFile(temporary_clobber) == regFile) {
                InterfGraphBuilder_addEdge(this, interfNode_live,
                                           InterfGraphBuilder_getNode(this, temporary_clobber));
              }
            } RegisterSet_ENDEACH_Register;
          }
        }
      } TemporarySet_ENDSORT_Temporary;

#line 1862 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
      //ALGO: live <- use(I) union (live \ def(I)) ignore uses on PHI
//      TemporarySet_diff( live, def);	
      if (Operation_operator(operation) != Operator_PHI)
        TemporarySet_union( live, use);
      // Split uses interfer.
      // FIXEME: In fact, we should represent the same topology as
      // the split graph. But here, it is incomplete.
      PtrSet_FOREACH(splitUse, SplitInfo, useInfo) {
        InterfNode interfNode_use =
          InterfGraphBuilder_getNode(this, SplitInfo_SPLITVAR(useInfo));
        const PtrSetMember *(PtrSet_innerITER) = PtrSet_ITER - 1;    \
        for (; PtrSet_innerITER >= PtrSet_BASE; --(PtrSet_innerITER)) {
          SplitInfo useInfo2 = (SplitInfo)*(PtrSet_innerITER);
          if(SplitInfo_ORIGVAR(useInfo) == SplitInfo_ORIGVAR(useInfo2)) {
            InterfGraphBuilder_addAffinity(this, operation,
                                           SplitInfo_SPLITVAR(useInfo),
                                           SplitInfo_SPLITVAR(useInfo2),
                                           1);
          } else {
            InterfNode interfNode_use2 =
              InterfGraphBuilder_getNode(this, SplitInfo_SPLITVAR(useInfo2));
            InterfGraphBuilder_addEdge(this, interfNode_use, interfNode_use2);
          }
        }
        PtrSet_FOREACH(dedicatedUse, InterfNode, interfNode_useDedicated) {
          InterfGraphBuilder_addEdge(this, interfNode_use,
                                     interfNode_useDedicated);
        } PtrSet_ENDEACH;
      } PtrSet_ENDEACH;
      // Split defs interfer
      PtrSet_FOREACH(splitDef, SplitInfo, defInfo) {
        InterfNode interfNode_def =
          InterfGraphBuilder_getNode(this, SplitInfo_SPLITVAR(defInfo));
        const PtrSetMember *(PtrSet_innerITER) = PtrSet_ITER - 1;    \
        for (; PtrSet_innerITER >= PtrSet_BASE; --(PtrSet_innerITER)) {
          SplitInfo defInfo2 = (SplitInfo)*(PtrSet_innerITER);
          if(SplitInfo_ORIGVAR(defInfo) == SplitInfo_ORIGVAR(defInfo2)) {
            // This case is not possible in SSA
            InterfGraphBuilder_addAffinity(this, operation,
                                           SplitInfo_SPLITVAR(defInfo),
                                           SplitInfo_SPLITVAR(defInfo2),
                                           1);
          } else {
            InterfNode interfNode_def2 =
              InterfGraphBuilder_getNode(this, SplitInfo_SPLITVAR(defInfo2));
            InterfGraphBuilder_addEdge(this, interfNode_def, interfNode_def2);
          }
        }
        PtrSet_FOREACH(dedicatedDef, InterfNode, interfNode_defDedicated) {
          InterfGraphBuilder_addEdge(this, interfNode_def,
                                     interfNode_defDedicated);
        } PtrSet_ENDEACH;
      } PtrSet_ENDEACH;

#line 1916 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
    } BasicBlock_ENDBACK_Operation;
    
    // for each PHI predecessor, add inteference between uses on PHI
    // this is necessary to keep C-SSA as we ignore interferences on moves
    // that otherwise do not interfere.
#if 0
    {
      int argIdx = 0;
      //ALGO: foreach argIdx in num_phi_args
      BasicBlock_ENTER_FOREACH_BasicBlockEdge(basicBlock, edge) {
        TemporarySet_empty(live);
        BasicBlock_FOREACH_Operation(basicBlock, operation) {
          Temporary use;
          InterfNode useNode;

#line 1931 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
          if(Operation_operator(operation) != Operator_PHI) {
            break;
          }
          use = Operation_getArgument(operation, argIdx);
          if(Temporary_regFile(use) != regFile) {
            continue;
          }
          useNode = InterfGraphBuilder_getNode(this, use);
	  
          //ALGO: foreach i in live 
          TemporarySet_FORSORT_Temporary(live, Temporary_compare, temporary_live) {
            InterfNode interfNode_live = InterfGraphBuilder_getNode(this, temporary_live);
            //ALGO: AddEdge(use(argIdx), i)
            InterfGraphBuilder_addEdge(this, interfNode_live, useNode);
          } TemporarySet_ENDSORT_Temporary;

#line 1947 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
          //ALGO: live <- live \ use(argIdx)
          TemporarySet_insert(live, use);
        } BasicBlock_ENDEACH_Operation;
        argIdx++;
      } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
    }
#endif
  } CodeRegion_ENDEACH_BasicBlock;
  TemporarySet_kill(use);
  TemporarySet_kill(def);
  TemporarySet_kill(live);
  PtrSet_Dtor(splitUse);
  PtrSet_Dtor(splitDef);
  PtrSet_Dtor(splitLive);
  PtrSet_Dtor(dedicatedCross);

#line 1963 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
  Memory_free(InterfGraphBuilder_MEMORY(this), sameValues);
  IDList_FOREACH(temporarySetsStorage, TemporarySet_, setOfSameValue) {
    // remove (a, b) edge if it exists for all same values
    TemporarySet_FOREACH_Temporary(setOfSameValue, a) {
      const PtrSetMember *iter = PtrSet_ITER - 1;
      for(; iter >= PtrSet_BASE; --iter) {
        Temporary b = (Temporary)*iter;
        InterfNode aNode = InterfGraphBuilder_getNode(this, a);
        InterfNode bNode = InterfGraphBuilder_getNode(this, b);
        InterfGraphBuilder_remEdge(this, aNode, bNode);
      }
    } TemporarySet_ENDEACH_Temporary;
  } IDList_ENDEACH;

#line 1977 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
  IDList_Dtor(temporarySetsStorage);
}

#line 1980 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
void
InterfGraphBuilder_setDedicated(InterfGraphBuilder this) {
  RegFile regFile = InterfGraphBuilder_REGFILE(this);
  Register i;
  for(i = RegFile_lowRegister(regFile); i < RegFile_highRegister(regFile);
      ++i) {
    Temporary dedicatedTempo1 = InterfGraphBuilder_getDedicated(this, i);
    Register j;
    for(j = i + 1; j <=  RegFile_highRegister(regFile); ++j) {
      Temporary dedicatedTempo2 = InterfGraphBuilder_getDedicated(this, j);
      InterfGraphBuilder_addEdge(this, InterfGraphBuilder_getNode(this,
                                                                  dedicatedTempo1),
                                 InterfGraphBuilder_getNode(this, dedicatedTempo2));
    }
  }
}

#line 1997 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
static void
InterfGraphBuilder_setUnAllocatable(InterfGraphBuilder this) {
  RegisterSet_ registerSet[1];
  RegisterSet_ allocatableSet[1];
  RegisterSet_Copy(registerSet, RegFile_registerSet(InterfGraphBuilder_REGFILE(this)));
  *allocatableSet = Convention_allocatableSet(InterfGraphBuilder_CONVENTION(this),
                                              InterfGraphBuilder_REGFILE(this));
  RegisterSet_diff(registerSet, allocatableSet);
  RegisterSet_FOREACH_Register(registerSet, unallocatableReg) {
    Temporary reservedTemporary =
      InterfGraphBuilder_getDedicated(this, unallocatableReg);
    InterfNode reservedNode = InterfGraphBuilder_getNode(this, reservedTemporary);
    IDList_FOREACH(InterfGraphBuilder_NODES(this), InterfNode_, node) {
      InterfGraphBuilder_addEdge(this, reservedNode, node);
    } IDList_ENDEACH;
  } RegisterSet_ENDEACH_Register;
}

#line 2015 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
static int 
compareMoveElt(const_IDListItem elt1, const_IDListItem elt2) {
  InterfMove a = *(InterfMove*)elt1;
  InterfMove b = *(InterfMove*)elt2;
  int32_t aDefIdx = InterfNode_index(InterfMove_DEF(a));
  int32_t bDefIdx = InterfNode_index(InterfMove_DEF(b));
  int32_t aUseIdx = InterfNode_index(InterfMove_USE(a));
  int32_t bUseIdx = InterfNode_index(InterfMove_USE(b));
  int result;
  if(aDefIdx == bDefIdx) {
    result = aUseIdx - bUseIdx;
  } else if(aDefIdx == bUseIdx) {
    result = aUseIdx - bDefIdx;
  } else if(aUseIdx == bDefIdx) {
    result = aDefIdx - bUseIdx;
  } else {
    result = aDefIdx - bDefIdx;
  }
  return result;
}

#line 2042 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
void
InterfGraphBuilder_displayMapping(InterfGraphBuilder this, FILE* file) {
  if(file == NULL) {
    file = stdout;
  }
  fprintf(file, "index\t\tidentity\n");
  IDList_FOREACH(InterfGraphBuilder_NODES(this), InterfNode_, node) {
    fprintf(file, "%d\t\t%d\n", InterfNode_index(node),
            Temporary_identity(InterfNode_TEMPORARY(node)));
  } IDList_ENDEACH;
}

#line 2066 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
void
InterfGraphBuilder_exportGraph(InterfGraphBuilder this, FILE* file,
                               bool dispInterferenceOnSame,
                               bool dispAffinitiesOnInterference,
                               bool dispInterferenceOnDedicated) {
  InterfGraph interfGraph = InterfGraphBuilder_INTERFGRAPH(this);
  if(file == NULL) {
    file = stdout;
  }
  // NbNodes NbColors
  fprintf(file, "%d %d\n", IDList_count(InterfGraphBuilder_NODES(this)),
          RegFile_highRegister(InterfGraphBuilder_REGFILE(this))
          - RegFile_lowRegister(InterfGraphBuilder_REGFILE(this)) + 1);
  // Interferences Edges
  IDList_FOREACH(InterfGraphBuilder_NODES(this), InterfNode_, node) {
    IDListItem iter;
    for(iter = (IDListItem)node; iter != NULL;
        iter = IDListItemCell_NEXT(IDListItem_CELL(iter))) {
      if(InterfGraph_isAdjacent(interfGraph, node, (InterfNode)iter)
/*          && InterfNode_index(node) <= InterfNode_index((InterfNode)iter) */
         && (dispInterferenceOnSame
             || InterfNode_index(node) != InterfNode_index((InterfNode)iter))) {
        if(!Temporary_isDedicated(InterfNode_TEMPORARY(node))
           || !Temporary_isDedicated(InterfNode_TEMPORARY((InterfNode)iter))
           || dispInterferenceOnDedicated) {
          fprintf(file, "%d %d -1\n", InterfNode_index(node),
                  InterfNode_index((InterfNode)iter));
        }
      }
    }
  } IDList_ENDEACH;
  // Affinities Edges
  IDList_FOREACH(InterfGraphBuilder_NODES(this), InterfNode_, node) {
    IDListItem iter;
    int32_t srcIdx = InterfNode_index(node);
    int32_t dstIdx = -1;
    int32_t affinities = 0;
    IDList_sort(InterfNode_MOVELIST(node), compareMoveElt);
    
    IDList_FOREACH(InterfNode_MOVELIST(node), InterfMove, pmove) {
      InterfMove move = *pmove;
      InterfNode consideredNode =
        InterfNode_index(InterfMove_DEF(move)) == srcIdx
        ? InterfMove_USE(move): InterfMove_DEF(move);
      // assume movelist is sorted!
      if(dstIdx != InterfNode_index(consideredNode)) {
        if(affinities != 0) {
          fprintf(file, "%d %d %d\n", srcIdx, dstIdx, affinities);
        }
        affinities = 0;
        dstIdx = InterfNode_index(consideredNode);
      }

#line 2119 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
      if(srcIdx < dstIdx
         && (dispAffinitiesOnInterference
             || !InterfGraph_isAdjacent(interfGraph, node, consideredNode))) {
        // Expect an integer output
        affinities += (int32_t)(InterfMove_COST(move) * 10);
      }
    } IDList_ENDEACH;
    if(affinities != 0) {
      fprintf(file, "%d %d %d\n", srcIdx, dstIdx, affinities);
    }
  } IDList_ENDEACH;
}

#line 2133 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 2145 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
#if XCC__C
static void
InterfGraph_TEST(void)
{
#include "GRA/InterfGraph_.c"
}

#line 2152 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/InterfGraph.xcc"
int
main(int argc, char **argv)
{
  GRA_Test(InterfGraph_TEST);
  return 0;
}
#endif


#endif//InterfGraph_c_INCLUDED
