#ifndef OutOfColoredSSA__h_INCLUDED
#define OutOfColoredSSA__h_INCLUDED

//
#include "GRA/OutOfColoredSSA.h"

//
#ifndef OUT_OF_COLORED_SSA_POOL
#   define OUT_OF_COLORED_SSA_POOL 128
#endif

//
#define GLUE(a, b) a ## b
// interpreted glue
#define IGLUE(a, b) GLUE(a, b)
#define VAR(variable) IGLUE(variable, __LINE__)

//
#define BasicBlock_FORBACK_ContinusOperation(basicBlock, endBB, operation) \
  {                                                                     \
    BasicBlock VAR(__nextBB) = basicBlock;                              \
    Operation operation = NULL;                                         \
    bool VAR(__continusOperation_hasBreak) = false;                     \
    while(VAR(__nextBB) != NULL && !VAR(__continusOperation_hasBreak)) { \
      BasicBlock VAR(__curBB) = VAR(__nextBB);                          \
      endBB = VAR(__curBB);                                             \
      if(BasicBlock_enterCount(VAR(__curBB)) == 1                       \
         && BasicBlock_leaveCount(BasicBlockEdge_origBlock(BasicBlock_enterFirst(VAR(__curBB)))) == 1 \
         && !BasicBlock_isEntry(VAR(__curBB))) {                        \
        VAR(__nextBB) = BasicBlockEdge_origBlock(BasicBlock_enterFirst(VAR(__curBB))); \
      } else {                                                          \
        VAR(__nextBB) = NULL;                                           \
      }                                                                 \
      for(operation = BasicBlock_lastOperation(VAR(__curBB));           \
          operation != NULL; operation = Operation_prev(operation),     \
            VAR(__continusOperation_hasBreak) = false) {                \
        VAR(__continusOperation_hasBreak) = true;
#define BasicBlock_ENDBACK_ContinusOperation        \
      }                                             \
    }                                               \
  }

//
struct OutOfColoredSSA_ {
  //@args CodeRegion codeRegion, RegFile regFile, Liveness* pliveness, Memory memory
  Memory MEMORY;
  CodeRegion CODEREGION;
  //@access CONVENTION	CodeRegion_convention(OutOfColoredSSA_CODEREGION(this))
  RegFile REGFILE;
  Liveness* PLIVENESS;
};
typedef struct OutOfColoredSSA_ OutOfColoredSSA_, *OutOfColoredSSA;
typedef const struct OutOfColoredSSA_ *const_OutOfColoredSSA;
typedef struct OutOfColoredSSA_ * restrict_OutOfColoredSSA;

extern OutOfColoredSSA
OutOfColoredSSA_Ctor(OutOfColoredSSA this, CodeRegion codeRegion, RegFile regFile, Liveness* pliveness, Memory memory);

extern OutOfColoredSSA
OutOfColoredSSA_Copy(OutOfColoredSSA this, const_OutOfColoredSSA that);

extern void
OutOfColoredSSA_Dtor(OutOfColoredSSA this);

extern size_t
OutOfColoredSSA_Size(CodeRegion codeRegion, RegFile regFile, Liveness* pliveness, Memory memory);

#define OutOfColoredSSA_MEMORY(this) ((this)->MEMORY)
#define OutOfColoredSSA__MEMORY(this) (&(this)->MEMORY)
#define OutOfColoredSSA_CODEREGION(this) ((this)->CODEREGION)
#define OutOfColoredSSA__CODEREGION(this) (&(this)->CODEREGION)
#define OutOfColoredSSA_REGFILE(this) ((this)->REGFILE)
#define OutOfColoredSSA__REGFILE(this) (&(this)->REGFILE)
#define OutOfColoredSSA_PLIVENESS(this) ((this)->PLIVENESS)
#define OutOfColoredSSA__PLIVENESS(this) (&(this)->PLIVENESS)
#define OutOfColoredSSA_CONVENTION(this) (CodeRegion_convention(OutOfColoredSSA_CODEREGION(this)))


//
static inline Memory
OutOfColoredSSA_memory(OutOfColoredSSA this) {
  return OutOfColoredSSA_MEMORY(this);
}

//
static inline CodeRegion
OutOfColoredSSA_codeRegion(OutOfColoredSSA this) {
  return OutOfColoredSSA_CODEREGION(this);
}

//
static inline RegFile
OutOfColoredSSA_regFile(OutOfColoredSSA this) {
  return OutOfColoredSSA_REGFILE(this);
}

//
static inline Procedure
OutOfColoredSSA_procedure(OutOfColoredSSA this) {
  return CodeRegion_procedure(OutOfColoredSSA_CODEREGION(this));
}

//
static void OutOfColoredSSA_initRegisterMap(OutOfColoredSSA this);

//
struct RpcBlock_;
typedef struct RpcBlock_ RpcBlock_, *RpcBlock;
typedef const struct RpcBlock_ *const_RpcBlock;
typedef struct RpcBlock_ * restrict_RpcBlock;

//
struct RpcBlock_ {
  //@args       int nregs
  Rpc_ RPC_IN_;
  //@access rpc_in RpcBlock__RPC_IN_(this)
  Rpc_ RPC_OUT_;
  //@access rpc_out RpcBlock__RPC_OUT_(this)
  float FREQUENCY;
  //access frequency RpcBlock_FREQUENCY(this)
};

extern RpcBlock
RpcBlock_Ctor(RpcBlock this, int nregs);

extern RpcBlock
RpcBlock_Copy(RpcBlock this, const_RpcBlock that);

extern void
RpcBlock_Dtor(RpcBlock this);

extern size_t
RpcBlock_Size(int nregs);

#define RpcBlock_RPC_IN_(this) ((this)->RPC_IN_)
#define RpcBlock__RPC_IN_(this) (&(this)->RPC_IN_)
#define RpcBlock_RPC_OUT_(this) ((this)->RPC_OUT_)
#define RpcBlock__RPC_OUT_(this) (&(this)->RPC_OUT_)
#define RpcBlock_FREQUENCY(this) ((this)->FREQUENCY)
#define RpcBlock__FREQUENCY(this) (&(this)->FREQUENCY)
#define RpcBlock_rpc_out(this) (RpcBlock__RPC_OUT_(this))
#define RpcBlock_rpc_in(this) (RpcBlock__RPC_IN_(this))


//
struct RpcEdge_;
typedef struct RpcEdge_ RpcEdge_, *RpcEdge;
typedef const struct RpcEdge_ *const_RpcEdge;
typedef struct RpcEdge_ * restrict_RpcEdge;

//
struct RpcEdge_ {
  //@args       int nregs, BasicBlockEdge flowArc
  Rpc_ RPC_;
  //@access rpc RpcEdge__RPC_(this)
  BasicBlockEdge FLOWARC;
  bool SPLIT;
  //@access split RpcEdge_SPLIT(this)
  bool PSPLIT;
  //@access psplit RpcEdge_PSPLIT(this)
  bool SPLITABLE;
  //@access splitable RpcEdge_SPLITABLE(this)
  bool MARK;
  //@access mark RpcEdge_MARK(this)
  float FREQUENCY;
  //access frequency RpcEdge_FREQUENCY(this)
  bool FALSEEDGE;
  //@access falseEdge RpcEdge_FALSEEDGE(this)
  bool BACKEDGE;
  //@access backEdge RpcEdge_BACKEDGE(this)
  /*  int SAVEINDEX; */
  /*  //@access saveIndex RpcEdge_SAVEINDEX(this)*/
};

extern RpcEdge
RpcEdge_Ctor(RpcEdge this, int nregs, BasicBlockEdge flowArc);

extern RpcEdge
RpcEdge_Copy(RpcEdge this, const_RpcEdge that);

extern void
RpcEdge_Dtor(RpcEdge this);

extern size_t
RpcEdge_Size(int nregs, BasicBlockEdge flowArc);

#define RpcEdge_RPC_(this) ((this)->RPC_)
#define RpcEdge__RPC_(this) (&(this)->RPC_)
#define RpcEdge_FLOWARC(this) ((this)->FLOWARC)
#define RpcEdge__FLOWARC(this) (&(this)->FLOWARC)
#define RpcEdge_SPLIT(this) ((this)->SPLIT)
#define RpcEdge__SPLIT(this) (&(this)->SPLIT)
#define RpcEdge_PSPLIT(this) ((this)->PSPLIT)
#define RpcEdge__PSPLIT(this) (&(this)->PSPLIT)
#define RpcEdge_SPLITABLE(this) ((this)->SPLITABLE)
#define RpcEdge__SPLITABLE(this) (&(this)->SPLITABLE)
#define RpcEdge_MARK(this) ((this)->MARK)
#define RpcEdge__MARK(this) (&(this)->MARK)
#define RpcEdge_FREQUENCY(this) ((this)->FREQUENCY)
#define RpcEdge__FREQUENCY(this) (&(this)->FREQUENCY)
#define RpcEdge_FALSEEDGE(this) ((this)->FALSEEDGE)
#define RpcEdge__FALSEEDGE(this) (&(this)->FALSEEDGE)
#define RpcEdge_BACKEDGE(this) ((this)->BACKEDGE)
#define RpcEdge__BACKEDGE(this) (&(this)->BACKEDGE)
#define RpcEdge_rpc(this) (RpcEdge__RPC_(this))
#define RpcEdge_falseEdge(this) (RpcEdge_FALSEEDGE(this))
#define RpcEdge_splitable(this) (RpcEdge_SPLITABLE(this))
#define RpcEdge_mark(this) (RpcEdge_MARK(this))
#define RpcEdge_psplit(this) (RpcEdge_PSPLIT(this))
#define RpcEdge_backEdge(this) (RpcEdge_BACKEDGE(this))
#define RpcEdge_saveIndex(this) (RpcEdge_SAVEINDEX(this)*/)
#define RpcEdge_split(this) (RpcEdge_SPLIT(this))


//
/**
 * Setup an empty permutation.
 */
extern void
Rpc_clear(Rpc Rpc);

//
/**
 * Returns true if the permutation is empty.
 * I.e. only not connected nodes.
 */
static bool Rpc_isEmpty(Rpc Rpc);

//
/**
 * Returns true if the reverse parallel copy is identity.
 * I.e. only not connected or self-cycle nodes.
 */
extern bool
Rpc_isIdentity(Rpc Rpc);

//
/**
 * Outputs Rpc into file.
 */
bool
Rpc_pretty(Rpc Rpc, FILE *file);

//
/**
 * Generate the list of reg moves for a reverse parallel copy
 */
extern void
Rpc_getMoveList (Rpc Rpc, int *moves);

//
/*
 * Update live in from live out given the reverse parallel copy to
 * be generated in the block.
 * Live in = (live out - defs + uses)
 */
static void
OutOfColoredSSA_updateLiveIn(OutOfColoredSSA this, BasicBlock B, Rpc Rpc);

//
static void
OutOfColoredSSA_connectLiveNode(OutOfColoredSSA this, bool liveOther[],
                                Rpc rpc);

//
static void
OutOfColoredSSA_saveRemainingLive(OutOfColoredSSA this, bool liveOther[],
                                  Rpc rpc);

//
/**
 * Move a reverse parallel copy [Rpc] on the edge [E] to the
 * top of E, i.e., to the end of the orig basic bloc
 */
static void
OutOfColoredSSA_RpcMoveup (OutOfColoredSSA this, Rpc rpc, BasicBlockEdge E, bool split, bool cond_move);

//
struct Change_ {
  //@arg Operation point, int32_t idx, Temporary previous, bool isArg
  Operation POINT;
  int32_t IDX;
  Temporary PREVIOUS;
  bool ISARG;
};
typedef struct Change_ Change_, *Change;
typedef const struct Change_ *const_Change;
typedef struct Change_ * restrict_Change;

#define Change_POINT(this) ((this)->POINT)
#define Change__POINT(this) (&(this)->POINT)
#define Change_IDX(this) ((this)->IDX)
#define Change__IDX(this) (&(this)->IDX)
#define Change_PREVIOUS(this) ((this)->PREVIOUS)
#define Change__PREVIOUS(this) (&(this)->PREVIOUS)
#define Change_ISARG(this) ((this)->ISARG)
#define Change__ISARG(this) (&(this)->ISARG)


//
extern void
Change_undo(Change this);

//
/**
 * Generate in Rpc the parallel move for the PHIs in the incoming edge.
 * For each Rj = phi(... Rk ...) where Rk comes from E generate
 * the edge Rj <- Rk.
 * If after is true the reverse parallel copy will be placed after the PHI,
 * in this case the PHI is transformed as:
 * Rj = phi(...Rk...) -> Rk = phi(...Rk...)
 * If after is false the reverse parallel copy will be placed before the PHI (in the
 * predecessor), in this case the PHI is transformed as:
 * Rj = phi(...Rk...) -> Rj = phi(...Rj...)
 * TODO: should remove the phi!
 */
static void OutOfColoredSSA_RpcForArc (OutOfColoredSSA this, BasicBlockEdge E, Rpc Rpc, bool after);

//
#define SWAPCOST 3

//
/**
   Provides the static cost (number of sequential instructions) of a 
   parallel copy. Should be multiplied by the frequency.
*/
static int Rpc_moveCount(Rpc rpc);

//
/**
 * Return the cost of generating an RPC on an edge
 * @param cond  predication or not
 */
float Rpc_CostOnEdge(Rpc rpc, BasicBlockEdge E, bool cond);

//
/**
 * Cost of generating an RPC at the end of a block.
 * The RPC can be moved up into the BB.
 */
float Rpc_CostOnBlockBottom(OutOfColoredSSA this, Rpc rpc, BasicBlock B);

//
static bool
adjustRpcWithDeadDefinition(OutOfColoredSSA this, Operation op, Rpc rpc);

//
/**
 * Actually generates the RPC at the end of a block. Find the best place
 * starting from the end and going up.
 */
void Rpc_motionUpfromBlockBottom(OutOfColoredSSA this, Rpc rpc, BasicBlock B);

//
/**
 * Same but generation at the beginning of a BB
 */
void Rpc_motionDownfromBlockTop(OutOfColoredSSA this, Rpc rpc, BasicBlock B);

//
/**
 * Same but cost at the beginning of a BB
 */
float Rpc_CostOnBlockTop(OutOfColoredSSA this, Rpc rpc, BasicBlock B);

//
/**
   Invert the reverse parallel copy "rpc" into "invrpc".
   Inplace inversion is correct.
*/
static void Rpc_invert( Rpc rpc, Rpc rpcinv);

//
/**
   Expands reversible parallel copy "rpc" with "liveIn" as 
   new live in set of "rpc". The old set of live in variables of rpc are 
   sources of "rpc". It should be included in "liveIn". 
*/
static
void Expand_in (OutOfColoredSSA this, Rpc rpc, bool *liveIn);

//
/**
   Expands reversible parallel copy "rpc" with "liveOut" as 
   new live out set of "rpc". The old set of live out variables of rpc are 
   targets of "rpc". It should be included in "liveOut". 
*/
static
void Expand_out (OutOfColoredSSA this, Rpc rpc, bool *liveOut);

//
/**
   Provides the set of live registers between the def and the use points of Operation op
*/
static void Operation_live(OutOfColoredSSA this, Operation op, bool *live);

//
/*
 * Return the set of livein registers of a RPC
 */
static void Rpc_livein(Rpc rpc, bool *live);

//
/**
   Traverse if possible (returns 0 otherwise) an operation from bottom to top.
   Modifies the parallel copy accordingly.
   Recolors the assignments accordingly.
*/
static int Traverse_DownUp(OutOfColoredSSA this, Operation op, Rpc rpc, bool simulate, double *p_costIncludedMoves);

//
/**
   Project a reversible parallel copy "rpc" with "liveOut" as new live out set of "rpc". The old set of live out variables of rpc are targets of "rpc". It should include "liveout".
*/
static void Project_out(OutOfColoredSSA this, Rpc rpc, bool *liveOut);

//
/**
   Traverse if possible (returns 0 otherwise) an operation from top to bottom.
   Modifies the parallel copy accordingly.
   Recolors the assignments accordingly.
*/
static int Traverse_UpDown(OutOfColoredSSA this, Operation op, Rpc rpc, bool simulate);

//
/**
 * Function to create the initial RPC on an edge (identity if there is no
 * PHI in the following BB.
 */
static void BasicBlockEdge_initialRpc(OutOfColoredSSA this, BasicBlockEdge E, Rpc rpc);

//
/**
 *  Return the Edge which has:
 *  - max frequency
 *  - split = false
 *  - rpc != identity
 */
static BasicBlockEdge RpcEdge_bestCandidate();

//
/**
 * Unmark the "potential splits" from the flowArc E, which is the one which 
 * will be split
 */
void static unmark_potential_split(OutOfColoredSSA this, BasicBlockEdge E, bool dir_up, bool first);

//
/**
 * apply compensation and split the already marked potential splits
 */
void static
apply_compensation(OutOfColoredSSA this, BasicBlockEdge E, bool dir_up);

//
/**
 * Process an edge: must choose to
 *  - split it
 *  - move the rpc up
 *  - move the rpc down
 */
static int
OutOfColoredSSA_Process_rpc_Arc(OutOfColoredSSA this, BasicBlockEdge edge);

//
/**
 * Remove the phi-functions at the beginning of a block
 */
static void
OutOfColoredSSA_processPHIs (OutOfColoredSSA this, BasicBlock B);

/*
 * OutOfColoredSSA_INIT --	Initialize the OutOfColoredSSA module.
 */
#define OutOfColoredSSA_INIT()

/*
 * OutOfColoredSSA_FINI --	Finalize the OutOfColoredSSA module.
 */
#define OutOfColoredSSA_FINI()


#endif//OutOfColoredSSA__h_INCLUDED
