#ifndef CGIR_c_INCLUDED
#define CGIR_c_INCLUDED

#line 17 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
#include "O64/O64_.h"

#line 22 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 49 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
const char *
CGIRType_(CGIRType type)
{
  static const char *_[] = {
    "Virtual",
    "Assigned",
    "Dedicated",
    "Absolute",
    "Symbol",
    "Label",
  };
  Except_REQUIRE((unsigned)type < CGIRType__);
  return _[type];
}

#line 129 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
static CGIR_LAB
CGIR_LAB_make(CGIR_LAB cgir_lab, const char *name)
{
  O64_OUTPUT && fprintf(O64_OUTPUT, "    CGIR_LAB_make(CGIR_LAB(%d), \"%s\");\n",
      CGIR_LAB_identity(cgir_lab), name);
  return cgir_lab;
}

#line 143 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
static CGIR_SYM
CGIR_SYM_make(CGIR_SYM cgir_sym, const char *name, bool isSpill, NativeType lai_nativeType)
{
  O64_OUTPUT && fprintf(O64_OUTPUT, "    CGIR_SYM_make(CGIR_SYM(%d), \"%s\", %s, NativeType_%s);\n",
      CGIR_SYM_identity(cgir_sym), name, isSpill? "true": "false", NativeType_name_(lai_nativeType));
  return cgir_sym;
}

#line 157 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
static CGIR_TN
CGIR_TN_make(CGIR_TN cgir_tn, CGIRType cgir_type, ...)
{
  O64_OUTPUT && fprintf(O64_OUTPUT, "    CGIR_TN_make(CGIR_TN(%d), CGIRType_%s, ...);\n",
      CGIR_TN_identity(cgir_tn), CGIRType_(cgir_type));
  return cgir_tn;
}

#line 171 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
static CGIR_OP
CGIR_OP_make(CGIR_OP cgir_op, Operator lai_operator, CGIR_TN arguments[], CGIR_TN results[], CGIR_OP orig_op)
{
  O64_OUTPUT &&
    fprintf(O64_OUTPUT, "    CGIR_OP_make(CGIR_OP(%d),", CGIR_OP_identity(cgir_op)) &&
    CGIR_Print_TN_Vector(arguments, O64_OUTPUT) && CGIR_Print_TN_Vector(results, O64_OUTPUT) &&
    fprintf(O64_OUTPUT, ");\n");
  return cgir_op;
}

#line 185 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
static void
CGIR_OP_more(CGIR_OP cgir_op, int iteration, int startDate, unsigned flags)
{
}

#line 196 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
static CGIR_BB
CGIR_BB_make(CGIR_BB cgir_bb, CGIR_LAB labels[], CGIR_OP operations[], CGIR_RID cgir_rid, float frequency)
{
  O64_OUTPUT &&
    fprintf(O64_OUTPUT, "    CGIR_BB_make(CGIR_BB(%d)", CGIR_BB_identity(cgir_bb)) &&
    CGIR_Print_LAB_Vector(labels, O64_OUTPUT) && CGIR_Print_OP_Vector(operations, O64_OUTPUT) &&
    fprintf(O64_OUTPUT, ",\n\t0x%p,%f);\n", cgir_rid, frequency);
  return cgir_bb;
}

#line 210 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
static void
CGIR_BB_more(CGIR_BB cgir_bb, CGIR_BB loop_bb, intptr_t traceId, int unrolled, unsigned flags)
{
}

#line 221 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
static CGIR_LD
CGIR_LD_make(CGIR_LD cgir_ld, CGIR_BB head_bb, CGIR_TN trip_count_tn, int unrolled)
{
  O64_OUTPUT && fprintf(O64_OUTPUT, "    CGIR_LD_make(CGIR_LD(%d), CGIR_BB(%d), ",
      CGIR_LD_identity(cgir_ld), CGIR_BB_identity(head_bb));
  O64_OUTPUT && trip_count_tn != NULL && fprintf(O64_OUTPUT, "CGIR_TN(%d));\n", CGIR_TN_identity(trip_count_tn));
  O64_OUTPUT && trip_count_tn == NULL && fprintf(O64_OUTPUT, "NULL);\n");
  return cgir_ld;
}

#line 237 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
static void
CGIR_BB_chain(CGIR_BB cgir_bb, CGIR_BB succ_cgir_bb)
{
  O64_OUTPUT && fprintf(O64_OUTPUT, "    CGIR_BB_chain(CGIR_BB(%d), CGIR_BB(%d));\n",
      CGIR_BB_identity(cgir_bb), CGIR_BB_identity(succ_cgir_bb));
}

#line 250 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
static void
CGIR_BB_unchain(CGIR_BB cgir_bb)
{
  O64_OUTPUT && fprintf(O64_OUTPUT, "    CGIR_BB_unchain(CGIR_BB(%d));\n",
      CGIR_BB_identity(cgir_bb));
}

#line 263 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
static void
CGIR_BB_link(CGIR_BB tail_cgir_bb, CGIR_BB head_cgir_bb, float probability)
{
  O64_OUTPUT && fprintf(O64_OUTPUT, "    CGIR_BB_link(CGIR_BB(%d), CGIR_BB(%d), %f);\n",
      CGIR_BB_identity(tail_cgir_bb), CGIR_BB_identity(head_cgir_bb), probability);
}

#line 277 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
static void
CGIR_BB_unlink(CGIR_BB cgir_bb, bool preds, bool succs)
{
  O64_OUTPUT && fprintf(O64_OUTPUT, "    CGIR_BB_unlink(CGIR_BB(%d), %d, %d);\n",
      CGIR_BB_identity(cgir_bb), preds, succs);
}

#line 291 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
static void
CGIR_BB_discard(CGIR_BB cgir_bb)
{
  O64_OUTPUT && fprintf(O64_OUTPUT, "    CGIR_BB_discard(CGIR_BB(%d));\n",
      CGIR_BB_identity(cgir_bb));
}

#line 298 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 323 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
int
CGIR_Print_LAB_Vector(CGIR_LAB cgir_labels[], FILE *file)
{
  int i;
  fprintf(file, "CGIR_LAB_Vector(");
  for (i = 0; cgir_labels[i] != 0; i++) {
    fprintf(file, ", CGIR_LAB(%d)", CGIR_LAB_identity(cgir_labels[i]));
  }
  fprintf(file, ", 0)");
  return 1;
}

#line 339 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
int
CGIR_Print_TN_Vector(CGIR_TN cgir_temporaries[], FILE *file)
{
  int i;
  fprintf(file, "CGIR_TN_Vector(");
  for (i = 0; cgir_temporaries[i] != 0; i++) {
    fprintf(file, ", CGIR_TN(%d)", CGIR_TN_identity(cgir_temporaries[i]));
  }
  fprintf(file, ", 0)");
  return 1;
}

#line 355 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
int
CGIR_Print_OP_Vector(CGIR_OP cgir_operations[], FILE *file)
{
  int i;
  fprintf(file, "CGIR_OP_Vector(");
  for (i = 0; cgir_operations[i] != 0; i++) {
    fprintf(file, ", CGIR_OP(%d)", CGIR_OP_identity(cgir_operations[i]));
  }
  fprintf(file, ", 0)");
  return 1;
}

#line 495 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
O64_Interface
O64_getInstance(void)
{
  static O64_Interface_ O64_instance_ = {
    sizeof(O64_Interface_),
    &Interface_Initialize,
    &Interface_Finalize,
    &Interface_getInstance,
    &Interface_setMaxIssue,
    &Interface_setMinTaken,
    &Interface_setReserved,
    &Interface_setArgStage,
    &Interface_setResStage,
    &Interface_makeLabel,
    &Interface_findLabel,
    &Interface_makeSymbol,
    &Interface_Symbol_setClasses,
    &Interface_findSymbol,
    &Interface_makeDedicatedTemporary,
    &Interface_makeAssignedTemporary,
    &Interface_makeVirtualTemporary,
    &Interface_makeAbsoluteTemporary,
    &Interface_makeSymbolTemporary,
    &Interface_makeLabelTemporary,
    &Interface_Temporary_setWidth,
    &Interface_Temporary_setRemater,
    &Interface_Temporary_setHomeable,
    &Interface_Temporary_setDedicated,
    &Interface_findTemporary,
    &Interface_Temporary_identity,
    &Interface_Temporary_isAbsolute,
    &Interface_Temporary_value,
    &Interface_Temporary_isSymbol,
    &Interface_Temporary_symbol,
    &Interface_Temporary_offset,
    &Interface_Temporary_invariant,
    &Interface_Temporary_isVirtual,
    &Interface_Temporary_isDedicated,
    &Interface_Temporary_isAssigned,
    &Interface_Temporary_register,
    &Interface_Temporary_regFile,
    &Interface_Symbol_identity,
    &Interface_Symbol_name,
    &Interface_Symbol_isSpill,
    &Interface_Symbol_nativeType,
    &Interface_Operation_identity,
    &Interface_Operation_operator,
    &Interface_Operation_iteration,
    &Interface_Operation_startDate,
    &Interface_Operation_isSpillCode,
    &Interface_Operation_isVolatile,
    &Interface_Operation_isHoisted,
    &Interface_Label_identity,
    &Interface_Label_name,
    &Interface_BasicBlock_identity,
    &Interface_BasicBlock_unrolled,
    &Interface_BasicBlock_traceId,
    &Interface_LoopScope_identity,
    &Interface_LoopScope_unrolled,
    &Interface_makeOperation,
    &Interface_findOperation,
    &Interface_Operation_setSafeAccess,
    &Interface_Operation_setHoisted,
    &Interface_Operation_setVolatile,
    &Interface_Operation_setPrefetch,
    &Interface_Operation_setPreload,
    &Interface_Operation_setBarrier,
    &Interface_Operation_setSafePerfs,
    &Interface_Operation_setSpillCode,
    &Interface_makeBasicBlock,
    &Interface_findBasicBlock,
    &Interface_linkBasicBlocks,
    &Interface_makeLoopScope,
    &Interface_findLoopScope,
    &Interface_LoopScope_setDependenceNode,
    &Interface_LoopScope_setDependenceArc,
    &Interface_setBody,
    &Interface_setEntry,
    &Interface_setExit,
    &Interface_setStart,
    &Interface_updateCGIR,
    &Interface_open,
    &Interface_optimize,
    &Interface_close
  };
  return &O64_instance_;
}

#line 676 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 684 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
void
CGIR_INIT(void)
{
}

#line 695 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
void
CGIR_FINI(void)
{
}

#line 700 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
#if XCC__C
void
CGIR_TEST(void)
{
#include "O64/CGIR_.c"
}

#line 707 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/CGIR.xcc"
int
main(int argc, char **argv)
{
  O64_Test(CGIR_TEST);
  return 0;
}
#endif


#endif//CGIR_c_INCLUDED
