#ifndef O64_c_INCLUDED
#define O64_c_INCLUDED

#line 17 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/O64.xcc"
#include "O64/O64_.h"

#line 38 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/O64.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 54 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/O64.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 64 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/O64.xcc"
#undef O64_INPUT 
FILE *O64_INPUT = NULL;

#line 75 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/O64.xcc"
#undef O64_OUTPUT 
FILE *O64_OUTPUT = NULL;

#line 86 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/O64.xcc"
#undef O64_TRACE 
FILE *O64_TRACE = NULL;

#line 97 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/O64.xcc"
#undef O64_XMLIN
FILE *O64_XMLIN = NULL;

#line 108 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/O64.xcc"
#undef O64_XMLOUT
FILE *O64_XMLOUT = NULL;

#line 111 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/O64.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 119 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/O64.xcc"
void
O64_Initialize(void)
{
  MDS_INIT();
  AIR_INIT();
  LIR_INIT();
  PFA_INIT();
  CGO_INIT();
  GRA_INIT();
  XFA_INIT();
  SCD_INIT();
  O64_INIT();
}

#line 139 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/O64.xcc"
void
O64_Open(void)
{
  IndexedFactory_reset(Label_Factory);
  IndexedFactory_reset(Symbol_Factory);
  IndexedFactory_reset(Temporary_Factory);
  IndexedFactory_reset(Operation_Factory);
  IndexedFactory_reset(BasicBlock_Factory);
  IndexedFactory_reset(LoopScope_Factory);
}

#line 156 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/O64.xcc"
void
O64_Close(void)
{
  IndexedFactory_reset(LoopScope_Factory);
  IndexedFactory_reset(BasicBlock_Factory);
  IndexedFactory_reset(Operation_Factory);
  IndexedFactory_reset(Temporary_Factory);
  IndexedFactory_reset(Symbol_Factory);
  IndexedFactory_reset(Label_Factory);
}

#line 173 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/O64.xcc"
void
O64_Finalize(void)
{
  O64_FINI();
  SCD_FINI();
  XFA_FINI();
  GRA_FINI();
  CGO_FINI();
  PFA_FINI();
  LIR_FINI();
  AIR_FINI();
  MDS_FINI();
  CAL_FINI();
  CCL_FINI();
}

#line 189 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/O64.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 197 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/O64.xcc"
static int O64_Initialized = 0;

#line 199 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/O64.xcc"
void
O64_INIT(void)
{
  Except_DEBUG("Except_DEBUG");
  if (O64_Initialized++ == 0) {
    if (GETENV("O64_INPUT")) {
      int file = 0;
      sscanf(GETENV("O64_INPUT"), "%d", &file);
      if (file == 1) O64_INPUT = stdout;
      else if (file == 2) O64_INPUT = stderr;
    }
    if (GETENV("O64_OUTPUT")) {
      int file = 0;
      sscanf(GETENV("O64_OUTPUT"), "%d", &file);
      if (file == 1) O64_OUTPUT = stdout;
      else if (file == 2) O64_OUTPUT = stderr;
    }
    if (GETENV("O64_TRACE")) {
      int file = 0;
      sscanf(GETENV("O64_TRACE"), "%d", &file);
      if (file == 1) O64_TRACE = stdout;
      else if (file == 2) O64_TRACE = stderr;
    }
    if (GETENV("O64_XMLIN")) {
      int file = 0;
      sscanf(GETENV("O64_XMLIN"), "%d", &file);
      if (file == 1) O64_XMLIN = stdout;
      else if (file == 2) O64_XMLIN = stderr;
    }
    if (GETENV("O64_XMLOUT")) {
      int file = 0;
      sscanf(GETENV("O64_XMLOUT"), "%d", &file);
      if (file == 1) O64_XMLOUT = stdout;
      else if (file == 2) O64_XMLOUT = stderr;
    }
    if (O64_INPUT != NULL) {
      fprintf(O64_INPUT, "#include \"O64.h\"\n");
      fprintf(O64_INPUT, "\n");
      fprintf(O64_INPUT, "#define CGIR_LAB(cgir_lab)\t(CGIR_LAB)(cgir_lab)\n");
      fprintf(O64_INPUT, "#define CGIR_SYM(cgir_sym)\t(CGIR_SYM)(cgir_sym)\n");
      fprintf(O64_INPUT, "#define CGIR_WN(cgir_wn)\t(CGIR_WN)(cgir_wn)\n");
      fprintf(O64_INPUT, "#define CGIR_TN(cgir_tn)\t(CGIR_TN)(cgir_tn)\n");
      fprintf(O64_INPUT, "#define CGIR_OP(cgir_op)\t(CGIR_OP)(cgir_op)\n");
      fprintf(O64_INPUT, "#define CGIR_BB(cgir_bb)\t(CGIR_BB)(cgir_bb)\n");
      fprintf(O64_INPUT, "#define CGIR_LD(cgir_ld)\t(CGIR_LD)(cgir_ld)\n");
      fprintf(O64_INPUT, "\n");
      fprintf(O64_INPUT, "extern Label label[];\n");
      fprintf(O64_INPUT, "extern Symbol symbol[];\n");
      fprintf(O64_INPUT, "extern Temporary temporary[];\n");
      fprintf(O64_INPUT, "extern Operation operation[];\n");
      fprintf(O64_INPUT, "extern BasicBlock basicBlock[];\n");
      fprintf(O64_INPUT, "extern LoopScope loopScope[];\n");
      fprintf(O64_INPUT, "extern Interface interface;\n");
      fprintf(O64_INPUT, "\n");
      fprintf(O64_INPUT, "void Interface_0(void) {\n");
    }
    Interface_Counter = 0;
    CCL_INIT();
    CAL_INIT();
    MDS_INIT();
    AIR_INIT();
    LIR_INIT();
    PFA_INIT();
    CGO_INIT();
    GRA_INIT();
    XFA_INIT();
    SCD_INIT();
    CGIR_INIT();
    Interface_INIT();
  }
}

#line 277 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/O64.xcc"
void
O64_FINI(void)
{
  if (--O64_Initialized == 0) {
    Interface_FINI();
    CGIR_FINI();
    SCD_FINI();
    XFA_FINI();
    GRA_FINI();
    CGO_FINI();
    PFA_FINI();
    LIR_FINI();
    AIR_FINI();
    MDS_FINI();
    CAL_FINI();
    CCL_FINI();
    if (O64_INPUT != NULL) {
      int i;
      fprintf(O64_INPUT, "int main(int argc, char **argv) {\n");
      fprintf(O64_INPUT, "  Interface_Initialize();\n");
      fprintf(O64_INPUT, "  Interface_0();\n");
      for (i = 0; i < Interface_Counter; i++) {
        fprintf(O64_INPUT, "  Interface_%d();\n", i + 1);
      }
      fprintf(O64_INPUT, "  Interface_Finalize();\n");
      fprintf(O64_INPUT, "  return 0;\n");
      fprintf(O64_INPUT, "}\n\n");
      if (IndexedFactory_maxCount(Label_Factory) != 0) {
        fprintf(O64_INPUT, "Label label[%d];\n",
                IndexedFactory_maxCount(Label_Factory));
      }
      if (IndexedFactory_maxCount(Symbol_Factory) != 0) {
        fprintf(O64_INPUT, "Symbol symbol[%d];\n",
                IndexedFactory_maxCount(Symbol_Factory));
      }
      if (IndexedFactory_maxCount(Temporary_Factory) != 0) {
        fprintf(O64_INPUT, "Temporary temporary[%d];\n",
                IndexedFactory_maxCount(Temporary_Factory));
      }
      if (IndexedFactory_maxCount(Operation_Factory) != 0) {
        fprintf(O64_INPUT, "Operation operation[%d];\n",
                IndexedFactory_maxCount(Operation_Factory));
      }
      if (IndexedFactory_maxCount(BasicBlock_Factory) != 0) {
        fprintf(O64_INPUT, "BasicBlock basicBlock[%d];\n",
                IndexedFactory_maxCount(BasicBlock_Factory));
      }
      if (IndexedFactory_maxCount(LoopScope_Factory) != 0) {
        fprintf(O64_INPUT, "LoopScope loopScope[%d];\n",
                IndexedFactory_maxCount(LoopScope_Factory));
      }
      fprintf(O64_INPUT, "\n");
    }
  }
}

#line 339 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/O64.xcc"
void
O64_Test(void (*test)(void))
{
  O64_INIT();
  (*test)();
  O64_FINI();
}

#line 347 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/O64.xcc"
#if XCC__C
void
O64_TEST(void)
{
#include "O64/O64_.c"
}

#line 354 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/O64.xcc"
int
main(int argc, char **argv)
{
  O64_Test(O64_TEST);
  return 0;
}
#endif


#endif//O64_c_INCLUDED
