#ifndef O64_h_INCLUDED
#define O64_h_INCLUDED

/*
 * !!!!	O64.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 * Christophe Guillon (Christophe.Guillon@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

//
#include "CCL.h"
#include "CAL.h"
#include "MDS.h"
#include "AIR.h"
#include "LIR.h"
#include "PFA.h"
#include "CGO.h"
#include "PRO.h"
#include "GRA/GRA.h"
#include "XFA/XFA.h"
#include "SCD/SCD.h"

//
#include "MDS/MDS_.h"	//FIXME!

/*
 * The O64 (Open64) library contains the following modules:
 * *	<CGIR CGIR.html> CGIR management functions.
 * *	<Interface Interface.html> Interface.
 */

//
#include "O64/CGIR.h"
#include "O64/Interface.h"

/*
 * O64_XMLIN --	File handle used to print the XML before optimizations.
 */
extern FILE *O64_XMLIN;
#ifdef ECL_NTRACE
#define O64_XMLIN NULL
#endif//ECL_NTRACE

/*
 * O64_XMLOUT --	File handle used to print the XML after optimizations.
 */
extern FILE *O64_XMLOUT;
#ifdef ECL_NTRACE
#define O64_XMLOUT NULL
#endif//ECL_NTRACE

/*
 * O64_Initialize --	Call the INIT functions of the libraries.
 */
void
O64_Initialize(void);

/*
 * O64_Open --	Open the libraries.
 */
void
O64_Open(void);

/*
 * O64_Close --	Close the libraries.
 */
void
O64_Close(void);

/*
 * O64_Finalize --	Call the FINI functions of the libraries.
 */
void
O64_Finalize(void);

/*
 * O64_INIT --	O64 init function.
 */
void
O64_INIT(void);

/*
 * O64_FINI --	O64 fini function.
 */
void
O64_FINI(void);


#endif//O64_h_INCLUDED
