#ifndef Construction_c_INCLUDED
#define Construction_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
#include "SCD/SCD_.h"

#line 21 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 60 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
Construction
Construction_Ctor(Construction this,
                  Memory memory, RegionFlow regionFlow, BlockTrace blockTrace)
{
  CFGNode headNode = BlockTrace_HEADNODE(blockTrace);
  CFGNode tailNode = BlockTrace_TAILNODE(blockTrace);
  BasicBlock headBlock = CFGNode_basicBlock(headNode);
  BasicBlock tailBlock = CFGNode_basicBlock(tailNode);
  intptr_t traceId = BasicBlock_traceId(headBlock);
  int32_t regionId = BasicBlock_regionId(headBlock);
  int unrolled = BasicBlock_unrolled(headBlock);
  *Construction__REGIONFLOW(this) = regionFlow;
  *Construction__BLOCKTRACE(this) = blockTrace;
  IDList_Ctor(Construction_ISSUEITEMS(this), memory);
  memset(Construction_ENDITEM(this), 0, sizeof(IssueItem_));
  IDList_Ctor(Construction_MASTERS(this), memory);
  IDList_Ctor(Construction_EPILOGS(this), memory);
  *Construction__PREDBLOCK(this) = BasicBlock_prev(headBlock);
  *Construction__HEADBLOCK(this) = headBlock;
  *Construction__TRACEID(this) = traceId;
  *Construction__REGIONID(this) = regionId;
  *Construction__UNROLLED(this) = unrolled;
  *Construction__FREQUENCY(this) = BlockTrace_getEnterFrequency(blockTrace);
  return this;
}

#line 86 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
void
Construction_Dtor(Construction this)
{
  IDList_Dtor(Construction_ISSUEITEMS(this));
  IDList_Dtor(Construction_MASTERS(this));
  IDList_Dtor(Construction_EPILOGS(this));
}

#line 94 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
size_t
Construction_Size(Memory memory, RegionFlow regionFlow, BlockTrace blockTrace)
{
	return sizeof(Construction_);
}

#line 109 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
Construction
Construction_make(Memory memory, RegionFlow regionFlow, BlockTrace blockTrace)
{
  size_t size = Construction_Size(memory, regionFlow, blockTrace);
  Construction this = Memory_alloc(memory, size);
  return Construction_Ctor(this, memory, regionFlow, blockTrace);
}

#line 121 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
Construction
Construction_kill(Construction this)
{
  if (this != NULL) {
    Memory memory = Construction_MEMORY(this);
    Construction_Dtor(this);
    Memory_free_(memory, this);
  }
  return NULL;
}

#line 132 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 140 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
IDList
Construction_issueItems(Construction this)
{
  return Construction_ISSUEITEMS(this);
}

#line 169 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
#ifndef ECL_NTRACE
bool
Construction_prettyIssueItems(Construction this, FILE *file)
{
  int16_t lambda = Construction_LAMBDA(this);
  if (file == NULL) file = stderr;
  Construction_FOREACH_IssueItem(this, item) {
    int iteration = IssueItem_ITERATION(item);
    int controlId = IssueItem_CONTROLID(item);
    int startDate = IssueItem_STARTDATE(item);
    fprintf(file, "    [%d] @%d.%d\t", startDate, iteration, controlId);
    IssueItem_pretty(item, file);
  } Construction_ENDEACH_IssueItem;
  return true;
}
#endif//ECL_NTRACE

#line 194 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
IssueItem
Construction_makeIssueItem(Construction this, IssueItem issueItem)
{
  Operation operation = IssueItem_OPERATION(issueItem);
  Instance instance = IssueItem_INSTANCE(issueItem);
  size_t size = IssueItem_Size(operation, instance);
  IssueItem newItem = IDList_push(Construction_ISSUEITEMS(this), size);
  IssueItem_Ctor(newItem, operation, instance);
  // Ensure issueItem and newItem compare the same.
  *IssueItem__FLAGS(newItem) = IssueItem_FLAGS(issueItem);
  *IssueItem__ITERATION(newItem) = IssueItem_ITERATION(issueItem);
  *IssueItem__ORDERING(newItem) = IssueItem_ORDERING(issueItem);
  *IssueItem__STARTDATE(newItem) = IssueItem_STARTDATE(issueItem);
  Except_ENSURE(InstructionTask_compare(issueItem, newItem) == 0);
  // Copy some other issueItem fields too.
  *IssueItem__EXITARC(newItem) = IssueItem_EXITARC(issueItem);
  *IssueItem__FALLARC(newItem) = IssueItem_FALLARC(issueItem);
  *IssueItem__CONTROLID(newItem) = IssueItem_CONTROLID(issueItem);
  if (Operator_isControl(Operation_operator(operation))) {
    *IssueItem__FLAGS(newItem) |= InstructionFlag_Control;
  }
  return newItem;
}   

#line 218 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
IssueItem
Construction_appendIssueItem(Construction this, IssueItem issueItem, Operation operation)
{
  size_t size = IssueItem_Size(operation, Instance__UNDEF);
  IDList issueItems = Construction_ISSUEITEMS(this);
  IssueItem newItem = IDList_makeItem(issueItems, size);
  IssueItem_Ctor(newItem, operation, Instance__UNDEF);
  IDList_append_(issueItems, issueItem, newItem);
  if (Operator_isControl(Operation_operator(operation))) {
    *IssueItem__FLAGS(newItem) |= InstructionFlag_Control;
  }
  return newItem;
}

#line 232 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
IssueItem
Construction_putIssueItem(Construction this, Operation operation)
{
  size_t size = IssueItem_Size(operation, Instance__UNDEF);
  IDList issueItems = Construction_ISSUEITEMS(this);
  IssueItem newItem = IDList_makeItem(issueItems, size);
  IssueItem_Ctor(newItem, operation, Instance__UNDEF);
  IDList_put_(issueItems, newItem);
  if (Operator_isControl(Operation_operator(operation))) {
    *IssueItem__FLAGS(newItem) |= InstructionFlag_Control;
  }
  return newItem;
}

#line 246 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
static inline void
Construction_sortIssueItems(Construction this)
{
  IDList_sort(Construction_ISSUEITEMS(this), InstructionTask_compare);
}

#line 258 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
IDList
Construction_epilogs(Construction this)
{
  return Construction_EPILOGS(this);
}

#line 264 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
static inline int32_t
Construction_countEpilogs(Construction this)
{
  return IDList_count(Construction_EPILOGS(this));
}

#line 292 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
ConstructionEpilog
Construction_makeEpilog(Construction this, IssueItem issueItem)
{
  size_t size = ConstructionEpilog_Size(this, issueItem);
  ConstructionEpilog epilog = IDList_push(Construction_EPILOGS(this), size);
  ConstructionEpilog_Ctor(epilog, this, issueItem);
  return epilog;
}   

#line 305 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
void
Construction_sortEpilogs(Construction this)
{
  IDList_sort(Construction_EPILOGS(this), ConstructionEpilog_compare);
}

#line 325 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
IDList
Construction_masters(Construction this)
{
  return Construction_MASTERS(this);
}

#line 331 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
int32_t
Construction_countMasters(Construction this)
{
  return IDList_count(Construction_MASTERS(this));
}

#line 337 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
/*
 * Sort this Construction MASTERS in execution order.
 */
static inline void
Construction_sortMasters(Construction this)
{
  IDList_sort(Construction_MASTERS(this), ConstructionMaster_compare);
}

#line 368 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
void
Construction_makeMaster(Construction this, IssueItem issueItem, BasicBlock basicBlock)
{
  CFGArc exitArc = IssueItem_EXITARC(issueItem);
  size_t size = ConstructionMaster_Size(issueItem, basicBlock);
  ConstructionMaster master = IDList_push(Construction_MASTERS(this), size);
  ConstructionMaster_Ctor(master, issueItem, basicBlock);
  if (exitArc != NULL) {
    ConstructionEpilog epilog = Construction_makeEpilog(this, issueItem);
    *ConstructionMaster__EPILOG(master) = epilog;
  }
}

#line 381 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
Operation
Construction_replicateOperation(Construction this, const_Operation this_operation)
{
  BlockTrace blockTrace = Construction_BLOCKTRACE(this);
  EffectTable effectTable = BlockTrace_EFFECTTABLE(blockTrace);
  RegionFlow regionFlow = Construction_REGIONFLOW(this);
  CodeRegion codeRegion = RegionFlow_codeRegion(regionFlow);
  Selector selector = CodeRegion_selector(codeRegion);
  Operation that_operation = Selector_replicateOperation(selector, this_operation);
  Operation_setIteration(that_operation, Operation_iteration(this_operation));
  Operation_setBoosting(that_operation, Operation_boosting(this_operation));
  Selector_detachOperation(selector, that_operation);
  EffectTable_enterOperation(effectTable, that_operation, false);
  {
    Effect_ *this_argEffects = Operation_argEffects(this_operation);
    Effect_ *this_resEffects = Operation_resEffects(this_operation);
    Effect_ *that_argEffects = Operation_argEffects(that_operation);
    Effect_ *that_resEffects = Operation_resEffects(that_operation);
    Operation_ARGUMENTS_FOREACH_Temporary(this_operation, temporary) {
      *Effect__LIFETIME(that_argEffects + Operation_ARGUMENTS_INDEX) =
          Effect_LIFETIME(this_argEffects + Operation_ARGUMENTS_INDEX);
    } Operation_ARGUMENTS_ENDEACH_Temporary;
    Operation_RESULTS_FOREACH_Temporary(this_operation, temporary) {
      *Effect__LIFETIME(that_resEffects + Operation_RESULTS_INDEX) =
          Effect_LIFETIME(this_resEffects + Operation_RESULTS_INDEX);
    } Operation_RESULTS_ENDEACH_Temporary;
  }
  return that_operation;
}

#line 411 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 419 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
void
Construction_construct(Construction this, bool anyExit)
{
  int lambda = Construction_LAMBDA(this);
  BlockTrace blockTrace = Construction_BLOCKTRACE(this);
  // Sort the BlockTrace IssueItems after scheduling.
  BlockTrace_sortIssueItems(blockTrace);
  SCD_TRACE && fprintf(SCD_TRACE, "*** LOCAL SCHEDULE:\tLAMBDA=%d\n",
      BlockTrace_LAMBDA(blockTrace));
  SCD_TRACE && BlockTrace_prettyIssueItems(blockTrace, SCD_TRACE);
  // Construct the instruction schedule.
  BlockTrace_computeKunroll(blockTrace, lambda);
  Construction_makeEndItem(this, anyExit);
  Construction_buildMaster(this);
  if (Construction_KUNROLL(this) > 0) {
    LoopScope loopScope = BlockTrace_LOOPSCOPE(blockTrace);
    LoopScope_updateUnrolled(loopScope, Construction_KUNROLL(this));
    Construction_splitMaster(this);
    Construction_sortMasters(this);
    Construction_sortEpilogs(this);
    Construction_fillEpilogs(this);
    Construction_completeEpilogs(this);
    Construction_patchOperations(this);
    Construction_moveRegisters(this);
    Construction_fixCFGraph(this);
    Construction_fixFrequencies(this);
  } else {
    Construction_sortMasters(this);
    Construction_patchOperations(this);
  }
  Construction_fillBasicBlocks(this);
  Construction_fixBasicBlocks(this);
  Construction_fixSpeculated(this);
}

#line 466 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
void
Construction_makeEndItem(Construction this, bool anyExit)
{
  int lambda = Construction_LAMBDA(this);
  BlockTrace blockTrace = Construction_BLOCKTRACE(this);
  CFGNode headNode = BlockTrace_HEADNODE(blockTrace);
  CFGNode tailNode = BlockTrace_TAILNODE(blockTrace);
  IssueItem lastItem = BlockTrace_LASTITEM(blockTrace);
  int kunroll = Construction_KUNROLL(this);
  IssueItem endItem = NULL;
  if (kunroll > 0 && !anyExit) {
    // Compute this Construction_ENDITEM.
    bool noEndItem = true;
    IssueItem cutItem = IssueItem_PREV(lastItem);
    // Loop over the EXITITEMS.
    BlockTrace_FOREACH_IssueItem(blockTrace, ITEM) {
      if (IssueItem_EXITARC(ITEM) != NULL) {
        IssueItem_ exit_item_ = *ITEM, *exit_item = &exit_item_;
        while (InstructionTask_compare(exit_item, cutItem) < 0) {
          *IssueItem__STARTDATE(exit_item) += lambda;
          ++*IssueItem__ITERATION(exit_item);
        }
        // Found the earliest shifted exit item not lower than cutItem.
        if (endItem == NULL) {
          endItem = Construction_ENDITEM(this);
          *endItem = *exit_item;
        } else if (InstructionTask_compare(exit_item, endItem) < 0) {
          // Keep the earliest of all the shifted exit items as the endItem.
          *endItem = *exit_item;
        }
      }
    } BlockTrace_ENDEACH_IssueItem;
    // Adjust for kernel unrolling.
    *IssueItem__STARTDATE(endItem) += (kunroll - 1)*lambda;
    *IssueItem__ITERATION(endItem) += kunroll - 1;
    *IssueItem__EXITARC(endItem) = NULL;
  } else {
    // In this case, just pick the last of the local schedule.
    endItem = Construction_ENDITEM(this);
    *endItem = *lastItem;
  }
  SCD_TRACE && fprintf(SCD_TRACE, "*** ENDITEM:\tdate=%d\titeration=%d",
      IssueItem_STARTDATE(endItem), IssueItem_ITERATION(endItem));
  SCD_TRACE && Operation_pretty(IssueItem_OPERATION(endItem), SCD_TRACE);
}

#line 525 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
void
Construction_buildMaster(Construction this)
{
  int lambda = Construction_LAMBDA(this);
  int kunroll = Construction_KUNROLL(this);
  Processor processor = Construction_PROCESSOR(this);
  RegionFlow regionFlow = Construction_REGIONFLOW(this);
  BlockTrace blockTrace = Construction_BLOCKTRACE(this);
  EffectTable effectTable = BlockTrace_EFFECTTABLE(blockTrace);
  IssueItem firstItem = BlockTrace_FIRSTITEM(blockTrace);
  IssueItem lastItem = BlockTrace_LASTITEM(blockTrace);
  IssueItem endItem = Construction_ENDITEM(this);
  BasicBlock basicBlock = NULL;
  // Main replication loop.
  BlockTrace_FOREACH_IssueItem(blockTrace, ITEM) {
    IssueItem_ temp_item_ = *ITEM, *temp_item = &temp_item_;
    Operation operation = IssueItem_OPERATION(ITEM);
    basicBlock = Operation_basicBlock(operation);
    if (basicBlock != NULL) {
      Selector selector = BasicBlock_selector(basicBlock);
      Selector_detachOperation(selector, operation);
    }
    if (ITEM == firstItem) {
      IssueItem first_item = Construction_makeIssueItem(this, firstItem);
    } else if (ITEM != lastItem) {
      do {
        IssueItem new_item = NULL;
        Operation master_operation = operation;
        if (IssueItem_ITERATION(temp_item) != 0) {
          // Replicate the operation.
          master_operation = Construction_replicateOperation(this, operation);
          Except_CHECK(Operation_index(master_operation) == Operation_index(operation));
          Except_CHECK(kunroll > 0);
        }
        // Fill the master schedule with master_operation.
        *IssueItem__OPERATION(temp_item) = master_operation;
        new_item = Construction_makeIssueItem(this, temp_item);
        if (Operator_isControl(Operation_operator(operation))) {
          Construction_makeMaster(this, new_item, basicBlock);
        }
        // Replication for the next software pipeline stage.
        if (kunroll > 0) {
          *IssueItem__STARTDATE(temp_item) += lambda;
          ++*IssueItem__ITERATION(temp_item);
        } else break;
      } while (InstructionTask_compare(temp_item, endItem) <= 0);
    }
  } BlockTrace_ENDEACH_IssueItem;
  // Sort the master schedule.
  Construction_sortIssueItems(this);
  // Add the last operation to the master schedule if required.
  if (kunroll <= 0) {
    IssueItem last_item = Construction_makeIssueItem(this, lastItem);
    Construction_makeMaster(this, last_item, basicBlock);
  } else {
    // Software pipelining.
    Procedure procedure = RegionFlow_procedure(regionFlow);
    const_Operation last_operation = IssueItem_OPERATION(lastItem);
    if (Operator_isLoop(Operation_operator(last_operation))) {
      // Do not replicate the LOOP and invert the previous branch.
      IssueItem goto_item = Construction_LASTITEM(this);
      Operation goto_operation = IssueItem_OPERATION(goto_item);
      const_Operation label_operation = IssueItem_OPERATION(firstItem);
      Label label = Operation_getTargetLabel(label_operation);
      Except_CHECK(Operator_isGoTo(Operation_operator(goto_operation)));
      // EffectTable_releaseOperation(effectTable, goto_operation);
      Operation_setMainEffects(goto_operation, NULL);
      Procedure_updateTargetedOperation(procedure, goto_operation, label);
      Operation_invertGoTo(goto_operation, processor);
    } else {
      IssueItem last_item = Construction_makeIssueItem(this, lastItem);
      *IssueItem__STARTDATE(last_item) = IssueItem_STARTDATE(endItem) + kunroll*lambda;
      Construction_makeMaster(this, last_item, basicBlock);
    }
  }
}

#line 611 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
void
Construction_splitMaster(Construction this)
{
  int lambda = Construction_LAMBDA(this);
  int kunroll = Construction_KUNROLL(this), controlId = 0;
  RegionFlow regionFlow = Construction_REGIONFLOW(this);
  IssueItem label_item = Construction_FIRSTITEM(this);
  const_Operation label_operation = IssueItem_OPERATION(label_item);
  BlockTrace blockTrace = Construction_BLOCKTRACE(this);
  IssueItem endItem = Construction_ENDITEM(this);
  IssueItem ITEM = label_item, prev_item = NULL;
  // Compute the limit item between the prolog and the kernel.
  IssueItem_ limit_item_ = *endItem, *limit_item = &limit_item_;
  *IssueItem__STARTDATE(limit_item) -= kunroll*lambda;
  *IssueItem__ITERATION(limit_item) -= kunroll;
  SCD_TRACE && fprintf(SCD_TRACE, "*** CUTITEM:\tdate=%d\titeration=%d",
      IssueItem_STARTDATE(limit_item), IssueItem_ITERATION(limit_item));
  SCD_TRACE && Operation_pretty(IssueItem_OPERATION(limit_item), SCD_TRACE);
  Except_CHECK(Operator_isLabel(Operation_operator(label_operation)));
  // Loop to find the first IssueItem in the kernel.
  for (; ITEM != NULL; ITEM = IssueItem_NEXT((prev_item = ITEM))) {
    if (IssueItem_isControl(ITEM)) controlId = IssueItem_CONTROLID(ITEM);
    if (InstructionTask_compare(ITEM, limit_item) > 0) break;
    *IssueItem__FLAGS(ITEM) |= InstructionFlag_InProlog;
  }
  // Here prev_item is the last in the prolog.
  if (prev_item != NULL && !IssueItem_isControl(prev_item)) {
    // Insert a FALL operation to separate the prolog from the kernel.
    ConstructionMaster firstMaster = Construction_FIRSTMASTER(this);
    BasicBlock first_block = ConstructionMaster_BASICBLOCK(firstMaster);
    Selector first_selector = BasicBlock_selector(first_block);
    Label label = Operation_getTargetLabel(label_operation);
    Operation fall_operation = Selector_makeOperationFALL(first_selector, label);
    IssueItem fall_item = Construction_appendIssueItem(this, prev_item, fall_operation);
    Selector_detachOperation(first_selector, fall_operation);
    *IssueItem__STARTDATE(fall_item) = IssueItem_STARTDATE(prev_item);
    *IssueItem__FLAGS(fall_item) |= InstructionFlag_InProlog;
    *IssueItem__CONTROLID(fall_item) = controlId;
    Construction_makeMaster(this, fall_item, first_block);
  }
  if (kunroll > 1) {
    // Set the limit item between the first and the second kernel stage.
    *IssueItem__STARTDATE(limit_item) += lambda;
    ++*IssueItem__ITERATION(limit_item);
    // Loop to find the first kernel unrolled IssueItem.
    for (; ITEM != NULL; ITEM = IssueItem_NEXT(ITEM)) {
      if (InstructionTask_compare(ITEM, limit_item) > 0) break;
    }
    // Loop to flag the kernel unrolled IssueItems.
    for (; ITEM != NULL; ITEM = IssueItem_NEXT(ITEM)) {
      *IssueItem__FLAGS(ITEM) |= InstructionFlag_Kunrolled;
    }
  }
}

#line 678 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
void
Construction_fillEpilogs(Construction this)
{
  RegionFlow regionFlow = Construction_REGIONFLOW(this);
  BlockTrace blockTrace = Construction_BLOCKTRACE(this);
  EffectTable effectTable = BlockTrace_EFFECTTABLE(blockTrace);
  Construction_FOREACH_IssueItem(this, ITEM) {
    const_Operation operation = IssueItem_OPERATION(ITEM);
    Construction_FOREACH_ConstructionEpilog(this, epilog) {
      IssueItem epilog_item = ConstructionEpilog_ISSUEITEM(epilog);
      if (IssueItem_ITERATION(ITEM) < IssueItem_ITERATION(epilog_item) ||
          (IssueItem_ITERATION(ITEM) == IssueItem_ITERATION(epilog_item) &&
            IssueItem_ORDERING(ITEM) < IssueItem_ORDERING(epilog_item))) {
        // ITEM is executable in the current epilog.
        if (InstructionTask_compare(ITEM, epilog_item) > 0) {
          // ITEM is after epilog_item in the master schedule.
          // Push a replicate of the operation onto the epilog.
          Operation epilog_operation = Construction_replicateOperation(this, operation);
          ConstructionEpilog_pushOperation(epilog, epilog_operation);
        }
      }
    } Construction_ENDEACH_ConstructionEpilog;
  } Construction_ENDEACH_IssueItem;
}

#line 709 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
void
Construction_completeEpilogs(Construction this)
{
  int kunroll = Construction_KUNROLL(this);
  ConstructionMaster firstMaster = Construction_FIRSTMASTER(this);
  ConstructionMaster lastMaster = Construction_LASTMASTER(this);
  CFGNode firstNode = ConstructionMaster_CFGNODE(firstMaster);
  CFGNode lastNode = ConstructionMaster_CFGNODE(lastMaster);
  Construction_FOREACH_ConstructionEpilog(this, epilog) {
    CFGNode cfgNode = ConstructionEpilog_CFGNODE(epilog);
    if (cfgNode == firstNode) {
      //TODO
    }
  } Construction_ENDEACH_ConstructionEpilog;
}

#line 733 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
void
Construction_patchOperations(Construction this)
{
  RegionFlow regionFlow = Construction_REGIONFLOW(this);
  Procedure procedure = RegionFlow_procedure(regionFlow);
  Construction_FOREACH_IssueItem(this, ITEM) {
    int iteration = IssueItem_ITERATION(ITEM);
    const_Operation operation = IssueItem_OPERATION(ITEM);
    if (Operation_mainEffects(operation) != NULL) {
      Operation_ARGUMENTS_FOREACH_Effect(operation, argEffect) {
        Lifetime lifetime = Effect_LIFETIME(argEffect);
        if (lifetime != NULL) {
          Lifetime_fixArgument(lifetime, procedure, argEffect, iteration);
        }
        *Effect__LIFETIME(argEffect) = NULL;
      } Operation_ARGUMENTS_ENDEACH_Effect;
      Operation_RESULTS_FOREACH_Effect(operation, resEffect) {
        Lifetime lifetime = Effect_LIFETIME(resEffect);
        if (lifetime != NULL) {
          Lifetime_fixResult(lifetime, procedure, resEffect, iteration);
        }
        *Effect__LIFETIME(resEffect) = NULL;
      } Operation_RESULTS_ENDEACH_Effect;
    }
  } Construction_ENDEACH_IssueItem;
}

#line 775 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
void
Construction_moveRegisters(Construction this)
{
  RegionFlow regionFlow = Construction_REGIONFLOW(this);
  CodeRegion codeRegion = RegionFlow_codeRegion(regionFlow);
  Selector selector = CodeRegion_selector(codeRegion);
  int kunroll = Construction_KUNROLL(this);
  if (kunroll > 0) {
    BlockTrace blockTrace = Construction_BLOCKTRACE(this);
    CFGNode headNode = BlockTrace_headNode(blockTrace);
    ConstructionMaster firstMaster = Construction_FIRSTMASTER(this);
    BasicBlock firstBlock = ConstructionMaster_BASICBLOCK(firstMaster);
    IssueItem prologItem = IssueItem_PREV(ConstructionMaster_ISSUEITEM(firstMaster));
    LifetimeTable lifetimeTable = BlockTrace_LIFETIMETABLE(blockTrace);
    LifetimeTable_FOREACH_Lifetime(lifetimeTable, LIFETIME) {
      Temporary old_temporary = Lifetime_TEMPORARY(LIFETIME);
      if (Lifetime_hasRenaming(LIFETIME)) {
        // If this lifetime contains an exposed use that could be reached from both
        // outside and inside the loop:
        // - If it is reached from outside the loop, then it is reached by the original
        // temporary,
        // - If it is reached from inside the loop then it is reached by the
        // temporary for iteration -1.
        // If these are not the same temporary, then insert a copy from the original
        // temporary to the new temporary.
        // the copy must be in the prolog before any possible use of the new_temporary.
        // Sufficient conditions for an exposed use are:
        // - the register is live on entry to the loop, and
        // - the lifetime does not have a def that dominates all uses in the loop.
        if (CFGNode_isLiveInSet(headNode, old_temporary)
	    && !Lifetime_isReadAfter(LIFETIME)) {
          Temporary new_temporary = Lifetime_getRename(LIFETIME, -1);
          if (new_temporary != old_temporary) {
            // Put a MOVE new_temporary <- old_temporary in the prolog code block.
            IssueItem copyItem;
            Selector_selectCOPY(selector, new_temporary, old_temporary);
	    // Care, because a copy may be more than one operation.
	    while (!Selector_isEmpty(selector)) {
	      Operation copyOperation = Selector_detachFirst(selector);
              IssueItem copyItem = Construction_putIssueItem(this, copyOperation);
              // [SC] Worry here that we cannot issue an instruction at this date,
              // because we are inserting instructions in already scheduled code;
              // so mark the prolog as unscheduled.
              *IssueItem__STARTDATE(copyItem) = 0;
              *IssueItem__FLAGS(copyItem) |= InstructionFlag_InProlog;
              *IssueItem__CONTROLID(copyItem) = IssueItem_CONTROLID(prologItem);
	      prologItem = copyItem;
              SCD_TRACE && fprintf(SCD_TRACE, "*** PROLOG move inserted ");
              SCD_TRACE && Operation_pretty(copyOperation, SCD_TRACE);
            }
	    *ConstructionMaster__FLAGS(firstMaster) |= ConstructionMasterFlag_Unscheduled;
          }
        }
        Lifetime_FOREACH_Effect(LIFETIME, EFFECT) {
          if (Effect_isIndirect(EFFECT)) {
            int index = Operation_index(Effect_OPERATION(EFFECT));
	    Construction_FOREACH_ConstructionEpilog(this, epilog) {
	      IssueItem epilogItem = ConstructionEpilog_ISSUEITEM(epilog);
              if (Operation_index(IssueItem_OPERATION(epilogItem)) == index) {
                int iteration = IssueItem_ITERATION(epilogItem) - Effect_isCarried(EFFECT);
                Temporary new_temporary = Lifetime_getRename(LIFETIME, iteration);
                if (new_temporary != old_temporary) {
                  // Add a MOVE old_temporary <- new_temporary to the epilog code block.
		  Selector epilog_selector = ConstructionEpilog_SELECTOR(epilog);
                  Selector_selectCOPY(selector, old_temporary, new_temporary);
                  while (!Selector_isEmpty(selector)) {
		    Operation copyOperation = Selector_detachFirst(selector);
		    Selector_attachLast(epilog_selector, copyOperation);
                  }
                }
              }
            } Construction_ENDEACH_ConstructionEpilog;
          }
        } Lifetime_ENDEACH_Effect;
      }
    } LifetimeTable_ENDEACH_Lifetime;
  }
}

#line 868 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
void
Construction_fixCFGraph(Construction this)
{
  Memory memory = Construction_MEMORY(this);
  int32_t regionId = Construction_REGIONID(this);
  Processor processor = Construction_PROCESSOR(this);
  RegionFlow regionFlow = Construction_REGIONFLOW(this);
  CodeRegion codeRegion = RegionFlow_codeRegion(regionFlow);
  Procedure procedure = RegionFlow_procedure(regionFlow);
  CFGraph cfgraph = RegionFlow_cfgraph(regionFlow);
  BlockTrace blockTrace = Construction_BLOCKTRACE(this);
  CFGNode headNode = BlockTrace_HEADNODE(blockTrace), next_node = headNode;
  ConstructionMaster firstMaster = Construction_FIRSTMASTER(this);
  BasicBlock firstBlock = ConstructionMaster_BASICBLOCK(firstMaster);
  Selector firstSelector = BasicBlock_selector(firstBlock);
  CFGNodeSet_ cfgNodes_, *cfgNodes = &cfgNodes_;
  CFGNodeSet_Ctor(cfgNodes, memory, Construction_MASTERCOUNT(this));
  // Create and attach the CFGNodes and CFGArcs.
  {
    SCD_TRACE && fprintf(SCD_TRACE, "*** EPILOG BLOCKS:\n");
    Construction_FOREACH_ConstructionEpilog(this, epilog) {
      IssueItem epilog_item = ConstructionEpilog_ISSUEITEM(epilog);
      // If this epilog is reached from the last item of the master schedule,
      // then we can fall through to it.  Otherwise, we must explicitly branch
      // to the epilog.
      bool fall_through = (epilog_item == Construction_LASTITEM(this));
      Selector selector = ConstructionEpilog_SELECTOR(epilog);
      if (!Selector_isEmpty(selector)) {
        CFGNode node = ConstructionEpilog_CFGNODE(epilog);
        BasicBlock block = CFGNode_BASICBLOCK(node);
        Label label = BasicBlock_label(block);
        float frequency = BasicBlock_FREQUENCY(block);
        BasicBlock new_block = CodeRegion_makeBasicBlock(codeRegion, frequency);
        Label new_label = BasicBlock_makeLabel(new_block);
        CFGNode new_node = CFGraph_makeNode(cfgraph, new_block);
        CFGArcFlags new_flags = 0;
        CFGArc new_arc = CFGraph_makeArc(cfgraph, new_node, node, 1.0, new_flags);
	LoopScope loop_scope = LoopScope_PARENT(BlockTrace_LOOPSCOPE(blockTrace));
	Operation gotoOperation;
        BasicBlock_setLoopScope(new_block, loop_scope);
        *ConstructionEpilog__CFGNODE(epilog) = new_node;
	Selector_selectGOTO(firstSelector, label);
        gotoOperation = Selector_detachLast(firstSelector);
        Selector_attachLast(selector, gotoOperation);
        if (fall_through) {
          next_node = new_node;
        } else {
	  Operation branch_operation = IssueItem_OPERATION(epilog_item);
	  Procedure_updateTargetedOperation(procedure, branch_operation, new_label);
        }
        SCD_TRACE && ConstructionEpilog_pretty(epilog, SCD_TRACE);
      }
    } Construction_ENDEACH_ConstructionEpilog;
  }
  SCD_TRACE && fprintf(SCD_TRACE, "*** MASTER BLOCKS:\n");
  Construction_FORBACK_ConstructionMaster(this, master) {
    IssueItem issueItem = ConstructionMaster_ISSUEITEM(master);
    CFGArc exitArc = ConstructionMaster_EXITARC(master);
    CFGArc fallArc = ConstructionMaster_FALLARC(master);
    CFGNode cfgNode = ConstructionMaster_CFGNODE(master);
    if (IssueItem_isInProlog(issueItem) || IssueItem_isKunrolled(issueItem)) {
      // Must create the ConstructionMaster BASICBLOCK, CFGNODE, EXITARC, FALLARC.
      BasicBlock basicBlock = CodeRegion_makeBasicBlock(codeRegion, 0.0);
      cfgNode = CFGraph_makeNode(cfgraph, basicBlock);
      *ConstructionMaster__BASICBLOCK(master) = basicBlock;
      *ConstructionMaster__CFGNODE(master) = cfgNode;
      // Update the BlockTrace CFGNODES for later use during Construction.
      if (exitArc != NULL) {
        CFGArcFlags flags = 0;
        ConstructionEpilog epilog = ConstructionMaster_EPILOG(master);
        CFGNode exit_node = ConstructionEpilog_CFGNODE(epilog);
        float probability = CFGArc_probability(exitArc);
        exitArc = CFGraph_makeArc(cfgraph, cfgNode, exit_node, probability, flags);
      }
      if (next_node != NULL) {
        CFGArcFlags flags = CFGArcFlag_Fall;
        float probability = fallArc != NULL? CFGArc_probability(fallArc): 1.0;
        fallArc = CFGraph_makeArc(cfgraph, cfgNode, next_node, probability, flags);
      }
      *ConstructionMaster__EXITARC(master) = exitArc;
      *ConstructionMaster__FALLARC(master) = fallArc;
    } else {
      // In the first kernel stage: attach the heads of the EXITARCs.
      if (exitArc != NULL) {
        ConstructionEpilog epilog = ConstructionMaster_EPILOG(master);
        CFGNode exit_node = ConstructionEpilog_CFGNODE(epilog);
        Except_CHECK(CFGArc_TAIL(exitArc) == cfgNode);
        if (CFGArc_HEAD(exitArc) != exit_node) {
          CFGArc_detachHeadNode(exitArc);
          CFGArc_attachHeadNode(exitArc, exit_node);
        }
      }
      // Attach the heads of the FALLARCs.
      if (next_node != NULL) {
        if (CFGArc_HEAD(fallArc) != next_node) {
          CFGArc_detachHeadNode(fallArc);
          CFGArc_attachHeadNode(fallArc, next_node);
        }
      }
    }
    CFGNodeSet_insert(cfgNodes, cfgNode);
    next_node = cfgNode;
    SCD_TRACE && ConstructionMaster_pretty(master, SCD_TRACE);
  } Construction_ENDBACK_ConstructionMaster;
  // Reroute the CFGArcs entering from outside into the HEADNODE.
  if (headNode != next_node) {
    CFGNode_FORENTER_CFGArc(headNode, arc) {
      CFGNode tail_node = CFGArc_TAIL(arc);
      if (!CFGNodeSet_contains(cfgNodes, tail_node)) {
        Operation goto_operation;
        CFGArc_detachHeadNode(arc);
        CFGArc_attachHeadNode(arc, next_node);
        goto_operation = BasicBlock_getControlOperation(CFGNode_basicBlock(tail_node));
        if (goto_operation != NULL) {
          // FdF 20070523: Must check that target(goto_operation) ==
          // headNode
          Label goto_label = Operation_getTargetLabel(goto_operation);
          if (BasicBlock_hasLabel(CFGNode_basicBlock(headNode), goto_label)) {
            Label label = BasicBlock_makeLabel(CFGNode_basicBlock(next_node));
            Procedure procedure = RegionFlow_procedure(regionFlow);
            Procedure_updateTargetedOperation(procedure, goto_operation, label);
          }
        }
      }
    } CFGNode_ENDENTER_CFGArc;
  }
  // Detach the BlockTrace CFGNode(s) that are left over.
  BlockTrace_FOREACH_CFGNode(blockTrace, cfgNode) {
    if (!CFGNodeSet_contains(cfgNodes, cfgNode)) {
      SCD_TRACE && fprintf(SCD_TRACE, "*** LEFTOVER node %d:", CFGNode_INDEX(cfgNode));
      CFGNode_FORENTER_CFGArc(cfgNode, arc) {
        SCD_TRACE && fprintf(SCD_TRACE, "\t<-%d:", CFGNode_INDEX(CFGArc_TAIL(arc)));
        CFGArc_detachTailNode(arc);
      } CFGNode_ENDENTER_CFGArc;
      CFGNode_FORLEAVE_CFGArc(cfgNode, arc) {
        SCD_TRACE && fprintf(SCD_TRACE, "\t->%d:", CFGNode_INDEX(CFGArc_HEAD(arc)));
        CFGArc_detachHeadNode(arc);
      } CFGNode_ENDLEAVE_CFGArc;
      SCD_TRACE && fprintf(SCD_TRACE, "\n");
    }
  } BlockTrace_ENDEACH_CFGNode;
  //
  CFGNodeSet_Dtor(cfgNodes);
}

#line 1019 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
void
Construction_fixFrequencies(Construction this)
{
  float frequency = Construction_FREQUENCY(this);
  Construction_FOREACH_ConstructionMaster(this, master) {
    IssueItem issueItem = ConstructionMaster_ISSUEITEM(master);
    CFGNode cfgNode = ConstructionMaster_CFGNODE(master);
    CFGArc fallArc = ConstructionMaster_FALLARC(master);
    BasicBlock basicBlock = CFGNode_basicBlock(cfgNode);
    if (IssueItem_isInProlog(issueItem) || IssueItem_isKunrolled(issueItem)) {
      BasicBlock_setFrequency(basicBlock, frequency);
    } else {
      frequency = BasicBlock_frequency(basicBlock);
    }
    frequency *= CFGArc_probability(fallArc);
  } Construction_ENDEACH_ConstructionMaster;
}

#line 1043 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
void
Construction_fillBasicBlocks(Construction this)
{
  int firstDate = -1;
  int kunroll = Construction_KUNROLL(this);
  int16_t lambda = Construction_LAMBDA(this);
  RegionFlow regionFlow = Construction_REGIONFLOW(this);
  Procedure procedure = RegionFlow_procedure(regionFlow);
  BlockTrace blockTrace = Construction_BLOCKTRACE(this);
  ConstructionMaster master = Construction_FIRSTMASTER(this);
  BasicBlock headBlock = Construction_HEADBLOCK(this);
  BasicBlock predBlock = Construction_PREDBLOCK(this);
  Processor processor = Construction_PROCESSOR(this);
  BasicBlock previous_block = predBlock;
  // Unchain all the former BasicBlock(s).
  BlockTrace_FOREACH_CFGNode(blockTrace, cfgNode) {
    BasicBlock basicBlock = CFGNode_basicBlock(cfgNode);
    if (predBlock == NULL && basicBlock == headBlock) {
      previous_block = headBlock;
    } else {
      Procedure_unchainBasicBlock(procedure, basicBlock);
    }
  } BlockTrace_ENDEACH_CFGNode;
  // Chain all the current BasicBlock(s).
  Construction_FOREACH_ConstructionMaster(this, master) {
    BasicBlock basicBlock = ConstructionMaster_BASICBLOCK(master);
    if (basicBlock != previous_block) {
      Procedure_chainBasicBlocks(procedure, previous_block, basicBlock);
    }
    ASSERT(BasicBlock_isEmpty(basicBlock));
    previous_block = basicBlock;
  } Construction_ENDEACH_ConstructionMaster;
  Construction_FORBACK_ConstructionEpilog(this, epilog) {
    Selector selector = ConstructionEpilog_SELECTOR(epilog);
    if (!Selector_isEmpty(selector)) {
      CFGNode node = ConstructionEpilog_CFGNODE(epilog);
      BasicBlock basicBlock = CFGNode_BASICBLOCK(node);
      Procedure_chainBasicBlocks(procedure, previous_block, basicBlock);
      previous_block = basicBlock;
    }
  } Construction_ENDBACK_ConstructionEpilog;
  // Scan the master schedule and fill its BasicBlock(s).
  Construction_FOREACH_IssueItem(this, ITEM) {
    Operation operation = IssueItem_OPERATION(ITEM);
    BasicBlock basicBlock = ConstructionMaster_BASICBLOCK(master);
    int startDate = IssueItem_STARTDATE(ITEM);
    Operator operator = Operation_operator(operation);
    if (!Operator_isPseudo(operator) || Operator_isKill(operator)) {
      Selector selector = BasicBlock_selector(basicBlock);
      Selector_attachLast(selector, operation);
    }
    if (IssueItem_isControl(ITEM)) {
      // Iterate to the next ConstructionMaster.
      master = ConstructionMaster_NEXT(master);
    }
    // Compute the firstDate.
    Except_CHECK(startDate >= 0);
    if (firstDate < 0) firstDate = startDate;
  } Construction_ENDEACH_IssueItem;
  Except_CHECK(firstDate >= 0);
  Construction_FORBACK_IssueItem(this, ITEM) {
    Operation operation = IssueItem_OPERATION(ITEM);
    int startDate = IssueItem_STARTDATE(ITEM) - firstDate;
    Operation_setStartDate(operation, startDate);
  } Construction_ENDBACK_IssueItem;
  SCD_TRACE && fprintf(SCD_TRACE, "*** MASTER SCHEDULE:\tLAMBDA=%d\tKUNROLL=%d\n",
                       Construction_LAMBDA(this), Construction_KUNROLL(this));
  SCD_TRACE && Construction_prettyIssueItems(this, SCD_TRACE);
  // Scan the epilogs and fill their BasicBlocks
  Construction_FOREACH_ConstructionEpilog(this, epilog) {
    Selector selector = ConstructionEpilog_SELECTOR(epilog);
    if (!Selector_isEmpty(selector)) {
      CFGNode node = ConstructionEpilog_CFGNODE(epilog);
      BasicBlock basicBlock = CFGNode_BASICBLOCK(node);
      Selector block_selector = BasicBlock_SELECTOR(basicBlock);
      BasicBlock_putSelector(basicBlock, selector);
    }
  } Construction_ENDEACH_ConstructionEpilog;
}

#line 1129 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
void
Construction_fixBasicBlocks(Construction this)
{
  int kunroll = Construction_KUNROLL(this);
  intptr_t traceId = Construction_TRACEID(this);
  BlockTrace blockTrace = Construction_BLOCKTRACE(this);
  int unrolled = Construction_UNROLLED(this);
  if (unrolled <= 0) unrolled = 1;
  Construction_FOREACH_ConstructionMaster(this, master) {
    BasicBlock basicBlock = ConstructionMaster_BASICBLOCK(master);
    Operation first_operation = BasicBlock_firstOperation(basicBlock);
    BasicBlock_setTraceId(basicBlock, traceId);
    if (!ConstructionMaster_isUnscheduled(master)) {
      BasicBlock_setFlags(basicBlock, BasicBlockFlag_Scheduled);
    }
    if (kunroll > 0) {
      BasicBlock basicBlock = ConstructionMaster_BASICBLOCK(master);
      if (IssueItem_isInProlog(ConstructionMaster_ISSUEITEM(master))) {
        Except_CHECK(BasicBlock_unrolled(basicBlock) == 0);
        BasicBlock_FOREACH_Operation(basicBlock, operation) {
          Operation_setFlags(operation, OperationFlag_Hoisted);
        } BasicBlock_ENDEACH_Operation;
      } else {
        BasicBlock headBlock = Construction_HEADBLOCK(this);
        LoopScope loopScope = BasicBlock_loopScope(headBlock);
        Except_CHECK(LoopScope_headerBlock(loopScope) == headBlock);
        BasicBlock_setLoopScope(basicBlock, loopScope);
        BasicBlock_setUnrolled(basicBlock, unrolled*kunroll);
        BasicBlock_FOREACH_Operation(basicBlock, operation) {
          IssueItem ITEM = Operation_issueItem(operation);
          int offset = unrolled*IssueItem_ITERATION(ITEM);
          int iteration = Operation_iteration(operation) + offset;
          Operation_setIteration(operation, iteration);
        } BasicBlock_ENDEACH_Operation;
      }
    }
  } Construction_ENDEACH_ConstructionMaster;
}

#line 1174 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
void
Construction_fixSpeculated(Construction this)
{
  Processor processor = Construction_PROCESSOR(this);
  BlockTrace blockTrace = Construction_BLOCKTRACE(this);
  EffectTable effectTable = BlockTrace_EFFECTTABLE(blockTrace);
  int current_controlId = -1, current_iteration = -1; 
  // Fix the speculated Operations.
  PFA_TRACE && fprintf(PFA_TRACE, "*** SPECULATION\n");
  Construction_FORBACK_IssueItem(this, ITEM) {
    int controlId = IssueItem_CONTROLID(ITEM);
    int iteration = IssueItem_ITERATION(ITEM);
    Operation operation = IssueItem_OPERATION(ITEM);
    // EffectTable_releaseOperation(effectTable, operation);
    Operation_setMainEffects(operation, NULL);
    if (IssueItem_isControl(ITEM)) {
      current_controlId = controlId;
      current_iteration = iteration;
    } else if (iteration != current_iteration || controlId != current_controlId) {
      // Operation has been control speculated.
      if (Operation_isSpeculable(operation)) {
        Operation_speculate(operation, processor);
      }
      PFA_TRACE && fprintf(PFA_TRACE, "    @%d.%d -> @%d.%d",
          iteration, controlId, current_iteration, current_controlId);
      PFA_TRACE && Operation_pretty(operation, PFA_TRACE);
    } else if (Operation_boosting(operation) != 0) {
      // Operation has not been control speculated so reverse boosting.
      Operation_unpredicate(operation, processor);
      Operation_setBoosting(operation, 0);
      PFA_TRACE && fprintf(PFA_TRACE, "    reverse boosting");
      PFA_TRACE && Operation_pretty(operation, PFA_TRACE);
    }
    Operation_setTask(operation, NULL);
    Operation_setIndex(operation, -1);
  } Construction_ENDBACK_IssueItem;
}

#line 1212 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1231 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
ConstructionEpilog
ConstructionEpilog_Ctor(ConstructionEpilog this,
                        Construction construction, IssueItem issueItem)
{
  RegionFlow regionFlow = Construction_REGIONFLOW(construction);
  Procedure procedure = RegionFlow_procedure(regionFlow);
  CFGArc exitArc = IssueItem_EXITARC(issueItem);
  *ConstructionEpilog__CONSTRUCTION(this) = construction;
  *ConstructionEpilog__ISSUEITEM(this) = issueItem;
  *ConstructionEpilog__CFGNODE(this) = CFGArc_HEAD(exitArc);
  Selector_Ctor(ConstructionEpilog_SELECTOR(this),
                Procedure_memory(procedure), procedure, Processor__UNDEF, false);
  return this;
}

#line 1246 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
void
ConstructionEpilog_Dtor(ConstructionEpilog this)
{
  Selector_Dtor(ConstructionEpilog_SELECTOR(this));
}

#line 1252 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
size_t
ConstructionEpilog_Size(Construction construction, IssueItem issueItem)
{
  return sizeof(ConstructionEpilog_);
}

#line 1280 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
#ifndef ECL_NTRACE
bool
ConstructionEpilog_pretty(ConstructionEpilog this, FILE *file)
{
  IssueItem issueItem = ConstructionEpilog_ISSUEITEM(this);
  if (file == NULL) file = stderr;
  fprintf(file, "*** EPILOG:\tdate=%d\titeration=%d",
      IssueItem_STARTDATE(issueItem), IssueItem_ITERATION(issueItem));
  Operation_pretty(IssueItem_OPERATION(issueItem), file);
  ConstructionEpilog_FOREACH_Operation(this, operation) {
    fprintf(file, "\t") && Operation_pretty(operation, file);
  } ConstructionEpilog_ENDEACH_Operation;
  return true;
}
#endif//ECL_NTRACE

#line 1308 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
int
ConstructionEpilog_compare(const void *this_pointer, const void *that_pointer)
{
  const_ConstructionEpilog this = this_pointer;
  const_ConstructionEpilog that = that_pointer;
  return InstructionTask_compare(ConstructionEpilog_ISSUEITEM(this),
                           ConstructionEpilog_ISSUEITEM(that));
}

#line 1317 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1341 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
ConstructionMaster
ConstructionMaster_Ctor(ConstructionMaster this,
                        IssueItem issueItem, BasicBlock basicBlock)
{
  CFGNode cfgNode = BasicBlock_cfgNode(basicBlock);
  *ConstructionMaster__ISSUEITEM(this) = issueItem;
  *ConstructionMaster__BASICBLOCK(this) = basicBlock;
  *ConstructionMaster__CFGNODE(this) = cfgNode;
  *ConstructionMaster__EPILOG(this) = NULL;
  *ConstructionMaster__FLAGS(this) = 0;
  return this;
}

#line 1354 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
size_t
ConstructionMaster_Size(IssueItem issueItem, BasicBlock basicBlock) {
  return sizeof(ConstructionMaster_);
}

#line 1368 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
int
ConstructionMaster_compare(const void *this_pointer, const void *that_pointer)
{
  const_ConstructionMaster this = this_pointer;
  const_ConstructionMaster that = that_pointer;
  IssueItem this_item = ConstructionMaster_ISSUEITEM(this);
  IssueItem that_item = ConstructionMaster_ISSUEITEM(that);
  return InstructionTask_compare(this_item, that_item);
}

#line 1385 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
#ifndef ECL_NTRACE
bool
ConstructionMaster_pretty(ConstructionMaster this, FILE *file)
{
  IssueItem issueItem = ConstructionMaster_ISSUEITEM(this);
  BasicBlock basicBlock = ConstructionMaster_BASICBLOCK(this);
  CFGNode cfgNode = ConstructionMaster_CFGNODE(this);
  CFGArc exitArc = ConstructionMaster_EXITARC(this);
  CFGArc fallArc = ConstructionMaster_FALLARC(this);
  if (file == NULL) file = stderr;
  fprintf(file, "\t%d:Block_%d",
      BasicBlock_identity(basicBlock), CFGNode_INDEX(cfgNode));
  if (exitArc != NULL) {
    CFGNode tail_node = CFGArc_TAIL(exitArc);
    CFGNode head_node = CFGArc_HEAD(exitArc);
    fprintf(file, "\texit(_%d, _%d)",
        tail_node == NULL? -1: CFGNode_INDEX(tail_node),
        head_node == NULL? -1: CFGNode_INDEX(head_node));
  } else fprintf(file, "\t\t");
  if (fallArc != NULL) {
    CFGNode tail_node = CFGArc_TAIL(fallArc);
    CFGNode head_node = CFGArc_HEAD(fallArc);
    fprintf(file, "\tfall(_%d, _%d)",
        tail_node == NULL? -1: CFGNode_INDEX(tail_node),
        head_node == NULL? -1: CFGNode_INDEX(head_node));
  } else fprintf(file, "\t\t");
  Operation_pretty(IssueItem_OPERATION(issueItem), file);
  return true;
}
#endif//ECL_NTRACE

#line 1416 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1424 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
void
Construction_INIT(void)
{
}

#line 1435 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
void
Construction_FINI(void)
{
}

#line 1440 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
#if XCC__C
void
Construction_TEST(void)
{
#include "SCD/Construction_.c"
}

#line 1447 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Construction.xcc"
int
main(int argc, char **argv)
{
  SCD_Test(Construction_TEST);
  return 0;
}
#endif


#endif//Construction_c_INCLUDED
