#ifndef FastList_c_INCLUDED
#define FastList_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
#include "SCD/SCD_.h"

#line 21 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 38 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
FastListRank
FastListRank_Ctor(FastListRank this,
                  int release)
{
  *FastListRank__CAPACITY(this) = (uint32_t)(int32_t)-1;
  *FastListRank__CONSUMED(this) = 0;
  *FastListRank__RELEASE(this) = release;
  *FastListRank__PARENT(this) = NULL;
  return this;
}

#line 78 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
unsigned
FastListRank_schedule(FastListRank this, unsigned available, unsigned required)
{
  FastListRank rank = FastListRank_find(this);
  uint32_t capacity = FastListRank_CAPACITY(rank);
  uint32_t consumed = FastListRank_CONSUMED(rank);
  uint32_t cumulated = consumed + required;
  Except_REQUIRE(consumed < capacity && required > 0);
  if (cumulated < capacity) {
    *FastListRank__CONSUMED(rank) = cumulated;
    return FastListRank_RELEASE(rank) + (cumulated - 1)/available;
  }
  *FastListRank__CONSUMED(rank) = capacity;
  *FastListRank__PARENT(rank) = FastListRank_find(FastListRank_NEXT(rank));
  if (cumulated == capacity) {
    return FastListRank_RELEASE(FastListRank_NEXT(rank)) - 1;
  }
  return FastListRank_schedule(rank, available, cumulated - capacity);
}

#line 104 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
unsigned
FastListRank_scheduleS(FastListRank this, int shift, unsigned required)
{
  FastListRank rank = FastListRank_find(this);
  uint32_t capacity = FastListRank_CAPACITY(rank);
  uint32_t consumed = FastListRank_CONSUMED(rank);
  uint32_t cumulated = consumed + required;
  Except_REQUIRE(consumed < capacity && required > 0);
  if (cumulated < capacity) {
    *FastListRank__CONSUMED(rank) = cumulated;
    return FastListRank_RELEASE(rank) + ((cumulated - 1)>>shift);
  }
  *FastListRank__CONSUMED(rank) = capacity;
  *FastListRank__PARENT(rank) = FastListRank_find(FastListRank_NEXT(rank));
  if (cumulated == capacity) {
    return FastListRank_RELEASE(FastListRank_NEXT(rank)) - 1;
  }
  return FastListRank_scheduleS(rank, shift, cumulated - capacity);
}

#line 137 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
const char *
FastListType_name_(FastListType this)
{
  static const char *_[] = {
    "Release",
    "Schedule",
    "Deadline",
  };
  Except_REQUIRE((unsigned)this < FastListType__);
  return _[this];
}

#line 171 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
FastListTask
FastListTask_Ctor(FastListTask this,
                  const uint8_t *requirements, RelaxationItem item)
{
  *FastListTask__REQUIREMENTS(this) = requirements;
  *FastListTask__ITEM(this) = item;
  *FastListTask__RANK(this) = NULL;
  FastListTask_LINKS(this)[FastListType_Release] = NULL;
  FastListTask_LINKS(this)[FastListType_Schedule] = NULL;
  FastListTask_LINKS(this)[FastListType_Deadline] = NULL;
  FastListTask_DATES(this)[FastListType_Release] = -1;
  FastListTask_DATES(this)[FastListType_Schedule] = -1;
  FastListTask_DATES(this)[FastListType_Deadline] = -1;
  return this;
}

#line 216 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
FastListTask
FastListTask_meld(FastListTask this, FastListTask that, FastListType type)
{
  FastListTask_ meld_task_, *meld_task = &meld_task_;
  FastListTask_LINKS(meld_task)[type] = NULL;
  while (this != NULL && that != NULL) {
    if (FastListTask_compare(this, that, type) <= 0) {
      FastListTask_LINKS(meld_task)[type] = this;
      this = FastListTask_LINKS((meld_task = this))[type];
    } else {
      FastListTask_LINKS(meld_task)[type] = that;
      that = FastListTask_LINKS((meld_task = that))[type];
    }
  }
  if (this != NULL) {
    FastListTask_LINKS(meld_task)[type] = this;
  }
  if (that != NULL) {
    FastListTask_LINKS(meld_task)[type] = that;
  }
  return FastListTask_LINKS(&meld_task_)[type];
}

#line 239 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 269 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
FastList
FastList_Ctor(FastList this,
              Memory memory, int32_t count, const uint8_t *availability)
{
  *FastList__AVAILABILITY(this) = availability;
  *FastList__TASKS(this) = Memory_alloc(memory, count*sizeof(FastListTask_));
  *FastList__ENDTASK(this) = FastList_TASKS(this);
  *FastList__RANKS(this) = Memory_alloc(memory, count*sizeof(FastListRank_));
  *FastList__ENDRANK(this) = FastList_RANKS(this);
  FastListTask_Ctor(FastList_LISTS(this), NULL, NULL);
  IQueue_Ctor(FastList_IQUEUE(this), memory, sizeof(FastListTask), count);
  return this;
}

#line 283 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
void
FastList_Dtor(FastList this)
{
  Memory memory = FastList_MEMORY(this);
  Memory_free_(memory, FastList_TASKS(this));
  Memory_free_(memory, FastList_RANKS(this));
  IQueue_Dtor(FastList_IQUEUE(this));
}

#line 429 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
void
FastList_updateRelease(FastList this, int p, int q)
{
  FastListType type = FastListType_Release;
  FastListTask firstTask = FastList_FIRSTTASK(this);
  FastListTask prev_task = FastList_LISTS(this);
  FastListTask task = FastListTask_LINKS(prev_task)[type];
  FastListTask_ head_task[1], *tail_task = head_task;
  Except_CHECK(!FastList_sortTasks(this, type, FastList_LISTS(this)));
  FastListTask_LINKS(head_task)[type] = NULL;
  // Loop over the FastListTask(s) in sorted Release order. When updating a
  // release date, move the corresponding FastListTask into the head_task list.
  while (task != NULL) {
    FastListTask next_task = FastListTask_LINKS(task)[type];
    RelaxationItem item = FastListTask_ITEM(task);
    int release = RelaxationItem_RELEASE(item);
    int latency = RelaxationItem_LATENCY(item);
    if (release < latency + q) {
      release = latency + q;
      Except_CHECK(latency >= 0);
    }
    if (task == firstTask) release = p;
    if (FastListTask_RELEASE(task) != release) {
      *FastListTask__RELEASE(task) = release;
      FastListTask_LINKS(prev_task)[type] = next_task;
      FastListTask_LINKS(tail_task)[type] = task;
      tail_task = task;
    } else {
      prev_task = task;
    }
    task = next_task;
  }
  // Here FastList_LINKS points to the unchanged FastListTask(s), and
  // head_task points to the FastListTask(s) with changed release dates.
  if (tail_task != head_task) {
    // Sort the head_task list and merge with FastList_LINKS.
    FastListTask_LINKS(tail_task)[type] = NULL;
    FastList_sortTasks(this, type, head_task);
    FastList_LINKS(this)[type] =
        FastListTask_meld(
            FastListTask_LINKS(head_task)[type],
            FastList_LINKS(this)[type], type);
  }
}

#line 484 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
void
FastList_updateDeadline(FastList this, int p, int q)
{
  FastListType type = FastListType_Deadline;
  FastListTask firstTask = FastList_FIRSTTASK(this);
  FastListTask prev_task = FastList_LISTS(this);
  FastListTask task = FastListTask_LINKS(prev_task)[type];
  FastListTask_ head_task[1], *tail_task = head_task;
  Except_CHECK(!FastList_sortTasks(this, type, FastList_LISTS(this)));
  FastListTask_LINKS(head_task)[type] = NULL;
  // Loop over the FastListTask(s) in sorted Deadline order. When updating a
  // release date, move the corresponding FastListTask into the head_task list.
  // Deadline modification may only happen for firstTask, we so exit early.
  while (task != NULL) {
    FastListTask next_task = FastListTask_LINKS(task)[type];
    RelaxationItem item = FastListTask_ITEM(task);
    int deadline = RelaxationItem_DEADLINE(item);
    if (task == firstTask) {
      deadline = q + 1;
      if (FastListTask_DEADLINE(task) != deadline) {
        *FastListTask__DEADLINE(task) = deadline;
        FastListTask_LINKS(prev_task)[type] = next_task;
        FastListTask_LINKS(tail_task)[type] = task;
        tail_task = task;
      }
      break;
    }
    prev_task = task;
    task = next_task;
  }
  // Here FastList_LINKS points to the unchanged FastListTask(s), and
  // head_task points to the FastListTask with changed deadline date.
  if (tail_task != head_task) {
    // Because there is only firstTask in the head_task list, just merge it.
    FastListTask_LINKS(tail_task)[type] = NULL;
    FastList_LINKS(this)[type] =
        FastListTask_meld(
            FastListTask_LINKS(head_task)[type],
            FastList_LINKS(this)[type], type);
  }
}

#line 535 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
bool
FastList_sortTasks(FastList this, FastListType type, FastListTask lists)
{
  FastListTask task = FastListTask_LINKS(lists)[type];
  if (task != NULL && FastListTask_LINKS(task)[type] != NULL) {
    IQueue iqueue = FastList_IQUEUE(this);
    FastListTask next_task = FastListTask_LINKS(task)[type];
    // Split the list into sorted chains.
    IQueue_PUT(iqueue, FastListTask, task);
    while (next_task != NULL) {
      if (FastListTask_compare(task, next_task, type) > 0) {
        IQueue_PUT(iqueue, FastListTask, next_task);
        FastListTask_LINKS(task)[type] = NULL;
      }
      next_task = FastListTask_LINKS((task = next_task))[type];
    }
    if (IQueue_isSingle(iqueue)) {
      IQueue_empty(iqueue, NULL);
      return false;
    }
    // Merge the sorted chains together.
    do {
      FastListTask task1 = NULL, task2 = NULL;
      IQueue_POP(iqueue, FastListTask, task1);
      IQueue_POP(iqueue, FastListTask, task2);
      IQueue_PUT(iqueue, FastListTask, FastListTask_meld(task1, task2, type));
    } while (!IQueue_isSingle(iqueue));
    FastListTask_LINKS(lists)[type] = IQueue_TOP(iqueue, FastListTask);
    IQueue_empty(iqueue, NULL);
    return true;
  }
  return false;
}

#line 575 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
FastListRank
FastList_makeRank(FastList this, int release)
{
  FastListRank rank = FastList_ENDRANK(this);
  FastListRank_Ctor(rank, release);
  ++*FastList__ENDRANK(this);
  return rank;
}

#line 590 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
void
FastList_makeRanks(FastList this, unsigned available)
{
  int prev_release = -1;
  FastListRank prev_rank = NULL;
  *FastList__ENDRANK(this) = FastList_RANKS(this);
  FastList_FOREACH_Release_FastListTask(this, task) {
    int release = FastListTask_RELEASE(task);
    if (release > prev_release) {
      FastListRank rank = FastList_makeRank(this, release);
      if (prev_rank != NULL) {
        Except_CHECK(FastListRank_NEXT(prev_rank) == rank);
        *FastListRank__CAPACITY(prev_rank) = (release - prev_release)*available;
      }
      prev_release = release;
      prev_rank = rank;
    }
    *FastListTask__RANK(task) = prev_rank;
  } FastList_ENDEACH_Release_FastListTask;
  Except_ENSURE(FastListRank_CAPACITY(prev_rank) == (uint32_t)(int32_t)-1);
}

#line 618 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
bool
FastList_schedule(FastList this, Resource resource)
{
  static int8_t log2[] = { -1, 0, 1, -1, 2, -1, -1, -1, 3 };
  unsigned available = FastList_AVAILABILITY(this)[resource];
  int shift = (available <= 8)? log2[available]: -1;
  FastListTask lists = FastList_LISTS(this);
  Except_CHECK(!FastList_sortTasks(this, FastListType_Release, lists));
  Except_CHECK(!FastList_sortTasks(this, FastListType_Deadline, lists));
  FastList_makeRanks(this, available);
  if (shift < 0) {
    FastList_FOREACH_Deadline_FastListTask(this, task) {
      unsigned required = FastListTask_REQUIREMENTS(task)[resource];
      int schedule = FastListTask_RELEASE(task);
      int deadline = FastListTask_DEADLINE(task);
      if (required > 0) {
        FastListRank rank = FastListTask_RANK(task);
        schedule = FastListRank_schedule(rank, available, required);
        if (schedule >= deadline) return false;
      }
      *FastListTask__SCHEDULE(task) = schedule;
    } FastList_ENDEACH_Deadline_FastListTask;
  } else {
    Except_CHECK(available == (1 << shift));
    FastList_FOREACH_Deadline_FastListTask(this, task) {
      unsigned required = FastListTask_REQUIREMENTS(task)[resource];
      int schedule = FastListTask_RELEASE(task);
      int deadline = FastListTask_DEADLINE(task);
      if (required > 0) {
        FastListRank rank = FastListTask_RANK(task);
        schedule = FastListRank_scheduleS(rank, shift, required);
        if (schedule >= deadline) return false;
      }
      *FastListTask__SCHEDULE(task) = schedule;
    } FastList_ENDEACH_Deadline_FastListTask;
  }
  return true;
}

#line 663 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
bool
FastList_check(FastList this, Resource resource)
{
  int time = -1, consumed = 0;
  int available = FastList_AVAILABILITY(this)[resource];
  FastList_sortTasks(this, FastListType_Schedule, FastList_LISTS(this));
  FastList_FOREACH_Schedule_FastListTask(this, task) {
    int schedule = FastListTask_SCHEDULE(task);
    int required = FastListTask_REQUIREMENTS(task)[resource];
    if (time < schedule) {
      time = schedule;
      consumed = 0;
    }
    consumed += required;
    if (consumed > available) {
      return false;
    }
  } FastList_ENDEACH_Schedule_FastListTask;
  return true;
}

#line 690 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
bool
FastList_pretty(FastList this, FILE *file)
{
  int time = -1;
  if (file == NULL) file = stderr;
  FastList_sortTasks(this, FastListType_Schedule, FastList_LISTS(this));
  FastList_FOREACH_Schedule_FastListTask(this, task) {
    int32_t index = FastListTask_INDEX(task);
    int schedule = FastListTask_SCHEDULE(task);
    if (time < schedule) {
      if (time >= 0) fprintf(file, "}");
      for (++time; time < schedule; time++) fprintf(file, "\t.");
      fprintf(file, "\t{%d", index);
    } else fprintf(file, ",%d", index);
  } FastList_ENDEACH_Schedule_FastListTask;
  fprintf(file, "}");
  return true;
}

#line 795 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 807 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
#if XCC__C
void
FastList_TEST(void)
{
#include "SCD/FastList_.c"
}

#line 814 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
int
main(int argc, char **argv)
{
  SCD_Test(FastList_TEST);
  return 0;
}
#endif


#endif//FastList_c_INCLUDED
