#ifndef FastList__c_INCLUDED
#define FastList__c_INCLUDED

#line 49 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
//
{
  printf("sizeof(FastListRank_) = %d\n", sizeof(FastListRank_));
}

#line 187 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
//
{
  printf("sizeof(FastListTask_) = %d\n", sizeof(FastListTask_));
}

#line 292 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
//
{
  printf("sizeof(FastList_) = %d\n", sizeof(FastList_));
}

#line 709 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/FastList.xcc"
//
{
  int n = 8, resource = 0;
  uint8_t availability[] = { 1, 3 };
  uint8_t requirements[] = { 1, 2 };
  FastListTask tasks[8];
  FastList_ fastList[1];
  FastList_Ctor(fastList, Memory_Root, n, availability);
  tasks[0] = FastList_makeTask(fastList, requirements, NULL);
  tasks[1] = FastList_makeTask(fastList, requirements, NULL);
  tasks[2] = FastList_makeTask(fastList, requirements, NULL);
  tasks[3] = FastList_makeTask(fastList, requirements, NULL);
  tasks[4] = FastList_makeTask(fastList, requirements, NULL);
  tasks[5] = FastList_makeTask(fastList, requirements, NULL);
  tasks[6] = FastList_makeTask(fastList, requirements, NULL);
  tasks[7] = FastList_makeTask(fastList, requirements, NULL);
  *FastListTask__RELEASE(tasks[0]) = 0;
  *FastListTask__RELEASE(tasks[1]) = 1;
  *FastListTask__RELEASE(tasks[2]) = 3;
  *FastListTask__RELEASE(tasks[3]) = 1;
  *FastListTask__RELEASE(tasks[4]) = 3;
  *FastListTask__RELEASE(tasks[5]) = 7;
  *FastListTask__RELEASE(tasks[6]) = 6;
  *FastListTask__RELEASE(tasks[7]) = 6;
  *FastListTask__DEADLINE(tasks[0]) = 1;
  *FastListTask__DEADLINE(tasks[1]) = 2;
  *FastListTask__DEADLINE(tasks[2]) = 7;
  *FastListTask__DEADLINE(tasks[3]) = 5;
  *FastListTask__DEADLINE(tasks[4]) = 7;
  *FastListTask__DEADLINE(tasks[5]) = 9;
  *FastListTask__DEADLINE(tasks[6]) = 8;
  *FastListTask__DEADLINE(tasks[7]) = 8;
  printf("\nreleases:");
  FastList_sortTasks(fastList, FastListType_Release, FastList_LISTS(fastList));
  FastList_FOREACH_Release_FastListTask(fastList, task) {
    int index = task - FastList_TASKS(fastList);
    int release = FastListTask_RELEASE(task);
    printf("\tr_%d=%d", index+1, release);
  } FastList_ENDEACH_Release_FastListTask;
  printf("\ndeadlines:");
  FastList_sortTasks(fastList, FastListType_Deadline, FastList_LISTS(fastList));
  FastList_FOREACH_Deadline_FastListTask(fastList, task) {
    int index = task - FastList_TASKS(fastList);
    int deadline = FastListTask_DEADLINE(task);
    printf("\td_%d=%d", index+1, deadline);
  } FastList_ENDEACH_Deadline_FastListTask;
  printf("\nranks before:\n");
  FastList_makeRanks(fastList, availability[resource]);
  FastList_FOREACH_FastListRank(fastList, rank) {
    int release = FastListRank_RELEASE(rank);
    int capacity = FastListRank_CAPACITY(rank);
    int consumed = FastListRank_CONSUMED(rank);
    printf("\trelease=%d\tcapacity=%d\t", release, capacity);
    FastList_FOREACH_FastListTask(fastList, task) {
      if (FastListTask_RANK(task) == rank) {
        int index = task - FastList_TASKS(fastList);
        printf("I_%d ", index+1);
      }
    } FastList_ENDEACH_FastListTask;
    printf("\n");
  } FastList_ENDEACH_FastListRank;
  for (resource = 0; resource < 2; resource++) {
    printf("\n%d processors, %d units per task:\n", availability[resource], requirements[resource]);
    FastList_schedule(fastList, resource);
    printf("ranks after:\n");
    FastList_FOREACH_FastListRank(fastList, rank) {
      int release = FastListRank_RELEASE(rank);
      int capacity = FastListRank_CAPACITY(rank);
      int consumed = FastListRank_CONSUMED(rank);
      printf("\trelease=%d\tcapacity=%d\tconsumed=%d\t", release, capacity, consumed);
      printf("\n");
    } FastList_ENDEACH_FastListRank;
    printf("schedule:\n");
    FastList_sortTasks(fastList, FastListType_Schedule, FastList_LISTS(fastList));
    FastList_FOREACH_Schedule_FastListTask(fastList, task) {
      int index = task - FastList_TASKS(fastList);
      int release = FastListTask_RELEASE(task);
      int schedule = FastListTask_SCHEDULE(task);
      int deadline = FastListTask_DEADLINE(task);
      printf("\trelease=%d\tschedule_%d=%d\tdeadline=%d\t", release, index+1, schedule, deadline);
      printf("\n");
    } FastList_ENDEACH_Schedule_FastListTask;
  }
  FastList_Dtor(fastList);
}


#endif//FastList__c_INCLUDED
