#ifndef GrahamList_c_INCLUDED
#define GrahamList_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/GrahamList.xcc"
#include "SCD/SCD_.h"

#line 21 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/GrahamList.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 32 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/GrahamList.xcc"
GrahamListDates
GrahamListDates_Ctor(GrahamListDates this)
{
  *GrahamListDates__EARLYDATE(this) = 0;
  *GrahamListDates__LATEDATE(this) = 0;
  return this;
}

#line 63 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/GrahamList.xcc"
GrahamListTask
GrahamListTask_Ctor(GrahamListTask this, IssueItem issueItem, int unwinding)
{
  Except_REQUIRE(unwinding >= 0);
  *GrahamListTask__ITEM(this) = issueItem;
  *GrahamListTask__PRIORITY1(this) = 0;
  *GrahamListTask__PRIORITY2(this) = 0;
  *GrahamListTask__TAU(this) = 0;
  *GrahamListTask__PHI(this) = 0;
  memset(GrahamListTask_DATES(this), 0, (unwinding + 1)*sizeof(GrahamListDates_));
  return this;
}

#line 76 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/GrahamList.xcc"
size_t
GrahamListTask_Size(IssueItem issueItem, int unwinding)
{
  return sizeof(GrahamListTask_) + unwinding*sizeof(GrahamListDates_);
}

#line 93 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/GrahamList.xcc"
int
GrahamListTask_compare(const void *this_pointer, const void *that_pointer)
{
  const_GrahamListTask this = this_pointer;
  const_GrahamListTask that = that_pointer;
  int result = GrahamListTask_PRIORITY1(this) - GrahamListTask_PRIORITY1(that);
  if (result != 0) return result;
  result = GrahamListTask_PRIORITY2(this) - GrahamListTask_PRIORITY2(that);
  if (result != 0) return result;
  result = IssueItem_ORDERING(GrahamListTask_ITEM(this)) -
      IssueItem_ORDERING(GrahamListTask_ITEM(that));
  return result;
}

#line 119 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/GrahamList.xcc"
const char *
GrahamListKind_type(GrahamListKind this)
{
  static const char *_[] = {
    "Forward",
    "Backward",
  };
  Except_REQUIRE((unsigned)this < GrahamListKind__);
  return _[this];
}

#line 158 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/GrahamList.xcc"
GrahamList
GrahamList_Ctor(GrahamList this,
                Memory memory, DDGraph ddgraph, const uint8_t *availability)
{
  int32_t nodeCount = DDGraph_nodeCount(ddgraph);
  *GrahamList__DDGRAPH(this) = ddgraph;
  *GrahamList__ISSUETABLE(this) = IssueTable_new(memory, availability);
  IStack_Ctor(GrahamList_TASKS(this),
              memory, sizeof(GrahamListTask), nodeCount);
  IDList_Ctor(GrahamList_TOISSUE(this), memory);
  IDList_Ctor(GrahamList_NOISSUE(this), memory);
  IDList_Ctor(GrahamList_ISSUED(this), memory);
  return this;
}

#line 173 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/GrahamList.xcc"
void
GrahamList_Dtor(GrahamList this)
{
  IssueTable_delete(GrahamList_ISSUETABLE(this));
  IStack_Dtor(GrahamList_TASKS(this));
  IDList_Dtor(GrahamList_TOISSUE(this));
  IDList_Dtor(GrahamList_NOISSUE(this));
  IDList_Dtor(GrahamList_ISSUED(this));
}

#line 183 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/GrahamList.xcc"
size_t
GrahamList_Size(Memory memory, DDGraph ddgraph, const uint8_t *availability)
{
  return sizeof(GrahamList_);
}

#line 198 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/GrahamList.xcc"
#ifndef GrahamList_POOLED
#define GrahamList_POOLED 128
#endif//GrahamList_POOLED

#line 202 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/GrahamList.xcc"
GrahamList
GrahamList_new(Memory parent, DDGraph ddgraph, const uint8_t *availability)
{
  Memory memory = Memory_new(parent, 0);
  size_t size = GrahamList_Size(memory, ddgraph, availability);
  GrahamList this = Memory_alloc(memory, size);
  return GrahamList_Ctor(this, memory, ddgraph, availability);
}

#line 215 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/GrahamList.xcc"
GrahamList
GrahamList_delete(GrahamList this)
{
  if (this != NULL) {
    Memory memory = GrahamList_MEMORY(this);
#ifndef PRO_NDTOR
    GrahamList_Dtor(this);
    Memory_free_(memory, this);
#endif//PRO_NDTOR
    Memory_delete(memory);
  }
  return NULL;
}

#line 317 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/GrahamList.xcc"
void
GrahamList_enterIssueItem(GrahamList this, IssueItem issueItem, int unwinding)
{
  IDList toIssue = GrahamList_TOISSUE(this);
  IDList noIssue = GrahamList_NOISSUE(this);
  Scheduling scheduling = IssueItem_SCHEDULING(issueItem);
  size_t size = GrahamListTask_Size(issueItem, unwinding);
  GrahamListTask task = NULL;
  if (scheduling != Scheduling__UNDEF) {
    task = GrahamListTask_Ctor(IDList_push(toIssue, size), issueItem, unwinding);
  } else {
    task = GrahamListTask_Ctor(IDList_push(noIssue, size), issueItem, unwinding);
    if (Operator_isPseudo(Operation_operator(IssueItem_OPERATION(issueItem))));
    else {
#ifndef ECL_NTRACE
      fprintf(stderr, "*** No Scheduling for %s\n",
              Operator_name_(Operation_operator(IssueItem_OPERATION(issueItem))));
#endif//ECL_NTRACE
      Except_NEVER(true);
    }
  }
  IStack_PUSH(GrahamList_TASKS(this), GrahamListTask, task);
  IssueTable_enter(GrahamList_ISSUETABLE(this), issueItem);
}

#line 348 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/GrahamList.xcc"
void
GrahamList_scheduleNoIssue(GrahamList this)
{
  DDGraph ddgraph = GrahamList_DDGRAPH(this);
  DDGraphKind kind = DDGraph_KIND(ddgraph);
  int16_t lambda = DDGraph_LAMBDA(ddgraph);
  GrahamList_FOREACH_NOISSUE_GrahamListTask(this, TASK) {
    IssueItem ITEM = GrahamListTask_ITEM(TASK);
    DDGraphNode NODE = IssueItem_DDGNODES(ITEM)[kind];
    int16_t tau = DDGraphNode_DATE(NODE)%lambda;
    int16_t phi = DDGraphNode_DATE(NODE)/lambda;
    while (tau >= lambda) tau -= lambda, phi += 1;
    while (tau < 0) tau += lambda, phi -= 1;
    *GrahamListTask__TAU(TASK) = tau;
    *GrahamListTask__PHI(TASK) = phi;
  } GrahamList_ENDEACH_NOISSUE_GrahamListTask;
}

#line 366 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/GrahamList.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 374 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/GrahamList.xcc"
void
GrahamList_INIT(void)
{
}

#line 385 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/GrahamList.xcc"
void
GrahamList_FINI(void)
{
}

#line 390 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/GrahamList.xcc"
#if XCC__C
void
GrahamList_TEST(void)
{
#include "SCD/GrahamList_.c"
}

#line 397 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/GrahamList.xcc"
int
main(int argc, char **argv)
{
  SCD_Test(GrahamList_TEST);
  return 0;
}
#endif


#endif//GrahamList_c_INCLUDED
