#ifndef Relaxation__c_INCLUDED
#define Relaxation__c_INCLUDED

#line 61 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Relaxation.xcc"
//
{
  printf("sizeof(RelaxationItem_) = %d\n", sizeof(RelaxationItem_));
}

#line 143 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Relaxation.xcc"
//
{
  printf("sizeof(RelaxationItemTable_) = %d\n", sizeof(RelaxationItemTable_));
}

#line 431 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Relaxation.xcc"
//
{
  printf("sizeof(RelaxationStep_) = %d\n", sizeof(RelaxationStep_));
}

#line 781 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Relaxation.xcc"
//
{
  printf("sizeof(Relaxation_) = %d\n", sizeof(Relaxation_));
}

#line 1038 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/Relaxation.xcc"
//
{
  int i, j, k;
  int16_t lambda = 0;
  static DDGraphNode nodes[10];
  static Resource resources[1] = { 1 };
  static uint8_t availability[] = { 0, 1, 3 };
  static uint8_t requirements[] =  { 0, 1, 2 };
  static int8_t releases[] =  { -1, 0, 1, 3, 1, 3, 7, 6, 6 };
  static int8_t deadlines[] = { -1, 1, 2, 7, 5, 7, 9, 8, 8 };
  DDGraph ddgraph = DDGraph_new(Memory_Root, DDGraphKind_Early, 0,
                                Processor__UNDEF + 1, 10, &lambda);
  DDGraphNode node_0 = DDGraph_makeNode(ddgraph, NULL);
  DDGraphNode node_1 = DDGraph_makeNode(ddgraph, NULL);
  DDGraphNode node_2 = DDGraph_makeNode(ddgraph, NULL);
  DDGraphNode node_3 = DDGraph_makeNode(ddgraph, NULL);
  DDGraphNode node_4 = DDGraph_makeNode(ddgraph, NULL);
  DDGraphNode node_5 = DDGraph_makeNode(ddgraph, NULL);
  DDGraphNode node_6 = DDGraph_makeNode(ddgraph, NULL);
  DDGraphNode node_7 = DDGraph_makeNode(ddgraph, NULL);
  DDGraphNode node_8 = DDGraph_makeNode(ddgraph, NULL);
  GrahamList grahamList = GrahamList_new(Memory_Root, ddgraph, availability);
  Relaxation_ relaxation[1];
  for (i = 0; i < 9; i++) IStack_PUSH(GrahamList_TASKS(grahamList), GrahamListTask, NULL);
  {
    DDGraphArc arc_1_2 = DDGraph_makeArc(ddgraph, node_1, node_2, 1+0, 0, DependenceKind_Some, NULL);
    DDGraphArc arc_1_4 = DDGraph_makeArc(ddgraph, node_1, node_4, 1+0, 0, DependenceKind_Some, NULL);
    DDGraphArc arc_2_3 = DDGraph_makeArc(ddgraph, node_2, node_3, 1+0, 0, DependenceKind_Some, NULL);
    DDGraphArc arc_2_5 = DDGraph_makeArc(ddgraph, node_2, node_5, 1+0, 0, DependenceKind_Some, NULL);
    DDGraphArc arc_3_6 = DDGraph_makeArc(ddgraph, node_3, node_6, 1+1, 0, DependenceKind_Some, NULL);
    DDGraphArc arc_4_3 = DDGraph_makeArc(ddgraph, node_4, node_3, 1+1, 0, DependenceKind_Some, NULL);
    DDGraphArc arc_4_5 = DDGraph_makeArc(ddgraph, node_4, node_5, 1+1, 0, DependenceKind_Some, NULL);
    DDGraphArc arc_7_6 = DDGraph_makeArc(ddgraph, node_7, node_6, 1+0, 0, DependenceKind_Some, NULL);
    nodes[0] = node_0; nodes[1] = node_1; nodes[2] = node_2; nodes[3] = node_3; nodes[4] = node_4;
    nodes[5] = node_5; nodes[6] = node_6; nodes[7] = node_7; nodes[8] = node_8; nodes[9] = NULL;
  }
  Relaxation_Ctor(relaxation, Memory_Root, RelaxationKind_Backward, grahamList, 0);
  // Enter in lower release date first order.
  for (i = 1; i < 9; i++) {
    int release = INT_MAX, k = -1;
    for (j = 1; j < 9; j++) {
      if (nodes[j] == NULL) continue;
      if (release > releases[j]) {
        release = releases[j];
        k = j;
      }
    }
    if (k >= 0) {
      RelaxationItemTable itemTable = Relaxation_itemTable(relaxation);
      RelaxationItem item = RelaxationItemTable_makeItem(itemTable, requirements, nodes[k], 0);
      *RelaxationItem__RELEASE(item) = releases[k];
      *RelaxationItem__DEADLINE(item) = deadlines[k];
      nodes[k] = NULL;
    }
  }
  printf("\n");
  Relaxation_FORBACK_RelaxationItem(relaxation, firstItem) {
    bool feasible = false;
    RelaxationItemTable itemTable = Relaxation_itemTable(relaxation);
    RelaxationStep_ relaxationStep[1];
    RelaxationStep_Ctor(relaxationStep, Memory_Root, itemTable, firstItem, availability);
    feasible = RelaxationStep_enterItems(relaxationStep);
    RelaxationStep_FOREACH_RelaxationItem(relaxationStep, item) {
      FastListTask task = RelaxationItem_TASK(item);
      int release = RelaxationItem_RELEASE(item);
      int deadline = RelaxationItem_DEADLINE(item);
      int latency = RelaxationItem_LATENCY(item);
      int index = RelaxationItem_INDEX(item);
      printf("{r=%d d=%d}_%d\t", release, deadline, index);
    } RelaxationStep_ENDEACH_RelaxationItem;
    Relaxation_runRelaxationStep(relaxation, relaxationStep, 1, resources);
    printf("\n");
    RelaxationStep_Dtor(relaxationStep);
  } Relaxation_ENDBACK_RelaxationItem;
  Relaxation_Dtor(relaxation);
  GrahamList_delete(grahamList);
  DDGraph_delete(ddgraph);
}


#endif//Relaxation__c_INCLUDED
