#ifndef SCD_c_INCLUDED
#define SCD_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/SCD.xcc"
#include "SCD/SCD_.h"

#line 31 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/SCD.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 85 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/SCD.xcc"
#undef SCD_TRACE 
FILE *SCD_TRACE = NULL;

#line 101 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/SCD.xcc"
int LAO_STARTSCD;
int LAO_STARTSWP;
int LAO_IDENTITY;
int LAO_SERIALIZE;
int FORCE_LLPALEVEL;
int FORCE_UNWINDING;
int LAO_MAXITEMCOUNT;
int FORCE_SCANNING;
int FORCE_EXITWEIGHT;

#line 117 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/SCD.xcc"
static int SCD_Initialized = 0;

#line 119 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/SCD.xcc"
void
SCD_INIT(void)
{
  if (SCD_Initialized++ == 0) {
    if (GETENV("SCD_TRACE")) {
      int file = 0;
      sscanf(GETENV("SCD_TRACE"), "%d", &file);
      if (file == 1) SCD_TRACE = stdout;
      else if (file == 2) SCD_TRACE = stderr;
    }
    LAO_STARTSCD = -1;
    if (GETENV("LAO_STARTSCD")) {
      sscanf(GETENV("LAO_STARTSCD"), "%d", &LAO_STARTSCD);
      fprintf(stderr, "*** LAO_STARTSCD=%d\n", LAO_STARTSCD);
    }
    LAO_STARTSWP = -1;
    if (GETENV("LAO_STARTSWP")) {
      sscanf(GETENV("LAO_STARTSWP"), "%d", &LAO_STARTSWP);
      fprintf(stderr, "*** LAO_STARTSWP=%d\n", LAO_STARTSWP);
    }
    LAO_IDENTITY = -1;
    if (GETENV("LAO_IDENTITY")) {
      sscanf(GETENV("LAO_IDENTITY"), "%d", &LAO_IDENTITY);
      fprintf(stderr, "*** LAO_IDENTITY=%d\n", LAO_IDENTITY);
    }
    LAO_SERIALIZE = 0;
    if (GETENV("LAO_SERIALIZE")) {
      sscanf(GETENV("LAO_SERIALIZE"), "%d", &LAO_SERIALIZE);
      fprintf(stderr, "*** LAO_SERIALIZE=%d\n", LAO_SERIALIZE);
    }
    FORCE_LLPALEVEL = 2;
    if (GETENV("FORCE_LLPALEVEL")) {
      sscanf(GETENV("FORCE_LLPALEVEL"), "%d", &FORCE_LLPALEVEL);
      fprintf(stderr, "*** FORCE_LLPALEVEL=%d\n", FORCE_LLPALEVEL);
    }
    FORCE_UNWINDING = -1;
    if (GETENV("FORCE_UNWINDING")) {
      sscanf(GETENV("FORCE_UNWINDING"), "%d", &FORCE_UNWINDING);
      fprintf(stderr, "*** FORCE_UNWINDING=%d\n", FORCE_UNWINDING);
    }
    LAO_MAXITEMCOUNT = 512;
    if (GETENV("LAO_MAXITEMCOUNT")) {
      sscanf(GETENV("LAO_MAXITEMCOUNT"), "%d", &LAO_MAXITEMCOUNT);
      fprintf(stderr, "*** LAO_MAXITEMCOUNT=%d\n", LAO_MAXITEMCOUNT);
    }
    FORCE_SCANNING = -1;
    if (GETENV("FORCE_SCANNING")) {
      sscanf(GETENV("FORCE_SCANNING"), "%d", &FORCE_SCANNING);
      fprintf(stderr, "*** FORCE_SCANNING=%d\n", FORCE_SCANNING);
    }
    FORCE_EXITWEIGHT = 1;//-1;
    if (GETENV("FORCE_EXITWEIGHT")) {
      sscanf(GETENV("FORCE_EXITWEIGHT"), "%d", &FORCE_EXITWEIGHT);
      fprintf(stderr, "*** FORCE_EXITWEIGHT=%d\n", FORCE_EXITWEIGHT);
    }
    CCL_INIT();
    CAL_INIT();
    MDS_INIT();
    AIR_INIT();
    LIR_INIT();
    PFA_INIT();
    XFA_INIT();
    FastList_INIT();
    GrahamList_INIT();
    Relaxation_INIT();
    Scheduler_INIT();
    Insertion_INIT();
    CycleBased_INIT();
    Unwinding_INIT();
    Iterative_INIT();
    Acyclic_INIT();
    Formulation_INIT();
    Construction_INIT();
    RCMS_INIT();
  }
}

#line 202 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/SCD.xcc"
void
SCD_FINI(void)
{
  if (--SCD_Initialized == 0) {
    RCMS_FINI();
    Construction_FINI();
    Formulation_FINI();
    Acyclic_FINI();
    Iterative_FINI();
    Unwinding_FINI();
    CycleBased_FINI();
    Insertion_FINI();
    Scheduler_FINI();
    Relaxation_FINI();
    GrahamList_FINI();
    FastList_FINI();
    XFA_FINI();
    PFA_FINI();
    LIR_FINI();
    AIR_FINI();
    MDS_FINI();
    CAL_FINI();
    CCL_FINI();
  }
}

#line 234 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/SCD.xcc"
void
SCD_Test(void (*test)(void))
{
  SCD_INIT();
  (*test)();
  SCD_FINI();
}

#line 242 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/SCD.xcc"
#if XCC__C
void
SCD_TEST(void)
{
#include "SCD/SCD_.c"
}

#line 249 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/SCD/SCD.xcc"
int
main(int argc, char **argv)
{
  SCD_Test(SCD_TEST);
  return 0;
}
#endif


#endif//SCD_c_INCLUDED
