#ifndef BlockTrace_c_INCLUDED
#define BlockTrace_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
#include "XFA/XFA_.h"

#line 21 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 113 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
BlockTrace
BlockTrace_Ctor(BlockTrace this,
                Memory memory, OptimizeRegionType regionType, BlockTraceFlags traceFlags)
{
  *BlockTrace__REGIONTYPE(this) = regionType;
  *BlockTrace__FLAGS(this) = traceFlags;
  *BlockTrace__REGIONFLOW(this) = NULL;
  *BlockTrace__HEADNODE(this) = NULL;
  *BlockTrace__TAILNODE(this) = NULL;
  *BlockTrace__HEADBLOCK(this) = NULL;
  *BlockTrace__TAILBLOCK(this) = NULL;
  PtrSet_Ctor(BlockTrace_CFGNODES(this), memory, 0);
  *BlockTrace__FIRSTITEM(this) = NULL;
  *BlockTrace__STARTITEM(this) = NULL;
  *BlockTrace__STOPITEM(this) = NULL;
  *BlockTrace__LASTITEM(this) = NULL;
  IDList_Ctor(BlockTrace_ISSUEITEMS(this), memory);
  PtrSet_Ctor(BlockTrace_DDGNODES(this), memory, 256);
  *BlockTrace__LOOPSCOPE(this) = NULL;
  *BlockTrace__EFFECTTABLE(this) = NULL;
  *BlockTrace__LIFETIMETABLE(this) = NULL;
  *BlockTrace__SOLVING(this) = 0;
  *BlockTrace__TIMEOUT(this) = 0;
  *BlockTrace__LAMBDA(this) = 0;
  *BlockTrace__LENGTH(this) = 0;
  *BlockTrace__FACTOR(this) = 0;
  *BlockTrace__KUNROLL(this) = -1;
  return this;
}

#line 143 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
void
BlockTrace_Dtor(BlockTrace this)
{
  PtrSet_Dtor(BlockTrace_CFGNODES(this));
  IDList_empty(BlockTrace_ISSUEITEMS(this),
               (IDListItemRelease)IssueItem_Dtor);
  IDList_Dtor(BlockTrace_ISSUEITEMS(this));
  PtrSet_Dtor(BlockTrace_DDGNODES(this));
  EffectTable_delete(BlockTrace_EFFECTTABLE(this));
  LifetimeTable_delete(BlockTrace_LIFETIMETABLE(this));
}

#line 155 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
size_t
BlockTrace_Size(Memory memory, OptimizeRegionType regionType, BlockTraceFlags traceFlags)
{
  return sizeof(BlockTrace_);
}

#line 170 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
int
BlockTrace_compare(const void *this_pointer, const void *that_pointer)
{
  const_BlockTrace this = this_pointer;
  const_BlockTrace that = that_pointer;
  LoopScope this_scope = BlockTrace_LOOPSCOPE(this);
  LoopScope that_scope = BlockTrace_LOOPSCOPE(that);
  int result = LoopScope_nesting(that_scope) - LoopScope_nesting(this_scope);
  if (result == 0 && this != that) {
    CFGNode this_headNode = BlockTrace_HEADNODE(this);
    CFGNode that_headNode = BlockTrace_HEADNODE(that);
    BasicBlock this_basicBlock = CFGNode_basicBlock(this_headNode);
    BasicBlock that_basicBlock = CFGNode_basicBlock(that_headNode);
    intptr_t this_index = BasicBlock_index(this_basicBlock);
    intptr_t that_index = BasicBlock_index(that_basicBlock);
    return (this_index < that_index) - (this_index > that_index);
  }
  return result;
}

#line 198 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
BlockTrace
BlockTrace_createSingleton(Memory memory, RegionFlow regionFlow, CFGNode cfgNode,
                           LoopScope loopScope, OptimizeRegionType regionType,
                           BlockTraceFlags traceFlags)
{
  size_t size = BlockTraceSize(memory, regionType, traceFlags);
  BasicBlock basicBlock = CFGNode_BASICBLOCK(cfgNode);
  BlockTrace blockTrace = Memory_alloc(memory, size);
  EntryCode(blockTrace, memory, regionType, traceFlags);
  BlockTraceGrow(blockTrace, cfgNode);
  BlockTraceStop(blockTrace, regionFlow, loopScope);
  return blockTrace;
}

#line 289 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
#ifndef ECL_NTRACE
bool
BlockTrace_prettyIssueItems(BlockTrace this, FILE *file)
{
  if (file == NULL) file = stderr;
  BlockTrace_FOREACH_IssueItem(this, item) {
    int controlId = IssueItem_CONTROLID(item);
    int date = IssueItem_STARTDATE(item);
    fprintf(file, "    [%d] %d\t", date, controlId);
    IssueItem_pretty(item, file);
  } BlockTrace_ENDEACH_IssueItem;
  return true;
}
#endif//ECL_NTRACE

#line 311 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
#ifndef ECL_NTRACE
bool
BlockTrace_pretty(BlockTrace this, FILE *file)
{
  OptimizeRegionType regionType = BlockTrace_REGIONTYPE(this);
  if (file == NULL) file = stderr;
  ETable_prettyFlags(OptimizeRegionType_Table, regionType, "\t", file);
  BlockTrace_FOREACH_CFGNode(this, node) {
    int32_t numbering = CFGNode_NUMBERING(node);
    BasicBlock block = CFGNode_basicBlock(node);
    if (block != NULL) {
      fprintf(file, "%d:Block_%d", BasicBlock_identity(block), CFGNode_INDEX(node));
    } else {
      fprintf(file, "node_%d", CFGNode_INDEX(node));
    }
    fprintf(file, "[%d]\t", numbering);
  } BlockTrace_ENDEACH_CFGNode;
  fprintf(file, "\n");
  return true;
}
#endif//ECL_NTRACE

#line 339 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
size_t
BlockTraceSize(Memory memory, OptimizeRegionType regionType, BlockTraceFlags traceFlags)
{
  return BlockTrace_Size(memory, regionType, traceFlags);
}

#line 352 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
void
EntryCode(BlockTrace this, Memory memory, OptimizeRegionType regionType,
          BlockTraceFlags traceFlags)
{
  BlockTrace_Ctor(this, memory, regionType, traceFlags);
}

#line 365 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
bool
BlockTraceGrow(BlockTrace this, CFGNode cfgNode)
{
  CFGNode lastNode = BlockTrace_TAILNODE(this);
  *CFGNode__NEXTNODE(cfgNode) = NULL;
  *CFGNode__PREVNODE(cfgNode) = NULL;
  if (lastNode == NULL) {
    // This is the first cfgNode added to this BlockTrace.
    *BlockTrace__HEADNODE(this) = cfgNode;
    *CFGNode__NUMBERING(cfgNode) = 0;
  } else {
    // Adding another cfgNode to this BlockTrace.
    *CFGNode__NEXTNODE(lastNode) = cfgNode;
    *CFGNode__NUMBERING(cfgNode) = CFGNode_NUMBERING(lastNode) + 1;
  }
  *BlockTrace__TAILNODE(this) = cfgNode;
  PtrSet_insert(BlockTrace_CFGNODES(this), cfgNode);
  return true;
}

#line 391 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
void
BlockTraceStop(BlockTrace this, RegionFlow regionFlow, LoopScope loopScope)
{
  CFGNode prev_node = NULL;
  int nodeCount = BlockTrace_NODECOUNT(this);
  // Refine this BlockTrace REGIONTYPE and FLAGS.
  CodeRegion codeRegion = RegionFlow_codeRegion(regionFlow);
  OptimizeRegionType regionType = BlockTrace_REGIONTYPE(this);
  Configure_Copy(BlockTrace_CONFIGURE(this), LoopScope_configure(loopScope));
  Configure_merge(BlockTrace_CONFIGURE(this), CodeRegion_configure(codeRegion));
  if (nodeCount == 1) {
    regionType = OptimizeRegionType_InnerLoop;
  }
  if (nodeCount == LoopScope_blockCount(loopScope)) {
    *BlockTrace__FLAGS(this) |= BlockTraceFlag_LoopBody;
    prev_node = BlockTrace_TAILNODE(this);
  } else {
    regionType &= ~OptimizeRegionType_InnerLoop;
  }
  *BlockTrace__REGIONTYPE(this) = regionType;
  *BlockTrace__REGIONFLOW(this) = regionFlow;
  *BlockTrace__LOOPSCOPE(this) = loopScope;
  // Set the CFGNode PREV and NEXT fields, and fill CFGNODES.
  BlockTrace_FOREACH_CFGNode(this, node) {
    BasicBlock basicBlock = CFGNode_basicBlock(node);
    intptr_t traceId = CodeRegion_makeTraceId(codeRegion);
    BasicBlock_setTraceId(basicBlock, traceId);
    if (prev_node != NULL) {
      *CFGNode__PREVNODE(node) = prev_node;
      *CFGNode__NEXTNODE(prev_node) = node;
    }
    prev_node = node;
  } BlockTrace_ENDEACH_CFGNode;
#ifdef XCC__C
  BlockTrace_pretty(this, stdout);
#endif
  // Complete this BlockTrace.
  BlockTrace_complete(this);
}

#line 437 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
void
BlockTrace_complete(BlockTrace this)
{
  LoopScope loopScope = BlockTrace_LOOPSCOPE(this);
  Processor processor = BlockTrace_PROCESSOR(this);
  Optimize optimize = BlockTrace_OPTIMIZE(this);
  unsigned solving = Optimize_RCMSSOLVING(optimize);
  unsigned timeOut = 1<<Optimize_LOGTIMEOUT(optimize);
  bool isPrePass = BlockTrace_isPrePass(this);
  bool isInnerLoop = BlockTrace_isInnerLoop(this);
  int compensation = LoopScope_COMPENSATION(loopScope);
  int speculation = LoopScope_SPECULATION(loopScope);
  int pipelining = LoopScope_PIPELINING(loopScope);
  int renaming = LoopScope_RENAMING(loopScope), factor = 0;
  if (pipelining >= 4) {
    // Software pipelining levels between 4 and 7: override Optimize_RCMSSOLVING.
    solving |= (OptimizeRCMSSolving_Dinechin|OptimizeRCMSSolving_PostPass);
    solving &= ~(OptimizeRCMSSolving_LNSScan1|OptimizeRCMSSolving_LNSScan2);
    if (pipelining == 4) solving |= OptimizeRCMSSolving_LNSScan1;
    if (pipelining == 5) solving |= OptimizeRCMSSolving_LNSScan2;
    if (pipelining == 6) solving |= OptimizeRCMSSolving_LNSScan1|OptimizeRCMSSolving_LNSScan2;
    pipelining = 4;
  }
  if (isPrePass) {
    *BlockTrace__FLAGS(this) |= BlockTraceFlag_PrePass;
    if (isInnerLoop && !LoopScope_isRemainder(loopScope)) {
      // Pre-pass scheduling of an inner loop body.
      Temporary tripCount = LoopScope_tripCount(loopScope);
      if (LoopScope_isHardware(loopScope) && tripCount != NULL) {
        if (Temporary_isAbsolute(tripCount)) {
          // Constant loop trip count, get its lowest power of 2.
          TemporaryInvariant trip_invariant = Temporary_INVARIANT(tripCount);
          unsigned value = (unsigned)TemporaryInvariant_VALUE(trip_invariant);
          factor = value != 0? (value & -value): 1;
        } else {
          // Find how much power of 2 is left available for kernel unrolling.
          int modulus = LoopScope_TRIPMODULUS(loopScope);
          int residue = LoopScope_TRIPRESIDUE(loopScope);
          int unrolled = LoopScope_unrolled(loopScope);
          if (unrolled == 0) unrolled = 1;
          if (residue == 0 && modulus > 1 && modulus%unrolled == 0) {
            modulus /= unrolled;
            factor = modulus & -modulus;
          } else factor = 1;
        }
        // Shift factor until lower than or equal to renaming.
        while (factor > renaming) factor >>= 1; //FIXME! This is wrong.
        if (factor != 0) renaming = factor;
        else factor = 1;
      } else {
        // Not a hardware counted loop: no need to constrain modulo renaming.
      }
      if (pipelining < 1) {
        // No software pipelining: disable modulo renaming and kernel unrolling.
        renaming = factor = 0;
      }
    } else {
      // Pre-pass scheduling of non pipelinable loop.
      pipelining = renaming = factor = 0;
    }
  } else {
    // Post-pass scheduling.
    pipelining = renaming = factor = 0;
    if (compensation > FORCE_POSTCOMP) compensation = FORCE_POSTCOMP;
    if (speculation > FORCE_POSTSPEC) speculation = FORCE_POSTSPEC;
  }
  // Store the configured values.
  *BlockTrace__SOLVING(this) = solving;
  *BlockTrace__TIMEOUT(this) = timeOut;
  *BlockTrace__COMPENSATION(this) = compensation;
  *BlockTrace__SPECULATION(this) = speculation;
  *BlockTrace__PIPELINING(this) = pipelining;
  *BlockTrace__RENAMING(this) = renaming;
  *BlockTrace__FACTOR(this) = factor;
}

#line 517 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
void
BlockTrace_disablePipelining(BlockTrace this)
{
  *BlockTrace__PIPELINING(this) = 0;
  *BlockTrace__RENAMING(this) = 0;
  *BlockTrace__FACTOR(this) = 0;
  PFA_TRACE && fprintf(PFA_TRACE, "*** DISABLE\tpipelining=%d\trenaming=%d\n",
                                  BlockTrace_PIPELINING(this), BlockTrace_RENAMING(this));
}

#line 533 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
bool
BlockTrace_isEmpty(BlockTrace this)
{
  BlockTrace_FOREACH_CFGNode(this, cfgNode) {
    BasicBlock basicBlock = CFGNode_basicBlock(cfgNode);
    if (basicBlock != NULL && !BasicBlock_isEmpty(basicBlock)) return false;
  } BlockTrace_ENDEACH_CFGNode;
  return true;
}

#line 549 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
float
BlockTrace_getEnterFrequency(BlockTrace this)
{
  float frequency = 0.0;
  CFGNode prev_node = NULL;
  PtrSet cfgNodes = BlockTrace_CFGNODES(this);
  BlockTrace_FOREACH_CFGNode(this, cfgNode) {
    CFGNode_FORENTER_CFGArc(cfgNode, arc) {
      CFGNode tail_node = CFGArc_TAIL(arc);
      BasicBlock tail_block = CFGNode_basicBlock(tail_node);
      if (tail_block != NULL && tail_node != prev_node &&
          !PtrSet_contains(cfgNodes, tail_node)) {
        frequency += BasicBlock_frequency(tail_block);
      }
    } CFGNode_ENDENTER_CFGArc;
    prev_node = cfgNode;
  } BlockTrace_ENDEACH_CFGNode;
  return frequency;
}

#line 575 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
float
BlockTrace_getLoopProbalility(BlockTrace this)
{
  float probability = 0.0;
  CFGNode headNode = BlockTrace_HEADNODE(this);
  CFGNode_FORENTER_CFGArc(headNode, arc) {
    CFGNode tail_node = CFGArc_TAIL(arc);
    if (BlockTrace_contains(this, tail_node)) {
      probability += CFGArc_PROBABILITY(arc);
    }
  } CFGNode_ENDENTER_CFGArc;
  return probability;
}

#line 595 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
const_DependenceTable
BlockTrace_getDependenceTable(const_BlockTrace this)
{
  LoopScope loopScope = BlockTrace_LOOPSCOPE(this);
  LoopScope parent_scope = LoopScope_parent(loopScope);
  const_DependenceTable dependenceTable = LoopScope_dependenceTable(loopScope);
  while (   parent_scope != NULL
         && dependenceTable == NULL) {
    // Improper loops are detected at a coarser granularity in the Open64.
    // So visit the parent LoopScope(s) (/bugs/st200/pro-release-1-3-0-B/15).
    dependenceTable = LoopScope_dependenceTable(parent_scope);
    parent_scope = LoopScope_parent(parent_scope);
  }
  return dependenceTable;
}

#line 618 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
bool
BlockTrace_normalizeRegionFlow(BlockTrace this)
{
  bool isPrePass = BlockTrace_isPrePass(this), discarded = false;
  Procedure procedure = BlockTrace_PROCEDURE(this);
  CFGNode headNode = BlockTrace_HEADNODE(this);
  CFGNode tailNode = BlockTrace_TAILNODE(this);
  CFGNode cfgNode = NULL, prev_node = NULL;
  BasicBlock headBlock = NULL, tailBlock = NULL, prev_block = NULL;
  BlockTrace_FOREACH_CFGNode(this, cfgNode) {
    BasicBlock basicBlock = CFGNode_basicBlock(cfgNode);
    if (basicBlock != NULL && prev_block != NULL) {
      // Straighten the BasicBlocks.
      CFGArc fall_arc = CFGNode_getFallArc(prev_node);
      Procedure_unchainBasicBlock(procedure, basicBlock);
      Procedure_chainBasicBlocks(procedure, prev_block, basicBlock);
      if (fall_arc != NULL) {
        // Conditional GOTO fall-through arc.
        if (CFGArc_HEAD(fall_arc) != cfgNode) {
          if (CFGNode_invertGoToOperation(prev_node));
          else Except_NEVER(true);
        }
        Except_CHECK(CFGArc_HEAD(CFGNode_getFallArc(prev_node)) == cfgNode);
      } else {
        // No fall-through arc: remove the unconditional GOTO.
        CFGNode_discardGoToOperation(prev_node);
      }
    }
    if (headBlock == NULL) headBlock = basicBlock;
    if (basicBlock != NULL) tailBlock = basicBlock;
    prev_block = basicBlock;
    prev_node = cfgNode;
  } BlockTrace_ENDEACH_CFGNode;
  // Set this BlockTrace HEADBLOCK and TAILBLOCK.
  *BlockTrace__HEADBLOCK(this) = headBlock;
  *BlockTrace__TAILBLOCK(this) = tailBlock;
  Except_ENSURE(CFGNode_basicBlock(BlockTrace_HEADNODE(this)) == headBlock);
  Except_ENSURE(CFGNode_basicBlock(BlockTrace_TAILNODE(this)) == tailBlock);
  // Discard the middle CFGNodes.
  prev_node = headNode;
  cfgNode = CFGNode_NEXTNODE(headNode);
  while (cfgNode != NULL && cfgNode != tailNode) {
    CFGNode next_node = CFGNode_NEXTNODE(cfgNode);
    CFGNode succ_node = CFGNode_getOnlySuccessor(cfgNode);
    CFGNode pred_node = CFGNode_getOnlyPredecessor(cfgNode);
    if (next_node != NULL && next_node == succ_node && pred_node != NULL) {
      BasicBlock basicBlock = CFGNode_basicBlock(cfgNode);
      if (BasicBlock_isEntry(basicBlock) || BasicBlock_isExit(basicBlock));
      else if (isPrePass && BasicBlock_hasDedicatedEffects(basicBlock));
      else {
        // Empty and unchain the basicBlock.
        BasicBlock next_block = CFGNode_basicBlock(next_node);
        Selector selector = BasicBlock_selector(basicBlock);
        BasicBlock_putSelector(next_block, selector);
        Procedure_unchainBasicBlock(procedure, basicBlock);
        // Bypass the cfgNode.
        DGraphNode_detachEnterArcs((DGraphNode)cfgNode);
        CFGNode_FORLEAVE_CFGArc(pred_node, arc) {
          if (CFGArc_HEAD(arc) == NULL) {
            CFGArc_attachHeadNode(arc, succ_node);
          }
        } CFGNode_ENDLEAVE_CFGArc;
        CFGNode_FORLEAVE_CFGArc(cfgNode, arc) {
          CFGArc_detachHeadNode(arc);
        } CFGNode_ENDLEAVE_CFGArc;
        DGraphNode_detachLeaveArcs((DGraphNode)cfgNode);
        // Remove the cfgNode from this BlockTrace.
        *CFGNode__NEXTNODE(pred_node) = succ_node;
        *CFGNode__PREVNODE(succ_node) = pred_node;
        PtrSet_remove(BlockTrace_CFGNODES(this), cfgNode);
        discarded = true;
        PFA_TRACE && fprintf(PFA_TRACE, "*** DISCARD %d:Block_%d\n",
                                        BasicBlock_identity(basicBlock),
                                        CFGNode_INDEX(cfgNode));
      }
    }
    cfgNode = next_node;
  }
  if (discarded) {
    // Ensure the CFGNode_NUMBERING are contiguous.
    int numbering = 0;
    BlockTrace_FOREACH_CFGNode(this, cfgNode) {
      *CFGNode__NUMBERING(cfgNode) = numbering++;
    } BlockTrace_ENDEACH_CFGNode;
    Except_CHECK(numbering == BlockTrace_NODECOUNT(this));
  }
  return discarded;
}

#line 721 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
void
BlockTrace_prepareScheduling(BlockTrace this)
{
  BasicBlock headBlock = BlockTrace_HEADBLOCK(this);
  BasicBlock tailBlock = BlockTrace_TAILBLOCK(this);
  CFGNode headNode = BlockTrace_HEADNODE(this);
  CFGNode tailNode = BlockTrace_TAILNODE(this);
  Operation prev_control_operation = NULL;
  BasicBlock prev_block = NULL;
  // Add the missing LABEL and FALL Operations into this BlockTrace region.
  BlockTrace_FOREACH_CFGNode(this, cfgNode) {
    BasicBlock basicBlock = CFGNode_basicBlock(cfgNode);
    Operation control_operation = BasicBlock_getControlOperation(basicBlock);
    if (prev_block == NULL) {
      // Add the first LABEL Operation.
      Label label = BasicBlock_makeLabel(basicBlock);
      Selector selector = BasicBlock_selector(basicBlock);
      Operation label_operation = Selector_makeOperationLABEL(selector, label);
      Selector_moveOperationFirst(selector, label_operation);
      Operation_setFlags(label_operation, OperationFlag_EntryCode);
    } else if (prev_control_operation == NULL) {
      // Need a FALL Operation between two BasicBlocks.
      Label label = BasicBlock_makeLabel(basicBlock);
      Selector prev_selector = BasicBlock_selector(prev_block);
      Selector_makeOperationFALL(prev_selector, label);
    }
    if (cfgNode != tailNode && CFGNode_isSuccessor(cfgNode, headNode)) {
      // Multiple loop arcs: disable software pipelining.
      BlockTrace_disablePipelining(this);
    }
    if (BasicBlock_hasGNUASM(basicBlock)) {
      // Disable software pipelining because unsafe to duplicate a GNUASM.
      BlockTrace_disablePipelining(this);
    }
    prev_control_operation = control_operation;
    prev_block = basicBlock;
  } BlockTrace_ENDEACH_CFGNode;
  // Further adjust the control-flow, depending on the type of scheduling.
  if (BlockTrace_isPipeline(this)) {
    // Software pipelining: convert the loop branch to exit branch.
    Operation last_operation = BasicBlock_lastOperation(tailBlock);
    Operator last_operator = Operation_operator(last_operation);
    Label label = Operation_getTargetLabel(last_operation);
    if (Operator_isGoTo(last_operator)) {
      if (!BasicBlock_hasLabel(headBlock, label)) {
        // Odd loop layout: disable software pipelining.
        BlockTrace_disablePipelining(this);
        Except_CHECK(BasicBlock_getControlOperation(tailBlock) != NULL);
      } else if (CFGNode_invertGoToOperation(tailNode)) {
        // There was a conditional loop back branch, it is now an exit.
        // It will be inverted again if necessary in software pipeline Construction.
      } else {
        // Last operator is unconditional: disable software pipelining.
        BlockTrace_disablePipelining(this);
        Except_CHECK(!Operator_isConditional(last_operator));
      }
    } else if (Operator_isHWLIter(last_operator)) {
      // Ensure this operation branches to the loop header.
      Except_CHECK(BasicBlock_hasLabel(headBlock, label));
    } else {
      // Neither a GOTO, nor a HWLIter: disable software pipelining.
      BlockTrace_disablePipelining(this);
    }
  }
  if (!BlockTrace_isPipeline(this)) {
    // Not software pipelining, or demoted to loop scheduling.
    if (BasicBlock_getControlOperation(tailBlock) == NULL) {
      // Append a FALL pseudo-operation to provide a LAST control operation.
      CFGArc fall_arc = CFGNode_getFallArc(tailNode);
      CFGNode head_node = CFGArc_HEAD(fall_arc);
      BasicBlock head_block = CFGNode_basicBlock(head_node);
      Label label = BasicBlock_makeLabel(head_block);
      Selector tailSelector = BasicBlock_selector(tailBlock);
      Selector_makeOperationFALL(tailSelector, label);
    }
  }
}

#line 828 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
void
BlockTrace_enterOperations(BlockTrace this)
{
  int controlId = 0;
  int32_t operationIndex = 0;
  PtrSet ddgNodes = BlockTrace_DDGNODES(this);
  LoopScope loopScope = BlockTrace_LOOPSCOPE(this);
  Configure configure = LoopScope_configure(loopScope);
  BasicBlock headBlock = BlockTrace_HEADBLOCK(this);
  BasicBlock tailBlock = BlockTrace_TAILBLOCK(this);
  Operation first_operation = BasicBlock_firstOperation(headBlock);
  Operation last_operation = BasicBlock_lastOperation(tailBlock);
  const_DependenceTable dependenceTable = BlockTrace_getDependenceTable(this);
  // Enter the Operations into this BlockTrace_ISSUEITEMS.
  BlockTrace_FOREACH_CFGNode(this, cfgNode) {
    IssueItem last_item = NULL;
    Operator last_operator = Operator__UNDEF;
    BasicBlock basicBlock = CFGNode_basicBlock(cfgNode);
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      Operator operator = Operation_operator(operation);
      IssueItem item = BlockTrace_makeIssueItem(this, operation);
      *IssueItem__CONTROLID(item) = controlId;
      Operation_setIndex(operation, ++operationIndex);
      // Fill the BlockTrace_DDGNODES.
      if (   Configure_ALIASING(configure) > 0
          && dependenceTable != NULL
          && DependenceTable_isNode(dependenceTable, operation)) {
        PtrSet_insert(ddgNodes, operation);
      }
      last_operator = operator;
      last_item = item;
    } BasicBlock_ENDEACH_Operation;
    // Compute EXITARC et FALLARC.
    if (Operator_isBranch(last_operator)) {
      if (Operator_isConditional(last_operator)) {
        *IssueItem__EXITARC(last_item) = CFGNode_getTargetArc(cfgNode);
        ++controlId;
      }
    }
    CFGNode_FORLEAVE_CFGArc(cfgNode, arc) {
      if (arc != IssueItem_EXITARC(last_item)) {
        if (IssueItem_FALLARC(last_item) == NULL) {
          *IssueItem__FALLARC(last_item) = arc;
        } else {
          *IssueItem__FALLARC(last_item) = NULL;
          break;
        }
      }
    } CFGNode_ENDLEAVE_CFGArc;
  } BlockTrace_ENDEACH_CFGNode;
  // Set this BlockTrace FIRSTITEM, STARTITEM, STOPITEM, LASTITEM.
  Except_REQUIRE(BlockTrace_FIRSTITEM(this) == NULL);
  *BlockTrace__FIRSTITEM(this) = *BlockTrace__STARTITEM(this)
                               = Operation_issueItem(first_operation);
  *BlockTrace__LASTITEM(this) = *BlockTrace__STOPITEM(this)
                              = Operation_issueItem(last_operation);
  if (BasicBlock_isEntry(headBlock)) {
    Operation start_operation = first_operation;
    BasicBlock_FOREACH_Operation(headBlock, operation) {
      if (Operation_isEntryCode(operation)) start_operation = operation;
      else break;
    } BasicBlock_ENDEACH_Operation;
    *BlockTrace__STARTITEM(this) = Operation_issueItem(start_operation);
  }
  if (BlockTrace_isPipeline(this)) {
    // Append a LOOP pseudo-operation as the last operation.
    Label label = BasicBlock_makeLabel(headBlock);
    Selector tailSelector = BasicBlock_selector(tailBlock);
    Operation loop_operation = Selector_makeOperationLOOP(tailSelector, label);
    IssueItem loop_item = BlockTrace_makeIssueItem(this, loop_operation);
    Operation_setIndex(loop_operation, ++operationIndex);
    *BlockTrace__STOPITEM(this) = *BlockTrace__LASTITEM(this) = loop_item;
  } else
  if (BasicBlock_isExit(tailBlock)) {
    Operation stop_operation = last_operation;
    BasicBlock_FORBACK_Operation(tailBlock, operation) {
      if (Operation_isExitCode(operation)) stop_operation = operation;
      else break;
    } BasicBlock_ENDBACK_Operation;
    *BlockTrace__STOPITEM(this) = Operation_issueItem(stop_operation);
  }
  PFA_TRACE && (fprintf(PFA_TRACE, "FIRST:\t"),
      Operation_pretty(IssueItem_OPERATION(BlockTrace_FIRSTITEM(this)), PFA_TRACE));
  PFA_TRACE && (fprintf(PFA_TRACE, "START:\t"),
      Operation_pretty(IssueItem_OPERATION(BlockTrace_STARTITEM(this)), PFA_TRACE));
  PFA_TRACE && (fprintf(PFA_TRACE, "STOP:\t"),
      Operation_pretty(IssueItem_OPERATION(BlockTrace_STOPITEM(this)), PFA_TRACE));
  PFA_TRACE && (fprintf(PFA_TRACE, "LAST:\t"),
      Operation_pretty(IssueItem_OPERATION(BlockTrace_LASTITEM(this)), PFA_TRACE));
}

#line 925 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
void
BlockTrace_relaxConstraints(BlockTrace this)
{
  bool isPrePass = BlockTrace_isPrePass(this);
  int speculation = BlockTrace_SPECULATION(this);
  int compensation = BlockTrace_COMPENSATION(this);
  Optimize optimize = BlockTrace_OPTIMIZE(this);
  Processor processor = BlockTrace_PROCESSOR(this);
  Convention convention = Optimize_CONVENTION(optimize);
  Register stackRegister = Convention_stackRegister(convention);
  // Flag speculable and compensable Operation(s).
  BlockTrace_FOREACH_IssueItem(this, ITEM) {
    InstructionTask task = IssueItem_TASK(ITEM);
    Operation operation = IssueItem_OPERATION(ITEM);
    Operation_refreshFlags(operation, stackRegister);
    if (   Operation_maySpeculate(operation, processor, speculation)
        && (!isPrePass || !Operation_hasDedicatedResult(operation, false))) {
#if ECL_DEBUG
      if (DEBUG_SPECULABLE && DEBUG_SPECULABLE--)
#endif//ECL_DEBUG
      {
        *InstructionTask__FLAGS(task) |= InstructionFlag_Speculable;
        //PFA_TRACE && fprintf(PFA_TRACE, "*** Speculable")
                  //&& Operation_pretty(operation, PFA_TRACE);
      }
    }
    if (   Operation_mayCompensate(operation, processor, compensation)
        && (!isPrePass || !Operation_hasDedicatedArgument(operation, false))) {
#if ECL_DEBUG
      if (DEBUG_COMPENSABLE && DEBUG_COMPENSABLE--)
#endif//ECL_DEBUG
      {
        *InstructionTask__FLAGS(task) |= InstructionFlag_Compensable;
        //PFA_TRACE && fprintf(PFA_TRACE, "*** Compensable")
                  //&& Operation_pretty(operation, PFA_TRACE);
      }
    }
  } BlockTrace_ENDEACH_IssueItem;
  // Prepare boostable Operation(s).
  if (BlockTrace_isPrePass(this)) {
    BlockTrace_prepareBoosting(this);
  }
}

#line 975 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
void
BlockTrace_prepareBoosting(BlockTrace this)
{
  int goto_polarity = 0;
  Temporary goto_predicate = NULL;
  int boosting = BlockTrace_BOOSTING(this);
  Processor processor = BlockTrace_PROCESSOR(this);
  if (boosting <= ConfigureBoosting_None) return;
  // Identify the last control Operation before LOOP.
  if (BlockTrace_isPipeline(this)) {
    BlockTrace_FORBACK_IssueItem(this, ITEM) {
      Operation operation = IssueItem_OPERATION(ITEM);
      Operator operator = Operation_operator(operation);
      if (Operator_isLoop(operator)) continue;
      if (Operator_isControl(operator)) {
        goto_polarity = 0;
        goto_predicate = NULL;
        if (Operator_isGoTo(operator)) {
          goto_polarity = Operator_predicatePolarity(operator);
          goto_predicate = Operation_getPredicate(operation);
        }
        break;
      }
    } BlockTrace_ENDBACK_IssueItem;
  }
  // Process the boostable Operation(s).
  BlockTrace_FOREACH_IssueItem(this, ITEM) {
    Operation operation = IssueItem_OPERATION(ITEM);
    Operator operator = Operation_operator(operation);
    if (Operator_isControl(operator)) {
      goto_polarity = 0;
      goto_predicate = NULL;
      if (Operator_isGoTo(operator)) {
        goto_polarity = Operator_predicatePolarity(operator);
        goto_predicate = Operation_getPredicate(operation);
      }
    } else
    if (   !Operation_isSpeculable(operation)
        && !Operation_hasDedicatedResult(operation, false)) {
      if (   (   goto_polarity > 0
              && Operation_mayPredicateNegative(operation, processor))
          || (   goto_polarity < 0
              && Operation_mayPredicatePositive(operation, processor))) {
#if ECL_DEBUG
      if (DEBUG_BOOSTABLE && DEBUG_BOOSTABLE--)
#endif//ECL_DEBUG
        {
          Operation_predicate(operation, processor, goto_predicate, -goto_polarity);
          Operation_setBoosting(operation, 1);
          PFA_TRACE && fprintf(PFA_TRACE, "*** Boosting")
                    && Operation_pretty(operation, PFA_TRACE);
        }
      }
      if (   boosting >= ConfigureBoosting_Combine && false/*FIXME*/
          && Operation_mayUnpredicate(operation, processor)) {
#if ECL_DEBUG
      if (DEBUG_BOOSTABLE && DEBUG_BOOSTABLE--)
#endif//ECL_DEBUG
        {
          Operation_setBoosting(operation, 1);
          PFA_TRACE && fprintf(PFA_TRACE, "*** Boosting")
                    && Operation_pretty(operation, PFA_TRACE);
        }
      }
    }
  } BlockTrace_ENDEACH_IssueItem;
}

#line 1049 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
void
BlockTrace_buildEffects(BlockTrace this)
{
  Memory memory = BlockTrace_MEMORY(this);
  Procedure procedure = BlockTrace_PROCEDURE(this);
  CodeRegion codeRegion = BlockTrace_CODEREGION(this);
  Optimize optimize = CodeRegion_optimize(codeRegion);
  Convention convention = Optimize_CONVENTION(optimize);
  const_RegisterSet argumentSet = Convention_roleRegisterSet(convention,
                                                              ConventionRole_Argument);
  const_RegisterSet resultSet = Convention_roleRegisterSet(convention,
                                                            ConventionRole_Result);
  const_RegisterSet structSet = Convention_roleRegisterSet(convention,
                                                            ConventionRole_Struct);
  const_RegisterSet calleeSet = Convention_roleRegisterSet(convention,
                                                            ConventionRole_Callee);
  int32_t estimate = BlockTrace_ITEMCOUNT(this)*2;
  EffectTable effectTable = EffectTable_new(memory, procedure, estimate);
  Processor processor = BlockTrace_PROCESSOR(this);
  IssueItem firstItem = BlockTrace_FIRSTITEM(this);
  IssueItem lastItem = BlockTrace_LASTITEM(this);
  int speculation = BlockTrace_SPECULATION(this);
  PFA_TRACE && fprintf(PFA_TRACE, "*** BUILD EFFECTS\n");
  BlockTrace_FOREACH_IssueItem(this, ITEM) {
    Operation OPERATION = IssueItem_OPERATION(ITEM);
    if (BlockTrace_isInnerLoop(this) && ITEM == firstItem) {
      // In case of InnerLoop, do not consider the write effects of the
      // first operation which is a LABEL pseudo-operation.
    } else if (BlockTrace_isPipeline(this) && ITEM == lastItem) {
      // In case of Pipeline, do not consider the read effects of the last
      // operation, as it has been normalized into a LOOP pseudo-operation.
    } else {
      Operator OPERATOR = Operation_operator(OPERATION);
      BasicBlock basicBlock = Operation_basicBlock(OPERATION);
      // Enter OPERATION Effect(s) including side-Effect(s).
      EffectTable_enterOperation(effectTable, OPERATION, true);
      // Label indirect write effects.
      if (Operator_isLabel(OPERATOR)) {
        CFGNode cfgNode = BasicBlock_cfgNode(basicBlock);
        CFGNode prevNode = CFGNode_PREVNODE(cfgNode);
        CFGNode_FORENTER_CFGArc(cfgNode, cfgArc) {
          if (CFGArc_TAIL(cfgArc) != prevNode) {
            // HACK ALERT! We need the reaching defs along cfgArc.
            TemporarySet liveOnEntry = CFGNode_LIVEINSET(cfgNode);
            EffectTable_enterTemporarySetSideEffects(effectTable,
                OPERATION, liveOnEntry, EffectFlag_Indirect|EffectFlag_Write);
            break;
          }
        } CFGNode_ENDENTER_CFGArc;
      }
      // Branch indirect read effects.
      if (Operator_isBranch(OPERATOR)) {
        CFGNode cfgNode = BasicBlock_cfgNode(basicBlock);
        CFGNode nextNode = CFGNode_NEXTNODE(cfgNode);
        CFGNode_FORLEAVE_CFGArc(cfgNode, cfgArc) {
          CFGNode headNode = CFGArc_HEAD(cfgArc);
          if (headNode != nextNode &&
              CFGNode_basicBlock(headNode) != NULL) {
            // Compute the live on exit along cfgArc.
            TemporarySet liveInSet = CFGNode_LIVEINSET(headNode);
            TemporarySet liveOutSet = CFGNode_LIVEOUTSET(cfgNode);
            int32_t count = TemporarySet_count(liveOutSet);
            TemporarySet liveOnExit = TemporarySet_make(memory, count);
            TemporarySet_union(liveOnExit, liveOutSet);
            if (liveInSet != NULL) TemporarySet_inter(liveOnExit, liveInSet);
            else;	// HACK! Must be a new headNode created by the pipeliner.
            EffectTable_enterTemporarySetSideEffects(effectTable,
                OPERATION, liveOnExit, EffectFlag_Indirect);
            TemporarySet_kill(liveOnExit);
          }
        } CFGNode_ENDLEAVE_CFGArc;
        if (BasicBlock_isExit(basicBlock)) {
          // Non-local branch, assume it results from tail-call optimization.
          // Include Indirect read effects of Callee-saved registers in case of
          // non-interlocked registers.
          if (!Processor_interlocks(processor)) {
            EffectTable_enterRegisterSetSideEffects(effectTable, OPERATION,
                                                    argumentSet, EffectFlag_Indirect);
            EffectTable_enterRegisterSetSideEffects(effectTable, OPERATION,
                                                    structSet, EffectFlag_Indirect);
            EffectTable_enterRegisterSetSideEffects(effectTable, OPERATION,
                                                    calleeSet, EffectFlag_Indirect);
          }
        }
      }
      if (Operator_isRoutine(OPERATOR) || Operator_isReturn(OPERATOR)) {
        // Routine call and Return indirect read effects of Callee-saved registers.
        // Only include these indirect effects in case of non-interlocked registers.
        // For Routine call, the Argument and possibly Struct registers are already
        // in the call explicit effects so there is no need to include them.
        // FIXME! In postpass scheduling Argument+Struct should also be included!
        if (!Processor_interlocks(processor)) {
          EffectTable_enterRegisterSetSideEffects(effectTable, OPERATION,
                                                  calleeSet, EffectFlag_Indirect);
        }
      }
    }
  } BlockTrace_ENDEACH_IssueItem;
  *BlockTrace__EFFECTTABLE(this) = effectTable;
}

#line 1156 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
void
BlockTrace_buildLifetimes(BlockTrace this)
{
  PtrSet ddgNodes = BlockTrace_DDGNODES(this);
  Optimize optimize = BlockTrace_OPTIMIZE(this);
  Configure configure = BlockTrace_CONFIGURE(this);
  Processor processor = BlockTrace_PROCESSOR(this);
  EffectTable effectTable = BlockTrace_EFFECTTABLE(this);
  Memory memory = BlockTrace_MEMORY(this);
  LifetimeTable lifetimeTable = LifetimeTable_new(memory, optimize, configure);
  // Build the LifetimeTable.
  bool isPrePass = BlockTrace_isPrePass(this);
  bool isInnerLoop = BlockTrace_isInnerLoop(this);
  const_DependenceTable dependenceTable = BlockTrace_getDependenceTable(this);
  LifetimeTable_build(lifetimeTable, effectTable, isInnerLoop, isPrePass);
  LifetimeTable_linkEffects(lifetimeTable, ddgNodes);
  if (!PtrSet_isEmpty(ddgNodes)) {
    LifetimeTable_refineDependences(lifetimeTable, ddgNodes, dependenceTable);
  }
  *BlockTrace__LIFETIMETABLE(this) = lifetimeTable;
}

#line 1204 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
#if 0
void
BlockTrace_findInvariants(BlockTrace this)
{
  bool change = false;
  LifetimeTable lifetimeTable = BlockTrace_LIFETIMETABLE(this);
  TemporaryMap temporaryMap = LifetimeTable_TEMPORARYMAP(lifetimeTable);
  Except_REQUIRE(BlockTrace_isInnerLoop(this));
  do {
    change = false;
    BlockTrace_FOREACH_IssueItem(this, ITEM) {
      Operation operation = IssueItem_OPERATION(ITEM);
      if (!IssueItem_isInvariant(ITEM) && !IssueItem_isCritical(ITEM)) {
        IssueItemFlag invariant = IssueItemFlag_Invariant;
        Operation_ARGUMENTS_FOREACH_Temporary(operation, temporary) {
          if (Temporary_hasRegFile(temporary) && !Temporary_isConstant(temporary)) {
            // Only the register arguments that are not wired may prevent loop invariance.
            Lifetime *_lifetime = (Lifetime *)TemporaryMap_access(temporaryMap, temporary);
            Lifetime lifetime = Lifetime_findReachingLifetime(*_lifetime, operation,
                                                              Operation_ARGUMENTS_INDEX);
            if (Lifetime_isOnlyUses(lifetime)) {
              // Defined outside the loop.
            } else if (Lifetime_isWriteOnce(lifetime) && Lifetime_isReadAfter(lifetime)) {
              // Single reaching definition, with all uses after the definition.
              Effect write_effect = Lifetime_firstEffect(lifetime);
              Operation write_operation = Effect_OPERATION(write_effect);
              if (!IssueItem_isInvariant(Operation_issueItem(write_operation))) {
                // The single reaching definition is not invariant.
                invariant = 0;
                break;
              }
            } else {
              // Has multiple reaching definitions, or has a use before the definition.
              invariant = 0;
              break;
            }
          }
        } Operation_ARGUMENTS_ENDEACH_Temporary;
        if (invariant != 0) {
          *IssueItem__FLAGS(ITEM) |= invariant;
          change = true;
        }
      }
    } BlockTrace_ENDEACH_IssueItem;
  } while (change);
}
#endif

#line 1260 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
int
BlockTrace_computeKunroll(BlockTrace this, int lambda)
{
  bool isAcyclic = BlockTrace_isAcyclic(this);
  Procedure procedure = BlockTrace_PROCEDURE(this);
  LifetimeTable lifetimeTable = BlockTrace_LIFETIMETABLE(this);
  int maxSpan = LifetimeTable_computeMaxSpan(lifetimeTable, lambda, isAcyclic);
  *BlockTrace__KUNROLL(this) = 0;
  if (BlockTrace_isPipeline(this)) {
    // Case of software pipelining.
    int factor = BlockTrace_FACTOR(this);
    int16_t kunroll = (maxSpan + lambda - 1)/lambda;
    if (kunroll <= 0) kunroll = 1;
    if (kunroll < FORCE_KUNROLL) kunroll = FORCE_KUNROLL;
    PFA_TRACE && fprintf(PFA_TRACE,
        "*** PREPARE:\tmaxSpan=%d\tlambda=%d\tkunroll=%d\n",
        maxSpan, lambda, kunroll);
    if (factor > 1) {
      // Counted hardware loop: adjust kunroll.
      Except_CHECK(kunroll > 0 && kunroll <= factor);
      // Find the smallest divisor of factor not lower than kunroll.
      while (factor >> 1 >= kunroll) factor >>= 1;
      *BlockTrace__FACTOR(this) = kunroll = factor;
      PFA_TRACE && fprintf(PFA_TRACE, "*** ADJUST:\tkunroll=%d\n", kunroll);
    }
    if (kunroll > 0) {
      LifetimeTable_fillRenaming(lifetimeTable, procedure, lambda, kunroll);
    }
    *BlockTrace__KUNROLL(this) = kunroll;
  }
  return BlockTrace_KUNROLL(this);
} 

#line 1293 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1312 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
RegionFlowCover
RegionFlowCover_Ctor(RegionFlowCover this,
                     Memory memory, RegionFlow regionFlow,
                     OptimizeRegionType regionType, BlockTraceFlags traceFlags)
{
  *RegionFlowCover__REGIONFLOW(this) = regionFlow;
  *RegionFlowCover__REGIONTYPE(this) = regionType;
  *RegionFlowCover__TRACEFLAGS(this) = traceFlags;
  IDList_Ctor(RegionFlowCover_BLOCKTRACES(this), memory);
  {
    OptimizeRegionType acyclic_type = regionType & ~OptimizeRegionType_InnerLoop;
    Hierarchy hierarchy = RegionFlow_makeHierarchy(regionFlow);
    HierarchyComponent root = Hierarchy_root(hierarchy);
    CodeRegion_resetTraceCounter(RegionFlow_codeRegion(regionFlow));
    RegionFlowCover_processHierarchyComponent(this, root, regionType, traceFlags);
    // Sort the BlockTrace(s) with inner later loops first.
    IDList_sort(RegionFlowCover_BLOCKTRACES(this), BlockTrace_compare);
  }
  return this;
}

#line 1334 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
void
RegionFlowCover_Dtor(RegionFlowCover this)
{
  IDList_empty(RegionFlowCover_BLOCKTRACES(this),
               (IDListItemRelease)BlockTrace_Dtor);
  IDList_Dtor(RegionFlowCover_BLOCKTRACES(this));
}

#line 1342 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
size_t
RegionFlowCover_Size(Memory memory, RegionFlow regionFlow,
                     OptimizeRegionType regionType, BlockTraceFlags traceFlags) {
	return sizeof(RegionFlowCover_);
}

#line 1354 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
void
RegionFlowCover_processNode(RegionFlowCover this, OptimizeRegionType regionType,
                             BlockTraceFlags traceFlags, CFGNode cfgNode,
                             LoopScope loopScope)
{
  Memory memory = RegionFlowCover_MEMORY(this);
  IDList blockTraces = RegionFlowCover_BLOCKTRACES(this);
  RegionFlow regionFlow = RegionFlowCover_REGIONFLOW(this);
  float superGrow = (float)FORCE_SUPERGROW;
  if (CFGNode_isGrow(cfgNode)) {
    CFGNode curr_node = cfgNode;
    float curr_probability = 1.0;
    size_t size = BlockTraceSize(memory, regionType, traceFlags);
    BlockTrace blockTrace = IDList_push(blockTraces, size);
    EntryCode(blockTrace, memory, regionType, traceFlags);
    PFA_TRACE && fprintf(PFA_TRACE, "*** BLOCKTRACE:\tStart(%s)",
                         regionType&OptimizeRegionType_InnerLoop? "inner":"");
    do {
      bool growOK = BlockTraceGrow(blockTrace, curr_node);
      *CFGNode__FLAGS(curr_node) &= ~CFGNodeFlag_Grow;
      PFA_TRACE && fprintf(PFA_TRACE, "Grow(_%d)", CFGNode_INDEX(curr_node));
      if (!CFGNode_isStop(curr_node)) {
        BasicBlock curr_block = CFGNode_basicBlock(curr_node);
        CFGNode_FORLEAVE_CFGArc(curr_node, arc) {
          float probability = CFGArc_PROBABILITY(arc);
          float head_probability = curr_probability*probability;
          CFGNode head_node = CFGArc_HEAD(arc);
          BasicBlock head_block = CFGNode_basicBlock(head_node);
          if (CFGNode_isGrow(head_node) && !CFGNode_isStart(head_node) &&
              BasicBlock_regionId(head_block) == BasicBlock_regionId(curr_block) &&
              BasicBlock_loopScope(head_block) == BasicBlock_loopScope(curr_block) &&
              BasicBlock_index(head_block) == BasicBlock_index(curr_block) + 1 &&
              (probability*superGrow >= 1.0 || CFGNode_isStop(head_node)) &&
              CFGNode_isOnlyPredecessor(head_node, curr_node)) {
            curr_probability = head_probability;
            curr_node = head_node;
            break;
          }
        } CFGNode_ENDLEAVE_CFGArc;
      }
    } while (CFGNode_isGrow(curr_node));
    BlockTraceStop(blockTrace, regionFlow, loopScope);
    PFA_TRACE && fprintf(PFA_TRACE, "Stop\n");
  }
}

#line 1407 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
void
RegionFlowCover_processHierarchyComponent(RegionFlowCover this,
                                          HierarchyComponent component,
                                          OptimizeRegionType regionType,
                                          BlockTraceFlags traceFlags)
{
  RegionFlow regionFlow = RegionFlowCover_REGIONFLOW(this);
  Procedure procedure = RegionFlow_procedure(regionFlow);
  OptimizeRegionType acyclic_type = regionType & ~OptimizeRegionType_InnerLoop;
  HierarchyComponentType type = HierarchyComponent_type(component);
  BasicBlock headerBlock = NULL;
  LoopScope loopScope = NULL;
  CFGNode cfgNode = HierarchyComponent_node(component);
  // Access the HierarchyComponent LoopScope.
  if (cfgNode != NULL && type != HierarchyComponentType_Node) {
    headerBlock = CFGNode_basicBlock(cfgNode);
  }
  loopScope = Procedure_findLoopScope(procedure, headerBlock);
  // Adjust the regionType in case of inner loop.
  if (LoopScope_isInner(loopScope) > 0) {
    regionType |= OptimizeRegionType_InnerLoop;
  }
  // Traversal of component: prepare BasicBlock and CFGNode flags.
  HierarchyComponent_CHILDREN_FOREACH_HierarchyComponent(component, child) {
    if (HierarchyComponent_type(child) == HierarchyComponentType_Node) {
      CFGNode cfgNode = HierarchyComponent_node(child);
      RegionFlowCover_processNode(this, regionType, traceFlags, cfgNode, loopScope);
    } else {
      RegionFlowCover_processHierarchyComponent(this, child, regionType, traceFlags);
    }
  } HierarchyComponent_CHILDREN_ENDEACH_HierarchyComponent;
}

#line 1450 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
#ifndef RegionFlowCover_POOLED
#define RegionFlowCover_POOLED 128
#endif//RegionFlowCover_POOLED

#line 1454 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
RegionFlowCover
RegionFlowCover_new(Memory parent, RegionFlow regionFlow,
                    OptimizeRegionType regionType, BlockTraceFlags traceFlags)
{
  Memory memory = Memory_new(parent, RegionFlowCover_POOLED);
  size_t size = RegionFlowCover_Size(memory, regionFlow, regionType, traceFlags);
  RegionFlowCover this = Memory_alloc(memory, size);
  return RegionFlowCover_Ctor(this, memory, regionFlow, regionType, traceFlags);
}

#line 1468 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
RegionFlowCover
RegionFlowCover_delete(RegionFlowCover this)
{
  if (this != NULL) {
    Memory memory = RegionFlowCover_MEMORY(this);
#ifndef PRO_NDTOR
    RegionFlowCover_Dtor(this);
    Memory_free_(memory, this);
#endif//PRO_NDTOR
    Memory_delete(memory);
  }
  return NULL;
}

#line 1488 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
IDList
RegionFlowCover_blockTraces(RegionFlowCover this)
{
  return RegionFlowCover_BLOCKTRACES(this);
}

#line 1502 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1514 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
#if XCC__C
void
BlockTrace_TEST(void)
{
#include "XFA/BlockTrace_.c"
}

#line 1521 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/BlockTrace.xcc"
int
main(int argc, char **argv)
{
  XFA_Test(BlockTrace_TEST);
  return 0;
}
#endif


#endif//BlockTrace_c_INCLUDED
