#ifndef CFGraph_c_INCLUDED
#define CFGraph_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
#include "XFA/XFA_.h"

#line 21 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 56 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
CFGArc
CFGArc_Ctor(CFGArc this, float probability, CFGArcFlags flags)
{
  *CFGArc__PROBABILITY(this) = probability;
  *CFGArc__ARGINDEX(this) = -1;
  *CFGArc__RESINDEX(this) = -1;
  *CFGArc__ELAPSED(this) = -1;
  *CFGArc__FLAGS(this) = flags;
  return this;
}

#line 67 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
size_t
CFGArc_Size(float probability, CFGArcFlags flags)
{
  return sizeof(CFGArc_);
}

#line 156 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 187 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
CFGNode
CFGNode_Ctor(CFGNode this,
             Memory memory, BasicBlock basicBlock)
{
  *CFGNode__BASICBLOCK(this) = basicBlock;
  *CFGNode__PREVNODE(this) = NULL;
  *CFGNode__NEXTNODE(this) = NULL;
  *CFGNode__NUMBERING(this) = 0;
  *CFGNode__FLAGS(this) = 0;
  return this;
}

#line 199 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
size_t
CFGNode_Size(Memory memory, BasicBlock basicBlock)
{
  return sizeof(CFGNode_);
}

#line 318 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 326 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
bool
CFGNode_check(const_CFGNode this)
{
  int leaveCount = 0;
  CFGNode prev_head = NULL;
  float probability = 0.0;
  CFGNode_FORLEAVE_CFGArc(this, arc) {
    CFGNode head = CFGArc_HEAD(arc);
    probability += CFGArc_PROBABILITY(arc);
    //FIXME! Except_ALWAYS(probability <= 1.001);
    Except_ALWAYS(probability >= 0);
    if (++leaveCount > 2) continue;
    Except_ALWAYS(head != prev_head);
    prev_head = head;
  } CFGNode_ENDLEAVE_CFGArc;
  return true;
}

#line 350 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
#ifndef ECL_NTRACE
bool
CFGNode_pretty(CFGNode this, FILE *file)
{
  if (file == NULL) file = stderr;
  fprintf(file, "_%d", CFGNode_INDEX(this));
  fprintf(file, "\n\tpredecessors:\t");
  CFGNode_FORENTER_CFGArc(this, arc) {
    CFGNode tail_node = CFGArc_TAIL(arc);
    if (tail_node != NULL) {
      BasicBlock tail_block = CFGNode_basicBlock(tail_node);
      if (tail_block != NULL) {
        fprintf(file, "%d:Block_%d(%d)\t",
            BasicBlock_identity(tail_block), CFGNode_INDEX(tail_node),
            CFGArc_ELAPSED(arc));
      } else {
        fprintf(file, "node_%d\t", CFGNode_INDEX(tail_node));
      }
    } else {
      fprintf(file, "(NULL)\t");
    }
  } CFGNode_ENDENTER_CFGArc;
  fprintf(file, "\n\tsuccessors:\t");
  CFGNode_FORLEAVE_CFGArc(this, arc) {
    CFGNode head_node = CFGArc_HEAD(arc);
    if (head_node != NULL) {
      BasicBlock head_block = CFGNode_basicBlock(head_node);
      if (head_block != NULL) {
        fprintf(file, "%d:Block_%d(%2.0f%%)\t",
            BasicBlock_identity(head_block), CFGNode_INDEX(head_node),
            100.0*CFGArc_PROBABILITY(arc));
      } else {
        fprintf(file, "node_%d(%2.0f%%)\t",
            CFGNode_INDEX(head_node), 100.0*CFGArc_PROBABILITY(arc));
      }
    } else {
      fprintf(file, "(NULL)(%2.0f%%)\t", 100.0*CFGArc_PROBABILITY(arc));
    }
  } CFGNode_ENDLEAVE_CFGArc;
  fprintf(file, "\n");
  return true;
}
#endif//ECL_NTRACE

#line 394 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 402 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
bool
CFGNode_isPredecessor(CFGNode this, CFGNode that)
{
  CFGNode_FORENTER_CFGArc(this, arc) {
    if (CFGArc_TAIL(arc) == that) return true;
  } CFGNode_ENDENTER_CFGArc;
  return false;
}

#line 417 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
bool
CFGNode_isSuccessor(CFGNode this, CFGNode that)
{
  CFGNode_FORLEAVE_CFGArc(this, arc) {
    if (CFGArc_HEAD(arc) == that) return true;
  } CFGNode_ENDLEAVE_CFGArc;
  return false;
}

#line 432 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
bool
CFGNode_hasSuccessor(CFGNode this, CFGNode that)
{
  CFGNode_FORENTER_CFGArc(this, arc) {
    if (CFGArc_TAIL(arc) == that) return true;
  } CFGNode_ENDENTER_CFGArc;
  return false;
}

#line 447 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
CFGNode
CFGNode_getOnlyPredecessor(CFGNode this)
{
  int enterCount = 0;
  CFGNode that = NULL;
  CFGNode_FORENTER_CFGArc(this, arc) {
    that = CFGArc_TAIL(arc);
    if (++enterCount > 1) return NULL;
  } CFGNode_ENDENTER_CFGArc;
  return that;
}

#line 471 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
CFGNode
CFGNode_getOnlySuccessor(CFGNode this)
{
  int leaveCount = 0;
  CFGNode that = NULL;
  CFGNode_FORLEAVE_CFGArc(this, arc) {
    that = CFGArc_HEAD(arc);
    if (++leaveCount > 1) return NULL;
  } CFGNode_ENDLEAVE_CFGArc;
  return that;
}

#line 496 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
CFGArc
CFGNode_getCFGArc(CFGNode this, CFGNode that, int position)
{
  CFGNode_FORLEAVE_CFGArc(this, arc) {
    if (CFGArc_HEAD(arc) == that && position-- == 0) return arc;
  } CFGNode_ENDLEAVE_CFGArc;
  return NULL;
}

#line 511 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
Operation
CFGNode_getGoToOperation(CFGNode this)
{
  BasicBlock basicBlock = CFGNode_basicBlock(this);
  Operation last_operation = BasicBlock_lastOperation(basicBlock);
  if (last_operation != NULL && Operation_isGoTo(last_operation)) return last_operation;
  return NULL;
}

#line 532 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
bool
CFGNode_invertGoToOperation(CFGNode this)
{
  BasicBlock basicBlock = CFGNode_basicBlock(this);
  Procedure procedure = BasicBlock_procedure(basicBlock);
  Processor processor = BasicBlock_processor(basicBlock);
  Operation goto_operation = CFGNode_getGoToOperation(this);
  if (goto_operation != NULL) {
    if (Operation_isConditional(goto_operation)) {
      CFGArc fall_arc = CFGNode_getFallArc(this);
      CFGNode fall_node = CFGArc_HEAD(fall_arc);
      BasicBlock fall_block = CFGNode_basicBlock(fall_node);
      Label label = BasicBlock_makeLabel(fall_block);
      Procedure_updateTargetedOperation(procedure, goto_operation, label);
      Operation_invertGoTo(goto_operation, processor);
      CFGNode_FORLEAVE_CFGArc(this, arc) {
        *CFGArc__FLAGS(arc) ^= CFGArcFlag_Fall;
      } CFGNode_ENDLEAVE_CFGArc
      return true;
    }
  }
  return false;
}

#line 562 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
bool
CFGNode_discardGoToOperation(CFGNode this)
{
  BasicBlock basicBlock = CFGNode_basicBlock(this);
  Operation last_operation = BasicBlock_lastOperation(basicBlock);
  if (last_operation != NULL && Operation_isGoTo(last_operation)) {
    Except_CHECK(!Operation_isConditional(last_operation));
    BasicBlock_detachOperation(basicBlock, last_operation);
    CFGNode_FORLEAVE_CFGArc(this, arc) {
      *CFGArc__FLAGS(arc) |= CFGArcFlag_Fall;
    } CFGNode_ENDLEAVE_CFGArc;
    return true;
  }
  return false;
}

#line 585 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
int
CFGNode_compare(CFGNode this, CFGNode that) {
  uint32_t this_index = CFGNode_INDEX(this);
  uint32_t that_index = CFGNode_INDEX(that);
  return (this_index > that_index) - (this_index < that_index);
}

#line 598 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
CFGArc
CFGNode_getTargetArc(CFGNode this)
{
  BasicBlock basicBlock = CFGNode_basicBlock(this);
  Operation operation = BasicBlock_lastOperation(basicBlock);
  if (operation != NULL) {
    Label label = Operation_getTargetLabel(operation);
    if (label != NULL) {
      CFGNode_FORLEAVE_CFGArc(this, arc) {
        CFGNode head_node = CFGArc_HEAD(arc);
        BasicBlock head_block = CFGNode_basicBlock(head_node);
        if (BasicBlock_hasLabel(head_block, label)) return arc;
      } CFGNode_ENDLEAVE_CFGArc;
    }
  }
  return NULL;
}

#line 624 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
CFGArc
CFGNode_getFallArc(const_CFGNode this)
{
  int leaveCount = 0;
  CFGNode_FORLEAVE_CFGArc(this, arc) {
    if (CFGArc_isFall(arc)) return arc;
    if (++leaveCount > 2) return NULL;
  } CFGNode_ENDLEAVE_CFGArc;
  return NULL;
}

#line 635 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 647 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
CFGNodeSet
CFGNodeSet_Ctor(CFGNodeSet this,
                Memory memory, int32_t estimate)
{
  PtrSet_Ctor(CFGNodeSet_PTRSET(this), memory, estimate);
  return this;
}

#line 655 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
void
CFGNodeSet_Dtor(CFGNodeSet this)
{
  PtrSet_Dtor(CFGNodeSet_PTRSET(this));
}

#line 661 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
size_t
CFGNodeSet_Size(Memory memory, int32_t estimate)
{
  return sizeof(CFGNodeSet_);
}

#line 724 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 746 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
CFGraph
CFGraph_Ctor(CFGraph this,
             Memory memory, int32_t maxNodes)
{
  DGraph_Ctor(CFGraph_DGRAPH(this), memory, maxNodes);
  CFGraph_makeNode(this, NULL);
  *CFGraph__SINKNODE(this) = NULL;
  return this;
}

#line 756 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
void
CFGraph_Dtor(CFGraph this)
{
  DGraph_Dtor(CFGraph_DGRAPH(this));
}

#line 762 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
size_t
CFGraph_Size(Memory memory, int32_t maxNodes)
{
  return sizeof(CFGraph_);
}

#line 777 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
#ifndef CFGraph_POOLED
#define CFGraph_POOLED 128
#endif//CFGraph_POOLED

#line 781 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
CFGraph
CFGraph_new(Memory parent, int32_t maxNodes)
{
  Memory memory = Memory_new(parent, CFGraph_POOLED);
  size_t size = CFGraph_Size(memory, maxNodes);
  CFGraph this = Memory_alloc(memory, size);
  return CFGraph_Ctor(this, memory, maxNodes);
}

#line 794 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
CFGraph
CFGraph_delete(CFGraph this)
{
  if (this != NULL) {
    Memory memory = CFGraph_MEMORY(this);
#ifndef PRO_NDTOR
    CFGraph_Dtor(this);
    Memory_free_(memory, this);
#endif//PRO_NDTOR
    Memory_delete(memory);
  }
  return NULL;
}

#line 861 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
CFGArc
CFGraph_makeArc(CFGraph this, CFGNode tail_node, CFGNode head_node,
                float probability, CFGArcFlags flags)
{
  size_t size = CFGArc_Size(probability, flags);
  CFGArc arc = DGraph_makeArc(CFGraph_DGRAPH(this), tail_node, head_node, size);
  Except_REQUIRE(probability >= 0.0 && probability <= 1.0);
  CFGArc_Ctor(arc, probability, flags);
  Except_CHECK(CFGNode_check(tail_node));
  return arc;
}

#line 879 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
CFGNode
CFGraph_makeNode(CFGraph this, BasicBlock basicBlock)
{
  Memory memory = CFGraph_MEMORY(this);
  size_t size = CFGNode_Size(memory, basicBlock);
  CFGNode node = DGraph_makeNode(CFGraph_DGRAPH(this), size);
  CFGNode_Ctor(node, memory, basicBlock);
  if (basicBlock != NULL) BasicBlock_setCFGNode(basicBlock, node);
  return node;
}

#line 896 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
CFGNode
CFGraph_complete(CFGraph this)
{
  CFGArcFlags flags = 0;
  CFGNode rootNode = CFGraph_ROOTNODE(this);
  CFGNode sinkNode = CFGraph_makeNode(this, NULL);
  CFGraph_FOREACH_CFGNode(this, cfgNode) {
    if (cfgNode != rootNode && cfgNode != sinkNode) {
      if (!DGraphNode_ENTERARC(cfgNode)) {
        CFGraph_makeArc(this, rootNode, cfgNode, 0.0, flags);
      }
      if (!DGraphNode_LEAVEARC(cfgNode)) {
        CFGraph_makeArc(this, cfgNode, sinkNode, 0.0, flags);
      }
    }
  } CFGraph_ENDEACH_CFGNode;
  *CFGraph__SINKNODE(this) = sinkNode;
  return sinkNode;
}

#line 926 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
CFGraph
CFGraph_sortLeaveArcs(CFGraph this)
{
  CFGraph_FOREACH_CFGNode(this, node) {
    CFGArc arc_1 = DGraphNode_LEAVEARC(node);
    if (arc_1 != NULL) {
      CFGArc arc_2 = DGraphArc_LEAVEARC(arc_1);
      if (arc_2 != NULL) {
        CFGArc arc_3 = DGraphArc_LEAVEARC(arc_2);
        if (arc_3 == NULL) {
          // For non-negative 32-bit IEEE, integer compare works.
          int32_t probability_1 = *(int32_t *)CFGArc__PROBABILITY(arc_1);
          int32_t probability_2 = *(int32_t *)CFGArc__PROBABILITY(arc_2);
          if (probability_1 < probability_2) {
            *DGraphNode__LEAVEARC(node) = arc_2;
            *DGraphArc__LEAVEARC(arc_2) = arc_1;
            *DGraphArc__LEAVEARC(arc_1) = NULL;
          }
        }
      }
    }
  } CFGraph_ENDEACH_CFGNode;
  return this;
}

#line 957 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
#ifndef ECL_NTRACE
bool
CFGraph_prettyVCG(CFGraph this, FILE *file, const char *name)
{
  if (file == NULL) file = stderr;
  //
  fprintf(file, "graph: {\n");
  fprintf(file, "title: \"%s\"\n", name);
  fprintf(file, "shape: box\n");
  fprintf(file, "color: white\n");
  // Dump all the nodes
  CFGraph_FOREACH_CFGNode(this, node) {
    BasicBlock block = CFGNode_BASICBLOCK(node);
    fprintf(file, "node: { title: \"%d\" label: \"BB%d\n ",
            CFGNode_INDEX(node),CFGNode_INDEX(node));
    if (block != NULL) {
      // Dump all the instructions into the block
      BasicBlock_pretty(block, file);
    }
    fprintf(file, "\"}\n");
    // Now dump all the outgoing edges
    CFGNode_FORLEAVE_CFGArc(node, arc) {
      if (CFGArc_isFall(arc)) {
        fprintf(file, "edge: { sourcename: \"%d\" targetname: \"%d\" color: blue}\n",
                CFGNode_INDEX(CFGArc_TAIL(arc)),CFGNode_INDEX(CFGArc_HEAD(arc)));
      }
      else {
         fprintf(file, "edge: { sourcename: \"%d\" targetname: \"%d\" }\n",
                CFGNode_INDEX(CFGArc_TAIL(arc)),CFGNode_INDEX(CFGArc_HEAD(arc)));
      }
    } CFGNode_ENDLEAVE_CFGArc;
  } CFGraph_ENDEACH_CFGNode;
  fprintf(file, "}\n");
  return true;
}
#endif//ECL_NTRACE

#line 995 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1007 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
#if XCC__C
static void
CFGraph_TEST(void)
{
#include "XFA/CFGraph_.c"
}

#line 1014 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/CFGraph.xcc"
int
main(int argc, char **argv)
{
  XFA_Test(CFGraph_TEST);
  return 0;
}
#endif


#endif//CFGraph_c_INCLUDED
