#ifndef Issue_c_INCLUDED
#define Issue_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
#include "XFA/XFA_.h"

#line 21 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 74 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
IssueItem
IssueItem_Ctor(IssueItem this,
               Operation operation, Instance instance)
{
  Scheduling scheduling = Instance_scheduling(instance);
  Reservation reservation = Scheduling_reservation(scheduling);
  const_ReservationTable table = Reservation_table(reservation);
  Operation_setTask(operation, IssueItem_TASK(this));
  InstructionTask_Ctor(IssueItem_TASK(this), instance);
  *InstructionTask__INDEXED(IssueItem_TASK(this)) = (Indexed)operation;
  *InstructionTask__STARTDATE(IssueItem_TASK(this)) = INT16_MAX;
  *IssueItem__TABLE(this) = Reservation_table(reservation);
  *IssueItem__SCHEDULING(this) = scheduling;
  *IssueItem__CONTROLID(this) = -1;
  IssueItem_DDGNODES(this)[0] = NULL;
  IssueItem_DDGNODES(this)[1] = NULL;
  IssueItem_DDGNODES(this)[2] = NULL;
  *IssueItem__EXITARC(this) = NULL;
  *IssueItem__FALLARC(this) = NULL;
  return this;
}

#line 96 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
void
IssueItem_Dtor(IssueItem this)
{
}

#line 101 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
size_t
IssueItem_Size(Operation operation, Instance instance)
{
  return sizeof(IssueItem_);
}

#line 118 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
#ifndef ECL_NTRACE
bool
IssueItem_pretty(IssueItem this, FILE *file)
{
  Operation operation = IssueItem_OPERATION(this);
  struct CFGArc_ *exitArc = IssueItem_EXITARC(this);
  struct CFGArc_ *fallArc = IssueItem_FALLARC(this);
  BasicBlock basicBlock = Operation_basicBlock(operation);
  if (file == NULL) file = stderr;
  if (basicBlock != NULL) {
    DGraphNode node = (DGraphNode)BasicBlock_CFGNODE(basicBlock);
    fprintf(file, "%d:Block_%d",
        BasicBlock_identity(basicBlock), DGraphNode_INDEX(node));
  } else fprintf(file, "\t");
  if (exitArc != NULL) {
    DGraphNode tail_node = DGraphArc_TAILNODE(exitArc);
    DGraphNode head_node = DGraphArc_HEADNODE(exitArc);
    fprintf(file, "\texit(_%d, _%d)",
        tail_node ==  NULL? -1: DGraphNode_INDEX(tail_node),
        head_node ==  NULL? -1: DGraphNode_INDEX(head_node));
  } else fprintf(file, "\t\t");
  if (fallArc != NULL) {
    DGraphNode tail_node = DGraphArc_TAILNODE(fallArc);
    DGraphNode head_node = DGraphArc_HEADNODE(fallArc);
    fprintf(file, "\tfall(_%d, _%d)",
        tail_node ==  NULL? -1: DGraphNode_INDEX(tail_node),
        head_node ==  NULL? -1: DGraphNode_INDEX(head_node));
  } else fprintf(file, "\t\t");
#if 0
  if (IssueItem_isInvariant(this)) {
    fprintf(file, "(invar)");
  }
#endif
  Operation_pretty(operation, file);
  return true;
}
#endif//ECL_NTRACE

#line 156 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 177 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
IssueGroup
IssueGroup_Ctor(IssueGroup this,
                const uint8_t *availability)
{
  int resource;
#if Bundle_ISSUE_MAX
  IssueGroup_ITEMS(this)[0] = NULL;
#endif//Bundle_ISSUE_MAX
  *IssueGroup__AVAILABILITY(this) = availability;
  *IssueGroup__ITEMCOUNT(this) = 0;
  for (resource = 0; resource < Resource__COUNT; resource++) {
    IssueGroup_COUNTERS(this)[resource] = 0;
  }
  return this;
}

#line 193 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
IssueGroup
IssueGroup_Copy(IssueGroup this, const_IssueGroup that)
{
  *(this) = *(that);
  return this;
}

#line 200 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
void
IssueGroup_Dtor(IssueGroup this)
{
}

#line 205 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
size_t
IssueGroup_Size(const uint8_t *availability)
{
  return sizeof(IssueGroup_);
}

#line 263 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
#ifndef ECL_NTRACE
bool
IssueGroup_pretty(IssueGroup this, FILE *file)
{
  if (file == NULL) file = stderr;
  IssueGroup_FOREACH_IssueItem(this, item) {
    int32_t index = IssueItem_INDEX(item);
    Scheduling scheduling = IssueItem_SCHEDULING(item);
    fprintf(file, "\t%s_%d", Scheduling_name(scheduling), index);
  } IssueGroup_ENDEACH_IssueItem;
  return true;
}
#endif//ECL_NTRACE

#line 283 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
bool
IssueGroup_check(IssueGroup this)
{
  const uint8_t *availability = IssueGroup_AVAILABILITY(this);
  uint8_t *counters = IssueGroup_COUNTERS(this);
  IssueItem *items = IssueGroup_ITEMS(this);
  int itemCount = IssueGroup_ITEMCOUNT(this), i;
  uint8_t *check_counters = alloca(sizeof(uint8_t)*Resource__COUNT);
  Except_ALWAYS(itemCount <= Bundle_ISSUE_MAX);
  IssueGroup_FOREACH_Resource(this, resource) {
    Except_ALWAYS(counters[resource] <= availability[resource]);
    check_counters[resource] = 0;
  } IssueGroup_ENDEACH_Resource;
  for (i = 0; i < itemCount - 1; i++) {
    Scheduling scheduling_i = IssueItem_SCHEDULING(items[i]);
    Scheduling scheduling_j = IssueItem_SCHEDULING(items[i + 1]);
    Except_ALWAYS(scheduling_i <= scheduling_j);
  }
  for (i = 0; i < itemCount; i++) {
    const uint8_t *requirements = IssueItem_REQUIREMENTS(items[i]);
    IssueGroup_FOREACH_Resource(this, resource) {
      check_counters[resource] += requirements[resource];
    } IssueGroup_ENDEACH_Resource;
  }
  IssueGroup_FOREACH_Resource(this, resource) {
    Except_ALWAYS(check_counters[resource] == counters[resource]);
  } IssueGroup_ENDEACH_Resource;
  return true;
}

#line 329 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
IssueItem
IssueGroup_conflict(IssueGroup this, IssueItem item)
{
  const uint8_t *requirements = IssueItem_REQUIREMENTS(item);
  const uint8_t *this_availability = IssueGroup_AVAILABILITY(this);
  uint8_t *this_counters = IssueGroup_COUNTERS(this);
  IssueItem *this_items = IssueGroup_ITEMS(this);
  int itemCount = IssueGroup_ITEMCOUNT(this);
  Except_REQUIRE(IssueItem_SCHEDULING(item) != Scheduling__UNDEF);
  // Check this IssueGroup_COUNTERS.
  IssueGroup_FOREACH_Resource(this, resource) {
    int available = this_availability[resource];
    int counter = requirements[resource], i;
    if (this_counters[resource] + counter > available) {
      for (i = 0; i < itemCount; i++) {
        IssueItem this_item = this_items[i];
        const uint8_t *this_requirements = IssueItem_REQUIREMENTS(this_item);
        if (this_requirements[resource] + counter > available) return this_item;
      }
    }
  } IssueGroup_ENDEACH_Resource;
  Except_CHECK(itemCount > 0);
  return this_items[0];
}

#line 360 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
bool
IssueGroup_accept(IssueGroup this, IssueItem item)
{
  Scheduling scheduling = IssueItem_SCHEDULING(item);
  const uint8_t *requirements = IssueItem_REQUIREMENTS(item);
  const uint8_t *this_availability = IssueGroup_AVAILABILITY(this);
  uint8_t *this_counters = IssueGroup_COUNTERS(this);
  Except_REQUIRE(scheduling != Scheduling__UNDEF);
  // Check this IssueGroup_COUNTERS.
  IssueGroup_FOREACH_Resource(this, resource) {
    int available = this_availability[resource];
    int counter = requirements[resource];
    if (this_counters[resource] + counter > available) return false;
  } IssueGroup_ENDEACH_Resource;
  if (0) {
    IssueItem *this_items = IssueGroup_ITEMS(this);
    int itemCount = IssueGroup_ITEMCOUNT(this), i, j;
    Scheduling schedulings[Bundle_ISSUE_MAX + 1];
    // Fill the schedulings array in non-decreasing scheduling order.
    for (i = 0; i < itemCount; i++) {
      if (IssueItem_SCHEDULING(this_items[i]) >= scheduling) break;
      schedulings[i] = IssueItem_SCHEDULING(this_items[i]);
    }
    schedulings[i] = scheduling;
    for (j = itemCount; j > i; j--) {
      schedulings[j] = IssueItem_SCHEDULING(this_items[j - 1]);
    }
    schedulings[itemCount + 1] = Scheduling__UNDEF;
  }
  return true;
}

#line 398 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
void
IssueGroup_insert(IssueGroup this, IssueItem item)
{
  Scheduling scheduling = IssueItem_SCHEDULING(item);
  const uint8_t *requirements = IssueItem_REQUIREMENTS(item);
  uint8_t *this_counters = IssueGroup_COUNTERS(this);
  IssueItem *this_items = IssueGroup_ITEMS(this);
  int itemCount = IssueGroup_ITEMCOUNT(this), i, j;
  Except_REQUIRE(scheduling != Scheduling__UNDEF);
  // Update this IssueGroup_COUNTERS.
  IssueGroup_FOREACH_Resource(this, resource) {
    this_counters[resource] += requirements[resource];
  } IssueGroup_ENDEACH_Resource;
  // Insert item in non-decreasing scheduling order.
  for (i = 0; i < itemCount; i++) {
    if (IssueItem_SCHEDULING(this_items[i]) >= scheduling) break;
  }
  for (j = itemCount; j > i; j--) this_items[j] = this_items[j - 1];
  this_items[i] = item;
  ++*IssueGroup__ITEMCOUNT(this);
  Except_CHECK(IssueGroup_check(this));
}

#line 427 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
void
IssueGroup_remove(IssueGroup this, IssueItem item)
{
  Scheduling scheduling = IssueItem_SCHEDULING(item);
  const uint8_t *requirements = IssueItem_REQUIREMENTS(item);
  uint8_t *this_counters = IssueGroup_COUNTERS(this);
  IssueItem *this_items = IssueGroup_ITEMS(this);
  int itemCount = IssueGroup_ITEMCOUNT(this), i, j;
  Except_REQUIRE(scheduling != Scheduling__UNDEF);
  // Update this IssueGroup_COUNTERS.
  IssueGroup_FOREACH_Resource(this, resource) {
    this_counters[resource] -= requirements[resource];
  } IssueGroup_ENDEACH_Resource;
  // Remove item in non-decreasing scheduling order.
  for (i = 0; i < itemCount && this_items[i] != item; i++);
  Except_CHECK(i < itemCount);
  for (j = i + 1; j < itemCount; j++) this_items[j - 1] = this_items[j];
  --*IssueGroup__ITEMCOUNT(this);
  Except_CHECK(IssueGroup_check(this));
}

#line 448 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
#if XCC__C
void
IssueGroup_enumerate(IssueGroup this, Processor processor, Scheduling scheduling)
{
  IssueItem_ item[1];
  LabelTable labelTable = LabelTable_new(Memory_Root, 16);
  Label label = LabelTable_makeLabel(labelTable);
  Reservation reservation = Scheduling_reservation(scheduling);
  const_ReservationTable table = Reservation_table(reservation);
  Operation_ operation[1];
  Operation_Ctor(operation, Operator_LABEL, 0, 0, NULL, NULL);
  IssueItem_Ctor(item, operation, Instance__UNDEF);
  *IssueItem__TABLE(item) = table;
  *IssueItem__SCHEDULING(item) = scheduling;
  printf("IssueGroup:");
  IssueGroup_FOREACH_IssueItem(this, item) {
    Scheduling scheduling = IssueItem_SCHEDULING(item);
    printf("\t%s", Scheduling_name(scheduling));
  } IssueGroup_ENDEACH_IssueItem;
  printf("\n");
  for (; scheduling < Scheduling__COUNT; scheduling++) {
    Reservation reservation = Scheduling_reservation(scheduling);
    const_ReservationTable table = Reservation_table(reservation);
    const_ResourceVector column = ReservationTable_COLUMNS(table);
    const uint8_t *requirements = ResourceVector_UNITS(column);
    int cumulated = 0, resource = 0;
    for (; resource < Resource__COUNT; resource++) {
      cumulated += requirements[resource];
    }
    if (cumulated == 0) continue;
    *IssueItem__TABLE(item) = table;
    *IssueItem__SCHEDULING(item) = scheduling;
    if (IssueGroup_accept(this, item)) {
      IssueGroup_insert(this, item);
      IssueGroup_enumerate(this, processor, scheduling);
      IssueGroup_remove(this, item);
    }
  }
  LabelTable_delete(labelTable);
  IssueItem_Dtor(item);
}

#line 490 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
void
IssueGroup_Enumerate(Processor processor)
{
  const uint8_t *availability = Processor_availability(processor);
  IssueGroup_ group[1];
  IssueGroup_Ctor(group, availability);
  IssueGroup_enumerate(group, processor, Scheduling__UNDEF + 1);
  IssueGroup_Dtor(group);
}
#endif

#line 512 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 531 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
IssueTable
IssueTable_Ctor(IssueTable this,
                Memory memory, const uint8_t *availability)
{
  int resource;
  IStack_Ctor(IssueTable_GROUPS(this),
              memory, sizeof(IssueGroup_), 128);
  IssueGroup_Ctor(IStack_push2(IssueTable_GROUPS(this)), availability);
  *IssueTable__AVAILABILITY(this) = availability;
  *IssueTable__DELTAS(this) = 0;
  for (resource = 0; resource < Resource__COUNT; resource++) {
    IssueTable_COUNTERS(this)[resource] = 0;
  }
  return this;
}

#line 547 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
void
IssueTable_Dtor(IssueTable this)
{
  IStack_Dtor(IssueTable_GROUPS(this));
}

#line 553 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
size_t
IssueTable_Size(Memory memory, const uint8_t *availability)
{
  return sizeof(IssueTable_);
}

#line 568 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
#ifndef IssueTable_POOLED
#define IssueTable_POOLED 128
#endif//IssueTable_POOLED

#line 572 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
IssueTable
IssueTable_new(Memory parent, const uint8_t *availability)
{
  Memory memory = Memory_new(parent, IssueTable_POOLED);
  size_t size = IssueTable_Size(memory, availability);
  IssueTable this = Memory_alloc(memory, size);
  return IssueTable_Ctor(this, memory, availability);
}

#line 585 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
IssueTable
IssueTable_delete(IssueTable this)
{
  if (this != NULL) {
    Memory memory = IssueTable_MEMORY(this);
#ifndef PRO_NDTOR
    IssueTable_Dtor(this);
    Memory_free_(memory, this);
#endif//PRO_NDTOR
    Memory_delete(memory);
  }
  return NULL;
}

#line 669 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
#ifndef ECL_NTRACE
bool
IssueTable_prettyCounters(IssueTable this, FILE *file)
{
  if (file == NULL) file = stderr;
  fprintf(file, "    RESOURCE");
  IssueTable_FOREACH_Resource(this, resource) {
    fprintf(file, "\t%s", Resource_name(resource));
  } IssueTable_ENDEACH_Resource;
  fprintf(file, "\n");
  fprintf(file, "    COUNTERS");
  IssueTable_FOREACH_Resource(this, resource) {
    int available = IssueTable_AVAILABILITY(this)[resource];
    int counter = IssueTable_COUNTERS(this)[resource];
    fprintf(file, "\t%d/%d", counter, available);
  } IssueTable_ENDEACH_Resource;
  fprintf(file, "\n");
  return true;
}
#endif//ECL_NTRACE

#line 696 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
#ifndef ECL_NTRACE
bool
IssueTable_pretty(IssueTable this, FILE *file)
{
  int cycle = 0;
  if (file == NULL) file = stderr;
  fprintf(file, "*** ISSUE TABLE:\tLAMBDA=%d\tDELTAS=%d\n",
      IssueTable_LAMBDA(this), IssueTable_DELTAS(this));
  IssueTable_FOREACH_IssueGroup(this, group) {
    fprintf(file, "    [%d] ", cycle);
    IssueGroup_pretty(group, file);
    fprintf(file, "\n");
    cycle++;
  } IssueTable_ENDEACH_IssueGroup;
  IssueTable_prettyCounters(this, file);
  return true;
}
#endif//ECL_NTRACE

#line 721 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
bool
IssueTable_check(IssueTable this)
{
  bool result = true;
  IssueTable_FOREACH_IssueGroup(this, group) {
    result &= IssueGroup_check(group);
  } IssueTable_ENDEACH_IssueGroup;
  return result;
}

#line 737 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
void
IssueTable_enter(IssueTable this, IssueItem item)
{
  Scheduling scheduling = IssueItem_SCHEDULING(item);
  const uint8_t *requirements = IssueItem_REQUIREMENTS(item);
  if (scheduling != Scheduling__UNDEF) {
    PFA_TRACE && fprintf(PFA_TRACE, "    %s_%d",
        Scheduling_name(scheduling), IssueItem_INDEX(item));
    IssueTable_FOREACH_Resource(this, resource) {
      IssueTable_COUNTERS(this)[resource] += requirements[resource];
      PFA_TRACE && fprintf(PFA_TRACE, "\t%d", requirements[resource]);
    } IssueTable_ENDEACH_Resource;
    PFA_TRACE && fprintf(PFA_TRACE, "\n");
  }
}

#line 759 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
int
IssueTable_estimateLambda(IssueTable this)
{
  const uint8_t *this_availability = IssueTable_AVAILABILITY(this);
  int *this_counters = IssueTable_COUNTERS(this), lambda = 1;
  IssueTable_FOREACH_Resource(this, resource) {
    int available = this_availability[resource], counter = this_counters[resource];
    if (available > 0 && lambda*available < counter + available - 1) {
      lambda = (counter + available - 1)/available;
    }
  } IssueTable_ENDEACH_Resource;
  return lambda;
}

#line 779 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
void
IssueTable_ready(IssueTable this, int lambda)
{
  int delta = lambda - IssueTable_LAMBDA(this);
  IssueTable_FOREACH_IssueGroup(this, group) {
    IssueGroup_clear(group);
  } IssueTable_ENDEACH_IssueGroup;
  for (; delta > 0; delta--) {
    IssueGroup group = IStack_push2(IssueTable_GROUPS(this));
    IssueGroup_Ctor(group, IssueTable_AVAILABILITY(this));
  }
  for (; delta < 0; delta++) {
    IStack_pop(IssueTable_GROUPS(this), (IStackItemRelease)IssueGroup_Dtor);
  }
  *IssueTable__DELTAS(this) = 0;
  Except_ENSURE(lambda == IssueTable_LAMBDA(this));
}

#line 814 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
IssueGroup
IssueTable_assign(IssueTable this, int moduloDate, IssueGroup group)
{
  IssueGroup baseGroup = IssueTable_BASEGROUP(this);
  Except_REQUIRE(moduloDate >= 0 && moduloDate < IssueTable_LAMBDA(this));
  IssueGroup_Dtor(baseGroup + moduloDate);
  IssueGroup_Copy(baseGroup + moduloDate, group);
  return baseGroup + moduloDate;
}

#line 831 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
int
IssueTable_accept(IssueTable this, IssueItem item, int moduloDate)
{
  IssueGroup baseGroup = IssueTable_BASEGROUP(this);
  Except_REQUIRE(baseGroup + moduloDate < IssueTable_PASTGROUP(this));
  return IssueGroup_accept(baseGroup + moduloDate, item);
}

#line 845 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
void
IssueTable_insert(IssueTable this, IssueItem item, int moduloDate)
{
  if (IssueItem_SCHEDULING(item) != Scheduling__UNDEF) {
    IssueGroup baseGroup = IssueTable_BASEGROUP(this);
    Except_REQUIRE(baseGroup + moduloDate < IssueTable_PASTGROUP(this));
    IssueGroup_insert(baseGroup + moduloDate, item);
  }
}

#line 861 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
void
IssueTable_remove(IssueTable this, IssueItem item, int moduloDate)
{
  IssueGroup baseGroup = IssueTable_BASEGROUP(this);
  Except_REQUIRE(baseGroup + moduloDate < IssueTable_PASTGROUP(this));
  IssueGroup_remove(baseGroup + moduloDate, item);
}

#line 875 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
void
IssueTable_growAt(IssueTable this, int moduloDate, int delta)
{
  if (delta > 0) {
    int lambda = IssueTable_LAMBDA(this) + delta, i;
    const uint8_t *availability = IssueTable_AVAILABILITY(this);
    IssueGroup baseGroup = NULL, pastGroup = NULL, group = NULL;
    for (i = 0; i < delta; i++) {
      IssueGroup_Ctor(IStack_push2(IssueTable_GROUPS(this)), availability);
    }
    Except_CHECK(lambda == IssueTable_LAMBDA(this));
    baseGroup = IssueTable_BASEGROUP(this);
    pastGroup = IssueTable_PASTGROUP(this);
    for (group = pastGroup - 1; group - delta > baseGroup + moduloDate; --group) {
      IssueGroup_Dtor(group), IssueGroup_Copy(group, group - delta);
    }
    for (group = baseGroup + moduloDate + 1, i = 0; i < delta; i++, group++) {
      IssueGroup_Dtor(group), IssueGroup_Ctor(group, availability);
    }
    *IssueTable__DELTAS(this) += delta;
  }
}

#line 904 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
int
IssueTable_shrinkTo(IssueTable this, int lambda)
{
  int delta = IssueTable_LAMBDA(this) - lambda;
  while (delta-- > 0) {
    IssueGroup group = IssueTable_LASTGROUP(this);
    if (IssueGroup_itemCount(group) == 0) {
      IStack_pop(IssueTable_GROUPS(this), (IStackItemRelease)IssueGroup_Dtor);
      --*IssueTable__DELTAS(this);
    } else break;
  }
  return IssueTable_LAMBDA(this);
}

#line 924 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
int
IssueTable_sortResources(IssueTable this, Resource resources[])
{
  int resourceUses[Resource__FIXME], i;
  // Initialize the resources and resourceUses arrays.
  resourceUses[Resource__UNDEF] = 0;
  resources[Resource__UNDEF] = Resource__UNDEF;
  IssueTable_FOREACH_Resource(this, resource) {
    int available = IssueTable_AVAILABILITY(this)[resource];
    int counter = IssueTable_COUNTERS(this)[resource];
    resourceUses[resource] = available != 0?
        (counter + available - 1)/available: 0;
    resources[resource] = (Resource)resource;
  } IssueTable_ENDEACH_Resource;
  // Sort the resources array.
  for (i = Resource__UNDEF; i < Resource__COUNT; i++) {
    int min = i, j;
    Resource tmp_resource;
    for (j = i + 1; j < Resource__COUNT; j++) {
      Resource resource1 = resources[j];
      Resource resource2 = resources[min];
      if (resourceUses[resource1] > resourceUses[resource2]) min = j;
    }
    tmp_resource = resources[i];
    resources[i] = resources[min];
    resources[min] = tmp_resource;
  }
  // Find index of the lowest zero resourceUses.
  for (i = Resource__COUNT - 1; i >= Resource__UNDEF; --i) {
    if(resourceUses[resources[i]] != 0) break;
  }
  return i + 1;
}

#line 958 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 970 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
#if XCC__C
void
Issue_TEST(void)
{
#include "XFA/Issue_.c"
}

#line 977 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/Issue.xcc"
int
main(int argc, char **argv)
{
  XFA_Test(Issue_TEST);
  return 0;
}
#endif


#endif//Issue_c_INCLUDED
