#ifndef XFA_c_INCLUDED
#define XFA_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/XFA.xcc"
#include "XFA/XFA_.h"

#line 30 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/XFA.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 61 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/XFA.xcc"
#undef PFA_TRACE 
extern FILE *PFA_TRACE;

#line 64 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/XFA.xcc"
#undef MAXLIVE_TRACE
extern FILE* MAXLIVE_TRACE;

#line 79 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/XFA.xcc"
int FORCE_POSTCOMP;
int FORCE_POSTSPEC;
int FORCE_KUNROLL;
int FORCE_PRESERIAL;
int FORCE_POSTSERIAL;
unsigned DEBUG_BOOSTABLE;
unsigned DEBUG_SPECULABLE;
unsigned DEBUG_COMPENSABLE;

#line 94 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/XFA.xcc"
static int XFA_Initialized = 0;

#line 96 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/XFA.xcc"
void
XFA_INIT(void)
{
  if (XFA_Initialized++ == 0) {
    if (GETENV("PFA_TRACE")) {
      int file = 0;
      sscanf(GETENV("PFA_TRACE"), "%d", &file);
      if (file == 1) PFA_TRACE = stdout;
      else if (file == 2) PFA_TRACE = stderr;
    }
    if (GETENV("MAXLIVE_TRACE")) {
      int file = 0;
      sscanf(GETENV("MAXLIVE_TRACE"), "%d", &file);
      if (file == 1) MAXLIVE_TRACE = stdout;
      else if (file == 2) MAXLIVE_TRACE = stderr;
    }

#line 113 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/XFA.xcc"
    FORCE_POSTCOMP = ConfigureCompensation_Local;
    if (GETENV("FORCE_POSTCOMP")) {
      sscanf(GETENV("FORCE_POSTCOMP"), "%d", &FORCE_POSTCOMP);
      fprintf(stderr, "*** FORCE_POSTCOMP=%d\n", FORCE_POSTCOMP);
    }
    FORCE_POSTSPEC = ConfigureSpeculation_SafeAccess;
    if (GETENV("FORCE_POSTSPEC")) {
      sscanf(GETENV("FORCE_POSTSPEC"), "%d", &FORCE_POSTSPEC);
      fprintf(stderr, "*** FORCE_POSTSPEC=%d\n", FORCE_POSTSPEC);
    }
    FORCE_KUNROLL = 0;
    if (GETENV("FORCE_KUNROLL")) {
      sscanf(GETENV("FORCE_KUNROLL"), "%d", &FORCE_KUNROLL);
      fprintf(stderr, "*** FORCE_KUNROLL=%d\n", FORCE_KUNROLL);
    }
    FORCE_PRESERIAL = 0;
    if (GETENV("FORCE_PRESERIAL")) {
      sscanf(GETENV("FORCE_PRESERIAL"), "%d", &FORCE_PRESERIAL);
      fprintf(stderr, "*** FORCE_PRESERIAL=%d\n", FORCE_PRESERIAL);
    }
    FORCE_POSTSERIAL = 0;
    if (GETENV("FORCE_POSTSERIAL")) {
      sscanf(GETENV("FORCE_POSTSERIAL"), "%d", &FORCE_POSTSERIAL);
      fprintf(stderr, "*** FORCE_POSTSERIAL=%d\n", FORCE_POSTSERIAL);
    }
    DEBUG_BOOSTABLE = -1;
    if (GETENV("DEBUG_BOOSTABLE")) {
      sscanf(GETENV("DEBUG_BOOSTABLE"), "%d", &DEBUG_BOOSTABLE);
      fprintf(stderr, "*** DEBUG_BOOSTABLE=%d\n", DEBUG_BOOSTABLE);
    }
    DEBUG_SPECULABLE = -1;
    if (GETENV("DEBUG_SPECULABLE")) {
      sscanf(GETENV("DEBUG_SPECULABLE"), "%d", &DEBUG_SPECULABLE);
      fprintf(stderr, "*** DEBUG_SPECULABLE=%d\n", DEBUG_SPECULABLE);
    }
    DEBUG_COMPENSABLE = -1;
    if (GETENV("DEBUG_COMPENSABLE")) {
      sscanf(GETENV("DEBUG_COMPENSABLE"), "%d", &DEBUG_COMPENSABLE);
      fprintf(stderr, "*** DEBUG_COMPENSABLE=%d\n", DEBUG_COMPENSABLE);
    }
    CCL_INIT();
    CAL_INIT();
    MDS_INIT();
    AIR_INIT();
    LIR_INIT();
    PFA_INIT();
    Issue_INIT();
    Effect_INIT();
    CFGraph_INIT();
    RegionFlow_INIT();
    Lifetime_INIT();
    BlockTrace_INIT();
    DDGraph_INIT();
  }
}

#line 175 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/XFA.xcc"
void
XFA_FINI(void)
{
  if (--XFA_Initialized == 0) {
    DDGraph_FINI();
    BlockTrace_FINI();
    Lifetime_FINI();
    RegionFlow_FINI();
    CFGraph_FINI();
    Effect_FINI();
    Issue_FINI();
    PFA_FINI();
    LIR_FINI();
    AIR_FINI();
    MDS_FINI();
    CAL_FINI();
    CCL_FINI();
  }
}

#line 201 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/XFA.xcc"
void
XFA_Test(void (*test)(void))
{
  XFA_INIT();
  (*test)();
  XFA_FINI();
}

#line 209 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/XFA.xcc"
#if XCC__C
void
XFA_TEST(void)
{
#include "XFA/XFA_.c"
}

#line 216 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/XFA/XFA.xcc"
int
main(int argc, char **argv)
{
  XFA_Test(XFA_TEST);
  return 0;
}
#endif


#endif//XFA_c_INCLUDED
