#ifndef XMLCan__h_INCLUDED
#define XMLCan__h_INCLUDED

//
#include "BSL/XMLCan.h"

//
struct XMLCanBuffer_ {
  //@args	Memory memory, FILE *input, size_t size
  Memory MEMORY;
  FILE *INPUT;
  size_t SIZE;
  char *DATA;
  char *START;
  char *PAST;
};

extern XMLCanBuffer
XMLCanBuffer_Ctor(XMLCanBuffer this, Memory memory, FILE *input, size_t size);

extern XMLCanBuffer
XMLCanBuffer_Copy(XMLCanBuffer this, const_XMLCanBuffer that);

extern void
XMLCanBuffer_Dtor(XMLCanBuffer this);

extern size_t
XMLCanBuffer_Size(Memory memory, FILE *input, size_t size);

#define XMLCanBuffer_MEMORY(this) ((this)->MEMORY)
#define XMLCanBuffer__MEMORY(this) (&(this)->MEMORY)
#define XMLCanBuffer_INPUT(this) ((this)->INPUT)
#define XMLCanBuffer__INPUT(this) (&(this)->INPUT)
#define XMLCanBuffer_SIZE(this) ((this)->SIZE)
#define XMLCanBuffer__SIZE(this) (&(this)->SIZE)
#define XMLCanBuffer_DATA(this) ((this)->DATA)
#define XMLCanBuffer__DATA(this) (&(this)->DATA)
#define XMLCanBuffer_START(this) ((this)->START)
#define XMLCanBuffer__START(this) (&(this)->START)
#define XMLCanBuffer_PAST(this) ((this)->PAST)
#define XMLCanBuffer__PAST(this) (&(this)->PAST)


/*
 * XMLCanBuffer_refill --	Refill this XMLCanBuffer.
 */
intptr_t
XMLCanBuffer_refill(XMLCanBuffer this);

//
struct XMLCan_ {
  XMLCanBuffer BUFFER;
  int (*LOOKUP)(struct XMLCan_ *this, const char *name);
  const char *ERROR;
  int32_t LINE;
  char *TEXT;
  //@access NAME	XMLCan_TEXT(this)
  //@mutate NAME	XMLCan__TEXT(this)
  size_t SIZE;
  short_XMLCanFlags FLAGS;
  short_XMLCanEvent EXPECT;
  short_XMLCanEvent EVENT;
  char SAVED;
  char QUOTE;
  int16_t DEPTH;
};

extern XMLCan
XMLCan_Ctor(XMLCan this, XMLCanBuffer buffer, int (*lookup)(struct XMLCan_ *this, const char *name), XMLCanFlags flags);

extern XMLCan
XMLCan_Copy(XMLCan this, const_XMLCan that);

extern void
XMLCan_Dtor(XMLCan this);

extern size_t
XMLCan_Size(XMLCanBuffer buffer, int (*lookup)(struct XMLCan_ *this, const char *name), XMLCanFlags flags);

#define XMLCan_BUFFER(this) ((this)->BUFFER)
#define XMLCan__BUFFER(this) (&(this)->BUFFER)
#define XMLCan_LOOKUP(this) ((this)->LOOKUP)
#define XMLCan__LOOKUP(this) (&(this)->LOOKUP)
#define XMLCan_ERROR(this) ((this)->ERROR)
#define XMLCan__ERROR(this) (&(this)->ERROR)
#define XMLCan_LINE(this) ((this)->LINE)
#define XMLCan__LINE(this) (&(this)->LINE)
#define XMLCan_TEXT(this) ((this)->TEXT)
#define XMLCan__TEXT(this) (&(this)->TEXT)
#define XMLCan_SIZE(this) ((this)->SIZE)
#define XMLCan__SIZE(this) (&(this)->SIZE)
#define XMLCan_FLAGS(this) ((this)->FLAGS)
#define XMLCan__FLAGS(this) (&(this)->FLAGS)
#define XMLCan_EXPECT(this) ((this)->EXPECT)
#define XMLCan__EXPECT(this) (&(this)->EXPECT)
#define XMLCan_EVENT(this) ((this)->EVENT)
#define XMLCan__EVENT(this) (&(this)->EVENT)
#define XMLCan_SAVED(this) ((this)->SAVED)
#define XMLCan__SAVED(this) (&(this)->SAVED)
#define XMLCan_QUOTE(this) ((this)->QUOTE)
#define XMLCan__QUOTE(this) (&(this)->QUOTE)
#define XMLCan_DEPTH(this) ((this)->DEPTH)
#define XMLCan__DEPTH(this) (&(this)->DEPTH)
#define XMLCan_NAME(this) (XMLCan_TEXT(this))
#define XMLCan__NAME(this) (XMLCan__TEXT(this))


//
void
XMLCanCharacterClass_Ctor(void);

/*
 * Macros for the XML character classes.
 */
#define XMLCanIsWhiteSpace(c) \
  ((XMLCanCharacterClass[(unsigned char)(c)] & XMLCanCharacter_WhiteSpace) != 0)
#define XMLCanIsNameStart(c) \
  ((XMLCanCharacterClass[(unsigned char)(c)] & XMLCanCharacter_NameStart) != 0)
#define XMLCanIsNameChar(c) \
  ((XMLCanCharacterClass[(unsigned char)(c)] & XMLCanCharacter_NameChar) != 0)
#define XMLCanIsDecChar(c) \
  ((XMLCanCharacterClass[(unsigned char)(c)] & XMLCanCharacter_DecChar) != 0)
#define XMLCanIsHexChar(c) \
  ((XMLCanCharacterClass[(unsigned char)(c)] & XMLCanCharacter_HexChar) != 0)
#define XMLCanIsNewLineChar(c) \
  ((c) == '\n')

/*
 * XMLCan_INIT --	Initialize the XMLCan module.
 */
#define XMLCan_INIT()

/*
 * XMLCan_FINI --	Finalize the XMLCan module.
 */
#define XMLCan_FINI()


#endif//XMLCan__h_INCLUDED
