#ifndef DomTreeScan_h_INCLUDED
#define DomTreeScan_h_INCLUDED

/*
 * !!!!	DomTreeScan.xcc
 *
 * Fabrice Rastello (Fabrice.Rastello@ens-lyon.fr).
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * DomTreeScan --	Tree scan register allocator.
 */
struct DomTreeScan_ {
  //@args	Memory memory, SSAForm ssaForm
  Memory MEMORY;
  SSAForm SSAFORM;
};
typedef struct DomTreeScan_ DomTreeScan_, *DomTreeScan;
typedef const struct DomTreeScan_ *const_DomTreeScan;
typedef struct DomTreeScan_ * restrict_DomTreeScan;

extern DomTreeScan
DomTreeScan_Ctor(DomTreeScan this, Memory memory, SSAForm ssaForm);

extern DomTreeScan
DomTreeScan_Copy(DomTreeScan this, const_DomTreeScan that);

extern void
DomTreeScan_Dtor(DomTreeScan this);

extern size_t
DomTreeScan_Size(Memory memory, SSAForm ssaForm);

#define DomTreeScan_MEMORY(this) ((this)->MEMORY)
#define DomTreeScan__MEMORY(this) (&(this)->MEMORY)
#define DomTreeScan_SSAFORM(this) ((this)->SSAFORM)
#define DomTreeScan__SSAFORM(this) (&(this)->SSAFORM)


//
DomTreeScan
DomTreeScan_new(Memory parent, SSAForm ssaForm);

//
DomTreeScan
DomTreeScan_delete(DomTreeScan this);

/*
 * DomTreeScan_memory --	This DomTreeScan Memory.
 */
Memory
DomTreeScan_memory(DomTreeScan this);

/*
 * DomTreeScan_pretty --	Pretty-print this DomTreeScan.
 */
bool
DomTreeScan_pretty(DomTreeScan this, FILE *file);

/*
 * DomTreeScan_allocate --	Top-level driver for register allocation.
 */
void
DomTreeScan_allocate(DomTreeScan this);


#endif//DomTreeScan_h_INCLUDED
