#ifndef ELinearScan_h_INCLUDED
#define ELinearScan_h_INCLUDED

/*
 * !!!!	ELinearScan.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * ELinearScan --	Linear scan register allocator.
 */
struct ELinearScan_ {
  //@args	Memory memory, SSAForm ssaForm
  Memory MEMORY;
  SSAForm SSAFORM;
};
typedef struct ELinearScan_ ELinearScan_, *ELinearScan;
typedef const struct ELinearScan_ *const_ELinearScan;
typedef struct ELinearScan_ * restrict_ELinearScan;

extern ELinearScan
ELinearScan_Ctor(ELinearScan this, Memory memory, SSAForm ssaForm);

extern ELinearScan
ELinearScan_Copy(ELinearScan this, const_ELinearScan that);

extern void
ELinearScan_Dtor(ELinearScan this);

extern size_t
ELinearScan_Size(Memory memory, SSAForm ssaForm);

#define ELinearScan_MEMORY(this) ((this)->MEMORY)
#define ELinearScan__MEMORY(this) (&(this)->MEMORY)
#define ELinearScan_SSAFORM(this) ((this)->SSAFORM)
#define ELinearScan__SSAFORM(this) (&(this)->SSAFORM)


//
ELinearScan
ELinearScan_new(Memory parent, SSAForm ssaForm);

//
ELinearScan
ELinearScan_delete(ELinearScan this);

/*
 * ELinearScan_memory --	This ELinearScan Memory.
 */
Memory
ELinearScan_memory(ELinearScan this);

/*
 * ELinearScan_ssaForm --	This ELinearScan SSAForm.
 */
SSAForm
ELinearScan_ssaForm(ELinearScan this);

/*
 * ELinearScan_pretty --	Pretty-print this ELinearScan.
 */
bool
ELinearScan_pretty(ELinearScan this, FILE *file);

/*
 * ELinearScan_allocate --	Top-level driver for register allocation.
 */
void
ELinearScan_allocate(ELinearScan this);


#endif//ELinearScan_h_INCLUDED
