#ifndef Pipeliner_h_INCLUDED
#define Pipeliner_h_INCLUDED

/*
 * !!!!	Pipeliner.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * Pipeliner --	Prepass instruction scheduling in a CodeRegion.
 */
struct Pipeliner_ {
  //@args	Memory memory, CodeRegion codeRegion
  Memory MEMORY;
  CodeRegion CODEREGION;
};
typedef struct Pipeliner_ Pipeliner_, *Pipeliner;
typedef const struct Pipeliner_ *const_Pipeliner;
typedef struct Pipeliner_ * restrict_Pipeliner;

extern Pipeliner
Pipeliner_Ctor(Pipeliner this, Memory memory, CodeRegion codeRegion);

extern Pipeliner
Pipeliner_Copy(Pipeliner this, const_Pipeliner that);

extern void
Pipeliner_Dtor(Pipeliner this);

extern size_t
Pipeliner_Size(Memory memory, CodeRegion codeRegion);

#define Pipeliner_MEMORY(this) ((this)->MEMORY)
#define Pipeliner__MEMORY(this) (&(this)->MEMORY)
#define Pipeliner_CODEREGION(this) ((this)->CODEREGION)
#define Pipeliner__CODEREGION(this) (&(this)->CODEREGION)


//
Pipeliner
Pipeliner_new(Memory parent, CodeRegion codeRegion);

//
Pipeliner
Pipeliner_delete(Pipeliner this);

/*
 * Pipeliner_memory --	This Pipeliner Memory.
 */
Memory
Pipeliner_memory(Pipeliner this);

/*
 * Pipeliner_codeRegion --	This Pipeliner CodeRegion.
 */
CodeRegion
Pipeliner_codeRegion(Pipeliner this);

/*
 * Pipeliner_pretty --	Pretty-print this Pipeliner.
 */
bool
Pipeliner_pretty(Pipeliner this, FILE *file);


#endif//Pipeliner_h_INCLUDED
