#ifndef Predicator_h_INCLUDED
#define Predicator_h_INCLUDED

/*
 * !!!!	Predicator.xcc
 *
 * Nikola Puzovic (Nikola.Puzovic@st.com).
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * Predicator --	Predication and IF-conversion for a CodeRegion.
 */
struct Predicator_ {
  //@args	Memory memory, SSAForm ssaForm
  Memory MEMORY;
  SSAForm SSAFORM;
  float AGRESSIVNESS_FACTOR;
  CodeRegion CODEREGION;
  BasicBlockStack_ POSTORDER_;
  //@access POSTORDER	Predicator__POSTORDER_(this)
  bool *VISITED;
};
typedef struct Predicator_ Predicator_, *Predicator;
typedef const struct Predicator_ *const_Predicator;
typedef struct Predicator_ * restrict_Predicator;

extern Predicator
Predicator_Ctor(Predicator this, Memory memory, SSAForm ssaForm);

extern Predicator
Predicator_Copy(Predicator this, const_Predicator that);

extern void
Predicator_Dtor(Predicator this);

extern size_t
Predicator_Size(Memory memory, SSAForm ssaForm);

#define Predicator_MEMORY(this) ((this)->MEMORY)
#define Predicator__MEMORY(this) (&(this)->MEMORY)
#define Predicator_SSAFORM(this) ((this)->SSAFORM)
#define Predicator__SSAFORM(this) (&(this)->SSAFORM)
#define Predicator_AGRESSIVNESS_FACTOR(this) ((this)->AGRESSIVNESS_FACTOR)
#define Predicator__AGRESSIVNESS_FACTOR(this) (&(this)->AGRESSIVNESS_FACTOR)
#define Predicator_CODEREGION(this) ((this)->CODEREGION)
#define Predicator__CODEREGION(this) (&(this)->CODEREGION)
#define Predicator_POSTORDER_(this) ((this)->POSTORDER_)
#define Predicator__POSTORDER_(this) (&(this)->POSTORDER_)
#define Predicator_VISITED(this) ((this)->VISITED)
#define Predicator__VISITED(this) (&(this)->VISITED)
#define Predicator_POSTORDER(this) (Predicator__POSTORDER_(this))


//
Predicator
Predicator_new(Memory parent, SSAForm ssaForm);

//
Predicator
Predicator_delete(Predicator this);

/*
 * Predicator_memory --	This Predicator Memory.
 */
Memory
Predicator_memory(Predicator this);

/*
 * Predicator_pretty --	Pretty-print this Predicator.
 */
bool
Predicator_pretty(Predicator this, FILE *file);


#endif//Predicator_h_INCLUDED
