#ifndef SSASpill_h_INCLUDED
#define SSASpill_h_INCLUDED

/*
 * !!!!	SSASpill.xcc
 *
 * Sebastian Hack (sebastian.hack@ens-lyon.fr).
 * Quentin Colombet (quentin.colombet@ens-lyon.fr).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * Do spilling for a register class on a graph using the belady heuristic.
 * In the transformed graph, the register pressure never exceeds the number
 * of available registers.
 * To produce a nice approximation, we must passed a deadcode before.
 * WARNING: To enable removal of phi with memory operands, ssaForm must be in CSSA
 *
 * @param birg  The backend graph
 * @param cls   The register class to spill
 */
extern void
SSASpill_spillBelady(SSAForm ssaForm, RegFile regFile, bool removeMemPhi);

//
int32_t
SSASpill_maxLive(SSAForm ssaForm, RegFile regFile);


#endif//SSASpill_h_INCLUDED
