#ifndef Equiv__h_INCLUDED
#define Equiv__h_INCLUDED

//
#include "GRA/Equiv.h"

//
/**
 * Equivalence class interface.
 */
/* Defines the Equiv Item. Currently bounded to Temporary. */
typedef Temporary Equiv_Item;
typedef struct Equiv_ *Equiv;
typedef struct Equiv_Tree_ *Equiv_Tree;
void Equiv_ctor(Equiv equiv, int initialSize, Memory memory);
Equiv Equiv_new(int initial_index, Memory memory);
void Equiv_dtor(Equiv equiv);
void Equiv_del(Equiv equiv);
Equiv_Tree Equiv_make(Equiv equiv, Equiv_Item key);
Equiv_Item Equiv_find(Equiv equiv, Equiv_Item key);
Equiv_Item Equiv_union(Equiv equiv, Equiv_Item keyX, Equiv_Item keyY);

/*
 * Equiv_INIT --	Initialize the Equiv module.
 */
#define Equiv_INIT()

/*
 * Equiv_FINI --	Finalize the Equiv module.
 */
#define Equiv_FINI()


#endif//Equiv__h_INCLUDED
