#ifndef Florent__h_INCLUDED
#define Florent__h_INCLUDED

//
#include "GRA/Florent.h"

//
struct RepairInfo_ {
  //@args Temporary temp, int32_t opndIdx, Operation operation
  Temporary TEMPORARY;
  int32_t OPNDIDX;
  Operation OPERATION;
};
typedef struct RepairInfo_ RepairInfo_, *RepairInfo;
typedef const struct RepairInfo_ *const_RepairInfo;
typedef struct RepairInfo_ * restrict_RepairInfo;

extern RepairInfo
RepairInfo_Ctor(RepairInfo this, Temporary temp, int32_t opndIdx, Operation operation);

extern RepairInfo
RepairInfo_Copy(RepairInfo this, const_RepairInfo that);

extern void
RepairInfo_Dtor(RepairInfo this);

extern size_t
RepairInfo_Size(Temporary temp, int32_t opndIdx, Operation operation);

#define RepairInfo_TEMPORARY(this) ((this)->TEMPORARY)
#define RepairInfo__TEMPORARY(this) (&(this)->TEMPORARY)
#define RepairInfo_OPNDIDX(this) ((this)->OPNDIDX)
#define RepairInfo__OPNDIDX(this) (&(this)->OPNDIDX)
#define RepairInfo_OPERATION(this) ((this)->OPERATION)
#define RepairInfo__OPERATION(this) (&(this)->OPERATION)


//
struct ActionParam_ {
  //@args Procedure proc, Temporary dst, Temporary src
  Procedure PROC;
  Temporary DST;
  Temporary SRC;
};
typedef struct ActionParam_ ActionParam_, *ActionParam;
typedef const struct ActionParam_ *const_ActionParam;
typedef struct ActionParam_ * restrict_ActionParam;

extern ActionParam
ActionParam_Ctor(ActionParam this, Procedure proc, Temporary dst, Temporary src);

extern ActionParam
ActionParam_Copy(ActionParam this, const_ActionParam that);

extern void
ActionParam_Dtor(ActionParam this);

extern size_t
ActionParam_Size(Procedure proc, Temporary dst, Temporary src);

#define ActionParam_PROC(this) ((this)->PROC)
#define ActionParam__PROC(this) (&(this)->PROC)
#define ActionParam_DST(this) ((this)->DST)
#define ActionParam__DST(this) (&(this)->DST)
#define ActionParam_SRC(this) ((this)->SRC)
#define ActionParam__SRC(this) (&(this)->SRC)


/*
 * Florent_INIT --	Initialize the Florent module.
 */
#define Florent_INIT()

/*
 * Florent_FINI --	Finalize the Florent module.
 */
#define Florent_FINI()


#endif//Florent__h_INCLUDED
