#ifndef CodeRegion__h_INCLUDED
#define CodeRegion__h_INCLUDED

//
#if ECL_OPTIMIZE
//#define CodeRegion_BRIGGSGLOBALS 1
#endif//ECL_OPTIMIZE
#ifndef CodeRegion_BRIGGSGLOBALS
extern int CodeRegion_BRIGGSGLOBALS;
#endif//CodeRegion_BRIGGSGLOBALS

//
struct CodeRegion_ {
  //@args	Memory memory, Procedure procedure, Processor processor,
  //@args	intptr_t regionId, Optimize optimize, Configure configure
  IDListItemCell_ ITEMCELL[1];		// Dummy IDListItemCell_ for the ROOTBLOCK-.
  BasicBlock_ ROOTBLOCK[1];		// Dummy block (INDEX = 0) of this CodeRegion.
  //@access MEMORY	BasicBlock_MEMORY(CodeRegion_ROOTBLOCK(this))
  //@access PROCEDURE	BasicBlock_PROCEDURE(CodeRegion_ROOTBLOCK(this))
  //@access SELECTOR	BasicBlock_SELECTOR(CodeRegion_ROOTBLOCK(this))
  //@access LEAVEFIRST	BasicBlock_ENTERFIRST(CodeRegion_ROOTBLOCK(this))
  BasicBlockTable_ BLOCKTABLE[1];	// IndexedTable of BasicBlock(s).
  //@access BLOCKTABLEBASE	BasicBlockTable_base(CodeRegion_BLOCKTABLE(this))
  //@access BLOCKCOUNT	BasicBlockTable_count(CodeRegion_BLOCKTABLE(this))
  BasicBlock FIRSTBLOCK;		// This CodeRegion first BasicBlock.
  BasicBlock PASTBLOCK;			// This CodeRegion past BasicBlock.
  TemporaryTable_ GLOBALTABLE[1];	// Table of global Temporary(ies).
  IBList_ VARIABLES[1];			// Container for Variable(s) of this CodeRegion.
  Memory CONSUMEM;			// Memory for Variable CONSUMEMRS.
  int32_t LIVECOUNT;			// BLOCKCOUNT for LIVEINSETS and LIVEOUTSETS;
  TemporarySet_ *LIVEINSETS;		// The live-in sets of this CodeRegion.
  TemporarySet_ *LIVEOUTSETS;		// The live-out sets of this CodeRegion.
  TemporarySet_ *PHIINSETS;		// The phi-in sets of this CodeRegion.
  TemporarySet_ *PHIOUTSETS;		// The phi-out sets of this CodeRegion.
  intptr_t REGIONID;			// This CodeRegion ID.
  struct SSAForm_ *SSAFORM;		// This CodeRegion SSA Form.
  struct RegionFlow_ *REGIONFLOW;	// RegionFlow of this CodeRegion (LAO legacy).
  intptr_t TRACECOUNTER;		// TraceId counter (LAO legacy).
  Optimize OPTIMIZE;			// This CodeRegion Optimize.
  //@access CONVENTION	Optimize_CONVENTION(CodeRegion_OPTIMIZE(this))
  Configure_ CONFIGURE[1];		// This CodeRegion Configure.
  //@access PROCESSOR	Configure_PROCESSOR(CodeRegion_CONFIGURE(this))
  //@mutate PROCESSOR	Configure__PROCESSOR(CodeRegion_CONFIGURE(this))
};

extern CodeRegion
CodeRegion_Ctor(CodeRegion this, Memory memory, Procedure procedure, Processor processor, intptr_t regionId, Optimize optimize, Configure configure);

extern CodeRegion
CodeRegion_Copy(CodeRegion this, const_CodeRegion that);

extern void
CodeRegion_Dtor(CodeRegion this);

extern size_t
CodeRegion_Size(Memory memory, Procedure procedure, Processor processor, intptr_t regionId, Optimize optimize, Configure configure);

#define CodeRegion_ITEMCELL(this) ((this)->ITEMCELL)
#define CodeRegion__ITEMCELL(this) (&(this)->ITEMCELL)
#define CodeRegion_ROOTBLOCK(this) ((this)->ROOTBLOCK)
#define CodeRegion__ROOTBLOCK(this) (&(this)->ROOTBLOCK)
#define CodeRegion_BLOCKTABLE(this) ((this)->BLOCKTABLE)
#define CodeRegion__BLOCKTABLE(this) (&(this)->BLOCKTABLE)
#define CodeRegion_FIRSTBLOCK(this) ((this)->FIRSTBLOCK)
#define CodeRegion__FIRSTBLOCK(this) (&(this)->FIRSTBLOCK)
#define CodeRegion_PASTBLOCK(this) ((this)->PASTBLOCK)
#define CodeRegion__PASTBLOCK(this) (&(this)->PASTBLOCK)
#define CodeRegion_GLOBALTABLE(this) ((this)->GLOBALTABLE)
#define CodeRegion__GLOBALTABLE(this) (&(this)->GLOBALTABLE)
#define CodeRegion_VARIABLES(this) ((this)->VARIABLES)
#define CodeRegion__VARIABLES(this) (&(this)->VARIABLES)
#define CodeRegion_CONSUMEM(this) ((this)->CONSUMEM)
#define CodeRegion__CONSUMEM(this) (&(this)->CONSUMEM)
#define CodeRegion_LIVECOUNT(this) ((this)->LIVECOUNT)
#define CodeRegion__LIVECOUNT(this) (&(this)->LIVECOUNT)
#define CodeRegion_LIVEINSETS(this) ((this)->LIVEINSETS)
#define CodeRegion__LIVEINSETS(this) (&(this)->LIVEINSETS)
#define CodeRegion_LIVEOUTSETS(this) ((this)->LIVEOUTSETS)
#define CodeRegion__LIVEOUTSETS(this) (&(this)->LIVEOUTSETS)
#define CodeRegion_PHIINSETS(this) ((this)->PHIINSETS)
#define CodeRegion__PHIINSETS(this) (&(this)->PHIINSETS)
#define CodeRegion_PHIOUTSETS(this) ((this)->PHIOUTSETS)
#define CodeRegion__PHIOUTSETS(this) (&(this)->PHIOUTSETS)
#define CodeRegion_REGIONID(this) ((this)->REGIONID)
#define CodeRegion__REGIONID(this) (&(this)->REGIONID)
#define CodeRegion_SSAFORM(this) ((this)->SSAFORM)
#define CodeRegion__SSAFORM(this) (&(this)->SSAFORM)
#define CodeRegion_REGIONFLOW(this) ((this)->REGIONFLOW)
#define CodeRegion__REGIONFLOW(this) (&(this)->REGIONFLOW)
#define CodeRegion_TRACECOUNTER(this) ((this)->TRACECOUNTER)
#define CodeRegion__TRACECOUNTER(this) (&(this)->TRACECOUNTER)
#define CodeRegion_OPTIMIZE(this) ((this)->OPTIMIZE)
#define CodeRegion__OPTIMIZE(this) (&(this)->OPTIMIZE)
#define CodeRegion_CONFIGURE(this) ((this)->CONFIGURE)
#define CodeRegion__CONFIGURE(this) (&(this)->CONFIGURE)
#define CodeRegion_BLOCKCOUNT(this) (BasicBlockTable_count(CodeRegion_BLOCKTABLE(this)))
#define CodeRegion_PROCEDURE(this) (BasicBlock_PROCEDURE(CodeRegion_ROOTBLOCK(this)))
#define CodeRegion_BLOCKTABLEBASE(this) (BasicBlockTable_base(CodeRegion_BLOCKTABLE(this)))
#define CodeRegion_CONVENTION(this) (Optimize_CONVENTION(CodeRegion_OPTIMIZE(this)))
#define CodeRegion_LEAVEFIRST(this) (BasicBlock_ENTERFIRST(CodeRegion_ROOTBLOCK(this)))
#define CodeRegion_PROCESSOR(this) (Configure_PROCESSOR(CodeRegion_CONFIGURE(this)))
#define CodeRegion_MEMORY(this) (BasicBlock_MEMORY(CodeRegion_ROOTBLOCK(this)))
#define CodeRegion_SELECTOR(this) (BasicBlock_SELECTOR(CodeRegion_ROOTBLOCK(this)))
#define CodeRegion__PROCESSOR(this) (Configure__PROCESSOR(CodeRegion_CONFIGURE(this)))


/*
 * CodeRegion_isEmpty --	True iff this CodeRegion is empty.
 */
static inline bool
CodeRegion_isEmpty(const_CodeRegion this)
{
  return CodeRegion_FIRSTBLOCK(this) == NULL;
}

/*
 * CodeRegion_pushBasicBlock --	Push a BasicBlock on this CodeRegion.
 *
 * Low-level call. Use Procedure_makeBasicBlock or CodeRegion_makeBasicBlock.
 */
void
CodeRegion_pushBasicBlock(CodeRegion this, BasicBlock basicBlock);

/*
 * CodeRegion_INIT --	Initialize the CodeRegion module.
 */
#if defined(CodeRegion_BRIGGSGLOBALS)
#define CodeRegion_INIT()
#else
void
CodeRegion_INIT(void);
#endif

/*
 * CodeRegion_FINI --	Finalize the CodeRegion module.
 */
#define CodeRegion_FINI()


#endif//CodeRegion__h_INCLUDED
