#ifndef Procedure__h_INCLUDED
#define Procedure__h_INCLUDED

//
#include "LIR/Procedure.h"

//
struct Procedure_ {
  //@args	Memory memory, Symbol symbol, struct Program_ *program
  Indexed_ __;			// A Procedure_ ISA Indexed_.
  //@access IDENTITY	Indexed_IDENTITY(Procedure____(this))
  //@access INDEX	Indexed_INDEX(Procedure____(this))
  //@mutate INDEX	Indexed__INDEX(Procedure____(this))
  struct Program_ *PROGRAM;		// This Procedure enclosing Program.
  //@access DEDICATED	Program_DEDICATED(Procedure_PROGRAM(this))
  //@access INVARIANTS	Program_INVARIANTS(Procedure_PROGRAM(this))
  IBList_ TEMPORARIES[1];		// Temporary(ies) for this Procedure.
  HTable_ REMATERMAP[1];		// Map Temporary to its rematerialization.
  HTable_ HOMEABLEMAP[1];		// Map Temporary to its home Temporary.
  IDList_ BLOCKCHAIN[1];		// The BasicBlock chain of this Procedure.
  //@access MEMORY	IDList_memory(Procedure_BLOCKCHAIN(this))
  //@access BLOCKCOUNT	IDList_count(Procedure_BLOCKCHAIN(this))
  IDList_ DISCARDED[1];			// The list of discarded BasicBlock(s).
  IDList_ CODEREGIONS[1];		// List of CodeRegion(s) in creation order.
  //@access FIRSTREGION	IDList_firstItem(Procedure_CODEREGIONS(this))
  //@access LASTREGION	IDList_lastItem(Procedure_CODEREGIONS(this))
  HTable_ LOOPSCOPES[1];		// Map header BasicBlock to LoopScope.
  Symbol SYMBOL;			// This Procedure global Symbol.
  Symbol SYMBOLSP;
  Symbol SYMBOLFP;
  Symbol SYMBOLGP;
};

extern Procedure
Procedure_Ctor(Procedure this, Memory memory, Symbol symbol, struct Program_ *program);

extern Procedure
Procedure_Copy(Procedure this, const_Procedure that);

extern void
Procedure_Dtor(Procedure this);

extern size_t
Procedure_Size(Memory memory, Symbol symbol, struct Program_ *program);

#define Procedure___(this) ((this)->__)
#define Procedure____(this) (&(this)->__)
#define Procedure_PROGRAM(this) ((this)->PROGRAM)
#define Procedure__PROGRAM(this) (&(this)->PROGRAM)
#define Procedure_TEMPORARIES(this) ((this)->TEMPORARIES)
#define Procedure__TEMPORARIES(this) (&(this)->TEMPORARIES)
#define Procedure_REMATERMAP(this) ((this)->REMATERMAP)
#define Procedure__REMATERMAP(this) (&(this)->REMATERMAP)
#define Procedure_HOMEABLEMAP(this) ((this)->HOMEABLEMAP)
#define Procedure__HOMEABLEMAP(this) (&(this)->HOMEABLEMAP)
#define Procedure_BLOCKCHAIN(this) ((this)->BLOCKCHAIN)
#define Procedure__BLOCKCHAIN(this) (&(this)->BLOCKCHAIN)
#define Procedure_DISCARDED(this) ((this)->DISCARDED)
#define Procedure__DISCARDED(this) (&(this)->DISCARDED)
#define Procedure_CODEREGIONS(this) ((this)->CODEREGIONS)
#define Procedure__CODEREGIONS(this) (&(this)->CODEREGIONS)
#define Procedure_LOOPSCOPES(this) ((this)->LOOPSCOPES)
#define Procedure__LOOPSCOPES(this) (&(this)->LOOPSCOPES)
#define Procedure_SYMBOL(this) ((this)->SYMBOL)
#define Procedure__SYMBOL(this) (&(this)->SYMBOL)
#define Procedure_SYMBOLSP(this) ((this)->SYMBOLSP)
#define Procedure__SYMBOLSP(this) (&(this)->SYMBOLSP)
#define Procedure_SYMBOLFP(this) ((this)->SYMBOLFP)
#define Procedure__SYMBOLFP(this) (&(this)->SYMBOLFP)
#define Procedure_SYMBOLGP(this) ((this)->SYMBOLGP)
#define Procedure__SYMBOLGP(this) (&(this)->SYMBOLGP)
#define Procedure_INVARIANTS(this) (Program_INVARIANTS(Procedure_PROGRAM(this)))
#define Procedure_INDEX(this) (Indexed_INDEX(Procedure____(this)))
#define Procedure_LASTREGION(this) (IDList_lastItem(Procedure_CODEREGIONS(this)))
#define Procedure_DEDICATED(this) (Program_DEDICATED(Procedure_PROGRAM(this)))
#define Procedure_FIRSTREGION(this) (IDList_firstItem(Procedure_CODEREGIONS(this)))
#define Procedure_BLOCKCOUNT(this) (IDList_count(Procedure_BLOCKCHAIN(this)))
#define Procedure_MEMORY(this) (IDList_memory(Procedure_BLOCKCHAIN(this)))
#define Procedure_IDENTITY(this) (Indexed_IDENTITY(Procedure____(this)))
#define Procedure__INDEX(this) (Indexed__INDEX(Procedure____(this)))


//
static inline Indexed
Procedure__(Procedure this)
{
  return Procedure____(this);
}
static inline const_Indexed
Procedure__const(const_Procedure this)
{
  return Procedure____(this);
}

//
Procedure
Procedure_new(Memory parent, Symbol symbol, struct Program_ *program);

//
Procedure
Procedure_delete(Procedure this);

/*
 * Procedure_INIT --	Initialize the Procedure module.
 */
void
Procedure_INIT(void);

/*
 * Procedure_FINI --	Finalize the Procedure module.
 */
#define Procedure_FINI()


#endif//Procedure__h_INCLUDED
