#ifndef Bundling_h_INCLUDED
#define Bundling_h_INCLUDED

/*
 * !!!!	Bundling.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * Bundling_name_ --	Names for the Bundling enumeration.
 */
extern const char *
Bundling_name_(Bundling this);

/*
 * BundlingBuffer --	Buffer used to reorder Bundling(s).
 */
#if Bundle_ISSUE_MAX
struct BundlingBuffer_ {
  Bundling BUNDLINGS[Bundle_ISSUE_MAX];
  uint8_t PERMUTE[Bundle_ISSUE_MAX];
};
#endif//Bundle_ISSUE_MAX
typedef struct BundlingBuffer_ BundlingBuffer_, *BundlingBuffer;
typedef const struct BundlingBuffer_ *const_BundlingBuffer;
typedef struct BundlingBuffer_ * restrict_BundlingBuffer;

#define BundlingBuffer_BUNDLINGS(this) ((this)->BUNDLINGS)
#define BundlingBuffer__BUNDLINGS(this) (&(this)->BUNDLINGS)
#define BundlingBuffer_PERMUTE(this) ((this)->PERMUTE)
#define BundlingBuffer__PERMUTE(this) (&(this)->PERMUTE)


/*
 * BundlingBuffer_sort --	Sort the BUNDLINGS array and fill the PERMUTE array.
 *
 * Return:	hash value suitable for use by =BundleMatch_FindBundle=.
 *
 * The hash value is computed as follows:
 *
 *	hash = -1;
 *	for (i = 0; i < count; i++) {
 *	  hash++; hash *= (Bundling__ - Bundling__BIAS);
 *	  hash += (bundlings[i] - Bundling__BIAS);
 *	}
 *	hash++;
 */
int32_t
BundlingBuffer_sort(BundlingBuffer this, int count);

//
bool
Bundling_DTD(FILE *file);

//
bool
Bundling_XML(FILE *file);


#endif//Bundling_h_INCLUDED
