#ifndef Decode__h_INCLUDED
#define Decode__h_INCLUDED

//
#include "MDS/Decode.h"

/*
 * Decode_Encoding function prototypes.
 */
#ifndef NDECODE
#define Encoding(NAME, PROCESSOR, WORDTYPE, WORDCOUNT) \
extern Instance \
Decode_Encoding_##NAME(const void *buffer);
#include /*MDS*/"Encoding.enum"
#endif//NDECODE

/*
 * Decode_Modifier functions.
 */
#define DECODE(e) e
#define Modifier(NAME, VALUES, ENCODE, DECODE) \
static inline void \
Decode_Modifier_##NAME(OperandEncoded encoded, void *result) \
{ \
  OperandDecoded VALUE = encoded; \
  DECODE; \
  *(OperandDecoded *)result = VALUE; \
}
#include "Modifier.enum"
#undef DECODE

/*
 * Decode_Immediate functions.
 */
#define DECODE(e) e
#define Immediate(NAME, MINVALUE, MAXVALUE, SIGNED, RELOCATIONS, ENCODE, DECODE) \
static inline void \
Decode_Immediate_##NAME(OperandEncoded encoded, void *result) \
{ \
  ImmediateConstant constant = (ImmediateConstant)result; \
  ImmediateValue VALUE = (ImmediateValue)encoded; \
  DECODE; \
  *ImmediateConstant__VALUE(constant) = VALUE; \
}
#include "Immediate.enum"
#undef DECODE
#undef VALUETYPE

/*
 * Decode_RegClass functions.
 */
#define DECODE(e) e
#define RegClass(NAME, REGISTERS, REGFILE, ENCODE, DECODE, MINREADSTAGES) \
static inline void \
Decode_RegClass_##NAME(OperandEncoded encoded, void *result) \
{ \
  OperandDecoded VALUE = encoded; \
  DECODE; \
  *(OperandDecoded *)result = VALUE + Register__BIAS; \
}
#include "RegClass.enum"
#undef DECODE

/*
 * Decode_RegMask functions.
 */
#define DECODE(e) e
#define RegMask(NAME, REGISTERS, REGFILE, ENCODE, DECODE) \
static inline void \
Decode_RegMask_##NAME(OperandEncoded encoded, void *result) \
{ \
  RegisterSet registerSet = (RegisterSet)result; \
  RegisterSetWord WORD = (RegisterSetWord)encoded; \
  RegisterSetWord *WORDS = RegisterSet_WORDS(registerSet); \
  DECODE; \
}
#include "RegMask.enum"
#undef DECODE

/*
 * Decode_INIT --	Initialize the Decode module.
 */
#define Decode_INIT()

/*
 * Decode_FINI --	Finalize the Decode module.
 */
#define Decode_FINI()

//
#ifndef NDECODE
extern Instance
Decode_Encoding_st220_ANY(const void *buffer);
#endif//NDECODE

//
#ifndef NDECODE
extern Instance
Decode_Encoding_st220_ANYX(const void *buffer);
#endif//NDECODE

//
#ifndef NDECODE
extern Instance
Decode_Encoding_st231_ANY(const void *buffer);
#endif//NDECODE

//
#ifndef NDECODE
extern Instance
Decode_Encoding_st231_ANYX(const void *buffer);
#endif//NDECODE

//
#ifndef NDECODE
extern Instance
Decode_Encoding_st240_ANY(const void *buffer);
#endif//NDECODE

//
#ifndef NDECODE
extern Instance
Decode_Encoding_st240_ANYX(const void *buffer);
#endif//NDECODE


#endif//Decode__h_INCLUDED
