#ifndef Encoding_h_INCLUDED
#define Encoding_h_INCLUDED

/*
 * !!!!	Encoding.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * Expand MDS-generated macros that typedef PlatformInt and PlatformUInt.
 */
typedef int32_t PlatformInt;	//FIXME! PlatformInt_TYPEDEF
typedef uint32_t PlatformUInt;	//FIXME! PlatformUInt_TYPEDEF

/*
 * Encoding_name_ --	Names for the Encoding enumeration.
 */
extern const char *
Encoding_name_(Encoding this);

/*
 * Encoding_processor --	This Encoding Processor.
 */
Processor
Encoding_processor(Encoding this);

/*
 * Encoding_wordCount --	This Encoding word count.
 */
uint8_t
Encoding_wordCount(Encoding this);

/*
 * Encoding_wordSize --	This Encoding word size.
 */
uint8_t
Encoding_wordSize(Encoding this);

/*
 * Encoding_decode --	This Encoding decode function.
 */
typedef Instance (*EncodingDecode)(const void *buffer);
EncodingDecode
Encoding_decode(Encoding this);


#endif//Encoding_h_INCLUDED
