#ifndef Modifier__h_INCLUDED
#define Modifier__h_INCLUDED

//
#include "MDS/Modifier.h"

//
typedef enum {
#define Modifier(NAME, MEMBERS, ENCODE, DECODE) \
  Modifier_##NAME,
  Modifier_,
#include /*MDS*/"Modifier.enum"
  Modifier__
#undef Modifier
} enum_Modifier;

//
typedef enum {
#define ALIAS(alias, name) ModifierMember_##alias = ModifierMember_##name,
#define ALIASES(count, items) items
#define MEMBER(name, ENCODED, NAMES, ALIASES) \
  ModifierMember_##name, ALIASES
#define MEMBERS(count, items) items
#define Modifier(NAME, MEMBERS, ENCODE, DECODE) \
  MEMBERS
  ModifierMember_,
#include /*MDS*/"Modifier.enum"
  ModifierMember__
#undef Modifier
#undef MEMBERS
#undef MEMBER
#undef ALIASES
#undef ALIAS
#undef ENCODED
} enum_ModifierMember;

/*
 * ModifierEncode functions.
 */
#define ENCODE(e) e
#define Modifier(NAME, VALUES, ENCODE, DECODE) \
static inline OperandEncoded \
ModifierEncode_##NAME(OperandDecoded decoded) \
{ \
  OperandEncoded VALUE = decoded; \
  ENCODE; \
  return VALUE; \
}
#include "Modifier.enum"
#undef ENCODE

/*
 * Modifier_INIT --	Initialize the Modifier module.
 */
#define Modifier_INIT()

/*
 * Modifier_FINI --	Finalize the Modifier module.
 */
#define Modifier_FINI()


#endif//Modifier__h_INCLUDED
