#ifndef NativeType_h_INCLUDED
#define NativeType_h_INCLUDED

/*
 * !!!!	NativeType.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * NativeType_name_ --	Names for the NativeType enumeration.
 */
extern const char *
NativeType_name_(NativeType this);

/*
 * NativeType_format --	This NativeType bit syntax.
 */
const char *
NativeType_format(NativeType this);

/*
 * NativeType_width --	This NativeType bit width.
 */
unsigned
NativeType_width(NativeType this);

/*
 * NativeType_signed --	This NativeType is signed.
 */
bool
NativeType_signed(NativeType this);

/*
 * NativeType_sizeOf --	This NativeType size in bytes when stored to memory.
 */
unsigned
NativeType_sizeOf(NativeType this);

/*
 * NativeType_align --	This NativeType Alignment Base
 */
unsigned
NativeType_align(NativeType this);

/*
 * NativeType_slice --	This NativeType slice width in bits.
 */
unsigned
NativeType_slice(NativeType this);


#endif//NativeType_h_INCLUDED
