#ifndef Platform_h_INCLUDED
#define Platform_h_INCLUDED

/*
 * !!!!	Platform.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * Platform_name_ --	Names for the Platform enumeration.
 */
extern const char *
Platform_name_(Platform this);

/*
 * Platform_charWidth --	This Platform charWidth.
 */
int
Platform_charWidth(Platform this);

/*
 * Platform_addrWidth --	This Platform addrWidth.
 */
int
Platform_addrWidth(Platform this);

//
typedef enum {
  PlatformEndian__UNDEF,
  PlatformEndian_Little,
  PlatformEndian_Big,
  PlatformEndian__
} enum_PlatformEndian;
typedef uint8_t PlatformEndian;

/*
 * Platform_endian --	Endian of this Platform.
 */
PlatformEndian
Platform_endian(Platform this);


#endif//Platform_h_INCLUDED
