#ifndef Processor_h_INCLUDED
#define Processor_h_INCLUDED

/*
 * !!!!	Processor.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * Processor_name_ --	Names for the Processor enumeration.
 */
extern const char *
Processor_name_(Processor this);

/*
 * Processor_minTaken --	This Processor minTaken.
 */
int
Processor_minTaken(Processor this);

/*
 * Processor_maxTakenCost --	This processor maximum branch taken cost.
 */
int
Processor_maxTakenCost(Processor this);

/*
 * Processor_interlocks --	Whether this Processor interlocks registers.
 */
bool
Processor_interlocks(Processor this);

/*
 * Processor_availability --	This Processor availability of Resource(s).
 */
const_ResourceVector
Processor_availability(Processor this);

//
bool
Processor_DTD(FILE *file);

//
bool
Processor_XML(FILE *file);


#endif//Processor_h_INCLUDED
