#ifndef Scheduling_h_INCLUDED
#define Scheduling_h_INCLUDED

/*
 * !!!!	Scheduling.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * Scheduling_name_ --	Names for the Scheduling enumeration.
 */
extern const char *
Scheduling_name_(Scheduling this);
extern const char *
Scheduling_name(Scheduling this);

/*
 * Scheduling_processor --	This Scheduling class processor.
 */
Processor
Scheduling_processor(Scheduling this);

/*
 * Scheduling_bundling --	This Scheduling class Bundling class.
 */
Bundling
Scheduling_bundling(Scheduling this);

/*
 * Scheduling_reservation --	This Scheduling class Reservation.
 */
Reservation
Scheduling_reservation(Scheduling this);

//
bool
Scheduling_DTD(FILE *file);

//
bool
Scheduling_XML(FILE *file);


#endif//Scheduling_h_INCLUDED
