#ifndef Interface__h_INCLUDED
#define Interface__h_INCLUDED

//
#include "O64/Interface.h"
#undef PRO_OPTIMIZE
#define PRO_OPTIMIZE 1

//
//#define Interface_DEDICATED 0
#ifndef Interface_DEDICATED
extern int Interface_DEDICATED;
#endif

//
struct Interface_ {
  //@args	Memory memory
  Memory MEMORY;
  Configure CONFIGURE;
  Selector_ SELECTOR_;
  //@access SELECTOR	Interface__SELECTOR_(this)
  //@access PROCEDURE	Selector_procedure(Interface_SELECTOR(this))
  HTable_ DIRECT[InterfaceType__];
  //@access LIR2CGIR	(Interface_DIRECT(this) + InterfaceType_CGIR)
  //@access LABELS	(Interface_DIRECT(this) + InterfaceType_Label)
  //@access SYMBOLS	(Interface_DIRECT(this) + InterfaceType_Symbol)
  //@access TEMPORARIES	(Interface_DIRECT(this) + InterfaceType_Temporary)
  //@access OPERATIONS	(Interface_DIRECT(this) + InterfaceType_Operation)
  //@access BASICBLOCKS	(Interface_DIRECT(this) + InterfaceType_BasicBlock)
  //@access LOOPSCOPES	(Interface_DIRECT(this) + InterfaceType_LoopScope)
  //@access CGIRIMPORT	(Interface_DIRECT(this) + InterfaceType_CGIRImport)
  //@access CGIRVALID	(Interface_DIRECT(this) + InterfaceType_CGIRValid)
  int REGISTERCOUNT;
  int *REGISTERARRAY;
  int LABELCOUNT;
  Label *LABELARRAY;
  int RESULTCOUNT;
  Temporary *RESULTARRAY;
  int ARGUMENTCOUNT;
  Temporary *ARGUMENTARRAY;
  int TEMPORARYCOUNT;
  Temporary *TEMPORARYARRAY;
  int OPERATIONCOUNT;
  Operation *OPERATIONARRAY;
};

extern Interface
Interface_Ctor(Interface this, Memory memory);

extern Interface
Interface_Copy(Interface this, const_Interface that);

extern void
Interface_Dtor(Interface this);

extern size_t
Interface_Size(Memory memory);

#define Interface_MEMORY(this) ((this)->MEMORY)
#define Interface__MEMORY(this) (&(this)->MEMORY)
#define Interface_CONFIGURE(this) ((this)->CONFIGURE)
#define Interface__CONFIGURE(this) (&(this)->CONFIGURE)
#define Interface_SELECTOR_(this) ((this)->SELECTOR_)
#define Interface__SELECTOR_(this) (&(this)->SELECTOR_)
#define Interface_DIRECT(this) ((this)->DIRECT)
#define Interface__DIRECT(this) (&(this)->DIRECT)
#define Interface_REGISTERCOUNT(this) ((this)->REGISTERCOUNT)
#define Interface__REGISTERCOUNT(this) (&(this)->REGISTERCOUNT)
#define Interface_REGISTERARRAY(this) ((this)->REGISTERARRAY)
#define Interface__REGISTERARRAY(this) (&(this)->REGISTERARRAY)
#define Interface_LABELCOUNT(this) ((this)->LABELCOUNT)
#define Interface__LABELCOUNT(this) (&(this)->LABELCOUNT)
#define Interface_LABELARRAY(this) ((this)->LABELARRAY)
#define Interface__LABELARRAY(this) (&(this)->LABELARRAY)
#define Interface_RESULTCOUNT(this) ((this)->RESULTCOUNT)
#define Interface__RESULTCOUNT(this) (&(this)->RESULTCOUNT)
#define Interface_RESULTARRAY(this) ((this)->RESULTARRAY)
#define Interface__RESULTARRAY(this) (&(this)->RESULTARRAY)
#define Interface_ARGUMENTCOUNT(this) ((this)->ARGUMENTCOUNT)
#define Interface__ARGUMENTCOUNT(this) (&(this)->ARGUMENTCOUNT)
#define Interface_ARGUMENTARRAY(this) ((this)->ARGUMENTARRAY)
#define Interface__ARGUMENTARRAY(this) (&(this)->ARGUMENTARRAY)
#define Interface_TEMPORARYCOUNT(this) ((this)->TEMPORARYCOUNT)
#define Interface__TEMPORARYCOUNT(this) (&(this)->TEMPORARYCOUNT)
#define Interface_TEMPORARYARRAY(this) ((this)->TEMPORARYARRAY)
#define Interface__TEMPORARYARRAY(this) (&(this)->TEMPORARYARRAY)
#define Interface_OPERATIONCOUNT(this) ((this)->OPERATIONCOUNT)
#define Interface__OPERATIONCOUNT(this) (&(this)->OPERATIONCOUNT)
#define Interface_OPERATIONARRAY(this) ((this)->OPERATIONARRAY)
#define Interface__OPERATIONARRAY(this) (&(this)->OPERATIONARRAY)
#define Interface_BASICBLOCKS(this) ((Interface_DIRECT(this) + InterfaceType_BasicBlock))
#define Interface_CGIRIMPORT(this) ((Interface_DIRECT(this) + InterfaceType_CGIRImport))
#define Interface_LOOPSCOPES(this) ((Interface_DIRECT(this) + InterfaceType_LoopScope))
#define Interface_PROCEDURE(this) (Selector_procedure(Interface_SELECTOR(this)))
#define Interface_LIR2CGIR(this) ((Interface_DIRECT(this) + InterfaceType_CGIR))
#define Interface_TEMPORARIES(this) ((Interface_DIRECT(this) + InterfaceType_Temporary))
#define Interface_CGIRVALID(this) ((Interface_DIRECT(this) + InterfaceType_CGIRValid))
#define Interface_SELECTOR(this) (Interface__SELECTOR_(this))
#define Interface_LABELS(this) ((Interface_DIRECT(this) + InterfaceType_Label))
#define Interface_SYMBOLS(this) ((Interface_DIRECT(this) + InterfaceType_Symbol))
#define Interface_OPERATIONS(this) ((Interface_DIRECT(this) + InterfaceType_Operation))


/*
 * The singleton Interface object.
 */
extern Interface interface;

/*
 * Interface_FOREACH_Label --	Iterate over this Interface_LABELS.
 */
#define Interface_FOREACH_Label(this, cgir_lab, label) \
  HTable_FOREACH(Interface_LABELS(this), Interface_KEY, Label, Interface_ITER) { \
    CGIR_LAB cgir_lab = (CGIR_LAB)Interface_KEY; \
    Label label = *Interface_ITER;
#define Interface_ENDEACH_Label \
  } HTable_ENDEACH;

/*
 * Interface_FOREACH_Symbol --	Iterate over this Interface_SYMBOLS.
 */
#define Interface_FOREACH_Symbol(this, cgir_sym, symbol) \
  HTable_FOREACH(Interface_SYMBOLS(this), Interface_KEY, Symbol, Interface_ITER) { \
    CGIR_SYM cgir_sym = (CGIR_SYM)Interface_KEY; \
    Symbol symbol = *Interface_ITER;
#define Interface_ENDEACH_Symbol \
  } HTable_ENDEACH;

/*
 * Interface_FOREACH_Temporary --	Iterate over this Interface_TEMPORARIES.
 */
#define Interface_FOREACH_Temporary(this, cgir_tn, temporary) \
  HTable_FOREACH(Interface_TEMPORARIES(this), Interface_KEY, Temporary, Interface_ITER) { \
    CGIR_TN cgir_tn = (CGIR_TN)Interface_KEY; \
    Temporary temporary = *Interface_ITER;
#define Interface_ENDEACH_Temporary \
  } HTable_ENDEACH;

/*
 * Interface_FOREACH_Operation --	Iterate over this Interface_OPERATIONS.
 */
#define Interface_FOREACH_Operation(this, cgir_op, operation) \
  HTable_FOREACH(Interface_OPERATIONS(this), Interface_KEY, Operation, Interface_ITER) { \
    CGIR_OP cgir_op = (CGIR_OP)Interface_KEY; \
    Operation operation = *Interface_ITER;
#define Interface_ENDEACH_Operation \
  } HTable_ENDEACH;

/*
 * Interface_FOREACH_BasicBlock --	Iterate over this Interface_BASICBLOCKS.
 */
#define Interface_FOREACH_BasicBlock(this, cgir_bb, basicBlock) \
  HTable_FOREACH(Interface_BASICBLOCKS(this), Interface_KEY, BasicBlock, Interface_ITER) { \
    CGIR_BB cgir_bb = (CGIR_BB)Interface_KEY; \
    BasicBlock basicBlock = *Interface_ITER;
#define Interface_ENDEACH_BasicBlock \
  } HTable_ENDEACH;

/*
 * Interface_FOREACH_LoopScope --	Iterate over this Interface_LOOPSCOPES.
 */
#define Interface_FOREACH_LoopScope(this, cgir_ld, loopScope) \
  HTable_FOREACH(Interface_LOOPSCOPES(this), Interface_KEY, LoopScope, Interface_ITER) { \
    CGIR_LD cgir_ld = (CGIR_LD)Interface_KEY; \
    LoopScope loopScope = *Interface_ITER;
#define Interface_ENDEACH_LoopScope \
  } HTable_ENDEACH;

/*
 * Interface_FOREACH_InterfaceMapped --	Iterate over this Interface_LIR2CGIR
 */
#define Interface_FOREACH_InterfaceMapped(this, key, mapped) \
  HTable_FOREACH(Interface_LIR2CGIR(this), key, InterfaceMapped_, mapped)
#define Interface_ENDEACH_InterfaceMapped \
  HTable_ENDEACH;

//
static inline void
Interface_setCGIRImport(Interface this, const void *object)
{
  HTable_insert(Interface_CGIRIMPORT(this), (HTableKey)object, 0);
}

//
static inline bool
Interface_isCGIRImport(Interface this, const void *object)
{
  return HTable_search(Interface_CGIRIMPORT(this), (HTableKey)object) != NULL;
}

//
static inline void
Interface_setCGIRValid(Interface this, const void *object)
{
  HTable_insert(Interface_CGIRVALID(this), (HTableKey)object, 0);
}

//
static inline bool
Interface_isCGIRValid(Interface this, const void *object)
{
  return HTable_search(Interface_CGIRVALID(this), (HTableKey)object) != NULL;
}

/*
 * Interface_PrintRegisters - Print a Register array as a call to Registers.
 */
int
Interface_PrintRegisters(FILE *file, int count, int registers[]);

/*
 * Interface_PrintLabels - Print a Label array as a call to Labels.
 */
int
Interface_PrintLabels(FILE *file, int count, Label labels[]);

/*
 * Interface_PrintTemporaries - Print a Temporary array as a call to Temporaries.
 */
int
Interface_PrintTemporaries(FILE *file, int count, Temporary temporaries[]);

/*
 * Interface_PrintOperations - Print a Operation array as a call to Operations.
 */
int
Interface_PrintOperations(FILE *file, int count, Operation operations[]);

//
extern int Interface_Counter;

//
void
RegionFlow_InstructionRelocateFixup(Instruction instruction,
                                    PlatformUInt nativePC,
                                    void* user_data);

/*
 * Interface_INIT --	Initialize the Interface module.
 */
void
Interface_INIT(void);

/*
 * Interface_FINI --	Finalize the Interface module.
 */
void
Interface_FINI(void);


#endif//Interface__h_INCLUDED
