#ifndef Decoalescer__h_INCLUDED
#define Decoalescer__h_INCLUDED

//
#include "PFA/Decoalescer.h"

//
struct Decoalescer_ {
  //@args       Memory memory, CodeRegion codeRegion, SSAForm ssaForm
  Coalescer_ COALESCER[1];		// SSA Coalescer.
  //@access MEMORY		Coalescer_MEMORY(Decoalescer_COALESCER(this))
  //@access CODEREGION		Coalescer_CODEREGION(Decoalescer_COALESCER(this))
  //@access SSAFORM		CodeRegion_ssaForm(Decoalescer_CODEREGION(this))
};

extern Decoalescer
Decoalescer_Ctor(Decoalescer this, Memory memory, CodeRegion codeRegion, SSAForm ssaForm);

extern Decoalescer
Decoalescer_Copy(Decoalescer this, const_Decoalescer that);

extern void
Decoalescer_Dtor(Decoalescer this);

extern size_t
Decoalescer_Size(Memory memory, CodeRegion codeRegion, SSAForm ssaForm);

#define Decoalescer_COALESCER(this) ((this)->COALESCER)
#define Decoalescer__COALESCER(this) (&(this)->COALESCER)
#define Decoalescer_CODEREGION(this) (Coalescer_CODEREGION(Decoalescer_COALESCER(this)))
#define Decoalescer_MEMORY(this) (Coalescer_MEMORY(Decoalescer_COALESCER(this)))
#define Decoalescer_SSAFORM(this) (CodeRegion_ssaForm(Decoalescer_CODEREGION(this)))


//
static VariableClass
Variable_color(Variable V);

/*
 * Decoalescer_filteringStrongInterference --  Check for strong interferences between two congruence classes
 */
bool
Decoalescer_filteringStrongInterference(Variable variable_0, VariableClass congruence_0,
					Variable variable_1, VariableClass congruence_1);

/*
 * Decoalescer_coalesceFiltering --  Coalesce variables with no strong interferences, to be processed by dforest.
 */
void
Decoalescer_coalesceFiltering(Decoalescer this, Operation operation, CoalescerFilter filter);

/*
 * Decoalescer_decoalesceWebs --	Main processing for Decoalescing.
 * /!\ Work on congruence classes not on weblinks.
 */
void
Decoalescer_decoalesceWebs(Decoalescer this);

/*
 * Decoalescer_generateCopies --       Main processing for Generate_Copies.
 */

//
void
Decoalescer_generateCopies(Decoalescer this);

/*
 * Decoalescer_INIT --	Initialize the Decoalescer module.
 */
#define Decoalescer_INIT()

/*
 * Decoalescer_FINI --	Finalize the Decoalescer module.
 */
#define Decoalescer_FINI()


#endif//Decoalescer__h_INCLUDED
