#ifndef Interference_h_INCLUDED
#define Interference_h_INCLUDED

/*
 * !!!!	Interference.xcc
 *
 * Nikola Puzovic (nikola.puzovic@st.com).
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 * Fabrice Rastello (Fabrice.Rastello@ens-lyon.fr).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * Interference --	Interference graph over a CodeRegion.
 */
struct Interference_;
typedef struct Interference_ Interference_, *Interference;
typedef const struct Interference_ *const_Interference;
typedef struct Interference_ * restrict_Interference;

//
Interference
Interference_make(Memory parent, CodeRegion codeRegion, Liveness liveness, bool chaintin);

//
Interference
Interference_kill(Interference this);

/*
 * Interference_memory --	This Interference Memory.
 */
Memory
Interference_memory(const_Interference this);

/*
 * Interference_pretty --	Pretty-print this Interference.
 */
bool
Interference_pretty(const_Interference this, FILE *file);

/*
 * Interference_add --	Add interference between two variables.
 */
void
Interference_add(Interference this, const_Temporary u, const_Temporary v);

/*
 * Interference_exists --	Check interference between two variables.
 */
bool
Interference_exists(const_Interference this, const_Temporary u, const_Temporary v);


#endif//Interference_h_INCLUDED
