#ifndef Interference__h_INCLUDED
#define Interference__h_INCLUDED

//
#include "PFA/Interference.h"

//
struct Interference_ {
  //@args	Memory memory, CodeRegion codeRegion, Liveness liveness, bool chaintin
  CodeRegion CODEREGION;		// The CodeRegion for this Interference graph.
  TemporaryTable TEMPORARYTABLE;	// The TemporaryTable for this Interference.
  IStack_ ISTACK[1];			// IStack of BitSet(s) for the bit half-matrix.
  //@access MEMORY	IStack_memory(Interference_ISTACK(this))
  //@access COUNT	(IStack_usedSize(Interference_ISTACK(this))/sizeof(BitSet_))
  //@access BASE	IStack_base(Interference_ISTACK(this))
};

extern Interference
Interference_Ctor(Interference this, Memory memory, CodeRegion codeRegion, Liveness liveness, bool chaintin);

extern Interference
Interference_Copy(Interference this, const_Interference that);

extern void
Interference_Dtor(Interference this);

extern size_t
Interference_Size(Memory memory, CodeRegion codeRegion, Liveness liveness, bool chaintin);

#define Interference_CODEREGION(this) ((this)->CODEREGION)
#define Interference__CODEREGION(this) (&(this)->CODEREGION)
#define Interference_TEMPORARYTABLE(this) ((this)->TEMPORARYTABLE)
#define Interference__TEMPORARYTABLE(this) (&(this)->TEMPORARYTABLE)
#define Interference_ISTACK(this) ((this)->ISTACK)
#define Interference__ISTACK(this) (&(this)->ISTACK)
#define Interference_BASE(this) (IStack_base(Interference_ISTACK(this)))
#define Interference_COUNT(this) ((IStack_usedSize(Interference_ISTACK(this))/sizeof(BitSet_)))
#define Interference_MEMORY(this) (IStack_memory(Interference_ISTACK(this)))


/*
 * Interference_INIT --	Initialize the Interference module.
 */
#define Interference_INIT()

/*
 * Interference_FINI --	Finalize the Interference module.
 */
#define Interference_FINI()


#endif//Interference__h_INCLUDED
