#ifndef GrahamList_h_INCLUDED
#define GrahamList_h_INCLUDED

/*
 * !!!!	GrahamList.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * GrahamListKind --	enumerates the GrahamList kinds.
 */
typedef enum {
  GrahamListKind_Forward,	// Forward GrahamList scheduling.
  GrahamListKind_Backward,	// Backward GrahamList scheduling.
  GrahamListKind__
} enum_GrahamListKind;
typedef uint8_t GrahamListKind;
extern const char *
GrahamListKind_type(GrahamListKind this);

/*
 * GrahamList --	Graham List Scheduling support.
 */
struct GrahamList_;
typedef struct GrahamList_ GrahamList_, *GrahamList;
typedef const struct GrahamList_ *const_GrahamList;
typedef struct GrahamList_ * restrict_GrahamList;

//
GrahamList
GrahamList_new(Memory parent, DDGraph ddgraph, const uint8_t *availability);

//
GrahamList
GrahamList_delete(GrahamList this);


#endif//GrahamList_h_INCLUDED
