#ifndef Insertion_h_INCLUDED
#define Insertion_h_INCLUDED

/*
 * !!!!	Insertion.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * Insertion --	Context for the insertion scheduling engine.
 */
struct Insertion_;
typedef struct Insertion_ Insertion_, *Insertion;
typedef const struct Insertion_ *const_Insertion;
typedef struct Insertion_ * restrict_Insertion;

//
Insertion
Insertion_new(Memory parent, Scheduler scheduler, int maxRange);

//
Insertion
Insertion_delete(Insertion this);

/*
 * Insertion_Schedule --	Schedule with Insertion Scheduling.
 */
int
Insertion_Schedule(Scheduler scheduler, int min_lambda, int max_lambda, int length);


#endif//Insertion_h_INCLUDED
