#ifndef Iterative__h_INCLUDED
#define Iterative__h_INCLUDED

//
#include "SCD/Iterative.h"

//
typedef struct IterativeExternalContext_ {
  int II;
  int *Distance;
  int *PreScheduleRetry;
  IDList AdditionalInArcs;
  IDList AdditionalOutArcs;
  int *ResourceUsageCycleMap;
} IterativeExternalContext_, *IterativeExternalContext;

//
struct Iterative_ {
  //@args Memory memory, Scheduler scheduler
  Memory MEMORY; // This Iterative Memory.
  Scheduler SCHEDULER; // The base instruction scheduler.
  //@access ISSUETABLE Scheduler_ISSUETABLE(Iterative_SCHEDULER(this))
  //@access MCRLGRAPH Scheduler_MCRLGRAPH(Iterative_SCHEDULER(this))
  //@access GRAHAMLIST Scheduler_GRAHAMLIST(Iterative_SCHEDULER(this))
  int32_t FIRSTINDEX; // The first non-lifetime INDEX.
  int32_t LASTINDEX; // The last non-lifetime INDEX.
};
typedef struct Iterative_ Iterative_, *Iterative;
typedef const struct Iterative_ *const_Iterative;
typedef struct Iterative_ * restrict_Iterative;

extern Iterative
Iterative_Ctor(Iterative this, Memory memory, Scheduler scheduler);

extern Iterative
Iterative_Copy(Iterative this, const_Iterative that);

extern void
Iterative_Dtor(Iterative this);

extern size_t
Iterative_Size(Memory memory, Scheduler scheduler);

#define Iterative_MEMORY(this) ((this)->MEMORY)
#define Iterative__MEMORY(this) (&(this)->MEMORY)
#define Iterative_SCHEDULER(this) ((this)->SCHEDULER)
#define Iterative__SCHEDULER(this) (&(this)->SCHEDULER)
#define Iterative_FIRSTINDEX(this) ((this)->FIRSTINDEX)
#define Iterative__FIRSTINDEX(this) (&(this)->FIRSTINDEX)
#define Iterative_LASTINDEX(this) ((this)->LASTINDEX)
#define Iterative__LASTINDEX(this) (&(this)->LASTINDEX)
#define Iterative_ISSUETABLE(this) (Scheduler_ISSUETABLE(Iterative_SCHEDULER(this)))
#define Iterative_MCRLGRAPH(this) (Scheduler_MCRLGRAPH(Iterative_SCHEDULER(this)))
#define Iterative_GRAHAMLIST(this) (Scheduler_GRAHAMLIST(Iterative_SCHEDULER(this)))


//
Iterative
Iterative_new(Memory parent, Scheduler scheduler);

//
Iterative
Iterative_delete(Iterative this);

/*
 * Iterative_INIT -- Initialize the Iterative module.
 */
void
Iterative_INIT(void);

/*
 * Iterative_INIT -- Finalize the Iterative module.
 */
#define Iterative_FINI()


#endif//Iterative__h_INCLUDED
