#ifndef Scheduler__h_INCLUDED
#define Scheduler__h_INCLUDED

//
#include "SCD/Scheduler.h"

//
struct Scheduler_ {
  Memory MEMORY;
  BlockTrace BLOCKTRACE;	// The BlockTrace to schedule.
  //@access isInnerLoop	BlockTrace_isInnerLoop(Scheduler_BLOCKTRACE(this))
  //@access isLoopBody	BlockTrace_isLoopBody(Scheduler_BLOCKTRACE(this))
  //@access isPrePass	BlockTrace_isPrePass(Scheduler_BLOCKTRACE(this))
  //@access isPipeline	BlockTrace_isPipeline(Scheduler_BLOCKTRACE(this))
  //@access OPTIMIZE	BlockTrace_OPTIMIZE(Scheduler_BLOCKTRACE(this))
  //@access REGIONTYPE	BlockTrace_REGIONTYPE(Scheduler_BLOCKTRACE(this))
  //@access HEADBLOCK	BlockTrace_HEADBLOCK(Scheduler_BLOCKTRACE(this))
  //@access ISSUEITEMS	BlockTrace_ISSUEITEMS(Scheduler_BLOCKTRACE(this))
  //@access ITEMCOUNT	BlockTrace_ITEMCOUNT(Scheduler_BLOCKTRACE(this))
  //@access FIRSTITEM	BlockTrace_FIRSTITEM(Scheduler_BLOCKTRACE(this))
  //@access LASTITEM	BlockTrace_LASTITEM(Scheduler_BLOCKTRACE(this))
  //@access ITEMCOUNT	BlockTrace_ITEMCOUNT(Scheduler_BLOCKTRACE(this))
  //@access PROCESSOR	BlockTrace_PROCESSOR(Scheduler_BLOCKTRACE(this))
  //@access LAMBDA	BlockTrace_LAMBDA(Scheduler_BLOCKTRACE(this))
  //@mutate LAMBDA	BlockTrace__LAMBDA(Scheduler_BLOCKTRACE(this))
  //@access LENGTH	BlockTrace_LENGTH(Scheduler_BLOCKTRACE(this))
  //@mutate LENGTH	BlockTrace__LENGTH(Scheduler_BLOCKTRACE(this))
  //@access COMPENSATION	BlockTrace_COMPENSATION(Scheduler_BLOCKTRACE(this))
  //@access SPECULATION	BlockTrace_SPECULATION(Scheduler_BLOCKTRACE(this))
  //@access RELAXATION	BlockTrace_RELAXATION(Scheduler_BLOCKTRACE(this))
  //@access PIPELINING	BlockTrace_PIPELINING(Scheduler_BLOCKTRACE(this))
  //@access RENAMING	BlockTrace_RENAMING(Scheduler_BLOCKTRACE(this))
  //@access BOOSTING	BlockTrace_BOOSTING(Scheduler_BLOCKTRACE(this))
  //@access FACTOR	BlockTrace_FACTOR(Scheduler_BLOCKTRACE(this))
  //@access SOLVING	BlockTrace_SOLVING(Scheduler_BLOCKTRACE(this))
  //@access TIMEOUT	BlockTrace_TIMEOUT(Scheduler_BLOCKTRACE(this))
  //@access LOGTIME	BlockTrace_LOGTIME(Scheduler_BLOCKTRACE(this))
  //@access KUNROLL	BlockTrace_KUNROLL(Scheduler_BLOCKTRACE(this))
  //@access OVERLAP	BlockTrace_OVERLAP(Scheduler_BLOCKTRACE(this))
  String HEADNAME;		// Label name of this BlockTrace HEADBLOCK.
  int32_t IDENTITY;		// Identity of this BlockTrace HEADBLOCK.
  GrahamList GRAHAMLIST;	// The GrahamList of this Scheduler.
  //@access INDEX2TASK	GrahamList_INDEX2TASK(Scheduler_GRAHAMLIST(this))
  //@access ISSUETABLE	GrahamList_ISSUETABLE(Scheduler_GRAHAMLIST(this))
  int32_t FIRSTINDEX;		// The first GrahamListTask INDEX.
  int32_t LASTINDEX;		// The last GrahamListTask INDEX.
  DDGraph DDGRAPHS[DDGraphKind__];	// The scheduling graphs of this Scheduler.
  //@access EARLYGRAPH	 (Scheduler_DDGRAPHS(this)[DDGraphKind_Early])
  //@access LATEGRAPH	 (Scheduler_DDGRAPHS(this)[DDGraphKind_Late])
  //@access MCRLGRAPH	 (Scheduler_DDGRAPHS(this)[DDGraphKind_MCRL])
  DDGraphArc *LINKARCS[RegFile__FIXME];	// Link arcs heading into the lifetime nodes.
  int16_t MAXLIVES[RegFile__FIXME];	// This Scheduler MaxLive per RegFile.
  int16_t *PRESSURES[RegFile__FIXME];	// This Scheduler pressure per RegFile.
  int32_t SERIALIZE;		// Counter of serialization arcs.
  int16_t LAMBDAS[3];		// Lambda resource, lambda recurrence, lambda relaxation.
  //@access DELTAS	(Scheduler_LAMBDA(this) - Scheduler_LAMBDAS(this)[2])
  int8_t BAROMEGA;		// Maximum of the OMEGA in the DDGraph(s).
  int8_t UNWINDING;		// The Relaxation unwinding level.
  int16_t BODYCOUNT;
  int16_t SCHEDULED;
  int16_t DELTALAMBDA;
  int16_t DELTALENGTH;
};

extern Scheduler
Scheduler_Ctor(Scheduler this, Memory memory, BlockTrace blockTrace);

extern Scheduler
Scheduler_Copy(Scheduler this, const_Scheduler that);

extern void
Scheduler_Dtor(Scheduler this);

extern size_t
Scheduler_Size(Memory memory, BlockTrace blockTrace);

#define Scheduler_MEMORY(this) ((this)->MEMORY)
#define Scheduler__MEMORY(this) (&(this)->MEMORY)
#define Scheduler_BLOCKTRACE(this) ((this)->BLOCKTRACE)
#define Scheduler__BLOCKTRACE(this) (&(this)->BLOCKTRACE)
#define Scheduler_HEADNAME(this) ((this)->HEADNAME)
#define Scheduler__HEADNAME(this) (&(this)->HEADNAME)
#define Scheduler_IDENTITY(this) ((this)->IDENTITY)
#define Scheduler__IDENTITY(this) (&(this)->IDENTITY)
#define Scheduler_GRAHAMLIST(this) ((this)->GRAHAMLIST)
#define Scheduler__GRAHAMLIST(this) (&(this)->GRAHAMLIST)
#define Scheduler_FIRSTINDEX(this) ((this)->FIRSTINDEX)
#define Scheduler__FIRSTINDEX(this) (&(this)->FIRSTINDEX)
#define Scheduler_LASTINDEX(this) ((this)->LASTINDEX)
#define Scheduler__LASTINDEX(this) (&(this)->LASTINDEX)
#define Scheduler_DDGRAPHS(this) ((this)->DDGRAPHS)
#define Scheduler__DDGRAPHS(this) (&(this)->DDGRAPHS)
#define Scheduler_LINKARCS(this) ((this)->LINKARCS)
#define Scheduler__LINKARCS(this) (&(this)->LINKARCS)
#define Scheduler_MAXLIVES(this) ((this)->MAXLIVES)
#define Scheduler__MAXLIVES(this) (&(this)->MAXLIVES)
#define Scheduler_PRESSURES(this) ((this)->PRESSURES)
#define Scheduler__PRESSURES(this) (&(this)->PRESSURES)
#define Scheduler_SERIALIZE(this) ((this)->SERIALIZE)
#define Scheduler__SERIALIZE(this) (&(this)->SERIALIZE)
#define Scheduler_LAMBDAS(this) ((this)->LAMBDAS)
#define Scheduler__LAMBDAS(this) (&(this)->LAMBDAS)
#define Scheduler_BAROMEGA(this) ((this)->BAROMEGA)
#define Scheduler__BAROMEGA(this) (&(this)->BAROMEGA)
#define Scheduler_UNWINDING(this) ((this)->UNWINDING)
#define Scheduler__UNWINDING(this) (&(this)->UNWINDING)
#define Scheduler_BODYCOUNT(this) ((this)->BODYCOUNT)
#define Scheduler__BODYCOUNT(this) (&(this)->BODYCOUNT)
#define Scheduler_SCHEDULED(this) ((this)->SCHEDULED)
#define Scheduler__SCHEDULED(this) (&(this)->SCHEDULED)
#define Scheduler_DELTALAMBDA(this) ((this)->DELTALAMBDA)
#define Scheduler__DELTALAMBDA(this) (&(this)->DELTALAMBDA)
#define Scheduler_DELTALENGTH(this) ((this)->DELTALENGTH)
#define Scheduler__DELTALENGTH(this) (&(this)->DELTALENGTH)
#define Scheduler_ITEMCOUNT(this) (BlockTrace_ITEMCOUNT(Scheduler_BLOCKTRACE(this)))
#define Scheduler_COMPENSATION(this) (BlockTrace_COMPENSATION(Scheduler_BLOCKTRACE(this)))
#define Scheduler_LENGTH(this) (BlockTrace_LENGTH(Scheduler_BLOCKTRACE(this)))
#define Scheduler_SOLVING(this) (BlockTrace_SOLVING(Scheduler_BLOCKTRACE(this)))
#define Scheduler_RENAMING(this) (BlockTrace_RENAMING(Scheduler_BLOCKTRACE(this)))
#define Scheduler_KUNROLL(this) (BlockTrace_KUNROLL(Scheduler_BLOCKTRACE(this)))
#define Scheduler_OVERLAP(this) (BlockTrace_OVERLAP(Scheduler_BLOCKTRACE(this)))
#define Scheduler_HEADBLOCK(this) (BlockTrace_HEADBLOCK(Scheduler_BLOCKTRACE(this)))
#define Scheduler_FIRSTITEM(this) (BlockTrace_FIRSTITEM(Scheduler_BLOCKTRACE(this)))
#define Scheduler_PIPELINING(this) (BlockTrace_PIPELINING(Scheduler_BLOCKTRACE(this)))
#define Scheduler_LAMBDA(this) (BlockTrace_LAMBDA(Scheduler_BLOCKTRACE(this)))
#define Scheduler_BOOSTING(this) (BlockTrace_BOOSTING(Scheduler_BLOCKTRACE(this)))
#define Scheduler_isLoopBody(this) (BlockTrace_isLoopBody(Scheduler_BLOCKTRACE(this)))
#define Scheduler_FACTOR(this) (BlockTrace_FACTOR(Scheduler_BLOCKTRACE(this)))
#define Scheduler_LOGTIME(this) (BlockTrace_LOGTIME(Scheduler_BLOCKTRACE(this)))
#define Scheduler_EARLYGRAPH(this) ((Scheduler_DDGRAPHS(this)[DDGraphKind_Early]))
#define Scheduler_isPrePass(this) (BlockTrace_isPrePass(Scheduler_BLOCKTRACE(this)))
#define Scheduler_TIMEOUT(this) (BlockTrace_TIMEOUT(Scheduler_BLOCKTRACE(this)))
#define Scheduler_isInnerLoop(this) (BlockTrace_isInnerLoop(Scheduler_BLOCKTRACE(this)))
#define Scheduler_MCRLGRAPH(this) ((Scheduler_DDGRAPHS(this)[DDGraphKind_MCRL]))
#define Scheduler_LATEGRAPH(this) ((Scheduler_DDGRAPHS(this)[DDGraphKind_Late]))
#define Scheduler_ISSUEITEMS(this) (BlockTrace_ISSUEITEMS(Scheduler_BLOCKTRACE(this)))
#define Scheduler_LASTITEM(this) (BlockTrace_LASTITEM(Scheduler_BLOCKTRACE(this)))
#define Scheduler_DELTAS(this) ((Scheduler_LAMBDA(this) - Scheduler_LAMBDAS(this)[2]))
#define Scheduler_INDEX2TASK(this) (GrahamList_INDEX2TASK(Scheduler_GRAHAMLIST(this)))
#define Scheduler_RELAXATION(this) (BlockTrace_RELAXATION(Scheduler_BLOCKTRACE(this)))
#define Scheduler_isPipeline(this) (BlockTrace_isPipeline(Scheduler_BLOCKTRACE(this)))
#define Scheduler_SPECULATION(this) (BlockTrace_SPECULATION(Scheduler_BLOCKTRACE(this)))
#define Scheduler_ISSUETABLE(this) (GrahamList_ISSUETABLE(Scheduler_GRAHAMLIST(this)))
#define Scheduler_REGIONTYPE(this) (BlockTrace_REGIONTYPE(Scheduler_BLOCKTRACE(this)))
#define Scheduler_OPTIMIZE(this) (BlockTrace_OPTIMIZE(Scheduler_BLOCKTRACE(this)))
#define Scheduler_PROCESSOR(this) (BlockTrace_PROCESSOR(Scheduler_BLOCKTRACE(this)))
#define Scheduler__LAMBDA(this) (BlockTrace__LAMBDA(Scheduler_BLOCKTRACE(this)))
#define Scheduler__LENGTH(this) (BlockTrace__LENGTH(Scheduler_BLOCKTRACE(this)))


/*
 * Scheduler_pretty --	Pretty-print this Scheduler.
 */
bool
Scheduler_pretty(Scheduler this, FILE *file);

/*
 * Scheduler_buildDDGraph --	Build a DDGraph of the specified DDGraphKind.
 */
DDGraph
Scheduler_buildDDGraph(Scheduler this, DDGraph thatGraph, DDGraphKind kind, DDGraphFlags flags);

/*
 * Scheduler_buildLinkArcs --	Build this Scheduler LINKARCS.
 *
 * Each LINKARCS entry is a NULL-terminated array of DDGraphArcs. There is one such
 * entry per RegFile.
 */
void
Scheduler_buildLinkArcs(Scheduler this, DDGraph mcrlGraph);

/*
 * Scheduler_computePressures --	Compute the register pressures of the schedule.
 *
 * This computation is based on the scheduling dates of the lifetime nodes,
 * identified by the LINKARCS. Lifetimes that have no such nodes are not accounted for.
 */
void
Scheduler_computePressures(Scheduler this);

/*
 * Scheduler_tryRelaxations --	Try the Forward and the Backward Relaxations.
 * Return:	true if the relaxations are feasible, else false.
 */
bool
Scheduler_tryRelaxations(Scheduler this, int lambda,
                         int issueCount, const Resource *resources);

/*
 * Scheduler_runRelaxations --	Run the Forward and the Backward Relaxations.
 *
 * We use a dichotomy search to find the minimum delta such that the relaxation
 * succeeds a initiation interval lambda + delta.
 */
void
Scheduler_runRelaxations(Scheduler this, int issueCount, const Resource *resources);

/*
 * Scheduler_prepareScheduling --	Prepare the scheduling problem.
 */
void
Scheduler_prepareScheduling(Scheduler this);

/*
 * Scheduler_iterateScheduling --	Iterate scheduling until it is successful.
 */
bool
Scheduler_iterateScheduling(Scheduler this, int scheduling);

/*
 * Scheduler_makeOrderings --	Recompute the IssueItem ORDERING(s) in topological order.
 */
void
Scheduler_makeOrderings(Scheduler this);

/*
 * Scheduler_commitSchedule --	Commit schedule.
 */
int
Scheduler_commitSchedule(Scheduler this, int lambda);

//
DDGraphArc
Scheduler_verifyDependences(Scheduler this);

/*
 * Scheduler_initializeFlows --	Solve the initial network flow problems.
 */
void
Scheduler_initializeFlows(Scheduler this, bool lifetime);

/*
 * Scheduler_increaseLambda --	Increase LAMBDA just enough to satisfy dependences.
 */
int
Scheduler_increaseLambda(Scheduler this, int maxDelta);

/*
 * Scheduler_optimizeFlows --	Optimize the network flow problems.
 */
void
Scheduler_optimizeFlows(Scheduler this, bool lifetime, bool refill);

/*
 * Scheduler_freezeTask --	Freeze the GrahamListTask with TAU biased by delta.
 */
void
Scheduler_freezeTask(Scheduler this, GrahamListTask task, int delta);

/*
 * Scheduler_unfreeze --	Unfreeze the dependence graphs.
 */
void
Scheduler_unfreeze(Scheduler this);

/*
 * Scheduler_makeArc --	Make an new dependence arc for this Scheduler.
 */
DDGraphArc
Scheduler_makeArc(Scheduler this, int32_t tail_index, int32_t head_index,
                  int theta, int omega, DependenceKind kind, Temporary temporary);

/*
 * Scheduler_freezeNode --	Freeze a node at the given tau and phi.
 */
DDGraphNode
Scheduler_freezeNode(Scheduler this, int32_t node_index, int tau, int phi);

/*
 * Scheduler_Schedule --	Array of Schedule functions.
 */
extern
int (*Scheduler_Schedule[OptimizeScheduling__])(struct Scheduler_ *, int, int, int);

/*
 * Scheduler_INIT --	Initialize the Scheduler module.
 */
void
Scheduler_INIT(void);

/*
 * Scheduler_FINI --	Finalize the Scheduler module.
 */
void
Scheduler_FINI(void);


#endif//Scheduler__h_INCLUDED
