#ifndef Unwinding__h_INCLUDED
#define Unwinding__h_INCLUDED

//
#include "SCD/Unwinding.h"

//
typedef struct UnwindingExternalContext_ {
  int II;
  int32_t IterationCount;
  IDList_ PatternDictionaryList[1];
} UnwindingExternalContext_, *UnwindingExternalContext;

//
struct Unwinding_ {
  //@args Memory memory, Scheduler scheduler
  Memory MEMORY; // This Unwinding Memory.
  Scheduler SCHEDULER; // The base instruction scheduler.
  //@access ISSUETABLE Scheduler_ISSUETABLE(Unwinding_SCHEDULER(this))
  //@access MCRLGRAPH Scheduler_MCRLGRAPH(Unwinding_SCHEDULER(this))
  //@access GRAHAMLIST Scheduler_GRAHAMLIST(Unwinding_SCHEDULER(this))
  int32_t FIRSTINDEX; // The first non-lifetime INDEX.
  int32_t LASTINDEX; // The last non-lifetime INDEX.
};
typedef struct Unwinding_ Unwinding_, *Unwinding;
typedef const struct Unwinding_ *const_Unwinding;
typedef struct Unwinding_ * restrict_Unwinding;

extern Unwinding
Unwinding_Ctor(Unwinding this, Memory memory, Scheduler scheduler);

extern Unwinding
Unwinding_Copy(Unwinding this, const_Unwinding that);

extern void
Unwinding_Dtor(Unwinding this);

extern size_t
Unwinding_Size(Memory memory, Scheduler scheduler);

#define Unwinding_MEMORY(this) ((this)->MEMORY)
#define Unwinding__MEMORY(this) (&(this)->MEMORY)
#define Unwinding_SCHEDULER(this) ((this)->SCHEDULER)
#define Unwinding__SCHEDULER(this) (&(this)->SCHEDULER)
#define Unwinding_FIRSTINDEX(this) ((this)->FIRSTINDEX)
#define Unwinding__FIRSTINDEX(this) (&(this)->FIRSTINDEX)
#define Unwinding_LASTINDEX(this) ((this)->LASTINDEX)
#define Unwinding__LASTINDEX(this) (&(this)->LASTINDEX)
#define Unwinding_ISSUETABLE(this) (Scheduler_ISSUETABLE(Unwinding_SCHEDULER(this)))
#define Unwinding_MCRLGRAPH(this) (Scheduler_MCRLGRAPH(Unwinding_SCHEDULER(this)))
#define Unwinding_GRAHAMLIST(this) (Scheduler_GRAHAMLIST(Unwinding_SCHEDULER(this)))


//
Unwinding
Unwinding_new(Memory parent, Scheduler scheduler);

//
Unwinding
Unwinding_delete(Unwinding this);

/*
 * Unwinding_INIT -- Initialize the Unwinding module.
 */
void
Unwinding_INIT(void);

/*
 * Unwinding_INIT -- Finalize the Unwinding module.
 */
#define Unwinding_FINI()


#endif//Unwinding__h_INCLUDED
